(*
Copyright 2011 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Generic_Usable_Rules
imports
  Term_Order
  "Q-Restricted_Rewriting"
  Trs_Impl
begin

type_synonym ('f,'v)usable_rules_checker = "'f af \<Rightarrow> ('f,'v)terms \<Rightarrow> ('f,'v)rules \<Rightarrow> ('f,'v)rules option \<Rightarrow> ('f,'v)trs \<Rightarrow> ('f,'v)rules option"

(* one might generalize this to have an alternation between af_redpair and ce_af_redpair, as soon as IsaFoR contains
   some non-ce-compatible orders *)
definition usable_rules_checker :: "('f,'v)usable_rules_checker \<Rightarrow> bool"
  where "usable_rules_checker checker \<equiv> \<forall> Q R \<pi> U_opt sts U S NS. checker \<pi> Q R U_opt sts = Some U \<longrightarrow> ce_af_redpair S NS \<pi> \<longrightarrow> set U \<subseteq> NS \<longrightarrow> (\<exists> f. 
           (\<forall> s t u \<sigma> \<tau>. (s,t) \<in> sts \<longrightarrow> s \<cdot> \<sigma> \<in> NF_terms Q \<longrightarrow> (t \<cdot> \<sigma>, u \<cdot> \<tau>) \<in> (qrstep Q (set R))^* \<longrightarrow> SN_on (qrstep Q (set R)) {t \<cdot> \<sigma>} \<longrightarrow> (t \<cdot> f \<sigma>, u \<cdot> f \<tau>) \<in> NS^*))"


end

