structure EvalCeta : sig
  val id : 'a -> 'a
  type 'a equal
  val equal : 'a equal -> 'a -> 'a -> bool
  val eq : 'a equal -> 'a -> 'a -> bool
  datatype nat = Zero_nat | Suc of nat
  datatype color = R | B
  datatype ('a, 'b) rbta = Emptya |
    Branch of color * ('a, 'b) rbta * 'a * 'b * ('a, 'b) rbta
  type 'a ord
  val less_eq : 'a ord -> 'a -> 'a -> bool
  val less : 'a ord -> 'a -> 'a -> bool
  type 'a preorder
  val ord_preorder : 'a preorder -> 'a ord
  type 'a order
  val preorder_order : 'a order -> 'a preorder
  type 'a linorder
  val order_linorder : 'a linorder -> 'a order
  datatype ('a, 'b) rbt = Rbt of ('a, 'b) rbta
  datatype rat = Frct of (int * int)
  val nat_aux : int -> nat -> nat
  val nat : int -> nat
  val hd : 'a list -> 'a
  val tl : 'a list -> 'a list
  datatype order_tag = Lex | Mul
  val null : 'a list -> bool
  val the : 'a option -> 'a
  val foldr : ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b
  val concat : ('a list) list -> 'a list
  datatype ('a, 'b) sum = Inl of 'a | Inr of 'b
  datatype nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5 |
    Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC |
    NibbleD | NibbleE | NibbleF
  val newline : char
  datatype xml =
    Xml of
      char list * (char list * char list) list * xml list * (char list) option
  val is_none : 'a option -> bool
  val equal_lista : 'a equal -> 'a list -> 'a list -> bool
  val equal_char : char equal
  type 'a show
  val shows_prec : 'a show -> nat -> 'a -> char list -> char list
  val shows_list : 'a show -> 'a list -> char list -> char list
  val shows_string : char list -> char list -> char list
  val shows_list_char : char list -> char list -> char list
  val shows_prec_char : nat -> char -> char list -> char list
  val show_char : char show
  val replicate : nat -> 'a -> 'a list
  val shows_map :
    ('a -> char list -> char list) -> 'a list -> char list -> char list
  val fst : 'a * 'b -> 'a
  val snd : 'a * 'b -> 'b
  val dquote : char list
  val shows_prec_list : 'a show -> nat -> 'a list -> char list -> char list
  val shows_attr : char list * char list -> char list -> char list
  val shows_attrs : (char list * char list) list -> char list -> char list
  val shows_XML_indent : char list -> nat -> xml -> char list -> char list
  val shows_prec_xml : nat -> xml -> char list -> char list
  val text : char list -> xml -> ((char list), (char list)) sum
  val take : nat -> 'a list -> 'a list
  val one_nata : nat
  val bindb : ('a, 'b) sum -> ('b -> ('a, 'c) sum) -> ('a, 'c) sum
  val digit2int : char -> ((char list), int) sum
  val string2int_aux : int -> char list -> ((char list), int) sum
  val string2int : char list -> ((char list), int) sum
  val inta : char list -> xml -> ((char list), int) sum
  val mapa : ('a -> 'b) -> 'a list -> 'b list
  val sequence : ('a, 'b) sum list -> ('a, ('b list)) sum
  val mapm : ('a -> ('b, 'c) sum) -> 'a list -> ('b, ('c list)) sum
  val map :
    (xml -> ((char list), 'a) sum) -> xml list -> ((char list), ('a list)) sum
  val nata : char list -> xml -> ((char list), nat) sum
  val abs_int : int -> int
  val sgn_int : int -> int
  val apsnd : ('a -> 'b) -> 'c * 'a -> 'c * 'b
  val divmod_int : int -> int -> int * int
  val mod_int : int -> int -> int
  val gcd_int : int -> int -> int
  val div_int : int -> int -> int
  val normalize : int * int -> int * int
  val fract : int -> int -> rat
  val xml_change :
    (xml -> ((char list), 'a) sum) -> ('a -> 'b) -> xml -> ((char list), 'b) sum
  val maps : ('a -> 'b list) -> 'a list -> 'b list
  val lookupa : 'a equal -> 'a -> ('a * 'b) list -> 'b option
  val get_name : xml -> char list
  val equal_list : 'a equal -> ('a list) equal
  val xml_options :
    (char list * (xml -> ((char list), 'a) sum)) list ->
      xml -> ((char list), 'a) sum
  val nth : 'a list -> nat -> 'a
  val equal_nata : nat -> nat -> bool
  val plus_nata : nat -> nat -> nat
  val size_list : 'a list -> nat
  val no_transform : char list -> xml -> ((char list), 'a) sum
  val xml2elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          ('a -> 'b -> 'c) -> xml -> ((char list), 'c) sum
  val rat : xml -> ((char list), rat) sum
  val fold : ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b
  val rev : 'a list -> 'a list
  val inserta : 'a equal -> 'a -> ('a -> bool) -> 'a -> bool
  type 'a bot
  val order_bot : 'a bot -> 'a order
  val bot : 'a bot -> 'a
  val bot_boola : bool
  val less_bool : bool -> bool -> bool
  val less_eq_bool : bool -> bool -> bool
  val ord_bool : bool ord
  val preorder_bool : bool preorder
  val order_bool : bool order
  val bot_bool : bool bot
  val bot_fun : 'b bot -> 'a -> 'b
  val set : 'a equal -> 'a list -> 'a -> bool
  val less_nat : nat -> nat -> bool
  val less_eq_nat : nat -> nat -> bool
  val upt : nat -> nat -> nat list
  val zip : 'a list -> 'b list -> ('a * 'b) list
  datatype ('a, 'b) term = Var of 'b | Fun of 'a * ('a, 'b) term list
  datatype ('a, 'b) ctxt = Hole |
    More of 'a * ('a, 'b) term list * ('a, 'b) ctxt * ('a, 'b) term list
  val string2bool : char list -> ((char list), bool) sum
  val boola : char list -> xml -> ((char list), bool) sum
  val drop : nat -> 'a list -> 'a list
  val last : 'a list -> 'a
  datatype 'a itself = Type
  val empty : 'a linorder -> ('a, 'b) rbt
  type 'a times
  val times : 'a times -> 'a -> 'a -> 'a
  type 'a dvd
  val times_dvd : 'a dvd -> 'a times
  val args : ('a, 'b) term -> ('a, 'b) term list
  val root : ('a, 'b) term -> 'a option
  val membera : 'a equal -> 'a list -> 'a -> bool
  val list_ex : ('a -> bool) -> 'a list -> bool
  val equal_term : 'a equal -> 'b equal -> ('a, 'b) term equal
  val equal_terma :
    'a equal -> 'b equal -> ('a, 'b) term -> ('a, 'b) term -> bool
  val supt_impl : 'a equal -> 'b equal -> ('a, 'b) term -> ('a, 'b) term -> bool
  val supt : 'a equal -> 'b equal -> ('a, 'b) term * ('a, 'b) term -> bool
  val find : ('a -> bool) -> 'a list -> 'a option
  val bind : 'a option -> ('a -> 'b option) -> 'b option
  val mapM : ('a -> 'b option) -> 'a list -> ('b list) option
  type 'a one
  val one : 'a one -> 'a
  val times_int : int times
  val dvd_int : int dvd
  val one_inta : int
  val one_int : int one
  val ord_int : int ord
  val foldl : ('a -> 'b -> 'a) -> 'a -> 'b list -> 'a
  val vec : nat -> 'a list -> bool
  val list_all : ('a -> bool) -> 'a list -> bool
  val mat : nat -> nat -> ('a list) list -> bool
  val times_nata : nat -> nat -> nat
  val times_nat : nat times
  val dvd_nat : nat dvd
  val one_nat : nat one
  val ord_nat : nat ord
  val impl_of : 'a linorder -> ('a, 'b) rbt -> ('a, 'b) rbta
  val balance : ('a, 'b) rbta -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val ins :
    'a linorder ->
      ('a -> 'b -> 'b -> 'b) -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val paint : color -> ('a, 'b) rbta -> ('a, 'b) rbta
  val insert_with_key :
    'a linorder ->
      ('a -> 'b -> 'b -> 'b) -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val insertc : 'a linorder -> 'a -> 'b -> ('a, 'b) rbta -> ('a, 'b) rbta
  val insert : 'a linorder -> 'a -> 'b -> ('a, 'b) rbt -> ('a, 'b) rbt
  val lookupc : 'a linorder -> ('a, 'b) rbta -> 'a -> 'b option
  val lookup : 'a linorder -> ('a, 'b) rbt -> 'a -> 'b option
  val quotient_of : rat -> int * int
  val times_rata : rat -> rat -> rat
  val times_rat : rat times
  val dvd_rat : rat dvd
  val one_rata : rat
  val one_rat : rat one
  val less_rat : rat -> rat -> bool
  val less_eq_rat : rat -> rat -> bool
  val ord_rat : rat ord
  val proja : ('a, 'b) term -> nat -> ('a, 'b) term
  val member : 'a -> ('a -> bool) -> bool
  val shows_between :
    (char list -> char list) ->
      (char list -> char list) ->
        (char list -> char list) -> char list -> char list
  val quote : (char list -> char list) -> char list -> char list
  val debug : char list -> char list -> 'a -> 'a
  type 'a diva
  val dvd_div : 'a diva -> 'a dvd
  val diva : 'a diva -> 'a -> 'a -> 'a
  val moda : 'a diva -> 'a -> 'a -> 'a
  val fun_upd : 'a equal -> ('a -> 'b) -> 'a -> 'b -> 'a -> 'b
  type 'a plus
  val plus : 'a plus -> 'a -> 'a -> 'a
  type 'a zero
  val zero : 'a zero -> 'a
  val plus_int : int plus
  val zero_inta : int
  val zero_int : int zero
  val filter : ('a -> bool) -> 'a list -> 'a list
  val insertb : 'a equal -> 'a -> 'a list -> 'a list
  val plus_nat : nat plus
  val zero_nat : nat zero
  datatype pos = Empty | PCons of nat * pos
  type 'a power
  val one_power : 'a power -> 'a one
  val times_power : 'a power -> 'a times
  val powera : 'a -> ('a -> 'a -> 'a) -> 'a -> nat -> 'a
  val power : 'a power -> 'a -> nat -> 'a
  val prc_nat : ('a -> nat -> nat) -> 'a -> nat -> 'a -> nat -> bool * bool
  val prl_nat : ('a -> nat -> nat) -> 'a -> bool
  val plus_rata : rat -> rat -> rat
  val plus_rat : rat plus
  val zero_rata : rat
  val zero_rat : rat zero
  val lterms :
    ('a * nat -> (nat * nat) list) ->
      ('a, 'b) term -> (('a, 'b) term * nat) list
  val is_var : ('a, 'b) term -> bool
  val supteq : 'a equal -> 'b equal -> ('a, 'b) term * ('a, 'b) term -> bool
  val fun_of : 'a equal -> ('a * 'b) list -> 'a -> 'b
  val equal_int : int equal
  val power_int : int power
  datatype ('a, 'b) lab = Lab of ('a, 'b) lab * 'b |
    FunLab of ('a, 'b) lab * ('a, 'b) lab list | UnLab of 'a |
    Sharp of ('a, 'b) lab
  val remdups : 'a equal -> 'a list -> 'a list
  val remove1 : 'a equal -> 'a -> 'a list -> 'a list
  val it_add :
    ('a -> 'b -> 'c -> 'c) ->
      (('a -> 'b -> 'c -> 'c) -> 'c -> 'c -> 'c) -> 'c -> 'c -> 'c
  val vec0I : 'a -> nat -> 'a list
  val mat0I : 'a -> nat -> nat -> ('a list) list
  val minus_nat : nat -> nat -> nat
  val vec1I : 'a -> 'a -> nat -> nat -> 'a list
  val mat1I : 'a -> 'a -> nat -> ('a list) list
  val lm_store_acc :
    'a equal -> ('a * 'b) list -> 'a * 'b -> ('a * 'b) list -> ('a * 'b) list
  val lm_store : 'a equal -> ('a * 'b) list -> 'a * 'b -> ('a * 'b) list
  val l2m_store :
    'a equal -> 'b equal ->
      ('a * ('b * 'c) list) list -> ('a * 'b) * 'c -> ('a * ('b * 'c) list) list
  datatype ('a, 'b, 'c, 'd) memory_ext =
    Memory_ext of
      (unit -> 'a) * ('a -> 'b -> 'c option) * ('a -> 'b * 'c -> 'a) * 'd
  val l2m_lookup :
    'a equal -> 'b equal -> ('a * ('b * 'c) list) list -> 'a * 'b -> 'c option
  val l2m :
    'a equal -> 'b equal ->
      ((('a * ('b * 'c) list) list), ('a * 'b), 'c, unit) memory_ext
  val less_eq_prod_aux :
    'a equal * 'a ord -> 'b ord -> 'a * 'b -> 'a * 'b -> bool
  val equal_proda : 'a equal -> 'b equal -> 'a * 'b -> 'a * 'b -> bool
  val less_prod :
    'a equal * 'a ord -> 'b equal * 'b ord -> 'a * 'b -> 'a * 'b -> bool
  val less_eq_prod : 'a equal * 'a ord -> 'b ord -> 'a * 'b -> 'a * 'b -> bool
  val ord_prod : 'a equal * 'a ord -> 'b equal * 'b ord -> ('a * 'b) ord
  val equal_nat : nat equal
  val preorder_nat : nat preorder
  val order_nat : nat order
  val power_nat : nat power
  val equal_rata : rat -> rat -> bool
  val equal_rat : rat equal
  val power_rat : rat power
  val key : 'a * (('b, 'c) term * ('b, 'c) term) -> ('b * nat) option
  type 'a non_strict_order
  val ge : 'a non_strict_order -> 'a -> 'a -> bool
  val shows_sep :
    ('a -> char list -> char list) ->
      (char list -> char list) -> 'a list -> char list -> char list
  val shows_list_gen :
    ('a -> char list -> char list) ->
      char list ->
        char list -> char list -> char list -> 'a list -> char list -> char list
  val shows_list_aux :
    ('a -> char list -> char list) -> 'a list -> char list -> char list
  val divmod_nat : nat -> nat -> nat * nat
  val div_nata : nat -> nat -> nat
  val mod_nat : nat -> nat -> nat
  val digit2string : nat -> char list
  val shows_nat : nat -> char list -> char list
  val shows_prec_nat : nat -> nat -> char list -> char list
  val shows_prec_int : nat -> int -> char list -> char list
  val shows_list_int : int list -> char list -> char list
  val show_int : int show
  val shows_list_nat : nat list -> char list -> char list
  val show_nat : nat show
  val show_rata : rat -> char list
  val shows_prec_rat : nat -> rat -> char list -> char list
  val shows_list_rat : rat list -> char list -> char list
  val show_rat : rat show
  val subt_at : ('a, 'b) term -> pos -> ('a, 'b) term
  val the_var : ('a, 'b) term -> 'b
  val map_term : ('a -> 'b) -> ('a, 'c) term -> ('b, 'c) term
  val map_rule :
    ('a -> 'b) -> ('a, 'c) term * ('a, 'c) term -> ('b, 'c) term * ('b, 'c) term
  val extract : ('a -> bool) -> 'a list -> ('a list * ('a * 'a list)) option
  val distinct : 'a equal -> 'a list -> bool
  val vec_comp_all : ('a -> 'a -> bool) -> 'a list -> 'a list -> bool
  val mat_comp_all :
    ('a -> 'a -> bool) -> ('a list) list -> ('a list) list -> bool
  val mat_ge : 'a non_strict_order -> ('a list) list -> ('a list) list -> bool
  val maxa : ('a -> 'a -> bool) -> 'a -> 'a -> 'a
  val max : 'a ord -> 'a -> 'a -> 'a
  val mina : ('a -> 'a -> bool) -> 'a -> 'a -> 'a
  val min : 'a ord -> 'a -> 'a -> 'a
  type 'a top
  val order_top : 'a top -> 'a order
  val top : 'a top -> 'a
  val minus_rat : rat -> rat -> rat
  val shows_list_list : 'a show -> ('a list) list -> char list -> char list
  val show_list : 'a show -> ('a list) show
  val shows_paren : (char list -> char list) -> char list -> char list
  val shows_prec_prod :
    'a show -> 'b show -> nat -> 'a * 'b -> char list -> char list
  val shows_list_prod :
    'a show -> 'b show -> ('a * 'b) list -> char list -> char list
  val show_prod : 'a show -> 'b show -> ('a * 'b) show
  val shows_nl : char list -> char list
  val map_vars : ('a -> 'b) -> ('c, 'a) term -> ('c, 'b) term
  val num_args : ('a, 'b) term -> nat
  val unapp :
    'a equal -> 'a -> ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term list
  val max_list : nat list -> nat
  val min_list : 'a linorder -> 'a list -> 'a
  val xml3elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            ('a -> 'b -> 'c -> 'd) -> xml -> ((char list), 'd) sum
  val position : xml -> ((char list), nat) sum
  val xml_many_elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a list -> 'b) -> xml -> ((char list), 'b) sum
  datatype af_entry = Collapse of nat | AFList of nat list
  val afs :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((('a * nat) * af_entry) list)) sum
  val list2position : nat list -> pos
  val pos : xml -> ((char list), pos) sum
  val var : xml -> ((char list), ('a, (char list)) term) sum
  val xml1element :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> 'b) -> xml -> ((char list), 'b) sum
  val xml1many_elements_gen :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> xml -> ((char list), 'b) sum) ->
          ('a -> 'b list -> 'c) -> xml -> ((char list), 'c) sum
  val xml1many_elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          ('a -> 'b list -> 'c) -> xml -> ((char list), 'c) sum
  val term :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) term) sum
  val rule :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list), (('a, (char list)) term * ('a, (char list)) term)) sum
  val map_filter : ('a -> 'b option) -> 'a list -> 'b list
  val scg_position : xml -> ((char list), nat) sum
  val scg :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          ((('a, (char list)) term * ('a, (char list)) term) *
            ((nat * nat) list * (nat * nat) list)))
          sum
  datatype 'a projL = Projection of ('a * nat) list
  datatype arithFun = Arg of nat | Const of nat | Sum of arithFun list |
    Max of arithFun list | Min of arithFun list | Prod of arithFun list
  datatype 'a sl_inter = SL_Inter of nat * (('a * nat) * arithFun) list
  datatype ('a, 'b) sl_variant = Rootlab of ('a * nat) option |
    Finitelab of 'a sl_inter | QuasiFinitelab of 'a sl_inter * 'b
  datatype arctic = MinInfty | Num_arc of int
  datatype arctic_rat = MinInfty_rat | Num_arc_rat of rat
  datatype 'a redtriple_impl =
    Int_carrier of (('a * nat) * (int * int list)) list |
    Int_nl_carrier of (('a * nat) * ((nat * nat) list * int) list) list |
    Rat_carrier of rat * (('a * nat) * (rat * rat list)) list |
    Rat_nl_carrier of rat * (('a * nat) * ((nat * nat) list * rat) list) list |
    Arctic_carrier of (('a * nat) * (arctic * arctic list)) list |
    Arctic_rat_carrier of
      rat * (('a * nat) * (arctic_rat * arctic_rat list)) list
    | Int_mat_carrier of
        nat * nat *
          (('a * nat) * ((int list) list * ((int list) list) list)) list
    | Rat_mat_carrier of
        rat * nat * nat *
          (('a * nat) * ((rat list) list * ((rat list) list) list)) list
    | Arc_mat_carrier of
        nat * (('a * nat) *
                ((arctic list) list * ((arctic list) list) list)) list
    | Arc_rat_mat_carrier of
        rat * nat *
          (('a * nat) *
            ((arctic_rat list) list * ((arctic_rat list) list) list)) list
    | Rpo of
        (('a * nat) * (nat * order_tag)) list * (('a * nat) * af_entry) list
  datatype list_order_type = MS_Ext | Max_Ext | Min_Ext
  datatype 'a root_redtriple_impl =
    Scnp of
      list_order_type * (('a * nat) * (nat * nat) list) list * 'a redtriple_impl
  datatype ('a, 'b, 'c) dp_proof = PisEmpty |
    SubtermCriterionProc of
      ('a, 'b) lab projL *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
          (pos *
            (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
              (('a, 'b) lab, 'c) term)) list) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
    | RedPairProc of
        (('a, 'b) lab root_redtriple_impl, ('a, 'b) lab redtriple_impl) sum *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | RedPairUrProc of
        (('a, 'b) lab root_redtriple_impl, ('a, 'b) lab redtriple_impl) sum *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | DepGraphProc of
        (('a, 'b, 'c) dp_proof option *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list) list
    | MonoRedPairProc of
        ('a, 'b) lab redtriple_impl *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | MonoRedPairUrProc of
        ('a, 'b) lab redtriple_impl *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | SizeChangeSubterm of
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
          ((nat * nat) list * (nat * nat) list)) list
    | SizeChangeRedPair of
        ('a, 'b) lab redtriple_impl *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
            ((nat * nat) list * (nat * nat) list)) list
    | UncurryProc of
        nat option *
          (('a, 'b) lab *
            (((('a, 'b) lab * nat) * ('a, 'b) lab list) list *
              (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
                ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))) *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | FccProc of
        ('a, 'b) lab * (('a, 'b) lab, 'c) ctxt list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | SplitProc of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof * ('a, 'b, 'c) dp_proof
    | SemlabProc of
        (('a, 'b) lab, 'c) sl_variant *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (('a, 'b) lab, 'c) term list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | AssumeFinite of
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
            ((('a, 'b) lab, 'c) term list *
              (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
                ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))))
  datatype ('a, 'b) strategy = No_Strategy | Innermost |
    Innermost_Q of ('a, 'b) term list
  datatype boundstype = Roof | Match
  datatype ('a, 'b) ta_rule = TA_rule of 'b * 'a list * 'a
  datatype ('a, 'b) tree_automaton =
    Tree_Automaton of 'a list * ('a, 'b) ta_rule list * ('a * 'a) list
  datatype ('a, 'b) bounds_info =
    Bounds_Info of boundstype * nat * 'b list * ('b, ('a * nat)) tree_automaton
  datatype ('a, 'b, 'c) trs_proof =
    DPTrans of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
    | RuleRemoval of
        ('a, 'b) lab redtriple_impl *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) trs_proof
    | StringReversal of ('a, 'b, 'c) trs_proof |
    Bounds of (('a, 'b) lab, 'c) bounds_info |
    Uncurry of
      (('a, 'b) lab *
        (((('a, 'b) lab * nat) * ('a, 'b) lab list) list *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))) *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) trs_proof
    | Semlab of
        (('a, 'b) lab, 'c) sl_variant * (('a, 'b) lab, 'c) term list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) trs_proof
    | RisEmpty |
    Fcc of
      (('a, 'b) lab, 'c) ctxt list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) trs_proof
    | Split of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) trs_proof * ('a, 'b, 'c) trs_proof
    | AssumeSN of
        ((('a, 'b) lab, 'c) term list *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
            ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))
  datatype ('a, 'b) dp_disproof =
    DP_Loop of
      ('a, 'b) term *
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
        ('b * ('a, 'b) term) list * ('a, 'b) ctxt
    | DP_Rule_Removal of
        (('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) dp_disproof
  datatype ('a, 'b) trs_disproof =
    TRS_Loop of
      ('a, 'b) term *
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list *
        ('b * ('a, 'b) term) list * ('a, 'b) ctxt
    | TRS_Not_Well_Formed |
    TRS_Rule_Removal of
      (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) trs_disproof
    | TRS_String_Reversal of ('a, 'b) trs_disproof |
    TRS_DP_Trans of (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) dp_disproof
  datatype ('a, 'b) reltrs_disproof =
    Rel_Loop of
      ('a, 'b) term *
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
        ('b * ('a, 'b) term) list * ('a, 'b) ctxt
    | Rel_Not_Well_Formed |
    Rel_Rule_Removal of
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) reltrs_disproof
    | Rel_R_Not_SN of ('a, 'b) trs_disproof
  datatype ('a, 'b, 'c) cert_problem =
    TRS_Proof of
      (('a, 'b) lab, 'c) strategy *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list) option *
        ('a, 'b, 'c) trs_proof
    | DP_Proof of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (('a, 'b) lab, 'c) strategy *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ('a, 'b, 'c) dp_proof
    | DP_Disproof of
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (('a, 'b) lab, 'c) strategy *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (('a, 'b) lab, 'c) dp_disproof
    | TRS_Disproof of
        (('a, 'b) lab, 'c) strategy *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (('a, 'b) lab, 'c) trs_disproof
    | Rel_TRS_Disproof of
        (('a, 'b) lab, 'c) strategy *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          (('a, 'b) lab, 'c) reltrs_disproof
  type 'a typerep
  val typerepa : 'a typerep -> 'a itself -> Term.typ
  val typerep_nata : nat itself -> Term.typ
  val typerep_nat : nat typerep
  type 'a term_of
  val typerep_term_of : 'a term_of -> 'a typerep
  val term_of : 'a term_of -> 'a -> Term.term
  val div_nat : nat diva
  type 'a no_zero_divisors
  val times_no_zero_divisors : 'a no_zero_divisors -> 'a times
  val zero_no_zero_divisors : 'a no_zero_divisors -> 'a zero
  type 'a semigroup_mult
  val times_semigroup_mult : 'a semigroup_mult -> 'a times
  type 'a semigroup_add
  val plus_semigroup_add : 'a semigroup_add -> 'a plus
  type 'a ab_semigroup_add
  val semigroup_add_ab_semigroup_add : 'a ab_semigroup_add -> 'a semigroup_add
  type 'a semiring
  val ab_semigroup_add_semiring : 'a semiring -> 'a ab_semigroup_add
  val semigroup_mult_semiring : 'a semiring -> 'a semigroup_mult
  type 'a mult_zero
  val times_mult_zero : 'a mult_zero -> 'a times
  val zero_mult_zero : 'a mult_zero -> 'a zero
  type 'a monoid_add
  val semigroup_add_monoid_add : 'a monoid_add -> 'a semigroup_add
  val zero_monoid_add : 'a monoid_add -> 'a zero
  type 'a comm_monoid_add
  val ab_semigroup_add_comm_monoid_add :
    'a comm_monoid_add -> 'a ab_semigroup_add
  val monoid_add_comm_monoid_add : 'a comm_monoid_add -> 'a monoid_add
  type 'a semiring_0
  val comm_monoid_add_semiring_0 : 'a semiring_0 -> 'a comm_monoid_add
  val mult_zero_semiring_0 : 'a semiring_0 -> 'a mult_zero
  val semiring_semiring_0 : 'a semiring_0 -> 'a semiring
  type 'a monoid_mult
  val semigroup_mult_monoid_mult : 'a monoid_mult -> 'a semigroup_mult
  val power_monoid_mult : 'a monoid_mult -> 'a power
  type 'a zero_neq_one
  val one_zero_neq_one : 'a zero_neq_one -> 'a one
  val zero_zero_neq_one : 'a zero_neq_one -> 'a zero
  type 'a semiring_1
  val monoid_mult_semiring_1 : 'a semiring_1 -> 'a monoid_mult
  val semiring_0_semiring_1 : 'a semiring_1 -> 'a semiring_0
  val zero_neq_one_semiring_1 : 'a semiring_1 -> 'a zero_neq_one
  type 'a ab_semigroup_mult
  val semigroup_mult_ab_semigroup_mult :
    'a ab_semigroup_mult -> 'a semigroup_mult
  type 'a comm_semiring
  val ab_semigroup_mult_comm_semiring : 'a comm_semiring -> 'a ab_semigroup_mult
  val semiring_comm_semiring : 'a comm_semiring -> 'a semiring
  type 'a comm_semiring_0
  val comm_semiring_comm_semiring_0 : 'a comm_semiring_0 -> 'a comm_semiring
  val semiring_0_comm_semiring_0 : 'a comm_semiring_0 -> 'a semiring_0
  type 'a comm_monoid_mult
  val ab_semigroup_mult_comm_monoid_mult :
    'a comm_monoid_mult -> 'a ab_semigroup_mult
  val monoid_mult_comm_monoid_mult : 'a comm_monoid_mult -> 'a monoid_mult
  type 'a comm_semiring_1
  val comm_monoid_mult_comm_semiring_1 :
    'a comm_semiring_1 -> 'a comm_monoid_mult
  val comm_semiring_0_comm_semiring_1 : 'a comm_semiring_1 -> 'a comm_semiring_0
  val dvd_comm_semiring_1 : 'a comm_semiring_1 -> 'a dvd
  val semiring_1_comm_semiring_1 : 'a comm_semiring_1 -> 'a semiring_1
  type 'a cancel_semigroup_add
  val semigroup_add_cancel_semigroup_add :
    'a cancel_semigroup_add -> 'a semigroup_add
  type 'a cancel_ab_semigroup_add
  val ab_semigroup_add_cancel_ab_semigroup_add :
    'a cancel_ab_semigroup_add -> 'a ab_semigroup_add
  val cancel_semigroup_add_cancel_ab_semigroup_add :
    'a cancel_ab_semigroup_add -> 'a cancel_semigroup_add
  type 'a cancel_comm_monoid_add
  val cancel_ab_semigroup_add_cancel_comm_monoid_add :
    'a cancel_comm_monoid_add -> 'a cancel_ab_semigroup_add
  val comm_monoid_add_cancel_comm_monoid_add :
    'a cancel_comm_monoid_add -> 'a comm_monoid_add
  type 'a semiring_0_cancel
  val cancel_comm_monoid_add_semiring_0_cancel :
    'a semiring_0_cancel -> 'a cancel_comm_monoid_add
  val semiring_0_semiring_0_cancel : 'a semiring_0_cancel -> 'a semiring_0
  type 'a semiring_1_cancel
  val semiring_0_cancel_semiring_1_cancel :
    'a semiring_1_cancel -> 'a semiring_0_cancel
  val semiring_1_semiring_1_cancel : 'a semiring_1_cancel -> 'a semiring_1
  type 'a comm_semiring_0_cancel
  val comm_semiring_0_comm_semiring_0_cancel :
    'a comm_semiring_0_cancel -> 'a comm_semiring_0
  val semiring_0_cancel_comm_semiring_0_cancel :
    'a comm_semiring_0_cancel -> 'a semiring_0_cancel
  type 'a comm_semiring_1_cancel
  val comm_semiring_0_cancel_comm_semiring_1_cancel :
    'a comm_semiring_1_cancel -> 'a comm_semiring_0_cancel
  val comm_semiring_1_comm_semiring_1_cancel :
    'a comm_semiring_1_cancel -> 'a comm_semiring_1
  val semiring_1_cancel_comm_semiring_1_cancel :
    'a comm_semiring_1_cancel -> 'a semiring_1_cancel
  type 'a semiring_div
  val div_semiring_div : 'a semiring_div -> 'a diva
  val comm_semiring_1_cancel_semiring_div :
    'a semiring_div -> 'a comm_semiring_1_cancel
  val no_zero_divisors_semiring_div : 'a semiring_div -> 'a no_zero_divisors
  val no_zero_divisors_nat : nat no_zero_divisors
  val semigroup_mult_nat : nat semigroup_mult
  val semigroup_add_nat : nat semigroup_add
  val ab_semigroup_add_nat : nat ab_semigroup_add
  val semiring_nat : nat semiring
  val mult_zero_nat : nat mult_zero
  val monoid_add_nat : nat monoid_add
  val comm_monoid_add_nat : nat comm_monoid_add
  val semiring_0_nat : nat semiring_0
  val monoid_mult_nat : nat monoid_mult
  val zero_neq_one_nat : nat zero_neq_one
  val semiring_1_nat : nat semiring_1
  val ab_semigroup_mult_nat : nat ab_semigroup_mult
  val comm_semiring_nat : nat comm_semiring
  val comm_semiring_0_nat : nat comm_semiring_0
  val comm_monoid_mult_nat : nat comm_monoid_mult
  val comm_semiring_1_nat : nat comm_semiring_1
  val cancel_semigroup_add_nat : nat cancel_semigroup_add
  val cancel_ab_semigroup_add_nat : nat cancel_ab_semigroup_add
  val cancel_comm_monoid_add_nat : nat cancel_comm_monoid_add
  val semiring_0_cancel_nat : nat semiring_0_cancel
  val semiring_1_cancel_nat : nat semiring_1_cancel
  val comm_semiring_0_cancel_nat : nat comm_semiring_0_cancel
  val comm_semiring_1_cancel_nat : nat comm_semiring_1_cancel
  val semiring_div_nat : nat semiring_div
  val term_of_num_semiring : 'a semiring_div * 'a equal -> 'a -> 'a -> Term.term
  val term_of_nata : nat -> Term.term
  val term_of_nat : nat term_of
  val typerep_chara : char itself -> Term.typ
  val typerep_char : char typerep
  val term_of_char : char term_of
  val typerep_lista : 'a typerep -> ('a list) itself -> Term.typ
  val typerep_list : 'a typerep -> ('a list) typerep
  val term_of_lista : 'a term_of -> 'a list -> Term.term
  val term_of_list : 'a term_of -> ('a list) term_of
  val term_of_sum : 'a term_of -> 'b term_of -> ('a, 'b) sum -> Term.term
  val typerep_cert_problema :
    'a typerep -> 'b typerep -> 'c typerep ->
      ('a, 'b, 'c) cert_problem itself -> Term.typ
  val typerep_cert_problem :
    'a typerep -> 'b typerep -> 'c typerep -> ('a, 'b, 'c) cert_problem typerep
  val typerep_terma :
    'a typerep -> 'b typerep -> ('a, 'b) term itself -> Term.typ
  val typerep_term : 'a typerep -> 'b typerep -> ('a, 'b) term typerep
  val term_of_term : 'a term_of -> 'b term_of -> ('a, 'b) term term_of
  val term_of_terma : 'a term_of -> 'b term_of -> ('a, 'b) term -> Term.term
  val typerep_laba : 'a typerep -> 'b typerep -> ('a, 'b) lab itself -> Term.typ
  val typerep_lab : 'a typerep -> 'b typerep -> ('a, 'b) lab typerep
  val term_of_lab : 'a term_of -> 'b term_of -> ('a, 'b) lab term_of
  val term_of_laba : 'a term_of -> 'b term_of -> ('a, 'b) lab -> Term.term
  val typerep_proda : 'a typerep -> 'b typerep -> ('a * 'b) itself -> Term.typ
  val typerep_prod : 'a typerep -> 'b typerep -> ('a * 'b) typerep
  val term_of_proda : 'a term_of -> 'b term_of -> 'a * 'b -> Term.term
  val term_of_prod : 'a term_of -> 'b term_of -> ('a * 'b) term_of
  val term_of_optiona : 'a term_of -> 'a option -> Term.term
  val typerep_ctxta :
    'a typerep -> 'b typerep -> ('a, 'b) ctxt itself -> Term.typ
  val typerep_ctxt : 'a typerep -> 'b typerep -> ('a, 'b) ctxt typerep
  val term_of_ctxta : 'a term_of -> 'b term_of -> ('a, 'b) ctxt -> Term.term
  val term_of_ctxt : 'a term_of -> 'b term_of -> ('a, 'b) ctxt term_of
  val typerep_posa : pos itself -> Term.typ
  val typerep_pos : pos typerep
  val term_of_posa : pos -> Term.term
  val term_of_pos : pos term_of
  val typerep_optiona : 'a typerep -> ('a option) itself -> Term.typ
  val typerep_option : 'a typerep -> ('a option) typerep
  val term_of_option : 'a term_of -> ('a option) term_of
  val typerep_dp_proofa :
    'a typerep -> 'b typerep -> 'c typerep ->
      ('a, 'b, 'c) dp_proof itself -> Term.typ
  val typerep_dp_proof :
    'a typerep -> 'b typerep -> 'c typerep -> ('a, 'b, 'c) dp_proof typerep
  val term_of_projL : 'a term_of -> 'a projL -> Term.term
  val typerep_arithFuna : arithFun itself -> Term.typ
  val typerep_arithFun : arithFun typerep
  val term_of_arithFun : arithFun term_of
  val term_of_arithFuna : arithFun -> Term.term
  val term_of_sl_inter : 'a term_of -> 'a sl_inter -> Term.term
  val term_of_sl_variant :
    'a term_of -> 'b term_of -> ('a, 'b) sl_variant -> Term.term
  val typerep_redtriple_impla :
    'a typerep -> 'a redtriple_impl itself -> Term.typ
  val typerep_redtriple_impl : 'a typerep -> 'a redtriple_impl typerep
  val typerep_rata : rat itself -> Term.typ
  val typerep_rat : rat typerep
  val typerep_inta : int itself -> Term.typ
  val typerep_int : int typerep
  val term_of_int : int term_of
  val term_of_rata : rat -> Term.term
  val term_of_rat : rat term_of
  val typerep_order_taga : order_tag itself -> Term.typ
  val typerep_order_tag : order_tag typerep
  val term_of_order_taga : order_tag -> Term.term
  val term_of_order_tag : order_tag term_of
  val typerep_arctica : arctic itself -> Term.typ
  val typerep_arctic : arctic typerep
  val term_of_arctica : arctic -> Term.term
  val term_of_arctic : arctic term_of
  val typerep_af_entrya : af_entry itself -> Term.typ
  val typerep_af_entry : af_entry typerep
  val term_of_af_entrya : af_entry -> Term.term
  val term_of_af_entry : af_entry term_of
  val typerep_arctic_rata : arctic_rat itself -> Term.typ
  val typerep_arctic_rat : arctic_rat typerep
  val term_of_arctic_rata : arctic_rat -> Term.term
  val term_of_arctic_rat : arctic_rat term_of
  val term_of_redtriple_impla : 'a term_of -> 'a redtriple_impl -> Term.term
  val term_of_redtriple_impl : 'a term_of -> 'a redtriple_impl term_of
  val typerep_root_redtriple_impla :
    'a typerep -> 'a root_redtriple_impl itself -> Term.typ
  val typerep_root_redtriple_impl : 'a typerep -> 'a root_redtriple_impl typerep
  val term_of_list_order_type : list_order_type -> Term.term
  val term_of_root_redtriple_impla :
    'a term_of -> 'a root_redtriple_impl -> Term.term
  val term_of_root_redtriple_impl : 'a term_of -> 'a root_redtriple_impl term_of
  val term_of_dp_proofa :
    'a term_of -> 'b term_of -> 'c term_of -> ('a, 'b, 'c) dp_proof -> Term.term
  val term_of_dp_proof :
    'a term_of -> 'b term_of -> 'c term_of -> ('a, 'b, 'c) dp_proof term_of
  val term_of_strategy :
    'a term_of -> 'b term_of -> ('a, 'b) strategy -> Term.term
  val term_of_boundstype : boundstype -> Term.term
  val typerep_ta_rulea :
    'a typerep -> 'b typerep -> ('a, 'b) ta_rule itself -> Term.typ
  val typerep_ta_rule : 'a typerep -> 'b typerep -> ('a, 'b) ta_rule typerep
  val term_of_ta_rulea :
    'a term_of -> 'b term_of -> ('a, 'b) ta_rule -> Term.term
  val term_of_ta_rule : 'a term_of -> 'b term_of -> ('a, 'b) ta_rule term_of
  val term_of_tree_automaton :
    'a term_of -> 'b term_of -> ('a, 'b) tree_automaton -> Term.term
  val term_of_bounds_info :
    'a term_of -> 'b term_of -> ('a, 'b) bounds_info -> Term.term
  val term_of_trs_proof :
    'a term_of -> 'b term_of -> 'c term_of ->
      ('a, 'b, 'c) trs_proof -> Term.term
  val typerep_boola : bool itself -> Term.typ
  val typerep_bool : bool typerep
  val term_of_boola : bool -> Term.term
  val term_of_bool : bool term_of
  val term_of_dp_disproof :
    'a term_of -> 'b term_of -> ('a, 'b) dp_disproof -> Term.term
  val term_of_trs_disproof :
    'a term_of -> 'b term_of -> ('a, 'b) trs_disproof -> Term.term
  val term_of_reltrs_disproof :
    'a term_of -> 'b term_of -> ('a, 'b) reltrs_disproof -> Term.term
  val term_of_cert_problema :
    'a term_of -> 'b term_of -> 'c term_of ->
      ('a, 'b, 'c) cert_problem -> Term.term
  val term_of_cert_problem :
    'a term_of -> 'b term_of -> 'c term_of -> ('a, 'b, 'c) cert_problem term_of
  val termifyCP :
    ((char list), ((char list), (nat list), (char list)) cert_problem) sum ->
      Term.term
  datatype cert_result = Certified of char list | Unsupported of char list |
    Error of char list
  val term_of_cert_result : cert_result -> Term.term
  val termifyCR : cert_result -> Term.term
  datatype ('a, 'b) gctxt = GCHole | GCFun of 'a * ('a, 'b) gctxt list
  val guard : bool -> unit option
  val merge_lists :
    'a equal ->
      ('a, 'b) gctxt list -> ('a, 'b) gctxt list -> (('a, 'b) gctxt list) option
  val merge :
    'a equal -> ('a, 'b) gctxt -> ('a, 'b) gctxt -> ('a, 'b) gctxt option
  val merge_var :
    'a equal -> 'b equal ->
      'a -> ('b, 'a) gctxt ->
              (('b, 'a) gctxt * 'a) list ->
                ((('b, 'a) gctxt * 'a) * (('b, 'a) gctxt * 'a) list) option
  val merge_all :
    'a equal -> 'b equal ->
      (('a, 'b) gctxt * 'b) list -> ((('a, 'b) gctxt * 'b) list) option
  val zip_option : 'a list -> 'b list -> (('a * 'b) list) option
  val match_lista :
    'a equal ->
      (('a, 'b) gctxt * ('a, 'b) term) list ->
        ((('a, 'b) gctxt * 'b) list) option
  val matchc :
    'a equal -> 'b equal ->
      ('a, 'b) gctxt * ('a, 'b) term -> ((('a, 'b) gctxt * 'b) list) option
  val matchb : 'a equal -> 'b equal -> ('a, 'b) gctxt -> ('a, 'b) term -> bool
  val capRM2 :
    'a equal -> 'b equal ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        ('a, 'b) term -> ('a, 'b) gctxt
  val capRM :
    'a equal -> 'b equal ->
      bool ->
        ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
          ('a, 'b) term -> ('a, 'b) gctxt
  val partition : ('a -> bool) -> 'a list -> 'a list * 'a list
  val removeAll : 'a equal -> 'a -> 'a list -> 'a list
  val sub_vec : nat -> 'a list -> 'a list
  val sub_mat : nat -> nat -> ('a list) list -> ('a list) list
  val vec_pre_gtI : ('a -> 'a -> bool) -> 'a list -> 'a list -> bool
  val mat_pre_gtI :
    ('a -> 'a -> bool) -> ('a list) list -> ('a list) list -> bool
  val mat_gtI :
    'a non_strict_order ->
      ('a -> 'a -> bool) -> nat -> ('a list) list -> ('a list) list -> bool
  val vec_map : ('a -> 'a) -> 'a list -> 'a list
  val mat_map : ('a -> 'a) -> ('a list) list -> ('a list) list
  val emptya : ('a, 'b, 'c, 'd) memory_ext -> unit -> 'a
  val store : ('a, 'b, 'c, 'd) memory_ext -> 'a -> 'b * 'c -> 'a
  val preorder_prod :
    'a equal * 'a order -> 'b equal * 'b order -> ('a * 'b) preorder
  val order_prod : 'a equal * 'a order -> 'b equal * 'b order -> ('a * 'b) order
  type 'a ordered_ab_semigroup
  val ab_semigroup_add_ordered_ab_semigroup :
    'a ordered_ab_semigroup -> 'a ab_semigroup_add
  val non_strict_order_ordered_ab_semigroup :
    'a ordered_ab_semigroup -> 'a non_strict_order
  type 'a max_ordered_monoid_add
  val monoid_add_max_ordered_monoid_add :
    'a max_ordered_monoid_add -> 'a monoid_add
  val ordered_ab_semigroup_max_ordered_monoid_add :
    'a max_ordered_monoid_add -> 'a ordered_ab_semigroup
  val max0 : 'a max_ordered_monoid_add -> 'a -> 'a
  val s_ins : ('a -> unit -> 'b -> 'c) -> 'a -> 'b -> 'c
  val sharp_term : ('a -> 'a) -> ('a, 'b) term -> ('a, 'b) term
  val aarity : ('a -> nat -> 'a list) -> 'a -> nat -> nat
  val list_diff : 'a equal -> 'a list -> 'a list -> 'a list
  val expecting :
    'a show -> char list -> 'a list -> ((char list), ('b * 'a list)) sum
  val eoi : 'a show -> 'a list -> ((char list), (unit * 'a list)) sum
  val xml_choice :
    char list ->
      (xml -> ((char list), 'a) sum) list -> xml -> ((char list), 'a) sum
  datatype ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter = Alter1 of 'a |
    Alter2 of 'b | Alter3 of 'c | Alter4 of 'd | Alter5 of 'e | Alter6 of 'f |
    Alter7 of 'g | Alter8 of 'h | Alter9 of 'i | Alter10 of 'j
  val xml0elements : char list -> 'a -> xml -> ((char list), 'a) sum
  val xml4elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              ('a -> 'b -> 'c -> 'd -> 'e) -> xml -> ((char list), 'e) sum
  val ctxt :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) ctxt) sum
  val subst :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((char list * ('a, (char list)) term) list)) sum
  val xml3to4elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              ('a -> 'b -> 'c option -> 'd -> 'e) ->
                xml -> ((char list), 'e) sum
  val rstep :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (pos *
            ((('a, (char list)) term * ('a, (char list)) term) *
              (bool * ('a, (char list)) term))))
          sum
  val rsteps :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (('a, (char list)) term *
            (pos *
              ((('a, (char list)) term * ('a, (char list)) term) *
                (bool * ('a, (char list)) term))) list))
          sum
  val loop :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (('a, (char list)) term *
            ((pos *
               ((('a, (char list)) term * ('a, (char list)) term) *
                 (bool * ('a, (char list)) term))) list *
              ((char list * ('a, (char list)) term) list *
                ('a, (char list)) ctxt))))
          sum
  val proj :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), 'a projL) sum
  val start_term :
    'a equal ->
      (xml -> ((char list), 'a) sum) ->
        ('a, (char list)) term ->
          xml -> ((char list), ('a, (char list)) term) sum
  val proj_term : ('a -> nat) -> ('a, 'b) term -> ('a, 'b) term
  val rseq :
    'a equal ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> nat) ->
          ('a, (char list)) term * ('a, (char list)) term ->
            xml ->
              ((char list),
                ((('a, (char list)) term * ('a, (char list)) term) *
                  (pos *
                    ((('a, (char list)) term * ('a, (char list)) term) *
                      ('a, (char list)) term)) list))
                sum
  val semigroup_mult_int : int semigroup_mult
  val semigroup_add_int : int semigroup_add
  val ab_semigroup_add_int : int ab_semigroup_add
  val semiring_int : int semiring
  val label :
    ('a, 'b) lab -> nat -> ('b, (('a, 'b) lab list)) sum -> ('a, 'b) lab
  val mat_max0 : 'a max_ordered_monoid_add -> ('a list) list -> ('a list) list
  val lookupb : ('a, 'b, 'c, 'd) memory_ext -> 'a -> 'b -> 'c option
  val rito_map_to_sorted_list :
    (('a -> 'b -> ('a * 'b) list -> ('a * 'b) list) ->
      'c -> ('a * 'b) list -> ('a * 'b) list) ->
      'c -> ('a * 'b) list
  val itoi_reverse_iterateo :
    (('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a) ->
      ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a
  val rm_reverse_iterateoi :
    ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbta -> 'a -> 'a
  val rm_reverse_iterateoia :
    'b linorder ->
      ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbt -> 'a -> 'a
  val rm_reverse_iterateo :
    'a linorder -> ('a -> 'b -> 'c -> 'c) -> ('a, 'b) rbt -> 'c -> 'c
  val rm_to_list : 'a linorder -> ('a, 'b) rbt -> ('a * 'b) list
  val values : 'a linorder -> ('a, ('b list)) rbt -> 'b list
  val linorder_nat : nat linorder
  datatype ('a, 'b) tpoly = PVar of 'a | PNum of 'b |
    PSum of ('a, 'b) tpoly list | PMult of ('a, 'b) tpoly list
  val semigroup_mult_rat : rat semigroup_mult
  val semigroup_add_rat : rat semigroup_add
  val ab_semigroup_add_rat : rat ab_semigroup_add
  val semiring_rat : rat semiring
  val s_memb : ('a -> 'b -> 'c option) -> 'a -> 'b -> bool
  val ctxt_apply : ('a, 'b) ctxt -> ('a, 'b) term -> ('a, 'b) term
  val equal_ctxt :
    'a equal -> 'b equal -> ('a, 'b) ctxt -> ('a, 'b) ctxt -> bool
  val hvf_top : 'a equal -> 'a -> nat -> ('a, 'b) term -> bool
  val list_inter : 'a equal -> 'a list -> 'a list -> 'a list
  val list_union : 'a equal -> 'a list -> 'a list -> 'a list
  val binda :
    ('a list -> ((char list), ('b * 'a list)) sum) ->
      ('b -> 'a list -> ((char list), ('c * 'a list)) sum) ->
        'a list -> ((char list), ('c * 'a list)) sum
  val many :
    (char -> bool) -> char list -> ((char list), (char list * char list)) sum
  val wspace : char list
  val trim : char list -> char list
  datatype domain = Natural of nat | Arctic | Arctic_rat of rat |
    Int_mat of nat * nat | Arc_mat of nat | Arc_rat_mat of rat * nat |
    Rational of rat * nat | Rat_mat of rat * nat * nat
  val labela :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((nat list), ('a list)) sum) sum
  val rules :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list), ((('a, (char list)) term * ('a, (char list)) term) list))
          sum
  val state : xml -> ((char list), (char list)) sum
  val xml_lab : 'a show -> 'b show -> ('a, ('b list)) lab -> xml
  val xml_term :
    'a show -> 'b show -> 'c show -> (('a, ('b list)) lab, 'c) term -> xml
  val xml_Q :
    'a show -> 'b show -> 'c show ->
      (('a, ('b list)) lab, 'c) strategy -> xml list
  val isOK : ('a, 'b) sum -> bool
  val mult_zero_int : int mult_zero
  val list_update : 'a list -> nat -> 'a -> 'a list
  val base : 'a * nat -> 'a
  val lift : nat -> 'a -> 'a * nat
  val vars_term_lista : ('a, 'b) term -> 'b list
  val vars_term_list : 'b equal -> ('a, 'b) term -> 'b list
  val roof : 'b equal -> ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term -> bool
  val mat_monoI : ('a -> bool) -> nat -> ('a list) list -> bool
  val transpose : nat -> ('a list) list -> ('a list) list
  val scalar_prodI :
    'a -> ('a -> 'a -> 'a) -> ('a -> 'a -> 'a) -> 'a list -> 'a list -> 'a
  val matT_vec_multI :
    'a -> ('a -> 'a -> 'a) ->
            ('a -> 'a -> 'a) -> ('a list) list -> 'a list -> 'a list
  val mat_multI :
    'a -> ('a -> 'a -> 'a) ->
            ('a -> 'a -> 'a) ->
              nat -> ('a list) list -> ('a list) list -> ('a list) list
  val vec_plusI : ('a -> 'a -> 'a) -> 'a list -> 'a list -> 'a list
  val mat_plusI :
    ('a -> 'a -> 'a) -> ('a list) list -> ('a list) list -> ('a list) list
  val equal_color : color -> color -> bool
  val equal_rbtb :
    'a equal -> 'b equal -> ('a, 'b) rbta -> ('a, 'b) rbta -> bool
  val equal_rbta :
    'a equal * 'a linorder -> 'b equal -> ('a, 'b) rbt -> ('a, 'b) rbt -> bool
  val equal_rbt : 'a equal * 'a linorder -> 'b equal -> ('a, 'b) rbt equal
  val mult_zero_rat : rat mult_zero
  val fun_ofa : 'b equal -> 'a -> ('b * 'a) list -> 'b -> 'a
  val s_empty : 'a -> 'a
  val s_union : 'a -> 'a
  val varsL : 'b equal -> (('a, 'b) term * ('a, 'b) term) list -> 'b -> bool
  val decompose :
    'a equal ->
      ('a, 'b) term ->
        ('a, 'b) term -> ((('a, 'b) term * ('a, 'b) term) list) option
  val simple_subst :
    'a equal -> 'a -> ('b, 'a) term -> ('b, 'a) term -> ('b, 'a) term
  val simple_subst_list :
    'a equal ->
      'a -> ('b, 'a) term ->
              (('b, 'a) term * ('b, 'a) term) list ->
                (('b, 'a) term * ('b, 'a) term) list
  val unify :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((('a, 'b) term * ('a, 'b) term) list) option
  val subst_of :
    'b equal -> (('a, 'b) term * ('a, 'b) term) list -> 'b -> ('a, 'b) term
  val mgu :
    'a equal -> 'b equal ->
      ('a, 'b) term -> ('a, 'b) term -> ('b -> ('a, 'b) term) option
  val linear_term_impl :
    'a equal -> 'a list -> ('b, 'a) term -> ('a list) option
  val linear_term : 'b equal -> ('a, 'b) term -> bool
  val map_term_wa : ('a -> nat -> 'b) -> ('a, 'c) term -> ('b, 'c) term
  val rq : ('a, 'b) ta_rule -> 'a
  val hvf_term : 'a equal -> 'a -> ('a, 'b) term -> bool
  val oneof_aux :
    (char list) list ->
      (char list) list ->
        char list -> ((char list), (char list * char list)) sum
  val oneof :
    (char list) list -> char list -> ((char list), (char list * char list)) sum
  datatype xmldoc = Xmldoc of char list * xml
  val xml5elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              (xml -> ((char list), 'e) sum) ->
                ('a -> 'b -> 'c -> 'd -> 'e -> 'f) ->
                  xml -> ((char list), 'f) sum
  val catch : ('a, 'b) sum -> ('a -> ('c, 'b) sum) -> ('c, 'b) sum
  val forallm : ('a -> ('b, unit) sum) -> 'a list -> (('a * 'b), unit) sum
  val check : bool -> 'a -> ('a, unit) sum
  val check_edges :
    ('a -> char list -> char list) ->
      ('a * 'a -> bool) ->
        'a list -> 'a list -> ((char list -> char list), unit) sum
  val monoid_add_int : int monoid_add
  val comm_monoid_add_int : int comm_monoid_add
  val semiring_0_int : int semiring_0
  val monoid_mult_int : int monoid_mult
  val zero_neq_one_int : int zero_neq_one
  val semiring_1_int : int semiring_1
  val rel_pow_impl :
    ('a list -> 'a list) ->
      ('a list -> 'b -> 'b) -> ('a -> 'b -> bool) -> 'a list -> 'b -> nat -> 'b
  val rtrancl_impl :
    (('a * 'a) list -> 'a list -> 'a list) ->
      ('a list -> 'b -> 'b) ->
        ('a -> 'b -> bool) -> 'b -> ('a * 'a) list -> 'a list -> 'b
  val rtrancl_list_impl : 'a equal -> ('a * 'a) list -> 'a list -> 'a list
  val w_impl : 'a equal -> ('a * ('b, 'a) term) list -> ('b, 'a) term -> 'a list
  val match : ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term -> bool
  val linorder_prod :
    'a equal * 'a linorder -> 'b equal * 'b linorder -> ('a * 'b) linorder
  val top_boola : bool
  val top_bool : bool top
  val top_fun : 'b top -> 'a -> 'b
  val equal_posa : pos -> pos -> bool
  val equal_pos : pos equal
  val rm_update : 'a linorder -> 'a -> 'b -> ('a, 'b) rbt -> ('a, 'b) rbt
  val itoi_iterateo :
    (('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a) ->
      ('b -> 'c -> 'a -> 'a) -> 'd -> 'a -> 'a
  val rm_iterateoi :
    ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbta -> 'a -> 'a
  val rm_iterateoia :
    'b linorder ->
      ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbt -> 'a -> 'a
  val rm_iterateo :
    'a linorder -> ('a -> 'b -> 'c -> 'c) -> ('a, 'b) rbt -> 'c -> 'c
  val rm_iterate :
    'a linorder -> ('a -> 'b -> 'c -> 'c) -> ('a, 'b) rbt -> 'c -> 'c
  val rm_add : 'a linorder -> ('a, 'b) rbt -> ('a, 'b) rbt -> ('a, 'b) rbt
  val rs_ins : 'a linorder -> 'a -> ('a, unit) rbt -> ('a, unit) rbt
  val equal_order_tag : order_tag -> order_tag -> bool
  val diag_l : 'a * 'b -> ('a * 'a) * 'b
  val lex_ext_efficient_m :
    ('a -> 'a -> 'b -> (bool * bool) * 'b) ->
      'a list -> 'a list -> 'b -> (bool * bool) * 'b
  val filter_not_stri_efficient_m_aux :
    ('a -> 'b -> (bool * bool) * 'b) -> 'a list -> 'a list -> 'b -> 'a list * 'b
  val filter_not_stri_efficient_m :
    ('a -> 'b -> (bool * bool) * 'b) -> 'a list -> 'b -> 'a list * 'b
  val mul_ext_efficient_m :
    'a equal ->
      ('a -> 'a -> 'b -> (bool * bool) * 'b) ->
        'a list -> 'a list -> 'b -> (bool * bool) * 'b
  val ex_dom_efficient_m :
    'a equal ->
      ('a -> 'a -> 'b -> (bool * bool) * 'b) ->
        'a -> 'a list -> 'a list -> 'a list -> 'b -> (bool * bool) * 'b
  val all_stri_efficient_m :
    ('a -> 'b -> (bool * bool) * 'b) -> 'a list -> 'b -> bool * 'b
  val any_nstri_efficient_m :
    ('a -> 'b -> (bool * bool) * 'b) -> 'a list -> 'b -> bool * 'b
  val rpo_efficient_m :
    'b equal -> 'c equal ->
      ('a, (('b, 'c) term * ('b, 'c) term), (bool * bool), unit) memory_ext ->
        ('b -> nat -> 'b -> nat -> bool * bool) * ('b -> bool) ->
          ('b -> nat -> order_tag) ->
            ('b, 'c) term -> ('b, 'c) term -> 'a -> (bool * bool) * 'a
  val efficient_rpo_2 :
    'a equal -> 'b equal ->
      ('a -> nat -> 'a -> nat -> bool * bool) * ('a -> bool) ->
        ('a -> nat -> order_tag) ->
          ('a, 'b) term -> ('a, 'b) term -> bool * bool
  val rpo_unbounded_impl :
    'a equal -> 'b equal ->
      ('a -> nat -> 'a -> nat -> bool * bool) * ('a -> bool) ->
        ('a -> nat -> order_tag) ->
          ('a, 'b) term -> ('a, 'b) term -> bool * bool
  val rpo_unbounded :
    'a equal -> 'b equal ->
      ('a -> nat -> 'a -> nat -> bool * bool) * ('a -> bool) ->
        ('a -> nat -> order_tag) ->
          ('a, 'b) term -> ('a, 'b) term -> bool * bool
  val monoid_add_rat : rat monoid_add
  val comm_monoid_add_rat : rat comm_monoid_add
  val semiring_0_rat : rat semiring_0
  val monoid_mult_rat : rat monoid_mult
  val zero_neq_one_rat : rat zero_neq_one
  val semiring_1_rat : rat semiring_1
  val equal_suma : 'a equal -> 'b equal -> ('a, 'b) sum -> ('a, 'b) sum -> bool
  val equal_sum : 'a equal -> 'b equal -> ('a, 'b) sum equal
  datatype ('a, 'b, 'c) redtriple_ext =
    Redtriple_ext of
      ((char list -> char list), unit) sum *
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) *
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) *
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) *
        ('a -> nat -> nat -> bool) * ((char list -> char list), unit) sum *
        (char list -> char list) * 'c
  val s :
    ('a, 'b, 'c) redtriple_ext ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val match_vars :
    'a equal -> 'b equal ->
      ('a * ('b, 'a) term) list -> ('a -> ('b, 'a) term) option
  val match_term_list :
    'a equal ->
      (('a, 'b) term * ('a, 'b) term) list -> (('b * ('a, 'b) term) list) option
  val match_list :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list -> ('b -> ('a, 'b) term) option
  val instance_rule :
    'a equal -> 'b equal ->
      ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term -> bool
  val equal_lab : 'a equal -> 'b equal -> ('a, 'b) lab equal
  val equal_laba : 'a equal -> 'b equal -> ('a, 'b) lab -> ('a, 'b) lab -> bool
  val gen_label : ('a, 'b) lab -> nat -> ('a, 'b) lab
  val label_depth : ('a, 'b) lab -> nat
  val fmap :
    'a equal -> 'b equal ->
      ('a, 'b) lab ->
        nat ->
          ((('a, 'b) lab * nat) * ('a, 'b) lab list) list ->
            ('a, 'b) lab -> nat -> ('a, 'b) lab
  val concat_lists : ('a list) list -> ('a list) list
  val enum_vectors : 'a list -> 'b list -> (('b * 'a) list) list
  val manyof :
    char list -> char list -> ((char list), (char list * char list)) sum
  val spaces : char list -> ((char list), (unit * char list)) sum
  val xml2nd_choice :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        char list ->
          (xml -> ((char list), 'b) sum) ->
            ('a -> 'b option -> 'c) -> xml -> ((char list), 'c) sum
  val alter1a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'a
  val alter2a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'b
  val alter3a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'c
  val alter4a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'd
  val alter5a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'e
  val alter6a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'f
  val alter7a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'g
  val alter8a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'h
  val alter9a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'i
  datatype ('a, 'b, 'c, 'd) dpp_ops_ext =
    Dpp_ops_ext of
      ('a ->
        (('b, 'c) term * ('b, 'c) term -> bool) *
          ((('b, 'c) term * ('b, 'c) term -> bool) *
            ((('b, 'c) term -> bool) *
              ((('b, 'c) term * ('b, 'c) term -> bool) *
                (('b, 'c) term * ('b, 'c) term -> bool))))) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> ('b, 'c) term list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) * ('a -> bool) *
        ('a -> bool) * ('a -> bool) * ('a -> ('b, 'c) term -> bool) *
        ('a -> bool) *
        ('a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list -> 'a) *
        ('a ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list -> 'a) *
        ('a ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list -> 'a) *
        ('a ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list *
              (('b, 'c) term * ('b, 'c) term) list) *
        ('a ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list *
              (('b, 'c) term * ('b, 'c) term) list) *
        ((('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list ->
            ('b, 'c) term list ->
              (('b, 'c) term * ('b, 'c) term) list ->
                (('b, 'c) term * ('b, 'c) term) list -> 'a) *
        'd
  val rules_mapb :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list
  val rules_no_left_vara : ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> bool
  val capRM_dpp :
    'b equal -> 'c equal ->
      ('a, 'b, 'c, unit) dpp_ops_ext -> 'a -> ('b, 'c) term -> ('b, 'c) gctxt
  val conflict_pos :
    'a equal -> 'b equal ->
      ('a -> ('b, 'a) term) ->
        ('b, 'a) term * (('b, 'a) term * nat) ->
          (('b, 'a) term * (('b, 'a) term * nat)) list
  val height : 'a * nat -> nat
  val equal_optiona : 'a equal -> 'a option -> 'a option -> bool
  val equal_option : 'a equal -> ('a option) equal
  val one_poly : 'b semiring_1 -> (('a * nat) list * 'b) list
  val eq_monom : 'a equal -> ('a * nat) list -> ('a * nat) list -> bool
  val poly_add :
    'a equal -> 'b equal * 'b semiring_0 ->
      (('a * nat) list * 'b) list ->
        (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list
  val monom_mult :
    'a equal -> ('a * nat) list -> ('a * nat) list -> ('a * nat) list
  val monom_mult_poly :
    'a equal -> 'b equal * 'b semiring_0 ->
      ('a * nat) list * 'b ->
        (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list
  val poly_mult :
    'a equal -> 'b equal * 'b semiring_0 ->
      (('a * nat) list * 'b) list ->
        (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list
  val zero_poly : (('a * nat) list * 'b) list
  val poly_of :
    'a equal -> 'b equal * 'b comm_semiring_1 ->
      ('a, 'b) tpoly -> (('a * nat) list * 'b) list
  val rm_lookup : 'a linorder -> 'a -> ('a, 'b) rbt -> 'b option
  val rs_memb : 'a linorder -> 'a -> ('a, unit) rbt -> bool
  val shows_rpo_repr :
    'a show -> (('a * nat) * (nat * order_tag)) list -> char list -> char list
  val scnp_af_to_af :
    ('a * nat -> (nat * nat) list) ->
      ('a -> nat -> nat -> bool) -> 'a -> nat -> nat -> bool
  val s_isEmpty : 'a -> 'a
  val matcha :
    'a equal -> 'b equal ->
      ('a, 'b) term -> ('a, 'b) term -> ('b -> ('a, 'b) term) option
  val subst_apply_term : ('a, 'b) term -> ('b -> ('a, 'c) term) -> ('a, 'c) term
  val subst_compose :
    ('a -> ('b, 'c) term) -> ('c -> ('b, 'd) term) -> 'a -> ('b, 'd) term
  val mk_subst : 'a equal -> ('a * ('b, 'a) term) list -> 'a -> ('b, 'a) term
  val shows_term :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) -> ('a, 'b) term -> char list -> char list
  val shows_prec_term :
    'a show -> 'b show -> nat -> ('a, 'b) term -> char list -> char list
  val shows_list_term :
    'a show -> 'b show -> ('a, 'b) term list -> char list -> char list
  val show_term : 'a show -> 'b show -> ('a, 'b) term show
  val full_af : 'a -> nat -> nat -> bool
  val af : ('a, 'b, 'c) redtriple_ext -> 'a -> nat -> nat -> bool
  val ns :
    ('a, 'b, 'c) redtriple_ext ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  datatype ('a, 'b, 'c) root_redtriple_ext =
    Root_redtriple_ext of
      ((char list -> char list), unit) sum *
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) *
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) *
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) *
        ('a -> nat -> nat -> bool) * ('a -> nat -> nat -> bool) *
        (char list -> char list) * 'c
  val sa :
    ('a, 'b, 'c) root_redtriple_ext ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val equal_prod : 'a equal -> 'b equal -> ('a * 'b) equal
  val defs_list :
    'a equal -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val shows_pos : pos -> char list -> char list
  val shows_rule :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) ->
        char list -> ('a, 'b) term * ('a, 'b) term -> char list -> char list
  val shows_rules :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) ->
        char list ->
          (('a, 'b) term * ('a, 'b) term) list -> char list -> char list
  val shows_trs :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) ->
        char list ->
          char list ->
            (('a, 'b) term * ('a, 'b) term) list -> char list -> char list
  val apply_args : 'a -> ('a, 'b) term -> ('a, 'b) term list -> ('a, 'b) term
  val get_symbol : ('a -> nat -> 'a list) -> 'a -> nat -> nat -> 'a
  val letters : char list
  val alter10a : ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter -> 'j
  val sum_lpoly : ('a -> 'a -> 'a) -> 'a list -> 'a list -> 'a list
  val lpoly_of :
    'a equal ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      (nat, 'a) tpoly -> ((char list), ('a * 'a list)) sum
  val strategy :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) strategy) sum
  val matches : 'a equal -> 'b equal -> ('a, 'b) term -> ('a, 'b) term -> bool
  val supteq_list : ('a, 'b) term -> ('a, 'b) term list
  val nF_subset :
    'a equal -> 'b equal -> ('a, 'b) term list -> ('a, 'b) term list -> bool
  val less_list : 'a equal * 'a order -> 'a list -> 'a list -> bool
  val less_eq_list : 'a equal * 'a order -> 'a list -> 'a list -> bool
  val ord_list : 'a equal * 'a order -> ('a list) ord
  val mat_arc_posI : ('a -> bool) -> ('a list) list -> bool
  val poly_var : 'a equal -> (('a * nat) list * 'b) list -> 'a -> bool
  val rm_alpha : 'a linorder -> ('a, 'b) rbt -> 'a -> 'b option
  val rm_empty : 'a linorder -> ('a, 'b) rbt
  val rs_empty : 'a linorder -> ('a, unit) rbt
  val rs_union :
    'a linorder -> ('a, unit) rbt -> ('a, unit) rbt -> ('a, unit) rbt
  val rules_with :
    'b equal * 'b linorder ->
      ('a -> bool) ->
        (('b * nat), (('a * (('b, 'c) term * ('b, 'c) term)) list)) rbt ->
          (('b, 'c) term * ('b, 'c) term) list
  val s_iteratei :
    (('a -> bool) -> ('b -> unit -> 'a -> 'a) -> 'c -> 'a -> 'a) ->
      ('a -> bool) -> ('b -> 'a -> 'a) -> 'c -> 'a -> 'a
  datatype ('a, 'b, 'c, 'd) tp_ops_ext =
    Tp_ops_ext of
      ('a ->
        (('b, 'c) term -> bool) *
          ((('b, 'c) term * ('b, 'c) term -> bool) *
            (('b, 'c) term * ('b, 'c) term -> bool))) *
        ('a -> ('b, 'c) term list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a -> (('b, 'c) term * ('b, 'c) term) list) * ('a -> bool) *
        ('a -> ('b, 'c) term -> bool) * ('a -> bool) *
        ('a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list) *
        ('a ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list -> 'a) *
        ('a ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list *
              (('b, 'c) term * ('b, 'c) term) list) *
        (('b, 'c) term list ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list -> 'a) *
        'd
  val qa : ('a, 'b, 'c, 'd) tp_ops_ext -> 'a -> ('b, 'c) term list
  val mka :
    ('a, 'b, 'c, 'd) tp_ops_ext ->
      ('b, 'c) term list ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list -> 'a
  val delete_R_Rwa :
    ('a, 'b, 'c, 'd) tp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list -> 'a
  val split_rulesa :
    ('a, 'b, 'c, 'd) tp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list *
                (('b, 'c) term * ('b, 'c) term) list
  val split_tt :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) tp_ops_ext ->
        'a -> (('b, 'c) term * ('b, 'c) term) list -> 'a * 'a
  val poss_list : ('a, 'b) term -> pos list
  val afa : ('a, 'b, 'c) root_redtriple_ext -> 'a -> nat -> nat -> bool
  val aft : ('a, 'b, 'c) root_redtriple_ext -> 'a -> nat -> nat -> bool
  val nsa :
    ('a, 'b, 'c) root_redtriple_ext ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val nst :
    ('a, 'b, 'c) redtriple_ext ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val aarity_term :
    'a equal -> 'a -> ('a -> nat -> 'a list) -> ('a, 'b) term -> nat option
  val uncurry_top :
    'a equal ->
      'a -> nat -> ('a -> nat -> 'a list) -> ('a, 'b) term -> ('a, 'b) term
  val xml1to2elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          ('a -> 'b option -> 'c) -> xml -> ((char list), 'c) sum
  val arith_fun : xml -> ((char list), arithFun) sum
  val int_coeff : xml -> ((char list), int) sum
  val vec_coeff :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), ('a list)) sum
  val mat_coeff :
    'a -> (xml -> ((char list), 'a) sum) ->
            xml -> ((char list), (('a list) list)) sum
  val status_precedence :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((('a * nat) * (nat * order_tag)) list)) sum
  val path_order :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), 'a redtriple_impl) sum
  val fit_length : 'a -> nat -> 'a list -> 'a list
  val polynomial :
    (xml -> ((char list), 'a) sum) -> xml -> ((char list), (nat, 'a) tpoly) sum
  val ab_semigroup_mult_int : int ab_semigroup_mult
  val comm_semiring_int : int comm_semiring
  val comm_semiring_0_int : int comm_semiring_0
  val comm_monoid_mult_int : int comm_monoid_mult
  val comm_semiring_1_int : int comm_semiring_1
  val ab_semigroup_mult_rat : rat ab_semigroup_mult
  val comm_semiring_rat : rat comm_semiring
  val comm_semiring_0_rat : rat comm_semiring_0
  val comm_monoid_mult_rat : rat comm_monoid_mult
  val comm_semiring_1_rat : rat comm_semiring_1
  val arctic_coeff : xml -> ((char list), arctic) sum
  val ge_int : int -> int -> bool
  val ge_rat : rat -> rat -> bool
  val rat_gt : rat -> rat -> rat -> bool
  val int_mono : int -> bool
  val max0_int : int -> int
  val max0_rat : rat -> rat
  val rat_mono : rat -> bool
  val ge_arctic : arctic -> arctic -> bool
  val gt_arctic : arctic -> arctic -> bool
  val arctic_rat_coeff : xml -> ((char list), arctic_rat) sum
  val one_arctic : arctic
  val pos_arctic : arctic -> bool
  val int_name : char list
  val mat_mono : nat -> ('a -> bool) -> ('a list) list -> bool
  val rat_name : char list
  val get_comp_0 :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a
  val get_comp_1 :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a
  val equal_arctica : arctic -> arctic -> bool
  val equal_arctic : arctic equal
  val plus_arctic : arctic -> arctic -> arctic
  val zero_arctic : arctic
  val get_comp_gt :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> bool
  val times_arctic : arctic -> arctic -> arctic
  val rat_domain : xml -> ((char list), rat) sum
  val basic_domain : xml -> ((char list), (nat -> domain)) sum
  val interpretation_type : xml -> ((char list), domain) sum
  val get_comp_def :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a
  val ge_arctic_rat : arctic_rat -> arctic_rat -> bool
  val gt_arctic_rat : rat -> arctic_rat -> arctic_rat -> bool
  val arctic_name : char list
  val get_comp_apos :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> bool
  val get_comp_mono :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      bool
  val get_comp_plus :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> 'a
  val one_arctic_rat : arctic_rat
  val pos_arctic_rat : arctic_rat -> bool
  val get_comp_times :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> 'a
  val equal_arctic_rata : arctic_rat -> arctic_rat -> bool
  val equal_arctic_rat : arctic_rat equal
  val plus_arctic_rat : arctic_rat -> arctic_rat -> arctic_rat
  val zero_arctic_rat : arctic_rat
  val times_arctic_rat : arctic_rat -> arctic_rat -> arctic_rat
  val arctic_rat_name : char list
  val non_strict_order_int : int non_strict_order
  val non_strict_order_rat : rat non_strict_order
  val get_comp_check_mono :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> bool
  val get_comp_description :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      char list
  val non_strict_order_arctic : arctic non_strict_order
  val ordered_ab_semigroup_int : int ordered_ab_semigroup
  val max_ordered_monoid_add_int : int max_ordered_monoid_add
  val ordered_ab_semigroup_rat : rat ordered_ab_semigroup
  val max_ordered_monoid_add_rat : rat max_ordered_monoid_add
  val non_strict_order_arctic_rat : arctic_rat non_strict_order
  val interpretation :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), 'a redtriple_impl) sum
  val redtriple :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), 'a redtriple_impl) sum
  val xml2dp_input :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          ((('a, (char list)) term * ('a, (char list)) term) list *
            (('a, (char list)) strategy *
              (('a, (char list)) term * ('a, (char list)) term) list)))
          sum
  val xml2trs_input :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (('a, (char list)) strategy *
            ((('a, (char list)) term * ('a, (char list)) term) list *
              ((('a, (char list)) term * ('a, (char list)) term) list) option)))
          sum
  val xml2input :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (((('a, (char list)) term * ('a, (char list)) term) list *
             (('a, (char list)) strategy *
               (('a, (char list)) term * ('a, (char list)) term) list)),
            (('a, (char list)) strategy *
              ((('a, (char list)) term * ('a, (char list)) term) list *
                ((('a, (char list)) term *
                   ('a, (char list)) term) list) option)))
            sum)
          sum
  val xml_rules :
    'a show -> 'b show -> 'c show ->
      char list ->
        ((('a, ('b list)) lab, 'c) term *
          (('a, ('b list)) lab, 'c) term) list ->
          xml
  val lexord_code : 'a equal -> ('a -> 'a -> bool) -> 'a list -> 'a list -> bool
  val less_lab :
    'a equal * 'a ord -> 'b equal * 'b ord ->
      ('a, 'b) lab -> ('a, 'b) lab -> bool
  val less_eq_lab :
    'a equal * 'a ord -> 'b equal * 'b ord ->
      ('a, 'b) lab -> ('a, 'b) lab -> bool
  val ord_lab : 'a equal * 'a ord -> 'b equal * 'b ord -> ('a, 'b) lab ord
  type 'a ordered_semiring_0
  val semiring_0_ordered_semiring_0 : 'a ordered_semiring_0 -> 'a semiring_0
  val ordered_ab_semigroup_ordered_semiring_0 :
    'a ordered_semiring_0 -> 'a ordered_ab_semigroup
  type 'a ordered_semiring_1
  val semiring_1_ordered_semiring_1 : 'a ordered_semiring_1 -> 'a semiring_1
  val ordered_semiring_0_ordered_semiring_1 :
    'a ordered_semiring_1 -> 'a ordered_semiring_0
  type 'a max_ordered_semiring_1
  val max_ordered_monoid_add_max_ordered_semiring_1 :
    'a max_ordered_semiring_1 -> 'a max_ordered_monoid_add
  val ordered_semiring_1_max_ordered_semiring_1 :
    'a max_ordered_semiring_1 -> 'a ordered_semiring_1
  type 'a poly_carrier
  val comm_semiring_1_poly_carrier : 'a poly_carrier -> 'a comm_semiring_1
  val max_ordered_semiring_1_poly_carrier :
    'a poly_carrier -> 'a max_ordered_semiring_1
  val default_I : 'a poly_carrier -> 'a -> nat -> ((nat * nat) list * 'a) list
  val poly_power :
    'a equal -> 'b equal * 'b comm_semiring_1 ->
      (('a * nat) list * 'b) list -> nat -> (('a * nat) list * 'b) list
  val monom_subst :
    'b equal -> 'c equal * 'c comm_semiring_1 ->
      ('a -> (('b * nat) list * 'c) list) ->
        ('a * nat) list -> (('b * nat) list * 'c) list
  val poly_subst :
    'b equal -> 'c equal * 'c comm_semiring_1 ->
      ('a -> (('b * nat) list * 'c) list) ->
        (('a * nat) list * 'c) list -> (('b * nat) list * 'c) list
  val eval_term :
    'b equal * 'b poly_carrier -> 'c equal ->
      ('a -> nat -> ((nat * nat) list * 'b) list) ->
        ('a, 'c) term -> (('c * nat) list * 'b) list
  val eval_monom : 'b comm_semiring_1 -> ('a -> 'b) -> ('a * nat) list -> 'b
  val eval_poly :
    'b comm_semiring_1 -> ('a -> 'b) -> (('a * nat) list * 'b) list -> 'b
  val check_supt :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val shows_ctxt :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) -> ('a, 'b) ctxt -> char list -> char list
  val desc : ('a, 'b, 'c) redtriple_ext -> char list -> char list
  val mono : ('a, 'b, 'c) redtriple_ext -> ((char list -> char list), unit) sum
  val nsta :
    ('a, 'b, 'c) root_redtriple_ext ->
      ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val eq_rule_mod_vars :
    'a equal -> 'b equal ->
      ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term -> bool
  val ctxt_of_pos_term : pos -> ('a, 'b) term -> ('a, 'b) ctxt
  val shows_prec_pos : nat -> pos -> char list -> char list
  val check_rstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        pos ->
          ('a, 'b) term * ('a, 'b) term ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_rrstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ('a, 'b) term * ('a, 'b) term ->
          ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_steps :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (pos *
            ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val generate_var : nat -> char list
  val uncurry_term :
    'a equal -> 'a -> ('a -> nat -> 'a list) -> ('a, 'b) term -> ('a, 'b) term
  val parse_name : char list -> ((char list), (char list * char list)) sum
  val parse_text :
    char list -> ((char list), ((char list) option * char list)) sum
  val parse_attribute_value :
    char list -> ((char list), (char list * char list)) sum
  val parse_attributes :
    char list -> ((char list), ((char list * char list) list * char list)) sum
  val parse_nodes : char list -> ((char list), (xml list * char list)) sum
  val parse_node : char list -> ((char list), (xml * char list)) sum
  val scan_upto :
    char list -> char list -> ((char list), (char list * char list)) sum
  val parse_header : char list -> ((char list), (char list * char list)) sum
  val update_tokens :
    ('a list -> 'a list) -> 'a list -> ((char list), ('a list * 'a list)) sum
  val remove_comments_aux : bool -> char list -> char list
  val remove_comments_aux_acc : char list -> bool -> char list -> char list
  val remove_comments : char list -> char list
  val parse_doc : char list -> ((char list), (xmldoc * char list)) sum
  datatype 'a filtered = FPair of 'a * nat
  val plain_name : xml -> ((char list), ((char list), (nat list)) lab) sum
  val xml1or2many_elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            ('a -> 'b option -> 'c list -> 'd) -> xml -> ((char list), 'd) sum
  val sl_variant :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) sl_variant) sum
  val xml2many_elements :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            ('a -> 'b -> 'c list -> 'd) -> xml -> ((char list), 'd) sum
  val transition_lhs :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list), ((('a * nat) * (char list) list), (char list)) sum) sum
  val transition :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (((char list), ('a * nat)) ta_rule, (char list * char list)) sum)
          sum
  val ord_char : char ord
  val all_interval_nat : (nat -> bool) -> nat -> nat -> bool
  val preorder_list : 'a equal * 'a order -> ('a list) preorder
  val order_list : 'a equal * 'a order -> ('a list) order
  val gen_list_to_map_aux : ('a -> 'b -> 'c -> 'c) -> 'c -> ('a * 'b) list -> 'c
  val gen_list_to_map : 'a -> ('b -> 'c -> 'a -> 'a) -> ('b * 'c) list -> 'a
  val delete_value :
    'a equal -> 'b linorder ->
      ('a -> 'b option) -> 'a -> ('b, ('a list)) rbt -> ('b, ('a list)) rbt
  val rm_update_dj : 'a linorder -> 'a -> 'b -> ('a, 'b) rbt -> ('a, 'b) rbt
  val insert_value :
    'a equal -> 'b linorder ->
      ('a -> 'b option) -> 'a -> ('b, ('a list)) rbt -> ('b, ('a list)) rbt
  val shows_monom : 'a show -> ('a * nat) list -> char list -> char list
  val shows_poly :
    'a show -> 'b equal * 'b poly_carrier * 'b show ->
      (('a * nat) list * 'b) list -> char list -> char list
  val poly_split :
    'a equal -> 'b zero ->
      ('a * nat) list ->
        (('a * nat) list * 'b) list -> 'b * (('a * nat) list * 'b) list
  val missing : char list -> (char list -> char list) -> char list -> char list
  val toomuch : char list -> (char list -> char list) -> char list -> char list
  val xml_tag : ('a, 'b, 'c) cert_problem -> char list
  val list_to_rm : 'a linorder -> ('a * 'b) list -> ('a, 'b) rbt
  val rm_isEmpty : 'a equal * 'a linorder -> 'b equal -> ('a, 'b) rbt -> bool
  val gen_list_to_set_aux : ('a -> 'b -> 'b) -> 'b -> 'a list -> 'b
  val gen_list_to_set : 'a -> ('b -> 'a -> 'a) -> 'b list -> 'a
  val list_to_rs : 'a linorder -> 'a list -> ('a, unit) rbt
  val equal_unita : unit -> unit -> bool
  val equal_unit : unit equal
  val rs_isEmpty : 'a equal * 'a linorder -> ('a, unit) rbt -> bool
  val rito_set_to_sorted_list :
    (('a -> 'a list -> 'a list) -> 'b -> 'a list -> 'a list) -> 'b -> 'a list
  val s_reverse_iterateo :
    'a linorder ->
      (('a -> unit -> 'b -> 'b) -> 'c -> 'b -> 'b) ->
        ('a -> 'b -> 'b) -> 'c -> 'b -> 'b
  val rs_reverse_iterateo :
    'a linorder -> ('a -> 'b -> 'b) -> ('a, unit) rbt -> 'b -> 'b
  val rs_to_list : 'a linorder -> ('a, unit) rbt -> 'a list
  val delete_values :
    'a equal -> 'b linorder ->
      ('a -> 'b option) -> 'a list -> ('b, ('a list)) rbt -> ('b, ('a list)) rbt
  val delete_rules :
    'a equal -> 'b equal * 'b linorder -> 'c equal ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b * nat), (('a * (('b, 'c) term * ('b, 'c) term)) list)) rbt ->
                (('b * nat), (('a * (('b, 'c) term * ('b, 'c) term)) list)) rbt
  val insert_values :
    'a equal -> 'b linorder ->
      ('a -> 'b option) -> 'a list -> ('b, ('a list)) rbt -> ('b, ('a list)) rbt
  val insert_rules :
    'a equal -> 'b equal * 'b linorder -> 'c equal ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b * nat), (('a * (('b, 'c) term * ('b, 'c) term)) list)) rbt ->
                (('b * nat), (('a * (('b, 'c) term * ('b, 'c) term)) list)) rbt
  val qc : ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> ('b, 'c) term list
  val mkc :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      (('b, 'c) term * ('b, 'c) term) list ->
        (('b, 'c) term * ('b, 'c) term) list ->
          ('b, 'c) term list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list -> 'a
  val delete_P_Pwa :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list -> 'a
  val delete_R_Rwc :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list -> 'a
  val split_pairsa :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list *
                (('b, 'c) term * ('b, 'c) term) list
  val split_rulesc :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list *
                (('b, 'c) term * ('b, 'c) term) list
  val split_proc :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        'a -> (('b, 'c) term * ('b, 'c) term) list ->
                (('b, 'c) term * ('b, 'c) term) list -> 'a * 'a
  val desca : ('a, 'b, 'c) root_redtriple_ext -> char list -> char list
  val valid : ('a, 'b, 'c) redtriple_ext -> ((char list -> char list), unit) sum
  val check_rsteps :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list ->
          ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_subseteq : 'a equal -> 'a list -> 'a list -> ('a, unit) sum
  val check_wf_trs :
    'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val map_rules_wa :
    ('a -> nat -> 'b) ->
      (('a, 'c) term * ('a, 'c) term) list ->
        (('b, 'c) term * ('b, 'c) term) list
  val generate_f_xs : 'a -> nat -> ('a, (char list)) term
  val bounds_type : xml -> ((char list), boundstype) sum
  val bounds_bound : xml -> ((char list), nat) sum
  val final_states : xml -> ((char list), ((char list) list)) sum
  val transitions :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          (((char list), ('a * nat)) ta_rule list *
            (char list * char list) list))
          sum
  val bounds_tree_automaton :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((char list), ('a * nat)) tree_automaton) sum
  val bounds_info :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) bounds_info) sum
  val label_decomp :
    ('a, 'b) lab -> ('a, 'b) lab * ('b, (('a, 'b) lab list)) sum
  val shows_lab :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) -> ('a, 'b) lab -> char list -> char list
  val shows_prec_lab :
    'a show -> 'b show -> nat -> ('a, 'b) lab -> char list -> char list
  val shows_list_lab :
    'a show -> 'b show -> ('a, 'b) lab list -> char list -> char list
  val show_lab : 'a show -> 'b show -> ('a, 'b) lab show
  val preorder_lab :
    'a equal * 'a order -> 'b equal * 'b order -> ('a, 'b) lab preorder
  val order_lab :
    'a equal * 'a order -> 'b equal * 'b order -> ('a, 'b) lab order
  val simplify_mp_impl :
    'a equal -> 'b equal ->
      ('a -> ('b, 'a) term) ->
        'a list ->
          (('b, 'a) term * ('b, 'a) term) list ->
            (('b, 'a) term * ('b, 'a) term) list ->
              ((('b, 'a) term * ('b, 'a) term) list * nat) option
  val simplify_mp :
    'a equal -> 'b equal ->
      ('a * ('b, 'a) term) list ->
        'a list ->
          (('b, 'a) term * ('b, 'a) term) list ->
            (('b, 'a) term * ('b, 'a) term) list ->
              ((('b, 'a) term * ('b, 'a) term) list * nat) option
  val v_incr_impl : 'a equal -> ('a * ('b, 'a) term) list -> 'a list
  val equal_boola : bool -> bool -> bool
  val equal_bool : bool equal
  val rm_iteratei :
    'b linorder ->
      ('a -> bool) -> ('b -> 'c -> 'a -> 'a) -> ('b, 'c) rbt -> 'a -> 'a
  val rs_iteratei :
    'b linorder ->
      ('a -> bool) -> ('b -> 'a -> 'a) -> ('b, unit) rbt -> 'a -> 'a
  val scnp_af_desc :
    'a show -> (('a * nat) * (nat * nat) list) list -> char list -> char list
  val set_ext : ('a -> 'a -> bool * bool) -> 'a list -> 'a list -> bool * bool
  val check_no_var :
    'a show -> 'b show -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_supteq :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) term -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val valida :
    ('a, 'b, 'c) root_redtriple_ext -> ((char list -> char list), unit) sum
  val vars_rule_lista : ('a, 'b) term * ('a, 'b) term -> 'b list
  val vars_trs_list :
    'b equal -> (('a, 'b) term * ('a, 'b) term) list -> 'b list
  val check_pairwise : ('a -> 'a -> ('b, unit) sum) -> 'a list -> ('b, unit) sum
  val check_disjoint : 'a equal -> 'a list -> 'a list -> ('a, unit) sum
  val check_partition : 'a equal -> ('a list) list -> ('a, unit) sum
  val check_inj :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) lab ->
        nat ->
          ((('a, 'b) lab * nat) * ('a, 'b) lab list) list ->
            ((char list -> char list), unit) sum
  val uncurry_info :
    (xml -> ((char list), 'a) sum) ->
      xml ->
        ((char list),
          ('a * ((('a * nat) * 'a list) list *
                  ((('a, (char list)) term * ('a, (char list)) term) list *
                    (('a, (char list)) term * ('a, (char list)) term) list))))
          sum
  val flat_contexts :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), (('a, (char list)) ctxt list)) sum
  val projected_rseq :
    'a equal ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> nat) ->
          xml ->
            ((char list),
              ((('a, (char list)) term * ('a, (char list)) term) *
                (pos *
                  ((('a, (char list)) term * ('a, (char list)) term) *
                    ('a, (char list)) term)) list))
              sum
  val xml1many2elements_gen :
    char list ->
      (xml -> ((char list), 'a) sum) ->
        ('a -> xml -> ((char list), 'b) sum) ->
          (xml -> ((char list), 'c) sum) ->
            (xml -> ((char list), 'd) sum) ->
              ('a -> 'b list -> 'c -> 'd -> 'e) -> xml -> ((char list), 'e) sum
  val strategy_to_Q :
    ('a, 'b) strategy ->
      (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) term list
  val create_proj : 'a equal -> 'a projL -> 'a -> nat
  val ordering_constraint_proofa :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), 'a redtriple_impl) sum
  val level_mapping :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ((('a * nat) * (nat * nat) list) list)) sum
  val root_redtriple :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), 'a root_redtriple_impl) sum
  val root_ordering_constraint_proof :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), 'a root_redtriple_impl) sum
  val ordering_constraint_proof :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a root_redtriple_impl, 'a redtriple_impl) sum) sum
  val xml2dp_proof :
    'a equal -> 'b equal ->
      (xml -> ((char list), ('a, 'b) lab) sum) ->
        xml -> ((char list), ('a, 'b, (char list)) dp_proof) sum
  val check_graph_decomp :
    ('a -> char list -> char list) ->
      ('a * 'a -> bool) ->
        (bool * 'a list) list -> ((char list -> char list), unit) sum
  val reverse_rules_mapa :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list
  val rules_non_collapsinga : ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> bool
  val reverse_capRM_dpp :
    'b equal -> 'c equal ->
      ('a, 'b, 'c, unit) dpp_ops_ext -> 'a -> ('b, 'c) term -> ('b, 'c) gctxt
  val pairsa :
    ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val check_dep_graph_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        'a -> ('d option * (('b, 'c) term * ('b, 'c) term) list) list ->
                ((char list -> char list), unit) sum
  val intersect_pairsa :
    ('a, 'b, 'c, 'd) dpp_ops_ext ->
      'a -> (('b, 'c) term * ('b, 'c) term) list -> 'a
  val dep_graph_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        'a -> ('d option * (('b, 'c) term * ('b, 'c) term) list) list ->
                ((char list -> char list), (('d * 'a) list)) sum
  val preorder_char : char preorder
  val order_char : char order
  datatype ('a, 'b) l_poly = LPoly of 'b * ('a * 'b) list
  val ident_prob_of_smp :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list
  val sym_collect : (('a, 'b) term -> bool) -> ('a, 'b) term -> 'a list
  val fresh_strings_list :
    char list -> nat -> (char list) list -> nat -> (char list) list
  val substpow_impl : ('a -> ('b, 'a) term) -> nat -> 'a -> ('b, 'a) term
  val funas_term_lista : ('a, 'b) term -> ('a * nat) list
  val funas_rule_list : ('a, 'b) term * ('a, 'b) term -> ('a * nat) list
  val funas_trs_list :
    'a equal -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val vars_rule_list : 'b equal -> ('a, 'b) term * ('a, 'b) term -> 'b list
  val ra :
    ('a, 'b, 'c, 'd) tp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val check_CS_subseteq :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((('a, 'b) term * ('a, 'b) term), unit) sum
  val uncurry_rules :
    'a equal ->
      'a -> ('a -> nat -> 'a list) ->
              (('a, 'b) term * ('a, 'b) term) list ->
                (('a, 'b) term * ('a, 'b) term) list
  val rwa :
    ('a, 'b, 'c, 'd) tp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val eta_closed_rules :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a -> ('a -> nat -> 'a list) ->
              (('a, 'b) term * ('a, 'b) term) list ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val uncurry_eta_split :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val sig_list_to_sig_map :
    'a equal ->
      'a -> (('a * nat) * 'a list) list ->
              ((('a * nat) * 'a list) list -> 'a -> nat -> 'a) ->
                'a -> nat -> 'a list
  val uncurry_of_sig_list :
    'a -> (('a * nat) * 'a list) list ->
            ('a -> nat -> 'a list) ->
              (('a, (char list)) term * ('a, (char list)) term) list
  val uncurry_tt :
    'b equal * 'b show ->
      ('a, 'b, (char list), unit) tp_ops_ext ->
        'b * ((('b * nat) * 'b list) list *
               ((('b, (char list)) term * ('b, (char list)) term) list *
                 (('b, (char list)) term * ('b, (char list)) term) list)) ->
          (('b, (char list)) term * ('b, (char list)) term) list ->
            'a -> ((char list -> char list), 'a) sum
  val apply_af_entry : 'a -> af_entry -> ('a, 'b) term list -> ('a, 'b) term
  val afs_term :
    ('a -> nat -> af_entry) -> ('a, 'b) term -> ('a filtered, 'b) term
  val xml2trs_proof :
    'a equal ->
      (xml -> ((char list), ('a, (nat list)) lab) sum) ->
        xml -> ((char list), ('a, (nat list), (char list)) trs_proof) sum
  val search_len :
    char list -> char list -> nat -> (char list * char list) option
  val list_sumI : 'a -> ('a -> 'a -> 'a) -> 'a list -> 'a
  val mul_pvarsI :
    'a equal -> 'a -> ('a -> 'a -> 'a) -> 'a -> ('b * 'a) list -> ('b * 'a) list
  val mul_lpolyI :
    'a equal ->
      'a -> ('a -> 'a -> 'a) -> 'a -> ('b, 'a) l_poly -> ('b, 'a) l_poly
  val add_varI :
    'a equal -> 'b equal ->
      'a -> ('a -> 'a -> 'a) -> 'b -> 'a -> ('b * 'a) list -> ('b * 'a) list
  val sum_pvarsI :
    'a equal -> 'b equal ->
      'a -> ('a -> 'a -> 'a) ->
              ('b * 'a) list -> ('b * 'a) list -> ('b * 'a) list
  val sum_lpolyI :
    'a equal -> 'b equal ->
      'a -> ('a -> 'a -> 'a) ->
              ('b, 'a) l_poly -> ('b, 'a) l_poly -> ('b, 'a) l_poly
  val pleftI :
    'a equal -> 'c equal ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      ('a -> 'a) ->
                        ('b -> nat -> 'a * 'a list) ->
                          ('b, 'c) term -> ('c, 'a) l_poly
  val linorder_list : 'a equal * 'a linorder -> ('a list) linorder
  val check_poly_ge :
    'a equal -> 'b ordered_semiring_0 ->
      (('a * nat) list * 'b) list -> (('a * nat) list * 'b) list -> bool
  val check_poly_gt :
    'a ordered_semiring_0 -> 'b equal ->
      ('a -> 'a -> bool) ->
        (('b * nat) list * 'a) list -> (('b * nat) list * 'a) list -> bool
  val rpo_strict_unbounded :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a -> nat -> 'a -> nat -> bool * bool) * ('a -> bool) ->
        ('a -> nat -> order_tag) ->
          ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val rpo_nstrict_unbounded :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a -> nat -> 'a -> nat -> bool * bool) * ('a -> bool) ->
        ('a -> nat -> order_tag) ->
          ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val create_RPO_redtriple :
    'a show -> 'b equal * 'b show -> 'c equal * 'c show ->
      ((('a * nat) * (nat * order_tag)) list ->
        ('b -> nat -> nat) * ('b -> nat -> order_tag)) ->
        (('a * nat) * (nat * order_tag)) list -> ('b, 'c, unit) redtriple_ext
  val rev_term : ('a, 'b) ctxt -> ('a, 'b) term -> ('a, 'b) term
  val rev_rule : ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term
  val doc_of_string : char list -> ((char list), xmldoc) sum
  val filtered_fun : 'a filtered -> 'a
  val shows_prec_filtered :
    'a show -> nat -> 'a filtered -> char list -> char list
  val shows_list_filtered :
    'a show -> 'a filtered list -> char list -> char list
  val show_filtered : 'a show -> 'a filtered show
  val afs_check :
    'a show -> 'b show ->
      (char list -> char list) ->
        ('a -> nat -> af_entry) ->
          (('a filtered, 'b) term * ('a filtered, 'b) term ->
            ((char list -> char list), unit) sum) ->
            ('a, 'b) term * ('a, 'b) term ->
              ((char list -> char list), unit) sum
  val shows_afs :
    'a show -> (('a * nat) * af_entry) list -> char list -> char list
  val starts_with : char list -> char list -> bool
  val forallm_index_aux :
    ('a -> nat -> ('b, unit) sum) ->
      nat -> 'a list -> ((('a * nat) * 'b), unit) sum
  val forallm_index :
    ('a -> nat -> ('b, unit) sum) -> 'a list -> ((('a * nat) * 'b), unit) sum
  val equal_gctxt : 'a equal -> ('a, 'b) gctxt equal
  val equal_gctxta : 'a equal -> ('a, 'b) gctxt -> ('a, 'b) gctxt -> bool
  val linorder_lab :
    'a equal * 'a linorder -> 'b equal * 'b linorder -> ('a, 'b) lab linorder
  val prightI :
    'a equal -> 'c equal ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      ('a -> 'a) ->
                        ('b -> nat -> 'a * 'a list) ->
                          ('b, 'c) term -> ('c, 'a) l_poly
  val match_to_idents_impl :
    'c equal -> 'd equal ->
      ('a list ->
        'b list -> ((('c, 'd) term * ('c, 'd) term) list * nat) option) ->
        (('c, 'd) term * ('c, 'd) term -> nat option) -> 'a -> nat option
  val match_prob_of_rp_impl :
    'b equal -> 'c equal ->
      ('a -> ('b, 'c) term) ->
        (('b, 'c) term -> 'a list) ->
          ('b, 'c) term * ('d, 'e) term -> (('b, 'c) term * ('d, 'e) term) list
  val redex_decision :
    'b equal -> 'c equal -> 'g equal -> 'h equal ->
      ('a -> ('b, 'c) term) ->
        ((('b, 'c) term * ('d, 'e) term) list ->
          'f list -> ((('g, 'h) term * ('g, 'h) term) list * nat) option) ->
          (('g, 'h) term * ('g, 'h) term -> nat option) ->
            (('b, 'c) term -> 'a list) -> ('b, 'c) term * ('d, 'e) term -> bool
  val poly_vars_list : 'a equal -> (('a * nat) list * 'b) list -> 'a list
  val indent : (char list -> char list) -> char list -> char list
  val label_s_ns_impl :
    'a show -> 'b show ->
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) ->
        (('a, 'b) term * ('a, 'b) term ->
          ((char list -> char list), unit) sum) ->
          ('a, 'b) term * nat -> ('a, 'b) term * nat -> bool * bool
  val funas_term_list : 'a equal -> ('a, 'b) term -> ('a * nat) list
  val mk_subst_domain :
    'a equal -> 'b equal ->
      ('a * ('b, 'a) term) list -> ('a * ('b, 'a) term) list
  val shows_prec_ctxt :
    'a show -> 'b show -> nat -> ('a, 'b) ctxt -> char list -> char list
  val only_eta_rules :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((char list -> char list), unit) sum
  val pa :
    ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val rc :
    ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val pwa :
    ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val rwc :
    ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val uncurry_proc :
    'b equal * 'b show ->
      ('a, 'b, (char list), unit) dpp_ops_ext ->
        'b * ((('b * nat) * 'b list) list *
               ((('b, (char list)) term * ('b, (char list)) term) list *
                 (('b, (char list)) term * ('b, (char list)) term) list)) ->
          ((('b * nat) * 'b list) list -> 'b -> nat -> 'b) ->
            ('b ->
              nat ->
                (('b * nat) * 'b list) list ->
                  ((char list -> char list), unit) sum) ->
              (('b, (char list)) term * ('b, (char list)) term) list ->
                (('b, (char list)) term * ('b, (char list)) term) list ->
                  'a -> ((char list -> char list), 'a) sum
  val xml2dp_disproof :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) dp_disproof) sum
  val eqWhiteSpace : char list -> char list -> bool
  val linorder_char : char linorder
  datatype ('a, 'b) ta_rule_impl =
    TA_rule_impl of 'b * 'a list * 'a * ('a, unit) rbt
  datatype ('a, 'b, 'c) ta_impl_ext =
    Ta_impl_ext of
      ('a, unit) rbt * (('b * nat), (('a, 'b) ta_rule_impl list)) rbt *
        'a list * ('a, unit) rbt * ('a * 'a) list * ('a -> ('a, unit) rbt) *
        ('a -> ('a, unit) rbt) * 'c
  val ta_rqs_set : ('a, 'b, 'c) ta_impl_ext -> ('a, unit) rbt
  val rsym_impl : ('a, 'b) ta_rule_impl -> 'b * nat
  val conv_ta_rule :
    ('a -> ('a, unit) rbt) -> ('a, 'b) ta_rule -> ('a, 'b) ta_rule_impl
  val elem_list_to_rm :
    'b linorder -> ('a -> 'b) -> 'a list -> ('b, ('a list)) rbt
  val rm_set_lookup : 'a linorder -> ('a, ('b list)) rbt -> 'a -> 'b list
  val rtrancl_rbt_impl :
    'a linorder -> ('a * 'a) list -> 'a list -> ('a, unit) rbt
  val memo_rbt_rtrancl : 'a linorder -> ('a * 'a) list -> 'a -> ('a, unit) rbt
  val generate_ta :
    'a linorder -> 'b equal * 'b linorder ->
      ('a, 'b) tree_automaton -> ('a, 'b, unit) ta_impl_ext
  val check_left_linear_trs :
    'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val boundstype_fun :
    'b equal ->
      boundstype -> ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term -> bool
  val ta_rules_impl :
    ('a, 'b, 'c) ta_impl_ext -> (('b * nat), (('a, 'b) ta_rule_impl list)) rbt
  val bounds_condition :
    'a show -> 'b equal * 'b show ->
      boundstype ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((char list -> char list), unit) sum
  val rqs_impl : ('a, 'b) ta_rule_impl -> 'a list
  val rqss_impl : ('a, 'b) ta_rule_impl -> ('a, unit) rbt
  val ta_epss_impl : ('a, 'b, 'c) ta_impl_ext -> 'a -> ('a, unit) rbt
  val ta_final_impl : ('a, 'b, 'c) ta_impl_ext -> ('a, unit) rbt
  val ta_contains_impl :
    'a equal * 'a linorder -> 'b equal * 'b linorder ->
      ('a * nat) list ->
        ('b, 'a, unit) ta_impl_ext ->
          'b list -> (('b, ('a, 'b) term) sum, unit) sum
  val flatten_term_enum_filter :
    (('a, 'b) term -> bool) -> (('a list), 'b) term -> ('a, 'b) term list
  val inverse_base_term_filter :
    ((('a * nat), 'b) term -> bool) ->
      ('a, 'b) term -> nat -> (('a * nat), 'b) term list
  val cover_bound_list_filter :
    ((('a * nat), 'b) term -> bool) ->
      (('a, 'b) term * ('a, 'b) term -> ('a, 'b) term -> bool) ->
        nat ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ((('a * nat), 'b) term * (('a * nat), 'b) term) list
  val ta_res_impl :
    'a equal * 'a linorder -> 'b linorder ->
      (('a * nat), (('b, 'a) ta_rule_impl list)) rbt ->
        ('b -> ('b, unit) rbt) -> ('a, 'b) term -> ('b, unit) rbt
  val ta_rqs_impl : ('a, 'b, 'c) ta_impl_ext -> 'a list
  val rs_subset : 'a linorder -> ('a, unit) rbt -> ('a, unit) rbt -> 'a option
  val ta_epsrs_impl : ('a, 'b, 'c) ta_impl_ext -> 'a -> ('a, unit) rbt
  val ta_match_impl :
    'a equal * 'a linorder -> 'b equal * 'b linorder ->
      'c equal * 'c linorder ->
      (('a * nat), (('b, 'a) ta_rule_impl list)) rbt ->
        ('b -> ('b, unit) rbt) ->
          ('a, 'c) term -> 'b -> ((('c * 'b) list), unit) rbt
  val ta_rule_compatible_eff_list :
    'a equal * 'a linorder -> 'b equal * 'b linorder ->
      'c equal * 'c linorder ->
      ('a, 'b, unit) ta_impl_ext ->
        ('b, 'c) term * ('b, 'c) term ->
          (((('b, 'a) term * ('b, 'a) term) * 'a), unit) sum
  val ta_trs_compatible_eff_list :
    'a equal * 'a linorder -> 'b equal * 'b linorder ->
      'c equal * 'c linorder ->
      ('a, 'b, unit) ta_impl_ext ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (((('b, 'c) term * ('b, 'c) term) *
             ((('b, 'a) term * ('b, 'a) term) * 'a)),
            unit)
            sum
  val ta_res_impl_all :
    'a linorder -> 'b equal * 'b linorder ->
      ('a, unit) rbt ->
        (('b * nat), (('a, 'b) ta_rule_impl list)) rbt ->
          ('b, 'c) term -> ('a, unit) rbt
  val ta_rule_compatible_heuristic :
    'a equal * 'a linorder -> 'b equal * 'b linorder -> 'c linorder ->
      ('a, 'b, unit) ta_impl_ext -> ('b, 'c) term -> bool
  val check_bounds :
    'a equal * 'a linorder * 'a show -> 'b equal * 'b linorder * 'b show ->
      ('a, 'b) bounds_info ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((char list -> char list), unit) sum
  val rulesb :
    ('a, 'b, 'c, 'd) tp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val bounds_tt :
    'b equal * 'b linorder * 'b show -> 'c equal * 'c linorder * 'c show ->
      ('a, 'b, 'c, unit) tp_ops_ext ->
        ('b, 'c) bounds_info -> 'a -> ((char list -> char list), unit) sum
  val s_label_mul_impl :
    'a show -> 'b show ->
      ((('a, 'b) term * nat -> ('a, 'b) term * nat -> bool * bool) ->
        (('a, 'b) term * nat) list ->
          (('a, 'b) term * nat) list -> bool * bool) ->
        ('a * nat -> (nat * nat) list) ->
          (('a, 'b) term * ('a, 'b) term ->
            ((char list -> char list), unit) sum) ->
            (('a, 'b) term * ('a, 'b) term ->
              ((char list -> char list), unit) sum) ->
              ('a, 'b) term * ('a, 'b) term ->
                ((char list -> char list), unit) sum
  val nST_label_mul_impl :
    'a show -> 'b show ->
      ((('a, 'b) term * nat -> ('a, 'b) term * nat -> bool * bool) ->
        (('a, 'b) term * nat) list ->
          (('a, 'b) term * nat) list -> bool * bool) ->
        ('a * nat -> (nat * nat) list) ->
          (('a, 'b) term * ('a, 'b) term ->
            ((char list -> char list), unit) sum) ->
            (('a, 'b) term * ('a, 'b) term ->
              ((char list -> char list), unit) sum) ->
              ('a, 'b) term * ('a, 'b) term ->
                ((char list -> char list), unit) sum
  val generate_scnp_rp :
    'a equal * 'a show -> 'b show ->
      ((('a, 'b) term * nat -> ('a, 'b) term * nat -> bool * bool) ->
        (('a, 'b) term * nat) list ->
          (('a, 'b) term * nat) list -> bool * bool) ->
        (('a * nat) * (nat * nat) list) list ->
          ('c -> ('a, 'b, unit) redtriple_ext) ->
            'c -> ('a, 'b, unit) root_redtriple_ext
  val eval_lab :
    ('a -> 'b list -> 'b) ->
      ('a -> 'b list -> 'c) ->
        ('a -> nat -> 'c -> 'd) ->
          ('e -> 'b) -> ('a, 'e) term -> 'b * ('d, 'e) term
  val lab_root :
    ('a -> 'b list -> 'b) ->
      ('a -> 'b list -> 'c) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'd) ->
            ('e -> 'b) -> ('a, 'e) term -> ('d, 'e) term
  datatype ('a, 'b) scg = Null |
    Scg of 'a * 'a * ('b * 'b) list * ('b * 'b) list
  val unary_term : ('a, 'b) term -> bool
  datatype ('a, 'b) tp =
    Tp of (('a, 'b) term list *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                    rbt))))
  val q_impl :
    ('a, 'b) term list *
      (bool *
        ((('a, 'b) term * ('a, 'b) term) list *
          ((('a, 'b) term * ('a, 'b) term) list *
            (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
              rbt))) ->
      ('a, 'b) term list
  val impl_ofa :
    'a linorder ->
      ('a, 'b) tp ->
        ('a, 'b) term list *
          (bool *
            ((('a, 'b) term * ('a, 'b) term) list *
              ((('a, 'b) term * ('a, 'b) term) list *
                (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                  rbt)))
  val q : 'a linorder -> ('a, 'b) tp -> ('a, 'b) term list
  val r_impl :
    'a equal * 'a linorder ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        (('a, 'b) term * ('a, 'b) term) list
  val r :
    'a equal * 'a linorder ->
      ('a, 'b) tp -> (('a, 'b) term * ('a, 'b) term) list
  val xml2reltrs_proof :
    'a equal ->
      (xml -> ((char list), ('a, (nat list)) lab) sum) ->
        xml -> ((char list), ('a, (nat list), (char list)) trs_proof) sum
  val xml2trs_disproof :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) trs_disproof) sum
  val xml2reltrs_disproof :
    (xml -> ((char list), 'a) sum) ->
      xml -> ((char list), ('a, (char list)) reltrs_disproof) sum
  val xml2cert_problem :
    'a equal ->
      (xml -> ((char list), 'a) sum) ->
        (xml -> ((char list), ('a, (nat list)) lab) sum) ->
          xml -> ((char list), ('a, (nat list), (char list)) cert_problem) sum
  val xml_cert_problem :
    'a show -> 'b show -> 'c show -> ('a, ('b list), 'c) cert_problem -> xml
  val xmldoc2cert_problem :
    xmldoc ->
      ((char list), ((char list), (nat list), (char list)) cert_problem) sum
  val parse_cert_problem :
    char list ->
      ((char list), ((char list), (nat list), (char list)) cert_problem) sum
  datatype ('a, 'b) dpp =
    Dpp of
      ((('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))))
  val extract_input_proof :
    char list -> (char list * (char list * char list)) option
  val shows_terms :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) ->
        char list -> ('a, 'b) term list -> char list -> char list
  val shows_dpp :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) ->
        ('c, 'a, 'b, unit) dpp_ops_ext -> 'c -> char list -> char list
  val uncurry_top_rules :
    'a equal ->
      'a -> nat ->
              ('a -> nat -> 'a list) ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  (('a, 'b) term * ('a, 'b) term) list
  val eta_closed_top_rules :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a -> nat ->
              ('a -> nat -> 'a list) ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  (('a, 'b) term * ('a, 'b) term) list ->
                    ((char list -> char list), unit) sum
  val uncurry_of_top_sig_list :
    'a -> nat ->
            (('a * nat) * 'a list) list ->
              ('a -> nat -> 'a list) ->
                (('a, (char list)) term * ('a, (char list)) term) list
  val uncurry_top_proc :
    'b equal * 'b show ->
      ('a, 'b, (char list), unit) dpp_ops_ext ->
        'b * ((('b * nat) * 'b list) list *
               ((('b, (char list)) term * ('b, (char list)) term) list *
                 (('b, (char list)) term * ('b, (char list)) term) list)) ->
          nat ->
            ((('b * nat) * 'b list) list -> 'b -> nat -> 'b) ->
              ('b ->
                nat ->
                  (('b * nat) * 'b list) list ->
                    ((char list -> char list), unit) sum) ->
                (('b, (char list)) term * ('b, (char list)) term) list ->
                  (('b, (char list)) term * ('b, (char list)) term) list ->
                    'a -> ((char list -> char list), 'a) sum
  val uncurry_proc_both :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, ('b, 'c) lab, (char list), unit) dpp_ops_ext ->
        nat option ->
          ('b, 'c) lab *
            (((('b, 'c) lab * nat) * ('b, 'c) lab list) list *
              (((('b, 'c) lab, (char list)) term *
                 (('b, 'c) lab, (char list)) term) list *
                ((('b, 'c) lab, (char list)) term *
                  (('b, 'c) lab, (char list)) term) list)) ->
            ((('b, 'c) lab, (char list)) term *
              (('b, 'c) lab, (char list)) term) list ->
              ((('b, 'c) lab, (char list)) term *
                (('b, 'c) lab, (char list)) term) list ->
                'a -> ((char list -> char list), 'a) sum
  val check_dpp_subsumes :
    'b equal * 'b show -> 'c equal * 'c show -> 'd equal * 'd show ->
      ('a, ('b, 'c) lab, 'd, unit) dpp_ops_ext ->
        ((('b, 'c) lab, 'd) term * (('b, 'c) lab, 'd) term) list *
          (((('b, 'c) lab, 'd) term * (('b, 'c) lab, 'd) term) list *
            ((('b, 'c) lab, 'd) term list *
              (((('b, 'c) lab, 'd) term * (('b, 'c) lab, 'd) term) list *
                ((('b, 'c) lab, 'd) term * (('b, 'c) lab, 'd) term) list))) ->
          'a -> ((char list -> char list), unit) sum
  val rulesd :
    ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> (('b, 'c) term * ('b, 'c) term) list
  val funas_args_term_list : ('a, 'b) term -> ('a * nat) list
  val funas_args_rule_list : ('a, 'b) term * ('a, 'b) term -> ('a * nat) list
  val funas_args_trs_list :
    'a equal -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val check_flat_ctxt :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a list -> ('b, 'a) ctxt -> ((char list -> char list), unit) sum
  val is_flat_ctxt_list :
    'a equal -> 'b equal -> 'a list -> ('b * nat) list -> ('b, 'a) ctxt -> bool
  val check_is_flat_ctxt :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a list ->
        ('b * nat) list -> ('b, 'a) ctxt -> ((char list -> char list), unit) sum
  val check_rule_preserving :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) ctxt list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_rule_reflecting :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) ctxt list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val hole_at : 'a equal -> nat -> nat -> 'a -> ('a, 'b) ctxt -> bool
  val check_flat_ctxt_complete :
    'a equal * 'a show -> 'b show ->
      ('a, 'b) ctxt list -> 'a * nat -> ((char list -> char list), unit) sum
  val block_term : 'a -> ('a, 'b) term -> ('a, 'b) term
  val block_rule :
    'a -> ('a, 'b) term * ('a, 'b) term -> ('a, 'b) term * ('a, 'b) term
  val check_superset_of_blocked :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a -> (('a, 'b) term * ('a, 'b) term) list ->
              (('a, 'b) term * ('a, 'b) term) list ->
                ((char list -> char list), unit) sum
  val check_no_defined_root_defs :
    'a equal * 'a show -> 'b show ->
      ('a * nat) list -> ('a, 'b) term -> ((char list -> char list), unit) sum
  val fcc_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        'b -> ('b, 'c) ctxt list ->
                (('b, 'c) term * ('b, 'c) term) list ->
                  (('b, 'c) term * ('b, 'c) term) list ->
                    (('b, 'c) term * ('b, 'c) term) list ->
                      'a -> ((char list -> char list), 'a) sum
  val redtriple_proc :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            'a -> ((char list -> char list), 'a) sum
  val mono_redpair_proc :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              'a -> ((char list -> char list), 'a) sum
  val create_rseq_map :
    'a equal -> 'b equal ->
      ((('a, 'b) term * ('a, 'b) term) *
        (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) list ->
        ('a, 'b) term * ('a, 'b) term ->
          ((pos *
             ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) option
  val matchCapRMBelow :
    'a equal -> 'b equal ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        ('a, 'b) term -> ('a, 'b) term -> bool
  val check_ur_closed_term_rm_af :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a -> nat -> nat -> bool) ->
            ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_ur_P_closed_rm_af :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ('a -> nat -> nat -> bool) -> ((char list -> char list), unit) sum
  val mono_ur_redpair_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list ->
                'a -> ((char list -> char list), 'a) sum
  val ur_af_redtriple_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              'a -> ((char list -> char list), 'a) sum
  val check_no_defined_root :
    'a show -> 'b show ->
      ('a * nat -> bool) ->
        ('a, 'b) term -> ((char list -> char list), unit) sum
  val root_redtriple_proc :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) root_redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            'a -> ((char list -> char list), 'a) sum
  datatype ('a, 'b, 'c, 'd) slm_ops_ext =
    Slm_ops_ext of
      ('a -> 'b list -> 'c) * ('a -> 'b list -> 'b) * 'b list * 'b *
        ('a -> 'b list -> 'c) * 'd
  val rl_slm :
    'a equal -> 'b equal ->
      (('a, 'b) lab * nat) option ->
        (('a, 'b) lab * nat) list ->
          (('a, 'b) lab * nat) list ->
            ((char list -> char list),
              (('a, 'b) lab, ('a, 'b) lab, ('b, (('a, 'b) lab list)) sum, unit)
                slm_ops_ext)
              sum
  datatype ('a, 'b, 'c, 'd, 'e) sl_ops_ext =
    Sl_ops_ext of
      ('a -> 'b list -> 'c) * ('a -> nat -> 'c -> bool) *
        ('a -> 'b list -> 'b) * 'b list * 'b *
        ((('a, 'd) term * ('a, 'd) term) list ->
          ((char list -> char list), unit) sum) *
        ('a -> 'b list -> 'c) * ('a -> nat -> 'c -> bool) * ('c -> 'c list) *
        ('a -> nat -> 'c list) * 'e
  val qmodel_cge : nat -> nat -> bool
  val pointwise_ext :
    ('a -> 'a -> bool * bool) -> 'a list -> 'a list -> bool * bool
  val qmodel_lge :
    'a -> 'b -> ((nat list), 'c) sum -> ((nat list), 'd) sum -> bool
  val qmodel_L :
    'a equal -> 'b equal ->
      (('a, 'b) lab * nat) list ->
        ('a, 'b) lab -> 'c list -> (('c list), 'd) sum
  val enum_vectors_nat : 'a list -> nat -> ('a list) list
  val qmodel_LS_gen :
    'a equal ->
      ('a * nat) list -> 'b list -> 'a -> nat -> (('b list), 'c) sum list
  val qmodel_LS :
    'a equal -> 'b equal -> 'c equal ->
      ('a * nat) list -> 'b list -> 'a -> nat -> (('b list), 'c) sum -> bool
  val qmodel_LSa :
    ('a, (nat list)) lab ->
      nat -> ((nat list), (('a, (nat list)) lab list)) sum -> bool
  val pointwise_lgen : nat list -> (nat list) list
  val qmodel_lgen : ((nat list), 'a) sum -> ((nat list), 'a) sum list
  val check_decr_present_aux_1 :
    'a equal -> 'b equal ->
      (('a, ('b * nat)) term * ('a, ('b * nat)) term) list ->
        'b -> 'a -> 'a -> nat ->
                            ((('a, ('b * nat)) term * ('a, ('b * nat)) term),
                              unit)
                              sum
  val check_decr_present_aux_2 :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        'b -> ('a * ('a * nat)) list ->
                ((('a, ('b * nat)) term * ('a, ('b * nat)) term), unit) sum
  val check_decr_present :
    'a equal -> 'b equal ->
      ('a * nat) list ->
        ('a -> nat list -> 'a) ->
          'b -> nat ->
                  (('a, 'b) term * ('a, 'b) term) list ->
                    ((('a, ('b * nat)) term * ('a, ('b * nat)) term), unit) sum
  val qmodel_check_decr :
    'a equal * 'a show -> 'b equal ->
      (('a, (nat list)) lab * nat) list ->
        'b -> nat ->
                ((('a, (nat list)) lab, 'b) term *
                  (('a, (nat list)) lab, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val take_default : 'a -> 'a list -> nat -> 'a
  val eval_arithFun_unbound : nat list -> arithFun -> nat
  val eval_arithFun : nat -> arithFun -> nat list -> nat
  val sl_inter_to_inter : 'a equal -> 'a sl_inter -> 'a -> nat list -> nat
  val get_largest_element : 'a sl_inter -> nat
  val qsli_to_sl_unsafe :
    'a equal -> 'b equal * 'b show ->
      'a -> (('b, (nat list)) lab * nat) list ->
              (('b, (nat list)) lab * nat) list ->
                ('b, (nat list)) lab sl_inter ->
                  (('b, (nat list)) lab, nat,
                    ((nat list), (('b, (nat list)) lab list)) sum, 'a, unit)
                    sl_ops_ext
  val qmodel_check_interpretation :
    arithFun -> nat -> nat -> ((char list -> char list), unit) sum
  val qmodel_check_valid :
    'a show -> 'a sl_inter -> ((char list -> char list), unit) sum
  val qsli_to_sl :
    'a equal -> 'b equal * 'b show ->
      'a -> (('b, (nat list)) lab * nat) list ->
              (('b, (nat list)) lab * nat) list ->
                ('b, (nat list)) lab sl_inter ->
                  ((char list -> char list),
                    (('b, (nat list)) lab, nat,
                      ((nat list), (('b, (nat list)) lab list)) sum, 'a, unit)
                      sl_ops_ext)
                    sum
  val sli_to_slm :
    'a equal ->
      ('a, (nat list)) lab sl_inter ->
        (('a, (nat list)) lab, nat,
          ((nat list), (('a, (nat list)) lab list)) sum, unit)
          slm_ops_ext
  val sl_C : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'b list
  val sl_I : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'a -> 'b list -> 'b
  val sl_L : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'a -> 'b list -> 'c
  val lab_lhs_list :
    'e equal ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'd) ->
            'b list -> ('a, 'e) term -> ('d, 'e) term list
  val lab_lhss_list :
    'e equal ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'd) ->
            'b list -> ('a, 'e) term list -> ('d, 'e) term list
  val check_sl_Q :
    'a equal * 'a show -> 'd equal * 'd show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'a) ->
            'b list ->
              ('a, 'd) term list ->
                ('a, 'd) term list -> ((char list -> char list), unit) sum
  val lab_rule_ass :
    ('a -> 'b list -> 'b) ->
      ('a -> 'b list -> 'c) ->
        ('a -> nat -> 'c -> 'd) ->
          ('e -> 'b) ->
            ('a, 'e) term * ('a, 'e) term -> ('d, 'e) term * ('d, 'e) term
  val lab_rule_list :
    'e equal ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'd) ->
            'b list ->
              ('a, 'e) term * ('a, 'e) term ->
                (('d, 'e) term * ('d, 'e) term) list
  val lab_trs_list :
    'e equal ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'd) ->
            'b list ->
              (('a, 'e) term * ('a, 'e) term) list ->
                (('d, 'e) term * ('d, 'e) term) list
  val check_sl_lab :
    'a equal * 'a show -> 'd equal * 'd show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'a) ->
            'b list ->
              (('a, 'd) term * ('a, 'd) term) list ->
                (('a, 'd) term * ('a, 'd) term) list ->
                  ((char list -> char list), unit) sum
  val check_sl_Qa :
    'a equal * 'a show -> 'c equal * 'c show ->
      ('a -> 'a * 'b) ->
        ('a, 'c) term list ->
          ('a, 'c) term list -> ((char list -> char list), unit) sum
  val model_splitter :
    'a equal -> 'c equal ->
      ('a -> 'a * 'b) ->
        (('a, 'c) term * ('a, 'c) term) list ->
          (('a, 'c) term * ('a, 'c) term) list ->
            (('a, 'c) term * ('a, 'c) term) list *
              ((('a, 'c) term * ('a, 'c) term) list *
                (('a, 'c) term * ('a, 'c) term) list)
  val sem_lab_proc :
    'a equal * 'a show -> 'd equal * 'd show ->
      ('a -> 'a * 'b) ->
        ('c, 'a, 'd, unit) dpp_ops_ext ->
          ((char list -> char list), unit) sum ->
            (('a, 'd) term list ->
              ('a, 'd) term list -> ((char list -> char list), unit) sum) ->
              ((('a, 'd) term * ('a, 'd) term) list ->
                (('a, 'd) term * ('a, 'd) term) list ->
                  ((char list -> char list), unit) sum) ->
                ((('a, 'd) term * ('a, 'd) term) list ->
                  (('a, 'd) term * ('a, 'd) term) list ->
                    ((char list -> char list), unit) sum) ->
                  ((('a, 'd) term * ('a, 'd) term) list ->
                    (('a, 'd) term * ('a, 'd) term) list ->
                      ((char list -> char list), unit) sum) ->
                    (('a, 'd) term * ('a, 'd) term) list ->
                      ('a, 'd) term list ->
                        (('a, 'd) term * ('a, 'd) term) list ->
                          'c -> ((char list -> char list), 'c) sum
  val check_sl_rule_ass :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      bool ->
        ('a -> 'b list -> 'b) ->
          ('a -> 'b list -> 'c) ->
            ('a -> nat -> 'c -> 'd) ->
              ('b -> 'b -> bool) ->
                (('d, 'e) term * ('d, 'e) term) list ->
                  ('e -> 'b) ->
                    ('a, 'e) term * ('a, 'e) term ->
                      ((char list -> char list), unit) sum
  val check_sl_rule :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> nat -> 'c -> 'd) ->
            'b list ->
              ('b -> 'b -> bool) ->
                bool ->
                  (('d, 'e) term * ('d, 'e) term) list ->
                    ('a, 'e) term * ('a, 'e) term ->
                      ((char list -> char list), unit) sum
  val check_sl_lab_trs :
    'a equal * 'a show -> 'b show -> 'd equal * 'd show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          'b list ->
            ('b -> 'b -> bool) ->
              ('a -> nat -> 'c -> 'a) ->
                (('a, 'd) term * ('a, 'd) term) list ->
                  (('a, 'd) term * ('a, 'd) term) list ->
                    ((char list -> char list), unit) sum
  val check_sl_model_lab_trs :
    'a equal * 'a show -> 'b show -> 'd equal * 'd show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          'b list ->
            ('b -> 'b -> bool) ->
              ('a -> nat -> 'c -> 'a) ->
                (('a, 'd) term * ('a, 'd) term) list ->
                  (('a, 'd) term * ('a, 'd) term) list ->
                    ((char list -> char list), unit) sum
  val sem_lab_fin_proc :
    'a equal * 'a show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> nat -> 'b -> 'a) ->
        ('a -> 'a * 'b) ->
          ('c, 'a, 'd, unit) dpp_ops_ext ->
            (('a * nat) list ->
              ('a * nat) list ->
                ((char list -> char list), ('a, 'e, 'b, 'd, unit) sl_ops_ext)
                  sum) ->
              (('a, 'd) term * ('a, 'd) term) list ->
                ('a, 'd) term list ->
                  (('a, 'd) term * ('a, 'd) term) list ->
                    'c -> ((char list -> char list), 'c) sum
  val slm_C : ('a, 'b, 'c, 'd) slm_ops_ext -> 'b list
  val slm_I : ('a, 'b, 'c, 'd) slm_ops_ext -> 'a -> 'b list -> 'b
  val slm_L : ('a, 'b, 'c, 'd) slm_ops_ext -> 'a -> 'b list -> 'c
  val slm_c : ('a, 'b, 'c, 'd) slm_ops_ext -> 'b
  val slm_La : ('a, 'b, 'c, 'd) slm_ops_ext -> 'a -> 'b list -> 'c
  val slm_to_sl :
    ('a, 'b, 'c, unit) slm_ops_ext -> ('a, 'b, 'c, 'd, unit) sl_ops_ext
  val slm_gen_to_sl_gen :
    (('a * nat) list ->
      ('a * nat) list ->
        ((char list -> char list), ('a, 'b, 'c, unit) slm_ops_ext) sum) ->
      ('a * nat) list ->
        ('a * nat) list ->
          ((char list -> char list), ('a, 'b, 'c, 'd, unit) sl_ops_ext) sum
  val sl_La : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'a -> 'b list -> 'c
  val funas_root_term_list : ('a, 'b) term -> ('a * nat) list
  val funas_root_rule_list :
    'a equal -> ('a, 'b) term * ('a, 'b) term -> ('a * nat) list
  val funas_root_rules_list :
    'a equal -> (('a, 'b) term * ('a, 'b) term) list -> ('a * nat) list
  val sem_lab_root_proc :
    'a equal * 'a show -> 'd equal * 'd show ->
      ('a -> 'a * 'b) ->
        ('c, 'a, 'd, unit) dpp_ops_ext ->
          ((char list -> char list), unit) sum ->
            (('a, 'd) term list ->
              ('a, 'd) term list -> ((char list -> char list), unit) sum) ->
              ((('a, 'd) term * ('a, 'd) term) list ->
                (('a, 'd) term * ('a, 'd) term) list ->
                  ((char list -> char list), unit) sum) ->
                ((('a, 'd) term * ('a, 'd) term) list ->
                  (('a, 'd) term * ('a, 'd) term) list ->
                    ((char list -> char list), unit) sum) ->
                  ((('a, 'd) term * ('a, 'd) term) list ->
                    (('a, 'd) term * ('a, 'd) term) list ->
                      ((char list -> char list), unit) sum) ->
                    (('a, 'd) term * ('a, 'd) term) list ->
                      ('a, 'd) term list ->
                        (('a, 'd) term * ('a, 'd) term) list ->
                          'c -> ((char list -> char list), 'c) sum
  val check_sl_rule_root :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> 'b list -> 'c) ->
            ('a -> nat -> 'c -> 'd) ->
              'b list ->
                (('d, 'e) term * ('d, 'e) term) list ->
                  ('a, 'e) term * ('a, 'e) term ->
                    ((char list -> char list), unit) sum
  val check_sl_lab_root_trs :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> 'b list -> 'c) ->
            'b list ->
              ('a -> nat -> 'c -> 'd) ->
                (('d, 'e) term * ('d, 'e) term) list ->
                  (('a, 'e) term * ('a, 'e) term) list ->
                    ((char list -> char list), unit) sum
  val sem_lab_fin_root_proc :
    'a equal * 'a show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> nat -> 'b -> 'a) ->
        ('a -> 'a * 'b) ->
          ('c, 'a, 'd, unit) dpp_ops_ext ->
            (('a * nat) list ->
              ('a * nat) list ->
                ((char list -> char list), ('a, 'e, 'b, 'd, unit) sl_ops_ext)
                  sum) ->
              (('a, 'd) term * ('a, 'd) term) list ->
                ('a, 'd) term list ->
                  (('a, 'd) term * ('a, 'd) term) list ->
                    'c -> ((char list -> char list), 'c) sum
  val sl_LS : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'a -> nat -> 'c -> bool
  val sl_lgen : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'c -> 'c list
  val sl_LS_gen : ('a, 'b, 'c, 'd, 'e) sl_ops_ext -> 'a -> nat -> 'c list
  val lge_to_lgr :
    'b equal ->
      ('a -> nat -> 'b -> 'b -> bool) ->
        ('a -> nat -> 'b -> bool) -> 'a -> nat -> 'b -> 'b -> bool
  val check_sl_decr_rule :
    'a equal -> 'b equal -> 'c equal -> 'd equal ->
      ('a -> nat -> 'b -> 'c) ->
        ('c -> 'a * 'b) ->
          ('a -> nat -> 'b -> bool) ->
            ('a -> nat -> 'b -> 'b -> bool) ->
              ('c, 'd) term * ('c, 'd) term -> bool
  val check_sl_decr :
    'a equal -> 'b equal -> 'c equal * 'c show -> 'd equal * 'd show ->
      ('a -> nat -> 'b -> 'c) ->
        ('c -> 'a * 'b) ->
          ('a -> nat -> 'b -> bool) ->
            ('a -> nat -> 'b -> 'b -> bool) ->
              (('c, 'd) term * ('c, 'd) term) list ->
                ((char list -> char list), unit) sum
  val sl_check_decr :
    ('a, 'b, 'c, 'd, 'e) sl_ops_ext ->
      (('a, 'd) term * ('a, 'd) term) list ->
        ((char list -> char list), unit) sum
  val check_wf_sym_F_all :
    'c equal * 'c show ->
      ('a -> nat -> 'b -> 'c) ->
        ('c -> 'a * 'b) ->
          ('a -> nat -> 'b -> bool) ->
            'c * nat -> ((char list -> char list), unit) sum
  val check_wf_terms_F_all :
    'c equal * 'c show ->
      ('a -> nat -> 'b -> 'c) ->
        ('c -> 'a * 'b) ->
          ('a -> nat -> 'b -> bool) ->
            ('c, 'd) term -> ((char list -> char list), unit) sum
  val check_Lab_all_trs :
    'a equal * 'a show -> 'c equal * 'c show ->
      ('a -> nat -> 'b -> 'a) ->
        ('a -> 'a * 'b) ->
          ('a -> nat -> 'b -> bool) ->
            (('a, 'c) term * ('a, 'c) term) list ->
              (('a, 'c) term * ('a, 'c) term) list ->
                ((char list -> char list), unit) sum
  val check_sl_rule_all_ass :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> 'b list -> 'c) ->
            ('a -> nat -> 'c -> 'd) ->
              ('c -> 'c list) ->
                (('d, 'e) term * ('d, 'e) term) list ->
                  ('e -> 'b) ->
                    ('a, 'e) term * ('a, 'e) term ->
                      ((char list -> char list), unit) sum
  val check_sl_rule_all :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> 'b list -> 'c) ->
            ('a -> nat -> 'c -> 'd) ->
              'b list ->
                ('c -> 'c list) ->
                  (('d, 'e) term * ('d, 'e) term) list ->
                    ('a, 'e) term * ('a, 'e) term ->
                      ((char list -> char list), unit) sum
  val check_sl_lab_all_trs :
    'a show -> 'b show -> 'd equal * 'd show -> 'e equal * 'e show ->
      ('a -> 'b list -> 'b) ->
        ('a -> 'b list -> 'c) ->
          ('a -> 'b list -> 'c) ->
            'b list ->
              ('c -> 'c list) ->
                ('a -> nat -> 'c -> 'd) ->
                  (('d, 'e) term * ('d, 'e) term) list ->
                    (('a, 'e) term * ('a, 'e) term) list ->
                      ((char list -> char list), unit) sum
  val flatten_term_enum : (('a list), 'b) term -> ('a, 'b) term list
  val lab_lhss_more_impl :
    ('a -> nat -> 'b -> 'c) ->
      ('a -> nat -> 'b list) -> ('a, 'd) term list -> ('c, 'd) term list
  val check_sl_lab_lhss_more :
    'a equal * 'a show -> 'c equal * 'c show ->
      ('a -> nat -> 'b -> 'a) ->
        ('a -> nat -> 'b list) ->
          ('a, 'c) term list ->
            ('a, 'c) term list -> ((char list -> char list), unit) sum
  val quasi_splitter :
    'a equal -> 'c equal ->
      ('a -> 'a * 'b) ->
        (('a, 'c) term * ('a, 'c) term) list ->
          (('a, 'c) term * ('a, 'c) term) list ->
            (('a, 'c) term * ('a, 'c) term) list *
              ((('a, 'c) term * ('a, 'c) term) list *
                (('a, 'c) term * ('a, 'c) term) list)
  val sem_lab_quasi_root_proc :
    'a equal * 'a show -> 'd equal * 'd show ->
      ('a -> 'a * 'b) ->
        ('c, 'a, 'd, unit) dpp_ops_ext ->
          ((char list -> char list), unit) sum ->
            ((('a, 'd) term * ('a, 'd) term) list ->
              ((char list -> char list), unit) sum) ->
              ((('a, 'd) term * ('a, 'd) term) list ->
                ((char list -> char list), unit) sum) ->
                (('a, 'd) term list ->
                  ('a, 'd) term list -> ((char list -> char list), unit) sum) ->
                  ((('a, 'd) term * ('a, 'd) term) list ->
                    (('a, 'd) term * ('a, 'd) term) list ->
                      ((char list -> char list), unit) sum) ->
                    ((('a, 'd) term * ('a, 'd) term) list ->
                      (('a, 'd) term * ('a, 'd) term) list ->
                        ((char list -> char list), unit) sum) ->
                      ((('a, 'd) term * ('a, 'd) term) list ->
                        (('a, 'd) term * ('a, 'd) term) list ->
                          ((char list -> char list), unit) sum) ->
                        (('a, 'd) term * ('a, 'd) term) list ->
                          ('a, 'd) term list ->
                            (('a, 'd) term * ('a, 'd) term) list ->
                              'c -> ((char list -> char list), 'c) sum
  val sem_lab_fin_quasi_root_proc :
    'a equal * 'a show -> 'b equal -> 'c show -> 'e equal * 'e show ->
      ('a -> nat -> 'b -> 'a) ->
        ('a -> 'a * 'b) ->
          ('c -> 'c -> bool) ->
            ('a -> nat -> 'b -> 'b -> bool) ->
              ('d, 'a, 'e, unit) dpp_ops_ext ->
                (('a * nat) list ->
                  ('a * nat) list ->
                    ((char list -> char list),
                      ('a, 'c, 'b, 'e, unit) sl_ops_ext)
                      sum) ->
                  (('a, 'e) term * ('a, 'e) term) list ->
                    ('a, 'e) term list ->
                      (('a, 'e) term * ('a, 'e) term) list ->
                        'd -> ((char list -> char list), 'd) sum
  val semlab_fin_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, ('b, (nat list)) lab, 'c, unit) dpp_ops_ext ->
        (('b, (nat list)) lab, 'c) sl_variant ->
          ((('b, (nat list)) lab, 'c) term *
            (('b, (nat list)) lab, 'c) term) list ->
            (('b, (nat list)) lab, 'c) term list ->
              ((('b, (nat list)) lab, 'c) term *
                (('b, (nat list)) lab, 'c) term) list ->
                'a -> ((char list -> char list), 'a) sum
  val ur_af_root_redtriple_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) root_redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              'a -> ((char list -> char list), 'a) sum
  val check_wf_afs :
    'a show ->
      (('a * nat) * af_entry) list -> ((char list -> char list), unit) sum
  val afs_list_to_af :
    'a equal -> (('a * nat) * af_entry) list -> 'a -> nat -> nat -> bool
  val mono_af_entry : nat -> af_entry -> bool
  val check_mono_afs_help : 'a show -> ('a * 'b) * 'c -> char list -> char list
  val check_mono_afs :
    'a show ->
      (('a * nat) * af_entry) list -> ((char list -> char list), unit) sum
  val default_af_entry : nat -> af_entry
  val afs_list_to_afs :
    'a equal -> (('a * nat) * af_entry) list -> 'a -> nat -> af_entry
  val af_redtriple :
    'a equal * 'a show -> 'b show ->
      (('a * nat) * af_entry) list ->
        ('a filtered, 'b, unit) redtriple_ext -> ('a, 'b, unit) redtriple_ext
  val equal_filtereda : 'a equal -> 'a filtered -> 'a filtered -> bool
  val equal_filtered : 'a equal -> 'a filtered equal
  val shows_arctic : arctic -> char list -> char list
  val shows_prec_arctic : nat -> arctic -> char list -> char list
  val shows_list_arctic : arctic list -> char list -> char list
  val show_arctic : arctic show
  val ordered_semiring_0_int : int ordered_semiring_0
  val ordered_semiring_1_int : int ordered_semiring_1
  val max_ordered_semiring_1_int : int max_ordered_semiring_1
  val poly_carrier_int : int poly_carrier
  val ordered_semiring_0_rat : rat ordered_semiring_0
  val ordered_semiring_1_rat : rat ordered_semiring_1
  val max_ordered_semiring_1_rat : rat max_ordered_semiring_1
  val poly_carrier_rat : rat poly_carrier
  val shows_arctic_rat : arctic_rat -> char list -> char list
  val shows_prec_arctic_rat : nat -> arctic_rat -> char list -> char list
  val shows_list_arctic_rat : arctic_rat list -> char list -> char list
  val show_arctic_rat : arctic_rat show
  val poly_inter_to_af :
    ('a -> nat -> ((nat * nat) list * 'b) list) -> 'a -> nat -> nat -> bool
  val check_poly_weak_mono_all :
    'b ordered_semiring_0 -> (('a * nat) list * 'b) list -> bool
  val check_poly_weak_mono_discrete :
    'a equal -> 'b equal * 'b poly_carrier ->
      (('a * nat) list * 'b) list -> 'a -> bool
  val check_poly_weak_mono_and_pos :
    'a equal -> 'b equal * 'b poly_carrier ->
      bool -> (('a * nat) list * 'b) list -> bool
  val check_poly_inter_list :
    'b equal * 'b poly_carrier ->
      bool ->
        (('a * nat) * ((nat * nat) list * 'b) list) list ->
          (('a * ((nat * nat) list * 'b) list), unit) sum
  val poly_inter_list_to_inter :
    'a poly_carrier -> 'b equal ->
      'a -> (('b * nat) * ((nat * nat) list * 'a) list) list ->
              'b -> nat -> ((nat * nat) list * 'a) list
  val check_monom_strict_mono :
    'a equal -> bool -> ('a * nat) list -> 'a -> bool
  val check_poly_strict_mono :
    'a equal -> 'b poly_carrier ->
      bool -> (('a * nat) list * 'b) list -> 'a -> bool
  val check_poly_strict_mono_discrete :
    'a equal * 'a poly_carrier -> 'b equal ->
      ('a -> 'a -> bool) -> (('b * nat) list * 'a) list -> 'b -> bool
  val check_poly_strict_mono_smart :
    'a equal * 'a poly_carrier -> 'b equal ->
      bool ->
        bool -> ('a -> 'a -> bool) -> (('b * nat) list * 'a) list -> 'b -> bool
  val create_nlpoly_redtriple :
    'a equal * 'a poly_carrier * 'a show -> 'b equal * 'b show ->
      'c equal * 'c show ->
      'a -> ('a -> 'a -> bool) ->
              bool ->
                bool ->
                  (('b * nat) * ((nat * nat) list * 'a) list) list ->
                    ('b, 'c, unit) redtriple_ext
  val create_afI :
    'a equal -> 'b equal ->
      'a -> (('b * nat) * ('a * 'a list)) list -> 'b -> nat -> nat -> bool
  val get_comp_ge :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a -> bool
  val show_pvars :
    'a equal * 'a show -> 'b show -> 'a -> ('b * 'a) list -> (char list) list
  val shows_lpoly :
    'a equal * 'a show -> 'b show ->
      'a -> 'a -> ('b, 'a) l_poly -> char list -> char list
  val lookup_rest :
    'a equal -> 'a -> ('a * 'b) list -> ('b * ('a * 'b) list) option
  val check_pvarsI :
    'b equal ->
      'a -> ('a -> 'a -> bool) ->
              ('b * 'a) list -> ('b * 'a) list -> ('b, unit) sum
  val check_lpoly_sI :
    'a equal * 'a show -> 'b equal * 'b show ->
      bool ->
        'a -> 'a -> ('a -> 'a -> bool) ->
                      ('a -> 'a -> bool) ->
                        ('b, 'a) l_poly ->
                          ('b, 'a) l_poly ->
                            ((char list -> char list), unit) sum
  val check_polo_sI :
    'a equal * 'a show -> 'b show -> 'c equal * 'c show ->
      bool ->
        'a -> 'a -> ('a -> 'a -> 'a) ->
                      ('a -> 'a -> 'a) ->
                        ('a -> 'a) ->
                          ('a -> 'a -> bool) ->
                            ('a -> 'a -> bool) ->
                              ('b -> nat -> 'a * 'a list) ->
                                ('b, 'c) term * ('b, 'c) term ->
                                  ((char list -> char list), unit) sum
  val get_comp_max0 :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> 'a
  val check_lpoly_nsI :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a -> 'a -> ('a -> 'a -> bool) ->
                    ('b, 'a) l_poly ->
                      ('b, 'a) l_poly -> ((char list -> char list), unit) sum
  val check_polo_nsI :
    'a equal * 'a show -> 'b show -> 'c equal * 'c show ->
      'a -> 'a -> ('a -> 'a -> 'a) ->
                    ('a -> 'a -> 'a) ->
                      ('a -> 'a) ->
                        ('a -> 'a -> bool) ->
                          ('b -> nat -> 'a * 'a list) ->
                            ('b, 'c) term * ('b, 'c) term ->
                              ((char list -> char list), unit) sum
  val to_lpoly_inter :
    'b equal ->
      'a -> 'a -> (('b * nat) * ('a * 'a list)) list ->
                    'b -> nat -> 'a * 'a list
  val check_poly_monoI :
    'a show -> 'b show ->
      'a -> ('a -> 'a -> bool) ->
              ('a -> bool) ->
                (('b * nat) * ('a * 'a list)) list ->
                  ((char list -> char list), unit) sum
  val get_comp_wf_elem :
    ('a -> bool) *
      ('a * ('a * ('a * (('a -> 'a -> 'a) *
                          (('a -> 'a -> 'a) *
                            (('a -> 'a) *
                              (('a -> 'a -> bool) *
                                (('a -> 'a -> bool) *
                                  (bool *
                                    (char list *
                                      (('a -> bool) * ('a -> bool)))))))))))) ->
      'a -> bool
  val create_lpoly_repr :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a -> bool) *
        ('a * ('a * ('a * (('a -> 'a -> 'a) *
                            (('a -> 'a -> 'a) *
                              (('a -> 'a) *
                                (('a -> 'a -> bool) *
                                  (('a -> 'a -> bool) *
                                    (bool *
                                      (char list *
(('a -> bool) * ('a -> bool)))))))))))) ->
        (('b * nat) * ('a * 'a list)) list -> char list -> char list
  val check_lpoly_coeffs :
    'a show -> 'b show ->
      ('a -> bool) ->
        ('a -> bool) ->
          ('a -> bool) ->
            (('b * nat) * ('a * 'a list)) list ->
              ((char list -> char list), unit) sum
  val create_poly_redtriple :
    'a equal * 'a show -> 'b equal * 'b show -> 'c equal * 'c show ->
      ((('a * nat) * ('b * 'b list)) list ->
        ((char list -> char list), unit) sum) ->
        ('b -> bool) *
          ('b * ('b * ('b * (('b -> 'b -> 'b) *
                              (('b -> 'b -> 'b) *
                                (('b -> 'b) *
                                  (('b -> 'b -> bool) *
                                    (('b -> 'b -> bool) *
                                      (bool *
(char list * (('b -> bool) * ('b -> bool)))))))))))) ->
          (('a * nat) * ('b * 'b list)) list -> ('a, 'c, unit) redtriple_ext
  val prec_repr_to_pr :
    'a equal ->
      (('a * nat) * (nat * order_tag)) list -> 'a filtered -> nat -> nat
  val faulty_redtriple :
    'a show -> 'b show -> char list -> ('a, 'b, unit) redtriple_ext
  val prec_repr_to_status :
    'a equal ->
      (('a * nat) * (nat * order_tag)) list -> 'a filtered -> nat -> order_tag
  val get_redtriple :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a redtriple_impl -> ('a, 'b, unit) redtriple_ext
  val check_weak :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a -> nat) ->
        ('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum
  val is_QNFc : ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> ('b, 'c) term -> bool
  val q_emptyc : ('a, 'b, 'c, 'd) dpp_ops_ext -> 'a -> bool
  val check_strict_rstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term ->
          ((pos *
             ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list) option) ->
          ('a -> nat) ->
            ('a, 'b) term * ('a, 'b) term ->
              ((char list -> char list), unit) sum
  val check_prop_rstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> ((char list -> char list), unit) sum) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          pos ->
            ('a, 'b) term * ('a, 'b) term ->
              ('a, 'b) term ->
                ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_qrstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> bool) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          pos ->
            ('a, 'b) term * ('a, 'b) term ->
              ('a, 'b) term ->
                ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_strict_qrstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> bool) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term ->
            ((pos *
               ((('a, 'b) term * ('a, 'b) term) *
                 ('a, 'b) term)) list) option) ->
            ('a -> nat) ->
              ('a, 'b) term * ('a, 'b) term ->
                ((char list -> char list), unit) sum
  val subterm_criterion_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b -> nat) ->
          (('b, 'c) term * ('b, 'c) term ->
            ((pos *
               ((('b, 'c) term * ('b, 'c) term) *
                 ('b, 'c) term)) list) option) ->
            (('b, 'c) term * ('b, 'c) term) list ->
              'a -> ((char list -> char list), 'a) sum
  val min_set_ext :
    ('a -> 'a -> bool * bool) -> 'a list -> 'a list -> bool * bool
  val or2 : bool * bool -> bool * bool -> bool * bool
  val lifta : bool * bool -> bool * bool
  val mul_ext_impl :
    'a equal -> ('a -> 'a -> bool * bool) -> 'a list -> 'a list -> bool * bool
  val ex_dominating :
    'a equal ->
      ('a -> 'a -> bool * bool) ->
        'a -> 'a list -> 'a list -> 'a list -> bool * bool
  val list_ext :
    'a equal ->
      list_order_type ->
        ('a -> 'a -> bool * bool) -> 'a list -> 'a list -> bool * bool
  val get_root_redtriple :
    'a equal * 'a show -> 'b equal * 'b show ->
      'a root_redtriple_impl -> ('a, 'b, unit) root_redtriple_ext
  val combine : 'b equal -> ('a, 'b) scg -> ('a, 'b) scg -> ('a, 'b) scg
  val in_situ : 'b equal -> ('a, 'b) scg -> bool
  val comp : 'a equal -> ('a * 'a) list -> ('a * 'a) list -> ('a * 'a) list
  val subtract_list : 'a equal -> 'a list -> 'a list -> 'a list
  val scg_comp :
    'b equal ->
      ('a -> 'a -> bool) -> ('a, 'b) scg -> ('a, 'b) scg -> ('a, 'b) scg
  val subsumes : 'a equal -> 'b equal -> ('a, 'b) scg -> ('a, 'b) scg -> bool
  val sagiv : 'a equal -> 'b equal -> ('a -> 'a -> bool) -> ('a, 'b) scg -> bool
  val equal_scg : 'a equal -> 'b equal -> ('a, 'b) scg -> ('a, 'b) scg -> bool
  val insert_scg :
    'a equal -> 'b equal ->
      ('a, 'b) scg -> ('a, 'b) scg list -> (('a, 'b) scg list) option
  val mk_trancl :
    'a equal -> 'b equal ->
      ('a -> 'a -> bool) ->
        ('a, 'b) scg list -> ('a, 'b) scg list -> ('a, 'b) scg list
  val check_SCT :
    'a equal -> 'b equal -> ('a -> 'a -> bool) -> ('a, 'b) scg list -> bool
  val get_arg : ('a, 'b) term -> nat -> ('a, 'b) term
  val check_sct_ur_af_entry :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a * nat -> bool) ->
        ('a * nat -> (('a, 'b) term * ('a, 'b) term) list) ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ('a -> nat -> nat -> bool) ->
              (('a, 'b) term * ('a, 'b) term -> ('c, 'd) sum) ->
                (('a, 'b) term * ('a, 'b) term -> ('e, 'f) sum) ->
                  ('a, 'b) term ->
                    ('a, 'b) term ->
                      (nat * nat) list ->
                        (nat * nat) list -> ((char list -> char list), unit) sum
  val sct_ur_af_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ('b, 'c, unit) redtriple_ext ->
          ((('b, 'c) term * ('b, 'c) term) *
            ((nat * nat) list * (nat * nat) list)) list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              'a -> ((char list -> char list), unit) sum
  val sct_subterm_proc :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) dpp_ops_ext ->
        ((('b, 'c) term * ('b, 'c) term) *
          ((nat * nat) list * (nat * nat) list)) list ->
          'a -> ((char list -> char list), unit) sum
  val check_dp_proof :
    'b equal * 'b show ->
      bool ->
        (char list -> char list) ->
          ('a, ('b, (nat list)) lab, (char list), unit) dpp_ops_ext ->
            'a -> ('b, (nat list), (char list)) dp_proof ->
                    ((char list -> char list), unit) sum
  val shows_tp :
    ('a -> char list -> char list) ->
      ('b -> char list -> char list) ->
        ('c, 'a, 'b, unit) tp_ops_ext -> 'c -> char list -> char list
  val check_tp_subsumes :
    'b equal * 'b show -> 'c equal * 'c show -> 'd equal * 'd show ->
      ('a, ('b, 'c) lab, 'd, unit) tp_ops_ext ->
        (('b, 'c) lab, 'd) term list *
          (((('b, 'c) lab, 'd) term * (('b, 'c) lab, 'd) term) list *
            ((('b, 'c) lab, 'd) term * (('b, 'c) lab, 'd) term) list) ->
          'a -> ((char list -> char list), unit) sum
  val fcc_tt :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) tp_ops_ext ->
        ('b, 'c) ctxt list ->
          (('b, 'c) term * ('b, 'c) term) list ->
            'a -> ((char list -> char list), 'a) sum
  val rule_removal_tt :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) tp_ops_ext ->
        ('b, 'c, unit) redtriple_ext ->
          (('b, 'c) term * ('b, 'c) term) list ->
            'a -> ((char list -> char list), 'a) sum
  val sem_lab_rel_tt :
    'a equal * 'a show -> 'b equal * 'b show ->
      ((('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a, 'b) term * ('a, 'b) term) list)) ->
        ('a -> 'a * 'c) ->
          ('d, 'a, 'b, unit) tp_ops_ext ->
            ((char list -> char list), unit) sum ->
              ((('a, 'b) term * ('a, 'b) term) list ->
                ((char list -> char list), unit) sum) ->
                ((('a, 'b) term * ('a, 'b) term) list ->
                  (('a, 'b) term * ('a, 'b) term) list ->
                    ((char list -> char list), unit) sum) ->
                  ('a, 'b) term list ->
                    (('a, 'b) term * ('a, 'b) term) list ->
                      'd -> ((char list -> char list), 'd) sum
  val sem_lab_fin_tt :
    'a equal * 'a show -> 'b equal * 'b show -> 'd show ->
      ((('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a, 'b) term * ('a, 'b) term) list)) ->
        ('a -> nat -> 'c -> 'a) ->
          ('a -> 'a * 'c) ->
            ('d -> 'd -> bool) ->
              ('e, 'a, 'b, unit) tp_ops_ext ->
                (('a * nat) list ->
                  ('a * nat) list ->
                    ((char list -> char list),
                      ('a, 'd, 'c, 'b, unit) sl_ops_ext)
                      sum) ->
                  ('a, 'b) term list ->
                    (('a, 'b) term * ('a, 'b) term) list ->
                      'e -> ((char list -> char list), 'e) sum
  val semlab_fin_tt :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, ('b, (nat list)) lab, 'c, unit) tp_ops_ext ->
        (('b, (nat list)) lab, 'c) sl_variant ->
          (('b, (nat list)) lab, 'c) term list ->
            ((('b, (nat list)) lab, 'c) term *
              (('b, (nat list)) lab, 'c) term) list ->
              'a -> ((char list -> char list), 'a) sum
  val check_unary_signature :
    'a show -> 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val string_reversal_tt :
    'b show -> 'c show ->
      ('a, 'b, 'c, unit) tp_ops_ext -> 'a -> ((char list -> char list), 'a) sum
  val dP_list :
    'a equal -> 'b equal ->
      ('a -> 'a) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a * nat) list -> (('a, 'b) term * ('a, 'b) term) list
  val is_QNFa : ('a, 'b, 'c, 'd) tp_ops_ext -> 'a -> ('b, 'c) term -> bool
  val useful_rule_impla :
    (('a, 'b) term -> bool) -> ('a, 'b) term * ('a, 'b) term -> bool
  val dependency_pairs_tt :
    'b equal * 'b show -> 'c equal * 'c show ->
      ('a, 'b, 'c, unit) tp_ops_ext ->
        ('d, 'b, 'c, unit) dpp_ops_ext ->
          'a -> ('b -> 'b) ->
                  (('b, 'c) term * ('b, 'c) term) list ->
                    ((char list -> char list), 'd) sum
  val check_trs_proof :
    'b equal * 'b linorder * 'b show ->
      bool ->
        (char list -> char list) ->
          ('a, ('b, (nat list)) lab, (char list), unit) tp_ops_ext ->
            ('c, ('b, (nat list)) lab, (char list), unit) dpp_ops_ext ->
              'a -> ('b, (nat list), (char list)) trs_proof ->
                      ((char list -> char list), unit) sum
  val contains_var_term : 'a equal -> 'a -> ('b, 'a) term -> bool
  val ident_solve_impla :
    'a equal -> 'b equal ->
      ('a -> ('b, 'a) term) ->
        'a list ->
          (('b, 'a) term * (('b, 'a) term * nat)) list ->
            ('b, 'a) term * (('b, 'a) term * nat) -> nat option
  val ident_solve_impl :
    'a equal -> 'b equal ->
      ('a -> ('b, 'a) term) ->
        'a list -> ('b, 'a) term * ('b, 'a) term -> nat option
  val redex_rps_decision :
    'a equal -> 'b equal ->
      ('a * ('b, 'a) term) list ->
        (('b, 'a) term * ('b, 'a) term) list ->
          ((('b, 'a) term * ('b, 'a) term), unit) sum
  val check_NF_iteration :
    'a equal -> 'b equal ->
      ('a * ('b, 'a) term) list ->
        ('b, 'a) term list ->
          ('b, 'a) term -> ((('b, 'a) term * ('b, 'a) term), unit) sum
  val check_qrstep_subst :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> ((('a, 'b) term * ('a, 'b) term), unit) sum) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          pos ->
            ('a, 'b) term * ('a, 'b) term ->
              ('a, 'b) term ->
                ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_rqrstep_subst :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> ((('a, 'b) term * ('a, 'b) term), unit) sum) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) term * ('a, 'b) term ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_qsteps_subst :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> ((('a, 'b) term * ('a, 'b) term), unit) sum) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (pos *
              ((('a, 'b) term * ('a, 'b) term) *
                (bool * ('a, 'b) term))) list ->
              ('a, 'b) term ->
                ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_qrsteps_subst :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> ((('a, 'b) term * ('a, 'b) term), unit) sum) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_loop :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) term list ->
        (('a, 'b) term -> bool) ->
          ('a, 'b) term ->
            (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list ->
              ('b * ('a, 'b) term) list ->
                ('a, 'b) ctxt ->
                  (('a, 'b) term * ('a, 'b) term) list ->
                    ((char list -> char list), unit) sum
  val check_rqrstep :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> bool) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) term * ('a, 'b) term ->
            ('a, 'b) term ->
              ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_qsteps :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> bool) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (pos *
              ((('a, 'b) term * ('a, 'b) term) *
                (bool * ('a, 'b) term))) list ->
              ('a, 'b) term ->
                ('a, 'b) term -> ((char list -> char list), unit) sum
  val check_dp_loop :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) term list ->
        (('a, 'b) term -> bool) ->
          ('a, 'b) term ->
            (pos *
              ((('a, 'b) term * ('a, 'b) term) *
                (bool * ('a, 'b) term))) list ->
              ('b * ('a, 'b) term) list ->
                ('a, 'b) ctxt ->
                  (('a, 'b) term * ('a, 'b) term) list ->
                    (('a, 'b) term * ('a, 'b) term) list ->
                      ((char list -> char list), unit) sum
  val check_dp_disproof :
    'b equal * 'b show -> 'c equal * 'c show ->
      (char list -> char list) ->
        ('a, 'b, 'c, unit) dpp_ops_ext ->
          'a -> ('b, 'c) dp_disproof -> ((char list -> char list), unit) sum
  val unsharp : ('a, 'b) lab -> ('a, 'b) lab
  val check_dps :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a -> 'a) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ((('a, 'b) term * ('a, 'b) term), unit) sum
  val q_emptya : ('a, 'b, 'c, 'd) tp_ops_ext -> 'a -> bool
  val useful_rule_impl :
    (('a, 'b) term -> bool) -> ('a, 'b) term * ('a, 'b) term -> bool
  val check_wwf_qtrs :
    'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> bool) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((char list -> char list), unit) sum
  val check_not_wwf_qtrs :
    'a show -> 'b equal * 'b show ->
      (('a, 'b) term -> bool) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ((char list -> char list), unit) sum
  val check_trs_disproof :
    'b equal * 'b show -> 'c equal * 'c show -> 'd equal * 'd show ->
      (char list -> char list) ->
        ('a, ('b, 'c) lab, 'd, unit) tp_ops_ext ->
          ('e, ('b, 'c) lab, 'd, unit) dpp_ops_ext ->
            'a -> (('b, 'c) lab, 'd) trs_disproof ->
                    ((char list -> char list), unit) sum
  val check_rel_seq :
    'a equal * 'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (pos *
            ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
            ('a, 'b) term ->
              ('a, 'b) term -> bool -> ((char list -> char list), unit) sum
  val check_rel_loop :
    'a equal * 'a show -> 'b equal * 'b show ->
      ('a, 'b) term ->
        (pos *
          ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list ->
          ('b * ('a, 'b) term) list ->
            ('a, 'b) ctxt ->
              (('a, 'b) term * ('a, 'b) term) list ->
                (('a, 'b) term * ('a, 'b) term) list ->
                  ((char list -> char list), unit) sum
  val check_wf_reltrs :
    'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val check_not_wf_reltrs :
    'a show -> 'b equal * 'b show ->
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list ->
        ((char list -> char list), unit) sum
  val check_reltrs_disproof :
    'b equal * 'b show -> 'c equal * 'c show -> 'd equal * 'd show ->
      (char list -> char list) ->
        ('a, ('b, 'c) lab, 'd, unit) tp_ops_ext ->
          ('e, ('b, 'c) lab, 'd, unit) dpp_ops_ext ->
            'a -> (('b, 'c) lab, 'd) reltrs_disproof ->
                    ((char list -> char list), unit) sum
  val certify_cert_problem :
    'b equal * 'b linorder * 'b show ->
      bool ->
        ('a, ('b, (nat list)) lab, (char list), unit) tp_ops_ext ->
          ('c, ('b, (nat list)) lab, (char list), unit) dpp_ops_ext ->
            ('b, (nat list), (char list)) cert_problem -> cert_result
  val mk_impl :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) term list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ('a, 'b) term list *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt)))
  val mk :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) term list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) tp
  val rw_impl :
    'a equal * 'a linorder ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        (('a, 'b) term * ('a, 'b) term) list
  val rw :
    'a equal * 'a linorder ->
      ('a, 'b) tp -> (('a, 'b) term * ('a, 'b) term) list
  val rules_impl :
    'a equal * 'a linorder ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        (('a, 'b) term * ('a, 'b) term) list
  val rulesa :
    'a equal * 'a linorder ->
      ('a, 'b) tp -> (('a, 'b) term * ('a, 'b) term) list
  val nF_terms_list :
    'a equal -> 'b equal -> ('a, 'b) term list -> ('a, 'b) term -> bool
  val is_QNF_impl :
    'a equal -> 'b equal ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        ('a, 'b) term -> bool
  val is_QNF :
    'a equal * 'a linorder -> 'b equal -> ('a, 'b) tp -> ('a, 'b) term -> bool
  val q_empty_impl :
    ('a, 'b) term list *
      (bool *
        ((('a, 'b) term * ('a, 'b) term) list *
          ((('a, 'b) term * ('a, 'b) term) list *
            (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
              rbt))) ->
      bool
  val q_empty : 'a linorder -> ('a, 'b) tp -> bool
  val qreltrs_impl :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        (('a, 'b) term -> bool) *
          ((('a, 'b) term * ('a, 'b) term -> bool) *
            (('a, 'b) term * ('a, 'b) term -> bool))
  val qreltrs :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) tp ->
        (('a, 'b) term -> bool) *
          ((('a, 'b) term * ('a, 'b) term -> bool) *
            (('a, 'b) term * ('a, 'b) term -> bool))
  val rules_map_impl :
    'a equal * 'a linorder ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        'a * nat -> (('a, 'b) term * ('a, 'b) term) list
  val rules_map :
    'a equal * 'a linorder ->
      ('a, 'b) tp -> 'a * nat -> (('a, 'b) term * ('a, 'b) term) list
  val delete_R_Rw_impl :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            ('a, 'b) term list *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt)))
  val delete_R_Rw :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) tp ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) tp
  val split_rules_impl :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) term list *
        (bool *
          ((('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                rbt))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val split_rules :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) tp ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val nFQ_subset_NF_rules_impl :
    ('a, 'b) term list *
      (bool *
        ((('a, 'b) term * ('a, 'b) term) list *
          ((('a, 'b) term * ('a, 'b) term) list *
            (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
              rbt))) ->
      bool
  val nFQ_subset_NF_rules : 'a linorder -> ('a, 'b) tp -> bool
  val tp_rbt_impl :
    'a equal * 'a linorder -> 'b equal -> (('a, 'b) tp, 'a, 'b, unit) tp_ops_ext
  val p_impl :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      (('a, 'b) term * ('a, 'b) term) list
  val impl_ofb :
    'a linorder ->
      ('a, 'b) dpp ->
        (('a, 'b) term * ('a, 'b) term) list *
          ((('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term list *
              (bool *
                (bool *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a, 'b) term * ('a, 'b) term) list *
                      ((('a * nat),
                         ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                         rbt *
                        (('a * nat),
                          ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                          rbt)))))))
  val p : 'a linorder -> ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list
  val q_impla :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      ('a, 'b) term list
  val qb : 'a linorder -> ('a, 'b) dpp -> ('a, 'b) term list
  val r_impla :
    'a equal * 'a linorder ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list
  val rb :
    'a equal * 'a linorder ->
      ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list
  val mk_impla :
    'a equal * 'a linorder -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) term list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              (('a, 'b) term * ('a, 'b) term) list ->
                (('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    (('a, 'b) term list *
                      (bool *
                        (bool *
                          ((('a, 'b) term * ('a, 'b) term) list *
                            ((('a, 'b) term * ('a, 'b) term) list *
                              ((('a * nat),
                                 ((bool *
                                    (('a, 'b) term * ('a, 'b) term)) list))
                                 rbt *
                                (('a * nat),
                                  ((bool *
                                     (('a, 'b) term * ('a, 'b) term)) list))
                                  rbt)))))))
  val mkb :
    'a equal * 'a linorder -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list ->
        (('a, 'b) term * ('a, 'b) term) list ->
          ('a, 'b) term list ->
            (('a, 'b) term * ('a, 'b) term) list ->
              (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) dpp
  val pw_impl :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      (('a, 'b) term * ('a, 'b) term) list
  val pw : 'a linorder -> ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list
  val rw_impla :
    'a equal * 'a linorder ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list
  val rwb :
    'a equal * 'a linorder ->
      ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list
  val dpp_impl :
    'a equal * 'a linorder -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term -> bool) *
          ((('a, 'b) term * ('a, 'b) term -> bool) *
            ((('a, 'b) term -> bool) *
              ((('a, 'b) term * ('a, 'b) term -> bool) *
                (('a, 'b) term * ('a, 'b) term -> bool))))
  val dppa :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) dpp ->
        (('a, 'b) term * ('a, 'b) term -> bool) *
          ((('a, 'b) term * ('a, 'b) term -> bool) *
            ((('a, 'b) term -> bool) *
              ((('a, 'b) term * ('a, 'b) term -> bool) *
                (('a, 'b) term * ('a, 'b) term -> bool))))
  val pairs_impl :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      (('a, 'b) term * ('a, 'b) term) list
  val pairs :
    'a linorder -> ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list
  val rules_impla :
    'a equal * 'a linorder ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list
  val rulesc :
    'a equal * 'a linorder ->
      ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list
  val is_QNF_impla :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        ('a, 'b) term -> bool
  val is_QNFb :
    'a equal * 'a linorder -> 'b equal -> ('a, 'b) dpp -> ('a, 'b) term -> bool
  val q_empty_impla :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      bool
  val q_emptyb : 'a linorder -> ('a, 'b) dpp -> bool
  val rules_map_impla :
    'a equal * 'a linorder ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        'a * nat -> (('a, 'b) term * ('a, 'b) term) list
  val rules_mapa :
    'a equal * 'a linorder ->
      ('a, 'b) dpp -> 'a * nat -> (('a, 'b) term * ('a, 'b) term) list
  val delete_P_Pw_impl :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list *
              ((('a, 'b) term * ('a, 'b) term) list *
                (('a, 'b) term list *
                  (bool *
                    (bool *
                      ((('a, 'b) term * ('a, 'b) term) list *
                        ((('a, 'b) term * ('a, 'b) term) list *
                          ((('a * nat),
                             ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                             rbt *
                            (('a * nat),
                              ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                              rbt)))))))
  val delete_P_Pw :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) dpp ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) dpp
  val delete_R_Rw_impla :
    'a equal * 'a linorder -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list ->
            (('a, 'b) term * ('a, 'b) term) list *
              ((('a, 'b) term * ('a, 'b) term) list *
                (('a, 'b) term list *
                  (bool *
                    (bool *
                      ((('a, 'b) term * ('a, 'b) term) list *
                        ((('a, 'b) term * ('a, 'b) term) list *
                          ((('a * nat),
                             ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                             rbt *
                            (('a * nat),
                              ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                              rbt)))))))
  val delete_R_Rwb :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) dpp ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) dpp
  val split_pairs_impl :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val split_pairs :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) dpp ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val split_rules_impla :
    'a equal * 'a linorder -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val split_rulesb :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) dpp ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            (('a, 'b) term * ('a, 'b) term) list
  val intersect_pairs_impl :
    'a equal -> 'b equal ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        (('a, 'b) term * ('a, 'b) term) list ->
          (('a, 'b) term * ('a, 'b) term) list *
            ((('a, 'b) term * ('a, 'b) term) list *
              (('a, 'b) term list *
                (bool *
                  (bool *
                    ((('a, 'b) term * ('a, 'b) term) list *
                      ((('a, 'b) term * ('a, 'b) term) list *
                        ((('a * nat),
                           ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                           rbt *
                          (('a * nat),
                            ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                            rbt)))))))
  val intersect_pairs :
    'a equal * 'a linorder -> 'b equal ->
      ('a, 'b) dpp -> (('a, 'b) term * ('a, 'b) term) list -> ('a, 'b) dpp
  val reverse_rules_map_impl :
    'a equal * 'a linorder ->
      (('a, 'b) term * ('a, 'b) term) list *
        ((('a, 'b) term * ('a, 'b) term) list *
          (('a, 'b) term list *
            (bool *
              (bool *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a, 'b) term * ('a, 'b) term) list *
                    ((('a * nat),
                       ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                       rbt *
                      (('a * nat),
                        ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                        rbt))))))) ->
        'a * nat -> (('a, 'b) term * ('a, 'b) term) list
  val reverse_rules_map :
    'a equal * 'a linorder ->
      ('a, 'b) dpp -> 'a * nat -> (('a, 'b) term * ('a, 'b) term) list
  val rules_no_left_var_impl :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      bool
  val rules_no_left_var : 'a linorder -> ('a, 'b) dpp -> bool
  val nFQ_subset_NF_rules_impla :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      bool
  val nFQ_subset_NF_rulesa : 'a linorder -> ('a, 'b) dpp -> bool
  val rules_non_collapsing_impl :
    (('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))) ->
      bool
  val rules_non_collapsing : 'a linorder -> ('a, 'b) dpp -> bool
  val dpp_rbt_impl :
    'a equal * 'a linorder -> 'b equal ->
      (('a, 'b) dpp, 'a, 'b, unit) dpp_ops_ext
  val certify_proof : bool -> char list -> cert_result
end = struct

fun id x = (fn xa => xa) x;

type 'a equal = {equal : 'a -> 'a -> bool};
val equal = #equal : 'a equal -> 'a -> 'a -> bool;

fun eq A_ a b = equal A_ a b;

datatype nat = Zero_nat | Suc of nat;

datatype color = R | B;

datatype ('a, 'b) rbta = Emptya |
  Branch of color * ('a, 'b) rbta * 'a * 'b * ('a, 'b) rbta;

type 'a ord = {less_eq : 'a -> 'a -> bool, less : 'a -> 'a -> bool};
val less_eq = #less_eq : 'a ord -> 'a -> 'a -> bool;
val less = #less : 'a ord -> 'a -> 'a -> bool;

type 'a preorder = {ord_preorder : 'a ord};
val ord_preorder = #ord_preorder : 'a preorder -> 'a ord;

type 'a order = {preorder_order : 'a preorder};
val preorder_order = #preorder_order : 'a order -> 'a preorder;

type 'a linorder = {order_linorder : 'a order};
val order_linorder = #order_linorder : 'a linorder -> 'a order;

datatype ('a, 'b) rbt = Rbt of ('a, 'b) rbta;

datatype rat = Frct of (int * int);

fun nat_aux i n =
  (if i <= (0 : IntInf.int) then n else nat_aux (i - (1 : IntInf.int)) (Suc n));

fun nat i = nat_aux i Zero_nat;

fun hd (x :: xs) = x;

fun tl [] = []
  | tl (x :: xs) = xs;

datatype order_tag = Lex | Mul;

fun null [] = true
  | null (x :: xs) = false;

fun the (SOME x) = x;

fun foldr f [] a = a
  | foldr f (x :: xs) a = f x (foldr f xs a);

fun concat xss = foldr (fn a => fn b => a @ b) xss [];

datatype ('a, 'b) sum = Inl of 'a | Inr of 'b;

datatype nibble = Nibble0 | Nibble1 | Nibble2 | Nibble3 | Nibble4 | Nibble5 |
  Nibble6 | Nibble7 | Nibble8 | Nibble9 | NibbleA | NibbleB | NibbleC | NibbleD
  | NibbleE | NibbleF;

val newline : char = #"\n";

datatype xml =
  Xml of
    char list * (char list * char list) list * xml list * (char list) option;

fun is_none (SOME x) = false
  | is_none NONE = true;

fun equal_lista A_ (a :: lista) [] = false
  | equal_lista A_ [] (a :: lista) = false
  | equal_lista A_ (aa :: listaa) (a :: lista) =
    eq A_ aa a andalso equal_lista A_ listaa lista
  | equal_lista A_ [] [] = true;

val equal_char = {equal = (fn a => fn b => ((a : char) = b))} : char equal;

type 'a show =
  {shows_prec : nat -> 'a -> char list -> char list,
    shows_list : 'a list -> char list -> char list};
val shows_prec = #shows_prec : 'a show -> nat -> 'a -> char list -> char list;
val shows_list = #shows_list : 'a show -> 'a list -> char list -> char list;

fun shows_string x = (fn a => x @ a);

fun shows_list_char cs = shows_string cs;

fun shows_prec_char d c = (fn a => c :: a);

val show_char = {shows_prec = shows_prec_char, shows_list = shows_list_char} :
  char show;

fun replicate Zero_nat x = []
  | replicate (Suc n) x = x :: replicate n x;

fun shows_map s [] = id
  | shows_map s (x :: xs) = s x o shows_map s xs;

fun fst (a, b) = a;

fun snd (a, b) = b;

val dquote : char list = [#"\""];

fun shows_prec_list A_ d l = shows_list A_ l;

fun shows_attr av =
  shows_prec_list show_char Zero_nat (fst av) o
    (shows_string [#"="] o shows_string (dquote @ snd av @ dquote));

fun shows_attrs asa =
  shows_map (fn a => shows_string [#" "] o shows_attr a) asa;

fun shows_XML_indent ind i (Xml (n, a, c, t)) =
  shows_string ind o
    (shows_string [#"<"] o
      (shows_prec_list show_char Zero_nat n o
        (shows_attrs a o
          (if null c andalso is_none t then shows_string [#"/", #">"]
            else shows_string [#">"] o
                   ((if not (null c)
                      then shows_map
                             (shows_XML_indent (ind @ replicate i #" ") i) c o
                             shows_string ind
                      else id) o
                     ((if is_none t then id else shows_string (the t)) o
                       (shows_string [#"<", #"/"] o
                         (shows_prec_list show_char Zero_nat n o
                           shows_string [#">"]))))))));

fun shows_prec_xml d xml =
  shows_XML_indent [newline] (nat (2 : IntInf.int)) xml;

fun text tag (Xml (n, atts, cs, t)) =
  (if equal_lista equal_char n tag andalso
        (null atts andalso
          (null cs andalso (not (is_none t) andalso not (null (the t)))))
    then Inr (the t)
    else Inl (concat
               [[#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                  #"e", #"x", #"t", #"r", #"a", #"c", #"t", #" ", #"t", #"e",
                  #"x", #"t", #" ", #"f", #"o", #"r", #" "],
                 tag, [#" ", #"f", #"r", #"o", #"m", #" "], [newline],
                 shows_prec_xml Zero_nat (Xml (n, atts, cs, t)) []]));

fun take n [] = []
  | take n (x :: xs) = (case n of Zero_nat => [] | Suc m => x :: take m xs);

val one_nata : nat = Suc Zero_nat;

fun bindb m f = (case m of Inl a => Inl a | Inr a => f a);

fun digit2int x =
  (if ((x : char) = #"0") then Inr (0 : IntInf.int)
    else (if ((x : char) = #"1") then Inr (1 : IntInf.int)
           else (if ((x : char) = #"2") then Inr (2 : IntInf.int)
                  else (if ((x : char) = #"3") then Inr (3 : IntInf.int)
                         else (if ((x : char) = #"4") then Inr (4 : IntInf.int)
                                else (if ((x : char) = #"5")
                                       then Inr (5 : IntInf.int)
                                       else (if ((x : char) = #"6")
      then Inr (6 : IntInf.int)
      else (if ((x : char) = #"7") then Inr (7 : IntInf.int)
             else (if ((x : char) = #"8") then Inr (8 : IntInf.int)
                    else (if ((x : char) = #"9") then Inr (9 : IntInf.int)
                           else Inl ([x] @
                                      [#" ", #"i", #"s", #" ", #"n", #"o", #"t",
#" ", #"a", #" ", #"d", #"i", #"g", #"i", #"t"])))))))))));

fun string2int_aux n [] = Inr n
  | string2int_aux n (d :: s) =
    bindb (digit2int d) (fn m => string2int_aux ((10 : IntInf.int) * n + m) s);

fun string2int s =
  (if null s
    then Inl [#"c", #"a", #"n", #"n", #"o", #"t", #" ", #"c", #"o", #"n", #"v",
               #"e", #"r", #"t", #" ", #"e", #"m", #"p", #"t", #"y", #" ", #"s",
               #"t", #"r", #"i", #"n", #"g", #" ", #"i", #"n", #"t", #"o", #" ",
               #"n", #"u", #"m", #"b", #"e", #"r"]
    else (if equal_lista equal_char (take one_nata s) [#"-"]
           then bindb (string2int_aux (0 : IntInf.int) (tl s))
                  (fn i => Inr ((0 : IntInf.int) - i))
           else string2int_aux (0 : IntInf.int) s));

fun inta tag x = bindb (text tag x) string2int;

fun mapa f [] = []
  | mapa f (x :: xs) = f x :: mapa f xs;

fun sequence [] = Inr []
  | sequence (m :: ms) =
    bindb m (fn x => bindb (sequence ms) (fn xs => Inr (x :: xs)));

fun mapm f ms = sequence (mapa f ms);

fun map x = mapm x;

fun nata tag x =
  bindb (text tag x) (fn txt => bindb (string2int txt) (fn i => Inr (nat i)));

fun abs_int i = (if i < (0 : IntInf.int) then ~ i else i);

fun sgn_int i =
  (if i = (0 : IntInf.int) then (0 : IntInf.int)
    else (if (0 : IntInf.int) < i then (1 : IntInf.int)
           else ~ (1 : IntInf.int)));

fun apsnd f (x, y) = (x, f y);

fun divmod_int k l =
  (if k = (0 : IntInf.int) then ((0 : IntInf.int), (0 : IntInf.int))
    else (if l = (0 : IntInf.int) then ((0 : IntInf.int), k)
           else apsnd (fn a => sgn_int l * a)
                  (if sgn_int k = sgn_int l then Integer.div_mod (abs k) (abs l)
                    else let
                           val (r, s) = Integer.div_mod (abs k) (abs l);
                         in
                           (if s = (0 : IntInf.int) then (~ r, (0 : IntInf.int))
                             else (~ r - (1 : IntInf.int), abs_int l - s))
                         end)));

fun mod_int a b = snd (divmod_int a b);

fun gcd_int k l =
  abs_int
    (if l = (0 : IntInf.int) then k
      else gcd_int l (mod_int (abs_int k) (abs_int l)));

fun div_int a b = fst (divmod_int a b);

fun normalize p =
  (if (0 : IntInf.int) < snd p
    then let
           val a = gcd_int (fst p) (snd p);
         in
           (div_int (fst p) a, div_int (snd p) a)
         end
    else (if snd p = (0 : IntInf.int) then ((0 : IntInf.int), (1 : IntInf.int))
           else let
                  val a = ~ (gcd_int (fst p) (snd p));
                in
                  (div_int (fst p) a, div_int (snd p) a)
                end));

fun fract a b = Frct (normalize (a, b));

fun xml_change p f x = bindb (p x) (fn a => Inr (f a));

fun maps f [] = []
  | maps f (x :: xs) = f x @ maps f xs;

fun lookupa A_ uu [] = NONE
  | lookupa A_ aa ((a, b) :: xs) =
    (if eq A_ aa a then SOME b else lookupa A_ aa xs);

fun get_name (Xml (name, uu, uv, uw)) = name;

fun equal_list A_ = {equal = equal_lista A_} : ('a list) equal;

fun xml_options ps x =
  (case lookupa (equal_list equal_char) (get_name x) ps
    of NONE =>
      Inl (concat
            [[#"e", #"x", #"p", #"e", #"c", #"t", #"e", #"d", #" ", #"o", #"n",
               #"e", #" ", #"o", #"f", #":", #" "],
              maps (fn p => fst p @ [#" "]) ps, [newline],
              [#"b", #"u", #"t", #" ", #"f", #"o", #"u", #"n", #"d"], [newline],
              shows_prec_xml Zero_nat x []])
    | SOME p => p x);

fun nth (x :: xs) (Suc n) = nth xs n
  | nth (x :: xs) Zero_nat = x;

fun equal_nata (Suc nat) Zero_nat = false
  | equal_nata Zero_nat (Suc nat) = false
  | equal_nata (Suc nata) (Suc nat) = equal_nata nata nat
  | equal_nata Zero_nat Zero_nat = true;

fun plus_nata (Suc m) n = plus_nata m (Suc n)
  | plus_nata Zero_nat n = n;

fun size_list [] = Zero_nat
  | size_list (a :: lista) = plus_nata (size_list lista) (Suc Zero_nat);

fun no_transform tag xml =
  Inl (concat
        [[#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"t",
           #"r", #"a", #"n", #"s", #"f", #"o", #"r", #"m", #" ", #"t", #"h",
           #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w", #"i", #"n", #"g",
           #"\n", #" ", #" ", #" ", #" ", #" ", #"x", #"m", #"l", #" ", #"e",
           #"l", #"e", #"m", #"e", #"n", #"t", #" ", #"(", #"e", #"x", #"p",
           #"e", #"c", #"t", #"e", #"d", #" "],
          tag, [#")"], [newline], shows_prec_xml Zero_nat xml []]);

fun xml2elements tag p1 p2 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (equal_nata (size_list cs) (nat (2 : IntInf.int)) andalso
            is_none text))
    then bindb (p1 (nth cs Zero_nat))
           (fn x1 => bindb (p2 (nth cs one_nata)) (fn x2 => Inr (f x1 x2)))
    else no_transform tag (Xml (name, atts, cs, text)));

fun rat x =
  xml_options
    [([#"i", #"n", #"t", #"e", #"g", #"e", #"r"],
       xml_change (inta [#"i", #"n", #"t", #"e", #"g", #"e", #"r"])
         (fn xa => fract xa (1 : IntInf.int))),
      ([#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l"],
        xml2elements [#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l"]
          (inta [#"n", #"u", #"m", #"e", #"r", #"a", #"t", #"o", #"r"])
          (inta [#"d", #"e", #"n", #"o", #"m", #"i", #"n", #"a", #"t", #"o",
                  #"r"])
          fract)]
    x;

fun fold f [] = id
  | fold f (x :: xs) = fold f xs o f x;

fun rev xs = fold (fn a => fn b => a :: b) xs [];

fun inserta A_ y a x = eq A_ y x orelse a x;

type 'a bot = {order_bot : 'a order, bot : 'a};
val order_bot = #order_bot : 'a bot -> 'a order;
val bot = #bot : 'a bot -> 'a;

val bot_boola : bool = false;

fun less_bool true b = false
  | less_bool false b = b;

fun less_eq_bool true b = b
  | less_eq_bool false b = true;

val ord_bool = {less_eq = less_eq_bool, less = less_bool} : bool ord;

val preorder_bool = {ord_preorder = ord_bool} : bool preorder;

val order_bool = {preorder_order = preorder_bool} : bool order;

val bot_bool = {order_bot = order_bool, bot = bot_boola} : bool bot;

fun bot_fun B_ = (fn _ => bot B_);

fun set A_ [] = bot_fun bot_bool
  | set A_ (x :: xs) = inserta A_ x (set A_ xs);

fun less_nat m (Suc n) = less_eq_nat m n
  | less_nat n Zero_nat = false
and less_eq_nat (Suc m) n = less_nat m n
  | less_eq_nat Zero_nat n = true;

fun upt i j = (if less_nat i j then i :: upt (Suc i) j else []);

fun zip (x :: xs) (y :: ys) = (x, y) :: zip xs ys
  | zip xs [] = []
  | zip [] ys = [];

datatype ('a, 'b) term = Var of 'b | Fun of 'a * ('a, 'b) term list;

datatype ('a, 'b) ctxt = Hole |
  More of 'a * ('a, 'b) term list * ('a, 'b) ctxt * ('a, 'b) term list;

fun string2bool s =
  (if equal_lista equal_char s [#"t", #"r", #"u", #"e"] then Inr true
    else (if equal_lista equal_char s [#"f", #"a", #"l", #"s", #"e"]
           then Inr false
           else Inl ([#"c", #"a", #"n", #"n", #"o", #"t", #" ", #"c", #"o",
                       #"n", #"v", #"e", #"r", #"t", #" "] @
                      s @ [#" ", #"i", #"n", #"t", #"o", #" ", #"B", #"o", #"o",
                            #"l", #"e", #"a", #"n"])));

fun boola tag node = bindb (text tag node) string2bool;

fun drop n [] = []
  | drop n (x :: xs) = (case n of Zero_nat => x :: xs | Suc m => drop m xs);

fun last (x :: xs) = (if null xs then x else last xs);

datatype 'a itself = Type;

fun empty A_ = Rbt Emptya;

type 'a times = {times : 'a -> 'a -> 'a};
val times = #times : 'a times -> 'a -> 'a -> 'a;

type 'a dvd = {times_dvd : 'a times};
val times_dvd = #times_dvd : 'a dvd -> 'a times;

fun args (Var x) = []
  | args (Fun (f, ts)) = ts;

fun root (Var uu) = NONE
  | root (Fun (f, uv)) = SOME f;

fun membera A_ [] y = false
  | membera A_ (x :: xs) y = eq A_ x y orelse membera A_ xs y;

fun list_ex p [] = false
  | list_ex p (x :: xs) = p x orelse list_ex p xs;

fun equal_term A_ B_ = {equal = equal_terma A_ B_} : ('a, 'b) term equal
and equal_terma A_ B_ (Fun (f, lista)) (Var v) = false
  | equal_terma A_ B_ (Var v) (Fun (f, lista)) = false
  | equal_terma A_ B_ (Fun (fa, listaa)) (Fun (f, lista)) =
    eq A_ fa f andalso equal_lista (equal_term A_ B_) listaa lista
  | equal_terma A_ B_ (Var va) (Var v) = eq B_ va v;

fun supt_impl A_ B_ (Var x) t = false
  | supt_impl A_ B_ (Fun (f, ss)) t =
    membera (equal_term A_ B_) ss t orelse
      list_ex (fn s => supt_impl A_ B_ s t) ss;

fun supt A_ B_ = (fn (a, b) => supt_impl A_ B_ a b);

fun find uu [] = NONE
  | find p (x :: xs) = (if p x then SOME x else find p xs);

fun bind NONE f = NONE
  | bind (SOME x) f = f x;

fun mapM f [] = SOME []
  | mapM f (x :: xs) =
    bind (f x) (fn y => bind (mapM f xs) (fn ys => SOME (y :: ys)));

type 'a one = {one : 'a};
val one = #one : 'a one -> 'a;

val times_int = {times = (fn a => fn b => a * b)} : int times;

val dvd_int = {times_dvd = times_int} : int dvd;

val one_inta : int = (1 : IntInf.int);

val one_int = {one = one_inta} : int one;

val ord_int =
  {less_eq = (fn a => fn b => a <= b), less = (fn a => fn b => a < b)} :
  int ord;

fun foldl f a [] = a
  | foldl f a (x :: xs) = foldl f (f a x) xs;

fun vec n x = equal_nata (size_list x) n;

fun list_all p [] = true
  | list_all p (x :: xs) = p x andalso list_all p xs;

fun mat nr nc m = equal_nata (size_list m) nc andalso list_all (vec nr) m;

fun times_nata Zero_nat n = Zero_nat
  | times_nata (Suc m) n = plus_nata n (times_nata m n);

val times_nat = {times = times_nata} : nat times;

val dvd_nat = {times_dvd = times_nat} : nat dvd;

val one_nat = {one = one_nata} : nat one;

val ord_nat = {less_eq = less_eq_nat, less = less_nat} : nat ord;

fun impl_of A_ (Rbt x) = x;

fun balance (Branch (R, a, w, x, b)) s t (Branch (R, c, y, z, d)) =
  Branch (R, Branch (B, a, w, x, b), s, t, Branch (B, c, y, z, d))
  | balance (Branch (R, Branch (R, a, w, x, b), s, t, c)) y z Emptya =
    Branch (R, Branch (B, a, w, x, b), s, t, Branch (B, c, y, z, Emptya))
  | balance (Branch (R, Branch (R, a, w, x, b), s, t, c)) y z
    (Branch (B, va, vb, vc, vd)) =
    Branch
      (R, Branch (B, a, w, x, b), s, t,
        Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
  | balance (Branch (R, Emptya, w, x, Branch (R, b, s, t, c))) y z Emptya =
    Branch (R, Branch (B, Emptya, w, x, b), s, t, Branch (B, c, y, z, Emptya))
  | balance
    (Branch (R, Branch (B, va, vb, vc, vd), w, x, Branch (R, b, s, t, c))) y z
    Emptya =
    Branch
      (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
        Branch (B, c, y, z, Emptya))
  | balance (Branch (R, Emptya, w, x, Branch (R, b, s, t, c))) y z
    (Branch (B, va, vb, vc, vd)) =
    Branch
      (R, Branch (B, Emptya, w, x, b), s, t,
        Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
  | balance
    (Branch (R, Branch (B, ve, vf, vg, vh), w, x, Branch (R, b, s, t, c))) y z
    (Branch (B, va, vb, vc, vd)) =
    Branch
      (R, Branch (B, Branch (B, ve, vf, vg, vh), w, x, b), s, t,
        Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
  | balance Emptya w x (Branch (R, b, s, t, Branch (R, c, y, z, d))) =
    Branch (R, Branch (B, Emptya, w, x, b), s, t, Branch (B, c, y, z, d))
  | balance (Branch (B, va, vb, vc, vd)) w x
    (Branch (R, b, s, t, Branch (R, c, y, z, d))) =
    Branch
      (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
        Branch (B, c, y, z, d))
  | balance Emptya w x (Branch (R, Branch (R, b, s, t, c), y, z, Emptya)) =
    Branch (R, Branch (B, Emptya, w, x, b), s, t, Branch (B, c, y, z, Emptya))
  | balance Emptya w x
    (Branch (R, Branch (R, b, s, t, c), y, z, Branch (B, va, vb, vc, vd))) =
    Branch
      (R, Branch (B, Emptya, w, x, b), s, t,
        Branch (B, c, y, z, Branch (B, va, vb, vc, vd)))
  | balance (Branch (B, va, vb, vc, vd)) w x
    (Branch (R, Branch (R, b, s, t, c), y, z, Emptya)) =
    Branch
      (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
        Branch (B, c, y, z, Emptya))
  | balance (Branch (B, va, vb, vc, vd)) w x
    (Branch (R, Branch (R, b, s, t, c), y, z, Branch (B, ve, vf, vg, vh))) =
    Branch
      (R, Branch (B, Branch (B, va, vb, vc, vd), w, x, b), s, t,
        Branch (B, c, y, z, Branch (B, ve, vf, vg, vh)))
  | balance Emptya s t Emptya = Branch (B, Emptya, s, t, Emptya)
  | balance Emptya s t (Branch (B, va, vb, vc, vd)) =
    Branch (B, Emptya, s, t, Branch (B, va, vb, vc, vd))
  | balance Emptya s t (Branch (v, Emptya, vb, vc, Emptya)) =
    Branch (B, Emptya, s, t, Branch (v, Emptya, vb, vc, Emptya))
  | balance Emptya s t (Branch (v, Branch (B, ve, vf, vg, vh), vb, vc, Emptya))
    = Branch
        (B, Emptya, s, t,
          Branch (v, Branch (B, ve, vf, vg, vh), vb, vc, Emptya))
  | balance Emptya s t (Branch (v, Emptya, vb, vc, Branch (B, vf, vg, vh, vi)))
    = Branch
        (B, Emptya, s, t,
          Branch (v, Emptya, vb, vc, Branch (B, vf, vg, vh, vi)))
  | balance Emptya s t
    (Branch (v, Branch (B, ve, vj, vk, vl), vb, vc, Branch (B, vf, vg, vh, vi)))
    = Branch
        (B, Emptya, s, t,
          Branch
            (v, Branch (B, ve, vj, vk, vl), vb, vc, Branch (B, vf, vg, vh, vi)))
  | balance (Branch (B, va, vb, vc, vd)) s t Emptya =
    Branch (B, Branch (B, va, vb, vc, vd), s, t, Emptya)
  | balance (Branch (B, va, vb, vc, vd)) s t (Branch (B, ve, vf, vg, vh)) =
    Branch (B, Branch (B, va, vb, vc, vd), s, t, Branch (B, ve, vf, vg, vh))
  | balance (Branch (B, va, vb, vc, vd)) s t
    (Branch (v, Emptya, vf, vg, Emptya)) =
    Branch
      (B, Branch (B, va, vb, vc, vd), s, t, Branch (v, Emptya, vf, vg, Emptya))
  | balance (Branch (B, va, vb, vc, vd)) s t
    (Branch (v, Branch (B, vi, vj, vk, vl), vf, vg, Emptya)) =
    Branch
      (B, Branch (B, va, vb, vc, vd), s, t,
        Branch (v, Branch (B, vi, vj, vk, vl), vf, vg, Emptya))
  | balance (Branch (B, va, vb, vc, vd)) s t
    (Branch (v, Emptya, vf, vg, Branch (B, vj, vk, vl, vm))) =
    Branch
      (B, Branch (B, va, vb, vc, vd), s, t,
        Branch (v, Emptya, vf, vg, Branch (B, vj, vk, vl, vm)))
  | balance (Branch (B, va, vb, vc, vd)) s t
    (Branch (v, Branch (B, vi, vn, vo, vp), vf, vg, Branch (B, vj, vk, vl, vm)))
    = Branch
        (B, Branch (B, va, vb, vc, vd), s, t,
          Branch
            (v, Branch (B, vi, vn, vo, vp), vf, vg, Branch (B, vj, vk, vl, vm)))
  | balance (Branch (v, Emptya, vb, vc, Emptya)) s t Emptya =
    Branch (B, Branch (v, Emptya, vb, vc, Emptya), s, t, Emptya)
  | balance (Branch (v, Emptya, vb, vc, Branch (B, ve, vf, vg, vh))) s t Emptya
    = Branch
        (B, Branch (v, Emptya, vb, vc, Branch (B, ve, vf, vg, vh)), s, t,
          Emptya)
  | balance (Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Emptya)) s t Emptya
    = Branch
        (B, Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Emptya), s, t,
          Emptya)
  | balance
    (Branch (v, Branch (B, vf, vg, vh, vi), vb, vc, Branch (B, ve, vj, vk, vl)))
    s t Emptya =
    Branch
      (B, Branch
            (v, Branch (B, vf, vg, vh, vi), vb, vc, Branch (B, ve, vj, vk, vl)),
        s, t, Emptya)
  | balance (Branch (v, Emptya, vf, vg, Emptya)) s t
    (Branch (B, va, vb, vc, vd)) =
    Branch
      (B, Branch (v, Emptya, vf, vg, Emptya), s, t, Branch (B, va, vb, vc, vd))
  | balance (Branch (v, Emptya, vf, vg, Branch (B, vi, vj, vk, vl))) s t
    (Branch (B, va, vb, vc, vd)) =
    Branch
      (B, Branch (v, Emptya, vf, vg, Branch (B, vi, vj, vk, vl)), s, t,
        Branch (B, va, vb, vc, vd))
  | balance (Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Emptya)) s t
    (Branch (B, va, vb, vc, vd)) =
    Branch
      (B, Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Emptya), s, t,
        Branch (B, va, vb, vc, vd))
  | balance
    (Branch (v, Branch (B, vj, vk, vl, vm), vf, vg, Branch (B, vi, vn, vo, vp)))
    s t (Branch (B, va, vb, vc, vd)) =
    Branch
      (B, Branch
            (v, Branch (B, vj, vk, vl, vm), vf, vg, Branch (B, vi, vn, vo, vp)),
        s, t, Branch (B, va, vb, vc, vd));

fun ins A_ f k v Emptya = Branch (R, Emptya, k, v, Emptya)
  | ins A_ f k v (Branch (B, l, x, y, r)) =
    (if less ((ord_preorder o preorder_order o order_linorder) A_) k x
      then balance (ins A_ f k v l) x y r
      else (if less ((ord_preorder o preorder_order o order_linorder) A_) x k
             then balance l x y (ins A_ f k v r)
             else Branch (B, l, x, f k y v, r)))
  | ins A_ f k v (Branch (R, l, x, y, r)) =
    (if less ((ord_preorder o preorder_order o order_linorder) A_) k x
      then Branch (R, ins A_ f k v l, x, y, r)
      else (if less ((ord_preorder o preorder_order o order_linorder) A_) x k
             then Branch (R, l, x, y, ins A_ f k v r)
             else Branch (R, l, x, f k y v, r)));

fun paint c Emptya = Emptya
  | paint c (Branch (uu, l, k, v, r)) = Branch (c, l, k, v, r);

fun insert_with_key A_ f k v t = paint B (ins A_ f k v t);

fun insertc A_ = insert_with_key A_ (fn _ => fn _ => fn nv => nv);

fun insert A_ k v t = Rbt (insertc A_ k v (impl_of A_ t));

fun lookupc A_ Emptya k = NONE
  | lookupc A_ (Branch (uu, l, x, y, r)) k =
    (if less ((ord_preorder o preorder_order o order_linorder) A_) k x
      then lookupc A_ l k
      else (if less ((ord_preorder o preorder_order o order_linorder) A_) x k
             then lookupc A_ r k else SOME y));

fun lookup A_ t = lookupc A_ (impl_of A_ t);

fun quotient_of (Frct x) = x;

fun times_rata p q =
  Frct let
         val (a, c) = quotient_of p;
         val (b, d) = quotient_of q;
       in
         normalize (a * b, c * d)
       end;

val times_rat = {times = times_rata} : rat times;

val dvd_rat = {times_dvd = times_rat} : rat dvd;

val one_rata : rat = Frct (one_inta, one_inta);

val one_rat = {one = one_rata} : rat one;

fun less_rat p q =
  let
    val (a, c) = quotient_of p;
    val (b, d) = quotient_of q;
  in
    a * d < c * b
  end;

fun less_eq_rat p q =
  let
    val (a, c) = quotient_of p;
    val (b, d) = quotient_of q;
  in
    a * d <= c * b
  end;

val ord_rat = {less_eq = less_eq_rat, less = less_rat} : rat ord;

fun proja (Fun (f, ts)) i =
  (if less_nat i (size_list ts) then nth ts i else Fun (f, ts));

fun member x a = a x;

fun shows_between l p r = l o (p o r);

fun quote s =
  shows_between (shows_prec_char Zero_nat #"'") s
    (shows_prec_char Zero_nat #"'");

fun debug i t x = x;

type 'a diva = {dvd_div : 'a dvd, diva : 'a -> 'a -> 'a, moda : 'a -> 'a -> 'a};
val dvd_div = #dvd_div : 'a diva -> 'a dvd;
val diva = #diva : 'a diva -> 'a -> 'a -> 'a;
val moda = #moda : 'a diva -> 'a -> 'a -> 'a;

fun fun_upd A_ f a b = (fn x => (if eq A_ x a then b else f x));

type 'a plus = {plus : 'a -> 'a -> 'a};
val plus = #plus : 'a plus -> 'a -> 'a -> 'a;

type 'a zero = {zero : 'a};
val zero = #zero : 'a zero -> 'a;

val plus_int = {plus = (fn a => fn b => a + b)} : int plus;

val zero_inta : int = (0 : IntInf.int);

val zero_int = {zero = zero_inta} : int zero;

fun filter p [] = []
  | filter p (x :: xs) = (if p x then x :: filter p xs else filter p xs);

fun insertb A_ x xs = (if membera A_ xs x then xs else x :: xs);

val plus_nat = {plus = plus_nata} : nat plus;

val zero_nat = {zero = Zero_nat} : nat zero;

datatype pos = Empty | PCons of nat * pos;

type 'a power = {one_power : 'a one, times_power : 'a times};
val one_power = #one_power : 'a power -> 'a one;
val times_power = #times_power : 'a power -> 'a times;

fun powera one times a (Suc n) = times a (powera one times a n)
  | powera one times a Zero_nat = one;

fun power A_ = powera (one (one_power A_)) (times (times_power A_));

fun prc_nat pr =
  (fn f => fn n => fn g => fn m =>
    let
      val pf = pr f n;
      val pg = pr g m;
    in
      (less_nat pg pf, less_eq_nat pg pf)
    end);

fun prl_nat pr = (fn f => equal_nata (pr f Zero_nat) Zero_nat);

fun plus_rata p q =
  Frct let
         val (a, c) = quotient_of p;
         val (b, d) = quotient_of q;
       in
         normalize (a * d + b * c, c * d)
       end;

val plus_rat = {plus = plus_rata} : rat plus;

val zero_rata : rat = Frct (zero_inta, one_inta);

val zero_rat = {zero = zero_rata} : rat zero;

fun lterms pi =
  (fn Fun (f, ts) =>
    mapa (fn (i, a) => (proja (Fun (f, ts)) i, a)) (pi (f, size_list ts)));

fun is_var (Var uu) = true
  | is_var (Fun (uv, uw)) = false;

fun supteq A_ B_ =
  (fn (x, y) => equal_terma A_ B_ x y orelse supt_impl A_ B_ x y);

fun fun_of A_ vec x = the (lookupa A_ x vec);

val equal_int = {equal = (fn a => fn b => a = b)} : int equal;

val power_int = {one_power = one_int, times_power = times_int} : int power;

datatype ('a, 'b) lab = Lab of ('a, 'b) lab * 'b |
  FunLab of ('a, 'b) lab * ('a, 'b) lab list | UnLab of 'a |
  Sharp of ('a, 'b) lab;

fun remdups A_ [] = []
  | remdups A_ (x :: xs) =
    (if membera A_ xs x then remdups A_ xs else x :: remdups A_ xs);

fun remove1 A_ x [] = []
  | remove1 A_ x (y :: xs) = (if eq A_ x y then xs else y :: remove1 A_ x xs);

fun it_add update iterate m1 m2 = iterate update m2 m1;

fun vec0I ze n = replicate n ze;

fun mat0I ze nr nc = replicate nc (vec0I ze nr);

fun minus_nat (Suc m) (Suc n) = minus_nat m n
  | minus_nat Zero_nat n = Zero_nat
  | minus_nat m Zero_nat = m;

fun vec1I ze on n i =
  replicate i ze @ on :: replicate (minus_nat (minus_nat n one_nata) i) ze;

fun mat1I ze on n = mapa (vec1I ze on n) (upt Zero_nat n);

fun lm_store_acc A_ [] kv accu = kv :: accu
  | lm_store_acc A_ ((a, uu) :: reca) (k, v) accu =
    (case eq A_ k a of true => accu
      | false => lm_store_acc A_ reca (k, v) accu);

fun lm_store A_ m kv = lm_store_acc A_ m kv m;

fun l2m_store A_ B_ [] ((k1, k2), v) = [(k1, [(k2, v)])]
  | l2m_store A_ B_ ((a, kvs) :: reca) ((k1, k2), v) =
    (case eq A_ k1 a of true => (a, lm_store B_ kvs (k2, v)) :: reca
      | false => (a, kvs) :: l2m_store A_ B_ reca ((k1, k2), v));

datatype ('a, 'b, 'c, 'd) memory_ext =
  Memory_ext of
    (unit -> 'a) * ('a -> 'b -> 'c option) * ('a -> 'b * 'c -> 'a) * 'd;

fun l2m_lookup A_ B_ [] uu = NONE
  | l2m_lookup A_ B_ ((a, kvs) :: reca) (k1, k2) =
    (case eq A_ k1 a of true => lookupa B_ k2 kvs
      | false => l2m_lookup A_ B_ reca (k1, k2));

fun l2m A_ B_ =
  Memory_ext ((fn _ => []), l2m_lookup A_ B_, l2m_store A_ B_, ());

fun less_eq_prod_aux (A1_, A2_) B_ (a1, a2) (b1, b2) =
  less A2_ a1 b1 orelse eq A1_ a1 b1 andalso less_eq B_ a2 b2;

fun equal_proda A_ B_ (aa, ba) (a, b) = eq A_ aa a andalso eq B_ ba b;

fun less_prod (A1_, A2_) (B1_, B2_) a b =
  not (equal_proda A1_ B1_ a b) andalso less_eq_prod_aux (A1_, A2_) B2_ a b;

fun less_eq_prod (A1_, A2_) B_ a b = less_eq_prod_aux (A1_, A2_) B_ a b;

fun ord_prod (A1_, A2_) (B1_, B2_) =
  {less_eq = less_eq_prod (A1_, A2_) B2_,
    less = less_prod (A1_, A2_) (B1_, B2_)}
  : ('a * 'b) ord;

val equal_nat = {equal = equal_nata} : nat equal;

val preorder_nat = {ord_preorder = ord_nat} : nat preorder;

val order_nat = {preorder_order = preorder_nat} : nat order;

val power_nat = {one_power = one_nat, times_power = times_nat} : nat power;

fun equal_rata a b =
  equal_proda equal_int equal_int (quotient_of a) (quotient_of b);

val equal_rat = {equal = equal_rata} : rat equal;

val power_rat = {one_power = one_rat, times_power = times_rat} : rat power;

fun key (uu, (Fun (f, ts), uv)) = SOME (f, size_list ts)
  | key (uw, (Var ux, uy)) = NONE;

type 'a non_strict_order = {ge : 'a -> 'a -> bool};
val ge = #ge : 'a non_strict_order -> 'a -> 'a -> bool;

fun shows_sep s sep [] = shows_string []
  | shows_sep s sep [x] = s x
  | shows_sep s sep (x :: v :: va) = s x o (sep o shows_sep s sep (v :: va));

fun shows_list_gen elt e l s r xs =
  (if null xs then shows_string e
    else shows_between (shows_string l) (shows_sep elt (shows_string s) xs)
           (shows_string r));

fun shows_list_aux s xs = shows_list_gen s [#"[", #"]"] [#"["] [#","] [#"]"] xs;

fun divmod_nat m n =
  (if equal_nata n Zero_nat orelse less_nat m n then (Zero_nat, m)
    else let
           val (q, a) = divmod_nat (minus_nat m n) n;
         in
           (Suc q, a)
         end);

fun div_nata m n = fst (divmod_nat m n);

fun mod_nat m n = snd (divmod_nat m n);

fun digit2string n =
  (if equal_nata n Zero_nat then [#"0"]
    else (if equal_nata n one_nata then [#"1"]
           else (if equal_nata n (nat (2 : IntInf.int)) then [#"2"]
                  else (if equal_nata n (nat (3 : IntInf.int)) then [#"3"]
                         else (if equal_nata n (nat (4 : IntInf.int))
                                then [#"4"]
                                else (if equal_nata n (nat (5 : IntInf.int))
                                       then [#"5"]
                                       else (if equal_nata n
          (nat (6 : IntInf.int))
      then [#"6"]
      else (if equal_nata n (nat (7 : IntInf.int)) then [#"7"]
             else (if equal_nata n (nat (8 : IntInf.int)) then [#"8"]
                    else (if equal_nata n (nat (9 : IntInf.int)) then [#"9"]
                           else [#"n", #"o", #"t", #" ", #"a", #" ", #"d", #"i",
                                  #"g", #"i", #"t"]))))))))));

fun shows_nat n =
  (if less_nat n (nat (10 : IntInf.int)) then shows_string (digit2string n)
    else shows_nat (div_nata n (nat (10 : IntInf.int))) o
           shows_string (digit2string (mod_nat n (nat (10 : IntInf.int)))));

fun shows_prec_nat d n = shows_nat n;

fun shows_prec_int d i =
  (if i < (0 : IntInf.int)
    then shows_prec_char Zero_nat #"-" o
           shows_prec_nat Zero_nat (nat ((0 : IntInf.int) - i))
    else shows_prec_nat Zero_nat (nat i));

fun shows_list_int is = shows_list_aux (shows_prec_int Zero_nat) is;

val show_int = {shows_prec = shows_prec_int, shows_list = shows_list_int} :
  int show;

fun shows_list_nat ns = shows_list_aux (shows_prec_nat Zero_nat) ns;

val show_nat = {shows_prec = shows_prec_nat, shows_list = shows_list_nat} :
  nat show;

fun show_rata x =
  let
    val (den, num) = quotient_of x;
  in
    (if num = (1 : IntInf.int) then shows_prec_int Zero_nat den []
      else (shows_prec_int Zero_nat den o shows_prec_char Zero_nat #"/" o
             shows_prec_int Zero_nat num)
             [])
  end;

fun shows_prec_rat d x = shows_string (show_rata x);

fun shows_list_rat rs = shows_list_aux (shows_prec_rat Zero_nat) rs;

val show_rat = {shows_prec = shows_prec_rat, shows_list = shows_list_rat} :
  rat show;

fun subt_at s Empty = s
  | subt_at (Fun (f, ss)) (PCons (i, p)) = subt_at (nth ss i) p;

fun the_var (Var x) = x;

fun map_term funa (Var x) = Var x
  | map_term funa (Fun (f, ts)) = Fun (funa f, mapa (map_term funa) ts);

fun map_rule fg lr = (map_term fg (fst lr), map_term fg (snd lr));

fun extract p [] = NONE
  | extract p (x :: xs) =
    (if p x then SOME ([], (x, xs))
      else (case extract p xs of NONE => NONE
             | SOME (ys, (y, zs)) => SOME (x :: ys, (y, zs))));

fun distinct A_ [] = true
  | distinct A_ (x :: xs) = not (membera A_ xs x) andalso distinct A_ xs;

fun vec_comp_all r v w = list_all (fn (a, b) => r a b) (zip v w);

fun mat_comp_all r m1 m2 =
  list_all (fn (a, b) => vec_comp_all r a b) (zip m1 m2);

fun mat_ge A_ = mat_comp_all (ge A_);

fun maxa less_eq a b = (if less_eq a b then b else a);

fun max A_ = maxa (less_eq A_);

fun mina less_eq a b = (if less_eq a b then a else b);

fun min A_ = mina (less_eq A_);

type 'a top = {order_top : 'a order, top : 'a};
val order_top = #order_top : 'a top -> 'a order;
val top = #top : 'a top -> 'a;

fun minus_rat p q =
  Frct let
         val (a, c) = quotient_of p;
         val (b, d) = quotient_of q;
       in
         normalize (a * d - b * c, c * d)
       end;

fun shows_list_list A_ ls = shows_list_aux (shows_prec_list A_ Zero_nat) ls;

fun show_list A_ =
  {shows_prec = shows_prec_list A_, shows_list = shows_list_list A_} :
  ('a list) show;

fun shows_paren p =
  shows_prec_char Zero_nat #"(" o (p o shows_prec_char Zero_nat #")");

fun shows_prec_prod A_ B_ d p =
  shows_paren
    (shows_prec A_ Zero_nat (fst p) o
      (shows_prec_char Zero_nat #"," o shows_prec B_ Zero_nat (snd p)));

fun shows_list_prod A_ B_ ps =
  shows_list_aux (shows_prec_prod A_ B_ Zero_nat) ps;

fun show_prod A_ B_ =
  {shows_prec = shows_prec_prod A_ B_, shows_list = shows_list_prod A_ B_} :
  ('a * 'b) show;

fun shows_nl x = shows_prec_char Zero_nat newline x;

fun map_vars m (Var x) = Var (m x)
  | map_vars m (Fun (f, ts)) = Fun (f, mapa (map_vars m) ts);

fun num_args (Var x) = Zero_nat
  | num_args (Fun (f, ts)) = size_list ts;

fun unapp A_ a (Var x) = (Var x, [])
  | unapp A_ a (Fun (f, ss)) =
    (if eq A_ f a andalso equal_nata (size_list ss) (nat (2 : IntInf.int))
      then let
             val (r, ts) = unapp A_ a (nth ss Zero_nat);
           in
             (r, ts @ [nth ss one_nata])
           end
      else (Fun (f, ss), []));

fun max_list [] = Zero_nat
  | max_list (x :: xs) = max ord_nat x (max_list xs);

fun min_list A_ [x] = x
  | min_list A_ (x :: v :: va) =
    min ((ord_preorder o preorder_order o order_linorder) A_) x
      (min_list A_ (v :: va));

fun xml3elements tag p1 p2 p3 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (equal_nata (size_list cs) (nat (3 : IntInf.int)) andalso
            is_none text))
    then bindb (p1 (nth cs Zero_nat))
           (fn x1 =>
             bindb (p2 (nth cs one_nata))
               (fn x2 =>
                 bindb (p3 (nth cs (nat (2 : IntInf.int))))
                   (fn x3 => Inr (f x1 x2 x3))))
    else no_transform tag (Xml (name, atts, cs, text)));

fun position x =
  xml_change (nata [#"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n"])
    (fn n => minus_nat n one_nata) x;

fun xml_many_elements tag p f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso (null atts andalso is_none text)
    then bindb (map p cs) (Inr o f)
    else no_transform tag (Xml (name, atts, cs, text)));

datatype af_entry = Collapse of nat | AFList of nat list;

fun afs xml2name =
  xml_many_elements
    [#"a", #"r", #"g", #"u", #"m", #"e", #"n", #"t", #"F", #"i", #"l", #"t",
      #"e", #"r"]
    (xml3elements
      [#"a", #"r", #"g", #"u", #"m", #"e", #"n", #"t", #"F", #"i", #"l", #"t",
        #"e", #"r", #"E", #"n", #"t", #"r", #"y"]
      xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
      (xml_options
        [([#"c", #"o", #"l", #"l", #"a", #"p", #"s", #"i", #"n", #"g"],
           xml_change
             (nata [#"c", #"o", #"l", #"l", #"a", #"p", #"s", #"i", #"n", #"g"])
             (fn i => Collapse (minus_nat i one_nata))),
          ([#"n", #"o", #"n", #"C", #"o", #"l", #"l", #"a", #"p", #"s", #"i",
             #"n", #"g"],
            xml_many_elements
              [#"n", #"o", #"n", #"C", #"o", #"l", #"l", #"a", #"p", #"s", #"i",
                #"n", #"g"]
              position AFList)])
      (fn f => fn a => (fn b => ((f, a), b))))
    id;

fun list2position [] = Empty
  | list2position (n :: ns) = PCons (n, list2position ns);

fun pos x =
  xml_many_elements
    [#"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n", #"I", #"n", #"T", #"e",
      #"r", #"m"]
    position list2position x;

fun var x = bindb (text [#"v", #"a", #"r"] x) (Inr o Var);

fun xml1element tag p1 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (equal_nata (size_list cs) one_nata andalso is_none text))
    then bindb (p1 (nth cs Zero_nat)) (fn x1 => Inr (f x1))
    else no_transform tag (Xml (name, atts, cs, text)));

fun xml1many_elements_gen tag p1 p2 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso (is_none text andalso not (null cs)))
    then bindb (p1 (hd cs))
           (fn x => bindb (map (p2 x) (tl cs)) (fn xs => Inr (f x xs)))
    else no_transform tag (Xml (name, atts, cs, text)));

fun xml1many_elements tag p1 p2 = xml1many_elements_gen tag p1 (fn _ => p2);

fun term xml2name x =
  xml_options
    [([#"v", #"a", #"r"], var),
      ([#"f", #"u", #"n", #"a", #"p", #"p"],
        xml1many_elements [#"f", #"u", #"n", #"a", #"p", #"p"] xml2name
          (xml1element [#"a", #"r", #"g"] (term xml2name) id)
          (fn a => fn b => Fun (a, b)))]
    x;

fun rule xml2name =
  xml2elements [#"r", #"u", #"l", #"e"]
    (xml1element [#"l", #"h", #"s"] (term xml2name) id)
    (xml1element [#"r", #"h", #"s"] (term xml2name) id)
    (fn a => fn b => (a, b));

fun map_filter f [] = []
  | map_filter f (x :: xs) =
    (case f x of NONE => map_filter f xs | SOME y => y :: map_filter f xs);

fun scg_position x = nata [#"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n"] x;

fun scg xml2name =
  xml1many_elements
    [#"s", #"i", #"z", #"e", #"C", #"h", #"a", #"n", #"g", #"e", #"G", #"r",
      #"a", #"p", #"h"]
    (rule xml2name)
    (xml3elements [#"e", #"d", #"g", #"e"] scg_position
      (boola [#"s", #"t", #"r", #"i", #"c", #"t"]) scg_position
      (fn p => fn s => fn q => (s, (p, q))))
    (fn lr => fn edges =>
      (lr, (map_filter (fn x => (if fst x then SOME (snd x) else NONE)) edges,
             map_filter (fn x => (if not (fst x) then SOME (snd x) else NONE))
               edges)));

datatype 'a projL = Projection of ('a * nat) list;

datatype arithFun = Arg of nat | Const of nat | Sum of arithFun list |
  Max of arithFun list | Min of arithFun list | Prod of arithFun list;

datatype 'a sl_inter = SL_Inter of nat * (('a * nat) * arithFun) list;

datatype ('a, 'b) sl_variant = Rootlab of ('a * nat) option |
  Finitelab of 'a sl_inter | QuasiFinitelab of 'a sl_inter * 'b;

datatype arctic = MinInfty | Num_arc of int;

datatype arctic_rat = MinInfty_rat | Num_arc_rat of rat;

datatype 'a redtriple_impl = Int_carrier of (('a * nat) * (int * int list)) list
  | Int_nl_carrier of (('a * nat) * ((nat * nat) list * int) list) list |
  Rat_carrier of rat * (('a * nat) * (rat * rat list)) list |
  Rat_nl_carrier of rat * (('a * nat) * ((nat * nat) list * rat) list) list |
  Arctic_carrier of (('a * nat) * (arctic * arctic list)) list |
  Arctic_rat_carrier of rat * (('a * nat) * (arctic_rat * arctic_rat list)) list
  | Int_mat_carrier of
      nat * nat * (('a * nat) * ((int list) list * ((int list) list) list)) list
  | Rat_mat_carrier of
      rat * nat * nat *
        (('a * nat) * ((rat list) list * ((rat list) list) list)) list
  | Arc_mat_carrier of
      nat * (('a * nat) * ((arctic list) list * ((arctic list) list) list)) list
  | Arc_rat_mat_carrier of
      rat * nat *
        (('a * nat) *
          ((arctic_rat list) list * ((arctic_rat list) list) list)) list
  | Rpo of (('a * nat) * (nat * order_tag)) list * (('a * nat) * af_entry) list;

datatype list_order_type = MS_Ext | Max_Ext | Min_Ext;

datatype 'a root_redtriple_impl =
  Scnp of
    list_order_type * (('a * nat) * (nat * nat) list) list * 'a redtriple_impl;

datatype ('a, 'b, 'c) dp_proof = PisEmpty |
  SubtermCriterionProc of
    ('a, 'b) lab projL *
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
        (pos *
          (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
            (('a, 'b) lab, 'c) term)) list) list *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) dp_proof
  | RedPairProc of
      (('a, 'b) lab root_redtriple_impl, ('a, 'b) lab redtriple_impl) sum *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | RedPairUrProc of
      (('a, 'b) lab root_redtriple_impl, ('a, 'b) lab redtriple_impl) sum *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | DepGraphProc of
      (('a, 'b, 'c) dp_proof option *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list) list
  | MonoRedPairProc of
      ('a, 'b) lab redtriple_impl *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | MonoRedPairUrProc of
      ('a, 'b) lab redtriple_impl *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | SizeChangeSubterm of
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
        ((nat * nat) list * (nat * nat) list)) list
  | SizeChangeRedPair of
      ('a, 'b) lab redtriple_impl *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) *
          ((nat * nat) list * (nat * nat) list)) list
  | UncurryProc of
      nat option *
        (('a, 'b) lab *
          (((('a, 'b) lab * nat) * ('a, 'b) lab list) list *
            (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
              ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))) *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | FccProc of
      ('a, 'b) lab * (('a, 'b) lab, 'c) ctxt list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | SplitProc of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof * ('a, 'b, 'c) dp_proof
  | SemlabProc of
      (('a, 'b) lab, 'c) sl_variant *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (('a, 'b) lab, 'c) term list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | AssumeFinite of
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term list *
            (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
              ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))));

datatype ('a, 'b) strategy = No_Strategy | Innermost |
  Innermost_Q of ('a, 'b) term list;

datatype boundstype = Roof | Match;

datatype ('a, 'b) ta_rule = TA_rule of 'b * 'a list * 'a;

datatype ('a, 'b) tree_automaton =
  Tree_Automaton of 'a list * ('a, 'b) ta_rule list * ('a * 'a) list;

datatype ('a, 'b) bounds_info =
  Bounds_Info of boundstype * nat * 'b list * ('b, ('a * nat)) tree_automaton;

datatype ('a, 'b, 'c) trs_proof =
  DPTrans of
    ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) dp_proof
  | RuleRemoval of
      ('a, 'b) lab redtriple_impl *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) trs_proof
  | StringReversal of ('a, 'b, 'c) trs_proof |
  Bounds of (('a, 'b) lab, 'c) bounds_info |
  Uncurry of
    (('a, 'b) lab *
      (((('a, 'b) lab * nat) * ('a, 'b) lab list) list *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list))) *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) trs_proof
  | Semlab of
      (('a, 'b) lab, 'c) sl_variant * (('a, 'b) lab, 'c) term list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) trs_proof
  | RisEmpty |
  Fcc of
    (('a, 'b) lab, 'c) ctxt list *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      ('a, 'b, 'c) trs_proof
  | Split of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) trs_proof * ('a, 'b, 'c) trs_proof
  | AssumeSN of
      ((('a, 'b) lab, 'c) term list *
        (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
          ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list));

datatype ('a, 'b) dp_disproof =
  DP_Loop of
    ('a, 'b) term *
      (pos * ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
      ('b * ('a, 'b) term) list * ('a, 'b) ctxt
  | DP_Rule_Removal of
      (('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) dp_disproof;

datatype ('a, 'b) trs_disproof =
  TRS_Loop of
    ('a, 'b) term *
      (pos * ((('a, 'b) term * ('a, 'b) term) * ('a, 'b) term)) list *
      ('b * ('a, 'b) term) list * ('a, 'b) ctxt
  | TRS_Not_Well_Formed |
  TRS_Rule_Removal of
    (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) trs_disproof
  | TRS_String_Reversal of ('a, 'b) trs_disproof |
  TRS_DP_Trans of (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) dp_disproof;

datatype ('a, 'b) reltrs_disproof =
  Rel_Loop of
    ('a, 'b) term *
      (pos * ((('a, 'b) term * ('a, 'b) term) * (bool * ('a, 'b) term))) list *
      ('b * ('a, 'b) term) list * ('a, 'b) ctxt
  | Rel_Not_Well_Formed |
  Rel_Rule_Removal of
    (('a, 'b) term * ('a, 'b) term) list *
      (('a, 'b) term * ('a, 'b) term) list * ('a, 'b) reltrs_disproof
  | Rel_R_Not_SN of ('a, 'b) trs_disproof;

datatype ('a, 'b, 'c) cert_problem =
  TRS_Proof of
    (('a, 'b) lab, 'c) strategy *
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
      (((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list) option *
      ('a, 'b, 'c) trs_proof
  | DP_Proof of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (('a, 'b) lab, 'c) strategy *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ('a, 'b, 'c) dp_proof
  | DP_Disproof of
      ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (('a, 'b) lab, 'c) strategy *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (('a, 'b) lab, 'c) dp_disproof
  | TRS_Disproof of
      (('a, 'b) lab, 'c) strategy *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (('a, 'b) lab, 'c) trs_disproof
  | Rel_TRS_Disproof of
      (('a, 'b) lab, 'c) strategy *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        ((('a, 'b) lab, 'c) term * (('a, 'b) lab, 'c) term) list *
        (('a, 'b) lab, 'c) reltrs_disproof;

type 'a typerep = {typerepa : 'a itself -> Term.typ};
val typerepa = #typerepa : 'a typerep -> 'a itself -> Term.typ;

fun typerep_nata t = Term.Type ("Nat.nat", []);

val typerep_nat = {typerepa = typerep_nata} : nat typerep;

type 'a term_of = {typerep_term_of : 'a typerep, term_of : 'a -> Term.term};
val typerep_term_of = #typerep_term_of : 'a term_of -> 'a typerep;
val term_of = #term_of : 'a term_of -> 'a -> Term.term;

val div_nat = {dvd_div = dvd_nat, diva = div_nata, moda = mod_nat} : nat diva;

type 'a no_zero_divisors =
  {times_no_zero_divisors : 'a times, zero_no_zero_divisors : 'a zero};
val times_no_zero_divisors = #times_no_zero_divisors :
  'a no_zero_divisors -> 'a times;
val zero_no_zero_divisors = #zero_no_zero_divisors :
  'a no_zero_divisors -> 'a zero;

type 'a semigroup_mult = {times_semigroup_mult : 'a times};
val times_semigroup_mult = #times_semigroup_mult :
  'a semigroup_mult -> 'a times;

type 'a semigroup_add = {plus_semigroup_add : 'a plus};
val plus_semigroup_add = #plus_semigroup_add : 'a semigroup_add -> 'a plus;

type 'a ab_semigroup_add = {semigroup_add_ab_semigroup_add : 'a semigroup_add};
val semigroup_add_ab_semigroup_add = #semigroup_add_ab_semigroup_add :
  'a ab_semigroup_add -> 'a semigroup_add;

type 'a semiring =
  {ab_semigroup_add_semiring : 'a ab_semigroup_add,
    semigroup_mult_semiring : 'a semigroup_mult};
val ab_semigroup_add_semiring = #ab_semigroup_add_semiring :
  'a semiring -> 'a ab_semigroup_add;
val semigroup_mult_semiring = #semigroup_mult_semiring :
  'a semiring -> 'a semigroup_mult;

type 'a mult_zero = {times_mult_zero : 'a times, zero_mult_zero : 'a zero};
val times_mult_zero = #times_mult_zero : 'a mult_zero -> 'a times;
val zero_mult_zero = #zero_mult_zero : 'a mult_zero -> 'a zero;

type 'a monoid_add =
  {semigroup_add_monoid_add : 'a semigroup_add, zero_monoid_add : 'a zero};
val semigroup_add_monoid_add = #semigroup_add_monoid_add :
  'a monoid_add -> 'a semigroup_add;
val zero_monoid_add = #zero_monoid_add : 'a monoid_add -> 'a zero;

type 'a comm_monoid_add =
  {ab_semigroup_add_comm_monoid_add : 'a ab_semigroup_add,
    monoid_add_comm_monoid_add : 'a monoid_add};
val ab_semigroup_add_comm_monoid_add = #ab_semigroup_add_comm_monoid_add :
  'a comm_monoid_add -> 'a ab_semigroup_add;
val monoid_add_comm_monoid_add = #monoid_add_comm_monoid_add :
  'a comm_monoid_add -> 'a monoid_add;

type 'a semiring_0 =
  {comm_monoid_add_semiring_0 : 'a comm_monoid_add,
    mult_zero_semiring_0 : 'a mult_zero, semiring_semiring_0 : 'a semiring};
val comm_monoid_add_semiring_0 = #comm_monoid_add_semiring_0 :
  'a semiring_0 -> 'a comm_monoid_add;
val mult_zero_semiring_0 = #mult_zero_semiring_0 :
  'a semiring_0 -> 'a mult_zero;
val semiring_semiring_0 = #semiring_semiring_0 : 'a semiring_0 -> 'a semiring;

type 'a monoid_mult =
  {semigroup_mult_monoid_mult : 'a semigroup_mult,
    power_monoid_mult : 'a power};
val semigroup_mult_monoid_mult = #semigroup_mult_monoid_mult :
  'a monoid_mult -> 'a semigroup_mult;
val power_monoid_mult = #power_monoid_mult : 'a monoid_mult -> 'a power;

type 'a zero_neq_one = {one_zero_neq_one : 'a one, zero_zero_neq_one : 'a zero};
val one_zero_neq_one = #one_zero_neq_one : 'a zero_neq_one -> 'a one;
val zero_zero_neq_one = #zero_zero_neq_one : 'a zero_neq_one -> 'a zero;

type 'a semiring_1 =
  {monoid_mult_semiring_1 : 'a monoid_mult,
    semiring_0_semiring_1 : 'a semiring_0,
    zero_neq_one_semiring_1 : 'a zero_neq_one};
val monoid_mult_semiring_1 = #monoid_mult_semiring_1 :
  'a semiring_1 -> 'a monoid_mult;
val semiring_0_semiring_1 = #semiring_0_semiring_1 :
  'a semiring_1 -> 'a semiring_0;
val zero_neq_one_semiring_1 = #zero_neq_one_semiring_1 :
  'a semiring_1 -> 'a zero_neq_one;

type 'a ab_semigroup_mult =
  {semigroup_mult_ab_semigroup_mult : 'a semigroup_mult};
val semigroup_mult_ab_semigroup_mult = #semigroup_mult_ab_semigroup_mult :
  'a ab_semigroup_mult -> 'a semigroup_mult;

type 'a comm_semiring =
  {ab_semigroup_mult_comm_semiring : 'a ab_semigroup_mult,
    semiring_comm_semiring : 'a semiring};
val ab_semigroup_mult_comm_semiring = #ab_semigroup_mult_comm_semiring :
  'a comm_semiring -> 'a ab_semigroup_mult;
val semiring_comm_semiring = #semiring_comm_semiring :
  'a comm_semiring -> 'a semiring;

type 'a comm_semiring_0 =
  {comm_semiring_comm_semiring_0 : 'a comm_semiring,
    semiring_0_comm_semiring_0 : 'a semiring_0};
val comm_semiring_comm_semiring_0 = #comm_semiring_comm_semiring_0 :
  'a comm_semiring_0 -> 'a comm_semiring;
val semiring_0_comm_semiring_0 = #semiring_0_comm_semiring_0 :
  'a comm_semiring_0 -> 'a semiring_0;

type 'a comm_monoid_mult =
  {ab_semigroup_mult_comm_monoid_mult : 'a ab_semigroup_mult,
    monoid_mult_comm_monoid_mult : 'a monoid_mult};
val ab_semigroup_mult_comm_monoid_mult = #ab_semigroup_mult_comm_monoid_mult :
  'a comm_monoid_mult -> 'a ab_semigroup_mult;
val monoid_mult_comm_monoid_mult = #monoid_mult_comm_monoid_mult :
  'a comm_monoid_mult -> 'a monoid_mult;

type 'a comm_semiring_1 =
  {comm_monoid_mult_comm_semiring_1 : 'a comm_monoid_mult,
    comm_semiring_0_comm_semiring_1 : 'a comm_semiring_0,
    dvd_comm_semiring_1 : 'a dvd, semiring_1_comm_semiring_1 : 'a semiring_1};
val comm_monoid_mult_comm_semiring_1 = #comm_monoid_mult_comm_semiring_1 :
  'a comm_semiring_1 -> 'a comm_monoid_mult;
val comm_semiring_0_comm_semiring_1 = #comm_semiring_0_comm_semiring_1 :
  'a comm_semiring_1 -> 'a comm_semiring_0;
val dvd_comm_semiring_1 = #dvd_comm_semiring_1 : 'a comm_semiring_1 -> 'a dvd;
val semiring_1_comm_semiring_1 = #semiring_1_comm_semiring_1 :
  'a comm_semiring_1 -> 'a semiring_1;

type 'a cancel_semigroup_add =
  {semigroup_add_cancel_semigroup_add : 'a semigroup_add};
val semigroup_add_cancel_semigroup_add = #semigroup_add_cancel_semigroup_add :
  'a cancel_semigroup_add -> 'a semigroup_add;

type 'a cancel_ab_semigroup_add =
  {ab_semigroup_add_cancel_ab_semigroup_add : 'a ab_semigroup_add,
    cancel_semigroup_add_cancel_ab_semigroup_add : 'a cancel_semigroup_add};
val ab_semigroup_add_cancel_ab_semigroup_add =
  #ab_semigroup_add_cancel_ab_semigroup_add :
  'a cancel_ab_semigroup_add -> 'a ab_semigroup_add;
val cancel_semigroup_add_cancel_ab_semigroup_add =
  #cancel_semigroup_add_cancel_ab_semigroup_add :
  'a cancel_ab_semigroup_add -> 'a cancel_semigroup_add;

type 'a cancel_comm_monoid_add =
  {cancel_ab_semigroup_add_cancel_comm_monoid_add : 'a cancel_ab_semigroup_add,
    comm_monoid_add_cancel_comm_monoid_add : 'a comm_monoid_add};
val cancel_ab_semigroup_add_cancel_comm_monoid_add =
  #cancel_ab_semigroup_add_cancel_comm_monoid_add :
  'a cancel_comm_monoid_add -> 'a cancel_ab_semigroup_add;
val comm_monoid_add_cancel_comm_monoid_add =
  #comm_monoid_add_cancel_comm_monoid_add :
  'a cancel_comm_monoid_add -> 'a comm_monoid_add;

type 'a semiring_0_cancel =
  {cancel_comm_monoid_add_semiring_0_cancel : 'a cancel_comm_monoid_add,
    semiring_0_semiring_0_cancel : 'a semiring_0};
val cancel_comm_monoid_add_semiring_0_cancel =
  #cancel_comm_monoid_add_semiring_0_cancel :
  'a semiring_0_cancel -> 'a cancel_comm_monoid_add;
val semiring_0_semiring_0_cancel = #semiring_0_semiring_0_cancel :
  'a semiring_0_cancel -> 'a semiring_0;

type 'a semiring_1_cancel =
  {semiring_0_cancel_semiring_1_cancel : 'a semiring_0_cancel,
    semiring_1_semiring_1_cancel : 'a semiring_1};
val semiring_0_cancel_semiring_1_cancel = #semiring_0_cancel_semiring_1_cancel :
  'a semiring_1_cancel -> 'a semiring_0_cancel;
val semiring_1_semiring_1_cancel = #semiring_1_semiring_1_cancel :
  'a semiring_1_cancel -> 'a semiring_1;

type 'a comm_semiring_0_cancel =
  {comm_semiring_0_comm_semiring_0_cancel : 'a comm_semiring_0,
    semiring_0_cancel_comm_semiring_0_cancel : 'a semiring_0_cancel};
val comm_semiring_0_comm_semiring_0_cancel =
  #comm_semiring_0_comm_semiring_0_cancel :
  'a comm_semiring_0_cancel -> 'a comm_semiring_0;
val semiring_0_cancel_comm_semiring_0_cancel =
  #semiring_0_cancel_comm_semiring_0_cancel :
  'a comm_semiring_0_cancel -> 'a semiring_0_cancel;

type 'a comm_semiring_1_cancel =
  {comm_semiring_0_cancel_comm_semiring_1_cancel : 'a comm_semiring_0_cancel,
    comm_semiring_1_comm_semiring_1_cancel : 'a comm_semiring_1,
    semiring_1_cancel_comm_semiring_1_cancel : 'a semiring_1_cancel};
val comm_semiring_0_cancel_comm_semiring_1_cancel =
  #comm_semiring_0_cancel_comm_semiring_1_cancel :
  'a comm_semiring_1_cancel -> 'a comm_semiring_0_cancel;
val comm_semiring_1_comm_semiring_1_cancel =
  #comm_semiring_1_comm_semiring_1_cancel :
  'a comm_semiring_1_cancel -> 'a comm_semiring_1;
val semiring_1_cancel_comm_semiring_1_cancel =
  #semiring_1_cancel_comm_semiring_1_cancel :
  'a comm_semiring_1_cancel -> 'a semiring_1_cancel;

type 'a semiring_div =
  {div_semiring_div : 'a diva,
    comm_semiring_1_cancel_semiring_div : 'a comm_semiring_1_cancel,
    no_zero_divisors_semiring_div : 'a no_zero_divisors};
val div_semiring_div = #div_semiring_div : 'a semiring_div -> 'a diva;
val comm_semiring_1_cancel_semiring_div = #comm_semiring_1_cancel_semiring_div :
  'a semiring_div -> 'a comm_semiring_1_cancel;
val no_zero_divisors_semiring_div = #no_zero_divisors_semiring_div :
  'a semiring_div -> 'a no_zero_divisors;

val no_zero_divisors_nat =
  {times_no_zero_divisors = times_nat, zero_no_zero_divisors = zero_nat} :
  nat no_zero_divisors;

val semigroup_mult_nat = {times_semigroup_mult = times_nat} :
  nat semigroup_mult;

val semigroup_add_nat = {plus_semigroup_add = plus_nat} : nat semigroup_add;

val ab_semigroup_add_nat = {semigroup_add_ab_semigroup_add = semigroup_add_nat}
  : nat ab_semigroup_add;

val semiring_nat =
  {ab_semigroup_add_semiring = ab_semigroup_add_nat,
    semigroup_mult_semiring = semigroup_mult_nat}
  : nat semiring;

val mult_zero_nat = {times_mult_zero = times_nat, zero_mult_zero = zero_nat} :
  nat mult_zero;

val monoid_add_nat =
  {semigroup_add_monoid_add = semigroup_add_nat, zero_monoid_add = zero_nat} :
  nat monoid_add;

val comm_monoid_add_nat =
  {ab_semigroup_add_comm_monoid_add = ab_semigroup_add_nat,
    monoid_add_comm_monoid_add = monoid_add_nat}
  : nat comm_monoid_add;

val semiring_0_nat =
  {comm_monoid_add_semiring_0 = comm_monoid_add_nat,
    mult_zero_semiring_0 = mult_zero_nat, semiring_semiring_0 = semiring_nat}
  : nat semiring_0;

val monoid_mult_nat =
  {semigroup_mult_monoid_mult = semigroup_mult_nat,
    power_monoid_mult = power_nat}
  : nat monoid_mult;

val zero_neq_one_nat =
  {one_zero_neq_one = one_nat, zero_zero_neq_one = zero_nat} : nat zero_neq_one;

val semiring_1_nat =
  {monoid_mult_semiring_1 = monoid_mult_nat,
    semiring_0_semiring_1 = semiring_0_nat,
    zero_neq_one_semiring_1 = zero_neq_one_nat}
  : nat semiring_1;

val ab_semigroup_mult_nat =
  {semigroup_mult_ab_semigroup_mult = semigroup_mult_nat} :
  nat ab_semigroup_mult;

val comm_semiring_nat =
  {ab_semigroup_mult_comm_semiring = ab_semigroup_mult_nat,
    semiring_comm_semiring = semiring_nat}
  : nat comm_semiring;

val comm_semiring_0_nat =
  {comm_semiring_comm_semiring_0 = comm_semiring_nat,
    semiring_0_comm_semiring_0 = semiring_0_nat}
  : nat comm_semiring_0;

val comm_monoid_mult_nat =
  {ab_semigroup_mult_comm_monoid_mult = ab_semigroup_mult_nat,
    monoid_mult_comm_monoid_mult = monoid_mult_nat}
  : nat comm_monoid_mult;

val comm_semiring_1_nat =
  {comm_monoid_mult_comm_semiring_1 = comm_monoid_mult_nat,
    comm_semiring_0_comm_semiring_1 = comm_semiring_0_nat,
    dvd_comm_semiring_1 = dvd_nat, semiring_1_comm_semiring_1 = semiring_1_nat}
  : nat comm_semiring_1;

val cancel_semigroup_add_nat =
  {semigroup_add_cancel_semigroup_add = semigroup_add_nat} :
  nat cancel_semigroup_add;

val cancel_ab_semigroup_add_nat =
  {ab_semigroup_add_cancel_ab_semigroup_add = ab_semigroup_add_nat,
    cancel_semigroup_add_cancel_ab_semigroup_add = cancel_semigroup_add_nat}
  : nat cancel_ab_semigroup_add;

val cancel_comm_monoid_add_nat =
  {cancel_ab_semigroup_add_cancel_comm_monoid_add = cancel_ab_semigroup_add_nat,
    comm_monoid_add_cancel_comm_monoid_add = comm_monoid_add_nat}
  : nat cancel_comm_monoid_add;

val semiring_0_cancel_nat =
  {cancel_comm_monoid_add_semiring_0_cancel = cancel_comm_monoid_add_nat,
    semiring_0_semiring_0_cancel = semiring_0_nat}
  : nat semiring_0_cancel;

val semiring_1_cancel_nat =
  {semiring_0_cancel_semiring_1_cancel = semiring_0_cancel_nat,
    semiring_1_semiring_1_cancel = semiring_1_nat}
  : nat semiring_1_cancel;

val comm_semiring_0_cancel_nat =
  {comm_semiring_0_comm_semiring_0_cancel = comm_semiring_0_nat,
    semiring_0_cancel_comm_semiring_0_cancel = semiring_0_cancel_nat}
  : nat comm_semiring_0_cancel;

val comm_semiring_1_cancel_nat =
  {comm_semiring_0_cancel_comm_semiring_1_cancel = comm_semiring_0_cancel_nat,
    comm_semiring_1_comm_semiring_1_cancel = comm_semiring_1_nat,
    semiring_1_cancel_comm_semiring_1_cancel = semiring_1_cancel_nat}
  : nat comm_semiring_1_cancel;

val semiring_div_nat =
  {div_semiring_div = div_nat,
    comm_semiring_1_cancel_semiring_div = comm_semiring_1_cancel_nat,
    no_zero_divisors_semiring_div = no_zero_divisors_nat}
  : nat semiring_div;

fun term_of_num_semiring (A1_, A2_) two k =
  (if eq A2_ k
        (zero ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_semiring_1 o
                 semiring_1_comm_semiring_1 o
                 comm_semiring_1_comm_semiring_1_cancel o
                 comm_semiring_1_cancel_semiring_div)
                A1_))
    then Term.Const ("Int.Pls", Term.Type ("Int.int", []))
    else (if eq A2_ (moda (div_semiring_div A1_) k two)
               (zero ((zero_mult_zero o mult_zero_semiring_0 o
                        semiring_0_semiring_1 o semiring_1_comm_semiring_1 o
                        comm_semiring_1_comm_semiring_1_cancel o
                        comm_semiring_1_cancel_semiring_div)
                       A1_))
           then Term.$
                  (Term.Const
                     ("Int.Bit0", Term.Type
                                    ("fun", [Term.Type ("Int.int", []),
      Term.Type
        ("Int.int", [])])), term_of_num_semiring (A1_, A2_) two
                              (diva (div_semiring_div A1_) k two))
           else Term.$
                  (Term.Const
                     ("Int.Bit1", Term.Type
                                    ("fun", [Term.Type ("Int.int", []),
      Term.Type
        ("Int.int", [])])), term_of_num_semiring (A1_, A2_) two
                              (diva (div_semiring_div A1_) k two))));

fun term_of_nata n =
  Term.$
    (Term.Const
       ("Int.number_class.number_of", Term.Type
("fun", [Term.Type ("Int.int", []),
          Term.Type
            ("Nat.nat", [])])), term_of_num_semiring
                                  (semiring_div_nat, equal_nat)
                                  (nat (2 : IntInf.int)) n);

val term_of_nat = {typerep_term_of = typerep_nat, term_of = term_of_nata} :
  nat term_of;

fun typerep_chara t = Term.Type ("String.char", []);

val typerep_char = {typerepa = typerep_chara} : char typerep;

val term_of_char =
  {typerep_term_of = typerep_char,
    term_of = (fn a => HOLogic.mk_char (IntInf.fromInt (Char.ord a)))}
  : char term_of;

fun typerep_lista A_ t = Term.Type ("List.list", [typerepa A_ Type]);

fun typerep_list A_ = {typerepa = typerep_lista A_} : ('a list) typerep;

fun term_of_lista A_ (a :: b) =
  Term.$
    (Term.$
       (Term.Const
          ("List.list.Cons", Term.Type
                               ("fun", [typerepa (typerep_term_of A_) Type,
 Term.Type
   ("fun", [Term.Type ("List.list", [typerepa (typerep_term_of A_) Type]),
             Term.Type
               ("List.list", [typerepa (typerep_term_of A_)
                                Type])])])), term_of A_ a), term_of_lista A_ b)
  | term_of_lista A_ [] =
    Term.Const
      ("List.list.Nil", Term.Type
                          ("List.list", [typerepa (typerep_term_of A_) Type]));

fun term_of_list A_ =
  {typerep_term_of = typerep_list (typerep_term_of A_),
    term_of = term_of_lista A_}
  : ('a list) term_of;

fun term_of_sum A_ B_ (Inr a) =
  Term.$
    (Term.Const
       ("Sum_Type.Inr", Term.Type
                          ("fun", [typerepa (typerep_term_of B_) Type,
                                    Term.Type
                                      ("Sum_Type.sum", [typerepa
                  (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type])])), term_of B_ a)
  | term_of_sum A_ B_ (Inl a) =
    Term.$
      (Term.Const
         ("Sum_Type.Inl", Term.Type
                            ("fun", [typerepa (typerep_term_of A_) Type,
                                      Term.Type
("Sum_Type.sum", [typerepa (typerep_term_of A_) Type,
                   typerepa (typerep_term_of B_) Type])])), term_of A_ a);

fun typerep_cert_problema A_ B_ C_ t =
  Term.Type
    ("Proof_Checker.cert_problem", [typerepa A_ Type, typerepa B_ Type,
                                     typerepa C_ Type]);

fun typerep_cert_problem A_ B_ C_ = {typerepa = typerep_cert_problema A_ B_ C_}
  : ('a, 'b, 'c) cert_problem typerep;

fun typerep_terma A_ B_ t =
  Term.Type ("Term.term", [typerepa A_ Type, typerepa B_ Type]);

fun typerep_term A_ B_ = {typerepa = typerep_terma A_ B_} :
  ('a, 'b) term typerep;

fun term_of_term A_ B_ =
  {typerep_term_of = typerep_term (typerep_term_of A_) (typerep_term_of B_),
    term_of = term_of_terma A_ B_}
  : ('a, 'b) term term_of
and term_of_terma A_ B_ (Fun (a, b)) =
  Term.$
    (Term.$
       (Term.Const
          ("Term.term.Fun", Term.Type
                              ("fun", [typerepa (typerep_term_of A_) Type,
Term.Type
  ("fun", [Term.Type
             ("List.list", [Term.Type
                              ("Term.term", [typerepa (typerep_term_of A_) Type,
      typerepa (typerep_term_of B_) Type])]),
            Term.Type
              ("Term.term", [typerepa (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_)
                                Type])])])), term_of A_
       a), term_of_lista (term_of_term A_ B_) b)
  | term_of_terma A_ B_ (Var a) =
    Term.$
      (Term.Const
         ("Term.term.Var", Term.Type
                             ("fun", [typerepa (typerep_term_of B_) Type,
                                       Term.Type
 ("Term.term", [typerepa (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type])])), term_of B_ a);

fun typerep_laba A_ B_ t =
  Term.Type ("Labelings.lab", [typerepa A_ Type, typerepa B_ Type]);

fun typerep_lab A_ B_ = {typerepa = typerep_laba A_ B_} : ('a, 'b) lab typerep;

fun term_of_lab A_ B_ =
  {typerep_term_of = typerep_lab (typerep_term_of A_) (typerep_term_of B_),
    term_of = term_of_laba A_ B_}
  : ('a, 'b) lab term_of
and term_of_laba A_ B_ (Sharp a) =
  Term.$
    (Term.Const
       ("Labelings.lab.Sharp", Term.Type
                                 ("fun", [Term.Type
    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type]),
   Term.Type
     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                         typerepa (typerep_term_of B_)
                           Type])])), term_of_laba A_ B_ a)
  | term_of_laba A_ B_ (UnLab a) =
    Term.$
      (Term.Const
         ("Labelings.lab.UnLab", Term.Type
                                   ("fun", [typerepa (typerep_term_of A_) Type,
     Term.Type
       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_)
                             Type])])), term_of A_ a)
  | term_of_laba A_ B_ (FunLab (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Labelings.lab.FunLab", Term.Type
                                       ("fun", [Term.Type
          ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_) Type]),
         Term.Type
           ("fun", [Term.Type
                      ("List.list", [Term.Type
                                       ("Labelings.lab", [typerepa
                    (typerep_term_of A_) Type,
                   typerepa (typerep_term_of B_) Type])]),
                     Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_)
     Type])])])), term_of_laba A_ B_ a), term_of_lista (term_of_lab A_ B_) b)
  | term_of_laba A_ B_ (Lab (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Labelings.lab.Lab", Term.Type
                                    ("fun", [Term.Type
       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type]),
      Term.Type
        ("fun", [typerepa (typerep_term_of B_) Type,
                  Term.Type
                    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
typerepa (typerep_term_of B_) Type])])])), term_of_laba A_ B_ a), term_of B_ b);

fun typerep_proda A_ B_ t =
  Term.Type ("Product_Type.prod", [typerepa A_ Type, typerepa B_ Type]);

fun typerep_prod A_ B_ = {typerepa = typerep_proda A_ B_} : ('a * 'b) typerep;

fun term_of_proda A_ B_ (a, b) =
  Term.$
    (Term.$
       (Term.Const
          ("Product_Type.Pair", Term.Type
                                  ("fun", [typerepa (typerep_term_of A_) Type,
    Term.Type
      ("fun", [typerepa (typerep_term_of B_) Type,
                Term.Type
                  ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type])])])), term_of A_ a), term_of B_ b);

fun term_of_prod A_ B_ =
  {typerep_term_of = typerep_prod (typerep_term_of A_) (typerep_term_of B_),
    term_of = term_of_proda A_ B_}
  : ('a * 'b) term_of;

fun term_of_optiona A_ (SOME a) =
  Term.$
    (Term.Const
       ("Option.option.Some", Term.Type
                                ("fun", [typerepa (typerep_term_of A_) Type,
  Term.Type
    ("Option.option", [typerepa (typerep_term_of A_) Type])])), term_of A_ a)
  | term_of_optiona A_ NONE =
    Term.Const
      ("Option.option.None", Term.Type
                               ("Option.option", [typerepa (typerep_term_of A_)
            Type]));

fun typerep_ctxta A_ B_ t =
  Term.Type ("Term.ctxt", [typerepa A_ Type, typerepa B_ Type]);

fun typerep_ctxt A_ B_ = {typerepa = typerep_ctxta A_ B_} :
  ('a, 'b) ctxt typerep;

fun term_of_ctxta A_ B_ (More (a, b, c, d)) =
  Term.$
    (Term.$
       (Term.$
          (Term.$
             (Term.Const
                ("Term.ctxt.More", Term.Type
                                     ("fun", [typerepa (typerep_term_of A_)
        Type,
       Term.Type
         ("fun", [Term.Type
                    ("List.list", [Term.Type
                                     ("Term.term", [typerepa
              (typerep_term_of A_) Type,
             typerepa (typerep_term_of B_) Type])]),
                   Term.Type
                     ("fun", [Term.Type
                                ("Term.ctxt", [typerepa (typerep_term_of A_)
         Type,
        typerepa (typerep_term_of B_) Type]),
                               Term.Type
                                 ("fun", [Term.Type
    ("List.list", [Term.Type
                     ("Term.term", [typerepa (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_) Type])]),
   Term.Type
     ("Term.ctxt", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_)
                       Type])])])])])), term_of A_
  a), term_of_lista (term_of_term A_ B_)
        b), term_of_ctxta A_ B_ c), term_of_lista (term_of_term A_ B_) d)
  | term_of_ctxta A_ B_ Hole =
    Term.Const
      ("Term.ctxt.Hole", Term.Type
                           ("Term.ctxt", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]));

fun term_of_ctxt A_ B_ =
  {typerep_term_of = typerep_ctxt (typerep_term_of A_) (typerep_term_of B_),
    term_of = term_of_ctxta A_ B_}
  : ('a, 'b) ctxt term_of;

fun typerep_posa t = Term.Type ("Position.pos", []);

val typerep_pos = {typerepa = typerep_posa} : pos typerep;

fun term_of_posa (PCons (a, b)) =
  Term.$
    (Term.$
       (Term.Const
          ("Position.pos.PCons", Term.Type
                                   ("fun", [Term.Type ("Nat.nat", []),
     Term.Type
       ("fun", [Term.Type ("Position.pos", []),
                 Term.Type
                   ("Position.pos", [])])])), term_of_nata a), term_of_posa b)
  | term_of_posa Empty =
    Term.Const ("Position.pos.Empty", Term.Type ("Position.pos", []));

val term_of_pos = {typerep_term_of = typerep_pos, term_of = term_of_posa} :
  pos term_of;

fun typerep_optiona A_ t = Term.Type ("Option.option", [typerepa A_ Type]);

fun typerep_option A_ = {typerepa = typerep_optiona A_} : ('a option) typerep;

fun term_of_option A_ =
  {typerep_term_of = typerep_option (typerep_term_of A_),
    term_of = term_of_optiona A_}
  : ('a option) term_of;

fun typerep_dp_proofa A_ B_ C_ t =
  Term.Type
    ("Proof_Checker.dp_proof", [typerepa A_ Type, typerepa B_ Type,
                                 typerepa C_ Type]);

fun typerep_dp_proof A_ B_ C_ = {typerepa = typerep_dp_proofa A_ B_ C_} :
  ('a, 'b, 'c) dp_proof typerep;

fun term_of_projL A_ (Projection a) =
  Term.$
    (Term.Const
       ("Subterm_Criterion_Impl.projL.Projection", Term.Type
             ("fun", [Term.Type
                        ("List.list", [Term.Type
 ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                         Term.Type ("Nat.nat", [])])]),
                       Term.Type
                         ("Subterm_Criterion_Impl.projL", [typerepa
                     (typerep_term_of A_)
                     Type])])), term_of_lista (term_of_prod A_ term_of_nat) a);

fun typerep_arithFuna t = Term.Type ("Semantic_Labeling_Carrier.arithFun", []);

val typerep_arithFun = {typerepa = typerep_arithFuna} : arithFun typerep;

fun term_of_arithFun () =
  {typerep_term_of = typerep_arithFun, term_of = term_of_arithFuna} :
  arithFun term_of
and term_of_arithFuna (Prod a) =
  Term.$
    (Term.Const
       ("Semantic_Labeling_Carrier.arithFun.Prod", Term.Type
             ("fun", [Term.Type
                        ("List.list", [Term.Type
 ("Semantic_Labeling_Carrier.arithFun", [])]),
                       Term.Type
                         ("Semantic_Labeling_Carrier.arithFun", [])])), term_of_lista
                                  (term_of_arithFun ()) a)
  | term_of_arithFuna (Min a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.arithFun.Min", Term.Type
              ("fun", [Term.Type
                         ("List.list", [Term.Type
  ("Semantic_Labeling_Carrier.arithFun", [])]),
                        Term.Type
                          ("Semantic_Labeling_Carrier.arithFun", [])])), term_of_lista
                                   (term_of_arithFun ()) a)
  | term_of_arithFuna (Max a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.arithFun.Max", Term.Type
              ("fun", [Term.Type
                         ("List.list", [Term.Type
  ("Semantic_Labeling_Carrier.arithFun", [])]),
                        Term.Type
                          ("Semantic_Labeling_Carrier.arithFun", [])])), term_of_lista
                                   (term_of_arithFun ()) a)
  | term_of_arithFuna (Sum a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.arithFun.Sum", Term.Type
              ("fun", [Term.Type
                         ("List.list", [Term.Type
  ("Semantic_Labeling_Carrier.arithFun", [])]),
                        Term.Type
                          ("Semantic_Labeling_Carrier.arithFun", [])])), term_of_lista
                                   (term_of_arithFun ()) a)
  | term_of_arithFuna (Const a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.arithFun.Const", Term.Type
                ("fun", [Term.Type ("Nat.nat", []),
                          Term.Type
                            ("Semantic_Labeling_Carrier.arithFun", [])])), term_of_nata
                                     a)
  | term_of_arithFuna (Arg a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.arithFun.Arg", Term.Type
              ("fun", [Term.Type ("Nat.nat", []),
                        Term.Type
                          ("Semantic_Labeling_Carrier.arithFun", [])])), term_of_nata
                                   a);
val term_of_arithFun = term_of_arithFun ();

fun term_of_sl_inter A_ (SL_Inter (a, b)) =
  Term.$
    (Term.$
       (Term.Const
          ("Semantic_Labeling_Carrier.sl_inter.SL_Inter", Term.Type
                    ("fun", [Term.Type ("Nat.nat", []),
                              Term.Type
                                ("fun", [Term.Type
   ("List.list", [Term.Type
                    ("Product_Type.prod", [Term.Type
     ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                             Term.Type ("Nat.nat", [])]),
    Term.Type ("Semantic_Labeling_Carrier.arithFun", [])])]),
  Term.Type
    ("Semantic_Labeling_Carrier.sl_inter", [typerepa (typerep_term_of A_)
      Type])])])), term_of_nata
                     a), term_of_lista
                           (term_of_prod (term_of_prod A_ term_of_nat)
                             term_of_arithFun)
                           b);

fun term_of_sl_variant A_ B_ (QuasiFinitelab (a, b)) =
  Term.$
    (Term.$
       (Term.Const
          ("Semantic_Labeling_Carrier.sl_variant.QuasiFinitelab", Term.Type
                            ("fun", [Term.Type
                                       ("Semantic_Labeling_Carrier.sl_inter", [typerepa
 (typerep_term_of A_) Type]),
                                      Term.Type
("fun", [typerepa (typerep_term_of B_) Type,
          Term.Type
            ("Semantic_Labeling_Carrier.sl_variant", [typerepa
                (typerep_term_of A_) Type,
               typerepa (typerep_term_of B_)
                 Type])])])), term_of_sl_inter A_ a), term_of B_ b)
  | term_of_sl_variant A_ B_ (Finitelab a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.sl_variant.Finitelab", Term.Type
                      ("fun", [Term.Type
                                 ("Semantic_Labeling_Carrier.sl_inter", [typerepa
                                   (typerep_term_of A_) Type]),
                                Term.Type
                                  ("Semantic_Labeling_Carrier.sl_variant", [typerepa
                                      (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_)
                                       Type])])), term_of_sl_inter A_ a)
  | term_of_sl_variant A_ B_ (Rootlab a) =
    Term.$
      (Term.Const
         ("Semantic_Labeling_Carrier.sl_variant.Rootlab", Term.Type
                    ("fun", [Term.Type
                               ("Option.option", [Term.Type
            ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                                    Term.Type ("Nat.nat", [])])]),
                              Term.Type
                                ("Semantic_Labeling_Carrier.sl_variant", [typerepa
                                    (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_)
                                     Type])])), term_of_optiona
          (term_of_prod A_ term_of_nat) a);

fun typerep_redtriple_impla A_ t =
  Term.Type
    ("Reduction_Pair_Implementations.redtriple_impl", [typerepa A_ Type]);

fun typerep_redtriple_impl A_ = {typerepa = typerep_redtriple_impla A_} :
  'a redtriple_impl typerep;

fun typerep_rata t = Term.Type ("Rat.rat", []);

val typerep_rat = {typerepa = typerep_rata} : rat typerep;

fun typerep_inta t = Term.Type ("Int.int", []);

val typerep_int = {typerepa = typerep_inta} : int typerep;

val term_of_int =
  {typerep_term_of = typerep_int, term_of = HOLogic.mk_number HOLogic.intT} :
  int term_of;

fun term_of_rata x =
  Term.$
    (Term.Const
       ("Rat.Frct", Term.Type
                      ("fun", [Term.Type
                                 ("Product_Type.prod", [Term.Type
                  ("Int.int", []),
                 Term.Type ("Int.int", [])]),
                                Term.Type
                                  ("Rat.rat", [])])), term_of_proda term_of_int
                term_of_int (quotient_of x));

val term_of_rat = {typerep_term_of = typerep_rat, term_of = term_of_rata} :
  rat term_of;

fun typerep_order_taga t = Term.Type ("RPO.order_tag", []);

val typerep_order_tag = {typerepa = typerep_order_taga} : order_tag typerep;

fun term_of_order_taga Mul =
  Term.Const ("RPO.order_tag.Mul", Term.Type ("RPO.order_tag", []))
  | term_of_order_taga Lex =
    Term.Const ("RPO.order_tag.Lex", Term.Type ("RPO.order_tag", []));

val term_of_order_tag =
  {typerep_term_of = typerep_order_tag, term_of = term_of_order_taga} :
  order_tag term_of;

fun typerep_arctica t = Term.Type ("SN_Order_Carrier.arctic", []);

val typerep_arctic = {typerepa = typerep_arctica} : arctic typerep;

fun term_of_arctica (Num_arc a) =
  Term.$
    (Term.Const
       ("SN_Order_Carrier.arctic.Num_arc", Term.Type
     ("fun", [Term.Type ("Int.int", []),
               Term.Type
                 ("SN_Order_Carrier.arctic", [])])), HOLogic.mk_number
               HOLogic.intT
               a)
  | term_of_arctica MinInfty =
    Term.Const
      ("SN_Order_Carrier.arctic.MinInfty", Term.Type
     ("SN_Order_Carrier.arctic", []));

val term_of_arctic =
  {typerep_term_of = typerep_arctic, term_of = term_of_arctica} :
  arctic term_of;

fun typerep_af_entrya t = Term.Type ("Argument_Filter.af_entry", []);

val typerep_af_entry = {typerepa = typerep_af_entrya} : af_entry typerep;

fun term_of_af_entrya (AFList a) =
  Term.$
    (Term.Const
       ("Argument_Filter.af_entry.AFList", Term.Type
     ("fun", [Term.Type ("List.list", [Term.Type ("Nat.nat", [])]),
               Term.Type
                 ("Argument_Filter.af_entry", [])])), term_of_lista term_of_nat
                a)
  | term_of_af_entrya (Collapse a) =
    Term.$
      (Term.Const
         ("Argument_Filter.af_entry.Collapse", Term.Type
         ("fun", [Term.Type ("Nat.nat", []),
                   Term.Type
                     ("Argument_Filter.af_entry", [])])), term_of_nata a);

val term_of_af_entry =
  {typerep_term_of = typerep_af_entry, term_of = term_of_af_entrya} :
  af_entry term_of;

fun typerep_arctic_rata t = Term.Type ("SN_Order_Carrier.arctic_rat", []);

val typerep_arctic_rat = {typerepa = typerep_arctic_rata} : arctic_rat typerep;

fun term_of_arctic_rata (Num_arc_rat a) =
  Term.$
    (Term.Const
       ("SN_Order_Carrier.arctic_rat.Num_arc_rat", Term.Type
             ("fun", [Term.Type ("Rat.rat", []),
                       Term.Type
                         ("SN_Order_Carrier.arctic_rat", [])])), term_of_rata a)
  | term_of_arctic_rata MinInfty_rat =
    Term.Const
      ("SN_Order_Carrier.arctic_rat.MinInfty_rat", Term.Type
             ("SN_Order_Carrier.arctic_rat", []));

val term_of_arctic_rat =
  {typerep_term_of = typerep_arctic_rat, term_of = term_of_arctic_rata} :
  arctic_rat term_of;

fun term_of_redtriple_impla A_ (Rpo (a, b)) =
  Term.$
    (Term.$
       (Term.Const
          ("Reduction_Pair_Implementations.redtriple_impl.RPO", Term.Type
                          ("fun", [Term.Type
                                     ("List.list", [Term.Type
              ("Product_Type.prod", [Term.Type
                                       ("Product_Type.prod", [typerepa
                        (typerep_term_of A_) Type,
                       Term.Type ("Nat.nat", [])]),
                                      Term.Type
("Product_Type.prod", [Term.Type ("Nat.nat", []),
                        Term.Type ("RPO.order_tag", [])])])]),
                                    Term.Type
                                      ("fun", [Term.Type
         ("List.list", [Term.Type
                          ("Product_Type.prod", [Term.Type
           ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                                   Term.Type ("Nat.nat", [])]),
          Term.Type ("Argument_Filter.af_entry", [])])]),
        Term.Type
          ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                       (typerep_term_of A_)
                       Type])])])), term_of_lista
                                      (term_of_prod
(term_of_prod A_ term_of_nat) (term_of_prod term_of_nat term_of_order_tag))
                                      a), term_of_lista
    (term_of_prod (term_of_prod A_ term_of_nat) term_of_af_entry) b)
  | term_of_redtriple_impla A_ (Arc_rat_mat_carrier (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Reduction_Pair_Implementations.redtriple_impl.Arc_rat_mat_carrier", Term.Type
       ("fun", [Term.Type ("Rat.rat", []),
                 Term.Type
                   ("fun", [Term.Type ("Nat.nat", []),
                             Term.Type
                               ("fun", [Term.Type
  ("List.list", [Term.Type
                   ("Product_Type.prod", [Term.Type
    ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                            Term.Type ("Nat.nat", [])]),
   Term.Type
     ("Product_Type.prod", [Term.Type
                              ("List.list", [Term.Type
       ("List.list", [Term.Type ("SN_Order_Carrier.arctic_rat", [])])]),
                             Term.Type
                               ("List.list", [Term.Type
        ("List.list", [Term.Type
                         ("List.list", [Term.Type
  ("SN_Order_Carrier.arctic_rat", [])])])])])])]),
 Term.Type
   ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                (typerep_term_of A_)
                Type])])])])), term_of_rata
                                 a), term_of_nata
                                       b), term_of_lista
     (term_of_prod (term_of_prod A_ term_of_nat)
       (term_of_prod (term_of_list (term_of_list term_of_arctic_rat))
         (term_of_list (term_of_list (term_of_list term_of_arctic_rat)))))
     c)
  | term_of_redtriple_impla A_ (Arc_mat_carrier (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Reduction_Pair_Implementations.redtriple_impl.Arc_mat_carrier", Term.Type
("fun", [Term.Type ("Nat.nat", []),
          Term.Type
            ("fun", [Term.Type
                       ("List.list", [Term.Type
("Product_Type.prod", [Term.Type
                         ("Product_Type.prod", [typerepa (typerep_term_of A_)
          Type,
         Term.Type ("Nat.nat", [])]),
                        Term.Type
                          ("Product_Type.prod", [Term.Type
           ("List.list", [Term.Type
                            ("List.list", [Term.Type
     ("SN_Order_Carrier.arctic", [])])]),
          Term.Type
            ("List.list", [Term.Type
                             ("List.list", [Term.Type
      ("List.list", [Term.Type ("SN_Order_Carrier.arctic", [])])])])])])]),
                      Term.Type
                        ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                                     (typerep_term_of A_)
                                     Type])])])), term_of_nata
            a), term_of_lista
                  (term_of_prod (term_of_prod A_ term_of_nat)
                    (term_of_prod (term_of_list (term_of_list term_of_arctic))
                      (term_of_list
                        (term_of_list (term_of_list term_of_arctic)))))
                  b)
  | term_of_redtriple_impla A_ (Rat_mat_carrier (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Reduction_Pair_Implementations.redtriple_impl.Rat_mat_carrier", Term.Type
      ("fun", [Term.Type ("Rat.rat", []),
                Term.Type
                  ("fun", [Term.Type ("Nat.nat", []),
                            Term.Type
                              ("fun", [Term.Type ("Nat.nat", []),
Term.Type
  ("fun", [Term.Type
             ("List.list", [Term.Type
                              ("Product_Type.prod", [Term.Type
               ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                                       Term.Type ("Nat.nat", [])]),
              Term.Type
                ("Product_Type.prod", [Term.Type
 ("List.list", [Term.Type ("List.list", [Term.Type ("Rat.rat", [])])]),
Term.Type
  ("List.list", [Term.Type
                   ("List.list", [Term.Type
                                    ("List.list", [Term.Type
             ("Rat.rat", [])])])])])])]),
            Term.Type
              ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                           (typerep_term_of A_)
                           Type])])])])])), term_of_rata
      a), term_of_nata
            b), term_of_nata
                  c), term_of_lista
                        (term_of_prod (term_of_prod A_ term_of_nat)
                          (term_of_prod
                            (term_of_list (term_of_list term_of_rat))
                            (term_of_list
                              (term_of_list (term_of_list term_of_rat)))))
                        d)
  | term_of_redtriple_impla A_ (Int_mat_carrier (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Reduction_Pair_Implementations.redtriple_impl.Int_mat_carrier", Term.Type
   ("fun", [Term.Type ("Nat.nat", []),
             Term.Type
               ("fun", [Term.Type ("Nat.nat", []),
                         Term.Type
                           ("fun", [Term.Type
                                      ("List.list", [Term.Type
               ("Product_Type.prod", [Term.Type
("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                        Term.Type ("Nat.nat", [])]),
                                       Term.Type
 ("Product_Type.prod", [Term.Type
                          ("List.list", [Term.Type
   ("List.list", [Term.Type ("Int.int", [])])]),
                         Term.Type
                           ("List.list", [Term.Type
    ("List.list", [Term.Type
                     ("List.list", [Term.Type ("Int.int", [])])])])])])]),
                                     Term.Type
                                       ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
            (typerep_term_of A_)
            Type])])])])), term_of_nata
                             a), term_of_nata
                                   b), term_of_lista
 (term_of_prod (term_of_prod A_ term_of_nat)
   (term_of_prod (term_of_list (term_of_list term_of_int))
     (term_of_list (term_of_list (term_of_list term_of_int)))))
 c)
  | term_of_redtriple_impla A_ (Arctic_rat_carrier (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Reduction_Pair_Implementations.redtriple_impl.Arctic_rat_carrier", Term.Type
   ("fun", [Term.Type ("Rat.rat", []),
             Term.Type
               ("fun", [Term.Type
                          ("List.list", [Term.Type
   ("Product_Type.prod", [Term.Type
                            ("Product_Type.prod", [typerepa (typerep_term_of A_)
             Type,
            Term.Type ("Nat.nat", [])]),
                           Term.Type
                             ("Product_Type.prod", [Term.Type
              ("SN_Order_Carrier.arctic_rat", []),
             Term.Type
               ("List.list", [Term.Type
                                ("SN_Order_Carrier.arctic_rat", [])])])])]),
                         Term.Type
                           ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
(typerep_term_of A_)
Type])])])), term_of_rata
               a), term_of_lista
                     (term_of_prod (term_of_prod A_ term_of_nat)
                       (term_of_prod term_of_arctic_rat
                         (term_of_list term_of_arctic_rat)))
                     b)
  | term_of_redtriple_impla A_ (Arctic_carrier a) =
    Term.$
      (Term.Const
         ("Reduction_Pair_Implementations.redtriple_impl.Arctic_carrier", Term.Type
                                    ("fun", [Term.Type
       ("List.list", [Term.Type
                        ("Product_Type.prod", [Term.Type
         ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                                 Term.Type ("Nat.nat", [])]),
        Term.Type
          ("Product_Type.prod", [Term.Type ("SN_Order_Carrier.arctic", []),
                                  Term.Type
                                    ("List.list", [Term.Type
             ("SN_Order_Carrier.arctic", [])])])])]),
      Term.Type
        ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                     (typerep_term_of A_)
                     Type])])), term_of_lista
                                  (term_of_prod (term_of_prod A_ term_of_nat)
                                    (term_of_prod term_of_arctic
                                      (term_of_list term_of_arctic)))
                                  a)
  | term_of_redtriple_impla A_ (Rat_nl_carrier (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Reduction_Pair_Implementations.redtriple_impl.Rat_nl_carrier", Term.Type
                                       ("fun", [Term.Type ("Rat.rat", []),
         Term.Type
           ("fun", [Term.Type
                      ("List.list", [Term.Type
                                       ("Product_Type.prod", [Term.Type
                        ("Product_Type.prod", [typerepa (typerep_term_of A_)
         Type,
        Term.Type ("Nat.nat", [])]),
                       Term.Type
                         ("List.list", [Term.Type
  ("Product_Type.prod", [Term.Type
                           ("List.list", [Term.Type
    ("Product_Type.prod", [Term.Type ("Nat.nat", []),
                            Term.Type ("Nat.nat", [])])]),
                          Term.Type ("Rat.rat", [])])])])]),
                     Term.Type
                       ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                                    (typerep_term_of A_)
                                    Type])])])), term_of_rata
           a), term_of_lista
                 (term_of_prod (term_of_prod A_ term_of_nat)
                   (term_of_list
                     (term_of_prod
                       (term_of_list (term_of_prod term_of_nat term_of_nat))
                       term_of_rat)))
                 b)
  | term_of_redtriple_impla A_ (Rat_carrier (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Reduction_Pair_Implementations.redtriple_impl.Rat_carrier", Term.Type
                                    ("fun", [Term.Type ("Rat.rat", []),
      Term.Type
        ("fun", [Term.Type
                   ("List.list", [Term.Type
                                    ("Product_Type.prod", [Term.Type
                     ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
     Term.Type ("Nat.nat", [])]),
                    Term.Type
                      ("Product_Type.prod", [Term.Type ("Rat.rat", []),
      Term.Type ("List.list", [Term.Type ("Rat.rat", [])])])])]),
                  Term.Type
                    ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                                 (typerep_term_of A_)
                                 Type])])])), term_of_rata
        a), term_of_lista
              (term_of_prod (term_of_prod A_ term_of_nat)
                (term_of_prod term_of_rat (term_of_list term_of_rat)))
              b)
  | term_of_redtriple_impla A_ (Int_nl_carrier a) =
    Term.$
      (Term.Const
         ("Reduction_Pair_Implementations.redtriple_impl.Int_nl_carrier", Term.Type
                                    ("fun", [Term.Type
       ("List.list", [Term.Type
                        ("Product_Type.prod", [Term.Type
         ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                                 Term.Type ("Nat.nat", [])]),
        Term.Type
          ("List.list", [Term.Type
                           ("Product_Type.prod", [Term.Type
            ("List.list", [Term.Type
                             ("Product_Type.prod", [Term.Type ("Nat.nat", []),
             Term.Type ("Nat.nat", [])])]),
           Term.Type ("Int.int", [])])])])]),
      Term.Type
        ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                     (typerep_term_of A_)
                     Type])])), term_of_lista
                                  (term_of_prod (term_of_prod A_ term_of_nat)
                                    (term_of_list
                                      (term_of_prod
(term_of_list (term_of_prod term_of_nat term_of_nat)) term_of_int)))
                                  a)
  | term_of_redtriple_impla A_ (Int_carrier a) =
    Term.$
      (Term.Const
         ("Reduction_Pair_Implementations.redtriple_impl.Int_carrier", Term.Type
                                 ("fun", [Term.Type
    ("List.list", [Term.Type
                     ("Product_Type.prod", [Term.Type
      ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                              Term.Type ("Nat.nat", [])]),
     Term.Type
       ("Product_Type.prod", [Term.Type ("Int.int", []),
                               Term.Type
                                 ("List.list", [Term.Type
          ("Int.int", [])])])])]),
   Term.Type
     ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
                  (typerep_term_of A_)
                  Type])])), term_of_lista
                               (term_of_prod (term_of_prod A_ term_of_nat)
                                 (term_of_prod term_of_int
                                   (term_of_list term_of_int)))
                               a);

fun term_of_redtriple_impl A_ =
  {typerep_term_of = typerep_redtriple_impl (typerep_term_of A_),
    term_of = term_of_redtriple_impla A_}
  : 'a redtriple_impl term_of;

fun typerep_root_redtriple_impla A_ t =
  Term.Type
    ("Reduction_Pair_Implementations.root_redtriple_impl", [typerepa A_ Type]);

fun typerep_root_redtriple_impl A_ =
  {typerepa = typerep_root_redtriple_impla A_} : 'a root_redtriple_impl typerep;

fun term_of_list_order_type Min_Ext =
  Term.Const
    ("List_Order_Implementations.list_order_type.Min_Ext", Term.Type
                     ("List_Order_Implementations.list_order_type", []))
  | term_of_list_order_type Max_Ext =
    Term.Const
      ("List_Order_Implementations.list_order_type.Max_Ext", Term.Type
                       ("List_Order_Implementations.list_order_type", []))
  | term_of_list_order_type MS_Ext =
    Term.Const
      ("List_Order_Implementations.list_order_type.MS_Ext", Term.Type
                      ("List_Order_Implementations.list_order_type", []));

fun term_of_root_redtriple_impla A_ (Scnp (a, b, c)) =
  Term.$
    (Term.$
       (Term.$
          (Term.Const
             ("Reduction_Pair_Implementations.root_redtriple_impl.SCNP", Term.Type
                                   ("fun", [Term.Type
      ("List_Order_Implementations.list_order_type", []),
     Term.Type
       ("fun", [Term.Type
                  ("List.list", [Term.Type
                                   ("Product_Type.prod", [Term.Type
                    ("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
    Term.Type ("Nat.nat", [])]),
                   Term.Type
                     ("List.list", [Term.Type
                                      ("Product_Type.prod", [Term.Type
                       ("Nat.nat", []),
                      Term.Type ("Nat.nat", [])])])])]),
                 Term.Type
                   ("fun", [Term.Type
                              ("Reduction_Pair_Implementations.redtriple_impl", [typerepa
   (typerep_term_of A_) Type]),
                             Term.Type
                               ("Reduction_Pair_Implementations.root_redtriple_impl", [typerepa
         (typerep_term_of A_)
         Type])])])])), term_of_list_order_type
                          a), term_of_lista
                                (term_of_prod (term_of_prod A_ term_of_nat)
                                  (term_of_list
                                    (term_of_prod term_of_nat term_of_nat)))
                                b), term_of_redtriple_impla A_ c);

fun term_of_root_redtriple_impl A_ =
  {typerep_term_of = typerep_root_redtriple_impl (typerep_term_of A_),
    term_of = term_of_root_redtriple_impla A_}
  : 'a root_redtriple_impl term_of;

fun term_of_dp_proofa A_ B_ C_ (AssumeFinite a) =
  Term.$
    (Term.Const
       ("Proof_Checker.dp_proof.AssumeFinite", Term.Type
         ("fun", [Term.Type
                    ("Product_Type.prod", [Term.Type
     ("List.list", [Term.Type
                      ("Product_Type.prod", [Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type]),
      Term.Type
        ("Term.term", [Term.Type
                         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
     typerepa (typerep_term_of B_) Type]),
                        typerepa (typerep_term_of C_) Type])])]),
    Term.Type
      ("Product_Type.prod", [Term.Type
                               ("List.list", [Term.Type
        ("Product_Type.prod", [Term.Type
                                 ("Term.term", [Term.Type
          ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_) Type]),
         typerepa (typerep_term_of C_) Type]),
                                Term.Type
                                  ("Term.term", [Term.Type
           ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                               typerepa (typerep_term_of B_) Type]),
          typerepa (typerep_term_of C_) Type])])]),
                              Term.Type
                                ("Product_Type.prod", [Term.Type
                 ("List.list", [Term.Type
                                  ("Term.term", [Term.Type
           ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                               typerepa (typerep_term_of B_) Type]),
          typerepa (typerep_term_of C_) Type])]),
                Term.Type
                  ("Product_Type.prod", [Term.Type
   ("List.list", [Term.Type
                    ("Product_Type.prod", [Term.Type
     ("Term.term", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     typerepa (typerep_term_of C_) Type]),
    Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type])])]),
  Term.Type
    ("List.list", [Term.Type
                     ("Product_Type.prod", [Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type])])])])])])]),
                   Term.Type
                     ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type,
          typerepa (typerep_term_of C_)
            Type])])), term_of_proda
                         (term_of_list
                           (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                             (term_of_term (term_of_lab A_ B_) C_)))
                         (term_of_prod
                           (term_of_list
                             (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                               (term_of_term (term_of_lab A_ B_) C_)))
                           (term_of_prod
                             (term_of_list
                               (term_of_term (term_of_lab A_ B_) C_))
                             (term_of_prod
                               (term_of_list
                                 (term_of_prod
                                   (term_of_term (term_of_lab A_ B_) C_)
                                   (term_of_term (term_of_lab A_ B_) C_)))
                               (term_of_list
                                 (term_of_prod
                                   (term_of_term (term_of_lab A_ B_) C_)
                                   (term_of_term (term_of_lab A_ B_) C_))))))
                         a)
  | term_of_dp_proofa A_ B_ C_ (SemlabProc (a, b, c, d, e)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.$
                  (Term.Const
                     ("Proof_Checker.dp_proof.SemlabProc", Term.Type
                     ("fun", [Term.Type
                                ("Semantic_Labeling_Carrier.sl_variant", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                   typerepa (typerep_term_of C_) Type]),
                               Term.Type
                                 ("fun", [Term.Type
    ("List.list", [Term.Type
                     ("Product_Type.prod", [Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type])])]),
   Term.Type
     ("fun", [Term.Type
                ("List.list", [Term.Type
                                 ("Term.term", [Term.Type
          ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_) Type]),
         typerepa (typerep_term_of C_) Type])]),
               Term.Type
                 ("fun", [Term.Type
                            ("List.list", [Term.Type
     ("Product_Type.prod", [Term.Type
                              ("Term.term", [Term.Type
       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type]),
      typerepa (typerep_term_of C_) Type]),
                             Term.Type
                               ("Term.term", [Term.Type
        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                            typerepa (typerep_term_of B_) Type]),
       typerepa (typerep_term_of C_) Type])])]),
                           Term.Type
                             ("fun", [Term.Type
("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                             typerepa (typerep_term_of B_) Type,
                             typerepa (typerep_term_of C_) Type]),
                                       Term.Type
 ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_) Type,
                              typerepa (typerep_term_of C_)
                                Type])])])])])])), term_of_sl_variant
             (term_of_lab A_ B_) C_
             a), term_of_lista
                   (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                     (term_of_term (term_of_lab A_ B_) C_))
                   b), term_of_lista (term_of_term (term_of_lab A_ B_) C_)
                         c), term_of_lista
                               (term_of_prod
                                 (term_of_term (term_of_lab A_ B_) C_)
                                 (term_of_term (term_of_lab A_ B_) C_))
                               d), term_of_dp_proofa A_ B_ C_ e)
  | term_of_dp_proofa A_ B_ C_ (SplitProc (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.dp_proof.SplitProc", Term.Type
                 ("fun", [Term.Type
                            ("List.list", [Term.Type
     ("Product_Type.prod", [Term.Type
                              ("Term.term", [Term.Type
       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type]),
      typerepa (typerep_term_of C_) Type]),
                             Term.Type
                               ("Term.term", [Term.Type
        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                            typerepa (typerep_term_of B_) Type]),
       typerepa (typerep_term_of C_) Type])])]),
                           Term.Type
                             ("fun", [Term.Type
("List.list", [Term.Type
                 ("Product_Type.prod", [Term.Type
  ("Term.term", [Term.Type
                   ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_) Type]),
                  typerepa (typerep_term_of C_) Type]),
 Term.Type
   ("Term.term", [Term.Type
                    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
typerepa (typerep_term_of B_) Type]),
                   typerepa (typerep_term_of C_) Type])])]),
                                       Term.Type
 ("fun", [Term.Type
            ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
 typerepa (typerep_term_of B_) Type, typerepa (typerep_term_of C_) Type]),
           Term.Type
             ("fun", [Term.Type
                        ("Proof_Checker.dp_proof", [typerepa
              (typerep_term_of A_) Type,
             typerepa (typerep_term_of B_) Type,
             typerepa (typerep_term_of C_) Type]),
                       Term.Type
                         ("Proof_Checker.dp_proof", [typerepa
               (typerep_term_of A_) Type,
              typerepa (typerep_term_of B_) Type,
              typerepa (typerep_term_of C_)
                Type])])])])])), term_of_lista
                                   (term_of_prod
                                     (term_of_term (term_of_lab A_ B_) C_)
                                     (term_of_term (term_of_lab A_ B_) C_))
                                   a), term_of_lista
 (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
   (term_of_term (term_of_lab A_ B_) C_))
 b), term_of_dp_proofa A_ B_ C_ c), term_of_dp_proofa A_ B_ C_ d)
  | term_of_dp_proofa A_ B_ C_ (FccProc (a, b, c, d, e)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.$
                  (Term.Const
                     ("Proof_Checker.dp_proof.FccProc", Term.Type
                  ("fun", [Term.Type
                             ("Labelings.lab", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_) Type]),
                            Term.Type
                              ("fun", [Term.Type
 ("List.list", [Term.Type
                  ("Term.ctxt", [Term.Type
                                   ("Labelings.lab", [typerepa
                (typerep_term_of A_) Type,
               typerepa (typerep_term_of B_) Type]),
                                  typerepa (typerep_term_of C_) Type])]),
Term.Type
  ("fun", [Term.Type
             ("List.list", [Term.Type
                              ("Product_Type.prod", [Term.Type
               ("Term.term", [Term.Type
                                ("Labelings.lab", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type]),
                               typerepa (typerep_term_of C_) Type]),
              Term.Type
                ("Term.term", [Term.Type
                                 ("Labelings.lab", [typerepa
              (typerep_term_of A_) Type,
             typerepa (typerep_term_of B_) Type]),
                                typerepa (typerep_term_of C_) Type])])]),
            Term.Type
              ("fun", [Term.Type
                         ("List.list", [Term.Type
  ("Product_Type.prod", [Term.Type
                           ("Term.term", [Term.Type
    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type]),
   typerepa (typerep_term_of C_) Type]),
                          Term.Type
                            ("Term.term", [Term.Type
     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                         typerepa (typerep_term_of B_) Type]),
    typerepa (typerep_term_of C_) Type])])]),
                        Term.Type
                          ("fun", [Term.Type
                                     ("Proof_Checker.dp_proof", [typerepa
                           (typerep_term_of A_) Type,
                          typerepa (typerep_term_of B_) Type,
                          typerepa (typerep_term_of C_) Type]),
                                    Term.Type
                                      ("Proof_Checker.dp_proof", [typerepa
                            (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type,
                           typerepa (typerep_term_of C_)
                             Type])])])])])])), term_of_laba A_ B_
          a), term_of_lista (term_of_ctxt (term_of_lab A_ B_) C_)
                b), term_of_lista
                      (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                        (term_of_term (term_of_lab A_ B_) C_))
                      c), term_of_lista
                            (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                              (term_of_term (term_of_lab A_ B_) C_))
                            d), term_of_dp_proofa A_ B_ C_ e)
  | term_of_dp_proofa A_ B_ C_ (UncurryProc (a, b, c, d, e)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.$
                  (Term.Const
                     ("Proof_Checker.dp_proof.UncurryProc", Term.Type
                      ("fun", [Term.Type
                                 ("Option.option", [Term.Type ("Nat.nat", [])]),
                                Term.Type
                                  ("fun", [Term.Type
     ("Product_Type.prod", [Term.Type
                              ("Labelings.lab", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type]),
                             Term.Type
                               ("Product_Type.prod", [Term.Type
                ("List.list", [Term.Type
                                 ("Product_Type.prod", [Term.Type
                  ("Product_Type.prod", [Term.Type
   ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                       typerepa (typerep_term_of B_) Type]),
  Term.Type ("Nat.nat", [])]),
                 Term.Type
                   ("List.list", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type])])])]),
               Term.Type
                 ("Product_Type.prod", [Term.Type
  ("List.list", [Term.Type
                   ("Product_Type.prod", [Term.Type
    ("Term.term", [Term.Type
                     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
 typerepa (typerep_term_of B_) Type]),
                    typerepa (typerep_term_of C_) Type]),
   Term.Type
     ("Term.term", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     typerepa (typerep_term_of C_) Type])])]),
 Term.Type
   ("List.list", [Term.Type
                    ("Product_Type.prod", [Term.Type
     ("Term.term", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     typerepa (typerep_term_of C_) Type]),
    Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type])])])])])]),
    Term.Type
      ("fun", [Term.Type
                 ("List.list", [Term.Type
                                  ("Product_Type.prod", [Term.Type
                   ("Term.term", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                   typerepa (typerep_term_of C_) Type]),
                  Term.Type
                    ("Term.term", [Term.Type
                                     ("Labelings.lab", [typerepa
                  (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type]),
                                    typerepa (typerep_term_of C_) Type])])]),
                Term.Type
                  ("fun", [Term.Type
                             ("List.list", [Term.Type
      ("Product_Type.prod", [Term.Type
                               ("Term.term", [Term.Type
        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                            typerepa (typerep_term_of B_) Type]),
       typerepa (typerep_term_of C_) Type]),
                              Term.Type
                                ("Term.term", [Term.Type
         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                             typerepa (typerep_term_of B_) Type]),
        typerepa (typerep_term_of C_) Type])])]),
                            Term.Type
                              ("fun", [Term.Type
 ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_) Type,
                              typerepa (typerep_term_of C_) Type]),
Term.Type
  ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                               typerepa (typerep_term_of B_) Type,
                               typerepa (typerep_term_of C_)
                                 Type])])])])])])), term_of_optiona term_of_nat
              a), term_of_proda (term_of_lab A_ B_)
                    (term_of_prod
                      (term_of_list
                        (term_of_prod
                          (term_of_prod (term_of_lab A_ B_) term_of_nat)
                          (term_of_list (term_of_lab A_ B_))))
                      (term_of_prod
                        (term_of_list
                          (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                            (term_of_term (term_of_lab A_ B_) C_)))
                        (term_of_list
                          (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                            (term_of_term (term_of_lab A_ B_) C_)))))
                    b), term_of_lista
                          (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                            (term_of_term (term_of_lab A_ B_) C_))
                          c), term_of_lista
                                (term_of_prod
                                  (term_of_term (term_of_lab A_ B_) C_)
                                  (term_of_term (term_of_lab A_ B_) C_))
                                d), term_of_dp_proofa A_ B_ C_ e)
  | term_of_dp_proofa A_ B_ C_ (SizeChangeRedPair (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.dp_proof.SizeChangeRedPair", Term.Type
                      ("fun", [Term.Type
                                 ("Reduction_Pair_Implementations.redtriple_impl", [Term.Type
      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                          typerepa (typerep_term_of B_) Type])]),
                                Term.Type
                                  ("fun", [Term.Type
     ("List.list", [Term.Type
                      ("Product_Type.prod", [Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type]),
      Term.Type
        ("Term.term", [Term.Type
                         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
     typerepa (typerep_term_of B_) Type]),
                        typerepa (typerep_term_of C_) Type])])]),
    Term.Type
      ("fun", [Term.Type
                 ("List.list", [Term.Type
                                  ("Product_Type.prod", [Term.Type
                   ("Product_Type.prod", [Term.Type
    ("Term.term", [Term.Type
                     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
 typerepa (typerep_term_of B_) Type]),
                    typerepa (typerep_term_of C_) Type]),
   Term.Type
     ("Term.term", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     typerepa (typerep_term_of C_) Type])]),
                  Term.Type
                    ("Product_Type.prod", [Term.Type
     ("List.list", [Term.Type
                      ("Product_Type.prod", [Term.Type ("Nat.nat", []),
      Term.Type ("Nat.nat", [])])]),
    Term.Type
      ("List.list", [Term.Type
                       ("Product_Type.prod", [Term.Type ("Nat.nat", []),
       Term.Type ("Nat.nat", [])])])])])]),
                Term.Type
                  ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_)
        Type,
       typerepa (typerep_term_of B_) Type,
       typerepa (typerep_term_of C_)
         Type])])])])), term_of_redtriple_impla (term_of_lab A_ B_)
                          a), term_of_lista
                                (term_of_prod
                                  (term_of_term (term_of_lab A_ B_) C_)
                                  (term_of_term (term_of_lab A_ B_) C_))
                                b), term_of_lista
                                      (term_of_prod
(term_of_prod (term_of_term (term_of_lab A_ B_) C_)
  (term_of_term (term_of_lab A_ B_) C_))
(term_of_prod (term_of_list (term_of_prod term_of_nat term_of_nat))
  (term_of_list (term_of_prod term_of_nat term_of_nat))))
                                      c)
  | term_of_dp_proofa A_ B_ C_ (SizeChangeSubterm a) =
    Term.$
      (Term.Const
         ("Proof_Checker.dp_proof.SizeChangeSubterm", Term.Type
                ("fun", [Term.Type
                           ("List.list", [Term.Type
    ("Product_Type.prod", [Term.Type
                             ("Product_Type.prod", [Term.Type
              ("Term.term", [Term.Type
                               ("Labelings.lab", [typerepa (typerep_term_of A_)
            Type,
           typerepa (typerep_term_of B_) Type]),
                              typerepa (typerep_term_of C_) Type]),
             Term.Type
               ("Term.term", [Term.Type
                                ("Labelings.lab", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type]),
                               typerepa (typerep_term_of C_) Type])]),
                            Term.Type
                              ("Product_Type.prod", [Term.Type
               ("List.list", [Term.Type
                                ("Product_Type.prod", [Term.Type
                 ("Nat.nat", []),
                Term.Type ("Nat.nat", [])])]),
              Term.Type
                ("List.list", [Term.Type
                                 ("Product_Type.prod", [Term.Type
                  ("Nat.nat", []),
                 Term.Type ("Nat.nat", [])])])])])]),
                          Term.Type
                            ("Proof_Checker.dp_proof", [typerepa
                  (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type,
                 typerepa (typerep_term_of C_)
                   Type])])), term_of_lista
                                (term_of_prod
                                  (term_of_prod
                                    (term_of_term (term_of_lab A_ B_) C_)
                                    (term_of_term (term_of_lab A_ B_) C_))
                                  (term_of_prod
                                    (term_of_list
                                      (term_of_prod term_of_nat term_of_nat))
                                    (term_of_list
                                      (term_of_prod term_of_nat term_of_nat))))
                                a)
  | term_of_dp_proofa A_ B_ C_ (MonoRedPairUrProc (a, b, c, d, e)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.$
                  (Term.Const
                     ("Proof_Checker.dp_proof.MonoRedPairUrProc", Term.Type
                            ("fun", [Term.Type
                                       ("Reduction_Pair_Implementations.redtriple_impl", [Term.Type
            ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                typerepa (typerep_term_of B_) Type])]),
                                      Term.Type
("fun", [Term.Type
           ("List.list", [Term.Type
                            ("Product_Type.prod", [Term.Type
             ("Term.term", [Term.Type
                              ("Labelings.lab", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type]),
                             typerepa (typerep_term_of C_) Type]),
            Term.Type
              ("Term.term", [Term.Type
                               ("Labelings.lab", [typerepa (typerep_term_of A_)
            Type,
           typerepa (typerep_term_of B_) Type]),
                              typerepa (typerep_term_of C_) Type])])]),
          Term.Type
            ("fun", [Term.Type
                       ("List.list", [Term.Type
("Product_Type.prod", [Term.Type
                         ("Term.term", [Term.Type
  ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                      typerepa (typerep_term_of B_) Type]),
 typerepa (typerep_term_of C_) Type]),
                        Term.Type
                          ("Term.term", [Term.Type
   ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                       typerepa (typerep_term_of B_) Type]),
  typerepa (typerep_term_of C_) Type])])]),
                      Term.Type
                        ("fun", [Term.Type
                                   ("List.list", [Term.Type
            ("Product_Type.prod", [Term.Type
                                     ("Term.term", [Term.Type
              ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                  typerepa (typerep_term_of B_) Type]),
             typerepa (typerep_term_of C_) Type]),
                                    Term.Type
                                      ("Term.term", [Term.Type
               ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type]),
              typerepa (typerep_term_of C_) Type])])]),
                                  Term.Type
                                    ("fun", [Term.Type
       ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type,
                                    typerepa (typerep_term_of C_) Type]),
      Term.Type
        ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_) Type,
                                     typerepa (typerep_term_of C_)
                                       Type])])])])])])), term_of_redtriple_impla
                    (term_of_lab A_ B_)
                    a), term_of_lista
                          (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                            (term_of_term (term_of_lab A_ B_) C_))
                          b), term_of_lista
                                (term_of_prod
                                  (term_of_term (term_of_lab A_ B_) C_)
                                  (term_of_term (term_of_lab A_ B_) C_))
                                c), term_of_lista
                                      (term_of_prod
(term_of_term (term_of_lab A_ B_) C_) (term_of_term (term_of_lab A_ B_) C_))
                                      d), term_of_dp_proofa A_ B_ C_ e)
  | term_of_dp_proofa A_ B_ C_ (MonoRedPairProc (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.dp_proof.MonoRedPairProc", Term.Type
                       ("fun", [Term.Type
                                  ("Reduction_Pair_Implementations.redtriple_impl", [Term.Type
       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type])]),
                                 Term.Type
                                   ("fun", [Term.Type
      ("List.list", [Term.Type
                       ("Product_Type.prod", [Term.Type
        ("Term.term", [Term.Type
                         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
     typerepa (typerep_term_of B_) Type]),
                        typerepa (typerep_term_of C_) Type]),
       Term.Type
         ("Term.term", [Term.Type
                          ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
      typerepa (typerep_term_of B_) Type]),
                         typerepa (typerep_term_of C_) Type])])]),
     Term.Type
       ("fun", [Term.Type
                  ("List.list", [Term.Type
                                   ("Product_Type.prod", [Term.Type
                    ("Term.term", [Term.Type
                                     ("Labelings.lab", [typerepa
                  (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type]),
                                    typerepa (typerep_term_of C_) Type]),
                   Term.Type
                     ("Term.term", [Term.Type
                                      ("Labelings.lab", [typerepa
                   (typerep_term_of A_) Type,
                  typerepa (typerep_term_of B_) Type]),
                                     typerepa (typerep_term_of C_) Type])])]),
                 Term.Type
                   ("fun", [Term.Type
                              ("Proof_Checker.dp_proof", [typerepa
                    (typerep_term_of A_) Type,
                   typerepa (typerep_term_of B_) Type,
                   typerepa (typerep_term_of C_) Type]),
                             Term.Type
                               ("Proof_Checker.dp_proof", [typerepa
                     (typerep_term_of A_) Type,
                    typerepa (typerep_term_of B_) Type,
                    typerepa (typerep_term_of C_)
                      Type])])])])])), term_of_redtriple_impla
 (term_of_lab A_ B_)
 a), term_of_lista
       (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
         (term_of_term (term_of_lab A_ B_) C_))
       b), term_of_lista
             (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
               (term_of_term (term_of_lab A_ B_) C_))
             c), term_of_dp_proofa A_ B_ C_ d)
  | term_of_dp_proofa A_ B_ C_ (DepGraphProc a) =
    Term.$
      (Term.Const
         ("Proof_Checker.dp_proof.DepGraphProc", Term.Type
           ("fun", [Term.Type
                      ("List.list", [Term.Type
                                       ("Product_Type.prod", [Term.Type
                        ("Option.option", [Term.Type
     ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                                  typerepa (typerep_term_of B_) Type,
                                  typerepa (typerep_term_of C_) Type])]),
                       Term.Type
                         ("List.list", [Term.Type
  ("Product_Type.prod", [Term.Type
                           ("Term.term", [Term.Type
    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type]),
   typerepa (typerep_term_of C_) Type]),
                          Term.Type
                            ("Term.term", [Term.Type
     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                         typerepa (typerep_term_of B_) Type]),
    typerepa (typerep_term_of C_) Type])])])])]),
                     Term.Type
                       ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type,
            typerepa (typerep_term_of C_)
              Type])])), term_of_lista
                           (term_of_prod
                             (term_of_option (term_of_dp_proof A_ B_ C_))
                             (term_of_list
                               (term_of_prod
                                 (term_of_term (term_of_lab A_ B_) C_)
                                 (term_of_term (term_of_lab A_ B_) C_))))
                           a)
  | term_of_dp_proofa A_ B_ C_ (RedPairUrProc (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.dp_proof.RedPairUrProc", Term.Type
                     ("fun", [Term.Type
                                ("Sum_Type.sum", [Term.Type
            ("Reduction_Pair_Implementations.root_redtriple_impl", [Term.Type
                              ("Labelings.lab", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type])]),
           Term.Type
             ("Reduction_Pair_Implementations.redtriple_impl", [Term.Type
                          ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
      typerepa (typerep_term_of B_) Type])])]),
                               Term.Type
                                 ("fun", [Term.Type
    ("List.list", [Term.Type
                     ("Product_Type.prod", [Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type])])]),
   Term.Type
     ("fun", [Term.Type
                ("List.list", [Term.Type
                                 ("Product_Type.prod", [Term.Type
                  ("Term.term", [Term.Type
                                   ("Labelings.lab", [typerepa
                (typerep_term_of A_) Type,
               typerepa (typerep_term_of B_) Type]),
                                  typerepa (typerep_term_of C_) Type]),
                 Term.Type
                   ("Term.term", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                   typerepa (typerep_term_of C_) Type])])]),
               Term.Type
                 ("fun", [Term.Type
                            ("Proof_Checker.dp_proof", [typerepa
                  (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type,
                 typerepa (typerep_term_of C_) Type]),
                           Term.Type
                             ("Proof_Checker.dp_proof", [typerepa
                   (typerep_term_of A_) Type,
                  typerepa (typerep_term_of B_) Type,
                  typerepa (typerep_term_of C_)
                    Type])])])])])), term_of_sum
                                       (term_of_root_redtriple_impl
 (term_of_lab A_ B_))
                                       (term_of_redtriple_impl
 (term_of_lab A_ B_))
                                       a), term_of_lista
     (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
       (term_of_term (term_of_lab A_ B_) C_))
     b), term_of_lista
           (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
             (term_of_term (term_of_lab A_ B_) C_))
           c), term_of_dp_proofa A_ B_ C_ d)
  | term_of_dp_proofa A_ B_ C_ (RedPairProc (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.dp_proof.RedPairProc", Term.Type
                ("fun", [Term.Type
                           ("Sum_Type.sum", [Term.Type
       ("Reduction_Pair_Implementations.root_redtriple_impl", [Term.Type
                         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
     typerepa (typerep_term_of B_) Type])]),
      Term.Type
        ("Reduction_Pair_Implementations.redtriple_impl", [Term.Type
                     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
 typerepa (typerep_term_of B_) Type])])]),
                          Term.Type
                            ("fun", [Term.Type
                                       ("List.list", [Term.Type
                ("Product_Type.prod", [Term.Type
 ("Term.term", [Term.Type
                  ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                      typerepa (typerep_term_of B_) Type]),
                 typerepa (typerep_term_of C_) Type]),
Term.Type
  ("Term.term", [Term.Type
                   ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_) Type]),
                  typerepa (typerep_term_of C_) Type])])]),
                                      Term.Type
("fun", [Term.Type
           ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
typerepa (typerep_term_of B_) Type, typerepa (typerep_term_of C_) Type]),
          Term.Type
            ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
 typerepa (typerep_term_of B_) Type,
 typerepa (typerep_term_of C_)
   Type])])])])), term_of_sum (term_of_root_redtriple_impl (term_of_lab A_ B_))
                    (term_of_redtriple_impl (term_of_lab A_ B_))
                    a), term_of_lista
                          (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                            (term_of_term (term_of_lab A_ B_) C_))
                          b), term_of_dp_proofa A_ B_ C_ c)
  | term_of_dp_proofa A_ B_ C_ (SubtermCriterionProc (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.dp_proof.SubtermCriterionProc", Term.Type
                            ("fun", [Term.Type
                                       ("Subterm_Criterion_Impl.projL", [Term.Type
                                   ("Labelings.lab", [typerepa
                (typerep_term_of A_) Type,
               typerepa (typerep_term_of B_) Type])]),
                                      Term.Type
("fun", [Term.Type
           ("List.list", [Term.Type
                            ("Product_Type.prod", [Term.Type
             ("Product_Type.prod", [Term.Type
                                      ("Term.term", [Term.Type
               ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type]),
              typerepa (typerep_term_of C_) Type]),
                                     Term.Type
                                       ("Term.term", [Term.Type
                ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]),
               typerepa (typerep_term_of C_) Type])]),
            Term.Type
              ("List.list", [Term.Type
                               ("Product_Type.prod", [Term.Type
                ("Position.pos", []),
               Term.Type
                 ("Product_Type.prod", [Term.Type
  ("Product_Type.prod", [Term.Type
                           ("Term.term", [Term.Type
    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type]),
   typerepa (typerep_term_of C_) Type]),
                          Term.Type
                            ("Term.term", [Term.Type
     ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                         typerepa (typerep_term_of B_) Type]),
    typerepa (typerep_term_of C_) Type])]),
 Term.Type
   ("Term.term", [Term.Type
                    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
typerepa (typerep_term_of B_) Type]),
                   typerepa (typerep_term_of C_) Type])])])])])]),
          Term.Type
            ("fun", [Term.Type
                       ("List.list", [Term.Type
("Product_Type.prod", [Term.Type
                         ("Term.term", [Term.Type
  ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                      typerepa (typerep_term_of B_) Type]),
 typerepa (typerep_term_of C_) Type]),
                        Term.Type
                          ("Term.term", [Term.Type
   ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                       typerepa (typerep_term_of B_) Type]),
  typerepa (typerep_term_of C_) Type])])]),
                      Term.Type
                        ("fun", [Term.Type
                                   ("Proof_Checker.dp_proof", [typerepa
                         (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type,
                        typerepa (typerep_term_of C_) Type]),
                                  Term.Type
                                    ("Proof_Checker.dp_proof", [typerepa
                          (typerep_term_of A_) Type,
                         typerepa (typerep_term_of B_) Type,
                         typerepa (typerep_term_of C_)
                           Type])])])])])), term_of_projL (term_of_lab A_ B_)
      a), term_of_lista
            (term_of_prod
              (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                (term_of_term (term_of_lab A_ B_) C_))
              (term_of_list
                (term_of_prod term_of_pos
                  (term_of_prod
                    (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                      (term_of_term (term_of_lab A_ B_) C_))
                    (term_of_term (term_of_lab A_ B_) C_)))))
            b), term_of_lista
                  (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                    (term_of_term (term_of_lab A_ B_) C_))
                  c), term_of_dp_proofa A_ B_ C_ d)
  | term_of_dp_proofa A_ B_ C_ PisEmpty =
    Term.Const
      ("Proof_Checker.dp_proof.PisEmpty", Term.Type
    ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
                                 typerepa (typerep_term_of B_) Type,
                                 typerepa (typerep_term_of C_) Type]))
and term_of_dp_proof A_ B_ C_ =
  {typerep_term_of =
     typerep_dp_proof (typerep_term_of A_) (typerep_term_of B_)
       (typerep_term_of C_),
    term_of = term_of_dp_proofa A_ B_ C_}
  : ('a, 'b, 'c) dp_proof term_of;

fun term_of_strategy A_ B_ (Innermost_Q a) =
  Term.$
    (Term.Const
       ("Proof_Checker.strategy.Innermost_Q", Term.Type
        ("fun", [Term.Type
                   ("List.list", [Term.Type
                                    ("Term.term", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type])]),
                  Term.Type
                    ("Proof_Checker.strategy", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_)
           Type])])), term_of_lista (term_of_term A_ B_) a)
  | term_of_strategy A_ B_ Innermost =
    Term.Const
      ("Proof_Checker.strategy.Innermost", Term.Type
     ("Proof_Checker.strategy", [typerepa (typerep_term_of A_) Type,
                                  typerepa (typerep_term_of B_) Type]))
  | term_of_strategy A_ B_ No_Strategy =
    Term.Const
      ("Proof_Checker.strategy.No_Strategy", Term.Type
       ("Proof_Checker.strategy", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]));

fun term_of_boundstype Match =
  Term.Const
    ("Matchbounds_Impl.boundstype.Match", Term.Type
    ("Matchbounds_Impl.boundstype", []))
  | term_of_boundstype Roof =
    Term.Const
      ("Matchbounds_Impl.boundstype.Roof", Term.Type
     ("Matchbounds_Impl.boundstype", []));

fun typerep_ta_rulea A_ B_ t =
  Term.Type ("Tree_Automata.ta_rule", [typerepa A_ Type, typerepa B_ Type]);

fun typerep_ta_rule A_ B_ = {typerepa = typerep_ta_rulea A_ B_} :
  ('a, 'b) ta_rule typerep;

fun term_of_ta_rulea A_ B_ (TA_rule (a, b, c)) =
  Term.$
    (Term.$
       (Term.$
          (Term.Const
             ("Tree_Automata.ta_rule.TA_rule", Term.Type
         ("fun", [typerepa (typerep_term_of B_) Type,
                   Term.Type
                     ("fun", [Term.Type
                                ("List.list", [typerepa (typerep_term_of A_)
         Type]),
                               Term.Type
                                 ("fun", [typerepa (typerep_term_of A_) Type,
   Term.Type
     ("Tree_Automata.ta_rule", [typerepa (typerep_term_of A_) Type,
                                 typerepa (typerep_term_of B_)
                                   Type])])])])), term_of B_
            a), term_of_lista A_ b), term_of A_ c);

fun term_of_ta_rule A_ B_ =
  {typerep_term_of = typerep_ta_rule (typerep_term_of A_) (typerep_term_of B_),
    term_of = term_of_ta_rulea A_ B_}
  : ('a, 'b) ta_rule term_of;

fun term_of_tree_automaton A_ B_ (Tree_Automaton (a, b, c)) =
  Term.$
    (Term.$
       (Term.$
          (Term.Const
             ("Tree_Automata_Impl.tree_automaton.Tree_Automaton", Term.Type
                            ("fun", [Term.Type
                                       ("List.list", [typerepa
                (typerep_term_of A_) Type]),
                                      Term.Type
("fun", [Term.Type
           ("List.list", [Term.Type
                            ("Tree_Automata.ta_rule", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type])]),
          Term.Type
            ("fun", [Term.Type
                       ("List.list", [Term.Type
("Product_Type.prod", [typerepa (typerep_term_of A_) Type,
                        typerepa (typerep_term_of A_) Type])]),
                      Term.Type
                        ("Tree_Automata_Impl.tree_automaton", [typerepa
                         (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_)
                          Type])])])])), term_of_lista A_
   a), term_of_lista (term_of_ta_rule A_ B_)
         b), term_of_lista (term_of_prod A_ A_) c);

fun term_of_bounds_info A_ B_ (Bounds_Info (a, b, c, d)) =
  Term.$
    (Term.$
       (Term.$
          (Term.$
             (Term.Const
                ("Matchbounds_Impl.bounds_info.Bounds_Info", Term.Type
                       ("fun", [Term.Type ("Matchbounds_Impl.boundstype", []),
                                 Term.Type
                                   ("fun", [Term.Type ("Nat.nat", []),
     Term.Type
       ("fun", [Term.Type ("List.list", [typerepa (typerep_term_of B_) Type]),
                 Term.Type
                   ("fun", [Term.Type
                              ("Tree_Automata_Impl.tree_automaton", [typerepa
                               (typerep_term_of B_) Type,
                              Term.Type
                                ("Product_Type.prod", [typerepa
                 (typerep_term_of A_) Type,
                Term.Type ("Nat.nat", [])])]),
                             Term.Type
                               ("Matchbounds_Impl.bounds_info", [typerepa
                           (typerep_term_of A_) Type,
                          typerepa (typerep_term_of B_)
                            Type])])])])])), term_of_boundstype
       a), term_of_nata
             b), term_of_lista B_
                   c), term_of_tree_automaton B_ (term_of_prod A_ term_of_nat)
                         d);

fun term_of_trs_proof A_ B_ C_ (AssumeSN a) =
  Term.$
    (Term.Const
       ("Proof_Checker.trs_proof.AssumeSN", Term.Type
      ("fun", [Term.Type
                 ("Product_Type.prod", [Term.Type
  ("List.list", [Term.Type
                   ("Term.term", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                   typerepa (typerep_term_of C_) Type])]),
 Term.Type
   ("Product_Type.prod", [Term.Type
                            ("List.list", [Term.Type
     ("Product_Type.prod", [Term.Type
                              ("Term.term", [Term.Type
       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type]),
      typerepa (typerep_term_of C_) Type]),
                             Term.Type
                               ("Term.term", [Term.Type
        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                            typerepa (typerep_term_of B_) Type]),
       typerepa (typerep_term_of C_) Type])])]),
                           Term.Type
                             ("List.list", [Term.Type
      ("Product_Type.prod", [Term.Type
                               ("Term.term", [Term.Type
        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                            typerepa (typerep_term_of B_) Type]),
       typerepa (typerep_term_of C_) Type]),
                              Term.Type
                                ("Term.term", [Term.Type
         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                             typerepa (typerep_term_of B_) Type]),
        typerepa (typerep_term_of C_) Type])])])])]),
                Term.Type
                  ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_)
         Type,
        typerepa (typerep_term_of B_) Type,
        typerepa (typerep_term_of C_)
          Type])])), term_of_proda
                       (term_of_list (term_of_term (term_of_lab A_ B_) C_))
                       (term_of_prod
                         (term_of_list
                           (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                             (term_of_term (term_of_lab A_ B_) C_)))
                         (term_of_list
                           (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                             (term_of_term (term_of_lab A_ B_) C_))))
                       a)
  | term_of_trs_proof A_ B_ C_ (Split (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.trs_proof.Split", Term.Type
           ("fun", [Term.Type
                      ("List.list", [Term.Type
                                       ("Product_Type.prod", [Term.Type
                        ("Term.term", [Term.Type
 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_) Type]),
typerepa (typerep_term_of C_) Type]),
                       Term.Type
                         ("Term.term", [Term.Type
  ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                      typerepa (typerep_term_of B_) Type]),
 typerepa (typerep_term_of C_) Type])])]),
                     Term.Type
                       ("fun", [Term.Type
                                  ("Proof_Checker.trs_proof", [typerepa
                         (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type,
                        typerepa (typerep_term_of C_) Type]),
                                 Term.Type
                                   ("fun", [Term.Type
      ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type,
                                    typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_) Type,
                                     typerepa (typerep_term_of C_)
                                       Type])])])])), term_of_lista
                (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                  (term_of_term (term_of_lab A_ B_) C_))
                a), term_of_trs_proof A_ B_ C_ b), term_of_trs_proof A_ B_ C_ c)
  | term_of_trs_proof A_ B_ C_ (Fcc (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.trs_proof.Fcc", Term.Type
         ("fun", [Term.Type
                    ("List.list", [Term.Type
                                     ("Term.ctxt", [Term.Type
              ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                  typerepa (typerep_term_of B_) Type]),
             typerepa (typerep_term_of C_) Type])]),
                   Term.Type
                     ("fun", [Term.Type
                                ("List.list", [Term.Type
         ("Product_Type.prod", [Term.Type
                                  ("Term.term", [Term.Type
           ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                               typerepa (typerep_term_of B_) Type]),
          typerepa (typerep_term_of C_) Type]),
                                 Term.Type
                                   ("Term.term", [Term.Type
            ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                typerepa (typerep_term_of B_) Type]),
           typerepa (typerep_term_of C_) Type])])]),
                               Term.Type
                                 ("fun", [Term.Type
    ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                  typerepa (typerep_term_of B_) Type,
                                  typerepa (typerep_term_of C_) Type]),
   Term.Type
     ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type,
                                   typerepa (typerep_term_of C_)
                                     Type])])])])), term_of_lista
              (term_of_ctxt (term_of_lab A_ B_) C_)
              a), term_of_lista
                    (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                      (term_of_term (term_of_lab A_ B_) C_))
                    b), term_of_trs_proof A_ B_ C_ c)
  | term_of_trs_proof A_ B_ C_ RisEmpty =
    Term.Const
      ("Proof_Checker.trs_proof.RisEmpty", Term.Type
     ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type,
                                   typerepa (typerep_term_of C_) Type]))
  | term_of_trs_proof A_ B_ C_ (Semlab (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.trs_proof.Semlab", Term.Type
               ("fun", [Term.Type
                          ("Semantic_Labeling_Carrier.sl_variant", [Term.Type
                              ("Labelings.lab", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type]),
                             typerepa (typerep_term_of C_) Type]),
                         Term.Type
                           ("fun", [Term.Type
                                      ("List.list", [Term.Type
               ("Term.term", [Term.Type
                                ("Labelings.lab", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type]),
                               typerepa (typerep_term_of C_) Type])]),
                                     Term.Type
                                       ("fun", [Term.Type
          ("List.list", [Term.Type
                           ("Product_Type.prod", [Term.Type
            ("Term.term", [Term.Type
                             ("Labelings.lab", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_) Type]),
                            typerepa (typerep_term_of C_) Type]),
           Term.Type
             ("Term.term", [Term.Type
                              ("Labelings.lab", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type]),
                             typerepa (typerep_term_of C_) Type])])]),
         Term.Type
           ("fun", [Term.Type
                      ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type,
            typerepa (typerep_term_of C_) Type]),
                     Term.Type
                       ("Proof_Checker.trs_proof", [typerepa
              (typerep_term_of A_) Type,
             typerepa (typerep_term_of B_) Type,
             typerepa (typerep_term_of C_)
               Type])])])])])), term_of_sl_variant (term_of_lab A_ B_) C_
                                  a), term_of_lista
(term_of_term (term_of_lab A_ B_) C_)
b), term_of_lista
      (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
        (term_of_term (term_of_lab A_ B_) C_))
      c), term_of_trs_proof A_ B_ C_ d)
  | term_of_trs_proof A_ B_ C_ (Uncurry (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.trs_proof.Uncurry", Term.Type
             ("fun", [Term.Type
                        ("Product_Type.prod", [Term.Type
         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                             typerepa (typerep_term_of B_) Type]),
        Term.Type
          ("Product_Type.prod", [Term.Type
                                   ("List.list", [Term.Type
            ("Product_Type.prod", [Term.Type
                                     ("Product_Type.prod", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     Term.Type ("Nat.nat", [])]),
                                    Term.Type
                                      ("List.list", [Term.Type
               ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type])])])]),
                                  Term.Type
                                    ("Product_Type.prod", [Term.Type
                     ("List.list", [Term.Type
                                      ("Product_Type.prod", [Term.Type
                       ("Term.term", [Term.Type
("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                    typerepa (typerep_term_of B_) Type]),
                                       typerepa (typerep_term_of C_) Type]),
                      Term.Type
                        ("Term.term", [Term.Type
 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_) Type]),
typerepa (typerep_term_of C_) Type])])]),
                    Term.Type
                      ("List.list", [Term.Type
                                       ("Product_Type.prod", [Term.Type
                        ("Term.term", [Term.Type
 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_) Type]),
typerepa (typerep_term_of C_) Type]),
                       Term.Type
                         ("Term.term", [Term.Type
  ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                      typerepa (typerep_term_of B_) Type]),
 typerepa (typerep_term_of C_) Type])])])])])]),
                       Term.Type
                         ("fun", [Term.Type
                                    ("List.list", [Term.Type
             ("Product_Type.prod", [Term.Type
                                      ("Term.term", [Term.Type
               ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type]),
              typerepa (typerep_term_of C_) Type]),
                                     Term.Type
                                       ("Term.term", [Term.Type
                ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]),
               typerepa (typerep_term_of C_) Type])])]),
                                   Term.Type
                                     ("fun", [Term.Type
        ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                      typerepa (typerep_term_of B_) Type,
                                      typerepa (typerep_term_of C_) Type]),
       Term.Type
         ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_) Type,
                                       typerepa (typerep_term_of C_)
 Type])])])])), term_of_proda (term_of_lab A_ B_)
                  (term_of_prod
                    (term_of_list
                      (term_of_prod
                        (term_of_prod (term_of_lab A_ B_) term_of_nat)
                        (term_of_list (term_of_lab A_ B_))))
                    (term_of_prod
                      (term_of_list
                        (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                          (term_of_term (term_of_lab A_ B_) C_)))
                      (term_of_list
                        (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                          (term_of_term (term_of_lab A_ B_) C_)))))
                  a), term_of_lista
                        (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                          (term_of_term (term_of_lab A_ B_) C_))
                        b), term_of_trs_proof A_ B_ C_ c)
  | term_of_trs_proof A_ B_ C_ (Bounds a) =
    Term.$
      (Term.Const
         ("Proof_Checker.trs_proof.Bounds", Term.Type
      ("fun", [Term.Type
                 ("Matchbounds_Impl.bounds_info", [Term.Type
             ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                 typerepa (typerep_term_of B_) Type]),
            typerepa (typerep_term_of C_) Type]),
                Term.Type
                  ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_)
         Type,
        typerepa (typerep_term_of B_) Type,
        typerepa (typerep_term_of C_)
          Type])])), term_of_bounds_info (term_of_lab A_ B_) C_ a)
  | term_of_trs_proof A_ B_ C_ (StringReversal a) =
    Term.$
      (Term.Const
         ("Proof_Checker.trs_proof.StringReversal", Term.Type
              ("fun", [Term.Type
                         ("Proof_Checker.trs_proof", [typerepa
                (typerep_term_of A_) Type,
               typerepa (typerep_term_of B_) Type,
               typerepa (typerep_term_of C_) Type]),
                        Term.Type
                          ("Proof_Checker.trs_proof", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type,
                typerepa (typerep_term_of C_)
                  Type])])), term_of_trs_proof A_ B_ C_ a)
  | term_of_trs_proof A_ B_ C_ (RuleRemoval (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.trs_proof.RuleRemoval", Term.Type
                 ("fun", [Term.Type
                            ("Reduction_Pair_Implementations.redtriple_impl", [Term.Type
 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_) Type])]),
                           Term.Type
                             ("fun", [Term.Type
("List.list", [Term.Type
                 ("Product_Type.prod", [Term.Type
  ("Term.term", [Term.Type
                   ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_) Type]),
                  typerepa (typerep_term_of C_) Type]),
 Term.Type
   ("Term.term", [Term.Type
                    ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
typerepa (typerep_term_of B_) Type]),
                   typerepa (typerep_term_of C_) Type])])]),
                                       Term.Type
 ("fun", [Term.Type
            ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type, typerepa (typerep_term_of C_) Type]),
           Term.Type
             ("Proof_Checker.trs_proof", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type,
   typerepa (typerep_term_of C_)
     Type])])])])), term_of_redtriple_impla (term_of_lab A_ B_)
                      a), term_of_lista
                            (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                              (term_of_term (term_of_lab A_ B_) C_))
                            b), term_of_trs_proof A_ B_ C_ c)
  | term_of_trs_proof A_ B_ C_ (DPTrans (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Proof_Checker.trs_proof.DPTrans", Term.Type
          ("fun", [Term.Type
                     ("List.list", [Term.Type
                                      ("Product_Type.prod", [Term.Type
                       ("Term.term", [Term.Type
("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                    typerepa (typerep_term_of B_) Type]),
                                       typerepa (typerep_term_of C_) Type]),
                      Term.Type
                        ("Term.term", [Term.Type
 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_) Type]),
typerepa (typerep_term_of C_) Type])])]),
                    Term.Type
                      ("fun", [Term.Type
                                 ("Proof_Checker.dp_proof", [typerepa
                       (typerep_term_of A_) Type,
                      typerepa (typerep_term_of B_) Type,
                      typerepa (typerep_term_of C_) Type]),
                                Term.Type
                                  ("Proof_Checker.trs_proof", [typerepa
                         (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type,
                        typerepa (typerep_term_of C_)
                          Type])])])), term_of_lista
 (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
   (term_of_term (term_of_lab A_ B_) C_))
 a), term_of_dp_proofa A_ B_ C_ b);

fun typerep_boola t = Term.Type ("HOL.bool", []);

val typerep_bool = {typerepa = typerep_boola} : bool typerep;

fun term_of_boola false = Term.Const ("HOL.False", Term.Type ("HOL.bool", []))
  | term_of_boola true = Term.Const ("HOL.True", Term.Type ("HOL.bool", []));

val term_of_bool = {typerep_term_of = typerep_bool, term_of = term_of_boola} :
  bool term_of;

fun term_of_dp_disproof A_ B_ (DP_Rule_Removal (a, b, c)) =
  Term.$
    (Term.$
       (Term.$
          (Term.Const
             ("Nontermination_Impl.dp_disproof.DP_Rule_Removal", Term.Type
                           ("fun", [Term.Type
                                      ("List.list", [Term.Type
               ("Product_Type.prod", [Term.Type
("Term.term", [typerepa (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                       Term.Type
 ("Term.term", [typerepa (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type])])]),
                                     Term.Type
                                       ("fun", [Term.Type
          ("List.list", [Term.Type
                           ("Product_Type.prod", [Term.Type
            ("Term.term", [typerepa (typerep_term_of A_) Type,
                            typerepa (typerep_term_of B_) Type]),
           Term.Type
             ("Term.term", [typerepa (typerep_term_of A_) Type,
                             typerepa (typerep_term_of B_) Type])])]),
         Term.Type
           ("fun", [Term.Type
                      ("Nontermination_Impl.dp_disproof", [typerepa
                     (typerep_term_of A_) Type,
                    typerepa (typerep_term_of B_) Type]),
                     Term.Type
                       ("Nontermination_Impl.dp_disproof", [typerepa
                      (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_)
                       Type])])])])), term_of_lista
(term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
a), term_of_lista (term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
      b), term_of_dp_disproof A_ B_ c)
  | term_of_dp_disproof A_ B_ (DP_Loop (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Nontermination_Impl.dp_disproof.DP_Loop", Term.Type
                        ("fun", [Term.Type
                                   ("Term.term", [typerepa (typerep_term_of A_)
            Type,
           typerepa (typerep_term_of B_) Type]),
                                  Term.Type
                                    ("fun", [Term.Type
       ("List.list", [Term.Type
                        ("Product_Type.prod", [Term.Type ("Position.pos", []),
        Term.Type
          ("Product_Type.prod", [Term.Type
                                   ("Product_Type.prod", [Term.Type
                    ("Term.term", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]),
                   Term.Type
                     ("Term.term", [typerepa (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_) Type])]),
                                  Term.Type
                                    ("Product_Type.prod", [Term.Type
                     ("HOL.bool", []),
                    Term.Type
                      ("Term.term", [typerepa (typerep_term_of A_) Type,
                                      typerepa (typerep_term_of B_)
Type])])])])]),
      Term.Type
        ("fun", [Term.Type
                   ("List.list", [Term.Type
                                    ("Product_Type.prod", [typerepa
                     (typerep_term_of B_) Type,
                    Term.Type
                      ("Term.term", [typerepa (typerep_term_of A_) Type,
                                      typerepa (typerep_term_of B_) Type])])]),
                  Term.Type
                    ("fun", [Term.Type
                               ("Term.ctxt", [typerepa (typerep_term_of A_)
        Type,
       typerepa (typerep_term_of B_) Type]),
                              Term.Type
                                ("Nontermination_Impl.dp_disproof", [typerepa
                               (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_)
                                Type])])])])])), term_of_terma A_ B_
           a), term_of_lista
                 (term_of_prod term_of_pos
                   (term_of_prod
                     (term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
                     (term_of_prod term_of_bool (term_of_term A_ B_))))
                 b), term_of_lista (term_of_prod B_ (term_of_term A_ B_))
                       c), term_of_ctxta A_ B_ d);

fun term_of_trs_disproof A_ B_ (TRS_DP_Trans (a, b)) =
  Term.$
    (Term.$
       (Term.Const
          ("Nontermination_Impl.trs_disproof.TRS_DP_Trans", Term.Type
                      ("fun", [Term.Type
                                 ("List.list", [Term.Type
          ("Product_Type.prod", [Term.Type
                                   ("Term.term", [typerepa (typerep_term_of A_)
            Type,
           typerepa (typerep_term_of B_) Type]),
                                  Term.Type
                                    ("Term.term", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type])])]),
                                Term.Type
                                  ("fun", [Term.Type
     ("Nontermination_Impl.dp_disproof", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
    Term.Type
      ("Nontermination_Impl.trs_disproof", [typerepa (typerep_term_of A_) Type,
     typerepa (typerep_term_of B_)
       Type])])])), term_of_lista
                      (term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
                      a), term_of_dp_disproof A_ B_ b)
  | term_of_trs_disproof A_ B_ (TRS_String_Reversal a) =
    Term.$
      (Term.Const
         ("Nontermination_Impl.trs_disproof.TRS_String_Reversal", Term.Type
                            ("fun", [Term.Type
                                       ("Nontermination_Impl.trs_disproof", [typerepa
                                       (typerep_term_of A_) Type,
                                      typerepa (typerep_term_of B_) Type]),
                                      Term.Type
("Nontermination_Impl.trs_disproof", [typerepa (typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_)
 Type])])), term_of_trs_disproof A_ B_ a)
  | term_of_trs_disproof A_ B_ (TRS_Rule_Removal (a, b)) =
    Term.$
      (Term.$
         (Term.Const
            ("Nontermination_Impl.trs_disproof.TRS_Rule_Removal", Term.Type
                            ("fun", [Term.Type
                                       ("List.list", [Term.Type
                ("Product_Type.prod", [Term.Type
 ("Term.term", [typerepa (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type]),
Term.Type
  ("Term.term", [typerepa (typerep_term_of A_) Type,
                  typerepa (typerep_term_of B_) Type])])]),
                                      Term.Type
("fun", [Term.Type
           ("Nontermination_Impl.trs_disproof", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type]),
          Term.Type
            ("Nontermination_Impl.trs_disproof", [typerepa (typerep_term_of A_)
            Type,
           typerepa (typerep_term_of B_)
             Type])])])), term_of_lista
                            (term_of_prod (term_of_term A_ B_)
                              (term_of_term A_ B_))
                            a), term_of_trs_disproof A_ B_ b)
  | term_of_trs_disproof A_ B_ TRS_Not_Well_Formed =
    Term.Const
      ("Nontermination_Impl.trs_disproof.TRS_Not_Well_Formed", Term.Type
                         ("Nontermination_Impl.trs_disproof", [typerepa
                         (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type]))
  | term_of_trs_disproof A_ B_ (TRS_Loop (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Nontermination_Impl.trs_disproof.TRS_Loop", Term.Type
                          ("fun", [Term.Type
                                     ("Term.term", [typerepa
              (typerep_term_of A_) Type,
             typerepa (typerep_term_of B_) Type]),
                                    Term.Type
                                      ("fun", [Term.Type
         ("List.list", [Term.Type
                          ("Product_Type.prod", [Term.Type ("Position.pos", []),
          Term.Type
            ("Product_Type.prod", [Term.Type
                                     ("Product_Type.prod", [Term.Type
                      ("Term.term", [typerepa (typerep_term_of A_) Type,
                                      typerepa (typerep_term_of B_) Type]),
                     Term.Type
                       ("Term.term", [typerepa (typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_) Type])]),
                                    Term.Type
                                      ("Term.term", [typerepa
               (typerep_term_of A_) Type,
              typerepa (typerep_term_of B_) Type])])])]),
        Term.Type
          ("fun", [Term.Type
                     ("List.list", [Term.Type
                                      ("Product_Type.prod", [typerepa
                       (typerep_term_of B_) Type,
                      Term.Type
                        ("Term.term", [typerepa (typerep_term_of A_) Type,
typerepa (typerep_term_of B_) Type])])]),
                    Term.Type
                      ("fun", [Term.Type
                                 ("Term.ctxt", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_) Type]),
                                Term.Type
                                  ("Nontermination_Impl.trs_disproof", [typerepa
                                  (typerep_term_of A_) Type,
                                 typerepa (typerep_term_of B_)
                                   Type])])])])])), term_of_terma A_ B_
              a), term_of_lista
                    (term_of_prod term_of_pos
                      (term_of_prod
                        (term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
                        (term_of_term A_ B_)))
                    b), term_of_lista (term_of_prod B_ (term_of_term A_ B_))
                          c), term_of_ctxta A_ B_ d);

fun term_of_reltrs_disproof A_ B_ (Rel_R_Not_SN a) =
  Term.$
    (Term.Const
       ("Nontermination_Impl.reltrs_disproof.Rel_R_Not_SN", Term.Type
                      ("fun", [Term.Type
                                 ("Nontermination_Impl.trs_disproof", [typerepa
                                 (typerep_term_of A_) Type,
                                typerepa (typerep_term_of B_) Type]),
                                Term.Type
                                  ("Nontermination_Impl.reltrs_disproof", [typerepa
                                     (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_)
                                      Type])])), term_of_trs_disproof A_ B_ a)
  | term_of_reltrs_disproof A_ B_ (Rel_Rule_Removal (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Nontermination_Impl.reltrs_disproof.Rel_Rule_Removal", Term.Type
                                  ("fun", [Term.Type
     ("List.list", [Term.Type
                      ("Product_Type.prod", [Term.Type
       ("Term.term", [typerepa (typerep_term_of A_) Type,
                       typerepa (typerep_term_of B_) Type]),
      Term.Type
        ("Term.term", [typerepa (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type])])]),
    Term.Type
      ("fun", [Term.Type
                 ("List.list", [Term.Type
                                  ("Product_Type.prod", [Term.Type
                   ("Term.term", [typerepa (typerep_term_of A_) Type,
                                   typerepa (typerep_term_of B_) Type]),
                  Term.Type
                    ("Term.term", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type])])]),
                Term.Type
                  ("fun", [Term.Type
                             ("Nontermination_Impl.reltrs_disproof", [typerepa
                                (typerep_term_of A_) Type,
                               typerepa (typerep_term_of B_) Type]),
                            Term.Type
                              ("Nontermination_Impl.reltrs_disproof", [typerepa
                                 (typerep_term_of A_) Type,
                                typerepa (typerep_term_of B_)
                                  Type])])])])), term_of_lista
           (term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
           a), term_of_lista
                 (term_of_prod (term_of_term A_ B_) (term_of_term A_ B_))
                 b), term_of_reltrs_disproof A_ B_ c)
  | term_of_reltrs_disproof A_ B_ Rel_Not_Well_Formed =
    Term.Const
      ("Nontermination_Impl.reltrs_disproof.Rel_Not_Well_Formed", Term.Type
                            ("Nontermination_Impl.reltrs_disproof", [typerepa
                               (typerep_term_of A_) Type,
                              typerepa (typerep_term_of B_) Type]))
  | term_of_reltrs_disproof A_ B_ (Rel_Loop (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Nontermination_Impl.reltrs_disproof.Rel_Loop", Term.Type
                             ("fun", [Term.Type
("Term.term", [typerepa (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                       Term.Type
 ("fun", [Term.Type
            ("List.list", [Term.Type
                             ("Product_Type.prod", [Term.Type
              ("Position.pos", []),
             Term.Type
               ("Product_Type.prod", [Term.Type
("Product_Type.prod", [Term.Type
                         ("Term.term", [typerepa (typerep_term_of A_) Type,
 typerepa (typerep_term_of B_) Type]),
                        Term.Type
                          ("Term.term", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type])]),
                                       Term.Type
 ("Product_Type.prod", [Term.Type ("HOL.bool", []),
                         Term.Type
                           ("Term.term", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type])])])])]),
           Term.Type
             ("fun", [Term.Type
                        ("List.list", [Term.Type
 ("Product_Type.prod", [typerepa (typerep_term_of B_) Type,
                         Term.Type
                           ("Term.term", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type])])]),
                       Term.Type
                         ("fun", [Term.Type
                                    ("Term.ctxt", [typerepa (typerep_term_of A_)
             Type,
            typerepa (typerep_term_of B_) Type]),
                                   Term.Type
                                     ("Nontermination_Impl.reltrs_disproof", [typerepa
(typerep_term_of A_) Type,
                                       typerepa (typerep_term_of B_)
 Type])])])])])), term_of_terma A_ B_
                    a), term_of_lista
                          (term_of_prod term_of_pos
                            (term_of_prod
                              (term_of_prod (term_of_term A_ B_)
                                (term_of_term A_ B_))
                              (term_of_prod term_of_bool (term_of_term A_ B_))))
                          b), term_of_lista
                                (term_of_prod B_ (term_of_term A_ B_))
                                c), term_of_ctxta A_ B_ d);

fun term_of_cert_problema A_ B_ C_ (Rel_TRS_Disproof (a, b, c, d)) =
  Term.$
    (Term.$
       (Term.$
          (Term.$
             (Term.Const
                ("Proof_Checker.cert_problem.Rel_TRS_Disproof", Term.Type
                          ("fun", [Term.Type
                                     ("Proof_Checker.strategy", [Term.Type
                           ("Labelings.lab", [typerepa (typerep_term_of A_)
        Type,
       typerepa (typerep_term_of B_) Type]),
                          typerepa (typerep_term_of C_) Type]),
                                    Term.Type
                                      ("fun", [Term.Type
         ("List.list", [Term.Type
                          ("Product_Type.prod", [Term.Type
           ("Term.term", [Term.Type
                            ("Labelings.lab", [typerepa (typerep_term_of A_)
         Type,
        typerepa (typerep_term_of B_) Type]),
                           typerepa (typerep_term_of C_) Type]),
          Term.Type
            ("Term.term", [Term.Type
                             ("Labelings.lab", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_) Type]),
                            typerepa (typerep_term_of C_) Type])])]),
        Term.Type
          ("fun", [Term.Type
                     ("List.list", [Term.Type
                                      ("Product_Type.prod", [Term.Type
                       ("Term.term", [Term.Type
("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                    typerepa (typerep_term_of B_) Type]),
                                       typerepa (typerep_term_of C_) Type]),
                      Term.Type
                        ("Term.term", [Term.Type
 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                     typerepa (typerep_term_of B_) Type]),
typerepa (typerep_term_of C_) Type])])]),
                    Term.Type
                      ("fun", [Term.Type
                                 ("Nontermination_Impl.reltrs_disproof", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                   typerepa (typerep_term_of C_) Type]),
                                Term.Type
                                  ("Proof_Checker.cert_problem", [typerepa
                            (typerep_term_of A_) Type,
                           typerepa (typerep_term_of B_) Type,
                           typerepa (typerep_term_of C_)
                             Type])])])])])), term_of_strategy
        (term_of_lab A_ B_) C_
        a), term_of_lista
              (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                (term_of_term (term_of_lab A_ B_) C_))
              b), term_of_lista
                    (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                      (term_of_term (term_of_lab A_ B_) C_))
                    c), term_of_reltrs_disproof (term_of_lab A_ B_) C_ d)
  | term_of_cert_problema A_ B_ C_ (TRS_Disproof (a, b, c)) =
    Term.$
      (Term.$
         (Term.$
            (Term.Const
               ("Proof_Checker.cert_problem.TRS_Disproof", Term.Type
                     ("fun", [Term.Type
                                ("Proof_Checker.strategy", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     typerepa (typerep_term_of C_) Type]),
                               Term.Type
                                 ("fun", [Term.Type
    ("List.list", [Term.Type
                     ("Product_Type.prod", [Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type])])]),
   Term.Type
     ("fun", [Term.Type
                ("Nontermination_Impl.trs_disproof", [Term.Type
                ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]),
               typerepa (typerep_term_of C_) Type]),
               Term.Type
                 ("Proof_Checker.cert_problem", [typerepa (typerep_term_of A_)
           Type,
          typerepa (typerep_term_of B_) Type,
          typerepa (typerep_term_of C_)
            Type])])])])), term_of_strategy (term_of_lab A_ B_) C_
                             a), term_of_lista
                                   (term_of_prod
                                     (term_of_term (term_of_lab A_ B_) C_)
                                     (term_of_term (term_of_lab A_ B_) C_))
                                   b), term_of_trs_disproof (term_of_lab A_ B_)
 C_ c)
  | term_of_cert_problema A_ B_ C_ (DP_Disproof (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.cert_problem.DP_Disproof", Term.Type
                       ("fun", [Term.Type
                                  ("List.list", [Term.Type
           ("Product_Type.prod", [Term.Type
                                    ("Term.term", [Term.Type
             ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                 typerepa (typerep_term_of B_) Type]),
            typerepa (typerep_term_of C_) Type]),
                                   Term.Type
                                     ("Term.term", [Term.Type
              ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                  typerepa (typerep_term_of B_) Type]),
             typerepa (typerep_term_of C_) Type])])]),
                                 Term.Type
                                   ("fun", [Term.Type
      ("Proof_Checker.strategy", [Term.Type
                                    ("Labelings.lab", [typerepa
                 (typerep_term_of A_) Type,
                typerepa (typerep_term_of B_) Type]),
                                   typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("fun", [Term.Type
                  ("List.list", [Term.Type
                                   ("Product_Type.prod", [Term.Type
                    ("Term.term", [Term.Type
                                     ("Labelings.lab", [typerepa
                  (typerep_term_of A_) Type,
                 typerepa (typerep_term_of B_) Type]),
                                    typerepa (typerep_term_of C_) Type]),
                   Term.Type
                     ("Term.term", [Term.Type
                                      ("Labelings.lab", [typerepa
                   (typerep_term_of A_) Type,
                  typerepa (typerep_term_of B_) Type]),
                                     typerepa (typerep_term_of C_) Type])])]),
                 Term.Type
                   ("fun", [Term.Type
                              ("Nontermination_Impl.dp_disproof", [Term.Type
                             ("Labelings.lab", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_) Type]),
                            typerepa (typerep_term_of C_) Type]),
                             Term.Type
                               ("Proof_Checker.cert_problem", [typerepa
                         (typerep_term_of A_) Type,
                        typerepa (typerep_term_of B_) Type,
                        typerepa (typerep_term_of C_)
                          Type])])])])])), term_of_lista
     (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
       (term_of_term (term_of_lab A_ B_) C_))
     a), term_of_strategy (term_of_lab A_ B_) C_
           b), term_of_lista
                 (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                   (term_of_term (term_of_lab A_ B_) C_))
                 c), term_of_dp_disproof (term_of_lab A_ B_) C_ d)
  | term_of_cert_problema A_ B_ C_ (DP_Proof (a, b, c, d, e, f)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.$
                  (Term.$
                     (Term.Const
                        ("Proof_Checker.cert_problem.DP_Proof", Term.Type
                          ("fun", [Term.Type
                                     ("List.list", [Term.Type
              ("Product_Type.prod", [Term.Type
                                       ("Term.term", [Term.Type
                ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]),
               typerepa (typerep_term_of C_) Type]),
                                      Term.Type
("Term.term", [Term.Type
                 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_) Type]),
                typerepa (typerep_term_of C_) Type])])]),
                                    Term.Type
                                      ("fun", [Term.Type
         ("List.list", [Term.Type
                          ("Product_Type.prod", [Term.Type
           ("Term.term", [Term.Type
                            ("Labelings.lab", [typerepa (typerep_term_of A_)
         Type,
        typerepa (typerep_term_of B_) Type]),
                           typerepa (typerep_term_of C_) Type]),
          Term.Type
            ("Term.term", [Term.Type
                             ("Labelings.lab", [typerepa (typerep_term_of A_)
          Type,
         typerepa (typerep_term_of B_) Type]),
                            typerepa (typerep_term_of C_) Type])])]),
        Term.Type
          ("fun", [Term.Type
                     ("Proof_Checker.strategy", [Term.Type
           ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                               typerepa (typerep_term_of B_) Type]),
          typerepa (typerep_term_of C_) Type]),
                    Term.Type
                      ("fun", [Term.Type
                                 ("List.list", [Term.Type
          ("Product_Type.prod", [Term.Type
                                   ("Term.term", [Term.Type
            ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                typerepa (typerep_term_of B_) Type]),
           typerepa (typerep_term_of C_) Type]),
                                  Term.Type
                                    ("Term.term", [Term.Type
             ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                 typerepa (typerep_term_of B_) Type]),
            typerepa (typerep_term_of C_) Type])])]),
                                Term.Type
                                  ("fun", [Term.Type
     ("List.list", [Term.Type
                      ("Product_Type.prod", [Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type]),
      Term.Type
        ("Term.term", [Term.Type
                         ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
     typerepa (typerep_term_of B_) Type]),
                        typerepa (typerep_term_of C_) Type])])]),
    Term.Type
      ("fun", [Term.Type
                 ("Proof_Checker.dp_proof", [typerepa (typerep_term_of A_) Type,
      typerepa (typerep_term_of B_) Type, typerepa (typerep_term_of C_) Type]),
                Term.Type
                  ("Proof_Checker.cert_problem", [typerepa (typerep_term_of A_)
            Type,
           typerepa (typerep_term_of B_) Type,
           typerepa (typerep_term_of C_)
             Type])])])])])])])), term_of_lista
                                    (term_of_prod
                                      (term_of_term (term_of_lab A_ B_) C_)
                                      (term_of_term (term_of_lab A_ B_) C_))
                                    a), term_of_lista
  (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
    (term_of_term (term_of_lab A_ B_) C_))
  b), term_of_strategy (term_of_lab A_ B_) C_
        c), term_of_lista
              (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                (term_of_term (term_of_lab A_ B_) C_))
              d), term_of_lista
                    (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                      (term_of_term (term_of_lab A_ B_) C_))
                    e), term_of_dp_proofa A_ B_ C_ f)
  | term_of_cert_problema A_ B_ C_ (TRS_Proof (a, b, c, d)) =
    Term.$
      (Term.$
         (Term.$
            (Term.$
               (Term.Const
                  ("Proof_Checker.cert_problem.TRS_Proof", Term.Type
                     ("fun", [Term.Type
                                ("Proof_Checker.strategy", [Term.Type
                      ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
  typerepa (typerep_term_of B_) Type]),
                     typerepa (typerep_term_of C_) Type]),
                               Term.Type
                                 ("fun", [Term.Type
    ("List.list", [Term.Type
                     ("Product_Type.prod", [Term.Type
      ("Term.term", [Term.Type
                       ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
   typerepa (typerep_term_of B_) Type]),
                      typerepa (typerep_term_of C_) Type]),
     Term.Type
       ("Term.term", [Term.Type
                        ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
    typerepa (typerep_term_of B_) Type]),
                       typerepa (typerep_term_of C_) Type])])]),
   Term.Type
     ("fun", [Term.Type
                ("Option.option", [Term.Type
                                     ("List.list", [Term.Type
              ("Product_Type.prod", [Term.Type
                                       ("Term.term", [Term.Type
                ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                    typerepa (typerep_term_of B_) Type]),
               typerepa (typerep_term_of C_) Type]),
                                      Term.Type
("Term.term", [Term.Type
                 ("Labelings.lab", [typerepa (typerep_term_of A_) Type,
                                     typerepa (typerep_term_of B_) Type]),
                typerepa (typerep_term_of C_) Type])])])]),
               Term.Type
                 ("fun", [Term.Type
                            ("Proof_Checker.trs_proof", [typerepa
                   (typerep_term_of A_) Type,
                  typerepa (typerep_term_of B_) Type,
                  typerepa (typerep_term_of C_) Type]),
                           Term.Type
                             ("Proof_Checker.cert_problem", [typerepa
                       (typerep_term_of A_) Type,
                      typerepa (typerep_term_of B_) Type,
                      typerepa (typerep_term_of C_)
                        Type])])])])])), term_of_strategy (term_of_lab A_ B_) C_
   a), term_of_lista
         (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
           (term_of_term (term_of_lab A_ B_) C_))
         b), term_of_optiona
               (term_of_list
                 (term_of_prod (term_of_term (term_of_lab A_ B_) C_)
                   (term_of_term (term_of_lab A_ B_) C_)))
               c), term_of_trs_proof A_ B_ C_ d);

fun term_of_cert_problem A_ B_ C_ =
  {typerep_term_of =
     typerep_cert_problem (typerep_term_of A_) (typerep_term_of B_)
       (typerep_term_of C_),
    term_of = term_of_cert_problema A_ B_ C_}
  : ('a, 'b, 'c) cert_problem term_of;

fun termifyCP x =
  term_of_sum (term_of_list term_of_char)
    (term_of_cert_problem (term_of_list term_of_char) (term_of_list term_of_nat)
      (term_of_list term_of_char))
    x;

datatype cert_result = Certified of char list | Unsupported of char list |
  Error of char list;

fun term_of_cert_result (Error a) =
  Term.$
    (Term.Const
       ("Proof_Checker.cert_result.Error", Term.Type
     ("fun", [Term.Type ("List.list", [Term.Type ("String.char", [])]),
               Term.Type
                 ("Proof_Checker.cert_result", [])])), term_of_lista
                 term_of_char a)
  | term_of_cert_result (Unsupported a) =
    Term.$
      (Term.Const
         ("Proof_Checker.cert_result.Unsupported", Term.Type
             ("fun", [Term.Type ("List.list", [Term.Type ("String.char", [])]),
                       Term.Type
                         ("Proof_Checker.cert_result", [])])), term_of_lista
                         term_of_char a)
  | term_of_cert_result (Certified a) =
    Term.$
      (Term.Const
         ("Proof_Checker.cert_result.Certified", Term.Type
           ("fun", [Term.Type ("List.list", [Term.Type ("String.char", [])]),
                     Term.Type
                       ("Proof_Checker.cert_result", [])])), term_of_lista
                       term_of_char a);

fun termifyCR x = term_of_cert_result x;

datatype ('a, 'b) gctxt = GCHole | GCFun of 'a * ('a, 'b) gctxt list;

fun guard b = (if b then SOME () else NONE);

fun merge_lists A_ (c :: cs) [] = NONE
  | merge_lists A_ [] (d :: ds) = NONE
  | merge_lists A_ (GCFun (f, ss) :: cs) (GCFun (g, ts) :: ds) =
    bind (guard (eq A_ f g))
      (fn _ =>
        bind (merge_lists A_ ss ts)
          (fn us =>
            bind (merge_lists A_ cs ds) (fn es => SOME (GCFun (f, us) :: es))))
  | merge_lists A_ (c :: cs) (GCHole :: ds) =
    bind (merge_lists A_ cs ds) (fn es => SOME (c :: es))
  | merge_lists A_ (GCHole :: cs) (d :: ds) =
    bind (merge_lists A_ cs ds) (fn es => SOME (d :: es))
  | merge_lists A_ [] [] = SOME [];

fun merge A_ c d =
  bind (merge_lists A_ [c] [d]) (fn es => SOME (nth es Zero_nat));

fun merge_var A_ B_ x c ((d, y) :: ps) =
  (if eq A_ x y then bind (merge B_ c d) (fn e => merge_var A_ B_ x e ps)
    else bind (merge_var A_ B_ x c ps) (fn (b, psa) => SOME (b, (d, y) :: psa)))
  | merge_var A_ B_ x c [] = SOME ((c, x), []);

fun merge_all A_ B_ [] = SOME []
  | merge_all A_ B_ ((c, x) :: ps) =
    bind (merge_var B_ A_ x c ps)
      (fn (cx, psa) => bind (merge_all A_ B_ psa) (fn psb => SOME (cx :: psb)));

fun zip_option [] [] = SOME []
  | zip_option (x :: xs) (y :: ys) =
    bind (zip_option xs ys) (fn zs => SOME ((x, y) :: zs))
  | zip_option (x :: xs) [] = NONE
  | zip_option [] (y :: ys) = NONE;

fun match_lista A_ ((GCFun (f, ss), Var x) :: ps) =
  bind (match_lista A_ ps) (fn psa => SOME ((GCFun (f, ss), x) :: psa))
  | match_lista A_ ((GCFun (f, ss), Fun (g, ts)) :: ps) =
    bind (guard (eq A_ f g))
      (fn _ => bind (zip_option ss ts) (fn psa => match_lista A_ (psa @ ps)))
  | match_lista A_ ((GCHole, t) :: ps) = match_lista A_ ps
  | match_lista A_ [] = SOME [];

fun matchc A_ B_ (c, t) = bind (match_lista A_ [(c, t)]) (merge_all A_ B_);

fun matchb A_ B_ c t = not (is_none (matchc A_ B_ (c, t)));

fun capRM2 A_ B_ uu (Var uv) = GCHole
  | capRM2 A_ B_ rm (Fun (f, ts)) =
    let
      val h = GCFun (f, mapa (capRM2 A_ B_ rm) ts);
      val n = size_list ts;
    in
      (if list_ex (fn r => matchb A_ B_ h (fst r)) (rm (f, n)) then GCHole
        else h)
    end;

fun capRM A_ B_ nlv rm = (if nlv then capRM2 A_ B_ rm else (fn _ => GCHole));

fun partition p [] = ([], [])
  | partition p (x :: xs) =
    let
      val (yes, no) = partition p xs;
    in
      (if p x then (x :: yes, no) else (yes, x :: no))
    end;

fun removeAll A_ x [] = []
  | removeAll A_ x (y :: xs) =
    (if eq A_ x y then removeAll A_ x xs else y :: removeAll A_ x xs);

fun sub_vec x = take x;

fun sub_mat nr nc m = mapa (sub_vec nr) (take nc m);

fun vec_pre_gtI gt v w = list_ex (fn (a, b) => gt a b) (zip v w);

fun mat_pre_gtI gt m1 m2 =
  list_ex (fn (a, b) => vec_pre_gtI gt a b) (zip m1 m2);

fun mat_gtI A_ gt sd m1 m2 =
  mat_ge A_ m1 m2 andalso mat_pre_gtI gt (sub_mat sd sd m1) (sub_mat sd sd m2);

fun vec_map x = mapa x;

fun mat_map f = mapa (vec_map f);

fun emptya (Memory_ext (empty, lookup, store, more)) = empty;

fun store (Memory_ext (empty, lookup, store, more)) = store;

fun preorder_prod (A1_, A2_) (B1_, B2_) =
  {ord_preorder =
     ord_prod (A1_, (ord_preorder o preorder_order) A2_)
       (B1_, (ord_preorder o preorder_order) B2_)}
  : ('a * 'b) preorder;

fun order_prod (A1_, A2_) (B1_, B2_) =
  {preorder_order = preorder_prod (A1_, A2_) (B1_, B2_)} : ('a * 'b) order;

type 'a ordered_ab_semigroup =
  {ab_semigroup_add_ordered_ab_semigroup : 'a ab_semigroup_add,
    non_strict_order_ordered_ab_semigroup : 'a non_strict_order};
val ab_semigroup_add_ordered_ab_semigroup =
  #ab_semigroup_add_ordered_ab_semigroup :
  'a ordered_ab_semigroup -> 'a ab_semigroup_add;
val non_strict_order_ordered_ab_semigroup =
  #non_strict_order_ordered_ab_semigroup :
  'a ordered_ab_semigroup -> 'a non_strict_order;

type 'a max_ordered_monoid_add =
  {monoid_add_max_ordered_monoid_add : 'a monoid_add,
    ordered_ab_semigroup_max_ordered_monoid_add : 'a ordered_ab_semigroup,
    max0 : 'a -> 'a};
val monoid_add_max_ordered_monoid_add = #monoid_add_max_ordered_monoid_add :
  'a max_ordered_monoid_add -> 'a monoid_add;
val ordered_ab_semigroup_max_ordered_monoid_add =
  #ordered_ab_semigroup_max_ordered_monoid_add :
  'a max_ordered_monoid_add -> 'a ordered_ab_semigroup;
val max0 = #max0 : 'a max_ordered_monoid_add -> 'a -> 'a;

fun s_ins update x s = update x () s;

fun sharp_term shp (Var x) = Var x
  | sharp_term shp (Fun (f, ss)) = Fun (shp f, ss);

fun aarity sm f n = minus_nat (size_list (sm f n)) one_nata;

fun list_diff A_ [] ys = []
  | list_diff A_ (x :: xs) ys =
    let
      val zs = list_diff A_ xs ys;
    in
      (if membera A_ ys x then zs else x :: zs)
    end;

fun expecting A_ msg ts =
  Inl ([#"e", #"x", #"p", #"e", #"c", #"t", #"i", #"n", #"g", #":", #" "] @
        msg @ [#",", #" ", #"b", #"u", #"t", #" ", #"f", #"o", #"u", #"n", #"d",
                #":", #" "] @
                quote (shows_prec_list A_ Zero_nat
                        (take (nat (30 : IntInf.int)) ts))
                  []);

fun eoi A_ [] = Inr ((), [])
  | eoi A_ (v :: va) =
    expecting A_
      [#"e", #"n", #"d", #" ", #"o", #"f", #" ", #"i", #"n", #"p", #"u", #"t"]
      (v :: va);

fun xml_choice e [] x =
  Inl (concat
        [[#"e", #"r", #"r", #"o", #"r", #" ", #"i", #"n", #" ", #"p", #"a",
           #"r", #"s", #"i", #"n", #"g", #" ", #"c", #"h", #"o", #"i", #"c",
           #"e", #" ", #"f", #"o", #"r", #" "],
          e, [newline], shows_prec_xml Zero_nat x []])
  | xml_choice e (p :: ps) x =
    (case p x of Inl _ => xml_choice e ps x | Inr a => Inr a);

datatype ('a, 'b, 'c, 'd, 'e, 'f, 'g, 'h, 'i, 'j) alter = Alter1 of 'a |
  Alter2 of 'b | Alter3 of 'c | Alter4 of 'd | Alter5 of 'e | Alter6 of 'f |
  Alter7 of 'g | Alter8 of 'h | Alter9 of 'i | Alter10 of 'j;

fun xml0elements tag x (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso (null cs andalso is_none text))
    then Inr x else no_transform tag (Xml (name, atts, cs, text)));

fun xml4elements tag p1 p2 p3 p4 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (equal_nata (size_list cs) (nat (4 : IntInf.int)) andalso
            is_none text))
    then bindb (p1 (nth cs Zero_nat))
           (fn x1 =>
             bindb (p2 (nth cs one_nata))
               (fn x2 =>
                 bindb (p3 (nth cs (nat (2 : IntInf.int))))
                   (fn x3 =>
                     bindb (p4 (nth cs (nat (3 : IntInf.int))))
                       (fn x4 => Inr (f x1 x2 x3 x4)))))
    else no_transform tag (Xml (name, atts, cs, text)));

fun ctxt xml2name x =
  xml_options
    [([#"b", #"o", #"x"], xml0elements [#"b", #"o", #"x"] Hole),
      ([#"f", #"u", #"n", #"C", #"o", #"n", #"t", #"e", #"x", #"t"],
        xml4elements
          [#"f", #"u", #"n", #"C", #"o", #"n", #"t", #"e", #"x", #"t"] xml2name
          (xml_many_elements [#"b", #"e", #"f", #"o", #"r", #"e"]
            (term xml2name) id)
          (ctxt xml2name)
          (xml_many_elements [#"a", #"f", #"t", #"e", #"r"] (term xml2name) id)
          (fn a => fn b => fn c => fn d => More (a, b, c, d)))]
    x;

fun subst xml2name =
  xml_many_elements
    [#"s", #"u", #"b", #"s", #"t", #"i", #"t", #"u", #"t", #"i", #"o", #"n"]
    (xml2elements [#"s", #"u", #"b", #"s", #"t", #"E", #"n", #"t", #"r", #"y"]
      (text [#"v", #"a", #"r"]) (term xml2name) (fn a => fn b => (a, b)))
    id;

fun xml3to4elements tag p1 p2 p3 p4 f (Xml (name, atts, cs, text)) =
  let
    val l = size_list cs;
  in
    (if equal_lista equal_char name tag andalso
          (null atts andalso
            (less_eq_nat (nat (3 : IntInf.int)) l andalso
              (less_eq_nat l (nat (4 : IntInf.int)) andalso is_none text)))
      then bindb (p1 (nth cs Zero_nat))
             (fn x1 =>
               bindb (p2 (nth cs one_nata))
                 (fn x2 =>
                   (if equal_nata l (nat (4 : IntInf.int))
                     then bindb (p3 (nth cs (nat (2 : IntInf.int))))
                            (fn x3 =>
                              bindb (p4 (nth cs (nat (3 : IntInf.int))))
                                (fn x4 => Inr (f x1 x2 (SOME x3) x4)))
                     else bindb (p4 (nth cs (nat (2 : IntInf.int))))
                            (fn x4 => Inr (f x1 x2 NONE x4)))))
      else no_transform tag (Xml (name, atts, cs, text)))
  end;

fun rstep xml2name =
  xml3to4elements
    [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #"S", #"t", #"e", #"p"] pos
    (rule xml2name)
    (xml0elements [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e"] ())
    (term xml2name)
    (fn p => fn r => fn rel => fn t => (p, (r, (is_none rel, t))));

fun rsteps xml2name =
  xml1many_elements
    [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #"S", #"e", #"q", #"u", #"e",
      #"n", #"c", #"e"]
    (xml1element [#"s", #"t", #"a", #"r", #"t", #"T", #"e", #"r", #"m"]
      (term xml2name) id)
    (rstep xml2name) (fn a => fn b => (a, b));

fun loop xml2name =
  xml3elements [#"l", #"o", #"o", #"p"] (rsteps xml2name) (subst xml2name)
    (ctxt xml2name)
    (fn (s, rseq) => fn sigma => fn c => (s, (rseq, (sigma, c))));

fun proj xml2name =
  xml_change (afs xml2name)
    (fn afl =>
      Projection
        (mapa (fn (a, b) =>
                let
                  val (f, aa) = a;
                in
                  (fn ba =>
                    (case ba of Collapse ab => (f, ab) | AFList _ => (f, aa)))
                end
                  b)
          afl));

fun start_term A_ xml2name t =
  xml1element [#"s", #"t", #"a", #"r", #"t", #"T", #"e", #"r", #"m"]
    (fn xml =>
      bindb (term xml2name xml)
        (fn s =>
          (if equal_terma A_ (equal_list equal_char) s t then Inr t
            else Inl [#"<", #"s", #"t", #"a", #"r", #"t", #"T", #"e", #"r",
                       #"m", #">", #" ", #"d", #"o", #"e", #"s", #" ", #"n",
                       #"o", #"t", #" ", #"m", #"a", #"t", #"c", #"h", #" ",
                       #"l", #"h", #"s"])))
    id;

fun proj_term p (Var x) = Var x
  | proj_term p (Fun (f, ts)) =
    (if less_nat (p f) (size_list ts) then nth ts (p f) else Fun (f, ts));

fun rseq A_ xml2name pi r =
  xml1many_elements
    [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #"S", #"e", #"q", #"u", #"e",
      #"n", #"c", #"e"]
    (start_term A_ xml2name (proj_term pi (fst r))) (rstep xml2name)
    (fn _ => fn rseq => (r, mapa (fn (x, (y, (_, z))) => (x, (y, z))) rseq));

val semigroup_mult_int = {times_semigroup_mult = times_int} :
  int semigroup_mult;

val semigroup_add_int = {plus_semigroup_add = plus_int} : int semigroup_add;

val ab_semigroup_add_int = {semigroup_add_ab_semigroup_add = semigroup_add_int}
  : int ab_semigroup_add;

val semiring_int =
  {ab_semigroup_add_semiring = ab_semigroup_add_int,
    semigroup_mult_semiring = semigroup_mult_int}
  : int semiring;

fun label f n (Inl l) = Lab (f, l)
  | label f n (Inr l) = FunLab (f, l);

fun mat_max0 A_ = mat_map (max0 A_);

fun lookupb (Memory_ext (empty, lookup, store, more)) = lookup;

fun rito_map_to_sorted_list iterate m =
  iterate (fn u => fn v => (fn a => (u, v) :: a)) m [];

fun itoi_reverse_iterateo it = it (fn _ => true);

fun rm_reverse_iterateoi c f Emptya sigma = sigma
  | rm_reverse_iterateoi c f (Branch (col, l, k, v, r)) sigma =
    (if c sigma
      then let
             val sigmaa = rm_reverse_iterateoi c f r sigma;
           in
             (if c sigmaa then rm_reverse_iterateoi c f l (f k v sigmaa)
               else sigmaa)
           end
      else sigma);

fun rm_reverse_iterateoia B_ c f r = rm_reverse_iterateoi c f (impl_of B_ r);

fun rm_reverse_iterateo A_ = itoi_reverse_iterateo (rm_reverse_iterateoia A_);

fun rm_to_list A_ = rito_map_to_sorted_list (rm_reverse_iterateo A_);

fun values A_ m = maps snd (rm_to_list A_ m);

val linorder_nat = {order_linorder = order_nat} : nat linorder;

datatype ('a, 'b) tpoly = PVar of 'a | PNum of 'b | PSum of ('a, 'b) tpoly list
  | PMult of ('a, 'b) tpoly list;

val semigroup_mult_rat = {times_semigroup_mult = times_rat} :
  rat semigroup_mult;

val semigroup_add_rat = {plus_semigroup_add = plus_rat} : rat semigroup_add;

val ab_semigroup_add_rat = {semigroup_add_ab_semigroup_add = semigroup_add_rat}
  : rat ab_semigroup_add;

val semiring_rat =
  {ab_semigroup_add_semiring = ab_semigroup_add_rat,
    semigroup_mult_semiring = semigroup_mult_rat}
  : rat semiring;

fun s_memb lookup x s = not (is_none (lookup x s));

fun ctxt_apply Hole s = s
  | ctxt_apply (More (f, ss1, c, ss2)) s = Fun (f, ss1 @ ctxt_apply c s :: ss2);

fun equal_ctxt A_ B_ (More (f, list1, ctxt, list2)) Hole = false
  | equal_ctxt A_ B_ Hole (More (f, list1, ctxt, list2)) = false
  | equal_ctxt A_ B_ (More (fa, list1a, ctxta, list2a))
    (More (f, list1, ctxt, list2)) =
    eq A_ fa f andalso
      (equal_lista (equal_term A_ B_) list1a list1 andalso
        (equal_ctxt A_ B_ ctxta ctxt andalso
          equal_lista (equal_term A_ B_) list2a list2))
  | equal_ctxt A_ B_ Hole Hole = true;

fun hvf_top A_ a n (Fun (f, ts)) =
  (if eq A_ f a andalso equal_nata (size_list ts) n then not (is_var (hd ts))
    else true)
  | hvf_top A_ a n (Var uu) = false;

fun list_inter A_ [] bs = []
  | list_inter A_ (a :: asa) bs =
    (if membera A_ bs a then a :: list_inter A_ asa bs
      else list_inter A_ asa bs);

fun list_union A_ [] ys = ys
  | list_union A_ (x :: xs) ys =
    let
      val zs = list_union A_ xs ys;
    in
      (if membera A_ zs x then zs else x :: zs)
    end;

fun binda m f ts = bindb (m ts) (fn (a, b) => f a b);

fun many p [] = Inr ([], [])
  | many p (t :: ts) =
    (if p t then bindb (many p ts) (fn (rs, tsa) => Inr (t :: rs, tsa))
      else Inr ([], t :: ts));

val wspace : char list = [newline, #"\t", #"\r", #" "];

fun trim [] = []
  | trim (c :: s) = (if membera equal_char wspace c then trim s else c :: s);

datatype domain = Natural of nat | Arctic | Arctic_rat of rat |
  Int_mat of nat * nat | Arc_mat of nat | Arc_rat_mat of rat * nat |
  Rational of rat * nat | Rat_mat of rat * nat * nat;

fun labela xml2name =
  xml_options
    [([#"n", #"u", #"m", #"b", #"e", #"r", #"L", #"a", #"b", #"e", #"l"],
       xml_many_elements
         [#"n", #"u", #"m", #"b", #"e", #"r", #"L", #"a", #"b", #"e", #"l"]
         (nata [#"n", #"u", #"m", #"b", #"e", #"r"]) Inl),
      ([#"s", #"y", #"m", #"b", #"o", #"l", #"L", #"a", #"b", #"e", #"l"],
        xml_many_elements
          [#"s", #"y", #"m", #"b", #"o", #"l", #"L", #"a", #"b", #"e", #"l"]
          xml2name Inr)];

fun rules xml2name =
  xml_many_elements [#"r", #"u", #"l", #"e", #"s"] (rule xml2name) id;

fun state x = text [#"s", #"t", #"a", #"t", #"e"] x;

fun xml_lab A_ B_ (UnLab x) =
  Xml ([#"n", #"a", #"m", #"e"], [], [], SOME (shows_prec A_ Zero_nat x []))
  | xml_lab A_ B_ (Sharp x) =
    Xml ([#"s", #"h", #"a", #"r", #"p"], [], [xml_lab A_ B_ x], NONE)
  | xml_lab A_ B_ (FunLab (x, l)) =
    Xml ([#"l", #"a", #"b", #"e", #"l", #"e", #"d", #"S", #"y", #"m", #"b",
           #"o", #"l"],
          [], [xml_lab A_ B_ x,
                Xml ([#"s", #"y", #"m", #"b", #"o", #"l", #"L", #"a", #"b",
                       #"e", #"l"],
                      [], mapa (xml_lab A_ B_) l, NONE)],
          NONE)
  | xml_lab A_ B_ (Lab (x, l)) =
    Xml ([#"l", #"a", #"b", #"e", #"l", #"e", #"d", #"S", #"y", #"m", #"b",
           #"o", #"l"],
          [], [xml_lab A_ B_ x,
                Xml ([#"n", #"u", #"m", #"b", #"e", #"r", #"L", #"a", #"b",
                       #"e", #"l"],
                      [], mapa (fn n =>
                                 Xml ([#"n", #"u", #"m", #"b", #"e", #"r"], [],
                                       [], SOME (shows_prec B_ Zero_nat n [])))
                            l,
                      NONE)],
          NONE);

fun xml_term A_ B_ C_ (Var x) =
  Xml ([#"v", #"a", #"r"], [], [], SOME (shows_prec C_ Zero_nat x []))
  | xml_term A_ B_ C_ (Fun (f, ts)) =
    Xml ([#"f", #"u", #"n", #"a", #"p", #"p"], [],
          xml_lab A_ B_ f ::
            mapa (fn t =>
                   Xml ([#"a", #"r", #"g"], [], [xml_term A_ B_ C_ t], NONE))
              ts,
          NONE);

fun xml_Q A_ B_ C_ No_Strategy = []
  | xml_Q A_ B_ C_ Innermost =
    [Xml ([#"s", #"t", #"r", #"a", #"t", #"e", #"g", #"y"], [],
           [Xml ([#"i", #"n", #"n", #"e", #"r", #"m", #"o", #"s", #"t"], [], [],
                  NONE)],
           NONE)]
  | xml_Q A_ B_ C_ (Innermost_Q q) =
    [Xml ([#"s", #"t", #"r", #"a", #"t", #"e", #"g", #"y"], [],
           [Xml ([#"i", #"n", #"n", #"e", #"r", #"m", #"o", #"s", #"t", #"L",
                   #"h", #"s", #"s"],
                  [], mapa (xml_term A_ B_ C_) q, NONE)],
           NONE)];

fun isOK m = (case m of Inl _ => false | Inr _ => true);

val mult_zero_int = {times_mult_zero = times_int, zero_mult_zero = zero_int} :
  int mult_zero;

fun list_update (x :: xs) (Suc i) y = x :: list_update xs i y
  | list_update (x :: xs) Zero_nat y = y :: xs
  | list_update [] i y = [];

fun base (f, h) = f;

fun lift h f = (f, h);

fun vars_term_lista (Var x) = [x]
  | vars_term_lista (Fun (uu, ts)) = maps vars_term_lista ts;

fun vars_term_list B_ = remdups B_ o vars_term_lista;

fun roof B_ (l, r) =
  let
    val xs = vars_term_list B_ r;
  in
    (fn t =>
      let
        val xt = vars_term_list B_ t;
      in
        list_all (membera B_ xt) xs
      end)
  end;

fun mat_monoI geq1 sd m = list_all (list_ex geq1) (sub_mat sd sd m);

fun transpose nr [] = replicate nr []
  | transpose nr (v :: m) = mapa (fn (a, b) => a :: b) (zip v (transpose nr m));

fun scalar_prodI ze pl ti v w = foldr (fn (x, y) => pl (ti x y)) (zip v w) ze;

fun matT_vec_multI ze pl ti m v = mapa (fn w => scalar_prodI ze pl ti w v) m;

fun mat_multI ze pl ti nr m1 m2 =
  mapa (matT_vec_multI ze pl ti (transpose nr m1)) m2;

fun vec_plusI pl v w = mapa (fn xy => pl (fst xy) (snd xy)) (zip v w);

fun mat_plusI pl m1 m2 =
  mapa (fn uv => vec_plusI pl (fst uv) (snd uv)) (zip m1 m2);

fun equal_color B R = false
  | equal_color R B = false
  | equal_color B B = true
  | equal_color R R = true;

fun equal_rbtb A_ B_ (Branch (color, rbt1, a, b, rbt2)) Emptya = false
  | equal_rbtb A_ B_ Emptya (Branch (color, rbt1, a, b, rbt2)) = false
  | equal_rbtb A_ B_ (Branch (colora, rbt1a, aa, ba, rbt2a))
    (Branch (color, rbt1, a, b, rbt2)) =
    equal_color colora color andalso
      (equal_rbtb A_ B_ rbt1a rbt1 andalso
        (eq A_ aa a andalso (eq B_ ba b andalso equal_rbtb A_ B_ rbt2a rbt2)))
  | equal_rbtb A_ B_ Emptya Emptya = true;

fun equal_rbta (A1_, A2_) B_ ra r =
  equal_rbtb A1_ B_ (impl_of A2_ ra) (impl_of A2_ r);

fun equal_rbt (A1_, A2_) B_ = {equal = equal_rbta (A1_, A2_) B_} :
  ('a, 'b) rbt equal;

val mult_zero_rat = {times_mult_zero = times_rat, zero_mult_zero = zero_rat} :
  rat mult_zero;

fun fun_ofa B_ def xs a = (case lookupa B_ a xs of NONE => def | SOME b => b);

fun s_empty empt = empt;

fun s_union add = add;

fun varsL B_ lista x =
  foldr (fn eq => fn b =>
          membera B_ (vars_term_list B_ (fst eq)) x orelse
            (membera B_ (vars_term_list B_ (snd eq)) x orelse b))
    lista false;

fun decompose A_ s t =
  (case (s, t) of (Var _, b) => NONE | (Fun (f, ss), Var _) => NONE
    | (Fun (f, ss), Fun (g, ts)) =>
      (if eq A_ f g then zip_option ss ts else NONE));

fun simple_subst A_ x t (Var y) = (if eq A_ x y then t else Var y)
  | simple_subst A_ x t (Fun (f, ss)) = Fun (f, mapa (simple_subst A_ x t) ss);

fun simple_subst_list A_ x u lista =
  mapa (fn p => (simple_subst A_ x u (fst p), simple_subst A_ x u (snd p)))
    lista;

fun unify A_ B_ [] seen = SOME seen
  | unify A_ B_ ((Fun (f, ss), Fun (g, ts)) :: unifs) seen =
    (case decompose A_ (Fun (f, ss)) (Fun (g, ts)) of NONE => NONE
      | SOME eqs => unify A_ B_ (eqs @ unifs) seen)
  | unify A_ B_ ((Fun (f, ss), Var x) :: unifs) seen =
    unify A_ B_ ((Var x, Fun (f, ss)) :: unifs) seen
  | unify A_ B_ ((Var x, t) :: unifs) seen =
    (if equal_terma A_ B_ t (Var x) then unify A_ B_ unifs seen
      else (if membera B_ (vars_term_list B_ t) x then NONE
             else (if varsL B_ (unifs @ seen) x
                    then unify A_ B_
                           (simple_subst_list B_ x t (unifs @ seen) @
                             [(Var x, t)])
                           []
                    else unify A_ B_ unifs ((Var x, t) :: seen))));

fun subst_of B_ [] = Var
  | subst_of B_ ((Var x, t) :: ts) =
    (fn y => (if eq B_ x y then t else subst_of B_ ts y));

fun mgu A_ B_ s t =
  (case unify A_ B_ [(s, t)] [] of NONE => NONE
    | SOME res => SOME (subst_of B_ res));

fun linear_term_impl A_ xs (Var x) =
  (if membera A_ xs x then NONE else SOME (x :: xs))
  | linear_term_impl A_ xs (Fun (uu, [])) = SOME xs
  | linear_term_impl A_ xs (Fun (f, t :: ts)) =
    (case linear_term_impl A_ xs t of NONE => NONE
      | SOME ys => linear_term_impl A_ ys (Fun (f, ts)));

fun linear_term B_ t =
  (case linear_term_impl B_ [] t of NONE => false | SOME _ => true);

fun map_term_wa fg (Var x) = Var x
  | map_term_wa fg (Fun (f, ts)) =
    Fun (fg f (size_list ts), mapa (map_term_wa fg) ts);

fun rq (TA_rule (f, qs, q)) = q;

fun hvf_term A_ a t =
  (case unapp A_ a t of (Var _, ts) => null ts
    | (Fun (_, us), ts) => list_all (hvf_term A_ a) (us @ ts));

fun oneof_aux allowed [] ts =
  expecting show_char
    ([#"o", #"n", #"e", #" ", #"o", #"f", #" "] @
      shows_list_list show_char allowed [])
    ts
  | oneof_aux allowed (x :: xs) ts =
    (if equal_lista equal_char (mapa snd (zip x ts)) x
      then Inr (x, trim (drop (size_list x) ts)) else oneof_aux allowed xs ts);

fun oneof xs = oneof_aux xs xs;

datatype xmldoc = Xmldoc of char list * xml;

fun xml5elements tag p1 p2 p3 p4 p5 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (equal_nata (size_list cs) (nat (5 : IntInf.int)) andalso
            is_none text))
    then bindb (p1 (nth cs Zero_nat))
           (fn x1 =>
             bindb (p2 (nth cs one_nata))
               (fn x2 =>
                 bindb (p3 (nth cs (nat (2 : IntInf.int))))
                   (fn x3 =>
                     bindb (p4 (nth cs (nat (3 : IntInf.int))))
                       (fn x4 =>
                         bindb (p5 (nth cs (nat (4 : IntInf.int))))
                           (fn x5 => Inr (f x1 x2 x3 x4 x5))))))
    else no_transform tag (Xml (name, atts, cs, text)));

fun catch m f = (case m of Inl a => f a | Inr a => Inr a);

fun forallm f [] = Inr ()
  | forallm f (x :: xs) =
    bindb (catch (f x) (fn xa => Inl (x, xa))) (fn _ => forallm f xs);

fun check b e = (if b then Inr () else Inl e);

fun check_edges ss g c d =
  catch (forallm
          (fn n =>
            catch (forallm
                    (fn m =>
                      check (not (g (m, n)))
                        (shows_string
                           [#"e", #"d", #"g", #"e", #" ", #"f", #"r", #"o",
                             #"m", #" "] o
                          (ss m o
                            (shows_string [#" ", #"t", #"o", #" "] o ss n))))
                    d)
              (fn x => Inl (snd x)))
          c)
    (fn x => Inl (snd x));

val monoid_add_int =
  {semigroup_add_monoid_add = semigroup_add_int, zero_monoid_add = zero_int} :
  int monoid_add;

val comm_monoid_add_int =
  {ab_semigroup_add_comm_monoid_add = ab_semigroup_add_int,
    monoid_add_comm_monoid_add = monoid_add_int}
  : int comm_monoid_add;

val semiring_0_int =
  {comm_monoid_add_semiring_0 = comm_monoid_add_int,
    mult_zero_semiring_0 = mult_zero_int, semiring_semiring_0 = semiring_int}
  : int semiring_0;

val monoid_mult_int =
  {semigroup_mult_monoid_mult = semigroup_mult_int,
    power_monoid_mult = power_int}
  : int monoid_mult;

val zero_neq_one_int =
  {one_zero_neq_one = one_int, zero_zero_neq_one = zero_int} : int zero_neq_one;

val semiring_1_int =
  {monoid_mult_semiring_1 = monoid_mult_int,
    semiring_0_semiring_1 = semiring_0_int,
    zero_neq_one_semiring_1 = zero_neq_one_int}
  : int semiring_1;

fun rel_pow_impl succ un memb new have Zero_nat = un new have
  | rel_pow_impl succ un memb new have (Suc m) =
    (if null new then have
      else let
             val maybe = succ new;
             val havea = un new have;
             val newa = filter (fn n => not (memb n havea)) maybe;
           in
             rel_pow_impl succ un memb newa havea m
           end);

fun rtrancl_impl gen_succ un memb emp rel =
  let
    val succ = gen_succ rel;
    val n = size_list rel;
  in
    (fn asa => rel_pow_impl succ un memb asa emp n)
  end;

fun rtrancl_list_impl A_ =
  rtrancl_impl
    (fn r => fn asa =>
      remdups A_
        (map_filter
          (fn x =>
            (if let
                  val (a, _) = x;
                in
                  membera A_ asa a
                end
              then SOME (snd x) else NONE))
          r))
    (fn xs => fn ys => filter (fn x => not (membera A_ ys x)) xs @ ys)
    (fn x => fn xs => membera A_ xs x) [];

fun w_impl A_ d =
  let
    val filt = filter (fn (x, y) => not (eq A_ x y));
    val xvs = maps (fn (x, t) => mapa (fn a => (x, a)) (vars_term_list A_ t)) d;
    val rel = filt xvs;
    val rtran = rtrancl_list_impl A_ rel;
  in
    (fn t => rtran (vars_term_list A_ t))
  end;

fun match x = (fn _ => fn _ => true) x;

fun linorder_prod (A1_, A2_) (B1_, B2_) =
  {order_linorder =
     order_prod (A1_, order_linorder A2_) (B1_, order_linorder B2_)}
  : ('a * 'b) linorder;

val top_boola : bool = true;

val top_bool = {order_top = order_bool, top = top_boola} : bool top;

fun top_fun B_ = (fn _ => top B_);

fun equal_posa (PCons (nat, pos)) Empty = false
  | equal_posa Empty (PCons (nat, pos)) = false
  | equal_posa (PCons (nata, posa)) (PCons (nat, pos)) =
    equal_nata nata nat andalso equal_posa posa pos
  | equal_posa Empty Empty = true;

val equal_pos = {equal = equal_posa} : pos equal;

fun rm_update A_ = insert A_;

fun itoi_iterateo it = it (fn _ => true);

fun rm_iterateoi c f Emptya sigma = sigma
  | rm_iterateoi c f (Branch (col, l, k, v, r)) sigma =
    (if c sigma
      then let
             val sigmaa = rm_iterateoi c f l sigma;
           in
             (if c sigmaa then rm_iterateoi c f r (f k v sigmaa) else sigmaa)
           end
      else sigma);

fun rm_iterateoia B_ c f r = rm_iterateoi c f (impl_of B_ r);

fun rm_iterateo A_ = itoi_iterateo (rm_iterateoia A_);

fun rm_iterate A_ = rm_iterateo A_;

fun rm_add A_ = it_add (rm_update A_) (rm_iterate A_);

fun rs_ins A_ = s_ins (rm_update A_);

fun equal_order_tag Mul Lex = false
  | equal_order_tag Lex Mul = false
  | equal_order_tag Mul Mul = true
  | equal_order_tag Lex Lex = true;

fun diag_l (a, b) = ((a, a), b);

fun lex_ext_efficient_m f [] [] m = ((false, true), m)
  | lex_ext_efficient_m f (uu :: uv) [] m = ((true, true), m)
  | lex_ext_efficient_m f [] (uw :: ux) m = ((false, false), m)
  | lex_ext_efficient_m f (a :: asa) (b :: bs) m =
    let
      val (aa, ba) = f a b m;
    in
      let
        val (s, ns) = aa;
      in
        (fn ma =>
          (if s then ((true, true), ma)
            else (if ns then lex_ext_efficient_m f asa bs ma
                   else ((false, false), ma))))
      end
        ba
    end;

fun filter_not_stri_efficient_m_aux f [] bs m = (bs, m)
  | filter_not_stri_efficient_m_aux f (a :: asa) bs m =
    let
      val (b, c) = f a m;
    in
      let
        val (s, _) = b;
      in
        (fn ma =>
          (if s then filter_not_stri_efficient_m_aux f asa bs ma
            else filter_not_stri_efficient_m_aux f asa (a :: bs) ma))
      end
        c
    end;

fun filter_not_stri_efficient_m f asa m =
  let
    val (ys, a) = filter_not_stri_efficient_m_aux f asa [] m;
  in
    (rev ys, a)
  end;

fun mul_ext_efficient_m A_ f [] [] m = ((false, true), m)
  | mul_ext_efficient_m A_ f [] (v :: va) m = ((false, false), m)
  | mul_ext_efficient_m A_ f (v :: va) [] m = ((true, true), m)
  | mul_ext_efficient_m A_ f (v :: va) (y :: ys) m =
    ex_dom_efficient_m A_ f y (v :: va) (v :: va) ys m
and ex_dom_efficient_m A_ f y [] uw ux m = ((false, false), m)
  | ex_dom_efficient_m A_ f y (b :: bs) xs ys m =
    let
      val (a, c) = f b y m;
    in
      let
        val (s, ns) = a;
      in
        (fn ma =>
          (if s then let
                       val (ysa, m2) = filter_not_stri_efficient_m (f b) ys ma;
                       val (aa, ba) =
                         mul_ext_efficient_m A_ f (remove1 A_ b xs) ysa m2;
                     in
                       let
                         val (_, ns1) = aa;
                       in
                         (fn m3 =>
                           (if ns1 then ((true, true), m3)
                             else ex_dom_efficient_m A_ f y bs xs ys m3))
                       end
                         ba
                     end
            else (if ns
                   then let
                          val (aa, ba) =
                            mul_ext_efficient_m A_ f (remove1 A_ b xs) ys ma;
                        in
                          let
                            val (s1, ns1) = aa;
                          in
                            (fn mb =>
                              (if s1 then ((true, true), mb)
                                else let
                                       val (ab, bb) =
 ex_dom_efficient_m A_ f y bs xs ys mb;
                                     in
                                       let
 val (s2, ns2) = ab;
                                       in
 (fn m3 => (if s2 then ((true, true), m3) else ((false, ns1 orelse ns2), m3)))
                                       end
 bb
                                     end))
                          end
                            ba
                        end
                   else ex_dom_efficient_m A_ f y bs xs ys ma)))
      end
        c
    end;

fun all_stri_efficient_m f [] m = (true, m)
  | all_stri_efficient_m f (a :: asa) m =
    let
      val (aa, b) = f a m;
    in
      let
        val (s, _) = aa;
      in
        (fn ma => (if s then all_stri_efficient_m f asa ma else (false, ma)))
      end
        b
    end;

fun any_nstri_efficient_m f [] m = (false, m)
  | any_nstri_efficient_m f (a :: asa) m =
    let
      val (aa, b) = f a m;
    in
      let
        val (_, ns) = aa;
      in
        (fn ma => (if ns then (true, ma) else any_nstri_efficient_m f asa ma))
      end
        b
    end;

fun rpo_efficient_m B_ C_ model pr tag s t m =
  (case lookupb model m (s, t)
    of NONE =>
      let
        val (res, res_m) =
          (case (s, t) of (Var x, Var y) => ((false, eq C_ x y), m)
            | (Var x, Fun (g, ts)) => ((false, null ts andalso snd pr g), m)
            | (Fun (f, ss), Var y) =>
              diag_l
                (any_nstri_efficient_m
                  (fn sa => rpo_efficient_m B_ C_ model pr tag sa (Var y)) ss m)
            | (Fun (f, ss), Fun (g, ts)) =>
              (case any_nstri_efficient_m
                      (fn sa =>
                        rpo_efficient_m B_ C_ model pr tag sa (Fun (g, ts)))
                      ss m
                of (true, ma) => ((true, true), ma)
                | (false, ma) =>
                  let
                    val maa = size_list ss;
                    val n = size_list ts;
                  in
                    (case fst pr f maa g n
                      of (prs, true) =>
                        (case all_stri_efficient_m
                                (rpo_efficient_m B_ C_ model pr tag
                                  (Fun (f, ss)))
                                ts ma
                          of (true, mb) =>
                            (if prs then ((true, true), mb)
                              else let
                                     val cf = tag f maa;
                                   in
                                     (if equal_order_tag cf (tag g n)
                                       then (if equal_order_tag cf Mul
      then mul_ext_efficient_m (equal_term B_ C_)
             (rpo_efficient_m B_ C_ model pr tag) ss ts mb
      else lex_ext_efficient_m (rpo_efficient_m B_ C_ model pr tag) ss ts mb)
                                       else let
      val b = equal_nata n Zero_nat;
    in
      ((not (equal_nata maa Zero_nat) andalso b, b), mb)
    end)
                                   end)
                          | (false, mb) => ((false, false), mb))
                      | (prs, false) => ((false, false), ma))
                  end));
      in
        (res, store model res_m ((s, t), res))
      end
    | SOME v => (v, m));

fun efficient_rpo_2 A_ B_ pr tag p q =
  fst (rpo_efficient_m A_ B_ (l2m (equal_term A_ B_) (equal_term A_ B_)) pr tag
        p q (emptya (l2m (equal_term A_ B_) (equal_term A_ B_)) ()));

fun rpo_unbounded_impl A_ B_ = efficient_rpo_2 A_ B_;

fun rpo_unbounded A_ B_ = rpo_unbounded_impl A_ B_;

val monoid_add_rat =
  {semigroup_add_monoid_add = semigroup_add_rat, zero_monoid_add = zero_rat} :
  rat monoid_add;

val comm_monoid_add_rat =
  {ab_semigroup_add_comm_monoid_add = ab_semigroup_add_rat,
    monoid_add_comm_monoid_add = monoid_add_rat}
  : rat comm_monoid_add;

val semiring_0_rat =
  {comm_monoid_add_semiring_0 = comm_monoid_add_rat,
    mult_zero_semiring_0 = mult_zero_rat, semiring_semiring_0 = semiring_rat}
  : rat semiring_0;

val monoid_mult_rat =
  {semigroup_mult_monoid_mult = semigroup_mult_rat,
    power_monoid_mult = power_rat}
  : rat monoid_mult;

val zero_neq_one_rat =
  {one_zero_neq_one = one_rat, zero_zero_neq_one = zero_rat} : rat zero_neq_one;

val semiring_1_rat =
  {monoid_mult_semiring_1 = monoid_mult_rat,
    semiring_0_semiring_1 = semiring_0_rat,
    zero_neq_one_semiring_1 = zero_neq_one_rat}
  : rat semiring_1;

fun equal_suma A_ B_ (Inr b) (Inl a) = false
  | equal_suma A_ B_ (Inl a) (Inr b) = false
  | equal_suma A_ B_ (Inr ba) (Inr b) = eq B_ ba b
  | equal_suma A_ B_ (Inl aa) (Inl a) = eq A_ aa a;

fun equal_sum A_ B_ = {equal = equal_suma A_ B_} : ('a, 'b) sum equal;

datatype ('a, 'b, 'c) redtriple_ext =
  Redtriple_ext of
    ((char list -> char list), unit) sum *
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
      ('a -> nat -> nat -> bool) * ((char list -> char list), unit) sum *
      (char list -> char list) * 'c;

fun s (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = s;

fun match_vars A_ B_ [] = SOME Var
  | match_vars A_ B_ ((x, t) :: ps) =
    (case lookupa A_ x ps
      of NONE =>
        (case match_vars A_ B_ ps of NONE => NONE
          | SOME sigma => SOME (fun_upd A_ sigma x t))
      | SOME s =>
        (if equal_terma B_ A_ t s then match_vars A_ B_ ps else NONE));

fun match_term_list A_ [] = SOME []
  | match_term_list A_ ((Var uu, Fun (uv, uw)) :: ps) = NONE
  | match_term_list A_ ((Fun (f, ts), Fun (g, ls)) :: ps) =
    bind (guard (eq A_ f g))
      (fn _ =>
        bind (zip_option ts ls) (fn eqs => match_term_list A_ (eqs @ ps)))
  | match_term_list A_ ((t, Var x) :: ps) =
    bind (match_term_list A_ ps) (fn eqs => SOME ((x, t) :: eqs));

fun match_list A_ B_ tls =
  (case match_term_list A_ tls of NONE => NONE | SOME a => match_vars B_ A_ a);

fun instance_rule A_ B_ lr st =
  not (is_none (match_list A_ B_ [(fst lr, fst st), (snd lr, snd st)]));

fun equal_lab A_ B_ = {equal = equal_laba A_ B_} : ('a, 'b) lab equal
and equal_laba A_ B_ (Sharp lab) (UnLab f) = false
  | equal_laba A_ B_ (UnLab f) (Sharp lab) = false
  | equal_laba A_ B_ (Sharp laba) (FunLab (lab, lista)) = false
  | equal_laba A_ B_ (FunLab (laba, lista)) (Sharp lab) = false
  | equal_laba A_ B_ (UnLab f) (FunLab (lab, lista)) = false
  | equal_laba A_ B_ (FunLab (lab, lista)) (UnLab f) = false
  | equal_laba A_ B_ (Sharp laba) (Lab (lab, l)) = false
  | equal_laba A_ B_ (Lab (laba, l)) (Sharp lab) = false
  | equal_laba A_ B_ (UnLab f) (Lab (lab, l)) = false
  | equal_laba A_ B_ (Lab (lab, l)) (UnLab f) = false
  | equal_laba A_ B_ (FunLab (laba, lista)) (Lab (lab, l)) = false
  | equal_laba A_ B_ (Lab (laba, l)) (FunLab (lab, lista)) = false
  | equal_laba A_ B_ (Sharp laba) (Sharp lab) = equal_laba A_ B_ laba lab
  | equal_laba A_ B_ (UnLab fa) (UnLab f) = eq A_ fa f
  | equal_laba A_ B_ (FunLab (laba, listaa)) (FunLab (lab, lista)) =
    equal_laba A_ B_ laba lab andalso equal_lista (equal_lab A_ B_) listaa lista
  | equal_laba A_ B_ (Lab (laba, la)) (Lab (lab, l)) =
    equal_laba A_ B_ laba lab andalso eq B_ la l;

fun gen_label f Zero_nat = f
  | gen_label f (Suc n) = FunLab (gen_label f n, []);

fun label_depth (UnLab uu) = Zero_nat
  | label_depth (Lab (f, uv)) = Suc (label_depth f)
  | label_depth (FunLab (f, uw)) = Suc (label_depth f)
  | label_depth (Sharp f) = Suc (label_depth f);

fun fmap A_ B_ a nn sml =
  let
    val m = Suc (max_list (mapa label_depth (a :: maps snd sml)));
  in
    (fn f => fn n =>
      (if equal_proda (equal_lab A_ B_) equal_nat (f, n) (a, nn) then a
        else gen_label f m))
  end;

fun concat_lists [] = [[]]
  | concat_lists (asa :: xs) =
    let
      val a = concat_lists xs;
    in
      maps (fn vec => mapa (fn aa => aa :: vec) asa) a
    end;

fun enum_vectors c [] = [[]]
  | enum_vectors c (x :: xs) =
    let
      val a = enum_vectors c xs;
    in
      maps (fn vec => mapa (fn ca => (x, ca) :: vec) c) a
    end;

fun manyof cs = many (membera equal_char cs);

fun spaces x = binda (manyof wspace) (fn _ => fn ts => Inr ((), ts)) x;

fun xml2nd_choice tag p1 cn p2 f (Xml (name, atts, cs, text)) =
  let
    val l = size_list cs;
  in
    (if equal_lista equal_char name tag andalso
          (null atts andalso
            (less_eq_nat (nat (2 : IntInf.int)) l andalso is_none text))
      then bindb (p1 (nth cs Zero_nat))
             (fn x1 =>
               bindb (boola cn (nth cs one_nata))
                 (fn b =>
                   (if b then bindb (p2 (nth cs (minus_nat l one_nata)))
                                (fn x2 => Inr (f x1 (SOME x2)))
                     else Inr (f x1 NONE))))
      else no_transform tag (Xml (name, atts, cs, text)))
  end;

fun alter1a (Alter1 x) = x;

fun alter2a (Alter2 x) = x;

fun alter3a (Alter3 x) = x;

fun alter4a (Alter4 x) = x;

fun alter5a (Alter5 x) = x;

fun alter6a (Alter6 x) = x;

fun alter7a (Alter7 x) = x;

fun alter8a (Alter8 x) = x;

fun alter9a (Alter9 x) = x;

datatype ('a, 'b, 'c, 'd) dpp_ops_ext =
  Dpp_ops_ext of
    ('a ->
      (('b, 'c) term * ('b, 'c) term -> bool) *
        ((('b, 'c) term * ('b, 'c) term -> bool) *
          ((('b, 'c) term -> bool) *
            ((('b, 'c) term * ('b, 'c) term -> bool) *
              (('b, 'c) term * ('b, 'c) term -> bool))))) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> ('b, 'c) term list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) * ('a -> bool) *
      ('a -> bool) * ('a -> bool) * ('a -> ('b, 'c) term -> bool) *
      ('a -> bool) * ('a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list -> 'a) *
      ('a ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list -> 'a) *
      ('a ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list -> 'a) *
      ('a ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list *
            (('b, 'c) term * ('b, 'c) term) list) *
      ('a ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list *
            (('b, 'c) term * ('b, 'c) term) list) *
      ((('b, 'c) term * ('b, 'c) term) list ->
        (('b, 'c) term * ('b, 'c) term) list ->
          ('b, 'c) term list ->
            (('b, 'c) term * ('b, 'c) term) list ->
              (('b, 'c) term * ('b, 'c) term) list -> 'a) *
      'd;

fun rules_mapb
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = rules_map;

fun rules_no_left_vara
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = rules_no_left_var;

fun capRM_dpp B_ C_ i dpp =
  capRM B_ C_ (rules_no_left_vara i dpp) (rules_mapb i dpp);

fun conflict_pos A_ B_ mu (Fun (f, ts), (Fun (g, ss), n)) =
  (if eq B_ f g andalso equal_nata (size_list ts) (size_list ss)
    then maps (fn (s, t) => conflict_pos A_ B_ mu (s, (t, n))) (zip ts ss)
    else [(Fun (f, ts), (Fun (g, ss), n))])
  | conflict_pos A_ B_ mu (Var x, (Fun (g, ss), n)) =
    [(Var x, (Fun (g, ss), n))]
  | conflict_pos A_ B_ mu (Fun (f, ts), (Var y, Zero_nat)) =
    [(Var y, (Fun (f, ts), Zero_nat))]
  | conflict_pos A_ B_ mu (Var x, (Var y, Zero_nat)) =
    (if eq A_ x y then [] else [(Var x, (Var y, Zero_nat))])
  | conflict_pos A_ B_ mu (s, (Var x, Suc n)) =
    conflict_pos A_ B_ mu (s, (mu x, n));

fun height (f, h) = h;

fun equal_optiona A_ (SOME a) NONE = false
  | equal_optiona A_ NONE (SOME a) = false
  | equal_optiona A_ (SOME aa) (SOME a) = eq A_ aa a
  | equal_optiona A_ NONE NONE = true;

fun equal_option A_ = {equal = equal_optiona A_} : ('a option) equal;

fun one_poly B_ =
  [([], one ((one_power o power_monoid_mult o monoid_mult_semiring_1) B_))];

fun eq_monom A_ [] n = null n
  | eq_monom A_ ((x, p) :: m) n =
    (case extract (fn yq => eq A_ (fst yq) x) n of NONE => false
      | SOME (n1, ((_, q), n2)) =>
        equal_nata p q andalso eq_monom A_ m (n1 @ n2));

fun poly_add A_ (B1_, B2_) [] q = q
  | poly_add A_ (B1_, B2_) ((m, c) :: p) q =
    (case extract (fn mc => eq_monom A_ (fst mc) m) q
      of NONE => (m, c) :: poly_add A_ (B1_, B2_) p q
      | SOME (q1, ((_, d), q2)) =>
        (if eq B1_
              (plus ((plus_semigroup_add o semigroup_add_monoid_add o
                       monoid_add_comm_monoid_add o comm_monoid_add_semiring_0)
                      B2_)
                c d)
              (zero ((zero_mult_zero o mult_zero_semiring_0) B2_))
          then poly_add A_ (B1_, B2_) p (q1 @ q2)
          else (m, plus ((plus_semigroup_add o semigroup_add_monoid_add o
                           monoid_add_comm_monoid_add o
                           comm_monoid_add_semiring_0)
                          B2_)
                     c d) ::
                 poly_add A_ (B1_, B2_) p (q1 @ q2)));

fun monom_mult A_ [] n = n
  | monom_mult A_ ((x, p) :: m) n =
    (case extract (fn yq => eq A_ (fst yq) x) n
      of NONE => (x, p) :: monom_mult A_ m n
      | SOME (n1, ((_, q), n2)) =>
        (x, plus_nata p q) :: monom_mult A_ m (n1 @ n2));

fun monom_mult_poly A_ (B1_, B2_) uu [] = []
  | monom_mult_poly A_ (B1_, B2_) (ma, c) ((m, d) :: p) =
    (if eq B1_ (times ((times_mult_zero o mult_zero_semiring_0) B2_) c d)
          (zero ((zero_mult_zero o mult_zero_semiring_0) B2_))
      then monom_mult_poly A_ (B1_, B2_) (ma, c) p
      else (monom_mult A_ ma m,
             times ((times_mult_zero o mult_zero_semiring_0) B2_) c d) ::
             monom_mult_poly A_ (B1_, B2_) (ma, c) p);

fun poly_mult A_ (B1_, B2_) [] q = []
  | poly_mult A_ (B1_, B2_) (mc :: p) q =
    poly_add A_ (B1_, B2_) (monom_mult_poly A_ (B1_, B2_) mc q)
      (poly_mult A_ (B1_, B2_) p q);

val zero_poly : (('a * nat) list * 'b) list = [];

fun poly_of A_ (B1_, B2_) (PNum i) =
  (if eq B1_ i
        (zero ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_semiring_1 o
                 semiring_1_comm_semiring_1)
                B2_))
    then [] else [([], i)])
  | poly_of A_ (B1_, B2_) (PVar x) =
    [([(x, one_nata)],
       one ((one_power o power_monoid_mult o monoid_mult_semiring_1 o
              semiring_1_comm_semiring_1)
             B2_))]
  | poly_of A_ (B1_, B2_) (PSum []) = zero_poly
  | poly_of A_ (B1_, B2_) (PSum (p :: ps)) =
    poly_add A_ (B1_, (semiring_0_semiring_1 o semiring_1_comm_semiring_1) B2_)
      (poly_of A_ (B1_, B2_) p) (poly_of A_ (B1_, B2_) (PSum ps))
  | poly_of A_ (B1_, B2_) (PMult []) = one_poly (semiring_1_comm_semiring_1 B2_)
  | poly_of A_ (B1_, B2_) (PMult (p :: ps)) =
    poly_mult A_ (B1_, (semiring_0_semiring_1 o semiring_1_comm_semiring_1) B2_)
      (poly_of A_ (B1_, B2_) p) (poly_of A_ (B1_, B2_) (PMult ps));

fun rm_lookup A_ k m = lookup A_ m k;

fun rs_memb A_ = s_memb (rm_lookup A_);

fun shows_rpo_repr A_ prs =
  shows_string
    [#"R", #"P", #"O", #" ", #"w", #"i", #"t", #"h", #" ", #"t", #"h", #"e",
      #" ", #"f", #"o", #"l", #"l", #"o", #"w", #"i", #"n", #"g", #" ", #"p",
      #"r", #"e", #"c", #"e", #"d", #"e", #"n", #"c", #"e"] o
    (shows_nl o
      (shows_map
         (fn (a, b) =>
           let
             val (f, n) = a;
           in
             (fn (pr, _) =>
               shows_string
                 [#"p", #"r", #"e", #"c", #"e", #"d", #"e", #"n", #"c", #"e",
                   #"("] o
                 (shows_prec A_ Zero_nat f o
                   (shows_string [#"["] o
                     (shows_prec_nat Zero_nat n o
                       (shows_string [#"]", #")", #" ", #"=", #" "] o
                         (shows_prec_nat Zero_nat pr o shows_nl))))))
           end
             b)
         prs o
        (shows_nl o
          (shows_string
             [#"p", #"r", #"e", #"c", #"e", #"d", #"e", #"n", #"c", #"e", #"(",
               #"_", #")", #" ", #"=", #" ", #"0"] o
            (shows_nl o
              (shows_string
                 [#"a", #"n", #"d", #" ", #"t", #"h", #"e", #" ", #"f", #"o",
                   #"l", #"l", #"o", #"w", #"i", #"n", #"g", #" ", #"s", #"t",
                   #"a", #"t", #"u", #"s"] o
                (shows_nl o
                  (shows_map
                     (fn (a, b) =>
                       let
                         val (f, n) = a;
                       in
                         (fn (_, s) =>
                           shows_string
                             [#"s", #"t", #"a", #"t", #"u", #"s", #"("] o
                             (shows_prec A_ Zero_nat f o
                               (shows_string [#"["] o
                                 (shows_prec_nat Zero_nat n o
                                   (shows_string
                                      [#"]", #")", #" ", #"=", #" "] o
                                     (shows_string
(case s of Lex => [#"l", #"e", #"x"] | Mul => [#"m", #"u", #"l"]) o
                                       shows_nl))))))
                       end
                         b)
                     prs o
                    (shows_nl o
                      (shows_string
                         [#"s", #"t", #"a", #"t", #"u", #"s", #"(", #"_", #")",
                           #" ", #"=", #" ", #"l", #"e", #"x"] o
                        shows_nl))))))))));

fun scnp_af_to_af pia pi =
  (fn f => fn n =>
    let
      val is = mapa fst (pia (f, n));
    in
      (if list_ex (less_eq_nat n) is
        then let
               val isa = pi f n;
             in
               (fn i => isa i orelse membera equal_nat is i)
             end
        else membera equal_nat is)
    end);

fun s_isEmpty isEmpty = isEmpty;

fun matcha A_ B_ t l = match_list A_ B_ [(t, l)];

fun subst_apply_term (Var x) sigma = sigma x
  | subst_apply_term (Fun (f, ss)) sigma =
    Fun (f, mapa (fn t => subst_apply_term t sigma) ss);

fun subst_compose sigma tau = (fn x => subst_apply_term (sigma x) tau);

fun mk_subst A_ xts =
  (fn x => (case lookupa A_ x xts of NONE => Var x | SOME t => t));

fun shows_term funa var (Var x) = var x
  | shows_term funa var (Fun (f, ts)) =
    funa f o
      shows_list_gen id [] [#"("] [#",", #" "] [#")"]
        (mapa (shows_term funa var) ts);

fun shows_prec_term A_ B_ d =
  shows_term (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat);

fun shows_list_term A_ B_ is =
  shows_list_aux (shows_prec_term A_ B_ Zero_nat) is;

fun show_term A_ B_ =
  {shows_prec = shows_prec_term A_ B_, shows_list = shows_list_term A_ B_} :
  ('a, 'b) term show;

fun full_af f n i = true;

fun af (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = af;

fun ns (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = ns;

datatype ('a, 'b, 'c) root_redtriple_ext =
  Root_redtriple_ext of
    ((char list -> char list), unit) sum *
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
      (('a, 'b) term * ('a, 'b) term -> ((char list -> char list), unit) sum) *
      ('a -> nat -> nat -> bool) * ('a -> nat -> nat -> bool) *
      (char list -> char list) * 'c;

fun sa (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) = s;

fun equal_prod A_ B_ = {equal = equal_proda A_ B_} : ('a * 'b) equal;

fun defs_list A_ [] = []
  | defs_list A_ ((Fun (f, ss), r) :: ts) =
    let
      val fs = defs_list A_ ts;
      val n = size_list ss;
    in
      (if membera (equal_prod A_ equal_nat) fs (f, n) then fs else (f, n) :: fs)
    end
  | defs_list A_ ((Var x, r) :: ts) = defs_list A_ ts;

fun shows_pos (PCons (i, Empty)) = shows_prec_nat Zero_nat i
  | shows_pos (PCons (i, PCons (v, va))) =
    shows_prec_nat Zero_nat i o shows_pos (PCons (v, va))
  | shows_pos Empty = shows_string [#"e"];

fun shows_rule funa var arr (l, r) =
  shows_term funa var l o (shows_string arr o shows_term funa var r);

fun shows_rules funa var arr trs =
  shows_list_gen (shows_rule funa var arr) [] [] [newline] [] trs o shows_nl;

fun shows_trs funa var name arr r =
  shows_string name o (shows_nl o shows_rules funa var arr r);

fun apply_args a t [] = t
  | apply_args a t (s :: ss) = apply_args a (Fun (a, [t, s])) ss;

fun get_symbol sm f n i = nth (sm f n) i;

val letters : char list =
  [#"a", #"b", #"c", #"d", #"e", #"f", #"g", #"h", #"i", #"j", #"k", #"l", #"m",
    #"n", #"o", #"p", #"q", #"r", #"s", #"t", #"u", #"v", #"w", #"x", #"y",
    #"z", #"A", #"B", #"C", #"D", #"E", #"F", #"G", #"H", #"I", #"J", #"K",
    #"L", #"M", #"N", #"O", #"P", #"Q", #"R", #"S", #"T", #"U", #"V", #"W",
    #"X", #"Y", #"Z", #"_", #"0", #"1", #"2", #"3", #"4", #"5", #"6", #"7",
    #"8", #"9", #"&", #";", #":"];

fun alter10a (Alter10 x) = x;

fun sum_lpoly uu [] ys = ys
  | sum_lpoly uv (v :: va) [] = v :: va
  | sum_lpoly pl (x :: xs) (y :: ys) = pl x y :: sum_lpoly pl xs ys;

fun lpoly_of A_ uu uv uw ux (PNum i) = Inr (i, [])
  | lpoly_of A_ ze on pl ti (PVar x) = Inr (ze, replicate x ze @ [on])
  | lpoly_of A_ ze on pl ti (PSum []) = Inr (ze, [])
  | lpoly_of A_ ze on pl ti (PSum (p :: ps)) =
    bindb (lpoly_of A_ ze on pl ti p)
      (fn (cp, ncp) =>
        bindb (lpoly_of A_ ze on pl ti (PSum ps))
          (fn (cq, ncq) => Inr (pl cp cq, sum_lpoly pl ncp ncq)))
  | lpoly_of A_ ze on pl ti (PMult []) = Inr (on, [])
  | lpoly_of A_ ze on pl ti (PMult (p :: ps)) =
    bindb (lpoly_of A_ ze on pl ti p)
      (fn (cp, ncp) =>
        bindb (lpoly_of A_ ze on pl ti (PMult ps))
          (fn (cq, ncq) =>
            (if list_all (eq A_ ze) ncp then Inr (ti cp cq, mapa (ti cp) ncq)
              else (if list_all (eq A_ ze) ncq
                     then Inr (ti cp cq, mapa (fn x => ti x cq) ncp)
                     else Inl [#"c", #"a", #"n", #"n", #"o", #"t", #" ", #"t",
                                #"r", #"a", #"n", #"s", #"f", #"o", #"r", #"m",
                                #" ", #"n", #"o", #"n", #"-", #"l", #"i", #"n",
                                #"e", #"a", #"r", #" ", #"p", #"o", #"l", #"y",
                                #"n", #"o", #"m", #"i", #"a", #"l", #" ", #"t",
                                #"o", #" ", #"l", #"i", #"n", #"e", #"a", #"r",
                                #" ", #"p", #"o", #"l", #"y", #"n", #"o", #"m",
                                #"i", #"a", #"l"]))));

fun strategy xml2name =
  xml1element [#"s", #"t", #"r", #"a", #"t", #"e", #"g", #"y"]
    (xml_options
      [([#"i", #"n", #"n", #"e", #"r", #"m", #"o", #"s", #"t"],
         xml0elements [#"i", #"n", #"n", #"e", #"r", #"m", #"o", #"s", #"t"]
           Innermost),
        ([#"i", #"n", #"n", #"e", #"r", #"m", #"o", #"s", #"t", #"L", #"h",
           #"s", #"s"],
          xml_many_elements
            [#"i", #"n", #"n", #"e", #"r", #"m", #"o", #"s", #"t", #"L", #"h",
              #"s", #"s"]
            (term xml2name) Innermost_Q)])
    id;

fun matches A_ B_ t l =
  (case matcha A_ B_ t l of NONE => false | SOME _ => true);

fun supteq_list (Var x) = [Var x]
  | supteq_list (Fun (f, ts)) = Fun (f, ts) :: maps supteq_list ts;

fun nF_subset A_ B_ ls q =
  list_all
    (fn l =>
      list_ex (fn t => list_ex (fn u => matches A_ B_ u t) (supteq_list l)) q)
    ls;

fun less_list (A1_, A2_) (x :: xs) (y :: ys) =
  less ((ord_preorder o preorder_order) A2_) x y orelse
    eq A1_ x y andalso less_list (A1_, A2_) xs ys
  | less_list (A1_, A2_) [] (x :: xs) = true
  | less_list (A1_, A2_) xs [] = false;

fun less_eq_list (A1_, A2_) (x :: xs) (y :: ys) =
  less ((ord_preorder o preorder_order) A2_) x y orelse
    eq A1_ x y andalso less_eq_list (A1_, A2_) xs ys
  | less_eq_list (A1_, A2_) [] xs = true
  | less_eq_list (A1_, A2_) (x :: xs) [] = false;

fun ord_list (A1_, A2_) =
  {less_eq = less_eq_list (A1_, A2_), less = less_list (A1_, A2_)} :
  ('a list) ord;

fun mat_arc_posI ap m = ap (nth (nth m Zero_nat) Zero_nat);

fun poly_var A_ p v = membera A_ (maps (mapa fst o fst) p) v;

fun rm_alpha A_ = lookup A_;

fun rm_empty A_ = empty A_;

fun rs_empty A_ = s_empty (rm_empty A_);

fun rs_union A_ = s_union (rm_add A_);

fun rules_with (B1_, B2_) p m =
  map_filter (fn x => (if (p o fst) x then SOME (snd x) else NONE))
    (values (linorder_prod (B1_, B2_) (equal_nat, linorder_nat)) m);

fun s_iteratei iteratei c f s sigma_0 =
  iteratei c (fn k => fn _ => f k) s sigma_0;

datatype ('a, 'b, 'c, 'd) tp_ops_ext =
  Tp_ops_ext of
    ('a ->
      (('b, 'c) term -> bool) *
        ((('b, 'c) term * ('b, 'c) term -> bool) *
          (('b, 'c) term * ('b, 'c) term -> bool))) *
      ('a -> ('b, 'c) term list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a -> (('b, 'c) term * ('b, 'c) term) list) * ('a -> bool) *
      ('a -> ('b, 'c) term -> bool) * ('a -> bool) *
      ('a -> 'b * nat -> (('b, 'c) term * ('b, 'c) term) list) *
      ('a ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list -> 'a) *
      ('a ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list *
            (('b, 'c) term * ('b, 'c) term) list) *
      (('b, 'c) term list ->
        (('b, 'c) term * ('b, 'c) term) list ->
          (('b, 'c) term * ('b, 'c) term) list -> 'a) *
      'd;

fun qa
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = q;

fun mka
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = mk;

fun delete_R_Rwa
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = delete_R_Rw;

fun split_rulesa
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = split_rules;

fun split_tt B_ C_ i tp r_remove =
  let
    val (r, rw) = split_rulesa i tp r_remove;
    val tp1 = mka i (qa i tp) r rw;
    val a = delete_R_Rwa i tp r_remove r_remove;
  in
    (tp1, a)
  end;

fun poss_list (Var x) = [Empty]
  | poss_list (Fun (f, ss)) =
    Empty ::
      maps (fn (i, a) => mapa (fn aa => PCons (i, aa)) a)
        (zip (upt Zero_nat (size_list ss)) (mapa poss_list ss));

fun afa (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) = af;

fun aft (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) = aft;

fun nsa (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) = ns;

fun nst (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = nst;

fun aarity_term A_ a sm t =
  (case unapp A_ a t of (Var _, ts) => NONE
    | (Fun (f, ss), ts) =>
      SOME (minus_nat (aarity sm f (size_list ss)) (size_list ts)));

fun uncurry_top A_ a n sm (Fun (f, ts)) =
  let
    val mt =
      mapa (map_term_wa (fn fa => fn na => get_symbol sm fa na Zero_nat));
  in
    (if eq A_ f a andalso
          (equal_nata (size_list ts) n andalso
            (not (is_var (hd ts)) andalso
              not (equal_nata
                    (aarity sm (the (root (hd ts))) (num_args (hd ts)))
                    Zero_nat)))
      then let
             val Fun (g, ss) = hd ts;
           in
             Fun (get_symbol sm g (size_list ss) one_nata, mt (ss @ tl ts))
           end
      else Fun (get_symbol sm f (size_list ts) Zero_nat, mt ts))
  end
  | uncurry_top A_ a n sm (Var x) = Var x;

fun xml1to2elements tag p1 p2 f (Xml (name, atts, cs, text)) =
  let
    val l = size_list cs;
  in
    (if equal_lista equal_char name tag andalso
          (null atts andalso
            (less_eq_nat one_nata l andalso
              (less_eq_nat l (nat (2 : IntInf.int)) andalso is_none text)))
      then bindb (p1 (nth cs Zero_nat))
             (fn x1 =>
               (if equal_nata l (nat (2 : IntInf.int))
                 then bindb (p2 (nth cs one_nata))
                        (fn x2 => Inr (f x1 (SOME x2)))
                 else Inr (f x1 NONE)))
      else no_transform tag (Xml (name, atts, cs, text)))
  end;

fun arith_fun xml =
  xml1element
    [#"a", #"r", #"i", #"t", #"h", #"F", #"u", #"n", #"c", #"t", #"i", #"o",
      #"n"]
    (xml_options
      [([#"n", #"a", #"t", #"u", #"r", #"a", #"l"],
         xml_change (nata [#"n", #"a", #"t", #"u", #"r", #"a", #"l"]) Const),
        ([#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e"],
          xml_change (nata [#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e"])
            (fn n => Arg (minus_nat n one_nata))),
        ([#"s", #"u", #"m"],
          xml_many_elements [#"s", #"u", #"m"] arith_fun Sum),
        ([#"p", #"r", #"o", #"d", #"u", #"c", #"t"],
          xml_many_elements [#"p", #"r", #"o", #"d", #"u", #"c", #"t"] arith_fun
            Prod),
        ([#"m", #"i", #"n"],
          xml_many_elements [#"m", #"i", #"n"] arith_fun Min),
        ([#"m", #"a", #"x"],
          xml_many_elements [#"m", #"a", #"x"] arith_fun Max)])
    id xml;

fun int_coeff x = inta [#"i", #"n", #"t", #"e", #"g", #"e", #"r"] x;

fun vec_coeff xml2coeff =
  xml_many_elements [#"v", #"e", #"c", #"t", #"o", #"r"]
    (xml1element
      [#"c", #"o", #"e", #"f", #"f", #"i", #"c", #"i", #"e", #"n", #"t"]
      xml2coeff id)
    id;

fun mat_coeff ze xml2coeff =
  xml_options
    [([#"m", #"a", #"t", #"r", #"i", #"x"],
       xml_many_elements [#"m", #"a", #"t", #"r", #"i", #"x"]
         (vec_coeff xml2coeff) id),
      ([#"v", #"e", #"c", #"t", #"o", #"r"],
        xml_change (vec_coeff xml2coeff)
          (fn v =>
            v :: replicate (minus_nat (size_list v) one_nata)
                   (replicate (size_list v) ze)))];

fun status_precedence xml2name =
  xml_many_elements
    [#"s", #"t", #"a", #"t", #"u", #"s", #"P", #"r", #"e", #"c", #"e", #"d",
      #"e", #"n", #"c", #"e"]
    (xml4elements
      [#"s", #"t", #"a", #"t", #"u", #"s", #"P", #"r", #"e", #"c", #"e", #"d",
        #"e", #"n", #"c", #"e", #"E", #"n", #"t", #"r", #"y"]
      xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
      (nata [#"p", #"r", #"e", #"c", #"e", #"d", #"e", #"n", #"c", #"e"])
      (xml_options
        [([#"l", #"e", #"x"], xml0elements [#"l", #"e", #"x"] Lex),
          ([#"m", #"u", #"l"], xml0elements [#"m", #"u", #"l"] Mul)])
      (fn f => fn a => fn p => fn s => ((f, a), (p, s))))
    id;

fun path_order xml2name =
  xml1to2elements [#"p", #"a", #"t", #"h", #"O", #"r", #"d", #"e", #"r"]
    (status_precedence xml2name) (afs xml2name)
    (fn prec_tau => fn afo =>
      let
        val a = (case afo of NONE => [] | SOME af => af);
      in
        Rpo (prec_tau, a)
      end);

fun fit_length uu Zero_nat uv = []
  | fit_length a (Suc v) [] = replicate (Suc v) a
  | fit_length a (Suc n) (b :: asa) = b :: fit_length a n asa;

fun polynomial xml2coeff x =
  xml1element [#"p", #"o", #"l", #"y", #"n", #"o", #"m", #"i", #"a", #"l"]
    (xml_options
      [([#"c", #"o", #"e", #"f", #"f", #"i", #"c", #"i", #"e", #"n", #"t"],
         xml1element
           [#"c", #"o", #"e", #"f", #"f", #"i", #"c", #"i", #"e", #"n", #"t"]
           xml2coeff PNum),
        ([#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e"],
          xml_change (nata [#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e"])
            (fn n => PVar (minus_nat n one_nata))),
        ([#"s", #"u", #"m"],
          xml_many_elements [#"s", #"u", #"m"] (polynomial xml2coeff) PSum),
        ([#"p", #"r", #"o", #"d", #"u", #"c", #"t"],
          xml_many_elements [#"p", #"r", #"o", #"d", #"u", #"c", #"t"]
            (polynomial xml2coeff) PMult)])
    id x;

val ab_semigroup_mult_int =
  {semigroup_mult_ab_semigroup_mult = semigroup_mult_int} :
  int ab_semigroup_mult;

val comm_semiring_int =
  {ab_semigroup_mult_comm_semiring = ab_semigroup_mult_int,
    semiring_comm_semiring = semiring_int}
  : int comm_semiring;

val comm_semiring_0_int =
  {comm_semiring_comm_semiring_0 = comm_semiring_int,
    semiring_0_comm_semiring_0 = semiring_0_int}
  : int comm_semiring_0;

val comm_monoid_mult_int =
  {ab_semigroup_mult_comm_monoid_mult = ab_semigroup_mult_int,
    monoid_mult_comm_monoid_mult = monoid_mult_int}
  : int comm_monoid_mult;

val comm_semiring_1_int =
  {comm_monoid_mult_comm_semiring_1 = comm_monoid_mult_int,
    comm_semiring_0_comm_semiring_1 = comm_semiring_0_int,
    dvd_comm_semiring_1 = dvd_int, semiring_1_comm_semiring_1 = semiring_1_int}
  : int comm_semiring_1;

val ab_semigroup_mult_rat =
  {semigroup_mult_ab_semigroup_mult = semigroup_mult_rat} :
  rat ab_semigroup_mult;

val comm_semiring_rat =
  {ab_semigroup_mult_comm_semiring = ab_semigroup_mult_rat,
    semiring_comm_semiring = semiring_rat}
  : rat comm_semiring;

val comm_semiring_0_rat =
  {comm_semiring_comm_semiring_0 = comm_semiring_rat,
    semiring_0_comm_semiring_0 = semiring_0_rat}
  : rat comm_semiring_0;

val comm_monoid_mult_rat =
  {ab_semigroup_mult_comm_monoid_mult = ab_semigroup_mult_rat,
    monoid_mult_comm_monoid_mult = monoid_mult_rat}
  : rat comm_monoid_mult;

val comm_semiring_1_rat =
  {comm_monoid_mult_comm_semiring_1 = comm_monoid_mult_rat,
    comm_semiring_0_comm_semiring_1 = comm_semiring_0_rat,
    dvd_comm_semiring_1 = dvd_rat, semiring_1_comm_semiring_1 = semiring_1_rat}
  : rat comm_semiring_1;

fun arctic_coeff x =
  xml_options
    [([#"i", #"n", #"t", #"e", #"g", #"e", #"r"],
       xml_change (inta [#"i", #"n", #"t", #"e", #"g", #"e", #"r"]) Num_arc),
      ([#"m", #"i", #"n", #"u", #"s", #"I", #"n", #"f", #"i", #"n", #"i", #"t",
         #"y"],
        xml0elements
          [#"m", #"i", #"n", #"u", #"s", #"I", #"n", #"f", #"i", #"n", #"i",
            #"t", #"y"]
          MinInfty)]
    x;

fun ge_int x y = y <= x;

fun ge_rat x y = less_eq_rat y x;

fun rat_gt delta = (fn x => fn y => less_eq_rat delta (minus_rat x y));

fun int_mono x = (1 : IntInf.int) <= x;

fun max0_int x = max ord_int (0 : IntInf.int) x;

fun max0_rat x = max ord_rat (fract (0 : IntInf.int) (1 : IntInf.int)) x;

fun rat_mono x = less_eq_rat (fract (1 : IntInf.int) (1 : IntInf.int)) x;

fun ge_arctic x MinInfty = true
  | ge_arctic MinInfty (Num_arc uu) = false
  | ge_arctic (Num_arc x) (Num_arc y) = y <= x;

fun gt_arctic uu MinInfty = true
  | gt_arctic MinInfty (Num_arc uv) = false
  | gt_arctic (Num_arc x) (Num_arc y) = y < x;

fun arctic_rat_coeff x =
  xml_options
    [([#"i", #"n", #"t", #"e", #"g", #"e", #"r"], xml_change rat Num_arc_rat),
      ([#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l"],
        xml_change rat Num_arc_rat),
      ([#"m", #"i", #"n", #"u", #"s", #"I", #"n", #"f", #"i", #"n", #"i", #"t",
         #"y"],
        xml0elements
          [#"m", #"i", #"n", #"u", #"s", #"I", #"n", #"f", #"i", #"n", #"i",
            #"t", #"y"]
          MinInfty_rat)]
    x;

val one_arctic : arctic = Num_arc (0 : IntInf.int);

fun pos_arctic MinInfty = false
  | pos_arctic (Num_arc n) = (0 : IntInf.int) <= n;

val int_name : char list =
  [#"n", #"a", #"t", #"u", #"r", #"a", #"l", #"s", #" ", #"w", #"i", #"t", #"h",
    #" ", #"n", #"e", #"g", #"a", #"t", #"i", #"v", #"e", #" ", #"c", #"o",
    #"n", #"s", #"t", #"a", #"n", #"t", #"s"];

fun mat_mono sd m = mat_monoI m sd;

val rat_name : char list =
  [#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l", #"s", #" ", #"(", #"w", #"i",
    #"t", #"h", #" ", #"n", #"e", #"g", #"a", #"t", #"i", #"v", #"e", #" ",
    #"c", #"o", #"n", #"s", #"t", #"a", #"n", #"t", #"s", #")"];

fun get_comp_0
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  ze;

fun get_comp_1
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  on;

fun equal_arctica (Num_arc inta) MinInfty = false
  | equal_arctica MinInfty (Num_arc inta) = false
  | equal_arctica (Num_arc intaa) (Num_arc inta) = intaa = inta
  | equal_arctica MinInfty MinInfty = true;

val equal_arctic = {equal = equal_arctica} : arctic equal;

fun plus_arctic MinInfty y = y
  | plus_arctic (Num_arc v) MinInfty = Num_arc v
  | plus_arctic (Num_arc x) (Num_arc y) = Num_arc (max ord_int x y);

val zero_arctic : arctic = MinInfty;

fun get_comp_gt
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  gt;

fun times_arctic MinInfty y = MinInfty
  | times_arctic (Num_arc v) MinInfty = MinInfty
  | times_arctic (Num_arc x) (Num_arc y) = Num_arc (x + y);

fun rat_domain x =
  xml1element [#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l", #"s"]
    (xml1element [#"d", #"e", #"l", #"t", #"a"] rat id) id x;

fun basic_domain x =
  xml_options
    [([#"n", #"a", #"t", #"u", #"r", #"a", #"l", #"s"],
       xml0elements [#"n", #"a", #"t", #"u", #"r", #"a", #"l", #"s"] Natural),
      ([#"a", #"r", #"c", #"t", #"i", #"c"],
        xml1element [#"a", #"r", #"c", #"t", #"i", #"c"]
          (xml1element [#"d", #"o", #"m", #"a", #"i", #"n"]
            (xml_options
              [([#"n", #"a", #"t", #"u", #"r", #"a", #"l", #"s"],
                 xml0elements [#"n", #"a", #"t", #"u", #"r", #"a", #"l", #"s"]
                   (fn _ => Arctic)),
                ([#"i", #"n", #"t", #"e", #"g", #"e", #"r", #"s"],
                  xml0elements [#"i", #"n", #"t", #"e", #"g", #"e", #"r", #"s"]
                    (fn _ => Arctic)),
                ([#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l", #"s"],
                  xml_change rat_domain (fn r => fn _ => Arctic_rat r))])
            id)
          id),
      ([#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l", #"s"],
        xml_change rat_domain (fn a => fn b => Rational (a, b)))]
    x;

fun interpretation_type x =
  xml1element [#"t", #"y", #"p", #"e"]
    (xml_options
      [([#"p", #"o", #"l", #"y", #"n", #"o", #"m", #"i", #"a", #"l"],
         xml2elements
           [#"p", #"o", #"l", #"y", #"n", #"o", #"m", #"i", #"a", #"l"]
           (xml1element [#"d", #"o", #"m", #"a", #"i", #"n"]
             (xml_options
               [([#"n", #"a", #"t", #"u", #"r", #"a", #"l", #"s"],
                  basic_domain),
                 ([#"a", #"r", #"c", #"t", #"i", #"c"], basic_domain),
                 ([#"r", #"a", #"t", #"i", #"o", #"n", #"a", #"l", #"s"],
                   basic_domain),
                 ([#"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s"],
                   xml3elements [#"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s"]
                     (nata [#"d", #"i", #"m", #"e", #"n", #"s", #"i", #"o",
                             #"n"])
                     (nata [#"s", #"t", #"r", #"i", #"c", #"t", #"D", #"i",
                             #"m", #"e", #"n", #"s", #"i", #"o", #"n"])
                     (xml1element [#"d", #"o", #"m", #"a", #"i", #"n"]
                       basic_domain id)
                     (fn di => fn sd => fn domain => fn d =>
                       (case domain d of Natural _ => Int_mat (di, sd)
                         | Arctic => Arc_mat di
                         | Arctic_rat delta => Arc_rat_mat (delta, di)
                         | Rational (delta, _) => Rat_mat (delta, di, sd))))])
             id)
           (nata [#"d", #"e", #"g", #"r", #"e", #"e"]) (fn typea => typea)),
        ([#"m", #"a", #"t", #"r", #"i", #"x", #"I", #"n", #"t", #"e", #"r",
           #"p", #"r", #"e", #"t", #"a", #"t", #"i", #"o", #"n"],
          xml3elements
            [#"m", #"a", #"t", #"r", #"i", #"x", #"I", #"n", #"t", #"e", #"r",
              #"p", #"r", #"e", #"t", #"a", #"t", #"i", #"o", #"n"]
            (xml1element [#"d", #"o", #"m", #"a", #"i", #"n"] basic_domain id)
            (nata [#"d", #"i", #"m", #"e", #"n", #"s", #"i", #"o", #"n"])
            (nata [#"s", #"t", #"r", #"i", #"c", #"t", #"D", #"i", #"m", #"e",
                    #"n", #"s", #"i", #"o", #"n"])
            (fn domain => fn di => fn sd =>
              (case domain Zero_nat of Natural _ => Int_mat (di, sd)
                | Arctic => Arc_mat di
                | Arctic_rat delta => Arc_rat_mat (delta, di)
                | Rational (delta, _) => Rat_mat (delta, di, sd))))])
    id x;

fun get_comp_def
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  def;

fun ge_arctic_rat x MinInfty_rat = true
  | ge_arctic_rat MinInfty_rat (Num_arc_rat uu) = false
  | ge_arctic_rat (Num_arc_rat x) (Num_arc_rat y) = less_eq_rat y x;

fun gt_arctic_rat delta uu MinInfty_rat = true
  | gt_arctic_rat delta MinInfty_rat (Num_arc_rat uv) = false
  | gt_arctic_rat delta (Num_arc_rat x) (Num_arc_rat y) = rat_gt delta x y;

val arctic_name : char list =
  [#"a", #"r", #"c", #"t", #"i", #"c", #" ", #"s", #"e", #"m", #"i", #"r", #"i",
    #"n", #"g"];

fun get_comp_apos
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  ap;

fun get_comp_mono
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  mo;

fun get_comp_plus
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  pl;

val one_arctic_rat : arctic_rat =
  Num_arc_rat (fract (0 : IntInf.int) (1 : IntInf.int));

fun pos_arctic_rat MinInfty_rat = false
  | pos_arctic_rat (Num_arc_rat n) =
    less_eq_rat (fract (0 : IntInf.int) (1 : IntInf.int)) n;

fun get_comp_times
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  ti;

fun equal_arctic_rata (Num_arc_rat rat) MinInfty_rat = false
  | equal_arctic_rata MinInfty_rat (Num_arc_rat rat) = false
  | equal_arctic_rata (Num_arc_rat rata) (Num_arc_rat rat) = equal_rata rata rat
  | equal_arctic_rata MinInfty_rat MinInfty_rat = true;

val equal_arctic_rat = {equal = equal_arctic_rata} : arctic_rat equal;

fun plus_arctic_rat MinInfty_rat y = y
  | plus_arctic_rat (Num_arc_rat v) MinInfty_rat = Num_arc_rat v
  | plus_arctic_rat (Num_arc_rat x) (Num_arc_rat y) =
    Num_arc_rat (max ord_rat x y);

val zero_arctic_rat : arctic_rat = MinInfty_rat;

fun times_arctic_rat MinInfty_rat y = MinInfty_rat
  | times_arctic_rat (Num_arc_rat v) MinInfty_rat = MinInfty_rat
  | times_arctic_rat (Num_arc_rat x) (Num_arc_rat y) =
    Num_arc_rat (plus_rata x y);

val arctic_rat_name : char list =
  [#"a", #"r", #"c", #"t", #"i", #"c", #" ", #"r", #"a", #"t", #"i", #"o", #"n",
    #"a", #"l", #"s"];

val non_strict_order_int = {ge = ge_int} : int non_strict_order;

val non_strict_order_rat = {ge = ge_rat} : rat non_strict_order;

fun get_comp_check_mono
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  cm;

fun get_comp_description
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  de;

val non_strict_order_arctic = {ge = ge_arctic} : arctic non_strict_order;

val ordered_ab_semigroup_int =
  {ab_semigroup_add_ordered_ab_semigroup = ab_semigroup_add_int,
    non_strict_order_ordered_ab_semigroup = non_strict_order_int}
  : int ordered_ab_semigroup;

val max_ordered_monoid_add_int =
  {monoid_add_max_ordered_monoid_add = monoid_add_int,
    ordered_ab_semigroup_max_ordered_monoid_add = ordered_ab_semigroup_int,
    max0 = max0_int}
  : int max_ordered_monoid_add;

val ordered_ab_semigroup_rat =
  {ab_semigroup_add_ordered_ab_semigroup = ab_semigroup_add_rat,
    non_strict_order_ordered_ab_semigroup = non_strict_order_rat}
  : rat ordered_ab_semigroup;

val max_ordered_monoid_add_rat =
  {monoid_add_max_ordered_monoid_add = monoid_add_rat,
    ordered_ab_semigroup_max_ordered_monoid_add = ordered_ab_semigroup_rat,
    max0 = max0_rat}
  : rat max_ordered_monoid_add;

val non_strict_order_arctic_rat = {ge = ge_arctic_rat} :
  arctic_rat non_strict_order;

fun interpretation xml2name =
  xml1many_elements_gen
    [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t", #"a", #"t", #"i",
      #"o", #"n"]
    interpretation_type
    (fn a =>
      (case a
        of Natural deg =>
          (if less_eq_nat deg one_nata
            then xml3elements
                   [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
                   xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
                   (fn x =>
                     bindb (polynomial int_coeff x)
                       (lpoly_of equal_int
                         (get_comp_0
                           ((fn _ => true),
                             ((0 : IntInf.int),
                               ((1 : IntInf.int),
                                 ((1 : IntInf.int),
                                   ((fn aa => fn b => aa + b),
                                     ((fn aa => fn b => aa * b),
                                       (max0_int,
 (ge_int,
   ((fn xa => fn y => y < xa),
     (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                         (get_comp_1
                           ((fn _ => true),
                             ((0 : IntInf.int),
                               ((1 : IntInf.int),
                                 ((1 : IntInf.int),
                                   ((fn aa => fn b => aa + b),
                                     ((fn aa => fn b => aa * b),
                                       (max0_int,
 (ge_int,
   ((fn xa => fn y => y < xa),
     (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                         (get_comp_plus
                           ((fn _ => true),
                             ((0 : IntInf.int),
                               ((1 : IntInf.int),
                                 ((1 : IntInf.int),
                                   ((fn aa => fn b => aa + b),
                                     ((fn aa => fn b => aa * b),
                                       (max0_int,
 (ge_int,
   ((fn xa => fn y => y < xa),
     (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                         (get_comp_times
                           ((fn _ => true),
                             ((0 : IntInf.int),
                               ((1 : IntInf.int),
                                 ((1 : IntInf.int),
                                   ((fn aa => fn b => aa + b),
                                     ((fn aa => fn b => aa * b),
                                       (max0_int,
 (ge_int,
   ((fn xa => fn y => y < xa),
     (true, (int_name, ((fn _ => true), int_mono)))))))))))))))
                   (fn f => fn aa => fn poly =>
                     Alter1
                       ((f, aa),
                         (fst poly,
                           fit_length
                             (get_comp_0
                               ((fn _ => true),
                                 ((0 : IntInf.int),
                                   ((1 : IntInf.int),
                                     ((1 : IntInf.int),
                                       ((fn ab => fn b => ab + b),
 ((fn ab => fn b => ab * b),
   (max0_int,
     (ge_int,
       ((fn x => fn y => y < x),
         (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                             aa (snd poly))))
            else xml3elements
                   [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
                   xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
                   (fn x =>
                     bindb (polynomial int_coeff x)
                       (fn p =>
                         Inr (poly_of equal_nat (equal_int, comm_semiring_1_int)
                               p)))
                   (fn f => fn aa => fn poly => Alter9 ((f, aa), poly)))
        | Arctic =>
          xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
            xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
            (fn x =>
              bindb (polynomial arctic_coeff x)
                (lpoly_of equal_arctic
                  (get_comp_0
                    ((fn _ => true),
                      (zero_arctic,
                        (one_arctic,
                          (one_arctic,
                            (plus_arctic,
                              (times_arctic,
                                (id, (ge_arctic,
                                       (gt_arctic,
 (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                  (get_comp_1
                    ((fn _ => true),
                      (zero_arctic,
                        (one_arctic,
                          (one_arctic,
                            (plus_arctic,
                              (times_arctic,
                                (id, (ge_arctic,
                                       (gt_arctic,
 (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                  (get_comp_plus
                    ((fn _ => true),
                      (zero_arctic,
                        (one_arctic,
                          (one_arctic,
                            (plus_arctic,
                              (times_arctic,
                                (id, (ge_arctic,
                                       (gt_arctic,
 (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                  (get_comp_times
                    ((fn _ => true),
                      (zero_arctic,
                        (one_arctic,
                          (one_arctic,
                            (plus_arctic,
                              (times_arctic,
                                (id, (ge_arctic,
                                       (gt_arctic,
 (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))))
            (fn f => fn aa => fn poly =>
              Alter3
                ((f, aa),
                  (fst poly,
                    fit_length
                      (get_comp_0
                        ((fn _ => true),
                          (zero_arctic,
                            (one_arctic,
                              (one_arctic,
                                (plus_arctic,
                                  (times_arctic,
                                    (id, (ge_arctic,
   (gt_arctic, (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                      aa (snd poly))))
        | Arctic_rat d =>
          xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
            xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
            (fn x =>
              bindb (polynomial arctic_rat_coeff x)
                (lpoly_of equal_arctic_rat
                  (get_comp_0
                    ((fn _ => true),
                      (zero_arctic_rat,
                        (one_arctic_rat,
                          (one_arctic_rat,
                            (plus_arctic_rat,
                              (times_arctic_rat,
                                (id, (ge_arctic_rat,
                                       (gt_arctic_rat d,
 (false, (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                  (get_comp_1
                    ((fn _ => true),
                      (zero_arctic_rat,
                        (one_arctic_rat,
                          (one_arctic_rat,
                            (plus_arctic_rat,
                              (times_arctic_rat,
                                (id, (ge_arctic_rat,
                                       (gt_arctic_rat d,
 (false, (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                  (get_comp_plus
                    ((fn _ => true),
                      (zero_arctic_rat,
                        (one_arctic_rat,
                          (one_arctic_rat,
                            (plus_arctic_rat,
                              (times_arctic_rat,
                                (id, (ge_arctic_rat,
                                       (gt_arctic_rat d,
 (false, (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                  (get_comp_times
                    ((fn _ => true),
                      (zero_arctic_rat,
                        (one_arctic_rat,
                          (one_arctic_rat,
                            (plus_arctic_rat,
                              (times_arctic_rat,
                                (id, (ge_arctic_rat,
                                       (gt_arctic_rat d,
 (false, (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))))
            (fn f => fn aa => fn poly =>
              Alter7
                ((f, aa),
                  (fst poly,
                    fit_length
                      (get_comp_0
                        ((fn _ => true),
                          (zero_arctic_rat,
                            (one_arctic_rat,
                              (one_arctic_rat,
                                (plus_arctic_rat,
                                  (times_arctic_rat,
                                    (id, (ge_arctic_rat,
   (gt_arctic_rat d,
     (false, (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                      aa (snd poly))))
        | Int_mat (n, sd) =>
          xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
            xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
            (fn x =>
              bindb (polynomial (mat_coeff (0 : IntInf.int) int_coeff) x)
                (lpoly_of (equal_list (equal_list equal_int))
                  (get_comp_0
                    (mat n n,
                      (mat0I (0 : IntInf.int) n n,
                        (mat1I (0 : IntInf.int) (1 : IntInf.int) n,
                          (mat1I (0 : IntInf.int)
                             (get_comp_def
                               ((fn _ => true),
                                 ((0 : IntInf.int),
                                   ((1 : IntInf.int),
                                     ((1 : IntInf.int),
                                       ((fn aa => fn b => aa + b),
 ((fn aa => fn b => aa * b),
   (max0_int,
     (ge_int,
       ((fn xa => fn y => y < xa),
         (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                             n,
                            (mat_plusI (fn aa => fn b => aa + b),
                              (mat_multI (0 : IntInf.int)
                                 (fn aa => fn b => aa + b)
                                 (fn aa => fn b => aa * b) n,
                                (mat_max0 max_ordered_monoid_add_int,
                                  (mat_ge non_strict_order_int,
                                    (mat_gtI non_strict_order_int
                                       (get_comp_gt
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         ((0 : IntInf.int),
           ((1 : IntInf.int),
             ((1 : IntInf.int),
               ((fn aa => fn b => aa + b),
                 ((fn aa => fn b => aa * b),
                   (max0_int,
                     (ge_int,
                       ((fn xa => fn y => y < xa),
                         (true,
                           (int_name, ((fn _ => true), int_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          ((0 : IntInf.int),
            ((1 : IntInf.int),
              ((1 : IntInf.int),
                ((fn aa => fn b => aa + b),
                  ((fn aa => fn b => aa * b),
                    (max0_int,
                      (ge_int,
                        ((fn xa => fn y => y < xa),
                          (true,
                            (int_name,
                              ((fn _ => true),
                                int_mono))))))))))))))))))))))))))
                  (get_comp_1
                    (mat n n,
                      (mat0I (0 : IntInf.int) n n,
                        (mat1I (0 : IntInf.int) (1 : IntInf.int) n,
                          (mat1I (0 : IntInf.int)
                             (get_comp_def
                               ((fn _ => true),
                                 ((0 : IntInf.int),
                                   ((1 : IntInf.int),
                                     ((1 : IntInf.int),
                                       ((fn aa => fn b => aa + b),
 ((fn aa => fn b => aa * b),
   (max0_int,
     (ge_int,
       ((fn xa => fn y => y < xa),
         (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                             n,
                            (mat_plusI (fn aa => fn b => aa + b),
                              (mat_multI (0 : IntInf.int)
                                 (fn aa => fn b => aa + b)
                                 (fn aa => fn b => aa * b) n,
                                (mat_max0 max_ordered_monoid_add_int,
                                  (mat_ge non_strict_order_int,
                                    (mat_gtI non_strict_order_int
                                       (get_comp_gt
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         ((0 : IntInf.int),
           ((1 : IntInf.int),
             ((1 : IntInf.int),
               ((fn aa => fn b => aa + b),
                 ((fn aa => fn b => aa * b),
                   (max0_int,
                     (ge_int,
                       ((fn xa => fn y => y < xa),
                         (true,
                           (int_name, ((fn _ => true), int_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          ((0 : IntInf.int),
            ((1 : IntInf.int),
              ((1 : IntInf.int),
                ((fn aa => fn b => aa + b),
                  ((fn aa => fn b => aa * b),
                    (max0_int,
                      (ge_int,
                        ((fn xa => fn y => y < xa),
                          (true,
                            (int_name,
                              ((fn _ => true),
                                int_mono))))))))))))))))))))))))))
                  (get_comp_plus
                    (mat n n,
                      (mat0I (0 : IntInf.int) n n,
                        (mat1I (0 : IntInf.int) (1 : IntInf.int) n,
                          (mat1I (0 : IntInf.int)
                             (get_comp_def
                               ((fn _ => true),
                                 ((0 : IntInf.int),
                                   ((1 : IntInf.int),
                                     ((1 : IntInf.int),
                                       ((fn aa => fn b => aa + b),
 ((fn aa => fn b => aa * b),
   (max0_int,
     (ge_int,
       ((fn xa => fn y => y < xa),
         (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                             n,
                            (mat_plusI (fn aa => fn b => aa + b),
                              (mat_multI (0 : IntInf.int)
                                 (fn aa => fn b => aa + b)
                                 (fn aa => fn b => aa * b) n,
                                (mat_max0 max_ordered_monoid_add_int,
                                  (mat_ge non_strict_order_int,
                                    (mat_gtI non_strict_order_int
                                       (get_comp_gt
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         ((0 : IntInf.int),
           ((1 : IntInf.int),
             ((1 : IntInf.int),
               ((fn aa => fn b => aa + b),
                 ((fn aa => fn b => aa * b),
                   (max0_int,
                     (ge_int,
                       ((fn xa => fn y => y < xa),
                         (true,
                           (int_name, ((fn _ => true), int_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          ((0 : IntInf.int),
            ((1 : IntInf.int),
              ((1 : IntInf.int),
                ((fn aa => fn b => aa + b),
                  ((fn aa => fn b => aa * b),
                    (max0_int,
                      (ge_int,
                        ((fn xa => fn y => y < xa),
                          (true,
                            (int_name,
                              ((fn _ => true),
                                int_mono))))))))))))))))))))))))))
                  (get_comp_times
                    (mat n n,
                      (mat0I (0 : IntInf.int) n n,
                        (mat1I (0 : IntInf.int) (1 : IntInf.int) n,
                          (mat1I (0 : IntInf.int)
                             (get_comp_def
                               ((fn _ => true),
                                 ((0 : IntInf.int),
                                   ((1 : IntInf.int),
                                     ((1 : IntInf.int),
                                       ((fn aa => fn b => aa + b),
 ((fn aa => fn b => aa * b),
   (max0_int,
     (ge_int,
       ((fn xa => fn y => y < xa),
         (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                             n,
                            (mat_plusI (fn aa => fn b => aa + b),
                              (mat_multI (0 : IntInf.int)
                                 (fn aa => fn b => aa + b)
                                 (fn aa => fn b => aa * b) n,
                                (mat_max0 max_ordered_monoid_add_int,
                                  (mat_ge non_strict_order_int,
                                    (mat_gtI non_strict_order_int
                                       (get_comp_gt
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   ((0 : IntInf.int),
     ((1 : IntInf.int),
       ((1 : IntInf.int),
         ((fn aa => fn b => aa + b),
           ((fn aa => fn b => aa * b),
             (max0_int,
               (ge_int,
                 ((fn xa => fn y => y < xa),
                   (true, (int_name, ((fn _ => true), int_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         ((0 : IntInf.int),
           ((1 : IntInf.int),
             ((1 : IntInf.int),
               ((fn aa => fn b => aa + b),
                 ((fn aa => fn b => aa * b),
                   (max0_int,
                     (ge_int,
                       ((fn xa => fn y => y < xa),
                         (true,
                           (int_name, ((fn _ => true), int_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          ((0 : IntInf.int),
            ((1 : IntInf.int),
              ((1 : IntInf.int),
                ((fn aa => fn b => aa + b),
                  ((fn aa => fn b => aa * b),
                    (max0_int,
                      (ge_int,
                        ((fn xa => fn y => y < xa),
                          (true,
                            (int_name,
                              ((fn _ => true),
                                int_mono))))))))))))))))))))))))))))
            (fn f => fn aa => fn poly =>
              Alter4
                ((f, aa),
                  (fst poly,
                    fit_length
                      (get_comp_0
                        (mat n n,
                          (mat0I (0 : IntInf.int) n n,
                            (mat1I (0 : IntInf.int) (1 : IntInf.int) n,
                              (mat1I (0 : IntInf.int)
                                 (get_comp_def
                                   ((fn _ => true),
                                     ((0 : IntInf.int),
                                       ((1 : IntInf.int),
 ((1 : IntInf.int),
   ((fn ab => fn b => ab + b),
     ((fn ab => fn b => ab * b),
       (max0_int,
         (ge_int,
           ((fn x => fn y => y < x),
             (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                                 n,
                                (mat_plusI (fn ab => fn b => ab + b),
                                  (mat_multI (0 : IntInf.int)
                                     (fn ab => fn b => ab + b)
                                     (fn ab => fn b => ab * b) n,
                                    (mat_max0 max_ordered_monoid_add_int,
                                      (mat_ge non_strict_order_int,
(mat_gtI non_strict_order_int
   (get_comp_gt
     ((fn _ => true),
       ((0 : IntInf.int),
         ((1 : IntInf.int),
           ((1 : IntInf.int),
             ((fn ab => fn b => ab + b),
               ((fn ab => fn b => ab * b),
                 (max0_int,
                   (ge_int,
                     ((fn x => fn y => y < x),
                       (true, (int_name, ((fn _ => true), int_mono)))))))))))))
   sd,
  (get_comp_mono
     ((fn _ => true),
       ((0 : IntInf.int),
         ((1 : IntInf.int),
           ((1 : IntInf.int),
             ((fn ab => fn b => ab + b),
               ((fn ab => fn b => ab * b),
                 (max0_int,
                   (ge_int,
                     ((fn x => fn y => y < x),
                       (true, (int_name, ((fn _ => true), int_mono)))))))))))),
    (concat
       [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
         [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w",
           #"i", #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ",
           #"d", #"i", #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
         shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
         get_comp_description
           ((fn _ => true),
             ((0 : IntInf.int),
               ((1 : IntInf.int),
                 ((1 : IntInf.int),
                   ((fn ab => fn b => ab + b),
                     ((fn ab => fn b => ab * b),
                       (max0_int,
                         (ge_int,
                           ((fn x => fn y => y < x),
                             (true,
                               (int_name,
                                 ((fn _ => true), int_mono))))))))))))],
      ((fn _ => true),
        mat_mono sd
          (get_comp_check_mono
            ((fn _ => true),
              ((0 : IntInf.int),
                ((1 : IntInf.int),
                  ((1 : IntInf.int),
                    ((fn ab => fn b => ab + b),
                      ((fn ab => fn b => ab * b),
                        (max0_int,
                          (ge_int,
                            ((fn x => fn y => y < x),
                              (true,
                                (int_name,
                                  ((fn _ => true),
                                    int_mono))))))))))))))))))))))))))
                      aa (snd poly))))
        | Arc_mat n =>
          xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
            xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
            (fn x =>
              bindb (polynomial (mat_coeff MinInfty arctic_coeff) x)
                (lpoly_of (equal_list (equal_list equal_arctic))
                  (get_comp_0
                    (mat n n,
                      (mat0I zero_arctic n n,
                        (mat1I zero_arctic one_arctic n,
                          (mat1I zero_arctic
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic,
                                   (one_arctic,
                                     (one_arctic,
                                       (plus_arctic,
 (times_arctic,
   (id, (ge_arctic,
          (gt_arctic,
            (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic,
                              (mat_multI zero_arctic plus_arctic times_arctic n,
                                (id, (mat_ge non_strict_order_arctic,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic,
        (one_arctic,
          (one_arctic,
            (plus_arctic,
              (times_arctic,
                (id, (ge_arctic,
                       (gt_arctic,
                         (false,
                           (arctic_name,
                             (pos_arctic, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))
                  (get_comp_1
                    (mat n n,
                      (mat0I zero_arctic n n,
                        (mat1I zero_arctic one_arctic n,
                          (mat1I zero_arctic
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic,
                                   (one_arctic,
                                     (one_arctic,
                                       (plus_arctic,
 (times_arctic,
   (id, (ge_arctic,
          (gt_arctic,
            (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic,
                              (mat_multI zero_arctic plus_arctic times_arctic n,
                                (id, (mat_ge non_strict_order_arctic,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic,
        (one_arctic,
          (one_arctic,
            (plus_arctic,
              (times_arctic,
                (id, (ge_arctic,
                       (gt_arctic,
                         (false,
                           (arctic_name,
                             (pos_arctic, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))
                  (get_comp_plus
                    (mat n n,
                      (mat0I zero_arctic n n,
                        (mat1I zero_arctic one_arctic n,
                          (mat1I zero_arctic
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic,
                                   (one_arctic,
                                     (one_arctic,
                                       (plus_arctic,
 (times_arctic,
   (id, (ge_arctic,
          (gt_arctic,
            (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic,
                              (mat_multI zero_arctic plus_arctic times_arctic n,
                                (id, (mat_ge non_strict_order_arctic,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic,
        (one_arctic,
          (one_arctic,
            (plus_arctic,
              (times_arctic,
                (id, (ge_arctic,
                       (gt_arctic,
                         (false,
                           (arctic_name,
                             (pos_arctic, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))
                  (get_comp_times
                    (mat n n,
                      (mat0I zero_arctic n n,
                        (mat1I zero_arctic one_arctic n,
                          (mat1I zero_arctic
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic,
                                   (one_arctic,
                                     (one_arctic,
                                       (plus_arctic,
 (times_arctic,
   (id, (ge_arctic,
          (gt_arctic,
            (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic,
                              (mat_multI zero_arctic plus_arctic times_arctic n,
                                (id, (mat_ge non_strict_order_arctic,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic,
        (one_arctic,
          (one_arctic,
            (plus_arctic,
              (times_arctic,
                (id, (ge_arctic,
                       (gt_arctic,
                         (false,
                           (arctic_name,
                             (pos_arctic, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic,
              (one_arctic,
                (one_arctic,
                  (plus_arctic,
                    (times_arctic,
                      (id, (ge_arctic,
                             (gt_arctic,
                               (false,
                                 (arctic_name,
                                   (pos_arctic, (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))))
            (fn f => fn aa => fn poly =>
              Alter6
                ((f, aa),
                  (fst poly,
                    fit_length
                      (get_comp_0
                        (mat n n,
                          (mat0I zero_arctic n n,
                            (mat1I zero_arctic one_arctic n,
                              (mat1I zero_arctic
                                 (get_comp_def
                                   ((fn _ => true),
                                     (zero_arctic,
                                       (one_arctic,
 (one_arctic,
   (plus_arctic,
     (times_arctic,
       (id, (ge_arctic,
              (gt_arctic,
                (false, (arctic_name, (pos_arctic, (fn _ => false))))))))))))))
                                 n,
                                (mat_plusI plus_arctic,
                                  (mat_multI zero_arctic plus_arctic
                                     times_arctic n,
                                    (id, (mat_ge non_strict_order_arctic,
   (mat_comp_all
      (get_comp_gt
        ((fn _ => true),
          (zero_arctic,
            (one_arctic,
              (one_arctic,
                (plus_arctic,
                  (times_arctic,
                    (id, (ge_arctic,
                           (gt_arctic,
                             (false,
                               (arctic_name,
                                 (pos_arctic, (fn _ => false)))))))))))))),
     (false,
       (concat
          [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
            [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o",
              #"v", #"e", #"r", #" "],
            get_comp_description
              ((fn _ => true),
                (zero_arctic,
                  (one_arctic,
                    (one_arctic,
                      (plus_arctic,
                        (times_arctic,
                          (id, (ge_arctic,
                                 (gt_arctic,
                                   (false,
                                     (arctic_name,
                                       (pos_arctic,
 (fn _ => false)))))))))))))],
         (mat_arc_posI
            (get_comp_apos
              ((fn _ => true),
                (zero_arctic,
                  (one_arctic,
                    (one_arctic,
                      (plus_arctic,
                        (times_arctic,
                          (id, (ge_arctic,
                                 (gt_arctic,
                                   (false,
                                     (arctic_name,
                                       (pos_arctic,
 (fn _ => false)))))))))))))),
           (fn _ => false))))))))))))))
                      aa (snd poly))))
        | Arc_rat_mat (d, n) =>
          xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
            xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
            (fn x =>
              bindb (polynomial (mat_coeff MinInfty_rat arctic_rat_coeff) x)
                (lpoly_of (equal_list (equal_list equal_arctic_rat))
                  (get_comp_0
                    (mat n n,
                      (mat0I zero_arctic_rat n n,
                        (mat1I zero_arctic_rat one_arctic_rat n,
                          (mat1I zero_arctic_rat
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic_rat,
                                   (one_arctic_rat,
                                     (one_arctic_rat,
                                       (plus_arctic_rat,
 (times_arctic_rat,
   (id, (ge_arctic_rat,
          (gt_arctic_rat d,
            (false,
              (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic_rat,
                              (mat_multI zero_arctic_rat plus_arctic_rat
                                 times_arctic_rat n,
                                (id, (mat_ge non_strict_order_arctic_rat,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic_rat,
        (one_arctic_rat,
          (one_arctic_rat,
            (plus_arctic_rat,
              (times_arctic_rat,
                (id, (ge_arctic_rat,
                       (gt_arctic_rat d,
                         (false,
                           (arctic_rat_name,
                             (pos_arctic_rat, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))
                  (get_comp_1
                    (mat n n,
                      (mat0I zero_arctic_rat n n,
                        (mat1I zero_arctic_rat one_arctic_rat n,
                          (mat1I zero_arctic_rat
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic_rat,
                                   (one_arctic_rat,
                                     (one_arctic_rat,
                                       (plus_arctic_rat,
 (times_arctic_rat,
   (id, (ge_arctic_rat,
          (gt_arctic_rat d,
            (false,
              (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic_rat,
                              (mat_multI zero_arctic_rat plus_arctic_rat
                                 times_arctic_rat n,
                                (id, (mat_ge non_strict_order_arctic_rat,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic_rat,
        (one_arctic_rat,
          (one_arctic_rat,
            (plus_arctic_rat,
              (times_arctic_rat,
                (id, (ge_arctic_rat,
                       (gt_arctic_rat d,
                         (false,
                           (arctic_rat_name,
                             (pos_arctic_rat, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))
                  (get_comp_plus
                    (mat n n,
                      (mat0I zero_arctic_rat n n,
                        (mat1I zero_arctic_rat one_arctic_rat n,
                          (mat1I zero_arctic_rat
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic_rat,
                                   (one_arctic_rat,
                                     (one_arctic_rat,
                                       (plus_arctic_rat,
 (times_arctic_rat,
   (id, (ge_arctic_rat,
          (gt_arctic_rat d,
            (false,
              (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic_rat,
                              (mat_multI zero_arctic_rat plus_arctic_rat
                                 times_arctic_rat n,
                                (id, (mat_ge non_strict_order_arctic_rat,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic_rat,
        (one_arctic_rat,
          (one_arctic_rat,
            (plus_arctic_rat,
              (times_arctic_rat,
                (id, (ge_arctic_rat,
                       (gt_arctic_rat d,
                         (false,
                           (arctic_rat_name,
                             (pos_arctic_rat, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))
                  (get_comp_times
                    (mat n n,
                      (mat0I zero_arctic_rat n n,
                        (mat1I zero_arctic_rat one_arctic_rat n,
                          (mat1I zero_arctic_rat
                             (get_comp_def
                               ((fn _ => true),
                                 (zero_arctic_rat,
                                   (one_arctic_rat,
                                     (one_arctic_rat,
                                       (plus_arctic_rat,
 (times_arctic_rat,
   (id, (ge_arctic_rat,
          (gt_arctic_rat d,
            (false,
              (arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
                             n,
                            (mat_plusI plus_arctic_rat,
                              (mat_multI zero_arctic_rat plus_arctic_rat
                                 times_arctic_rat n,
                                (id, (mat_ge non_strict_order_arctic_rat,
                                       (mat_comp_all
  (get_comp_gt
    ((fn _ => true),
      (zero_arctic_rat,
        (one_arctic_rat,
          (one_arctic_rat,
            (plus_arctic_rat,
              (times_arctic_rat,
                (id, (ge_arctic_rat,
                       (gt_arctic_rat d,
                         (false,
                           (arctic_rat_name,
                             (pos_arctic_rat, (fn _ => false)))))))))))))),
 (false,
   (concat
      [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
        [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o", #"v",
          #"e", #"r", #" "],
        get_comp_description
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))],
     (mat_arc_posI
        (get_comp_apos
          ((fn _ => true),
            (zero_arctic_rat,
              (one_arctic_rat,
                (one_arctic_rat,
                  (plus_arctic_rat,
                    (times_arctic_rat,
                      (id, (ge_arctic_rat,
                             (gt_arctic_rat d,
                               (false,
                                 (arctic_rat_name,
                                   (pos_arctic_rat,
                                     (fn _ => false)))))))))))))),
       (fn _ => false))))))))))))))))
            (fn f => fn aa => fn poly =>
              Alter8
                ((f, aa),
                  (fst poly,
                    fit_length
                      (get_comp_0
                        (mat n n,
                          (mat0I zero_arctic_rat n n,
                            (mat1I zero_arctic_rat one_arctic_rat n,
                              (mat1I zero_arctic_rat
                                 (get_comp_def
                                   ((fn _ => true),
                                     (zero_arctic_rat,
                                       (one_arctic_rat,
 (one_arctic_rat,
   (plus_arctic_rat,
     (times_arctic_rat,
       (id, (ge_arctic_rat,
              (gt_arctic_rat d,
                (false,
                  (arctic_rat_name,
                    (pos_arctic_rat, (fn _ => false))))))))))))))
                                 n,
                                (mat_plusI plus_arctic_rat,
                                  (mat_multI zero_arctic_rat plus_arctic_rat
                                     times_arctic_rat n,
                                    (id, (mat_ge non_strict_order_arctic_rat,
   (mat_comp_all
      (get_comp_gt
        ((fn _ => true),
          (zero_arctic_rat,
            (one_arctic_rat,
              (one_arctic_rat,
                (plus_arctic_rat,
                  (times_arctic_rat,
                    (id, (ge_arctic_rat,
                           (gt_arctic_rat d,
                             (false,
                               (arctic_rat_name,
                                 (pos_arctic_rat, (fn _ => false)))))))))))))),
     (false,
       (concat
          [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
            [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"o",
              #"v", #"e", #"r", #" "],
            get_comp_description
              ((fn _ => true),
                (zero_arctic_rat,
                  (one_arctic_rat,
                    (one_arctic_rat,
                      (plus_arctic_rat,
                        (times_arctic_rat,
                          (id, (ge_arctic_rat,
                                 (gt_arctic_rat d,
                                   (false,
                                     (arctic_rat_name,
                                       (pos_arctic_rat,
 (fn _ => false)))))))))))))],
         (mat_arc_posI
            (get_comp_apos
              ((fn _ => true),
                (zero_arctic_rat,
                  (one_arctic_rat,
                    (one_arctic_rat,
                      (plus_arctic_rat,
                        (times_arctic_rat,
                          (id, (ge_arctic_rat,
                                 (gt_arctic_rat d,
                                   (false,
                                     (arctic_rat_name,
                                       (pos_arctic_rat,
 (fn _ => false)))))))))))))),
           (fn _ => false))))))))))))))
                      aa (snd poly))))
        | Rational (d, deg) =>
          (if less_eq_nat deg one_nata
            then xml3elements
                   [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
                   xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
                   (fn x =>
                     bindb (polynomial rat x)
                       (lpoly_of equal_rat
                         (get_comp_0
                           ((fn _ => true),
                             (fract (0 : IntInf.int) (1 : IntInf.int),
                               (fract (1 : IntInf.int) (1 : IntInf.int),
                                 (d, (plus_rata,
                                       (times_rata,
 (max0_rat,
   (ge_rat, (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                         (get_comp_1
                           ((fn _ => true),
                             (fract (0 : IntInf.int) (1 : IntInf.int),
                               (fract (1 : IntInf.int) (1 : IntInf.int),
                                 (d, (plus_rata,
                                       (times_rata,
 (max0_rat,
   (ge_rat, (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                         (get_comp_plus
                           ((fn _ => true),
                             (fract (0 : IntInf.int) (1 : IntInf.int),
                               (fract (1 : IntInf.int) (1 : IntInf.int),
                                 (d, (plus_rata,
                                       (times_rata,
 (max0_rat,
   (ge_rat, (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                         (get_comp_times
                           ((fn _ => true),
                             (fract (0 : IntInf.int) (1 : IntInf.int),
                               (fract (1 : IntInf.int) (1 : IntInf.int),
                                 (d, (plus_rata,
                                       (times_rata,
 (max0_rat,
   (ge_rat,
     (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))))
                   (fn f => fn aa => fn poly =>
                     Alter2
                       ((f, aa),
                         (fst poly,
                           fit_length
                             (get_comp_0
                               ((fn _ => true),
                                 (fract (0 : IntInf.int) (1 : IntInf.int),
                                   (fract (1 : IntInf.int) (1 : IntInf.int),
                                     (d, (plus_rata,
   (times_rata,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                             aa (snd poly))))
            else xml3elements
                   [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
                   xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
                   (fn x =>
                     bindb (polynomial rat x)
                       (fn p =>
                         Inr (poly_of equal_nat (equal_rat, comm_semiring_1_rat)
                               p)))
                   (fn f => fn aa => fn poly => Alter10 ((f, aa), poly)))
        | Rat_mat (d, n, sd) =>
          xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
            xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
            (fn x =>
              bindb (polynomial
                      (mat_coeff (fract (0 : IntInf.int) (1 : IntInf.int)) rat)
                      x)
                (lpoly_of (equal_list (equal_list equal_rat))
                  (get_comp_0
                    (mat n n,
                      (mat0I (fract (0 : IntInf.int) (1 : IntInf.int)) n n,
                        (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                           (fract (1 : IntInf.int) (1 : IntInf.int)) n,
                          (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                             (get_comp_def
                               ((fn _ => true),
                                 (fract (0 : IntInf.int) (1 : IntInf.int),
                                   (fract (1 : IntInf.int) (1 : IntInf.int),
                                     (d, (plus_rata,
   (times_rata,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                             n,
                            (mat_plusI plus_rata,
                              (mat_multI
                                 (fract (0 : IntInf.int) (1 : IntInf.int))
                                 plus_rata times_rata n,
                                (mat_max0 max_ordered_monoid_add_rat,
                                  (mat_ge non_strict_order_rat,
                                    (mat_gtI non_strict_order_rat
                                       (get_comp_gt
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         (fract (0 : IntInf.int) (1 : IntInf.int),
           (fract (1 : IntInf.int) (1 : IntInf.int),
             (d, (plus_rata,
                   (times_rata,
                     (max0_rat,
                       (ge_rat,
                         (rat_gt d,
                           (true,
                             (rat_name, ((fn _ => true), rat_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          (fract (0 : IntInf.int) (1 : IntInf.int),
            (fract (1 : IntInf.int) (1 : IntInf.int),
              (d, (plus_rata,
                    (times_rata,
                      (max0_rat,
                        (ge_rat,
                          (rat_gt d,
                            (true,
                              (rat_name,
                                ((fn _ => true),
                                  rat_mono))))))))))))))))))))))))))
                  (get_comp_1
                    (mat n n,
                      (mat0I (fract (0 : IntInf.int) (1 : IntInf.int)) n n,
                        (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                           (fract (1 : IntInf.int) (1 : IntInf.int)) n,
                          (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                             (get_comp_def
                               ((fn _ => true),
                                 (fract (0 : IntInf.int) (1 : IntInf.int),
                                   (fract (1 : IntInf.int) (1 : IntInf.int),
                                     (d, (plus_rata,
   (times_rata,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                             n,
                            (mat_plusI plus_rata,
                              (mat_multI
                                 (fract (0 : IntInf.int) (1 : IntInf.int))
                                 plus_rata times_rata n,
                                (mat_max0 max_ordered_monoid_add_rat,
                                  (mat_ge non_strict_order_rat,
                                    (mat_gtI non_strict_order_rat
                                       (get_comp_gt
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         (fract (0 : IntInf.int) (1 : IntInf.int),
           (fract (1 : IntInf.int) (1 : IntInf.int),
             (d, (plus_rata,
                   (times_rata,
                     (max0_rat,
                       (ge_rat,
                         (rat_gt d,
                           (true,
                             (rat_name, ((fn _ => true), rat_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          (fract (0 : IntInf.int) (1 : IntInf.int),
            (fract (1 : IntInf.int) (1 : IntInf.int),
              (d, (plus_rata,
                    (times_rata,
                      (max0_rat,
                        (ge_rat,
                          (rat_gt d,
                            (true,
                              (rat_name,
                                ((fn _ => true),
                                  rat_mono))))))))))))))))))))))))))
                  (get_comp_plus
                    (mat n n,
                      (mat0I (fract (0 : IntInf.int) (1 : IntInf.int)) n n,
                        (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                           (fract (1 : IntInf.int) (1 : IntInf.int)) n,
                          (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                             (get_comp_def
                               ((fn _ => true),
                                 (fract (0 : IntInf.int) (1 : IntInf.int),
                                   (fract (1 : IntInf.int) (1 : IntInf.int),
                                     (d, (plus_rata,
   (times_rata,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                             n,
                            (mat_plusI plus_rata,
                              (mat_multI
                                 (fract (0 : IntInf.int) (1 : IntInf.int))
                                 plus_rata times_rata n,
                                (mat_max0 max_ordered_monoid_add_rat,
                                  (mat_ge non_strict_order_rat,
                                    (mat_gtI non_strict_order_rat
                                       (get_comp_gt
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         (fract (0 : IntInf.int) (1 : IntInf.int),
           (fract (1 : IntInf.int) (1 : IntInf.int),
             (d, (plus_rata,
                   (times_rata,
                     (max0_rat,
                       (ge_rat,
                         (rat_gt d,
                           (true,
                             (rat_name, ((fn _ => true), rat_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          (fract (0 : IntInf.int) (1 : IntInf.int),
            (fract (1 : IntInf.int) (1 : IntInf.int),
              (d, (plus_rata,
                    (times_rata,
                      (max0_rat,
                        (ge_rat,
                          (rat_gt d,
                            (true,
                              (rat_name,
                                ((fn _ => true),
                                  rat_mono))))))))))))))))))))))))))
                  (get_comp_times
                    (mat n n,
                      (mat0I (fract (0 : IntInf.int) (1 : IntInf.int)) n n,
                        (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                           (fract (1 : IntInf.int) (1 : IntInf.int)) n,
                          (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                             (get_comp_def
                               ((fn _ => true),
                                 (fract (0 : IntInf.int) (1 : IntInf.int),
                                   (fract (1 : IntInf.int) (1 : IntInf.int),
                                     (d, (plus_rata,
   (times_rata,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                             n,
                            (mat_plusI plus_rata,
                              (mat_multI
                                 (fract (0 : IntInf.int) (1 : IntInf.int))
                                 plus_rata times_rata n,
                                (mat_max0 max_ordered_monoid_add_rat,
                                  (mat_ge non_strict_order_rat,
                                    (mat_gtI non_strict_order_rat
                                       (get_comp_gt
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                                       sd,
                                      (get_comp_mono
 ((fn _ => true),
   (fract (0 : IntInf.int) (1 : IntInf.int),
     (fract (1 : IntInf.int) (1 : IntInf.int),
       (d, (plus_rata,
             (times_rata,
               (max0_rat,
                 (ge_rat,
                   (rat_gt d,
                     (true, (rat_name, ((fn _ => true), rat_mono)))))))))))),
(concat
   [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
     [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w", #"i",
       #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
       #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
     shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
     get_comp_description
       ((fn _ => true),
         (fract (0 : IntInf.int) (1 : IntInf.int),
           (fract (1 : IntInf.int) (1 : IntInf.int),
             (d, (plus_rata,
                   (times_rata,
                     (max0_rat,
                       (ge_rat,
                         (rat_gt d,
                           (true,
                             (rat_name, ((fn _ => true), rat_mono))))))))))))],
  ((fn _ => true),
    mat_mono sd
      (get_comp_check_mono
        ((fn _ => true),
          (fract (0 : IntInf.int) (1 : IntInf.int),
            (fract (1 : IntInf.int) (1 : IntInf.int),
              (d, (plus_rata,
                    (times_rata,
                      (max0_rat,
                        (ge_rat,
                          (rat_gt d,
                            (true,
                              (rat_name,
                                ((fn _ => true),
                                  rat_mono))))))))))))))))))))))))))))
            (fn f => fn aa => fn poly =>
              Alter5
                ((f, aa),
                  (fst poly,
                    fit_length
                      (get_comp_0
                        (mat n n,
                          (mat0I (fract (0 : IntInf.int) (1 : IntInf.int)) n n,
                            (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                               (fract (1 : IntInf.int) (1 : IntInf.int)) n,
                              (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
                                 (get_comp_def
                                   ((fn _ => true),
                                     (fract (0 : IntInf.int) (1 : IntInf.int),
                                       (fract (1 : IntInf.int) (1 : IntInf.int),
 (d, (plus_rata,
       (times_rata,
         (max0_rat,
           (ge_rat,
             (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                                 n,
                                (mat_plusI plus_rata,
                                  (mat_multI
                                     (fract (0 : IntInf.int) (1 : IntInf.int))
                                     plus_rata times_rata n,
                                    (mat_max0 max_ordered_monoid_add_rat,
                                      (mat_ge non_strict_order_rat,
(mat_gtI non_strict_order_rat
   (get_comp_gt
     ((fn _ => true),
       (fract (0 : IntInf.int) (1 : IntInf.int),
         (fract (1 : IntInf.int) (1 : IntInf.int),
           (d, (plus_rata,
                 (times_rata,
                   (max0_rat,
                     (ge_rat,
                       (rat_gt d,
                         (true,
                           (rat_name, ((fn _ => true), rat_mono)))))))))))))
   sd,
  (get_comp_mono
     ((fn _ => true),
       (fract (0 : IntInf.int) (1 : IntInf.int),
         (fract (1 : IntInf.int) (1 : IntInf.int),
           (d, (plus_rata,
                 (times_rata,
                   (max0_rat,
                     (ge_rat,
                       (rat_gt d,
                         (true,
                           (rat_name, ((fn _ => true), rat_mono)))))))))))),
    (concat
       [shows_prec_nat Zero_nat n [], [#"x"], shows_prec_nat Zero_nat n [],
         [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e", #"s", #" ", #"w",
           #"i", #"t", #"h", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ",
           #"d", #"i", #"m", #"e", #"n", #"s", #"i", #"o", #"n", #" "],
         shows_prec_nat Zero_nat sd [], [#" ", #"o", #"v", #"e", #"r", #" "],
         get_comp_description
           ((fn _ => true),
             (fract (0 : IntInf.int) (1 : IntInf.int),
               (fract (1 : IntInf.int) (1 : IntInf.int),
                 (d, (plus_rata,
                       (times_rata,
                         (max0_rat,
                           (ge_rat,
                             (rat_gt d,
                               (true,
                                 (rat_name,
                                   ((fn _ => true), rat_mono))))))))))))],
      ((fn _ => true),
        mat_mono sd
          (get_comp_check_mono
            ((fn _ => true),
              (fract (0 : IntInf.int) (1 : IntInf.int),
                (fract (1 : IntInf.int) (1 : IntInf.int),
                  (d, (plus_rata,
                        (times_rata,
                          (max0_rat,
                            (ge_rat,
                              (rat_gt d,
                                (true,
                                  (rat_name,
                                    ((fn _ => true),
                                      rat_mono))))))))))))))))))))))))))
                      aa (snd poly))))))
    (fn typea => fn pi =>
      (case typea
        of Natural deg =>
          (if less_eq_nat deg one_nata then Int_carrier (mapa alter1a pi)
            else Int_nl_carrier (mapa alter9a pi))
        | Arctic => Arctic_carrier (mapa alter3a pi)
        | Arctic_rat d => Arctic_rat_carrier (d, mapa alter7a pi)
        | Int_mat (n, sd) => Int_mat_carrier (n, sd, mapa alter4a pi)
        | Arc_mat n => Arc_mat_carrier (n, mapa alter6a pi)
        | Arc_rat_mat (d, n) => Arc_rat_mat_carrier (d, n, mapa alter8a pi)
        | Rational (d, deg) =>
          (if less_eq_nat deg one_nata then Rat_carrier (d, mapa alter2a pi)
            else Rat_nl_carrier (d, mapa alter10a pi))
        | Rat_mat (d, n, sd) => Rat_mat_carrier (d, n, sd, mapa alter5a pi)));

fun redtriple xml2name =
  xml1element [#"r", #"e", #"d", #"P", #"a", #"i", #"r"]
    (xml_options
      [([#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t", #"a", #"t", #"i",
          #"o", #"n"],
         interpretation xml2name),
        ([#"p", #"a", #"t", #"h", #"O", #"r", #"d", #"e", #"r"],
          path_order xml2name)])
    id;

fun xml2dp_input xml2name =
  xml_choice [#"d", #"p", #"I", #"n", #"p", #"u", #"t"]
    [xml4elements [#"d", #"p", #"I", #"n", #"p", #"u", #"t"]
       (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
       (xml1element [#"d", #"p", #"s"] (rules xml2name) id) (strategy xml2name)
       (boola [#"m", #"i", #"n", #"i", #"m", #"a", #"l"])
       (fn r => fn p => fn s => fn _ => (p, (s, r))),
      xml3elements [#"d", #"p", #"I", #"n", #"p", #"u", #"t"]
        (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
        (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
        (boola [#"m", #"i", #"n", #"i", #"m", #"a", #"l"])
        (fn r => fn p => fn _ => (p, (No_Strategy, r)))];

fun xml2trs_input xml2name =
  (fn x =>
    let
      val e = no_transform [#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"] x;
    in
      (case x of Xml (tag, [], [], optiona) => e
        | Xml (tag, [], c :: cs, NONE) =>
          (if less_eq_nat (size_list cs) (nat (2 : IntInf.int)) andalso
                equal_lista equal_char tag
                  [#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"]
            then bindb (xml1element [#"t", #"r", #"s"] (rules xml2name) id c)
                   (fn r =>
                     bindb (if null cs orelse
                                 not (equal_lista equal_char (get_name (hd cs))
                                       [#"s", #"t", #"r", #"a", #"t", #"e",
 #"g", #"y"])
                             then Inr (No_Strategy, cs)
                             else bindb (strategy xml2name (hd cs))
                                    (fn s => Inr (s, tl cs)))
                       (fn (str, csa) =>
                         bindb (if null csa orelse
                                     not (equal_lista equal_char
   (get_name (hd csa))
   [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"R", #"u", #"l", #"e",
     #"s"])
                                 then Inr (NONE, csa)
                                 else bindb
(xml1element
  [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"R", #"u", #"l", #"e", #"s"]
  (rules xml2name) id (hd csa))
(fn s => Inr (SOME s, tl csa)))
                           (fn (s_opt, csb) =>
                             (if null csb then Inr (str, (r, s_opt)) else e))))
            else e)
        | Xml (tag, [], c :: cs, SOME _) => e
        | Xml (tag, _ :: _, list3, optiona) => e)
    end);

fun xml2input xml2name =
  xml1element [#"i", #"n", #"p", #"u", #"t"]
    (xml_choice [#"i", #"n", #"p", #"u", #"t"]
      [xml_change (xml2trs_input xml2name) Inr,
        xml_change (xml2dp_input xml2name) Inl])
    id;

fun xml_rules A_ B_ C_ tag rls =
  Xml (tag, [],
        [Xml ([#"r", #"u", #"l", #"e", #"s"], [],
               mapa (fn (l, r) =>
                      Xml ([#"r", #"u", #"l", #"e"], [],
                            [Xml ([#"l", #"h", #"s"], [], [xml_term A_ B_ C_ l],
                                   NONE),
                              Xml ([#"r", #"h", #"s"], [],
                                    [xml_term A_ B_ C_ r], NONE)],
                            NONE))
                 rls,
               NONE)],
        NONE);

fun lexord_code A_ lt uu [] = false
  | lexord_code A_ lt [] (v :: va) = true
  | lexord_code A_ lt (x :: xs) (y :: ys) =
    lt x y orelse eq A_ x y andalso lexord_code A_ lt xs ys;

fun less_lab (A1_, A2_) (B1_, B2_) (UnLab f) (UnLab g) = less A2_ f g
  | less_lab (A1_, A2_) (B1_, B2_) (UnLab f) (Lab (v, va)) = true
  | less_lab (A1_, A2_) (B1_, B2_) (UnLab f) (FunLab (v, va)) = true
  | less_lab (A1_, A2_) (B1_, B2_) (UnLab f) (Sharp v) = true
  | less_lab (A1_, A2_) (B1_, B2_) (Lab (f, la)) (Lab (g, l)) =
    less B2_ la l orelse eq B1_ la l andalso less_lab (A1_, A2_) (B1_, B2_) f g
  | less_lab (A1_, A2_) (B1_, B2_) (Lab (f, l)) (UnLab uv) = false
  | less_lab (A1_, A2_) (B1_, B2_) (Lab (f, l)) (FunLab (v, va)) = true
  | less_lab (A1_, A2_) (B1_, B2_) (Lab (f, l)) (Sharp v) = true
  | less_lab (A1_, A2_) (B1_, B2_) (Sharp f) (Sharp g) =
    less_lab (A1_, A2_) (B1_, B2_) f g
  | less_lab (A1_, A2_) (B1_, B2_) (Sharp f) (UnLab ux) = false
  | less_lab (A1_, A2_) (B1_, B2_) (Sharp f) (Lab (uy, uz)) = false
  | less_lab (A1_, A2_) (B1_, B2_) (Sharp f) (FunLab (v, vb)) = true
  | less_lab (A1_, A2_) (B1_, B2_) (FunLab (f, fs)) (FunLab (g, gs)) =
    less_lab (A1_, A2_) (B1_, B2_) f g orelse
      equal_laba A1_ B1_ f g andalso
        lexord_code (equal_lab A1_ B1_) (less_lab (A1_, A2_) (B1_, B2_)) fs gs
  | less_lab (A1_, A2_) (B1_, B2_) (FunLab (f, fs)) (Lab (v, va)) = false
  | less_lab (A1_, A2_) (B1_, B2_) (FunLab (f, fs)) (UnLab v) = false
  | less_lab (A1_, A2_) (B1_, B2_) (FunLab (f, fs)) (Sharp v) = false;

fun less_eq_lab (A1_, A2_) (B1_, B2_) xs ys =
  less_lab (A1_, A2_) (B1_, B2_) xs ys orelse equal_laba A1_ B1_ xs ys;

fun ord_lab (A1_, A2_) (B1_, B2_) =
  {less_eq = less_eq_lab (A1_, A2_) (B1_, B2_),
    less = less_lab (A1_, A2_) (B1_, B2_)}
  : ('a, 'b) lab ord;

type 'a ordered_semiring_0 =
  {semiring_0_ordered_semiring_0 : 'a semiring_0,
    ordered_ab_semigroup_ordered_semiring_0 : 'a ordered_ab_semigroup};
val semiring_0_ordered_semiring_0 = #semiring_0_ordered_semiring_0 :
  'a ordered_semiring_0 -> 'a semiring_0;
val ordered_ab_semigroup_ordered_semiring_0 =
  #ordered_ab_semigroup_ordered_semiring_0 :
  'a ordered_semiring_0 -> 'a ordered_ab_semigroup;

type 'a ordered_semiring_1 =
  {semiring_1_ordered_semiring_1 : 'a semiring_1,
    ordered_semiring_0_ordered_semiring_1 : 'a ordered_semiring_0};
val semiring_1_ordered_semiring_1 = #semiring_1_ordered_semiring_1 :
  'a ordered_semiring_1 -> 'a semiring_1;
val ordered_semiring_0_ordered_semiring_1 =
  #ordered_semiring_0_ordered_semiring_1 :
  'a ordered_semiring_1 -> 'a ordered_semiring_0;

type 'a max_ordered_semiring_1 =
  {max_ordered_monoid_add_max_ordered_semiring_1 : 'a max_ordered_monoid_add,
    ordered_semiring_1_max_ordered_semiring_1 : 'a ordered_semiring_1};
val max_ordered_monoid_add_max_ordered_semiring_1 =
  #max_ordered_monoid_add_max_ordered_semiring_1 :
  'a max_ordered_semiring_1 -> 'a max_ordered_monoid_add;
val ordered_semiring_1_max_ordered_semiring_1 =
  #ordered_semiring_1_max_ordered_semiring_1 :
  'a max_ordered_semiring_1 -> 'a ordered_semiring_1;

type 'a poly_carrier =
  {comm_semiring_1_poly_carrier : 'a comm_semiring_1,
    max_ordered_semiring_1_poly_carrier : 'a max_ordered_semiring_1};
val comm_semiring_1_poly_carrier = #comm_semiring_1_poly_carrier :
  'a poly_carrier -> 'a comm_semiring_1;
val max_ordered_semiring_1_poly_carrier = #max_ordered_semiring_1_poly_carrier :
  'a poly_carrier -> 'a max_ordered_semiring_1;

fun default_I A_ def n =
  ([], def) ::
    mapa (fn i =>
           ([(i, one_nata)],
             one ((one_power o power_monoid_mult o monoid_mult_semiring_1 o
                    semiring_1_comm_semiring_1 o comm_semiring_1_poly_carrier)
                   A_)))
      (upt Zero_nat n);

fun poly_power A_ (B1_, B2_) uu Zero_nat =
  one_poly (semiring_1_comm_semiring_1 B2_)
  | poly_power A_ (B1_, B2_) p (Suc n) =
    poly_mult A_ (B1_, (semiring_0_semiring_1 o semiring_1_comm_semiring_1) B2_)
      p (poly_power A_ (B1_, B2_) p n);

fun monom_subst B_ (C1_, C2_) sigma [] =
  one_poly (semiring_1_comm_semiring_1 C2_)
  | monom_subst B_ (C1_, C2_) sigma ((x, p) :: m) =
    poly_mult B_ (C1_, (semiring_0_semiring_1 o semiring_1_comm_semiring_1) C2_)
      (poly_power B_ (C1_, C2_) (sigma x) p)
      (monom_subst B_ (C1_, C2_) sigma m);

fun poly_subst B_ (C1_, C2_) sigma [] = zero_poly
  | poly_subst B_ (C1_, C2_) sigma ((m, c) :: p) =
    poly_add B_ (C1_, (semiring_0_semiring_1 o semiring_1_comm_semiring_1) C2_)
      (poly_mult B_
        (C1_, (semiring_0_semiring_1 o semiring_1_comm_semiring_1) C2_)
        [([], c)] (monom_subst B_ (C1_, C2_) sigma m))
      (poly_subst B_ (C1_, C2_) sigma p);

fun eval_term (B1_, B2_) C_ uu (Var x) =
  [([(x, one_nata)],
     one ((one_power o power_monoid_mult o monoid_mult_semiring_1 o
            semiring_1_comm_semiring_1 o comm_semiring_1_poly_carrier)
           B2_))]
  | eval_term (B1_, B2_) C_ i (Fun (f, ts)) =
    let
      val ps = mapa (eval_term (B1_, B2_) C_ i) ts;
      val n = size_list ts;
    in
      poly_subst C_ (B1_, comm_semiring_1_poly_carrier B2_)
        (fn ia => (if less_nat ia n then nth ps ia else zero_poly)) (i f n)
    end;

fun eval_monom B_ alpha [] =
  one ((one_power o power_monoid_mult o monoid_mult_semiring_1 o
         semiring_1_comm_semiring_1)
        B_)
  | eval_monom B_ alpha ((x, p) :: m) =
    times ((times_dvd o dvd_comm_semiring_1) B_) (eval_monom B_ alpha m)
      (power
        ((power_monoid_mult o monoid_mult_semiring_1 o
           semiring_1_comm_semiring_1)
          B_)
        (alpha x) p);

fun eval_poly B_ alpha [] =
  zero ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_semiring_1 o
          semiring_1_comm_semiring_1)
         B_)
  | eval_poly B_ alpha (mc :: p) =
    plus ((plus_semigroup_add o semigroup_add_monoid_add o
            monoid_add_comm_monoid_add o comm_monoid_add_semiring_0 o
            semiring_0_semiring_1 o semiring_1_comm_semiring_1)
           B_)
      (times ((times_dvd o dvd_comm_semiring_1) B_)
        (eval_monom B_ alpha (fst mc)) (snd mc))
      (eval_poly B_ alpha p);

fun check_supt (A1_, A2_) (B1_, B2_) s t =
  check (member (s, t) (supt A1_ B1_))
    (shows_prec_term A2_ B2_ Zero_nat t o
      (shows_string
         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ", #"p",
           #"r", #"o", #"p", #"e", #"r", #" ", #"s", #"u", #"b", #"t", #"e",
           #"r", #"m", #" ", #"o", #"f", #" "] o
        shows_prec_term A2_ B2_ Zero_nat s));

fun shows_ctxt funa var Hole = shows_string [#"[", #"]"]
  | shows_ctxt funa var (More (f, ss1, d, ss2)) =
    funa f o
      (shows_string [#"("] o
        (shows_list_gen (shows_term funa var) [] [] [#",", #" "] [#",", #" "]
           ss1 o
          (shows_ctxt funa var d o
            shows_list_gen (shows_term funa var) [#")"] [#",", #" "]
              [#",", #" "] [#")"] ss2)));

fun desc (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = desc;

fun mono (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = mono;

fun nsta (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) = nst;

fun eq_rule_mod_vars A_ B_ lr st =
  instance_rule A_ B_ lr st andalso instance_rule A_ B_ st lr;

fun ctxt_of_pos_term Empty t = Hole
  | ctxt_of_pos_term (PCons (i, ps)) (Fun (f, ts)) =
    More (f, take i ts, ctxt_of_pos_term ps (nth ts i), drop (Suc i) ts);

fun shows_prec_pos d p = shows_pos p;

fun check_rstep (A1_, A2_) (B1_, B2_) ra p r s t =
  let
    val sps = poss_list s;
    val tps = poss_list t;
  in
    bindb (check (list_ex (eq_rule_mod_vars A1_ B1_ r) ra)
            (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
               [#" ", #"-", #">", #" "] r o
              (shows_string
                 [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ",
                   #"r", #"u", #"l", #"e", #" ", #"o", #"f"] o
                (shows_nl o
                  (shows_trs (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
                     [#" ", #"-", #">", #" "]
                     [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s",
                       #"y", #"s", #"t", #"e", #"m", #":"]
                     ra o
                    shows_nl)))))
      (fn _ =>
        bindb (check (membera equal_pos sps p)
                (shows_prec_pos Zero_nat p o
                  (shows_string
                     [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a",
                       #" ", #"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n",
                       #" ", #"o", #"f", #" "] o
                    (shows_prec_term A2_ B2_ Zero_nat s o shows_nl))))
          (fn _ =>
            bindb (check (membera equal_pos tps p)
                    (shows_prec_pos Zero_nat p o
                      (shows_string
                         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a",
                           #" ", #"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n",
                           #" ", #"o", #"f", #" "] o
                        (shows_prec_term A2_ B2_ Zero_nat t o shows_nl))))
              (fn _ =>
                let
                  val c = ctxt_of_pos_term p s;
                  val d = ctxt_of_pos_term p t;
                  val u = subt_at s p;
                  val v = subt_at t p;
                in
                  (case match_list A1_ B1_ [(u, fst r), (v, snd r)]
                    of NONE =>
                      Inl (shows_string
                             [#"t", #"h", #"e", #" ", #"t", #"e", #"r", #"m",
                               #" "] o
                            (shows_prec_term A2_ B2_ Zero_nat t o
                              (shows_string
                                 [#" ", #"d", #"o", #"e", #"s", #" ", #"n",
                                   #"o", #"t", #" ", #"r", #"e", #"s", #"u",
                                   #"l", #"t", #" ", #"f", #"r", #"o", #"m",
                                   #" ", #"a", #" ", #"p", #"r", #"o", #"p",
                                   #"e", #"r", #" ", #"a", #"p", #"p", #"l",
                                   #"i", #"c", #"a", #"t", #"i", #"o", #"n",
                                   #" ", #"o", #"f", #" ", #"r", #"u", #"l",
                                   #"e", #" "] o
                                (shows_nl o
                                  (shows_rule (shows_prec A2_ Zero_nat)
                                     (shows_prec B2_ Zero_nat)
                                     [#" ", #"-", #">", #" "] r o
                                    (shows_string
                                       [#" ", #"a", #"t", #" ", #"p", #"o",
 #"s", #"i", #"t", #"i", #"o", #"n", #" "] o
                                      (shows_prec_pos Zero_nat p o
shows_nl)))))))
                    | SOME _ =>
                      check (equal_ctxt A1_ B1_ c d)
                        (shows_string
                           [#"t", #"h", #"e", #" ", #"t", #"e", #"r", #"m",
                             #" "] o
                          (shows_prec_term A2_ B2_ Zero_nat t o
                            (shows_string
                               [#" ", #"d", #"o", #"e", #"s", #" ", #"n", #"o",
                                 #"t", #" ", #"r", #"e", #"s", #"u", #"l", #"t",
                                 #" ", #"f", #"r", #"o", #"m", #" ", #"a", #" ",
                                 #"p", #"r", #"o", #"p", #"e", #"r", #" ", #"a",
                                 #"p", #"p", #"l", #"i", #"c", #"a", #"t", #"i",
                                 #"o", #"n", #" ", #"o", #"f", #" ", #"r", #"u",
                                 #"l", #"e", #" "] o
                              (shows_nl o
                                (shows_rule (shows_prec A2_ Zero_nat)
                                   (shows_prec B2_ Zero_nat)
                                   [#" ", #"-", #">", #" "] r o
                                  (shows_string
                                     [#" ", #"a", #"t", #" ", #"p", #"o", #"s",
                                       #"i", #"t", #"i", #"o", #"n", #" "] o
                                    (shows_prec_pos Zero_nat p o
                                      shows_nl))))))))
                end)))
  end;

fun check_rrstep (A1_, A2_) (B1_, B2_) ra r s t =
  check_rstep (A1_, A2_) (B1_, B2_) ra Empty r s t;

fun check_steps (A1_, A2_) (B1_, B2_) p r [] s u =
  check (equal_terma A1_ B1_ s u)
    (shows_string
       [#"t", #"h", #"e", #" ", #"l", #"a", #"s", #"t", #" ", #"t", #"e", #"r",
         #"m", #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"r", #"e", #"w",
         #"r", #"i", #"t", #"e", #" ", #"s", #"e", #"q", #"u", #"e", #"n", #"c",
         #"e"] o
      (shows_nl o
        (shows_prec_term A2_ B2_ Zero_nat s o
          (shows_string
             (shows_nl
               [#"d", #"o", #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"c",
                 #"o", #"r", #"r", #"e", #"s", #"p", #"o", #"n", #"d", #" ",
                 #"t", #"o", #" ", #"t", #"h", #"e", #" ", #"g", #"o", #"a",
                 #"l", #" ", #"t", #"e", #"r", #"m"]) o
            (shows_nl o (shows_prec_term A2_ B2_ Zero_nat u o shows_nl))))))
  | check_steps (A1_, A2_) (B1_, B2_) p ra ((uu, (r, (true, t))) :: prts) s u =
    bindb (check_rrstep (A1_, A2_) (B1_, B2_) p r s t)
      (fn _ => check_steps (A1_, A2_) (B1_, B2_) p ra prts t u)
  | check_steps (A1_, A2_) (B1_, B2_) pa ra ((p, (r, (false, t))) :: prts) s u =
    bindb (check_rstep (A1_, A2_) (B1_, B2_) ra p r s t)
      (fn _ => check_steps (A1_, A2_) (B1_, B2_) pa ra prts t u);

fun generate_var i = #"x" :: shows_prec_nat Zero_nat i [];

fun uncurry_term A_ a sm t =
  (case unapp A_ a t
    of (Var x, ts) => apply_args a (Var x) (mapa (uncurry_term A_ a sm) ts)
    | (Fun (f, ss), ts) =>
      let
        val n = size_list ss;
        val uss = mapa (uncurry_term A_ a sm) ss;
        val uts = mapa (uncurry_term A_ a sm) ts;
        val aa = aarity sm f n;
        val m = min ord_nat (size_list ts) aa;
        val fm = get_symbol sm f n m;
      in
        apply_args a (Fun (fm, uss @ take m uts)) (drop m uts)
      end);

fun parse_name x =
  binda (manyof letters)
    (fn n =>
      binda spaces
        (fn _ =>
          (if null n then (fn _ => Inl letters) else (fn ts => Inr (n, ts)))))
    x;

fun parse_text x =
  binda (many (fn c => not (equal_lista equal_char [c] [#"<"])))
    (fn ts =>
      let
        val text = trim ts;
      in
        (if null text then (fn tsa => Inr (NONE, tsa))
          else (fn tsa => Inr (SOME (rev (trim (rev text))), tsa)))
      end)
    x;

fun parse_attribute_value x =
  binda (oneof [dquote])
    (fn _ =>
      binda (many (fn c => not (equal_lista equal_char [c] dquote)))
        (fn v => binda (oneof [dquote]) (fn _ => fn ts => Inr (v, ts))))
    x;

fun parse_attributes [] = Inr ([], [])
  | parse_attributes (c :: s) =
    (if membera equal_char [#"/", #">"] c then Inr ([], c :: s)
      else binda parse_name
             (fn k =>
               binda (oneof [[#"="]])
                 (fn _ =>
                   binda parse_attribute_value
                     (fn v =>
                       binda parse_attributes
                         (fn atts => fn ts => Inr ((k, v) :: atts, ts)))))
             (c :: s));

fun parse_nodes ts =
  (if null ts orelse
        equal_lista equal_char (take (nat (2 : IntInf.int)) ts) [#"<", #"/"]
    then Inr ([], ts)
    else binda (oneof [[#"<"]])
           (fn _ =>
             binda parse_name
               (fn n =>
                 binda parse_attributes
                   (fn atts =>
                     binda (oneof [[#"/", #">"], [#">"]])
                       (fn e => fn tsa =>
                         (if equal_lista equal_char e [#"/", #">"]
                           then binda parse_nodes
                                  (fn cs => fn tsb =>
                                    Inr (Xml (n, atts, [], NONE) :: cs, tsb))
                                  tsa
                           else binda parse_text
                                  (fn t =>
                                    binda parse_nodes
                                      (fn cs =>
binda (oneof [[#"<", #"/"] @ n @ [#">"]])
  (fn _ =>
    binda parse_nodes
      (fn ns => fn tsb => Inr (Xml (n, atts, cs, t) :: ns, tsb)))))
                                  tsa)))))
           ts);

fun parse_node x =
  binda (oneof [[#"<"]])
    (fn _ =>
      binda parse_name
        (fn n =>
          binda parse_attributes
            (fn atts =>
              binda (oneof [[#"/", #">"], [#">"]])
                (fn e =>
                  (if equal_lista equal_char e [#"/", #">"]
                    then (fn ts => Inr (Xml (n, atts, [], NONE), ts))
                    else binda parse_text
                           (fn t =>
                             binda parse_nodes
                               (fn cs =>
                                 binda (oneof [[#"<", #"/"] @ n @ [#">"]])
                                   (fn _ => fn ts =>
                                     Inr (Xml (n, atts, cs, t), ts)))))))))
    x;

fun scan_upto enda [] =
  Inl ([#"d", #"i", #"d", #" ", #"n", #"o", #"t", #" ", #"f", #"i", #"n", #"d",
         #" ", #"e", #"n", #"d", #"-", #"m", #"a", #"r", #"k", #"e", #"r",
         #" "] @
        quote (shows_prec_list show_char Zero_nat enda) [])
  | scan_upto enda (t :: ts) =
    (if equal_lista equal_char (mapa snd (zip enda (t :: ts))) enda
      then Inr (enda, drop (size_list enda) (t :: ts))
      else bindb (scan_upto enda ts) (fn (res, tsa) => Inr (t :: res, tsa)));

fun parse_header ts =
  (if equal_lista equal_char (take (nat (2 : IntInf.int)) (trim ts))
        [#"<", #"?"]
    then binda (scan_upto [#"?", #">"])
           (fn h => binda parse_header (fn hs => fn tsa => Inr (h @ hs, tsa)))
           ts
    else binda spaces (fn _ => fn tsa => Inr ([], tsa)) ts);

fun update_tokens f ts = Inr (ts, f ts);

fun remove_comments_aux false (c :: cs) =
  (if ((c : char) = #"<") andalso
        equal_lista equal_char (take (nat (3 : IntInf.int)) cs)
          [#"!", #"-", #"-"]
    then remove_comments_aux true (tl cs)
    else c :: remove_comments_aux false cs)
  | remove_comments_aux true (c :: cs) =
    (if ((c : char) = #"-") andalso
          equal_lista equal_char (take (nat (2 : IntInf.int)) cs) [#"-", #">"]
      then remove_comments_aux false (drop (nat (2 : IntInf.int)) cs)
      else remove_comments_aux true cs)
  | remove_comments_aux uu [] = [];

fun remove_comments_aux_acc a false (c :: cs) =
  (if ((c : char) = #"<") andalso
        equal_lista equal_char (take (nat (3 : IntInf.int)) cs)
          [#"!", #"-", #"-"]
    then remove_comments_aux_acc a true (tl cs)
    else remove_comments_aux_acc (c :: a) false cs)
  | remove_comments_aux_acc a true (c :: cs) =
    (if ((c : char) = #"-") andalso
          equal_lista equal_char (take (nat (2 : IntInf.int)) cs) [#"-", #">"]
      then remove_comments_aux_acc a false (drop (nat (2 : IntInf.int)) cs)
      else remove_comments_aux_acc a true cs)
  | remove_comments_aux_acc a uu [] = a;

fun remove_comments x =
  (if false then rev o remove_comments_aux_acc [] false
    else remove_comments_aux false)
    x;

fun parse_doc x =
  debug [#"0"]
    [#"p", #"a", #"r", #"s", #"i", #"n", #"g", #" ", #"t", #"x", #"t", #" ",
      #"t", #"o", #" ", #"x", #"m", #"l"]
    (binda (update_tokens remove_comments)
      (fn _ =>
        binda parse_header
          (fn h =>
            binda parse_node
              (fn xml =>
                binda (eoi show_char)
                  (fn _ => fn ts => Inr (Xmldoc (h, xml), ts))))))
    x;

datatype 'a filtered = FPair of 'a * nat;

fun plain_name x =
  xml_options
    [([#"n", #"a", #"m", #"e"],
       xml_change (text [#"n", #"a", #"m", #"e"]) UnLab),
      ([#"s", #"h", #"a", #"r", #"p"],
        xml1element [#"s", #"h", #"a", #"r", #"p"] plain_name Sharp),
      ([#"l", #"a", #"b", #"e", #"l", #"e", #"d", #"S", #"y", #"m", #"b", #"o",
         #"l"],
        xml2elements
          [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #"S", #"y", #"m", #"b",
            #"o", #"l"]
          plain_name (labela plain_name)
          (fn f => fn a =>
            (case a of Inl aa => Lab (f, aa) | Inr aa => FunLab (f, aa))))]
    x;

fun xml1or2many_elements tag p1 p2 p3 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (is_none text andalso
            less_eq_nat (nat (2 : IntInf.int)) (size_list cs)))
    then bindb (p1 (nth cs Zero_nat))
           (fn x =>
             catch (bindb (p2 (nth cs one_nata))
                     (fn y =>
                       bindb (map p3 (tl (tl cs)))
                         (fn xs => Inr (f x (SOME y) xs))))
               (fn _ => bindb (map p3 (tl cs)) (fn xs => Inr (f x NONE xs))))
    else no_transform tag (Xml (name, atts, cs, text)));

fun sl_variant xml2name =
  xml1element [#"m", #"o", #"d", #"e", #"l"]
    (xml_options
      [([#"f", #"i", #"n", #"i", #"t", #"e", #"M", #"o", #"d", #"e", #"l"],
         xml1or2many_elements
           [#"f", #"i", #"n", #"i", #"t", #"e", #"M", #"o", #"d", #"e", #"l"]
           (xml_change
             (nata [#"c", #"a", #"r", #"r", #"i", #"e", #"r", #"S", #"i", #"z",
                     #"e"])
             (fn n => minus_nat n one_nata))
           (xml1element
             [#"t", #"u", #"p", #"l", #"e", #"O", #"r", #"d", #"e", #"r"]
             (xml0elements
               [#"p", #"o", #"i", #"n", #"t", #"W", #"i", #"s", #"e"] ())
             id)
           (xml3elements [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t"]
             xml2name (nata [#"a", #"r", #"i", #"t", #"y"]) arith_fun
             (fn f => fn a => (fn b => ((f, a), b))))
           (fn n => fn model => fn xs =>
             (if is_none model then Finitelab (SL_Inter (n, xs))
               else QuasiFinitelab (SL_Inter (n, xs), [])))),
        ([#"r", #"o", #"o", #"t", #"L", #"a", #"b", #"e", #"l", #"i", #"n",
           #"g"],
          xml_choice
            [#"r", #"o", #"o", #"t", #"L", #"a", #"b", #"e", #"l", #"i", #"n",
              #"g"]
            [xml0elements
               [#"r", #"o", #"o", #"t", #"L", #"a", #"b", #"e", #"l", #"i",
                 #"n", #"g"]
               (Rootlab NONE),
              xml1element
                [#"r", #"o", #"o", #"t", #"L", #"a", #"b", #"e", #"l", #"i",
                  #"n", #"g"]
                xml2name (fn f => Rootlab (SOME (f, one_nata)))])])
    id;

fun xml2many_elements tag p1 p2 p3 f (Xml (name, atts, cs, text)) =
  (if equal_lista equal_char name tag andalso
        (null atts andalso
          (is_none text andalso
            less_eq_nat (nat (2 : IntInf.int)) (size_list cs)))
    then bindb (p1 (nth cs Zero_nat))
           (fn x =>
             bindb (p2 (nth cs one_nata))
               (fn y => bindb (map p3 (tl (tl cs))) (fn xs => Inr (f x y xs))))
    else no_transform tag (Xml (name, atts, cs, text)));

fun transition_lhs xml2name x =
  (if let
        val Xml (_, _, cs, _) = x;
      in
        equal_nata (size_list cs) one_nata
      end
    then xml1element [#"l", #"h", #"s"] state Inr x
    else xml2many_elements [#"l", #"h", #"s"] xml2name
           (nata [#"h", #"e", #"i", #"g", #"h", #"t"]) state
           (fn f => fn h => fn qs => Inl ((f, h), qs)) x);

fun transition xml2name =
  xml2elements [#"t", #"r", #"a", #"n", #"s", #"i", #"t", #"i", #"o", #"n"]
    (transition_lhs xml2name) (xml1element [#"r", #"h", #"s"] state id)
    (fn lhs => fn q =>
      (case lhs of Inl (f, qs) => Inl (TA_rule (f, qs, q))
        | Inr qa => Inr (qa, q)));

val ord_char =
  {less_eq = (fn a => fn b => a <= b), less = (fn a => fn b => a < b)} :
  char ord;

fun all_interval_nat p i j =
  less_eq_nat j i orelse p i andalso all_interval_nat p (Suc i) j;

fun preorder_list (A1_, A2_) = {ord_preorder = ord_list (A1_, A2_)} :
  ('a list) preorder;

fun order_list (A1_, A2_) = {preorder_order = preorder_list (A1_, A2_)} :
  ('a list) order;

fun gen_list_to_map_aux upd accs [] = accs
  | gen_list_to_map_aux upd accs ((k, v) :: l) =
    gen_list_to_map_aux upd (upd k v accs) l;

fun gen_list_to_map empt upd l = gen_list_to_map_aux upd empt (rev l);

fun delete_value A_ B_ key v m =
  (case key v of NONE => m
    | SOME k =>
      (case rm_lookup B_ k m of NONE => m
        | SOME vs => rm_update B_ k (removeAll A_ v vs) m));

fun rm_update_dj A_ = rm_update A_;

fun insert_value A_ B_ key v m =
  (case key v of NONE => m
    | SOME k =>
      (case rm_lookup B_ k m of NONE => rm_update_dj B_ k [v] m
        | SOME vs => rm_update B_ k (insertb A_ v vs) m));

fun shows_monom A_ [(x, p)] =
  (if equal_nata p one_nata then shows_prec A_ Zero_nat x
    else shows_prec A_ Zero_nat x o
           (shows_string [#"^"] o shows_prec_nat Zero_nat p))
  | shows_monom A_ ((x, p) :: v :: va) =
    (if equal_nata p one_nata then shows_prec A_ Zero_nat x
      else shows_prec A_ Zero_nat x o
             (shows_string [#"^"] o shows_prec_nat Zero_nat p)) o
      (shows_string [#"*"] o shows_monom A_ (v :: va))
  | shows_monom A_ [] = shows_string [#"1"];

fun shows_poly A_ (B1_, B2_, B3_) [] = shows_string [#"0"]
  | shows_poly A_ (B1_, B2_, B3_) ((m, c) :: p) =
    (if eq B1_ c
          (one ((one_power o power_monoid_mult o monoid_mult_semiring_1 o
                  semiring_1_comm_semiring_1 o comm_semiring_1_poly_carrier)
                 B2_))
      then shows_monom A_ m
      else (if null m then shows_prec B3_ Zero_nat c
             else shows_prec B3_ Zero_nat c o
                    (shows_string [#"*"] o shows_monom A_ m))) o
      (if null p then shows_string []
        else shows_string [#" ", #"+", #" "] o shows_poly A_ (B1_, B2_, B3_) p);

fun poly_split A_ B_ m p =
  (case extract (fn (n, _) => eq_monom A_ m n) p of NONE => (zero B_, p)
    | SOME (p1, ((_, c), p2)) => (c, p1 @ p2));

fun missing s x =
  shows_string [#"t", #"h", #"e", #" "] o
    (shows_string s o
      (shows_string [#" "] o
        (x o shows_string
               [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
                 #"g"])));

fun toomuch s x =
  shows_string
    [#"s", #"u", #"p", #"e", #"r", #"f", #"l", #"u", #"o", #"u", #"s", #" "] o
    (shows_string s o (shows_string [#" "] o (x o x)));

fun xml_tag (TRS_Proof (uu, uv, SOME uw, ux)) =
  [#"<", #"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"T", #"e", #"r", #"m",
    #"i", #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f",
    #">"]
  | xml_tag (TRS_Proof (uy, uz, NONE, va)) =
    [#"<", #"t", #"r", #"s", #"T", #"e", #"r", #"m", #"i", #"n", #"a", #"t",
      #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f", #">"]
  | xml_tag (TRS_Disproof (vb, vc, vd)) =
    [#"<", #"t", #"r", #"s", #"N", #"o", #"n", #"t", #"e", #"r", #"m", #"i",
      #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f", #">"]
  | xml_tag (Rel_TRS_Disproof (ve, vf, vg, vh)) =
    [#"<", #"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"N", #"o", #"n",
      #"t", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n", #"P",
      #"r", #"o", #"o", #"f", #">"]
  | xml_tag (DP_Proof (vi, vj, vk, vl, vm, vn)) =
    [#"<", #"d", #"p", #"P", #"r", #"o", #"o", #"f", #">"]
  | xml_tag (DP_Disproof (vo, vp, vq, vr)) =
    [#"<", #"d", #"p", #"N", #"o", #"n", #"t", #"e", #"r", #"m", #"i", #"n",
      #"a", #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f", #">"];

fun list_to_rm A_ = gen_list_to_map (rm_empty A_) (rm_update A_);

fun rm_isEmpty (A1_, A2_) B_ m = eq (equal_rbt (A1_, A2_) B_) m (empty A2_);

fun gen_list_to_set_aux ins accs [] = accs
  | gen_list_to_set_aux ins accs (x :: l) =
    gen_list_to_set_aux ins (ins x accs) l;

fun gen_list_to_set empt ins = gen_list_to_set_aux ins empt;

fun list_to_rs A_ = gen_list_to_set (rs_empty A_) (rs_ins A_);

fun equal_unita u v = true;

val equal_unit = {equal = equal_unita} : unit equal;

fun rs_isEmpty (A1_, A2_) = s_isEmpty (rm_isEmpty (A1_, A2_) equal_unit);

fun rito_set_to_sorted_list iterate m = iterate (fn a => fn b => a :: b) m [];

fun s_reverse_iterateo A_ iterate f s sigma_0 =
  iterate (fn k => fn _ => f k) s sigma_0;

fun rs_reverse_iterateo A_ = s_reverse_iterateo A_ (rm_reverse_iterateo A_);

fun rs_to_list A_ = rito_set_to_sorted_list (rs_reverse_iterateo A_);

fun delete_values A_ B_ uu [] m = m
  | delete_values A_ B_ key (v :: vs) m =
    delete_value A_ B_ key v (delete_values A_ B_ key vs m);

fun delete_rules A_ (B1_, B2_) C_ a rs =
  delete_values
    (equal_prod A_ (equal_prod (equal_term B1_ C_) (equal_term B1_ C_)))
    (linorder_prod (B1_, B2_) (equal_nat, linorder_nat)) key
    (mapa (fn b => (a, b)) rs);

fun insert_values A_ B_ uu [] m = m
  | insert_values A_ B_ key (v :: vs) m =
    insert_value A_ B_ key v (insert_values A_ B_ key vs m);

fun insert_rules A_ (B1_, B2_) C_ a rs =
  insert_values
    (equal_prod A_ (equal_prod (equal_term B1_ C_) (equal_term B1_ C_)))
    (linorder_prod (B1_, B2_) (equal_nat, linorder_nat)) key
    (mapa (fn b => (a, b)) rs);

fun qc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = q;

fun mkc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = mk;

fun delete_P_Pwa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = delete_P_Pw;

fun delete_R_Rwc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = delete_R_Rw;

fun split_pairsa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = split_pairs;

fun split_rulesc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = split_rules;

fun split_proc B_ C_ i d p_remove r_remove =
  let
    val (p, pw) = split_pairsa i d p_remove;
    val (r, rw) = split_rulesc i d r_remove;
    val dpp1 = mkc i p pw (qc i d) r rw;
    val a =
      delete_R_Rwc i (delete_P_Pwa i d p_remove p_remove) r_remove r_remove;
  in
    (dpp1, a)
  end;

fun desca (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) = desc;

fun valid (Redtriple_ext (valid, s, ns, nst, af, mono, desc, more)) = valid;

fun check_rsteps (A1_, A2_) (B1_, B2_) r prts s u =
  check_steps (A1_, A2_) (B1_, B2_) [] r
    (mapa (fn (p, (ra, t)) => (p, (ra, (false, t)))) prts) s u;

fun check_subseteq A_ xs ys =
  catch (forallm (fn x => (if membera A_ ys x then Inr () else Inl x)) xs)
    (fn x => Inl (snd x));

fun check_wf_trs A_ (B1_, B2_) r =
  catch (catch
          (forallm
            (fn rule =>
              catch (bindb
                      (check (not (is_var (fst rule)))
                        (shows_string
                          [#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #" ",
                            #"l", #"e", #"f", #"t", #"-", #"h", #"a", #"n",
                            #"d", #" ", #"s", #"i", #"d", #"e", #" ", #"i",
                            #"n"]))
                      (fn _ =>
                        catch (check_subseteq B1_
                                (vars_term_list B1_ (snd rule))
                                (vars_term_list B1_ (fst rule)))
                          (fn x =>
                            Inl (shows_string
                                   [#"f", #"r", #"e", #"e", #" ", #"v", #"a",
                                     #"r", #"i", #"a", #"b", #"l", #"e", #" "] o
                                  (shows_prec B2_ Zero_nat x o
                                    shows_string
                                      [#" ", #"i", #"n", #" ", #"r", #"i", #"g",
#"h", #"t", #"-", #"h", #"a", #"n", #"d", #" ", #"s", #"i", #"d", #"e", #" ",
#"o", #"f"])))))
                (fn x =>
                  Inl (x o (shows_string [#" ", #"r", #"u", #"l", #"e", #" "] o
                             (shows_rule (shows_prec A_ Zero_nat)
                                (shows_prec B2_ Zero_nat)
                                [#" ", #"-", #">", #" "] rule o
                               shows_nl)))))
            r)
          (fn x => Inl (snd x)))
    (fn x =>
      Inl (shows_string
             [#"t", #"h", #"e", #" ", #"T", #"R", #"S", #" ", #"i", #"s", #" ",
               #"n", #"o", #"t", #" ", #"w", #"e", #"l", #"l", #"-", #"f", #"o",
               #"r", #"m", #"e", #"d"] o
            (shows_nl o x)));

fun map_rules_wa fg r =
  mapa (fn (l, ra) => (map_term_wa fg l, map_term_wa fg ra)) r;

fun generate_f_xs f n =
  Fun (f, mapa (fn i => Var (generate_var i)) (upt Zero_nat n));

fun bounds_type x =
  xml1element [#"t", #"y", #"p", #"e"]
    (xml_options
      [([#"r", #"o", #"o", #"f"], xml0elements [#"r", #"o", #"o", #"f"] Roof),
        ([#"m", #"a", #"t", #"c", #"h"],
          xml0elements [#"m", #"a", #"t", #"c", #"h"] Match)])
    id x;

fun bounds_bound x = nata [#"b", #"o", #"u", #"n", #"d"] x;

fun final_states x =
  xml_many_elements
    [#"f", #"i", #"n", #"a", #"l", #"S", #"t", #"a", #"t", #"e", #"s"] state id
    x;

fun transitions xml2name =
  xml_many_elements
    [#"t", #"r", #"a", #"n", #"s", #"i", #"t", #"i", #"o", #"n", #"s"]
    (transition xml2name)
    (fn rls =>
      let
        val (rules, eps) =
          partition (fn a => (case a of Inl _ => true | Inr _ => false)) rls;
        val ruls = mapa (fn Inl r => r) rules;
        val a = mapa (fn Inr e => e) eps;
      in
        (ruls, a)
      end);

fun bounds_tree_automaton xml2name =
  xml2elements
    [#"t", #"r", #"e", #"e", #"A", #"u", #"t", #"o", #"m", #"a", #"t", #"o",
      #"n"]
    final_states (transitions xml2name)
    (fn f => fn (a, b) => Tree_Automaton (f, a, b));

fun bounds_info xml2name =
  xml4elements [#"b", #"o", #"u", #"n", #"d", #"s"] bounds_type bounds_bound
    final_states (bounds_tree_automaton xml2name)
    (fn a => fn b => fn c => fn d => Bounds_Info (a, b, c, d));

fun label_decomp (Lab (f, l)) = (f, Inl l)
  | label_decomp (FunLab (f, l)) = (f, Inr l);

fun shows_lab funa lab (UnLab f) = funa f
  | shows_lab funa lab (Lab (f, l)) =
    shows_lab funa lab f o (shows_string [#"["] o (lab l o shows_string [#"]"]))
  | shows_lab funa lab (Sharp f) = shows_lab funa lab f o shows_string [#"#"]
  | shows_lab funa lab (FunLab (f, l)) =
    shows_lab funa lab f o
      (shows_string [#"["] o
        (shows_map (shows_lab funa lab) l o shows_string [#"]"]));

fun shows_prec_lab A_ B_ d l =
  shows_lab (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat) l;

fun shows_list_lab A_ B_ fs = shows_list_aux (shows_prec_lab A_ B_ Zero_nat) fs;

fun show_lab A_ B_ =
  {shows_prec = shows_prec_lab A_ B_, shows_list = shows_list_lab A_ B_} :
  ('a, 'b) lab show;

fun preorder_lab (A1_, A2_) (B1_, B2_) =
  {ord_preorder =
     ord_lab (A1_, (ord_preorder o preorder_order) A2_)
       (B1_, (ord_preorder o preorder_order) B2_)}
  : ('a, 'b) lab preorder;

fun order_lab (A1_, A2_) (B1_, B2_) =
  {preorder_order = preorder_lab (A1_, A2_) (B1_, B2_)} : ('a, 'b) lab order;

fun simplify_mp_impl A_ B_ mu v_incr mp1 solved =
  (case mp1 of [] => SOME (solved, Zero_nat)
    | (Var v, Var x) :: mp =>
      simplify_mp_impl A_ B_ mu v_incr mp ((Var v, Var x) :: solved)
    | (Var v, Fun (_, _)) :: mp =>
      (if membera A_ v_incr v
        then let
               val m = mapa (fn (s, a) => (subst_apply_term s mu, a));
             in
               bind (simplify_mp_impl A_ B_ mu v_incr (m mp1) (m solved))
                 (fn (smp, i) => SOME (smp, Suc i))
             end
        else NONE)
    | (Fun (fa, lista), Var x) :: mp =>
      simplify_mp_impl A_ B_ mu v_incr mp ((Fun (fa, lista), Var x) :: solved)
    | (Fun (fa, lista), Fun (f, ls)) :: mp =>
      (if eq B_ f fa
        then (case zip_option lista ls of NONE => NONE
               | SOME pairs =>
                 simplify_mp_impl A_ B_ mu v_incr (pairs @ mp) solved)
        else NONE));

fun simplify_mp A_ B_ mu v =
  let
    val mua = mk_subst A_ mu;
  in
    simplify_mp_impl A_ B_ mua v
  end;

fun v_incr_impl A_ d =
  let
    val (ixs, uxs) = partition (fn (_, t) => not (is_var t)) d;
    val rel = mapa (fn (x, y) => (the_var y, x)) uxs;
    val a = mapa fst ixs;
  in
    rtrancl_list_impl A_ rel a
  end;

fun equal_boola p true = p
  | equal_boola p false = not p
  | equal_boola true p = p
  | equal_boola false p = not p;

val equal_bool = {equal = equal_boola} : bool equal;

fun rm_iteratei B_ = rm_iterateoia B_;

fun rs_iteratei B_ = s_iteratei (rm_iteratei B_);

fun scnp_af_desc A_ af =
  shows_prec_list show_char Zero_nat
    [#"S", #"C", #"N", #"P", #"-", #"v", #"e", #"r", #"s", #"i", #"o", #"n",
      #" ", #"o", #"f", #" "];

fun set_ext s_ns =
  (fn asa => fn bs =>
    (not (null asa) andalso
       list_all (fn b => list_ex (fn a => fst (s_ns a b)) asa) bs,
      list_all (fn b => list_ex (fn a => snd (s_ns a b)) asa) bs));

fun check_no_var A_ B_ t =
  check (not (is_var t))
    (shows_string
       [#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #" ", #"f", #"o", #"u",
         #"n", #"d"] o
      shows_nl);

fun check_supteq (A1_, A2_) (B1_, B2_) s t =
  check (member (s, t) (supteq A1_ B1_))
    (shows_prec_term A2_ B2_ Zero_nat t o
      (shows_string
         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ", #"s",
           #"u", #"b", #"t", #"e", #"r", #"m", #" ", #"o", #"f", #" "] o
        shows_prec_term A2_ B2_ Zero_nat s));

fun valida (Root_redtriple_ext (valid, s, ns, nst, af, aft, desc, more)) =
  valid;

fun vars_rule_lista r = vars_term_lista (fst r) @ vars_term_lista (snd r);

fun vars_trs_list B_ trs = remdups B_ (maps vars_rule_lista trs);

fun check_pairwise c [] = Inr ()
  | check_pairwise c (x :: xs) =
    bindb (catch (forallm (c x) xs) (fn xa => Inl (snd xa)))
      (fn _ => check_pairwise c xs);

fun check_disjoint A_ xs ys =
  catch (forallm (fn x => (if not (membera A_ ys x) then Inr () else Inl x)) xs)
    (fn x => Inl (snd x));

fun check_partition A_ xss = check_pairwise (check_disjoint A_) xss;

fun check_inj (A1_, A2_) (B1_, B2_) a nn sml =
  let
    val symbols =
      mapa (fn (aa, b) =>
             let
               val (_, n) = aa;
             in
               (fn fs =>
                 mapa (fn (g, i) =>
                        (g, plus_nata n (times_nata i (minus_nat nn one_nata))))
                   (zip fs (upt Zero_nat (size_list fs))))
             end
               b)
        sml;
    val fsymbols = concat symbols;
  in
    bindb (catch
            (check_partition (equal_prod (equal_lab A1_ B1_) equal_nat) symbols)
            (fn x =>
              Inl (shows_prec_list show_char Zero_nat
                     [#"s", #"y", #"m", #"b", #"o", #"l", #" "] o
                    (shows_prec_prod (show_lab A2_ B2_) show_nat Zero_nat x o
                      shows_prec_list show_char Zero_nat
                        [#" ", #"o", #"c", #"c", #"u", #"r", #"s", #" ", #"t",
                          #"w", #"i", #"c", #"e", #")"]))))
      (fn _ =>
        bindb (check
                (not (membera (equal_prod (equal_lab A1_ B1_) equal_nat)
                       fsymbols (a, nn)))
                (shows_prec_list show_char Zero_nat
                   [#"a", #"p", #"p", #"l", #"i", #"c", #"a", #"t", #"i", #"o",
                     #"n", #" ", #"s", #"y", #"m", #"b", #"o", #"l"] o
                  (shows_prec_lab A2_ B2_ Zero_nat a o
                    shows_prec_list show_char Zero_nat
                      [#" ", #"m", #"u", #"s", #"t", #" ", #"n", #"o", #"t",
                        #" ", #"o", #"c", #"c", #"u", #"r", #" ", #"a", #"s",
                        #" ", #"n", #"e", #"w", #" ", #"s", #"y", #"m", #"b",
                        #"o", #"l"])))
          (fn _ =>
            bindb (check
                    (not (membera (equal_prod (equal_lab A1_ B1_) equal_nat)
                           (mapa fst sml) (a, nn)))
                    (shows_prec_list show_char Zero_nat
                       [#"a", #"p", #"p", #"l", #"i", #"c", #"a", #"t", #"i",
                         #"o", #"n", #" ", #"s", #"y", #"m", #"b", #"o", #"l"] o
                      (shows_prec_lab A2_ B2_ Zero_nat a o
                        shows_prec_list show_char Zero_nat
                          [#" ", #"m", #"u", #"s", #"t", #" ", #"n", #"o", #"t",
                            #" ", #"b", #"e", #" ", #"u", #"n", #"c", #"u",
                            #"r", #"r", #"i", #"e", #"d"])))
              (fn _ =>
                (if less_eq_nat nn one_nata
                  then catch (forallm
                               (check_pairwise
                                 (fn gn1 => fn gn2 =>
                                   check (not
   (equal_proda (equal_lab A1_ B1_) equal_nat gn1 gn2))
                                     (shows_prec_list show_char Zero_nat
[#"s", #"y", #"m", #"b", #"o", #"l", #" "] o
                                       (shows_prec_prod (show_lab A2_ B2_)
  show_nat Zero_nat gn1 o
 shows_prec_list show_char Zero_nat
   [#" ", #"o", #"c", #"c", #"u", #"r", #"s", #" ", #"t", #"w", #"i", #"c",
     #"e"]))))
                               symbols)
                         (fn x => Inl (snd x))
                  else Inr ()))))
  end;

fun uncurry_info xml2name =
  xml4elements
    [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"I", #"n", #"f", #"o", #"r",
      #"m", #"a", #"t", #"i", #"o", #"n"]
    xml2name
    (xml_many_elements
      [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #"S", #"y", #"m",
        #"b", #"o", #"l", #"s"]
      (xml2many_elements
        [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #"S", #"y", #"m",
          #"b", #"o", #"l", #"E", #"n", #"t", #"r", #"y"]
        xml2name (nata [#"a", #"r", #"i", #"t", #"y"]) xml2name
        (fn f => fn n => (fn a => ((f, n), a))))
      id)
    (xml1element
      [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"R", #"u", #"l", #"e", #"s"]
      (rules xml2name) id)
    (xml1element [#"e", #"t", #"a", #"R", #"u", #"l", #"e", #"s"]
      (rules xml2name) id)
    (fn a => fn sml => fn u => fn e => (a, (sml, (u, e))));

fun flat_contexts xml2name =
  xml_many_elements
    [#"f", #"l", #"a", #"t", #"C", #"o", #"n", #"t", #"e", #"x", #"t", #"s"]
    (ctxt xml2name) id;

fun projected_rseq A_ xml2name pi (Xml (name, atts, cs, text)) =
  let
    val tag =
      [#"p", #"r", #"o", #"j", #"e", #"c", #"t", #"e", #"d", #"R", #"e", #"w",
        #"r", #"i", #"t", #"e", #"S", #"e", #"q", #"u", #"e", #"n", #"c", #"e"];
  in
    (if equal_lista equal_char name tag andalso
          (null atts andalso
            (is_none text andalso
              equal_nata (size_list cs) (nat (2 : IntInf.int))))
      then bindb (rule xml2name (nth cs Zero_nat))
             (fn r => rseq A_ xml2name pi r (nth cs one_nata))
      else no_transform tag (Xml (name, atts, cs, text)))
  end;

fun xml1many2elements_gen tag p1 p2 p3 p4 f (Xml (name, atts, cs, text)) =
  let
    val ds = rev cs;
    val l = size_list cs;
  in
    (if equal_lista equal_char name tag andalso
          (null atts andalso
            (is_none text andalso less_eq_nat (nat (3 : IntInf.int)) l))
      then bindb (p1 (nth cs Zero_nat))
             (fn x =>
               bindb (map (p2 x)
                       (tl (take (minus_nat l (nat (2 : IntInf.int))) cs)))
                 (fn xs =>
                   bindb (p3 (nth ds one_nata))
                     (fn y =>
                       bindb (p4 (nth ds Zero_nat))
                         (fn z => Inr (f x xs y z)))))
      else no_transform tag (Xml (name, atts, cs, text)))
  end;

fun strategy_to_Q no_strategy uu = [];

fun create_proj A_ (Projection p) f =
  (case lookupa A_ f p of NONE => Zero_nat | SOME n => n);

fun ordering_constraint_proofa xml2name =
  xml1element
    [#"o", #"r", #"d", #"e", #"r", #"i", #"n", #"g", #"C", #"o", #"n", #"s",
      #"t", #"r", #"a", #"i", #"n", #"t", #"P", #"r", #"o", #"o", #"f"]
    (redtriple xml2name) id;

fun level_mapping xml2name =
  xml_many_elements
    [#"l", #"e", #"v", #"e", #"l", #"M", #"a", #"p", #"p", #"i", #"n", #"g"]
    (xml2many_elements
      [#"l", #"e", #"v", #"e", #"l", #"M", #"a", #"p", #"p", #"i", #"n", #"g",
        #"E", #"n", #"t", #"r", #"y"]
      xml2name (nata [#"a", #"r", #"i", #"t", #"y"])
      (xml2elements
        [#"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n", #"L", #"e", #"v", #"e",
          #"l", #"E", #"n", #"t", #"r", #"y"]
        (nata [#"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n"])
        (nata [#"l", #"e", #"v", #"e", #"l"]) (fn a => fn b => (a, b)))
      (fn f => fn a => fn ps =>
        ((f, a),
          mapa (fn (p, b) =>
                 ((if equal_nata p Zero_nat then a else minus_nat p one_nata),
                   b))
            ps)))
    id;

fun root_redtriple xml2name =
  xml1element [#"r", #"e", #"d", #"P", #"a", #"i", #"r"]
    (xml3elements [#"s", #"c", #"n", #"p"]
      (xml1element [#"s", #"t", #"a", #"t", #"u", #"s"]
        (xml_options
          [([#"m", #"s"], xml0elements [#"m", #"s"] MS_Ext),
            ([#"m", #"i", #"n"], xml0elements [#"m", #"i", #"n"] Min_Ext),
            ([#"m", #"a", #"x"], xml0elements [#"m", #"a", #"x"] Max_Ext)])
        id)
      (level_mapping xml2name) (redtriple xml2name)
      (fn a => fn b => fn c => Scnp (a, b, c)))
    id;

fun root_ordering_constraint_proof xml2name =
  xml1element
    [#"o", #"r", #"d", #"e", #"r", #"i", #"n", #"g", #"C", #"o", #"n", #"s",
      #"t", #"r", #"a", #"i", #"n", #"t", #"P", #"r", #"o", #"o", #"f"]
    (root_redtriple xml2name) id;

fun ordering_constraint_proof xml2name =
  xml_choice
    [#"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ", #"p", #"a",
      #"i", #"r"]
    [xml_change (ordering_constraint_proofa xml2name) Inr,
      xml_change (root_ordering_constraint_proof xml2name) Inl];

fun xml2dp_proof A_ B_ xml2name x =
  xml1element [#"d", #"p", #"P", #"r", #"o", #"o", #"f"]
    (xml_options
      [([#"p", #"I", #"s", #"E", #"m", #"p", #"t", #"y"],
         xml0elements [#"p", #"I", #"s", #"E", #"m", #"p", #"t", #"y"]
           PisEmpty),
        ([#"d", #"e", #"p", #"G", #"r", #"a", #"p", #"h", #"P", #"r", #"o",
           #"c"],
          xml_many_elements
            [#"d", #"e", #"p", #"G", #"r", #"a", #"p", #"h", #"P", #"r", #"o",
              #"c"]
            (xml2nd_choice
              [#"c", #"o", #"m", #"p", #"o", #"n", #"e", #"n", #"t"]
              (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
              [#"r", #"e", #"a", #"l", #"S", #"c", #"c"]
              (xml2dp_proof A_ B_ xml2name)
              (fn dps => fn prfOpt => (prfOpt, dps)))
            DepGraphProc),
        ([#"r", #"e", #"d", #"P", #"a", #"i", #"r", #"P", #"r", #"o", #"c"],
          xml3elements
            [#"r", #"e", #"d", #"P", #"a", #"i", #"r", #"P", #"r", #"o", #"c"]
            (ordering_constraint_proof xml2name)
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => RedPairProc (a, b, c))),
        ([#"s", #"e", #"m", #"l", #"a", #"b", #"P", #"r", #"o", #"c"],
          xml4elements
            [#"s", #"e", #"m", #"l", #"a", #"b", #"P", #"r", #"o", #"c"]
            (sl_variant xml2name)
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn sli => fn lp =>
              (fn a => fn b => SemlabProc (sli, lp, [], a, b)))),
        ([#"s", #"u", #"b", #"t", #"e", #"r", #"m", #"P", #"r", #"o", #"c"],
          xml1many2elements_gen
            [#"s", #"u", #"b", #"t", #"e", #"r", #"m", #"P", #"r", #"o", #"c"]
            (proj xml2name)
            (fn pi =>
              projected_rseq (equal_lab A_ B_) xml2name
                (create_proj (equal_lab A_ B_) pi))
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => fn d =>
              SubtermCriterionProc (a, b, c, d))),
        ([#"r", #"e", #"d", #"P", #"a", #"i", #"r", #"U", #"r", #"P", #"r",
           #"o", #"c"],
          xml4elements
            [#"r", #"e", #"d", #"P", #"a", #"i", #"r", #"U", #"r", #"P", #"r",
              #"o", #"c"]
            (ordering_constraint_proof xml2name)
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml1element
              [#"u", #"s", #"a", #"b", #"l", #"e", #"R", #"u", #"l", #"e", #"s"]
              (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => fn d => RedPairUrProc (a, b, c, d))),
        ([#"m", #"o", #"n", #"o", #"R", #"e", #"d", #"P", #"a", #"i", #"r",
           #"U", #"r", #"P", #"r", #"o", #"c"],
          xml5elements
            [#"m", #"o", #"n", #"o", #"R", #"e", #"d", #"P", #"a", #"i", #"r",
              #"U", #"r", #"P", #"r", #"o", #"c"]
            (ordering_constraint_proofa xml2name)
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml1element
              [#"u", #"s", #"a", #"b", #"l", #"e", #"R", #"u", #"l", #"e", #"s"]
              (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => fn d => fn e =>
              MonoRedPairUrProc (a, b, c, d, e))),
        ([#"m", #"o", #"n", #"o", #"R", #"e", #"d", #"P", #"a", #"i", #"r",
           #"P", #"r", #"o", #"c"],
          xml4elements
            [#"m", #"o", #"n", #"o", #"R", #"e", #"d", #"P", #"a", #"i", #"r",
              #"P", #"r", #"o", #"c"]
            (ordering_constraint_proofa xml2name)
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => fn d => MonoRedPairProc (a, b, c, d))),
        ([#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"P", #"r", #"o", #"c"],
          xml_choice
            [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"P", #"r", #"o", #"c"]
            [xml4elements
               [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"P", #"r", #"o",
                 #"c"]
               (uncurry_info xml2name)
               (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
               (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
               (xml2dp_proof A_ B_ xml2name)
               (fn a => fn b => fn c => fn d => UncurryProc (NONE, a, b, c, d)),
              xml5elements
                [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"P", #"r", #"o",
                  #"c"]
                (nata [#"a", #"p", #"p", #"l", #"i", #"c", #"a", #"t", #"i",
                        #"v", #"e", #"T", #"o", #"p"])
                (uncurry_info xml2name)
                (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
                (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
                (xml2dp_proof A_ B_ xml2name)
                (fn n =>
                  (fn a => fn b => fn c => fn d =>
                    UncurryProc (SOME n, a, b, c, d)))]),
        ([#"f", #"l", #"a", #"t", #"C", #"o", #"n", #"t", #"e", #"x", #"t",
           #"C", #"l", #"o", #"s", #"u", #"r", #"e", #"P", #"r", #"o", #"c"],
          xml5elements
            [#"f", #"l", #"a", #"t", #"C", #"o", #"n", #"t", #"e", #"x", #"t",
              #"C", #"l", #"o", #"s", #"u", #"r", #"e", #"P", #"r", #"o", #"c"]
            (xml1element
              [#"f", #"r", #"e", #"s", #"h", #"S", #"y", #"m", #"b", #"o", #"l"]
              xml2name id)
            (flat_contexts xml2name)
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => fn d => fn e => FccProc (a, b, c, d, e))),
        ([#"s", #"p", #"l", #"i", #"t", #"P", #"r", #"o", #"c"],
          xml4elements [#"s", #"p", #"l", #"i", #"t", #"P", #"r", #"o", #"c"]
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2dp_proof A_ B_ xml2name) (xml2dp_proof A_ B_ xml2name)
            (fn a => fn b => fn c => fn d => SplitProc (a, b, c, d))),
        ([#"f", #"i", #"n", #"i", #"t", #"e", #"n", #"e", #"s", #"s", #"A",
           #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o", #"n"],
          xml1element
            [#"f", #"i", #"n", #"i", #"t", #"e", #"n", #"e", #"s", #"s", #"A",
              #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o", #"n"]
            (xml2dp_input xml2name)
            (fn (p, (q, r)) =>
              AssumeFinite (p, ([], (strategy_to_Q q r, ([], r)))))),
        ([#"s", #"i", #"z", #"e", #"C", #"h", #"a", #"n", #"g", #"e", #"P",
           #"r", #"o", #"c"],
          xml1many_elements
            [#"s", #"i", #"z", #"e", #"C", #"h", #"a", #"n", #"g", #"e", #"P",
              #"r", #"o", #"c"]
            (xml_options
              [([#"s", #"u", #"b", #"t", #"e", #"r", #"m", #"C", #"r", #"i",
                  #"t", #"e", #"r", #"i", #"o", #"n"],
                 xml0elements
                   [#"s", #"u", #"b", #"t", #"e", #"r", #"m", #"C", #"r", #"i",
                     #"t", #"e", #"r", #"i", #"o", #"n"]
                   NONE),
                ([#"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #"P",
                   #"a", #"i", #"r"],
                  xml2elements
                    [#"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #"P",
                      #"a", #"i", #"r"]
                    (ordering_constraint_proofa xml2name)
                    (xml1element
                      [#"u", #"s", #"a", #"b", #"l", #"e", #"R", #"u", #"l",
                        #"e", #"s"]
                      (rules xml2name) id)
                    (fn redp => fn ur => SOME (redp, ur)))])
            (scg xml2name)
            (fn a =>
              (case a of NONE => SizeChangeSubterm
                | SOME redp_ur =>
                  (fn aa =>
                    SizeChangeRedPair (fst redp_ur, snd redp_ur, aa)))))])
    id x;

fun check_graph_decomp ss g rcs =
  bindb (check_pairwise (check_edges ss g) (mapa snd rcs))
    (fn _ =>
      catch (forallm (fn c => check_edges ss g c c)
              (map_filter (fn x => (if not (fst x) then SOME (snd x) else NONE))
                rcs))
        (fn x => Inl (snd x)));

fun reverse_rules_mapa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = reverse_rules_map;

fun rules_non_collapsinga
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = rules_non_collapsing;

fun reverse_capRM_dpp B_ C_ i dpp =
  capRM B_ C_ (rules_non_collapsinga i dpp) (reverse_rules_mapa i dpp);

fun pairsa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = pairs;

fun check_dep_graph_proc (B1_, B2_) (C1_, C2_) i dpp dps =
  let
    val c = capRM_dpp B1_ C1_ i dpp;
    val rc = reverse_capRM_dpp B1_ C1_ i dpp;
    val p = pairsa i dpp;
  in
    bindb (catch
            (check_subseteq
              (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_)) p
              (maps snd dps))
            (fn x =>
              Inl (shows_string
                     [#"D", #"e", #"p", #"e", #"n", #"d", #"e", #"n", #"c",
                       #"y", #" ", #"P", #"a", #"i", #"r", #" "] o
                    (shows_rule (shows_prec B2_ Zero_nat)
                       (shows_prec C2_ Zero_nat) [#" ", #"-", #">", #" "] x o
                      (shows_string
                         [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i",
                           #"n", #"g", #" ", #"i", #"n", #" ", #"d", #"e", #"c",
                           #"o", #"m", #"p", #"o", #"s", #"i", #"t", #"i", #"o",
                           #"n"] o
                        shows_nl)))))
      (fn _ =>
        catch (check_graph_decomp
                (shows_prec_prod (show_term B2_ C2_) (show_term B2_ C2_)
                   Zero_nat o
                  fst)
                (fn (a, b) =>
                  let
                    val (aa, ba) = a;
                  in
                    let
                      val (_, t) = aa;
                    in
                      (fn (_, ct) => fn (ab, bb) =>
                        let
                          val (u, _) = ab;
                        in
                          (fn (cu, _) =>
                            matchb B1_ C1_ ct u andalso matchb B1_ C1_ cu t)
                        end
                          bb)
                    end
                      ba
                  end
                    b)
                (mapa (fn (real, cs) =>
                        (not (is_none real),
                          mapa (fn (s, t) => ((s, t), (rc s, c t))) cs))
                  dps))
          (fn x =>
            Inl (shows_string
                   [#"o", #"u", #"r", #" ", #"e", #"s", #"t", #"i", #"m", #"a",
                     #"t", #"i", #"o", #"n", #" ", #"(", #"E", #"D", #"G", #"*",
                     #"*", #"*", #")", #" ", #"c", #"o", #"u", #"l", #"d", #" ",
                     #"n", #"o", #"t", #" ", #"s", #"h", #"o", #"w", #" ", #"t",
                     #"h", #"a", #"t", #" ", #"y", #"o", #"u", #" ", #"h", #"a",
                     #"v", #"e", #" ", #"a", #" ", #"v", #"a", #"l", #"i", #"d",
                     #" ", #"d", #"e", #"c", #"o", #"m", #"p", #"o", #"s", #"i",
                     #"t", #"i", #"o", #"n", #" "] o
                  (shows_string
                     [#"d", #"u", #"e", #" ", #"t", #"o", #" ", #"t", #"h",
                       #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w", #"i",
                       #"n", #"g", #" ", #"r", #"e", #"a", #"s", #"o", #"n"] o
                    (shows_nl o x)))))
  end;

fun intersect_pairsa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = intersect_pairs;

fun dep_graph_proc (B1_, B2_) (C1_, C2_) i d dps =
  (case check_dep_graph_proc (B1_, B2_) (C1_, C2_) i d dps of Inl a => Inl a
    | Inr _ =>
      Inr (map_filter
            (fn x =>
              (if not (is_none (fst x))
                then SOME (the (fst x), intersect_pairsa i d (snd x))
                else NONE))
            dps));

val preorder_char = {ord_preorder = ord_char} : char preorder;

val order_char = {preorder_order = preorder_char} : char order;

datatype ('a, 'b) l_poly = LPoly of 'b * ('a * 'b) list;

fun ident_prob_of_smp A_ B_ [] = []
  | ident_prob_of_smp A_ B_ ((t, Var x) :: other) =
    map_filter
      (fn xa =>
        (if let
              val (_, s) = xa;
            in
              equal_terma A_ B_ s (Var x)
            end
          then SOME let
                      val (s, _) = xa;
                    in
                      (t, s)
                    end
          else NONE))
      other @
      ident_prob_of_smp A_ B_ other;

fun sym_collect p (Var x) = []
  | sym_collect p (Fun (f, ts)) =
    (if p (Fun (f, ts)) then [f] else []) @ maps (sym_collect p) ts;

fun fresh_strings_list name offset used n =
  take n
    (filter
      (fn s =>
        not (membera (equal_list equal_char)
              (remdups (equal_list equal_char) used) s))
      (mapa (fn i => name @ shows_prec_nat Zero_nat (plus_nata i offset) [])
        (upt Zero_nat
          (plus_nata n (size_list (remdups (equal_list equal_char) used))))));

fun substpow_impl sigma Zero_nat = Var
  | substpow_impl sigma (Suc n) = subst_compose sigma (substpow_impl sigma n);

fun funas_term_lista (Var uu) = []
  | funas_term_lista (Fun (f, ts)) =
    (f, size_list ts) :: maps funas_term_lista ts;

fun funas_rule_list r = funas_term_lista (fst r) @ funas_term_lista (snd r);

fun funas_trs_list A_ r =
  remdups (equal_prod A_ equal_nat) (maps funas_rule_list r);

fun vars_rule_list B_ r = remdups B_ (vars_rule_lista r);

fun ra
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = r;

fun check_CS_subseteq A_ B_ r s =
  catch (forallm
          (fn (l, ra) =>
            check (list_ex (instance_rule A_ B_ (l, ra)) s) (l, ra))
          r)
    (fn x => Inl (snd x));

fun uncurry_rules A_ a sm =
  mapa (fn (l, r) => (uncurry_term A_ a sm l, uncurry_term A_ a sm r));

fun rwa
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = rw;

fun eta_closed_rules (A1_, A2_) (B1_, B2_) a sm ra r =
  catch (forallm
          (fn (l, raa) =>
            (case aarity_term A1_ a sm l of NONE => Inr ()
              | SOME Zero_nat => Inr ()
              | SOME (Suc _) =>
                check (list_ex
                        (fn (lll, rrr) =>
                          (case (lll, rrr) of (Var _, b) => false
                            | (Fun (f, []), b) => false
                            | (Fun (f, [ll]), b) => false
                            | (Fun (f, [ll, Var x]), Var _) => false
                            | (Fun (f, [ll, Var x]), Fun (g, [])) => false
                            | (Fun (f, [ll, Var x]), Fun (g, [rr])) => false
                            | (Fun (f, [ll, Var x]), Fun (g, [rr, Var y])) =>
                              eq A1_ f a andalso
                                (eq A1_ g a andalso
                                  (eq B1_ x y andalso
                                    (not (membera B1_
   (vars_rule_list B1_ (ll, rr)) x) andalso
                                      instance_rule A1_ B1_ (l, raa) (ll, rr))))
                            | (Fun (f, [ll, Var x]),
                                Fun (g, rr :: Var y :: _ :: _))
                              => false
                            | (Fun (f, [ll, Var x]),
                                Fun (g, rr :: Fun (_, _) :: lista))
                              => false
                            | (Fun (f, ll :: Var x :: _ :: _), b) => false
                            | (Fun (f, ll :: Fun (_, _) :: lista), b) => false))
                        r)
                  (shows_prec_list show_char Zero_nat
                     [#"e", #"t", #"a", #" ", #"e", #"x", #"p", #"a", #"n",
                       #"s", #"i", #"o", #"n", #" ", #"o", #"f", #" "] o
                    (shows_rule (shows_prec A2_ Zero_nat)
                       (shows_prec B2_ Zero_nat) [#" ", #"-", #">", #" "]
                       (l, raa) o
                      shows_prec_list show_char Zero_nat
                        [#" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"]))))
          ra)
    (fn x => Inl (snd x));

fun uncurry_eta_split A_ B_ eboth rtest =
  let
    val test =
      (fn (l, r) =>
        less_nat Zero_nat (num_args l) andalso
          (less_nat Zero_nat (num_args r) andalso
            list_ex (eq_rule_mod_vars A_ B_ (hd (args l), hd (args r))) rtest));
  in
    partition test eboth
  end;

fun sig_list_to_sig_map A_ a sml fmap =
  let
    val fm = fmap sml;
  in
    (fn f => fn n =>
      (case lookupa (equal_prod A_ equal_nat) (f, n) sml of NONE => [fm f n]
        | SOME xs => (if null xs then [fm f n] else xs)))
  end;

fun uncurry_of_sig_list a sml sm =
  maps (fn (b, c) =>
         let
           val (f, n) = b;
         in
           (fn _ =>
             let
               val g = get_symbol sm f n;
             in
               mapa (fn i =>
                      (Fun (a, [generate_f_xs (g i) (plus_nata n i),
                                 Var (generate_var (plus_nata n i))]),
                        generate_f_xs (g (Suc i)) (plus_nata n (Suc i))))
                 (upt Zero_nat (aarity sm f n))
             end)
         end
           c)
    sml;

fun uncurry_tt (B1_, B2_) i info r tp =
  let
    val (a, (sml, (u, eb))) = info;
    val raa = ra i tp;
    val rw = rwa i tp;
    val (e, ew) = uncurry_eta_split B1_ (equal_list equal_char) eb raa;
    val r_eta = e @ raa;
    val rw_eta = ew @ rw;
    val rb_eta = r_eta @ rw_eta;
    val fmap = (fn _ => fn f => fn _ => f);
    val sm = sig_list_to_sig_map B1_ a sml fmap;
    val uR = uncurry_rules B1_ a sm r_eta;
    val uRw = uncurry_rules B1_ a sm rw_eta;
  in
    (case let
            val s = uncurry_of_sig_list a sml sm;
          in
            bindb (catch
                    (forallm
                      (fn (l, _) =>
                        check (hvf_term B1_ a l)
                          (shows_prec_list show_char Zero_nat
                             [#"h", #"e", #"a", #"d", #" ", #"v", #"a", #"r",
                               #"i", #"a", #"b", #"l", #"e", #" ", #"i", #"n",
                               #" ", #"l", #"h", #"s", #" "] o
                            (shows_term (shows_prec B2_ Zero_nat)
                               (shows_prec_list show_char Zero_nat) l o
                              shows_prec_list show_char Zero_nat
                                [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l",
                                  #"o", #"w", #"e", #"d"])))
                      r_eta)
                    (fn x => Inl (snd x)))
              (fn _ =>
                bindb (catch
                        (forallm
                          (fn (l, _) =>
                            check (hvf_term B1_ a l)
                              (shows_prec_list show_char Zero_nat
                                 [#"h", #"e", #"a", #"d", #" ", #"v", #"a",
                                   #"r", #"i", #"a", #"b", #"l", #"e", #" ",
                                   #"i", #"n", #" ", #"l", #"h", #"s", #" "] o
                                (shows_term (shows_prec B2_ Zero_nat)
                                   (shows_prec_list show_char Zero_nat) l o
                                  shows_prec_list show_char Zero_nat
                                    [#" ", #"n", #"o", #"t", #" ", #"a", #"l",
                                      #"l", #"o", #"w", #"e", #"d"])))
                          rw_eta)
                        (fn x => Inl (snd x)))
                  (fn _ =>
                    bindb (eta_closed_rules (B1_, B2_)
                            (equal_list equal_char, show_list show_char) a sm
                            r_eta r_eta)
                      (fn _ =>
                        bindb (eta_closed_rules (B1_, B2_)
                                (equal_list equal_char, show_list show_char) a
                                sm rb_eta rb_eta)
                          (fn _ =>
                            bindb (catch
                                    (forallm
                                      (fn (l, rb) =>
check (not (is_var l))
  (shows_prec_list show_char Zero_nat
     [#"l", #"h", #"s", #" ", #"m", #"u", #"s", #"t", #" ", #"n", #"o", #"t",
       #" ", #"b", #"e", #" ", #"a", #" ", #"v", #"a", #"r", #"i", #"a", #"b",
       #"l", #"e", #" ", #"i", #"n", #" ", #"r", #"u", #"l", #"e", #" "] o
    shows_rule (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
      [#" ", #"-", #">", #" "] (l, rb)))
                                      rw_eta)
                                    (fn x => Inl (snd x)))
                              (fn _ =>
                                bindb (catch
(check_subseteq
  (equal_prod (equal_term B1_ (equal_list equal_char))
    (equal_term B1_ (equal_list equal_char)))
  uR r)
(fn x =>
  Inl (shows_prec_list show_char Zero_nat
         [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #" ", #"r",
           #"u", #"l", #"e", #" "] o
        (shows_rule (shows_prec B2_ Zero_nat)
           (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] x o
          shows_prec_list show_char Zero_nat
            [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
              #"g"]))))
                                  (fn _ =>
                                    bindb (catch
    (check_subseteq
      (equal_prod (equal_term B1_ (equal_list equal_char))
        (equal_term B1_ (equal_list equal_char)))
      uRw r)
    (fn x =>
      Inl (shows_prec_list show_char Zero_nat
             [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #" ", #"r",
               #"u", #"l", #"e", #" "] o
            (shows_rule (shows_prec B2_ Zero_nat)
               (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] x o
              shows_prec_list show_char Zero_nat
                [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
                  #"g"]))))
                                      (fn _ =>
bindb (catch (check_CS_subseteq B1_ (equal_list equal_char) s u)
        (fn x =>
          Inl (shows_prec_list show_char Zero_nat
                 [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #" ", #"r", #"u",
                   #"l", #"e", #" "] o
                (shows_rule (shows_prec B2_ Zero_nat)
                   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "]
                   x o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
                      #"g"]))))
  (fn _ =>
    catch (check_subseteq
            (equal_prod (equal_term B1_ (equal_list equal_char))
              (equal_term B1_ (equal_list equal_char)))
            u r)
      (fn x =>
        Inl (shows_prec_list show_char Zero_nat
               [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #" ", #"r", #"u",
                 #"l", #"e", #" "] o
              (shows_rule (shows_prec B2_ Zero_nat)
                 (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "]
                 x o
                shows_prec_list show_char Zero_nat
                  [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
                    #"g", #" ", #"i", #"n", #" ", #"n", #"e", #"w", #" ", #"T",
                    #"R", #"S"])))))))))))
          end
      of Inl aa => Inl aa | Inr _ => Inr (mka i [] uR (uRw @ u)))
  end;

fun apply_af_entry uu (Collapse i) ts = nth ts i
  | apply_af_entry f (AFList is) ts = Fun (f, mapa (nth ts) is);

fun afs_term pi (Fun (f, ts)) =
  let
    val l = size_list ts;
  in
    apply_af_entry (FPair (f, l)) (pi f l) (mapa (afs_term pi) ts)
  end
  | afs_term pi (Var x) = Var x;

fun xml2trs_proof A_ xml2name x =
  xml1element
    [#"t", #"r", #"s", #"T", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i",
      #"o", #"n", #"P", #"r", #"o", #"o", #"f"]
    (xml_options
      [([#"r", #"I", #"s", #"E", #"m", #"p", #"t", #"y"],
         xml0elements [#"r", #"I", #"s", #"E", #"m", #"p", #"t", #"y"]
           RisEmpty),
        ([#"s", #"e", #"m", #"l", #"a", #"b"],
          xml3elements [#"s", #"e", #"m", #"l", #"a", #"b"]
            (sl_variant xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_proof A_ xml2name)
            (fn sli => (fn a => fn b => Semlab (sli, [], a, b)))),
        ([#"s", #"p", #"l", #"i", #"t"],
          xml3elements [#"s", #"p", #"l", #"i", #"t"]
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_proof A_ xml2name) (xml2trs_proof A_ xml2name)
            (fn a => fn b => fn c => Split (a, b, c))),
        ([#"d", #"p", #"T", #"r", #"a", #"n", #"s"],
          xml3elements [#"d", #"p", #"T", #"r", #"a", #"n", #"s"]
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (boola
              [#"m", #"a", #"r", #"k", #"e", #"d", #"S", #"y", #"m", #"b", #"o",
                #"l", #"s"])
            (xml2dp_proof A_ (equal_list equal_nat) xml2name)
            (fn dps => fn _ => (fn a => DPTrans (dps, a)))),
        ([#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"],
          xml3elements
            [#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
            (ordering_constraint_proofa xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_proof A_ xml2name)
            (fn a => fn b => fn c => RuleRemoval (a, b, c))),
        ([#"b", #"o", #"u", #"n", #"d", #"s"],
          (fn xml => bindb (bounds_info xml2name xml) (Inr o Bounds))),
        ([#"s", #"t", #"r", #"i", #"n", #"g", #"R", #"e", #"v", #"e", #"r",
           #"s", #"a", #"l"],
          xml2elements
            [#"s", #"t", #"r", #"i", #"n", #"g", #"R", #"e", #"v", #"e", #"r",
              #"s", #"a", #"l"]
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_proof A_ xml2name) (fn _ => StringReversal)),
        ([#"u", #"n", #"c", #"u", #"r", #"r", #"y"],
          xml3elements [#"u", #"n", #"c", #"u", #"r", #"r", #"y"]
            (uncurry_info xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_proof A_ xml2name)
            (fn a => fn b => fn c => Uncurry (a, b, c))),
        ([#"f", #"l", #"a", #"t", #"C", #"o", #"n", #"t", #"e", #"x", #"t",
           #"C", #"l", #"o", #"s", #"u", #"r", #"e"],
          xml3elements
            [#"f", #"l", #"a", #"t", #"C", #"o", #"n", #"t", #"e", #"x", #"t",
              #"C", #"l", #"o", #"s", #"u", #"r", #"e"]
            (flat_contexts xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_proof A_ xml2name)
            (fn a => fn b => fn c => Fcc (a, b, c))),
        ([#"t", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n",
           #"A", #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o", #"n"],
          xml1element
            [#"t", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n",
              #"A", #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o", #"n"]
            (xml2trs_input xml2name)
            (fn (q, (r, so)) =>
              AssumeSN
                (strategy_to_Q q r,
                  (r, (case so of NONE => [] | SOME s => s)))))])
    id x;

fun search_len t s n =
  (if equal_lista equal_char (take n t) s then SOME ([], drop n t)
    else (case t of [] => NONE
           | h :: tt =>
             (case search_len tt s n of NONE => NONE
               | SOME (bef, aft) => SOME (h :: bef, aft))));

fun list_sumI ze pl [] = ze
  | list_sumI ze pl (x :: xs) = pl x (list_sumI ze pl xs);

fun mul_pvarsI A_ uu uv a [] = []
  | mul_pvarsI A_ ze ti a ((x, b) :: vas) =
    let
      val p = ti a b;
      val res = mul_pvarsI A_ ze ti a vas;
    in
      (if eq A_ p ze then res else (x, p) :: res)
    end;

fun mul_lpolyI A_ ze ti a (LPoly (b, vas)) =
  LPoly (ti a b, mul_pvarsI A_ ze ti a vas);

fun add_varI A_ B_ uu uv x a [] = [(x, a)]
  | add_varI A_ B_ ze pl x a ((y, b) :: vas) =
    (if eq B_ x y
      then let
             val s = pl a b;
           in
             (if eq A_ s ze then vas else (x, s) :: vas)
           end
      else (y, b) :: add_varI A_ B_ ze pl x a vas);

fun sum_pvarsI A_ B_ uu uv [] vbs = vbs
  | sum_pvarsI A_ B_ ze pl ((x, a) :: vas) vbs =
    (if eq A_ a ze then sum_pvarsI A_ B_ ze pl vas vbs
      else sum_pvarsI A_ B_ ze pl vas (add_varI A_ B_ ze pl x a vbs));

fun sum_lpolyI A_ B_ ze pl (LPoly (a, vas)) (LPoly (b, vbs)) =
  LPoly (pl a b, sum_pvarsI A_ B_ ze pl vas vbs);

fun pleftI A_ C_ ze on pl ti mz pi (Var x) = LPoly (ze, [(x, on)])
  | pleftI A_ C_ ze on pl ti mz pi (Fun (f, ts)) =
    let
      val (c, asa) = pi f (size_list ts);
    in
      (case sum_lpolyI A_ C_ ze pl (LPoly (c, []))
              (list_sumI (LPoly (ze, [])) (sum_lpolyI A_ C_ ze pl)
                (mapa (fn at =>
                        mul_lpolyI A_ ze ti (fst at)
                          (pleftI A_ C_ ze on pl ti mz pi (snd at)))
                  (zip asa ts)))
        of LPoly (d, []) => LPoly (mz d, [])
        | LPoly (d, ab :: lista) => LPoly (d, ab :: lista))
    end;

fun linorder_list (A1_, A2_) =
  {order_linorder = order_list (A1_, order_linorder A2_)} : ('a list) linorder;

fun check_poly_ge A_ B_ [] q =
  list_all
    (fn (_, a) =>
      ge ((non_strict_order_ordered_ab_semigroup o
            ordered_ab_semigroup_ordered_semiring_0)
           B_)
        (zero ((zero_mult_zero o mult_zero_semiring_0 o
                 semiring_0_ordered_semiring_0)
                B_))
        a)
    q
  | check_poly_ge A_ B_ ((m, c) :: p) q =
    (case extract (fn nd => eq_monom A_ (fst nd) m) q
      of NONE =>
        ge ((non_strict_order_ordered_ab_semigroup o
              ordered_ab_semigroup_ordered_semiring_0)
             B_)
          c (zero ((zero_mult_zero o mult_zero_semiring_0 o
                     semiring_0_ordered_semiring_0)
                    B_)) andalso
          check_poly_ge A_ B_ p q
      | SOME (q1, ((_, d), q2)) =>
        ge ((non_strict_order_ordered_ab_semigroup o
              ordered_ab_semigroup_ordered_semiring_0)
             B_)
          c d andalso
          check_poly_ge A_ B_ p (q1 @ q2));

fun check_poly_gt A_ B_ gt p q =
  let
    val (a1, p1) =
      poly_split B_
        ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_ordered_semiring_0)
          A_)
        [] p;
    val (b1, q1) =
      poly_split B_
        ((zero_mult_zero o mult_zero_semiring_0 o semiring_0_ordered_semiring_0)
          A_)
        [] q;
  in
    gt a1 b1 andalso check_poly_ge B_ A_ p1 q1
  end;

fun rpo_strict_unbounded (A1_, A2_) (B1_, B2_) pr c =
  (fn (s, t) =>
    check (fst (rpo_unbounded A1_ B1_ pr c s t))
      (shows_string
         [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"o",
           #"r", #"i", #"e", #"n", #"t", #" "] o
        (shows_prec_term A2_ B2_ Zero_nat s o
          (shows_string [#" ", #">", #"R", #"P", #"O", #" "] o
            (shows_prec_term A2_ B2_ Zero_nat t o shows_nl)))));

fun rpo_nstrict_unbounded (A1_, A2_) (B1_, B2_) pr c =
  (fn (s, t) =>
    check (snd (rpo_unbounded A1_ B1_ pr c s t))
      (shows_string
         [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"o",
           #"r", #"i", #"e", #"n", #"t", #" "] o
        (shows_prec_term A2_ B2_ Zero_nat s o
          (shows_string [#" ", #">", #"=", #"R", #"P", #"O", #" "] o
            (shows_prec_term A2_ B2_ Zero_nat t o shows_nl)))));

fun create_RPO_redtriple A_ (B1_, B2_) (C1_, C2_) prec_repr_to_pr pr =
  let
    val (p, tau) = prec_repr_to_pr pr;
    val ns =
      rpo_nstrict_unbounded (B1_, B2_) (C1_, C2_) (prc_nat p, prl_nat p) tau;
  in
    Redtriple_ext
      (Inr (),
        rpo_strict_unbounded (B1_, B2_) (C1_, C2_) (prc_nat p, prl_nat p) tau,
        ns, ns, full_af, Inr (), shows_rpo_repr A_ pr, ())
  end;

fun rev_term c (Var x) = ctxt_apply c (Var x)
  | rev_term c (Fun (f, [t])) = rev_term (More (f, [], c, [])) t;

fun rev_rule (l, r) = (rev_term Hole l, rev_term Hole r);

fun doc_of_string s = bindb (parse_doc s) (fn (doc, _) => Inr doc);

fun filtered_fun (FPair (f, n)) = f;

fun shows_prec_filtered A_ d ff = shows_prec A_ Zero_nat (filtered_fun ff);

fun shows_list_filtered A_ ffs =
  shows_list_aux (shows_prec_filtered A_ Zero_nat) ffs;

fun show_filtered A_ =
  {shows_prec = shows_prec_filtered A_, shows_list = shows_list_filtered A_} :
  'a filtered show;

fun afs_check A_ B_ r pi g lr =
  let
    val pl = afs_term pi (fst lr);
    val pr = afs_term pi (snd lr);
  in
    catch (g (pl, pr))
      (fn x =>
        Inl (shows_string
               [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                 #"o", #"r", #"i", #"e", #"n", #"t", #" "] o
              (shows_prec_term A_ B_ Zero_nat (fst lr) o
                (shows_string [#" "] o
                  (r o (shows_string [#" "] o
                         (shows_prec_term A_ B_ Zero_nat (snd lr) o
                           (shows_nl o
                             (shows_string [#"p", #"i", #"(", #" "] o
                               (shows_prec_term A_ B_ Zero_nat (fst lr) o
                                 (shows_string [#" ", #")", #" ", #"=", #" "] o
                                   (shows_prec_term (show_filtered A_) B_
                                      Zero_nat pl o
                                     (shows_nl o
                                       (shows_string [#"p", #"i", #"(", #" "] o
 (shows_prec_term A_ B_ Zero_nat (snd lr) o
   (shows_string [#" ", #")", #" ", #"=", #" "] o
     (shows_prec_term (show_filtered A_) B_ Zero_nat pr o
       (shows_nl o x))))))))))))))))))
  end;

fun shows_afs A_ af =
  shows_map
    (fn (a, b) =>
      let
        val (f, n) = a;
      in
        (fn e =>
          shows_string [#"p", #"i", #"("] o
            (shows_prec A_ Zero_nat f o
              (shows_string [#"/"] o
                (shows_prec_nat Zero_nat n o
                  (shows_string [#")", #" ", #"=", #" "] o
                    ((case e of Collapse i => shows_prec_nat Zero_nat (Suc i)
                       | AFList ids =>
                         shows_prec_list show_nat Zero_nat (mapa Suc ids)) o
                      shows_nl))))))
      end
        b)
    af;

fun starts_with t s =
  (if not (null t) andalso membera equal_char wspace (hd t)
    then starts_with (tl t) s
    else (case search_len t s (size_list s) of NONE => false | SOME _ => true));

fun forallm_index_aux p i [] = Inr ()
  | forallm_index_aux p i (x :: xs) =
    bindb (catch (p x i) (fn xa => Inl ((x, i), xa)))
      (fn _ => forallm_index_aux p (Suc i) xs);

fun forallm_index p xs = forallm_index_aux p Zero_nat xs;

fun equal_gctxt A_ = {equal = equal_gctxta A_} : ('a, 'b) gctxt equal
and equal_gctxta A_ (GCFun (f, lista)) GCHole = false
  | equal_gctxta A_ GCHole (GCFun (f, lista)) = false
  | equal_gctxta A_ (GCFun (fa, listaa)) (GCFun (f, lista)) =
    eq A_ fa f andalso equal_lista (equal_gctxt A_) listaa lista
  | equal_gctxta A_ GCHole GCHole = true;

fun linorder_lab (A1_, A2_) (B1_, B2_) =
  {order_linorder =
     order_lab (A1_, order_linorder A2_) (B1_, order_linorder B2_)}
  : ('a, 'b) lab linorder;

fun prightI A_ C_ ze on pl ti mz pi (Var x) = LPoly (ze, [(x, on)])
  | prightI A_ C_ ze on pl ti mz pi (Fun (f, ts)) =
    let
      val (c, asa) = pi f (size_list ts);
      val LPoly (d, a) =
        sum_lpolyI A_ C_ ze pl (LPoly (c, []))
          (list_sumI (LPoly (ze, [])) (sum_lpolyI A_ C_ ze pl)
            (mapa (fn at =>
                    mul_lpolyI A_ ze ti (fst at)
                      (prightI A_ C_ ze on pl ti mz pi (snd at)))
              (zip asa ts)));
    in
      LPoly (mz d, a)
    end;

fun match_to_idents_impl C_ D_ simp ident t_l =
  bind (simp [t_l] [])
    (fn (smp, i) =>
      let
        val ids = mapa ident (ident_prob_of_smp C_ D_ smp);
      in
        (if membera (equal_option equal_nat) ids NONE then NONE
          else SOME (plus_nata (max_list (mapa the ids)) i))
      end);

fun match_prob_of_rp_impl B_ C_ mu w (t, Var x) = [(t, Var x)]
  | match_prob_of_rp_impl B_ C_ mu w (t, Fun (v, va)) =
    let
      val sterms = remdups (equal_term B_ C_) (t :: mapa mu (w t));
      val filt = filter (fn x => not (is_var x));
      val uterms = maps (fn ta => filt (supteq_list ta)) sterms;
    in
      mapa (fn u => (u, Fun (v, va))) (remdups (equal_term B_ C_) uterms)
    end;

fun redex_decision B_ C_ G_ H_ mu simp ident w rp =
  let
    val mps = match_prob_of_rp_impl B_ C_ mu w rp;
    val a = mapa (match_to_idents_impl G_ H_ simp ident) mps;
  in
    list_ex (fn sol => not (is_none sol)) a
  end;

fun poly_vars_list A_ p = remdups A_ (maps (mapa fst o fst) p);

fun indent p s =
  maps (fn c => (if ((c : char) = newline) then [newline, #" "] else [c]))
    (p s);

fun label_s_ns_impl A_ B_ cS cNS s t =
  let
    val (sa, i) = s;
    val (ta, j) = t;
  in
    (if isOK (cS (sa, ta)) then (true, true)
      else (if isOK (cNS (sa, ta)) then (less_nat j i, less_eq_nat j i)
             else (false, false)))
  end;

fun funas_term_list A_ = remdups (equal_prod A_ equal_nat) o funas_term_lista;

fun mk_subst_domain A_ B_ sigma =
  let
    val tau = mk_subst A_ sigma;
  in
    remdups (equal_prod A_ (equal_term B_ A_))
      (filter (fn (x, t) => not (equal_terma B_ A_ (Var x) t))
        (mapa (fn (x, _) => (x, tau x)) sigma))
  end;

fun shows_prec_ctxt A_ B_ d =
  shows_ctxt (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat);

fun only_eta_rules (A1_, A2_) (B1_, B2_) e r_eta =
  catch (forallm
          (fn (l, r) =>
            check (case (l, r) of (Var _, b) => false
                    | (Fun (f, ls), Var _) => false
                    | (Fun (f, ls), Fun (g, rs)) =>
                      eq A1_ f g andalso
                        (equal_nata (size_list ls)
                           (nat (2 : IntInf.int)) andalso
                          (equal_nata (size_list rs)
                             (nat (2 : IntInf.int)) andalso
                            (equal_terma A1_ B1_ (nth ls one_nata)
                               (nth rs one_nata) andalso
                              list_ex
                                (fn (la, ra) =>
                                  instance_rule A1_ B1_ (hd ls, hd rs) (la, ra))
                                r_eta))))
              (shows_prec_list show_char Zero_nat
                 [#"r", #"u", #"l", #"e", #" "] o
                (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
                   [#" ", #"-", #">", #" "] (l, r) o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #"n",
                      #" ", #"(", #"e", #"t", #"a", #"-", #"e", #"x", #"p",
                      #"a", #"n", #"d", #"e", #"d", #")", #" ", #"o", #"r",
                      #"i", #"g", #"i", #"n", #"a", #"l", #" ", #"r", #"u",
                      #"l", #"e"])))
          e)
    (fn x => Inl (snd x));

fun pa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = p;

fun rc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = r;

fun pwa
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = pw;

fun rwc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = rw;

fun uncurry_proc (B1_, B2_) i info fmap check_inj p r dpp =
  let
    val (a, (sml, (u, eb))) = info;
    val paa = pa i dpp;
    val pw = pwa i dpp;
    val ra = rc i dpp;
    val rw = rwc i dpp;
    val (e, ew) = uncurry_eta_split B1_ (equal_list equal_char) eb ra;
    val sm = sig_list_to_sig_map B1_ a sml fmap;
    val uP = uncurry_rules B1_ a sm paa;
    val uPw = uncurry_rules B1_ a sm pw;
    val r_eta = e @ ra;
    val rw_eta = ew @ rw;
    val uR = uncurry_rules B1_ a sm r_eta;
    val uRw = uncurry_rules B1_ a sm rw_eta;
  in
    (case let
            val s = uncurry_of_sig_list a sml sm;
          in
            bindb (check (null (qc i dpp))
                    (shows_prec_list show_char Zero_nat
                      [#"s", #"t", #"r", #"a", #"t", #"e", #"g", #"y", #" ",
                        #"n", #"o", #"t", #" ", #"s", #"u", #"p", #"p", #"o",
                        #"r", #"t", #"e", #"d", #" ", #"f", #"o", #"r", #" ",
                        #"u", #"n", #"c", #"u", #"r", #"r", #"y", #"i", #"n",
                        #"g"]))
              (fn _ =>
                bindb (only_eta_rules (B1_, B2_)
                        (equal_list equal_char, show_list show_char) e r_eta)
                  (fn _ =>
                    bindb (only_eta_rules (B1_, B2_)
                            (equal_list equal_char, show_list show_char) ew
                            rw_eta)
                      (fn _ =>
                        bindb (check_inj a (nat (2 : IntInf.int)) sml)
                          (fn _ =>
                            bindb (catch
                                    (forallm
                                      (fn (l, _) =>
check (hvf_term B1_ a l)
  (shows_prec_list show_char Zero_nat
     [#"h", #"e", #"a", #"d", #" ", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
       #"e", #" ", #"i", #"n", #" ", #"l", #"h", #"s", #" "] o
    (shows_term (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
       l o
      shows_prec_list show_char Zero_nat
        [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l", #"o", #"w", #"e",
          #"d"])))
                                      paa)
                                    (fn x => Inl (snd x)))
                              (fn _ =>
                                bindb (catch
(forallm
  (fn (l, _) =>
    check (hvf_term B1_ a l)
      (shows_prec_list show_char Zero_nat
         [#"h", #"e", #"a", #"d", #" ", #"v", #"a", #"r", #"i", #"a", #"b",
           #"l", #"e", #" ", #"i", #"n", #" ", #"l", #"h", #"s", #" "] o
        (shows_term (shows_prec B2_ Zero_nat)
           (shows_prec_list show_char Zero_nat) l o
          shows_prec_list show_char Zero_nat
            [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l", #"o", #"w", #"e",
              #"d"])))
  pw)
(fn x => Inl (snd x)))
                                  (fn _ =>
                                    bindb (catch
    (forallm
      (fn (l, _) =>
        check (hvf_term B1_ a l)
          (shows_prec_list show_char Zero_nat
             [#"h", #"e", #"a", #"d", #" ", #"v", #"a", #"r", #"i", #"a", #"b",
               #"l", #"e", #" ", #"i", #"n", #" ", #"l", #"h", #"s", #" "] o
            (shows_term (shows_prec B2_ Zero_nat)
               (shows_prec_list show_char Zero_nat) l o
              shows_prec_list show_char Zero_nat
                [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l", #"o", #"w",
                  #"e", #"d"])))
      r_eta)
    (fn x => Inl (snd x)))
                                      (fn _ =>
bindb (catch
        (forallm
          (fn (l, _) =>
            check (hvf_term B1_ a l)
              (shows_prec_list show_char Zero_nat
                 [#"h", #"e", #"a", #"d", #" ", #"v", #"a", #"r", #"i", #"a",
                   #"b", #"l", #"e", #" ", #"i", #"n", #" ", #"l", #"h", #"s",
                   #" "] o
                (shows_term (shows_prec B2_ Zero_nat)
                   (shows_prec_list show_char Zero_nat) l o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l", #"o", #"w",
                      #"e", #"d"])))
          rw_eta)
        (fn x => Inl (snd x)))
  (fn _ =>
    bindb (eta_closed_rules (B1_, B2_)
            (equal_list equal_char, show_list show_char) a sm r_eta r_eta)
      (fn _ =>
        bindb (eta_closed_rules (B1_, B2_)
                (equal_list equal_char, show_list show_char) a sm rw_eta rw_eta)
          (fn _ =>
            bindb (catch
                    (check_subseteq
                      (equal_prod (equal_term B1_ (equal_list equal_char))
                        (equal_term B1_ (equal_list equal_char)))
                      uP p)
                    (fn x =>
                      Inl (shows_prec_list show_char Zero_nat
                             [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e",
                               #"d", #" ", #"p", #"a", #"i", #"r", #" "] o
                            (shows_rule (shows_prec B2_ Zero_nat)
                               (shows_prec_list show_char Zero_nat)
                               [#" ", #"-", #">", #" "] x o
                              shows_prec_list show_char Zero_nat
                                [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s",
                                  #"i", #"n", #"g"]))))
              (fn _ =>
                bindb (catch
                        (check_subseteq
                          (equal_prod (equal_term B1_ (equal_list equal_char))
                            (equal_term B1_ (equal_list equal_char)))
                          uPw p)
                        (fn x =>
                          Inl (shows_prec_list show_char Zero_nat
                                 [#"u", #"n", #"c", #"u", #"r", #"r", #"i",
                                   #"e", #"d", #" ", #"p", #"a", #"i", #"r",
                                   #" "] o
                                (shows_rule (shows_prec B2_ Zero_nat)
                                   (shows_prec_list show_char Zero_nat)
                                   [#" ", #"-", #">", #" "] x o
                                  shows_prec_list show_char Zero_nat
                                    [#" ", #"i", #"s", #" ", #"m", #"i", #"s",
                                      #"s", #"i", #"n", #"g"]))))
                  (fn _ =>
                    bindb (catch
                            (check_subseteq
                              (equal_prod
                                (equal_term B1_ (equal_list equal_char))
                                (equal_term B1_ (equal_list equal_char)))
                              uR r)
                            (fn x =>
                              Inl (shows_prec_list show_char Zero_nat
                                     [#"u", #"n", #"c", #"u", #"r", #"r", #"i",
                                       #"e", #"d", #" ", #"r", #"u", #"l", #"e",
                                       #" "] o
                                    (shows_rule (shows_prec B2_ Zero_nat)
                                       (shows_prec_list show_char Zero_nat)
                                       [#" ", #"-", #">", #" "] x o
                                      shows_prec_list show_char Zero_nat
[#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"]))))
                      (fn _ =>
                        bindb (catch
                                (check_subseteq
                                  (equal_prod
                                    (equal_term B1_ (equal_list equal_char))
                                    (equal_term B1_ (equal_list equal_char)))
                                  uRw r)
                                (fn x =>
                                  Inl (shows_prec_list show_char Zero_nat
 [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #" ", #"r", #"u", #"l",
   #"e", #" "] o
(shows_rule (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
   [#" ", #"-", #">", #" "] x o
  shows_prec_list show_char Zero_nat
    [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"]))))
                          (fn _ =>
                            bindb (catch
                                    (check_CS_subseteq B1_
                                      (equal_list equal_char) s u)
                                    (fn x =>
                                      Inl
(shows_prec_list show_char Zero_nat
   [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #" ", #"r", #"u", #"l", #"e",
     #" "] o
  (shows_rule (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
     [#" ", #"-", #">", #" "] x o
    shows_prec_list show_char Zero_nat
      [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"]))))
                              (fn _ =>
                                bindb (catch
(check_CS_subseteq B1_ (equal_list equal_char) u s)
(fn x =>
  Inl (shows_prec_list show_char Zero_nat [#"r", #"u", #"l", #"e", #" "] o
        (shows_rule (shows_prec B2_ Zero_nat)
           (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] x o
          shows_prec_list show_char Zero_nat
            [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #"n", #" ",
              #"u", #"n", #"c", #"u", #"r", #"r", #"y", #" ", #"r", #"u", #"l",
              #"e"]))))
                                  (fn _ =>
                                    catch (check_subseteq
    (equal_prod (equal_term B1_ (equal_list equal_char))
      (equal_term B1_ (equal_list equal_char)))
    u r)
                                      (fn x =>
Inl (shows_prec_list show_char Zero_nat
       [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #" ", #"r", #"u", #"l", #"e",
         #" "] o
      (shows_rule (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
         [#" ", #"-", #">", #" "] x o
        shows_prec_list show_char Zero_nat
          [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g",
            #" ", #"i", #"n", #" ", #"n", #"e", #"w", #" ", #"T", #"R",
            #"S"])))))))))))))))))))
          end
      of Inl aa => Inl aa | Inr _ => Inr (mkc i uP uPw [] uR (uRw @ u)))
  end;

fun xml2dp_disproof xml2name x =
  xml1element
    [#"d", #"p", #"N", #"o", #"n", #"t", #"e", #"r", #"m", #"i", #"n", #"a",
      #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f"]
    (xml_options
      [([#"d", #"p", #"R", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a",
          #"l"],
         xml3elements
           [#"d", #"p", #"R", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v",
             #"a", #"l"]
           (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
           (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
           (xml2dp_disproof xml2name)
           (fn a => fn b => fn c => DP_Rule_Removal (a, b, c))),
        ([#"l", #"o", #"o", #"p"],
          xml_change (loop xml2name)
            (fn (s, (rseq, (a, b))) => DP_Loop (s, rseq, a, b)))])
    id x;

fun eqWhiteSpace s1 s2 =
  debug [#"0"]
    [#"c", #"o", #"m", #"p", #"a", #"r", #"i", #"n", #"g", #" ", #"w", #"h",
      #"e", #"t", #"h", #"e", #"r", #" ", #"p", #"a", #"r", #"s", #"e", #"d",
      #" ", #"i", #"n", #"p", #"u", #"t", #" ", #"c", #"o", #"r", #"r", #"e",
      #"s", #"p", #"o", #"n", #"d", #"s", #" ", #"t", #"o", #" ", #"r", #"e",
      #"a", #"l", #" ", #"i", #"n", #"p", #"u", #"t"]
    (equal_lista equal_char
      (filter (fn c => not (membera equal_char wspace c)) s1)
      (filter (fn c => not (membera equal_char wspace c)) s2));

val linorder_char = {order_linorder = order_char} : char linorder;

datatype ('a, 'b) ta_rule_impl =
  TA_rule_impl of 'b * 'a list * 'a * ('a, unit) rbt;

datatype ('a, 'b, 'c) ta_impl_ext =
  Ta_impl_ext of
    ('a, unit) rbt * (('b * nat), (('a, 'b) ta_rule_impl list)) rbt * 'a list *
      ('a, unit) rbt * ('a * 'a) list * ('a -> ('a, unit) rbt) *
      ('a -> ('a, unit) rbt) * 'c;

fun ta_rqs_set
  (Ta_impl_ext
    (ta_final_impl, ta_rules_impl, ta_rqs_impl, ta_rqs_set, ta_eps_impl,
      ta_epss_impl, ta_epsrs_impl, more))
  = ta_rqs_set;

fun rsym_impl (TA_rule_impl (f, qsa, q, qs)) = (f, size_list qsa);

fun conv_ta_rule eps (TA_rule (f, qs, q)) = TA_rule_impl (f, qs, q, eps q);

fun elem_list_to_rm B_ key [] = rm_empty B_
  | elem_list_to_rm B_ key (d :: ds) =
    let
      val rm = elem_list_to_rm B_ key ds;
      val k = key d;
    in
      (case rm_alpha B_ rm k of NONE => rm_update_dj B_ k [d] rm
        | SOME data => rm_update B_ k (d :: data) rm)
    end;

fun rm_set_lookup A_ rm =
  (fn a => (case rm_alpha A_ rm a of NONE => [] | SOME rules => rules));

fun rtrancl_rbt_impl A_ =
  rtrancl_impl
    (fn r =>
      let
        val rm = elem_list_to_rm A_ fst r;
      in
        (fn asa =>
          rs_to_list A_
            (foldl
              (fn a => fn x =>
                rs_union A_ a
                  (list_to_rs A_ (mapa snd (rm_set_lookup A_ rm x))))
              (rs_empty A_) asa))
      end)
    (fn asa => fn bs => rs_union A_ bs (list_to_rs A_ asa)) (rs_memb A_)
    (rs_empty A_);

fun memo_rbt_rtrancl A_ r =
  let
    val tr = rtrancl_rbt_impl A_ r;
    val rm =
      list_to_rm A_
        (mapa (fn a => (a, tr [a]))
          ((rs_to_list A_ o list_to_rs A_ o mapa fst) r));
  in
    (fn a =>
      (case rm_lookup A_ a rm of NONE => list_to_rs A_ [a] | SOME asa => asa))
  end;

fun generate_ta A_ (B1_, B2_) (Tree_Automaton (fin, rules, eps)) =
  let
    val ep = memo_rbt_rtrancl A_ eps;
    val epr = memo_rbt_rtrancl A_ (mapa (fn (q, qa) => (qa, q)) eps);
    val rqs_rs =
      foldl (fn a => fn x => rs_union A_ a (ep (rq x))) (rs_empty A_) rules;
    val rrules = mapa (conv_ta_rule ep) rules;
  in
    Ta_impl_ext
      (list_to_rs A_ fin,
        elem_list_to_rm (linorder_prod (B1_, B2_) (equal_nat, linorder_nat))
          rsym_impl rrules,
        rs_to_list A_ rqs_rs, rqs_rs, eps, ep, epr, ())
  end;

fun check_left_linear_trs A_ (B1_, B2_) trs =
  catch (catch
          (forallm (fn x => (if linear_term B1_ (fst x) then Inr () else Inl x))
            trs)
          (fn x => Inl (snd x)))
    (fn _ =>
      Inl (shows_prec_list (show_prod (show_term A_ B2_) (show_term A_ B2_))
             Zero_nat trs o
            (shows_nl o
              (shows_string
                 [#"i", #"s", #" ", #"n", #"o", #"t", #" ", #"l", #"e", #"f",
                   #"t", #"-", #"l", #"i", #"n", #"e", #"a", #"r"] o
                shows_nl))));

fun boundstype_fun B_ Roof = roof B_
  | boundstype_fun B_ Match = match;

fun ta_rules_impl
  (Ta_impl_ext
    (ta_final_impl, ta_rules_impl, ta_rqs_impl, ta_rqs_set, ta_eps_impl,
      ta_epss_impl, ta_epsrs_impl, more))
  = ta_rules_impl;

fun bounds_condition A_ (B1_, B2_) Roof uu = Inr ()
  | bounds_condition A_ (B1_, B2_) Match r =
    catch (catch
            (forallm
              (fn x =>
                (if let
                      val (_, a) = x;
                    in
                      linear_term B1_ a
                    end
                  then Inr () else Inl x))
              r)
            (fn x => Inl (snd x)))
      (fn x =>
        Inl let
              val (l, ra) = x;
            in
              shows_prec_list show_char Zero_nat
                [#"r", #"u", #"l", #"e", #" "] o
                (shows_rule (shows_prec A_ Zero_nat) (shows_prec B2_ Zero_nat)
                   [#" ", #"-", #">", #" "] (l, ra) o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"r", #"i",
                      #"g", #"h", #"t", #"-", #"l", #"i", #"n", #"e", #"a",
                      #"r", #" "])
            end);

fun rqs_impl (TA_rule_impl (f, qsa, q, qs)) = qsa;

fun rqss_impl (TA_rule_impl (f, qsa, q, qs)) = qs;

fun ta_epss_impl
  (Ta_impl_ext
    (ta_final_impl, ta_rules_impl, ta_rqs_impl, ta_rqs_set, ta_eps_impl,
      ta_epss_impl, ta_epsrs_impl, more))
  = ta_epss_impl;

fun ta_final_impl
  (Ta_impl_ext
    (ta_final_impl, ta_rules_impl, ta_rqs_impl, ta_rqs_set, ta_eps_impl,
      ta_epss_impl, ta_epsrs_impl, more))
  = ta_final_impl;

fun ta_contains_impl (A1_, A2_) (B1_, B2_) f ta qs =
  let
    val fin = ta_final_impl ta;
    val look =
      rm_set_lookup (linorder_prod (A1_, A2_) (equal_nat, linorder_nat))
        (ta_rules_impl ta);
    val _ = ta_epss_impl ta;
  in
    bindb (catch
            (catch (forallm (fn q => check (rs_memb B2_ q fin) q) qs)
              (fn x => Inl (snd x)))
            (fn x => Inl (Inl x)))
      (fn _ =>
        catch (catch
                (forallm
                  (fn (fa, n) =>
                    let
                      val rules = look (fa, n);
                    in
                      catch (catch
                              (forallm
                                (fn x =>
                                  (if list_ex
(fn rule =>
  equal_lista B1_ (rqs_impl rule) x andalso
    let
      val qq = rqss_impl rule;
    in
      list_ex (fn q => rs_memb B2_ q qq) qs
    end)
rules
                                    then Inr () else Inl x))
                                (concat_lists (replicate n qs)))
                              (fn x => Inl (snd x)))
                        (fn x => Inl (Fun (fa, mapa Var x)))
                    end)
                  f)
                (fn x => Inl (snd x)))
          (fn x => Inl (Inr x)))
  end;

fun flatten_term_enum_filter f (Var x) =
  let
    val tx = Var x;
  in
    (if f tx then [tx] else [])
  end
  | flatten_term_enum_filter f (Fun (fs, ts)) =
    let
      val lts = mapa (flatten_term_enum_filter f) ts;
    in
      (if list_ex null lts then []
        else let
               val ss = concat_lists lts;
             in
               filter f (maps (fn fa => mapa (fn a => Fun (fa, a)) ss) fs)
             end)
    end;

fun inverse_base_term_filter filt l c =
  let
    val hs = upt Zero_nat (Suc c);
  in
    flatten_term_enum_filter filt
      (map_term (fn f => mapa (fn h => lift h f) hs) l)
  end;

fun cover_bound_list_filter filt ff c r =
  maps (fn (l, ra) =>
         let
           val ee = ff (l, ra);
         in
           mapa (fn la =>
                  (la, map_term
                         (lift (Suc (min_list linorder_nat
                                      (mapa height
(sym_collect (fn t => ee (map_term base t)) la)))))
                         ra))
             (inverse_base_term_filter filt l c)
         end)
    r;

fun ta_res_impl (A1_, A2_) B_ ta eps (Var q) = eps q
  | ta_res_impl (A1_, A2_) B_ ta eps (Fun (f, ts)) =
    let
      val reca = mapa (ta_res_impl (A1_, A2_) B_ ta eps) ts;
      val n = size_list ts;
      val rules =
        rm_set_lookup (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) ta
          (f, n);
      val arules =
        filter
          (fn rule =>
            let
              val qs = rqs_impl rule;
            in
              all_interval_nat (fn i => rs_memb B_ (nth qs i) (nth reca i))
                Zero_nat n
            end)
          rules;
      val a = mapa rqss_impl arules;
    in
      foldl (rs_union B_) (rs_empty B_) a
    end;

fun ta_rqs_impl
  (Ta_impl_ext
    (ta_final_impl, ta_rules_impl, ta_rqs_impl, ta_rqs_set, ta_eps_impl,
      ta_epss_impl, ta_epsrs_impl, more))
  = ta_rqs_impl;

fun rs_subset A_ asa bs =
  rs_iteratei A_ (fn a => (case a of NONE => true | SOME _ => false))
    (fn a => fn _ => (if rs_memb A_ a bs then NONE else SOME a)) asa NONE;

fun ta_epsrs_impl
  (Ta_impl_ext
    (ta_final_impl, ta_rules_impl, ta_rqs_impl, ta_rqs_set, ta_eps_impl,
      ta_epss_impl, ta_epsrs_impl, more))
  = ta_epsrs_impl;

fun ta_match_impl (A1_, A2_) (B1_, B2_) (C1_, C2_) ta eps (Var x) q =
  list_to_rs
    (linorder_list (equal_prod C1_ B1_, linorder_prod (C1_, C2_) (B1_, B2_)))
    (mapa (fn qa => [(x, qa)]) (rs_to_list B2_ (eps q)))
  | ta_match_impl (A1_, A2_) (B1_, B2_) (C1_, C2_) ta eps (Fun (f, ts)) q =
    let
      val n = size_list ts;
      val rules =
        rm_set_lookup (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) ta
          (f, n);
      val ep = eps q;
      val fa =
        (fn rule =>
          list_to_rs
            (linorder_list
              (equal_prod C1_ B1_, linorder_prod (C1_, C2_) (B1_, B2_)))
            let
              val TA_rule_impl (_, qs, qa, _) = rule;
            in
              (if rs_memb B2_ qa ep
                then let
                       val reca =
                         mapa (fn (tsi, qsi) =>
                                rs_to_list
                                  (linorder_list
                                    (equal_prod C1_ B1_,
                                      linorder_prod (C1_, C2_) (B1_, B2_)))
                                  (ta_match_impl (A1_, A2_) (B1_, B2_)
                                    (C1_, C2_) ta eps tsi qsi))
                           (zip ts qs);
                     in
                       mapa concat (concat_lists reca)
                     end
                else [])
            end);
    in
      foldl (fn a => fn x =>
              rs_union
                (linorder_list
                  (equal_prod C1_ B1_, linorder_prod (C1_, C2_) (B1_, B2_)))
                a (fa x))
        (rs_empty
          (linorder_list
            (equal_prod C1_ B1_, linorder_prod (C1_, C2_) (B1_, B2_))))
        rules
    end;

fun ta_rule_compatible_eff_list (A1_, A2_) (B1_, B2_) (C1_, C2_) ta
  (Fun (f, ls), r) =
  let
    val rm = ta_rules_impl ta;
    val eps = ta_epss_impl ta;
    val epsa = ta_epsrs_impl ta;
    val n = size_list ls;
    val ta_res = ta_res_impl (B1_, B2_) A2_ rm eps;
  in
    catch (forallm
            (fn TA_rule_impl (fa, _, q, _) =>
              catch (forallm
                      (fn sigma =>
                        let
                          val sigmaa = fun_of C1_ sigma;
                          val l_sigma = map_vars sigmaa (Fun (fa, ls));
                          val r_sigma = map_vars sigmaa r;
                          val qsl = ta_res l_sigma;
                          val qsr = ta_res r_sigma;
                        in
                          (case rs_subset A2_ qsl qsr of NONE => Inr ()
                            | SOME qa => Inl ((l_sigma, r_sigma), qa))
                        end)
                      (rs_to_list
                        (linorder_list
                          (equal_prod C1_ A1_,
                            linorder_prod (C1_, C2_) (A1_, A2_)))
                        (ta_match_impl (B1_, B2_) (A1_, A2_) (C1_, C2_) rm epsa
                          (Fun (fa, ls)) q)))
                (fn x => Inl (snd x)))
            (rm_set_lookup (linorder_prod (B1_, B2_) (equal_nat, linorder_nat))
              rm (f, n)))
      (fn x => Inl (snd x))
  end
  | ta_rule_compatible_eff_list (A1_, A2_) (B1_, B2_) (C1_, C2_) ta (Var x, r) =
    let
      val rm = ta_rules_impl ta;
      val eps = ta_epss_impl ta;
      val ta_res = ta_res_impl (B1_, B2_) A2_ rm eps;
    in
      catch (forallm
              (fn q =>
                let
                  val r_sigma = map_vars (fn _ => q) r;
                in
                  check (rs_memb A2_ q (ta_res r_sigma)) ((Var q, r_sigma), q)
                end)
              (ta_rqs_impl ta))
        (fn xa => Inl (snd xa))
    end;

fun ta_trs_compatible_eff_list (A1_, A2_) (B1_, B2_) (C1_, C2_) ta r =
  let
    val check = ta_rule_compatible_eff_list (A1_, A2_) (B1_, B2_) (C1_, C2_) ta;
  in
    catch (forallm (fn lr => catch (check lr) (fn x => Inl (lr, x))) r)
      (fn x => Inl (snd x))
  end;

fun ta_res_impl_all A_ (B1_, B2_) q ta (Var uu) = q
  | ta_res_impl_all A_ (B1_, B2_) q ta (Fun (f, ts)) =
    let
      val reca = mapa (ta_res_impl_all A_ (B1_, B2_) q ta) ts;
      val n = size_list ts;
      val rules =
        rm_set_lookup (linorder_prod (B1_, B2_) (equal_nat, linorder_nat)) ta
          (f, n);
      val arules =
        filter
          (fn rule =>
            let
              val qs = rqs_impl rule;
            in
              all_interval_nat (fn i => rs_memb A_ (nth qs i) (nth reca i))
                Zero_nat n
            end)
          rules;
      val a = mapa rqss_impl arules;
    in
      foldl (rs_union A_) (rs_empty A_) a
    end;

fun ta_rule_compatible_heuristic (A1_, A2_) (B1_, B2_) C_ ta l =
  rs_isEmpty (A1_, A2_)
    (ta_res_impl_all A2_ (B1_, B2_) (ta_rqs_set ta) (ta_rules_impl ta) l);

fun check_bounds (A1_, A2_, A3_) (B1_, B2_, B3_)
  (Bounds_Info (typea, c, qfin, preTA)) r =
  let
    val ta =
      generate_ta B2_
        (equal_prod A1_ equal_nat,
          linorder_prod (A1_, A2_) (equal_nat, linorder_nat))
        preTA;
  in
    bindb (check_wf_trs A3_ (B1_, B3_) r)
      (fn _ =>
        bindb (check_left_linear_trs A3_ (B1_, B3_) r)
          (fn _ =>
            bindb (bounds_condition A3_ (B1_, B3_) typea r)
              (fn _ =>
                bindb (check
                        (list_ex (fn q => rs_memb B2_ q (ta_rqs_set ta)) qfin)
                        (shows_prec_list show_char Zero_nat
                          [#"d", #"i", #"d", #" ", #"n", #"o", #"t", #" ", #"f",
                            #"i", #"n", #"d", #" ", #"m", #"e", #"n", #"t",
                            #"i", #"o", #"n", #"e", #"d", #" ", #"f", #"i",
                            #"n", #"a", #"l", #" ", #"s", #"t", #"a", #"t",
                            #"e", #" ", #"i", #"n", #" ", #"T", #"A"]))
                  (fn _ =>
                    bindb (catch
                            (catch
                              (forallm
                                (fn x =>
                                  (if let
val (f, _) = x;
                                      in
less_eq_nat (height f) c
                                      end
                                    then Inr () else Inl x))
                                (mapa fst
                                  (rm_to_list
                                    (linorder_prod
                                      (equal_prod A1_ equal_nat,
linorder_prod (A1_, A2_) (equal_nat, linorder_nat))
                                      (equal_nat, linorder_nat))
                                    (ta_rules_impl ta))))
                              (fn x => Inl (snd x)))
                            (fn x =>
                              Inl let
                                    val (f, _) = x;
                                  in
                                    shows_prec_prod A3_ show_nat Zero_nat f o
                                      (shows_prec_list show_char Zero_nat
 [#" ", #"i", #"s", #" ", #"s", #"y", #"m", #"b", #"o", #"l", #" ", #"i", #"n",
   #" ", #"T", #"A", #" ", #"w", #"i", #"t", #"h", #" ", #"h", #"e", #"i", #"g",
   #"h", #"t", #" ", #"l", #"a", #"r", #"g", #"e", #"r", #" ", #"t", #"h", #"a",
   #"n", #" ", #"c", #" ", #"=", #" "] o
shows_prec_nat Zero_nat c)
                                  end))
                      (fn _ =>
                        bindb (catch
                                (ta_contains_impl
                                  (equal_prod A1_ equal_nat,
                                    linorder_prod (A1_, A2_)
                                      (equal_nat, linorder_nat))
                                  (B1_, B2_)
                                  (mapa (fn (f, a) => (lift Zero_nat f, a))
                                    (funas_trs_list A1_ r))
                                  ta qfin)
                                (fn x =>
                                  Inl (shows_prec_list show_char Zero_nat
 [#"i", #"t", #" ", #"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
   #"b", #"e", #" ", #"g", #"u", #"a", #"r", #"a", #"n", #"t", #"e", #"e", #"d",
   #" ", #"t", #"h", #"a", #"t", #" ", #"l", #"i", #"f", #"t", #"0", #"(", #"T",
   #"(", #"S", #"i", #"g", #"m", #"a", #")", #")", #" ", #"i", #"s", #" ", #"a",
   #"c", #"c", #"e", #"p", #"t", #"e", #"d", #" ", #"b", #"y", #" ", #"T",
   #"A"] o
(shows_nl o
  (case x
    of Inl q =>
      shows_prec_list show_char Zero_nat [#"s", #"t", #"a", #"t", #"e", #" "] o
        (shows_prec B3_ Zero_nat q o
          shows_prec_list show_char Zero_nat
            [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"f", #"i", #"n",
              #"a", #"l"])
    | Inr fqs =>
      shows_prec_list show_char Zero_nat
        [#"t", #"h", #"e", #"r", #"e", #" ", #"i", #"s", #" ", #"n", #"o", #" ",
          #"t", #"r", #"a", #"n", #"s", #"i", #"t", #"i", #"o", #"n", #" ",
          #"f", #"r", #"o", #"m", #" "] o
        (shows_prec_term (show_prod A3_ show_nat) B3_ Zero_nat fqs o
          shows_prec_list show_char Zero_nat
            [#" ", #"t", #"o", #" ", #"a", #" ", #"f", #"i", #"n", #"a", #"l",
              #" ", #"s", #"t", #"a", #"t", #"e"]))))))
                          (fn _ =>
                            catch (ta_trs_compatible_eff_list (B1_, B2_)
                                    (equal_prod A1_ equal_nat,
                                      linorder_prod (A1_, A2_)
(equal_nat, linorder_nat))
                                    (B1_, B2_) ta
                                    (cover_bound_list_filter
                                      (fn l =>
not (ta_rule_compatible_heuristic (B1_, B2_)
      (equal_prod A1_ equal_nat,
        linorder_prod (A1_, A2_) (equal_nat, linorder_nat))
      B2_ ta l))
                                      (boundstype_fun B1_ typea) c r))
                              (fn x =>
                                Inl let
                                      val (lr, (lrq, q)) = x;
                                    in
                                      shows_prec_list show_char Zero_nat
[#"T", #"A", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"c", #"o", #"m",
  #"p", #"a", #"t", #"i", #"b", #"l", #"e", #" ", #"w", #"i", #"t", #"h", #" ",
  #"R"] o
(shows_nl o
  (shows_prec_list show_char Zero_nat
     [#"f", #"o", #"r", #" ", #"r", #"u", #"l", #"e", #" "] o
    (shows_rule (shows_prec_prod A3_ show_nat Zero_nat)
       (shows_prec B3_ Zero_nat) [#" ", #"-", #">", #" "] lr o
      (shows_nl o
        (shows_prec_list show_char Zero_nat
           [#"w", #"h", #"i", #"c", #"h", #" ", #"i", #"s", #" ", #"i", #"n",
             #"s", #"t", #"a", #"n", #"t", #"i", #"a", #"t", #"e", #"d", #" ",
             #"b", #"y", #" ", #"s", #"t", #"a", #"t", #"e", #"s", #" ", #"t",
             #"o", #" "] o
          (shows_rule (shows_prec_prod A3_ show_nat Zero_nat)
             (shows_prec B3_ Zero_nat) [#" ", #"-", #">", #" "] lrq o
            (shows_nl o
              (shows_prec_list show_char Zero_nat
                 [#"t", #"h", #"e", #" ", #"s", #"t", #"a", #"t", #"e", #" "] o
                (shows_prec B3_ Zero_nat q o
                  (shows_prec_list show_char Zero_nat
                     [#" ", #"i", #"s", #" ", #"o", #"n", #"l", #"y", #" ",
                       #"r", #"e", #"a", #"c", #"h", #"a", #"b", #"l", #"e",
                       #" ", #"f", #"r", #"o", #"m", #" ", #"t", #"h", #"e",
                       #" ", #"l", #"h", #"s"] o
                    shows_nl))))))))))
                                    end)))))))
  end;

fun rulesb
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = rules;

fun bounds_tt (B1_, B2_, B3_) (C1_, C2_, C3_) i info tp =
  let
    val a = rulesb i tp;
  in
    check_bounds (B1_, B2_, B3_) (C1_, C2_, C3_) info a
  end;

fun s_label_mul_impl A_ B_ list_ext af cS cNS st =
  (case st
    of (Var _, b) =>
      Inl (shows_prec_list show_char Zero_nat
             [#"r", #"o", #"o", #"t", #"s", #" ", #"o", #"f", #" "] o
            (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
               [#" ", #"-", #">", #" "] st o
              shows_prec_list show_char Zero_nat
                [#" ", #"m", #"u", #"s", #"t", #" ", #"b", #"e", #" ", #"n",
                  #"o", #"n", #"-", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
                  #"e"]))
    | (Fun (f, ss), Var _) =>
      Inl (shows_prec_list show_char Zero_nat
             [#"r", #"o", #"o", #"t", #"s", #" ", #"o", #"f", #" "] o
            (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
               [#" ", #"-", #">", #" "] st o
              shows_prec_list show_char Zero_nat
                [#" ", #"m", #"u", #"s", #"t", #" ", #"b", #"e", #" ", #"n",
                  #"o", #"n", #"-", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
                  #"e"]))
    | (Fun (f, ss), Fun (g, ts)) =>
      check (fst (list_ext (label_s_ns_impl A_ B_ cS cNS)
                    (lterms af (Fun (f, ss)))
                   (lterms af (Fun (g, ts)))))
        (shows_prec_list show_char Zero_nat
           [#"c", #"a", #"n", #"n", #"o", #"t", #" ", #"o", #"r", #"i", #"e",
             #"n", #"t", #" ", #"p", #"a", #"i", #"r", #" "] o
          (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
             [#" ", #"-", #">", #" "] st o
            shows_prec_list show_char Zero_nat
              [#" ", #"w", #"e", #"a", #"k", #"l", #"y"])));

fun nST_label_mul_impl A_ B_ list_ext af cS cNS st =
  (case st
    of (Var _, b) =>
      Inl (shows_prec_list show_char Zero_nat
             [#"r", #"o", #"o", #"t", #"s", #" ", #"o", #"f", #" "] o
            (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
               [#" ", #"-", #">", #" "] st o
              shows_prec_list show_char Zero_nat
                [#" ", #"m", #"u", #"s", #"t", #" ", #"b", #"e", #" ", #"n",
                  #"o", #"n", #"-", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
                  #"e"]))
    | (Fun (f, ss), Var _) =>
      Inl (shows_prec_list show_char Zero_nat
             [#"r", #"o", #"o", #"t", #"s", #" ", #"o", #"f", #" "] o
            (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
               [#" ", #"-", #">", #" "] st o
              shows_prec_list show_char Zero_nat
                [#" ", #"m", #"u", #"s", #"t", #" ", #"b", #"e", #" ", #"n",
                  #"o", #"n", #"-", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
                  #"e"]))
    | (Fun (f, ss), Fun (g, ts)) =>
      check (snd (list_ext (label_s_ns_impl A_ B_ cS cNS)
                    (lterms af (Fun (f, ss)))
                   (lterms af (Fun (g, ts)))))
        (shows_prec_list show_char Zero_nat
           [#"c", #"a", #"n", #"n", #"o", #"t", #" ", #"o", #"r", #"i", #"e",
             #"n", #"t", #" ", #"p", #"a", #"i", #"r", #" "] o
          (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
             [#" ", #"-", #">", #" "] st o
            shows_prec_list show_char Zero_nat
              [#" ", #"w", #"e", #"a", #"k", #"l", #"y"])));

fun generate_scnp_rp (A1_, A2_) B_ list_ext afa rti x =
  let
    val rt = rti x;
    val afaa = fun_ofa (equal_prod A1_ equal_nat) [] afa;
    val pi = af rt;
    val cS = s rt;
    val cNS = ns rt;
  in
    Root_redtriple_ext
      (valid rt, s_label_mul_impl A2_ B_ list_ext afaa cS cNS, ns rt,
        nST_label_mul_impl A2_ B_ list_ext afaa cS cNS, pi,
        scnp_af_to_af afaa pi, scnp_af_desc A2_ afa o desc rt, ())
  end;

fun eval_lab i l lc alpha (Var x) = (alpha x, Var x)
  | eval_lab i l lc alpha (Fun (f, ts)) =
    let
      val clts = mapa (eval_lab i l lc alpha) ts;
      val cs = mapa fst clts;
      val c = i f cs;
      val lts = mapa snd clts;
    in
      (c, Fun (lc f (size_list ts) (l f cs), lts))
    end;

fun lab_root i la l lc alpha (Fun (f, ts)) =
  let
    val clts = mapa (eval_lab i la lc alpha) ts;
    val cs = mapa fst clts;
    val a = mapa snd clts;
  in
    Fun (lc f (size_list ts) (l f cs), a)
  end
  | lab_root uu uv uw ux uy (Var x) = Var x;

datatype ('a, 'b) scg = Null | Scg of 'a * 'a * ('b * 'b) list * ('b * 'b) list;

fun unary_term (Var x) = true
  | unary_term (Fun (f, [t])) = unary_term t
  | unary_term (Fun (v, [])) = false
  | unary_term (Fun (v, vb :: vd :: ve)) = false;

datatype ('a, 'b) tp =
  Tp of (('a, 'b) term list *
          (bool *
            ((('a, 'b) term * ('a, 'b) term) list *
              ((('a, 'b) term * ('a, 'b) term) list *
                (('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                  rbt))));

fun q_impl (q, uu) = q;

fun impl_ofa A_ (Tp x) = x;

fun q A_ tp = q_impl (impl_ofa A_ tp);

fun r_impl (A1_, A2_) (uu, (uv, (vR, (uw, m)))) =
  vR @ rules_with (A1_, A2_) id m;

fun r (A1_, A2_) tp = r_impl (A1_, A2_) (impl_ofa A2_ tp);

fun xml2reltrs_proof A_ xml2name x =
  xml1element
    [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"T", #"e", #"r", #"m",
      #"i", #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f"]
    (xml_options
      [([#"r", #"I", #"s", #"E", #"m", #"p", #"t", #"y"],
         xml0elements [#"r", #"I", #"s", #"E", #"m", #"p", #"t", #"y"]
           RisEmpty),
        ([#"s", #"I", #"s", #"E", #"m", #"p", #"t", #"y"],
          xml1element [#"s", #"I", #"s", #"E", #"m", #"p", #"t", #"y"]
            (xml2trs_proof A_ xml2name) id),
        ([#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"],
          xml4elements
            [#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
            (ordering_constraint_proofa xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2reltrs_proof A_ xml2name)
            (fn rp => fn one => fn two =>
              (fn a => RuleRemoval (rp, one @ two, a)))),
        ([#"s", #"e", #"m", #"l", #"a", #"b"],
          xml4elements [#"s", #"e", #"m", #"l", #"a", #"b"]
            (sl_variant xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2reltrs_proof A_ xml2name)
            (fn sli => fn lr => fn lrw =>
              (fn a => Semlab (sli, [], lr @ lrw, a)))),
        ([#"u", #"n", #"c", #"u", #"r", #"r", #"y"],
          xml4elements [#"u", #"n", #"c", #"u", #"r", #"r", #"y"]
            (uncurry_info xml2name)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2reltrs_proof A_ xml2name)
            (fn i => fn r => fn s => (fn a => Uncurry (i, r @ s, a)))),
        ([#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"T", #"e", #"r",
           #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n", #"A", #"s", #"s",
           #"u", #"m", #"p", #"t", #"i", #"o", #"n"],
          xml1element
            [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"T", #"e", #"r",
              #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n", #"A", #"s", #"s",
              #"u", #"m", #"p", #"t", #"i", #"o", #"n"]
            (xml1to2elements [#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"]
              (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
              (xml1element
                [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"R", #"u",
                  #"l", #"e", #"s"]
                (rules xml2name) id)
              (fn r => fn a =>
                (case a of NONE => AssumeSN ([], (r, []))
                  | SOME rw => AssumeSN ([], (r, rw)))))
            id)])
    id x;

fun xml2trs_disproof xml2name x =
  xml1element
    [#"t", #"r", #"s", #"N", #"o", #"n", #"t", #"e", #"r", #"m", #"i", #"n",
      #"a", #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f"]
    (xml_options
      [([#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #"C", #"o", #"n", #"d",
          #"i", #"t", #"i", #"o", #"n", #"V", #"i", #"o", #"l", #"a", #"t",
          #"e", #"d"],
         xml0elements
           [#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #"C", #"o", #"n",
             #"d", #"i", #"t", #"i", #"o", #"n", #"V", #"i", #"o", #"l", #"a",
             #"t", #"e", #"d"]
           TRS_Not_Well_Formed),
        ([#"l", #"o", #"o", #"p"],
          xml_change (loop xml2name)
            (fn (s, (rseq, (a, b))) =>
              TRS_Loop
                (s, mapa (fn (xa, (y, (_, z))) => (xa, (y, z))) rseq, a, b))),
        ([#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"],
          xml2elements
            [#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_disproof xml2name)
            (fn a => fn b => TRS_Rule_Removal (a, b))),
        ([#"d", #"p", #"T", #"r", #"a", #"n", #"s"],
          xml3elements [#"d", #"p", #"T", #"r", #"a", #"n", #"s"]
            (xml1element [#"d", #"p", #"s"] (rules xml2name) id)
            (boola
              [#"m", #"a", #"r", #"k", #"e", #"d", #"S", #"y", #"m", #"b", #"o",
                #"l", #"s"])
            (xml2dp_disproof xml2name)
            (fn p => fn _ => (fn a => TRS_DP_Trans (p, a)))),
        ([#"s", #"t", #"r", #"i", #"n", #"g", #"R", #"e", #"v", #"e", #"r",
           #"s", #"a", #"l"],
          xml2elements
            [#"s", #"t", #"r", #"i", #"n", #"g", #"R", #"e", #"v", #"e", #"r",
              #"s", #"a", #"l"]
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2trs_disproof xml2name) (fn _ => TRS_String_Reversal))])
    id x;

fun xml2reltrs_disproof xml2name x =
  xml1element
    [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"N", #"o", #"n", #"t",
      #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r",
      #"o", #"o", #"f"]
    (xml_options
      [([#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #"C", #"o", #"n", #"d",
          #"i", #"t", #"i", #"o", #"n", #"V", #"i", #"o", #"l", #"a", #"t",
          #"e", #"d"],
         xml0elements
           [#"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #"C", #"o", #"n",
             #"d", #"i", #"t", #"i", #"o", #"n", #"V", #"i", #"o", #"l", #"a",
             #"t", #"e", #"d"]
           Rel_Not_Well_Formed),
        ([#"l", #"o", #"o", #"p"],
          xml_change (loop xml2name)
            (fn (s, (rseq, (a, b))) => Rel_Loop (s, rseq, a, b))),
        ([#"t", #"r", #"s", #"N", #"o", #"n", #"t", #"e", #"r", #"m", #"i",
           #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f"],
          xml_change (xml2trs_disproof xml2name) Rel_R_Not_SN),
        ([#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"],
          xml3elements
            [#"r", #"u", #"l", #"e", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml1element [#"t", #"r", #"s"] (rules xml2name) id)
            (xml2reltrs_disproof xml2name)
            (fn a => fn b => fn c => Rel_Rule_Removal (a, b, c)))])
    id x;

fun xml2cert_problem A_ xml2uname xml2name (Xml (name, egal, cs, texta)) =
  (if equal_lista equal_char name
        [#"c", #"e", #"r", #"t", #"i", #"f", #"i", #"c", #"a", #"t", #"i", #"o",
          #"n", #"P", #"r", #"o", #"b", #"l", #"e", #"m"] andalso
        (is_none texta andalso
          less_eq_nat (nat (3 : IntInf.int)) (size_list cs))
    then bindb (xml2input xml2name (nth cs Zero_nat))
           (fn inp =>
             bindb (text [#"c", #"p", #"f", #"V", #"e", #"r", #"s", #"i", #"o",
                           #"n"]
                     (nth cs one_nata))
               (fn _ =>
                 (case inp
                   of Inl (p, (q, r)) =>
                     xml1element [#"p", #"r", #"o", #"o", #"f"]
                       (xml_options
                         [([#"d", #"p", #"P", #"r", #"o", #"o", #"f"],
                            xml_change
                              (xml2dp_proof A_ (equal_list equal_nat) xml2name)
                              (fn a => DP_Proof (p, [], q, [], r, a))),
                           ([#"d", #"p", #"N", #"o", #"n", #"t", #"e", #"r",
                              #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n",
                              #"P", #"r", #"o", #"o", #"f"],
                             xml_change (xml2dp_disproof xml2name)
                               (fn a => DP_Disproof (p, q, r, a)))])
                       id (nth cs (nat (2 : IntInf.int)))
                   | Inr (q, (r, NONE)) =>
                     xml1element [#"p", #"r", #"o", #"o", #"f"]
                       (xml_options
                         [([#"t", #"r", #"s", #"T", #"e", #"r", #"m", #"i",
                             #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r",
                             #"o", #"o", #"f"],
                            xml_change (xml2trs_proof A_ xml2name)
                              (fn a => TRS_Proof (q, r, NONE, a))),
                           ([#"t", #"r", #"s", #"N", #"o", #"n", #"t", #"e",
                              #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o",
                              #"n", #"P", #"r", #"o", #"o", #"f"],
                             xml_change (xml2trs_disproof xml2name)
                               (fn a => TRS_Disproof (q, r, a)))])
                       id (nth cs (nat (2 : IntInf.int)))
                   | Inr (q, (r, SOME s)) =>
                     xml1element [#"p", #"r", #"o", #"o", #"f"]
                       (xml_options
                         [([#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e",
                             #"T", #"e", #"r", #"m", #"i", #"n", #"a", #"t",
                             #"i", #"o", #"n", #"P", #"r", #"o", #"o", #"f"],
                            xml_change (xml2reltrs_proof A_ xml2name)
                              (fn a => TRS_Proof (q, r, SOME s, a))),
                           ([#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e",
                              #"N", #"o", #"n", #"t", #"e", #"r", #"m", #"i",
                              #"n", #"a", #"t", #"i", #"o", #"n", #"P", #"r",
                              #"o", #"o", #"f"],
                             xml_change (xml2reltrs_disproof xml2name)
                               (fn a => Rel_TRS_Disproof (q, r, s, a)))])
                       id (nth cs (nat (2 : IntInf.int))))))
    else Inl ([#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"p",
                #"a", #"r", #"s", #"e", #" ", #"r", #"o", #"o", #"t", #" ",
                #"e", #"l", #"e", #"m", #"e", #"n", #"t", #" ", #"<"] @
               name @ [#">"]));

fun xml_cert_problem A_ B_ C_ (TRS_Proof (q, r, NONE, uu)) =
  Xml ([#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"], [],
        [xml_rules A_ B_ C_ [#"t", #"r", #"s"] r] @ xml_Q A_ B_ C_ q, NONE)
  | xml_cert_problem A_ B_ C_ (TRS_Proof (q, r, SOME s, uv)) =
    Xml ([#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"], [],
          xml_rules A_ B_ C_ [#"t", #"r", #"s"] r ::
            xml_Q A_ B_ C_ q @
              [xml_rules A_ B_ C_
                 [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"R", #"u",
                   #"l", #"e", #"s"]
                 s],
          NONE)
  | xml_cert_problem A_ B_ C_ (TRS_Disproof (q, r, uw)) =
    Xml ([#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"], [],
          [xml_rules A_ B_ C_ [#"t", #"r", #"s"] r] @ xml_Q A_ B_ C_ q, NONE)
  | xml_cert_problem A_ B_ C_ (Rel_TRS_Disproof (q, r, s, ux)) =
    Xml ([#"t", #"r", #"s", #"I", #"n", #"p", #"u", #"t"], [],
          xml_rules A_ B_ C_ [#"t", #"r", #"s"] r ::
            xml_Q A_ B_ C_ q @
              [xml_rules A_ B_ C_
                 [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #"R", #"u",
                   #"l", #"e", #"s"]
                 s],
          NONE)
  | xml_cert_problem A_ B_ C_ (DP_Proof (p, pw, q, r, rw, uy)) =
    Xml ([#"d", #"p", #"I", #"n", #"p", #"u", #"t"], [],
          xml_rules A_ B_ C_ [#"t", #"r", #"s"] rw ::
            xml_rules A_ B_ C_ [#"d", #"p", #"s"] p ::
              xml_Q A_ B_ C_ q @
                [Xml ([#"m", #"i", #"n", #"i", #"m", #"a", #"l"], [], [],
                       SOME [#"t", #"r", #"u", #"e"])],
          NONE)
  | xml_cert_problem A_ B_ C_ (DP_Disproof (p, q, r, uz)) =
    Xml ([#"d", #"p", #"I", #"n", #"p", #"u", #"t"], [],
          xml_rules A_ B_ C_ [#"t", #"r", #"s"] r ::
            xml_rules A_ B_ C_ [#"d", #"p", #"s"] p ::
              xml_Q A_ B_ C_ q @
                [Xml ([#"m", #"i", #"n", #"i", #"m", #"a", #"l"], [], [],
                       SOME [#"t", #"r", #"u", #"e"])],
          NONE);

fun xmldoc2cert_problem (Xmldoc (header, xml)) =
  debug [#"0"]
    [#"p", #"a", #"r", #"s", #"i", #"n", #"g", #" ", #"x", #"m", #"l", #" ",
      #"t", #"o", #" ", #"c", #"e", #"r", #"t", #"i", #"f", #"i", #"c", #"a",
      #"t", #"i", #"o", #"n", #" ", #"p", #"r", #"o", #"b", #"l", #"e", #"m"]
    (xml2cert_problem (equal_list equal_char) (text [#"n", #"a", #"m", #"e"])
      plain_name xml);

fun parse_cert_problem s = bindb (doc_of_string s) xmldoc2cert_problem;

datatype ('a, 'b) dpp =
  Dpp of
    ((('a, 'b) term * ('a, 'b) term) list *
      ((('a, 'b) term * ('a, 'b) term) list *
        (('a, 'b) term list *
          (bool *
            (bool *
              ((('a, 'b) term * ('a, 'b) term) list *
                ((('a, 'b) term * ('a, 'b) term) list *
                  ((('a * nat), ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                     rbt *
                    (('a * nat),
                      ((bool * (('a, 'b) term * ('a, 'b) term)) list))
                      rbt))))))));

fun extract_input_proof s =
  (case search_len s [#"<", #"i", #"n", #"p", #"u", #"t", #">"]
          (size_list [#"<", #"i", #"n", #"p", #"u", #"t", #">"])
    of NONE => NONE
    | SOME (_, minput) =>
      (case search_len minput [#"<", #"/", #"i", #"n", #"p", #"u", #"t", #">"]
              (size_list [#"<", #"/", #"i", #"n", #"p", #"u", #"t", #">"])
        of NONE => NONE
        | SOME (the_input, sa) =>
          (case search_len sa [#"<", #"p", #"r", #"o", #"o", #"f", #">"]
                  (size_list [#"<", #"p", #"r", #"o", #"o", #"f", #">"])
            of NONE => NONE
            | SOME (version, prf) => SOME (the_input, (version, prf)))));

fun shows_terms funa var name ts =
  shows_string name o
    (shows_nl o
      (shows_list_gen (shows_term funa var) [] [] [newline] [] ts o shows_nl));

fun shows_dpp funa var i d =
  let
    val p = pa i d;
    val pw = pwa i d;
    val r = rc i d;
    val rw = rwc i d;
    val q = qc i d;
  in
    shows_trs funa var [#" ", #"-", #">", #" "]
      [#"p", #"a", #"i", #"r", #"s", #":"] p o
      ((if null pw then id
         else shows_trs funa var [#" ", #"-", #">", #"=", #" "]
                [#"w", #"e", #"a", #"k", #" ", #"p", #"a", #"i", #"r", #"s",
                  #":"]
                pw) o
        ((if null r then id
           else shows_trs funa var [#" ", #"-", #">", #"!", #" "]
                  [#"s", #"t", #"r", #"i", #"c", #"t", #" ", #"r", #"u", #"l",
                    #"e", #"s", #":"]
                  r) o
          (shows_trs funa var [#" ", #"-", #">", #" "]
             [#"r", #"u", #"l", #"e", #"s", #":"] rw o
            (if null q then id
              else shows_terms funa var
                     [#"Q", #"-", #"c", #"o", #"m", #"p", #"o", #"n", #"e",
                       #"n", #"t", #":"]
                     q))))
  end;

fun uncurry_top_rules A_ a n sm =
  mapa (fn (l, r) => (uncurry_top A_ a n sm l, uncurry_top A_ a n sm r));

fun eta_closed_top_rules (A1_, A2_) (B1_, B2_) a n sm r p =
  catch (forallm
          (fn (l, ra) =>
            (case l of Var _ => Inr ()
              | Fun (ff, ls) =>
                check (equal_nata (aarity sm ff (size_list ls)) Zero_nat orelse
                        list_ex
                          (fn (lll, rrr) =>
                            (case (lll, rrr) of (Var _, b) => false
                              | (Fun (f, []), b) => false
                              | (Fun (f, ll :: yy), Var _) => false
                              | (Fun (f, ll :: yy), Fun (g, [])) => false
                              | (Fun (f, ll :: yy), Fun (g, rr :: zz)) =>
                                eq A1_ f a andalso
                                  (eq A1_ g a andalso
                                    (equal_lista (equal_term A1_ B1_) zz
                                       yy andalso
                                      (equal_nata (size_list yy)
 (minus_nat n one_nata) andalso
(distinct (equal_term A1_ B1_) yy andalso
  (list_all is_var yy andalso
    (null (list_inter B1_ (mapa the_var yy)
            (vars_rule_list B1_ (ll, rr))) andalso
      instance_rule A1_ B1_ (l, ra) (ll, rr)))))))))
                          p)
                  (shows_prec_list show_char Zero_nat
                     [#"e", #"t", #"a", #" ", #"e", #"x", #"p", #"a", #"n",
                       #"s", #"i", #"o", #"n", #" ", #"o", #"f", #" "] o
                    (shows_rule (shows_prec A2_ Zero_nat)
                       (shows_prec B2_ Zero_nat) [#" ", #"-", #">", #" "]
                       (l, ra) o
                      shows_prec_list show_char Zero_nat
                        [#" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"]))))
          r)
    (fn x => Inl (snd x));

fun uncurry_of_top_sig_list a m sml sm =
  maps (fn (b, c) =>
         let
           val (f, n) = b;
         in
           (fn _ =>
             let
               val g = get_symbol sm f n;
             in
               mapa (fn i =>
                      (Fun (a, generate_f_xs (g i) (plus_nata n i) ::
                                 mapa (fn ia => Var (generate_var ia))
                                   (upt (plus_nata n i)
                                     (plus_nata (plus_nata n i)
                                       (minus_nat m one_nata)))),
                        generate_f_xs (g (Suc i))
                          (plus_nata (plus_nata n i) (minus_nat m one_nata))))
                 (upt Zero_nat (aarity sm f n))
             end)
         end
           c)
    sml;

fun uncurry_top_proc (B1_, B2_) i info n fmap check_inj p r dpp =
  let
    val (a, (sml, (u, eb))) = info;
    val paa = pa i dpp;
    val pw = pwa i dpp;
    val ra = rc i dpp;
    val rw = rwc i dpp;
    val (e, ew) = uncurry_eta_split B1_ (equal_list equal_char) eb ra;
    val sm = sig_list_to_sig_map B1_ a sml fmap;
    val p_eta = e @ paa;
    val pw_eta = ew @ pw;
    val uP = uncurry_top_rules B1_ a n sm p_eta;
    val uPw = uncurry_top_rules B1_ a n sm pw_eta;
    val uR = map_rules_wa (fn f => fn na => get_symbol sm f na Zero_nat) ra;
    val uRw = map_rules_wa (fn f => fn na => get_symbol sm f na Zero_nat) rw;
  in
    (case bindb (check (null (qc i dpp))
                  (shows_prec_list show_char Zero_nat
                    [#"s", #"t", #"r", #"a", #"t", #"e", #"g", #"y", #" ", #"c",
                      #"u", #"r", #"r", #"e", #"n", #"t", #"l", #"y", #" ",
                      #"u", #"n", #"s", #"u", #"p", #"p", #"o", #"r", #"t",
                      #"e", #"d"]))
            (fn _ =>
              bindb (check (not (equal_nata n Zero_nat))
                      (shows_prec_list show_char Zero_nat
                        [#"t", #"h", #"e", #" ", #"a", #"r", #"i", #"t", #"y",
                          #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"u",
                          #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #" ",
                          #"s", #"y", #"m", #"b", #"o", #"l", #" ", #"m", #"u",
                          #"s", #"t", #" ", #"b", #"e", #" ", #"a", #"t", #" ",
                          #"l", #"e", #"a", #"s", #"t", #" ", #"1"]))
                (fn _ =>
                  bindb (check_inj a n sml)
                    (fn _ =>
                      let
                        val pb = pairsa i dpp;
                        val is_def =
                          (fn fna => not (null (rules_mapb i dpp fna)));
                        val rm = rules_mapb i dpp;
                      in
                        bindb (catch
                                (forallm
                                  (fn (l, rb) =>
                                    bindb (check (hvf_top B1_ a n l)
    (shows_prec_list show_char Zero_nat
       [#"h", #"e", #"a", #"d", #" ", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
         #"e", #" ", #"i", #"n", #" ", #"l", #"h", #"s", #" "] o
      (shows_term (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
         l o
        shows_prec_list show_char Zero_nat
          [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l", #"o", #"w", #"e",
            #"d"])))
                                      (fn _ =>
check_no_var B2_ (show_list show_char) rb))
                                  (pw_eta @ p_eta))
                                (fn x => Inl (snd x)))
                          (fn _ =>
                            bindb (catch
                                    (forallm
                                      (fn (_, rb) =>
check (not (is_def (the (root rb), num_args rb)))
  (shows_prec_list show_char Zero_nat
     [#"r", #"o", #"o", #"t", #" ", #"o", #"f", #" "] o
    (shows_term (shows_prec B2_ Zero_nat) (shows_prec_list show_char Zero_nat)
       rb o
      shows_prec_list show_char Zero_nat
        [#" ", #"m", #"u", #"s", #"t", #" ", #"n", #"o", #"t", #" ", #"b", #"e",
          #" ", #"d", #"e", #"f", #"i", #"n", #"e", #"d"])))
                                      pb)
                                    (fn x => Inl (snd x)))
                              (fn _ =>
                                bindb (check (not (is_def (a, n)))
(shows_prec_list show_char Zero_nat
   [#"a", #"p", #"p", #"l", #"i", #"c", #"a", #"t", #"i", #"o", #"n", #" ",
     #"s", #"y", #"m", #"b", #"o", #"l", #" "] o
  (shows_prec B2_ Zero_nat a o
    shows_prec_list show_char Zero_nat
      [#" ", #"m", #"u", #"s", #"t", #" ", #"n", #"o", #"t", #" ", #"b", #"e",
        #" ", #"d", #"e", #"f", #"i", #"n", #"e", #"d", #" ", #"i", #"n", #" ",
        #"R"])))
                                  (fn _ =>
                                    bindb (if list_ex
        (fn (_, rb) =>
          eq B1_ (the (root rb)) a andalso
            (equal_nata (num_args rb) n andalso
              equal_gctxta B1_
                (capRM2 B1_ (equal_list equal_char) rm (hd (args rb))) GCHole))
        pb
    then bindb (catch
                 (check_CS_subseteq B1_ (equal_list equal_char)
                   (uncurry_of_top_sig_list a n sml sm) u)
                 (fn x =>
                   Inl (shows_prec_list show_char Zero_nat
                          [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"i", #"n",
                            #"g", #" ", #"p", #"a", #"i", #"r", #" "] o
                         (shows_rule (shows_prec B2_ Zero_nat)
                            (shows_prec_list show_char Zero_nat)
                            [#" ", #"-", #">", #" "] x o
                           (shows_prec_list show_char Zero_nat
                              [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s",
                                #"i", #"n", #"g", #" ", #"i", #"n"] o
                             (shows_nl o
                               shows_rules (shows_prec B2_ Zero_nat)
                                 (shows_prec_list show_char Zero_nat)
                                 [#" ", #"-", #">", #" "] u))))))
           (fn _ =>
             bindb (eta_closed_top_rules (B1_, B2_)
                     (equal_list equal_char, show_list show_char) a n sm ra
                     p_eta)
               (fn _ =>
                 eta_closed_top_rules (B1_, B2_)
                   (equal_list equal_char, show_list show_char) a n sm rw
                   pw_eta))
    else Inr ())
                                      (fn _ =>
bindb (catch
        (check_subseteq
          (equal_prod (equal_term B1_ (equal_list equal_char))
            (equal_term B1_ (equal_list equal_char)))
          uP p)
        (fn x =>
          Inl (shows_prec_list show_char Zero_nat
                 [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d", #" ",
                   #"p", #"a", #"i", #"r", #" "] o
                (shows_rule (shows_prec B2_ Zero_nat)
                   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "]
                   x o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
                      #"g"]))))
  (fn _ =>
    bindb (catch
            (check_subseteq
              (equal_prod (equal_term B1_ (equal_list equal_char))
                (equal_term B1_ (equal_list equal_char)))
              uPw p)
            (fn x =>
              Inl (shows_prec_list show_char Zero_nat
                     [#"u", #"n", #"c", #"u", #"r", #"r", #"i", #"e", #"d",
                       #" ", #"p", #"a", #"i", #"r", #" "] o
                    (shows_rule (shows_prec B2_ Zero_nat)
                       (shows_prec_list show_char Zero_nat)
                       [#" ", #"-", #">", #" "] x o
                      shows_prec_list show_char Zero_nat
                        [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i",
                          #"n", #"g"]))))
      (fn _ =>
        bindb (catch
                (check_subseteq
                  (equal_prod (equal_term B1_ (equal_list equal_char))
                    (equal_term B1_ (equal_list equal_char)))
                  u p)
                (fn x =>
                  Inl (shows_prec_list show_char Zero_nat
                         [#"u", #"n", #"c", #"u", #"r", #"r", #"y", #"i", #"n",
                           #"g", #" ", #"p", #"a", #"i", #"r", #" "] o
                        (shows_rule (shows_prec B2_ Zero_nat)
                           (shows_prec_list show_char Zero_nat)
                           [#" ", #"-", #">", #" "] x o
                          shows_prec_list show_char Zero_nat
                            [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s",
                              #"i", #"n", #"g", #" ", #"i", #"n", #" ", #"n",
                              #"e", #"w", #" ", #"p", #"a", #"i", #"r",
                              #"s"]))))
          (fn _ =>
            bindb (catch
                    (check_subseteq
                      (equal_prod (equal_term B1_ (equal_list equal_char))
                        (equal_term B1_ (equal_list equal_char)))
                      uR r)
                    (fn x =>
                      Inl (shows_prec_list show_char Zero_nat
                             [#"r", #"u", #"l", #"e", #" "] o
                            (shows_rule (shows_prec B2_ Zero_nat)
                               (shows_prec_list show_char Zero_nat)
                               [#" ", #"-", #">", #" "] x o
                              shows_prec_list show_char Zero_nat
                                [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s",
                                  #"i", #"n", #"g", #" ", #"i", #"n", #" ",
                                  #"n", #"e", #"w", #" ", #"r", #"u", #"l",
                                  #"e", #"s"]))))
              (fn _ =>
                catch (check_subseteq
                        (equal_prod (equal_term B1_ (equal_list equal_char))
                          (equal_term B1_ (equal_list equal_char)))
                        uRw r)
                  (fn x =>
                    Inl (shows_prec_list show_char Zero_nat
                           [#"r", #"u", #"l", #"e", #" "] o
                          (shows_rule (shows_prec B2_ Zero_nat)
                             (shows_prec_list show_char Zero_nat)
                             [#" ", #"-", #">", #" "] x o
                            shows_prec_list show_char Zero_nat
                              [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s",
                                #"i", #"n", #"g", #" ", #"i", #"n", #" ", #"n",
                                #"e", #"w", #" ", #"r", #"u", #"l", #"e",
                                #"s"])))))))))))
                      end)))
      of Inl aa => Inl aa | Inr _ => Inr (mkc i uP (uPw @ u) [] uR uRw))
  end;

fun uncurry_proc_both (B1_, B2_) (C1_, C2_) i NONE (a, (sml, (u, eb))) =
  uncurry_proc (equal_lab B1_ C1_, show_lab B2_ C2_) i (a, (sml, (u, eb)))
    (fmap B1_ C1_ a (nat (2 : IntInf.int))) (check_inj (B1_, B2_) (C1_, C2_))
  | uncurry_proc_both (B1_, B2_) (C1_, C2_) i (SOME n) (a, (sml, (u, eb))) =
    uncurry_top_proc (equal_lab B1_ C1_, show_lab B2_ C2_) i (a, (sml, (u, eb)))
      n (fmap B1_ C1_ a n) (check_inj (B1_, B2_) (C1_, C2_));

fun check_dpp_subsumes (B1_, B2_) (C1_, C2_) (D1_, D2_) i
  (p, (pw, (q, (r, rw)))) d =
  catch let
          val paa = pa i d;
          val pwaa = pwa i d;
          val qa = qc i d;
          val ra = rc i d;
          val rwa = rwc i d;
          val pb = p @ pw;
          val rb = ra @ rwa;
          val rba = r @ rw;
        in
          bindb (catch
                  (check_subseteq
                    (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
                      (equal_term (equal_lab B1_ C1_) D1_))
                    paa p)
                  (fn x =>
                    Inl (toomuch [#"p", #"a", #"i", #"r"]
                          (shows_rule (shows_prec_lab B2_ C2_ Zero_nat)
                            (shows_prec D2_ Zero_nat) [#" ", #"-", #">", #" "]
                            x))))
            (fn _ =>
              bindb (catch
                      (check_subseteq
                        (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
                          (equal_term (equal_lab B1_ C1_) D1_))
                        pwaa pb)
                      (fn x =>
                        Inl (toomuch
                              [#"w", #"e", #"a", #"k", #" ", #"p", #"a", #"i",
                                #"r"]
                              (shows_rule (shows_prec_lab B2_ C2_ Zero_nat)
                                (shows_prec D2_ Zero_nat)
                                [#" ", #"-", #">", #" "] x))))
                (fn _ =>
                  bindb (catch
                          (check_subseteq (equal_term (equal_lab B1_ C1_) D1_)
                            qa q)
                          (fn x =>
                            Inl (toomuch [#"t", #"e", #"r", #"m"]
                                  (shows_term (shows_prec_lab B2_ C2_ Zero_nat)
                                    (shows_prec D2_ Zero_nat) x))))
                    (fn _ =>
                      bindb (catch
                              (check_subseteq
                                (equal_term (equal_lab B1_ C1_) D1_) q qa)
                              (fn x =>
                                Inl (missing [#"t", #"e", #"r", #"m"]
                                      (shows_term
(shows_prec_lab B2_ C2_ Zero_nat) (shows_prec D2_ Zero_nat) x))))
                        (fn _ =>
                          bindb (catch
                                  (check_subseteq
                                    (equal_prod
                                      (equal_term (equal_lab B1_ C1_) D1_)
                                      (equal_term (equal_lab B1_ C1_) D1_))
                                    ra r)
                                  (fn x =>
                                    Inl (toomuch
  [#"s", #"t", #"r", #"i", #"c", #"t", #" ", #"r", #"u", #"l", #"e"]
  (shows_rule (shows_prec_lab B2_ C2_ Zero_nat) (shows_prec D2_ Zero_nat)
    [#" ", #"-", #">", #" "] x))))
                            (fn _ =>
                              bindb (catch
                                      (check_subseteq
(equal_prod (equal_term (equal_lab B1_ C1_) D1_)
  (equal_term (equal_lab B1_ C1_) D1_))
rb rba)
                                      (fn x =>
Inl (toomuch
      [#"s", #"t", #"r", #"i", #"c", #"t", #"/", #"w", #"e", #"a", #"k", #" ",
        #"r", #"u", #"l", #"e"]
      (shows_rule (shows_prec_lab B2_ C2_ Zero_nat) (shows_prec D2_ Zero_nat)
        [#" ", #"-", #">", #" "] x))))
                                (fn _ =>
                                  bindb (catch
  (check_subseteq
    (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
      (equal_term (equal_lab B1_ C1_) D1_))
    rba rb)
  (fn x =>
    Inl (missing
          [#"s", #"t", #"r", #"i", #"c", #"t", #"/", #"w", #"e", #"a", #"k",
            #" ", #"r", #"u", #"l", #"e"]
          (shows_rule (shows_prec_lab B2_ C2_ Zero_nat)
            (shows_prec D2_ Zero_nat) [#" ", #"-", #">", #" "] x))))
                                    (fn _ => Inr ())))))))
        end
    (fn x =>
      Inl (shows_string
             [#"f", #"i", #"n", #"i", #"t", #"e", #"n", #"e", #"s", #"s", #" ",
               #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"p", #"r", #"o", #"b",
               #"l", #"e", #"m"] o
            (shows_nl o
              (shows_dpp (shows_prec_lab B2_ C2_ Zero_nat)
                 (shows_prec D2_ Zero_nat) i d o
                (shows_nl o
                  (shows_string
                     [#"m", #"a", #"y", #" ", #"n", #"o", #"t", #" ", #"b",
                       #"e", #" ", #"c", #"o", #"n", #"c", #"l", #"u", #"d",
                       #"e", #"d", #" ", #"f", #"r", #"o", #"m", #" ", #"a",
                       #"s", #"s", #"u", #"m", #"i", #"n", #"g", #" ", #"f",
                       #"i", #"n", #"i", #"t", #"e", #"n", #"e", #"s", #"s",
                       #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"p",
                       #"r", #"o", #"b", #"l", #"e", #"m"] o
                    (shows_nl o
                      (shows_dpp (shows_prec_lab B2_ C2_ Zero_nat)
                         (shows_prec D2_ Zero_nat) i (mkc i p pw q r rw) o
                        (shows_nl o (x o shows_nl))))))))));

fun rulesd
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = rules;

fun funas_args_term_list t = maps funas_term_lista (args t);

fun funas_args_rule_list r =
  funas_args_term_list (fst r) @ funas_args_term_list (snd r);

fun funas_args_trs_list A_ r =
  remdups (equal_prod A_ equal_nat) (maps funas_args_rule_list r);

fun check_flat_ctxt (A1_, A2_) (B1_, B2_) vs c =
  (case c
    of Hole =>
      Inl (shows_prec_ctxt B2_ A2_ Zero_nat c o
            (shows_string
               [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ",
                 #"f", #"l", #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e",
                 #"x", #"t"] o
              shows_nl))
    | More (_, ss1, Hole, ss2) =>
      let
        val ss = ss1 @ ss2;
      in
        bindb (check (distinct (equal_term B1_ A1_) ss)
                (shows_prec_ctxt B2_ A2_ Zero_nat c o
                  (shows_string
                     [#" ", #"c", #"o", #"n", #"t", #"a", #"i", #"n", #"s",
                       #" ", #"d", #"u", #"p", #"l", #"i", #"c", #"a", #"t",
                       #"e", #" ", #"v", #"a", #"r", #"i", #"a", #"b", #"l",
                       #"e", #"s"] o
                    shows_nl)))
          (fn _ =>
            bindb (check (list_all is_var ss)
                    (shows_prec_ctxt B2_ A2_ Zero_nat c o
                      (shows_string
                         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"f",
                           #"l", #"a", #"t", #",", #" ", #"i", #".", #"e", #".",
                           #",", #" ", #"h", #"a", #"s", #" ", #"d", #"e", #"p",
                           #"t", #"h", #" ", #"g", #"r", #"e", #"a", #"t", #"e",
                           #"r", #" ", #"t", #"h", #"a", #"n", #" ", #"o", #"n",
                           #"e"] o
                        shows_nl)))
              (fn _ =>
                check (list_all (fn t => not (membera A1_ vs (the_var t)))
                        (ss1 @ ss2))
                  (shows_prec_ctxt B2_ A2_ Zero_nat c o
                    (shows_string
                       [#" ", #"h", #"a", #"s", #" ", #"t", #"o", #" ", #"c",
                         #"o", #"n", #"t", #"a", #"i", #"n", #" ", #"o", #"n",
                         #"l", #"y", #" ", #"f", #"r", #"e", #"s", #"h", #" ",
                         #"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e", #"s"] o
                      shows_nl))))
      end
    | More (_, ss1, More (_, _, _, _), ss2) =>
      Inl (shows_prec_ctxt B2_ A2_ Zero_nat c o
            (shows_string
               [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ",
                 #"f", #"l", #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e",
                 #"x", #"t"] o
              shows_nl)));

fun is_flat_ctxt_list A_ B_ vs fas (More (f, ss1, Hole, ss2)) =
  let
    val ss = ss1 @ ss2;
  in
    membera (equal_prod B_ equal_nat) fas (f, Suc (size_list ss)) andalso
      (list_all is_var ss andalso
        (distinct (equal_term B_ A_) ss andalso
          null (list_inter A_ (mapa the_var ss) vs)))
  end
  | is_flat_ctxt_list A_ B_ vs fas Hole = false
  | is_flat_ctxt_list A_ B_ vs fas (More (v, va, More (vd, ve, vf, vg), vc)) =
    false;

fun check_is_flat_ctxt (A1_, A2_) (B1_, B2_) vs fas c =
  check (is_flat_ctxt_list A1_ B1_ vs fas c)
    (shows_prec_ctxt B2_ A2_ Zero_nat c o
      (shows_string
         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ", #"f",
           #"l", #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e", #"x", #"t"] o
        shows_nl));

fun check_rule_preserving (A1_, A2_) (B1_, B2_) fcs rs rule =
  check (membera (equal_prod (equal_term A1_ B1_) (equal_term A1_ B1_)) rs
           rule orelse
          list_all
            (fn c =>
              membera (equal_prod (equal_term A1_ B1_) (equal_term A1_ B1_)) rs
                (ctxt_apply c (fst rule), ctxt_apply c (snd rule)))
            fcs)
    (shows_string [#"t", #"h", #"e", #" ", #"r", #"u", #"l", #"e", #" "] o
      (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
         [#" ", #"-", #">", #" "] rule o
        (shows_string
           [#" ", #"i", #"s", #" ", #"n", #"e", #"i", #"t", #"h", #"e", #"r",
             #" ", #"c", #"o", #"n", #"t", #"a", #"i", #"n", #"e", #"d", #" ",
             #"i", #"n", #" ", #"t", #"h", #"e", #" ", #"r", #"e", #"s", #"u",
             #"l", #"t", #"i", #"n", #"g", #" ", #"s", #"e", #"t", #" ", #"o",
             #"f", #" ", #"r", #"u", #"l", #"e", #"s", #" ", #"n", #"o", #"r",
             #" ", #"c", #"l", #"o", #"s", #"e", #"d", #" ", #"u", #"n", #"d",
             #"e", #"r", #" ", #"a", #"l", #"l", #" ", #"f", #"l", #"a", #"t",
             #" ", #"c", #"o", #"n", #"t", #"e", #"x", #"t", #"s"] o
          shows_nl)));

fun check_rule_reflecting (A1_, A2_) (B1_, B2_) fcs rs rule =
  check (list_ex
          (fn (l, r) =>
            list_ex
              (fn c =>
                equal_terma A1_ B1_ (fst rule) (ctxt_apply c l) andalso
                  equal_terma A1_ B1_ (snd rule) (ctxt_apply c r))
              (Hole :: fcs))
          rs)
    (shows_string [#"t", #"h", #"e", #" ", #"r", #"u", #"l", #"e", #" "] o
      (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
         [#" ", #"-", #">", #" "] rule o
        (shows_string
           [#" ", #"i", #"s", #" ", #"n", #"e", #"i", #"t", #"h", #"e", #"r",
             #" ", #"c", #"o", #"n", #"t", #"a", #"i", #"n", #"e", #"d", #" ",
             #"i", #"n", #" ", #"t", #"h", #"e", #" ", #"o", #"r", #"i", #"g",
             #"i", #"n", #"a", #"l", #" ", #"s", #"e", #"t", #" ", #"o", #"f",
             #" ", #"r", #"u", #"l", #"e", #"s", #" ", #"n", #"o", #"r", #" ",
             #"o", #"b", #"t", #"a", #"i", #"n", #"e", #"d", #" ", #"b", #"y",
             #" ", #"a", #"p", #"p", #"l", #"y", #"i", #"n", #"g", #" ", #"a",
             #" ", #"f", #"l", #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e",
             #"x", #"t"] o
          shows_nl)));

fun hole_at A_ n i f (More (g, ss1, Hole, ss2)) =
  eq A_ g f andalso
    (equal_nata (size_list ss1) i andalso
      equal_nata (size_list ss2) (minus_nat (minus_nat n i) one_nata))
  | hole_at A_ n i f Hole = false
  | hole_at A_ n i f (More (v, va, More (vd, ve, vf, vg), vc)) = false;

fun check_flat_ctxt_complete (A1_, A2_) B_ fcs fa =
  check (all_interval_nat
          (fn i => list_ex (hole_at A1_ (snd fa) i (fst fa)) fcs) Zero_nat
          (snd fa))
    (shows_string
       [#"t", #"h", #"e", #" ", #"l", #"i", #"s", #"t", #" ", #"o", #"f", #" ",
         #"f", #"l", #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e", #"x", #"t",
         #"s", #" ", #"i", #"s", #" ", #"i", #"n", #"c", #"o", #"m", #"p", #"l",
         #"e", #"t", #"e"] o
      shows_nl);

fun block_term f (Var x) = Var x
  | block_term f (Fun (g, ts)) = Fun (g, mapa (fn t => Fun (f, [t])) ts);

fun block_rule f r = (block_term f (fst r), block_term f (snd r));

fun check_superset_of_blocked (A1_, A2_) (B1_, B2_) f pa p =
  catch (catch
          (catch
            (forallm
              (fn x =>
                (if membera
                      (equal_prod (equal_term A1_ B1_) (equal_term A1_ B1_)) pa
                      (block_rule f x)
                  then Inr () else Inl x))
              p)
            (fn x => Inl (snd x)))
          (fn x =>
            Inl (shows_string
                   [#"t", #"h", #"e", #" ", #"r", #"u", #"l", #"e", #" "] o
                  (shows_rule (shows_prec A2_ Zero_nat)
                     (shows_prec B2_ Zero_nat) [#" ", #"-", #">", #" "]
                     (block_rule f x) o
                    (shows_string
                       [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i",
                         #"n", #"g"] o
                      shows_nl)))))
    (fn x =>
      Inl (shows_trs (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
             [#" ", #"-", #">", #" "]
             [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s", #"y", #"s",
               #"t", #"e", #"m", #":"]
             p o
            (shows_string
               [#"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ", #"s",
                 #"u", #"b", #"s", #"e", #"t", #" ", #"o", #"f"] o
              (shows_trs (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
                 [#" ", #"-", #">", #" "]
                 [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s", #"y",
                   #"s", #"t", #"e", #"m", #":"]
                 pa o
                (x o shows_nl)))));

fun check_no_defined_root_defs (A1_, A2_) B_ f t =
  check (not (membera (equal_prod A1_ equal_nat) f (the (root t), num_args t)))
    (shows_string
       [#"t", #"h", #"e", #" ", #"r", #"o", #"o", #"t", #" ", #"o", #"f",
         #" "] o
      (shows_prec_term A2_ B_ Zero_nat t o
        shows_string
          [#" ", #"i", #"s", #" ", #"d", #"e", #"f", #"i", #"n", #"e", #"d"]));

fun fcc_proc (B1_, B2_) (C1_, C2_) i f fcs p pw r dpp =
  (case let
          val paa = pa i dpp;
          val pwaa = pwa i dpp;
          val pb =
            list_union (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_))
              paa pwaa;
          val q = qc i dpp;
          val rs = rc i dpp;
          val ra = rwc i dpp;
          val fa = (f, one_nata);
          val cf = More (f, [], Hole, []);
          val fcsa = cf :: fcs;
          val vs = vars_trs_list C1_ ra;
          val fs =
            list_union (equal_prod B1_ equal_nat) (funas_trs_list B1_ ra)
              (funas_args_trs_list B1_ pb);
          val fas = fa :: fs;
          val ds = defs_list B1_ ra;
        in
          bindb (check (null q)
                  (shows_string
                     [#"Q", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ",
                       #"e", #"m", #"p", #"t", #"y"] o
                    shows_nl))
            (fn _ =>
              bindb (check (null rs)
                      (shows_string
                         [#"t", #"h", #"e", #" ", #"s", #"t", #"r", #"i", #"c",
                           #"t", #" ", #"r", #"u", #"l", #"e", #"s", #" ", #"a",
                           #"r", #"e", #" ", #"n", #"o", #"t", #" ", #"e", #"m",
                           #"p", #"t", #"y"] o
                        shows_nl))
                (fn _ =>
                  bindb (check (not (membera (equal_prod B1_ equal_nat) ds fa))
                          (shows_prec B2_ Zero_nat f o
                            (shows_string
                               [#"i", #"s", #" ", #"n", #"o", #"t", #" ", #"f",
                                 #"r", #"e", #"s", #"h"] o
                              shows_nl)))
                    (fn _ =>
                      bindb (check_left_linear_trs B2_ (C1_, C2_) ra)
                        (fn _ =>
                          bindb (check_wf_trs B2_ (C1_, C2_) ra)
                            (fn _ =>
                              bindb (catch
                                      (forallm
(fn rb =>
  bindb (check_no_var B2_ C2_ (fst rb))
    (fn _ =>
      bindb (check_no_var B2_ C2_ (snd rb))
        (fn _ => check_no_defined_root_defs (B1_, B2_) C2_ ds (snd rb))))
pb)
                                      (fn x => Inl (snd x)))
                                (fn _ =>
                                  bindb (catch
  (forallm (check_flat_ctxt (C1_, C2_) (B1_, B2_) vs) fcsa)
  (fn x => Inl (snd x)))
                                    (fn _ =>
                                      bindb
(catch (forallm (check_is_flat_ctxt (C1_, C2_) (B1_, B2_) vs fas) fcsa)
  (fn x => Inl (snd x)))
(fn _ =>
  bindb (catch (forallm (check_flat_ctxt_complete (B1_, B2_) C2_ fcsa) fas)
          (fn x => Inl (snd x)))
    (fn _ =>
      bindb (catch
              (forallm (check_rule_preserving (B1_, B2_) (C1_, C2_) fcsa r) ra)
              (fn x => Inl (snd x)))
        (fn _ =>
          bindb (catch
                  (forallm (check_rule_reflecting (B1_, B2_) (C1_, C2_) fcsa ra)
                    r)
                  (fn x => Inl (snd x)))
            (fn _ =>
              bindb (check_superset_of_blocked (B1_, B2_) (C1_, C2_) f p paa)
                (fn _ =>
                  check_superset_of_blocked (B1_, B2_) (C1_, C2_) f pw
                    pwaa))))))))))))
        end
    of Inl a => Inl a | Inr _ => Inr (mkc i p pw [] [] r));

fun redtriple_proc B_ C_ i rp premove dpp =
  (case catch let
                val (ps, pns) = split_pairsa i dpp premove;
                val r = rulesd i dpp;
              in
                bindb (valid rp)
                  (fn _ =>
                    bindb (catch
                            (catch (forallm (ns rp) r) (fn x => Inl (snd x)))
                            (fn x =>
                              Inl (shows_string
                                     [#"p", #"r", #"o", #"b", #"l", #"e", #"m",
                                       #" ", #"w", #"h", #"e", #"n", #" ", #"o",
                                       #"r", #"i", #"e", #"n", #"t", #"i", #"n",
                                       #"g", #" ", #"T", #"R", #"S"] o
                                    (shows_nl o x))))
                      (fn _ =>
                        bindb (catch
                                (catch (forallm (nst rp) pns)
                                  (fn x => Inl (snd x)))
                                (fn x =>
                                  Inl (shows_string
 [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n", #" ",
   #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D", #"P",
   #"s"] o
(shows_nl o x))))
                          (fn _ =>
                            catch (catch (forallm (s rp) ps)
                                    (fn x => Inl (snd x)))
                              (fn x =>
                                Inl (shows_string
                                       [#"p", #"r", #"o", #"b", #"l", #"e",
 #"m", #" ", #"w", #"h", #"e", #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t",
 #"i", #"n", #"g", #" ", #"D", #"P", #"s"] o
                                      (shows_nl o x))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desc rp o (shows_nl o x)))))
    of Inl a => Inl a | Inr _ => Inr (delete_P_Pwa i dpp premove premove));

fun mono_redpair_proc B_ C_ i rp premove rremove dpp =
  (case catch let
                val (ps, pns) = split_pairsa i dpp premove;
                val (rs, rns) = split_rulesc i dpp rremove;
              in
                bindb (valid rp)
                  (fn _ =>
                    bindb (catch (mono rp)
                            (fn x =>
                              Inl (shows_string
                                     [#"p", #"r", #"o", #"b", #"l", #"e", #"m",
                                       #" ", #"w", #"i", #"t", #"h", #" ", #"m",
                                       #"o", #"n", #"o", #"t", #"o", #"n", #"i",
                                       #"c", #"i", #"t", #"y", #" ", #"o", #"f",
                                       #" ", #"s", #"t", #"r", #"i", #"c", #"t",
                                       #" ", #"o", #"r", #"d", #"e", #"r"] o
                                    (shows_nl o x))))
                      (fn _ =>
                        bindb (catch
                                (catch (forallm (ns rp) rns)
                                  (fn x => Inl (snd x)))
                                (fn x =>
                                  Inl (shows_string
 [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n", #" ",
   #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"T", #"R",
   #"S"] o
(shows_nl o x))))
                          (fn _ =>
                            bindb (catch
                                    (catch (forallm (s rp) rs)
                                      (fn x => Inl (snd x)))
                                    (fn x =>
                                      Inl
(shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"T",
     #"R", #"S"] o
  (shows_nl o x))))
                              (fn _ =>
                                bindb (catch
(catch (forallm (ns rp) pns) (fn x => Inl (snd x)))
(fn x =>
  Inl (shows_string
         [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
           #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g",
           #" ", #"D", #"P", #"s"] o
        (shows_nl o x))))
                                  (fn _ =>
                                    catch (catch (forallm (s rp) ps)
    (fn x => Inl (snd x)))
                                      (fn x =>
Inl (shows_string
       [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
         #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D",
         #"P", #"s"] o
      (shows_nl o x))))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desc rp o (shows_nl o x)))))
    of Inl a => Inl a
    | Inr _ =>
      Inr (delete_R_Rwc i (delete_P_Pwa i dpp premove premove) rremove
            rremove));

fun create_rseq_map A_ B_ rseqs r =
  lookupa (equal_prod (equal_term A_ B_) (equal_term A_ B_)) r rseqs;

fun matchCapRMBelow A_ B_ rm l (Fun (f, ts)) =
  matchb A_ B_ (GCFun (f, mapa (capRM2 A_ B_ rm) ts)) l;

fun check_ur_closed_term_rm_af (A1_, A2_) (B1_, B2_) uu uv uw (Var x) = Inr ()
  | check_ur_closed_term_rm_af (A1_, A2_) (B1_, B2_) rm ur pi (Fun (f, ts)) =
    let
      val n = size_list ts;
      val pia = pi f n;
    in
      bindb (catch
              (forallm_index
                (fn t => fn i =>
                  (if pia i
                    then check_ur_closed_term_rm_af (A1_, A2_) (B1_, B2_) rm ur
                           pi t
                    else Inr ()))
                ts)
              (fn x => Inl (snd x)))
        (fn _ =>
          catch (forallm
                  (fn lr =>
                    check (membera
                             (equal_prod (equal_term A1_ B1_)
                               (equal_term A1_ B1_))
                             ur lr orelse
                            not (matchCapRMBelow A1_ B1_ rm (fst lr)
                                  (Fun (f, ts))))
                      (shows_string
                         [#"d", #"u", #"e", #" ", #"t", #"o", #" ", #"t", #"h",
                           #"e", #" ", #"s", #"u", #"b", #"t", #"e", #"r", #"m",
                           #" "] o
                        (shows_prec_term A2_ B2_ Zero_nat (Fun (f, ts)) o
                          (shows_string
                             [#" ", #"o", #"f", #" ", #"s", #"o", #"m", #"e",
                               #" ", #"u", #"s", #"a", #"b", #"l", #"e", #" ",
                               #"r", #"h", #"s", #",", #" ", #"r", #"u", #"l",
                               #"e", #" "] o
                            (shows_rule (shows_prec A2_ Zero_nat)
                               (shows_prec B2_ Zero_nat)
                               [#" ", #"-", #">", #" "] lr o
                              shows_string
                                [#" ", #"s", #"h", #"o", #"u", #"l", #"d", #" ",
                                  #"b", #"e", #" ", #"u", #"s", #"a", #"b",
                                  #"l", #"e", #"."])))))
                  (rm (f, n)))
            (fn x => Inl (snd x)))
    end;

fun check_ur_P_closed_rm_af (A1_, A2_) (B1_, B2_) rm ur p pi =
  bindb (catch
          (catch
            (forallm
              (fn lr =>
                check_ur_closed_term_rm_af (A1_, A2_) (B1_, B2_) rm ur pi
                  (snd lr))
              ur)
            (fn x => Inl (snd x)))
          (fn x =>
            Inl (shows_string
                   [#"e", #"r", #"r", #"o", #"r", #" ", #"w", #"h", #"e", #"n",
                     #" ", #"c", #"h", #"e", #"c", #"k", #"i", #"n", #"g", #" ",
                     #"c", #"l", #"o", #"s", #"u", #"r", #"e", #" ", #"p", #"r",
                     #"o", #"p", #"e", #"r", #"t", #"i", #"e", #"s", #" ", #"o",
                     #"f", #" ", #"r", #"h", #"s", #" ", #"o", #"f", #" ", #"u",
                     #"s", #"a", #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e",
                     #"s"] o
                  (shows_nl o x))))
    (fn _ =>
      catch (catch
              (forallm
                (fn st =>
                  check_ur_closed_term_rm_af (A1_, A2_) (B1_, B2_) rm ur pi
                    (snd st))
                p)
              (fn x => Inl (snd x)))
        (fn x =>
          Inl (shows_string
                 [#"e", #"r", #"r", #"o", #"r", #" ", #"w", #"h", #"e", #"n",
                   #" ", #"c", #"h", #"e", #"c", #"k", #"i", #"n", #"g", #" ",
                   #"c", #"l", #"o", #"s", #"u", #"r", #"e", #" ", #"p", #"r",
                   #"o", #"p", #"e", #"r", #"t", #"i", #"e", #"s", #" ", #"o",
                   #"f", #" ", #"r", #"h", #"s", #" ", #"o", #"f", #" ", #"D",
                   #"P", #"s"] o
                (shows_nl o x))));

fun mono_ur_redpair_proc (B1_, B2_) (C1_, C2_) i rp premove rremove ur dpp =
  (case catch let
                val p = pairsa i dpp;
                val us = maps (funas_term_list B1_ o snd) (p @ ur);
                val filt =
                  (fn lr =>
                    list_all (membera (equal_prod B1_ equal_nat) us)
                      (funas_term_list B1_ (fst lr)));
                val (pms, pns) = split_pairsa i dpp premove;
                val (ps, pnwf) = partition filt pms;
                val (urms, urns) =
                  partition
                    (membera
                      (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_))
                      rremove)
                    ur;
                val (urs, urnwf) = partition filt urms;
                val rm = rules_mapb i dpp;
              in
                bindb (valid rp)
                  (fn _ =>
                    bindb (mono rp)
                      (fn _ =>
                        bindb (check_ur_P_closed_rm_af (B1_, B2_) (C1_, C2_) rm
                                ur p full_af)
                          (fn _ =>
                            bindb (catch
                                    (catch (forallm (ns rp) (urns @ urnwf))
                                      (fn x => Inl (snd x)))
                                    (fn x =>
                                      Inl
(shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"u",
     #"s", #"a", #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e", #"s"] o
  (shows_nl o x))))
                              (fn _ =>
                                bindb (catch
(catch (forallm (s rp) urs) (fn x => Inl (snd x)))
(fn x =>
  Inl (shows_string
         [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
           #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g",
           #" ", #"u", #"s", #"a", #"b", #"l", #"e", #" ", #"r", #"u", #"l",
           #"e", #"s"] o
        (shows_nl o x))))
                                  (fn _ =>
                                    bindb (catch
    (catch (forallm (ns rp) (pns @ pnwf)) (fn x => Inl (snd x)))
    (fn x =>
      Inl (shows_string
             [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
               #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g",
               #" ", #"D", #"P", #"s"] o
            (shows_nl o x))))
                                      (fn _ =>
catch (catch (forallm (s rp) ps) (fn x => Inl (snd x)))
  (fn x =>
    Inl (shows_string
           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
             #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g",
             #" ", #"D", #"P", #"s"] o
          (shows_nl o x)))))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desc rp o (shows_nl o x)))))
    of Inl a => Inl a
    | Inr _ =>
      Inr (delete_R_Rwc i (delete_P_Pwa i dpp premove premove) rremove
            rremove));

fun ur_af_redtriple_proc (B1_, B2_) (C1_, C2_) i rp premove ur dpp =
  (case catch let
                val (ps, pns) = split_pairsa i dpp premove;
                val p = pairsa i dpp;
                val rm = rules_mapb i dpp;
              in
                bindb (valid rp)
                  (fn _ =>
                    bindb (check_ur_P_closed_rm_af (B1_, B2_) (C1_, C2_) rm ur p
                            (af rp))
                      (fn _ =>
                        bindb (catch
                                (catch (forallm (ns rp) ur)
                                  (fn x => Inl (snd x)))
                                (fn x =>
                                  Inl (shows_string
 [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n", #" ",
   #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"u", #"s", #"a",
   #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e", #"s"] o
(shows_nl o x))))
                          (fn _ =>
                            bindb (catch
                                    (catch (forallm (nst rp) pns)
                                      (fn x => Inl (snd x)))
                                    (fn x =>
                                      Inl
(shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D",
     #"P", #"s"] o
  (shows_nl o x))))
                              (fn _ =>
                                catch (catch (forallm (s rp) ps)
(fn x => Inl (snd x)))
                                  (fn x =>
                                    Inl (shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D",
     #"P", #"s"] o
  (shows_nl o x)))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desc rp o (shows_nl o x)))))
    of Inl a => Inl a | Inr _ => Inr (delete_P_Pwa i dpp premove premove));

fun check_no_defined_root A_ B_ isdef t =
  check (not (isdef (the (root t), num_args t)))
    (shows_string
       [#"t", #"h", #"e", #" ", #"r", #"o", #"o", #"t", #" ", #"o", #"f",
         #" "] o
      (shows_prec_term A_ B_ Zero_nat t o
        shows_string
          [#" ", #"i", #"s", #" ", #"d", #"e", #"f", #"i", #"n", #"e", #"d"]));

fun root_redtriple_proc B_ C_ i rp premove dpp =
  (case catch let
                val (ps, pns) = split_pairsa i dpp premove;
                val r = rulesd i dpp;
              in
                bindb (catch
                        (forallm
                          (fn (_, ra) =>
                            bindb (check_no_var B_ C_ ra)
                              (fn _ =>
                                check_no_defined_root B_ C_
                                  (fn fna => not (null (rules_mapb i dpp fna)))
                                  ra))
                          (pairsa i dpp))
                        (fn x => Inl (snd x)))
                  (fn _ =>
                    bindb (valida rp)
                      (fn _ =>
                        bindb (catch
                                (catch (forallm (nsa rp) r)
                                  (fn x => Inl (snd x)))
                                (fn x =>
                                  Inl (shows_string
 [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n", #" ",
   #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"T", #"R",
   #"S"] o
(shows_nl o x))))
                          (fn _ =>
                            bindb (catch
                                    (catch (forallm (nsta rp) pns)
                                      (fn x => Inl (snd x)))
                                    (fn x =>
                                      Inl
(shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D",
     #"P", #"s"] o
  (shows_nl o x))))
                              (fn _ =>
                                catch (catch (forallm (sa rp) ps)
(fn x => Inl (snd x)))
                                  (fn x =>
                                    Inl (shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D",
     #"P", #"s"] o
  (shows_nl o x)))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desca rp o (shows_nl o x)))))
    of Inl a => Inl a | Inr _ => Inr (delete_P_Pwa i dpp premove premove));

datatype ('a, 'b, 'c, 'd) slm_ops_ext =
  Slm_ops_ext of
    ('a -> 'b list -> 'c) * ('a -> 'b list -> 'b) * 'b list * 'b *
      ('a -> 'b list -> 'c) * 'd;

fun rl_slm A_ B_ delt_opt pre_fs g =
  let
    val fs =
      (if is_none delt_opt then pre_fs
        else filter
               (fn f =>
                 not (equal_proda (equal_lab A_ B_) equal_nat f (the delt_opt)))
               pre_fs);
  in
    bindb (check (not (null fs))
            (shows_string
               [#"r", #"o", #"o", #"t", #"-", #"l", #"a", #"b", #"e", #"l",
                 #"i", #"n", #"g", #" ", #"r", #"e", #"q", #"u", #"i", #"r",
                 #"e", #"s", #" ", #"a", #"t", #" ", #"l", #"e", #"a", #"s",
                 #"t", #" ", #"o", #"n", #"e", #" ", #"f", #"u", #"n", #"c",
                 #"t", #"i", #"o", #"n", #" ", #"s", #"y", #"m", #"b", #"o",
                 #"l", #" ", #"i", #"n", #" ", #"t", #"h", #"e", #" ", #"s",
                 #"i", #"g", #"n", #"a", #"t", #"u", #"r", #"e"] o
              shows_nl))
      (fn _ =>
        let
          val f = fst (hd fs);
        in
          Inr (Slm_ops_ext
                ((fn _ => Inr),
                  (fn ga => fn cs =>
                    (if membera (equal_prod (equal_lab A_ B_) equal_nat) fs
                          (ga, size_list cs)
                      then ga else f)),
                  mapa fst fs, f,
                  (if is_none delt_opt then (fn _ => Inr)
                    else (fn _ => fn gs =>
                           Inr (replicate (size_list gs)
                                 (fst (the delt_opt))))),
                  ()))
        end)
  end;

datatype ('a, 'b, 'c, 'd, 'e) sl_ops_ext =
  Sl_ops_ext of
    ('a -> 'b list -> 'c) * ('a -> nat -> 'c -> bool) * ('a -> 'b list -> 'b) *
      'b list * 'b *
      ((('a, 'd) term * ('a, 'd) term) list ->
        ((char list -> char list), unit) sum) *
      ('a -> 'b list -> 'c) * ('a -> nat -> 'c -> bool) * ('c -> 'c list) *
      ('a -> nat -> 'c list) * 'e;

fun qmodel_cge x = (fn xa => fn y => less_eq_nat y xa) x;

fun pointwise_ext f [] [] = (false, true)
  | pointwise_ext f (uu :: uv) [] = (false, false)
  | pointwise_ext f [] (uw :: ux) = (false, false)
  | pointwise_ext f (a :: asa) (b :: bs) =
    (case f a b
      of (stri, true) =>
        (case pointwise_ext f asa bs
          of (strir, true) => (stri orelse strir, true)
          | (strir, false) => (false, false))
      | (stri, false) => (false, false));

fun qmodel_lge f n =
  (fn l => fn r =>
    (case (l, r)
      of (Inl cs1, Inl cs2) =>
        snd (pointwise_ext (fn x => fn y => (less_nat y x, less_eq_nat y x)) cs1
              cs2)
      | (Inl cs1, Inr _) => false | (Inr _, b) => false));

fun qmodel_L A_ B_ siga =
  (fn f => fn cs =>
    (if membera (equal_prod (equal_lab A_ B_) equal_nat) siga (f, size_list cs)
      then Inl cs else Inl []));

fun enum_vectors_nat c Zero_nat = [[]]
  | enum_vectors_nat c (Suc n) =
    let
      val a = enum_vectors_nat c n;
    in
      maps (fn vec => mapa (fn ca => ca :: vec) c) a
    end;

fun qmodel_LS_gen A_ siga ls =
  (fn f => fn n =>
    (if membera (equal_prod A_ equal_nat) siga (f, n)
      then mapa Inl (enum_vectors_nat ls n) else [Inl []]));

fun qmodel_LS A_ B_ C_ siga ls =
  (fn f => fn n =>
    set (equal_sum (equal_list B_) C_) (qmodel_LS_gen A_ siga ls f n));

fun qmodel_LSa x =
  (fn _ => fn _ => fn a => (case a of Inl _ => true | Inr _ => false)) x;

fun pointwise_lgen ns = concat_lists (mapa (fn n => upt Zero_nat (Suc n)) ns);

fun qmodel_lgen l =
  (case l of Inl ns => mapa Inl (pointwise_lgen ns) | Inr _ => []);

fun check_decr_present_aux_1 A_ B_ r v f1 f2 n =
  let
    val vs = mapa (fn na => Var (v, na)) (upt Zero_nat n);
    val rule = (Fun (f1, vs), Fun (f2, vs));
  in
    check (not (is_none
                 (find (instance_rule A_ (equal_prod B_ equal_nat) rule) r)))
      rule
  end;

fun check_decr_present_aux_2 A_ B_ r v req =
  let
    val add_nats = map_vars (fn va => (va, Zero_nat));
    val ra = mapa (fn (l, ra) => (add_nats l, add_nats ra)) r;
  in
    catch (forallm
            (fn (f1, (a, b)) => check_decr_present_aux_1 A_ B_ ra v f1 a b) req)
      (fn x => Inl (snd x))
  end;

fun check_decr_present A_ B_ siga l v c r =
  let
    val ca = upt Zero_nat (Suc c);
    val ls =
      (fn (f, n) =>
        maps (fn cs =>
               maps (fn i =>
                      let
                        val ci = nth cs i;
                      in
                        (if less_nat ci c
                          then [(l f (list_update cs i (Suc ci)), (l f cs, n))]
                          else [])
                      end)
                 (upt Zero_nat n))
          (enum_vectors_nat ca n));
  in
    check_decr_present_aux_2 A_ B_ r v (maps ls siga)
  end;

fun qmodel_check_decr (A1_, A2_) B_ siga v c =
  (fn lR =>
    catch (check_decr_present (equal_lab A1_ (equal_list equal_nat)) B_ siga
            (fn a => fn b => Lab (a, b)) v c lR)
      (fn x =>
        Inl let
              val display =
                map_vars
                  (fn (_, n) =>
                    (shows_prec_list show_char Zero_nat [#"x"] o
                      shows_prec_nat Zero_nat n)
                      []);
            in
              shows_prec_list show_char Zero_nat
                [#"d", #"e", #"c", #"r", #"e", #"a", #"s", #"i", #"n", #"g",
                  #" ", #"r", #"u", #"l", #"e", #" "] o
                (shows_rule (shows_prec_lab A2_ (show_list show_nat) Zero_nat)
                   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "]
                   (display (fst x), display (snd x)) o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"])
            end));

fun take_default def [] uu = def
  | take_default uv (x :: xs) Zero_nat = x
  | take_default def (uw :: xs) (Suc i) = take_default def xs i;

fun eval_arithFun_unbound nats (Arg i) = take_default Zero_nat nats i
  | eval_arithFun_unbound nats (Const n) = n
  | eval_arithFun_unbound nats (Sum []) = Zero_nat
  | eval_arithFun_unbound nats (Sum (f :: fs)) =
    plus_nata (eval_arithFun_unbound nats f)
      (eval_arithFun_unbound nats (Sum fs))
  | eval_arithFun_unbound nats (Prod []) = one_nata
  | eval_arithFun_unbound nats (Prod (f :: fs)) =
    times_nata (eval_arithFun_unbound nats f)
      (eval_arithFun_unbound nats (Prod fs))
  | eval_arithFun_unbound nats (Max [f]) = eval_arithFun_unbound nats f
  | eval_arithFun_unbound nats (Max (f :: v :: va)) =
    max ord_nat (eval_arithFun_unbound nats f)
      (eval_arithFun_unbound nats (Max (v :: va)))
  | eval_arithFun_unbound nats (Min [f]) = eval_arithFun_unbound nats f
  | eval_arithFun_unbound nats (Min (f :: v :: va)) =
    min ord_nat (eval_arithFun_unbound nats f)
      (eval_arithFun_unbound nats (Min (v :: va)));

fun eval_arithFun c f nats = mod_nat (eval_arithFun_unbound nats f) c;

fun sl_inter_to_inter A_ (SL_Inter (c, ls)) fl cs =
  (case lookupa (equal_prod A_ equal_nat) (fl, size_list cs) ls
    of NONE => Zero_nat | SOME f => eval_arithFun (Suc c) f cs);

fun get_largest_element (SL_Inter (n, uu)) = n;

fun qsli_to_sl_unsafe A_ (B1_, B2_) v f g sli =
  let
    val c = get_largest_element sli;
    val ca = upt Zero_nat (Suc c);
  in
    Sl_ops_ext
      (qmodel_L B1_ (equal_list equal_nat) f,
        qmodel_LS (equal_lab B1_ (equal_list equal_nat)) equal_nat
          (equal_list (equal_lab B1_ (equal_list equal_nat))) f ca,
        sl_inter_to_inter (equal_lab B1_ (equal_list equal_nat)) sli, ca, c,
        qmodel_check_decr (B1_, B2_) A_ f v c,
        qmodel_L B1_ (equal_list equal_nat) g, qmodel_LSa, qmodel_lgen,
        qmodel_LS_gen (equal_lab B1_ (equal_list equal_nat)) f ca, ())
  end;

fun qmodel_check_interpretation f n c =
  let
    val ca = upt Zero_nat (Suc c);
    val css = enum_vectors_nat ca n;
  in
    catch (forallm
            (fn cs =>
              catch (forallm
                      (fn i =>
                        catch (forallm
                                (fn l =>
                                  check (less_eq_nat
  (eval_arithFun (Suc c) f cs) (eval_arithFun (Suc c) f (list_update cs i l)))
                                    (shows_prec_list show_char Zero_nat
                                       [#"n", #"o", #"t", #" ", #"m", #"o",
 #"n", #"o", #"t", #"o", #"n", #"e", #" ", #"i", #"n", #" "] o
                                      (shows_prec_nat Zero_nat (Suc i) o
shows_prec_list show_char Zero_nat
  [#".", #" ", #"a", #"r", #"g", #"u", #"m", #"e", #"n", #"t"])))
                                (upt (nth cs i) (Suc c)))
                          (fn x => Inl (snd x)))
                      (upt Zero_nat n))
                (fn x => Inl (snd x)))
            css)
      (fn x => Inl (snd x))
  end;

fun qmodel_check_valid A_ (SL_Inter (c, ls)) =
  catch (forallm
          (fn (a, b) =>
            let
              val (f, n) = a;
            in
              (fn g =>
                catch (qmodel_check_interpretation g n c)
                  (fn x =>
                    Inl (shows_prec_list show_char Zero_nat
                           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                             #"i", #"n", #" ", #"w", #"e", #"a", #"k", #"-",
                             #"m", #"o", #"n", #"o", #"t", #"o", #"n", #"i",
                             #"c", #"i", #"t", #"y", #" ", #"o", #"f", #" ",
                             #"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e",
                             #"t", #"a", #"t", #"i", #"o", #"n", #" ", #"o",
                             #"f", #" "] o
                          (shows_prec A_ Zero_nat f o (shows_nl o x)))))
            end
              b)
          ls)
    (fn x => Inl (snd x));

fun qsli_to_sl A_ (B1_, B2_) v f g sli =
  bindb (qmodel_check_valid (show_lab B2_ (show_list show_nat)) sli)
    (fn _ => Inr (qsli_to_sl_unsafe A_ (B1_, B2_) v f g sli));

fun sli_to_slm A_ sli =
  let
    val c = get_largest_element sli;
  in
    Slm_ops_ext
      ((fn _ => Inl),
        sl_inter_to_inter (equal_lab A_ (equal_list equal_nat)) sli,
        upt Zero_nat (Suc c), c, (fn _ => Inl), ())
  end;

fun sl_C
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_C;

fun sl_I
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_I;

fun sl_L
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_La;

fun lab_lhs_list E_ i l lc c t =
  mapa (fn alpha => snd (eval_lab i l lc alpha t))
    (mapa (fun_of E_) (enum_vectors c (vars_term_list E_ t)));

fun lab_lhss_list E_ i l lc c q = maps (lab_lhs_list E_ i l lc c) q;

fun check_sl_Q (A1_, A2_) (D1_, D2_) i l lc c lQ q =
  bindb (check (not (null c))
          (shows_prec_list show_char Zero_nat
            [#"c", #"a", #"r", #"r", #"i", #"e", #"r", #" ", #"m", #"u", #"s",
              #"t", #" ", #"b", #"e", #" ", #"n", #"o", #"n", #"-", #"e", #"m",
              #"p", #"t", #"y"]))
    (fn _ =>
      catch (check_subseteq (equal_term A1_ D1_) (lab_lhss_list D1_ i l lc c q)
              lQ)
        (fn x =>
          Inl (shows_prec_list show_char Zero_nat
                 [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"t", #"e",
                   #"r", #"m", #" "] o
                (shows_term (shows_prec A2_ Zero_nat) (shows_prec D2_ Zero_nat)
                   x o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n",
                      #"g"]))));

fun lab_rule_ass i l lc alpha rule =
  (snd (eval_lab i l lc alpha (fst rule)),
    snd (eval_lab i l lc alpha (snd rule)));

fun lab_rule_list E_ i l lc c lr =
  mapa (fn alpha => lab_rule_ass i l lc alpha lr)
    (mapa (fun_of E_) (enum_vectors c (vars_rule_list E_ lr)));

fun lab_trs_list E_ i l lc c r = maps (lab_rule_list E_ i l lc c) r;

fun check_sl_lab (A1_, A2_) (D1_, D2_) i l lc c lR r =
  bindb (check (not (null c))
          (shows_prec_list show_char Zero_nat
            [#"c", #"a", #"r", #"r", #"i", #"e", #"r", #" ", #"m", #"u", #"s",
              #"t", #" ", #"b", #"e", #" ", #"n", #"o", #"n", #"-", #"e", #"m",
              #"p", #"t", #"y"]))
    (fn _ =>
      catch (check_subseteq
              (equal_prod (equal_term A1_ D1_) (equal_term A1_ D1_)) lR
              (lab_trs_list D1_ i l lc c r))
        (fn x =>
          Inl (shows_prec_list show_char Zero_nat
                 [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"r", #"u",
                   #"l", #"e", #" "] o
                (shows_rule (shows_prec A2_ Zero_nat) (shows_prec D2_ Zero_nat)
                   [#" ", #"-", #">", #" "] x o
                  shows_prec_list show_char Zero_nat
                    [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #"l",
                      #"l", #"o", #"w", #"e", #"d"]))));

fun check_sl_Qa (A1_, A2_) (C1_, C2_) ld lQ q =
  let
    val u = (fn l => fst (ld l));
  in
    catch (forallm
            (fn lq =>
              check (membera (equal_term A1_ C1_) q (map_term u lq))
                (shows_prec_list show_char Zero_nat
                   [#"u", #"n", #"l", #"a", #"b", #"e", #"l", #"i", #"n", #"g",
                     #" "] o
                  (shows_term (shows_prec A2_ Zero_nat)
                     (shows_prec C2_ Zero_nat) lq o
                    shows_prec_list show_char Zero_nat
                      [#" ", #"y", #"i", #"e", #"l", #"d", #"s", #" ", #"a",
                        #" ", #"t", #"e", #"r", #"m", #" ", #"n", #"o", #"t",
                        #" ", #"i", #"n", #" ", #"Q"])))
            lQ)
      (fn x => Inl (snd x))
  end;

fun model_splitter A_ C_ ld lAll uRw =
  let
    val unlab = (fn lf => fst (ld lf));
    val la = mapa (fn r => (r, map_rule unlab r)) lAll;
    val (rw, r) =
      partition
        (fn (_, a) =>
          membera (equal_prod (equal_term A_ C_) (equal_term A_ C_)) uRw a)
        la;
  in
    (mapa fst r, (mapa fst rw, []))
  end;

fun sem_lab_proc (A1_, A2_) (D1_, D2_) ld i valid check_Q check_laba check_lab
  check_model_lab lPAll lQ lRAll dpp =
  let
    val r = rc i dpp;
    val rw = rwc i dpp;
    val pw = pwa i dpp;
    val p = pa i dpp;
    val (lP, (lPw, _)) = model_splitter A1_ D1_ ld lPAll pw;
    val (lR, (lRw, _)) = model_splitter A1_ D1_ ld lRAll rw;
  in
    (case bindb valid
            (fn _ =>
              let
                val q = qc i dpp;
              in
                catch (bindb (check_Q lQ q)
                        (fn _ =>
                          bindb (check_sl_Qa (A1_, A2_) (D1_, D2_) ld lQ q)
                            (fn _ =>
                              bindb (check_laba lP p)
                                (fn _ =>
                                  bindb (check_laba lPw pw)
                                    (fn _ =>
                                      bindb (check_model_lab lR r)
(fn _ =>
  bindb (check_model_lab lRw rw)
    (fn _ => bindb (check_lab lR r) (fn _ => check_lab lRw rw))))))))
                  (fn x =>
                    Inl (shows_string
                           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                             #"d", #"u", #"r", #"i", #"n", #"g", #" ", #"l",
                             #"a", #"b", #"e", #"l", #"i", #"n", #"g", #":"] o
                          (shows_nl o x)))
              end)
      of Inl a => Inl a | Inr _ => Inr (mkc i lP lPw lQ lR lRw))
  end;

fun check_sl_rule_ass A_ B_ (D1_, D2_) (E1_, E2_) mc i la lc cge lR alpha (l, r)
  = let
      val cl_ll = eval_lab i la lc alpha l;
      val cr_lr = eval_lab i la lc alpha r;
    in
      bindb (check (if mc then cge (fst cl_ll) (fst cr_lr) else true)
              (shows_string [#"r", #"u", #"l", #"e", #" "] o
                (shows_rule (shows_prec A_ Zero_nat) (shows_prec E2_ Zero_nat)
                   [#" ", #"-", #">", #" "] (l, r) o
                  (shows_string
                     [#" ", #"v", #"i", #"o", #"l", #"a", #"t", #"e", #"s",
                       #" ", #"t", #"h", #"e", #" ", #"m", #"o", #"d", #"e",
                       #"l", #" ", #"c", #"o", #"n", #"d", #"i", #"t", #"i",
                       #"o", #"n", #",", #" ", #"[", #"l", #"h", #"s", #"]",
                       #" ", #"=", #" "] o
                    (shows_prec B_ Zero_nat (fst cl_ll) o
                      (shows_string
                         [#",", #" ", #"[", #"r", #"h", #"s", #"]", #" ", #"=",
                           #" "] o
                        shows_prec B_ Zero_nat (fst cr_lr)))))))
        (fn _ =>
          check (membera (equal_prod (equal_term D1_ E1_) (equal_term D1_ E1_))
                  lR (snd cl_ll, snd cr_lr))
            (shows_string
               [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"r", #"u",
                 #"l", #"e", #" "] o
              (shows_rule (shows_prec D2_ Zero_nat) (shows_prec E2_ Zero_nat)
                 [#" ", #"-", #">", #" "] (snd cl_ll, snd cr_lr) o
                shows_string [#" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"])))
    end;

fun check_sl_rule A_ B_ (D1_, D2_) (E1_, E2_) i l lc c cge mc lR lr =
  catch (forallm
          (fn alpha =>
            check_sl_rule_ass A_ B_ (D1_, D2_) (E1_, E2_) mc i l lc cge lR alpha
              lr)
          (mapa (fun_of E1_) (enum_vectors c (vars_rule_list E1_ lr))))
    (fn x => Inl (snd x));

fun check_sl_lab_trs (A1_, A2_) B_ (D1_, D2_) i l c cge label lP p =
  catch (forallm
          (check_sl_rule A2_ B_ (A1_, A2_) (D1_, D2_) i l label c cge false lP)
          p)
    (fn x => Inl (snd x));

fun check_sl_model_lab_trs (A1_, A2_) B_ (D1_, D2_) i l c cge label lR r =
  catch (forallm
          (check_sl_rule A2_ B_ (A1_, A2_) (D1_, D2_) i l label c cge true lR)
          r)
    (fn x => Inl (snd x));

fun sem_lab_fin_proc (A1_, A2_) (D1_, D2_) (E1_, E2_) lc ld i gen lPAll lQ lRAll
  dp =
  bindb (gen (list_union (equal_prod A1_ equal_nat)
               (funas_trs_list A1_ (rulesd i dp))
               (funas_args_trs_list A1_ (pairsa i dp)))
          [])
    (fn ops =>
      let
        val check_q =
          check_sl_Q (A1_, A2_) (D1_, D2_) (sl_I ops) (sl_L ops) lc (sl_C ops);
        val check_ml =
          check_sl_model_lab_trs (A1_, A2_) E2_ (D1_, D2_) (sl_I ops) (sl_L ops)
            (sl_C ops) (eq E1_) lc;
        val check_l =
          check_sl_lab_trs (A1_, A2_) E2_ (D1_, D2_) (sl_I ops) (sl_L ops)
            (sl_C ops) (eq E1_) lc;
        val check_la =
          check_sl_lab (A1_, A2_) (D1_, D2_) (sl_I ops) (sl_L ops) lc
            (sl_C ops);
      in
        sem_lab_proc (A1_, A2_) (D1_, D2_) ld i (Inr ()) check_q check_l
          check_la check_ml lPAll lQ lRAll dp
      end);

fun slm_C (Slm_ops_ext (slm_La, slm_I, slm_C, slm_c, slm_L, more)) = slm_C;

fun slm_I (Slm_ops_ext (slm_La, slm_I, slm_C, slm_c, slm_L, more)) = slm_I;

fun slm_L (Slm_ops_ext (slm_La, slm_I, slm_C, slm_c, slm_L, more)) = slm_La;

fun slm_c (Slm_ops_ext (slm_La, slm_I, slm_C, slm_c, slm_L, more)) = slm_c;

fun slm_La (Slm_ops_ext (slm_La, slm_I, slm_C, slm_c, slm_L, more)) = slm_L;

fun slm_to_sl ops =
  Sl_ops_ext
    (slm_L ops, (fn _ => fn _ => top_fun top_bool), slm_I ops, slm_C ops,
      slm_c ops, (fn _ => Inr ()), slm_La ops,
      (fn _ => fn _ => top_fun top_bool), (fn l => [l]), (fn _ => fn _ => []),
      ());

fun slm_gen_to_sl_gen gen =
  (fn f => fn g => bindb (gen f g) (fn ops => Inr (slm_to_sl ops)));

fun sl_La
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_L;

fun funas_root_term_list (Fun (f, ts)) = [(f, size_list ts)]
  | funas_root_term_list (Var uu) = [];

fun funas_root_rule_list A_ r =
  remdups (equal_prod A_ equal_nat)
    (funas_root_term_list (fst r) @ funas_root_term_list (snd r));

fun funas_root_rules_list A_ r =
  remdups (equal_prod A_ equal_nat) (maps (funas_root_rule_list A_) r);

fun sem_lab_root_proc (A1_, A2_) (D1_, D2_) ld i valid check_Q check_laba
  check_lab check_model_lab lPAll lQ lRAll dpp =
  let
    val r = rc i dpp;
    val rw = rwc i dpp;
    val pw = pwa i dpp;
    val p = pa i dpp;
    val (lP, (lPw, _)) = model_splitter A1_ D1_ ld lPAll pw;
    val (lR, (lRw, _)) = model_splitter A1_ D1_ ld lRAll rw;
  in
    (case bindb valid
            (fn _ =>
              bindb (catch
                      (forallm
                        (fn (l, ra) =>
                          bindb (check_no_var A2_ D2_ l)
                            (fn _ =>
                              bindb (check_no_var A2_ D2_ ra)
                                (fn _ =>
                                  check_no_defined_root A2_ D2_
                                    (fn fna =>
                                      not (null (rules_mapb i dpp fna)))
                                    ra)))
                        (pairsa i dpp))
                      (fn x => Inl (snd x)))
                (fn _ =>
                  let
                    val q = qc i dpp;
                  in
                    catch (bindb (check_Q lQ q)
                            (fn _ =>
                              bindb (check_sl_Qa (A1_, A2_) (D1_, D2_) ld lQ q)
                                (fn _ =>
                                  bindb (check_laba lP p)
                                    (fn _ =>
                                      bindb (check_laba lPw pw)
(fn _ =>
  bindb (check_model_lab lR r)
    (fn _ =>
      bindb (check_model_lab lRw rw)
        (fn _ => bindb (check_lab lR r) (fn _ => check_lab lRw rw))))))))
                      (fn x =>
                        Inl (shows_string
                               [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                                 #"d", #"u", #"r", #"i", #"n", #"g", #" ", #"l",
                                 #"a", #"b", #"e", #"l", #"i", #"n", #"g",
                                 #":"] o
                              (shows_nl o x)))
                  end))
      of Inl a => Inl a | Inr _ => Inr (mkc i lP lPw lQ lR lRw))
  end;

fun check_sl_rule_root A_ B_ (D1_, D2_) (E1_, E2_) i la l lc c lR lr =
  catch (forallm
          (fn alpha =>
            let
              val laa = lab_root i la l lc alpha;
              val lb = laa (fst lr);
              val r = laa (snd lr);
            in
              check (membera
                      (equal_prod (equal_term D1_ E1_) (equal_term D1_ E1_)) lR
                      (lb, r))
                (shows_prec_list show_char Zero_nat
                   [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"r", #"u",
                     #"l", #"e", #" "] o
                  (shows_rule (shows_prec D2_ Zero_nat)
                     (shows_prec E2_ Zero_nat) [#" ", #"-", #">", #" "]
                     (lb, r) o
                    shows_prec_list show_char Zero_nat
                      [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i",
                        #"n", #"g"]))
            end)
          (mapa (fun_of E1_) (enum_vectors c (vars_rule_list E1_ lr))))
    (fn x => Inl (snd x));

fun check_sl_lab_root_trs A_ B_ (D1_, D2_) (E1_, E2_) i la l c label lP p =
  catch (forallm
          (check_sl_rule_root A_ B_ (D1_, D2_) (E1_, E2_) i la l label c lP) p)
    (fn x => Inl (snd x));

fun sem_lab_fin_root_proc (A1_, A2_) (D1_, D2_) (E1_, E2_) lc ld i gen lPAll lQ
  lRAll dp =
  let
    val pairs = pairsa i dp;
  in
    bindb (gen (list_union (equal_prod A1_ equal_nat)
                 (funas_trs_list A1_ (rulesd i dp))
                 (funas_args_trs_list A1_ pairs))
            (funas_root_rules_list A1_ pairs))
      (fn ops =>
        let
          val check_q =
            check_sl_Q (A1_, A2_) (D1_, D2_) (sl_I ops) (sl_L ops) lc
              (sl_C ops);
          val check_ml =
            check_sl_model_lab_trs (A1_, A2_) E2_ (D1_, D2_) (sl_I ops)
              (sl_L ops) (sl_C ops) (eq E1_) lc;
          val check_l =
            check_sl_lab_root_trs A2_ E2_ (A1_, A2_) (D1_, D2_) (sl_I ops)
              (sl_L ops) (sl_La ops) (sl_C ops) lc;
          val check_la =
            check_sl_lab (A1_, A2_) (D1_, D2_) (sl_I ops) (sl_L ops) lc
              (sl_C ops);
        in
          sem_lab_root_proc (A1_, A2_) (D1_, D2_) ld i (Inr ()) check_q check_l
            check_la check_ml lPAll lQ lRAll dp
        end)
  end;

fun sl_LS
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_LSa;

fun sl_lgen
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_lgen;

fun sl_LS_gen
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_LS_gen;

fun lge_to_lgr B_ lge ls f n =
  let
    val lSfn = ls f n;
    val lgefn = lge f n;
  in
    (fn l => fn la =>
      not (eq B_ l la) andalso
        (member l lSfn andalso (member la lSfn andalso lgefn l la)))
  end;

fun check_sl_decr_rule A_ B_ C_ D_ lc ld ls lge (Fun (lf, ts), Fun (lg, us)) =
  let
    val (f, l1) = ld lf;
    val (g, l2) = ld lg;
    val n = size_list ts;
  in
    eq A_ f g andalso
      (equal_lista (equal_term C_ D_) ts us andalso
        (eq C_ lf (lc f n l1) andalso
          (eq C_ lg (lc f n l2) andalso
            (member l1 (ls f n) andalso
              (member l2 (ls f n) andalso lge_to_lgr B_ lge ls f n l1 l2)))))
  end
  | check_sl_decr_rule A_ B_ C_ D_ uu uv uw ux (Var vb, va) = false
  | check_sl_decr_rule A_ B_ C_ D_ uu uv uw ux (v, Var vb) = false;

fun check_sl_decr A_ B_ (C1_, C2_) (D1_, D2_) lc ld ls lge d =
  catch (forallm
          (fn lr =>
            check (check_sl_decr_rule A_ B_ C1_ D1_ lc ld ls lge lr)
              (shows_rule (shows_prec C2_ Zero_nat) (shows_prec D2_ Zero_nat)
                 [#" ", #"-", #">", #" "] lr o
                shows_prec_list show_char Zero_nat
                  [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ",
                    #"d", #"e", #"c", #"r", #"e", #"a", #"s", #"i", #"n", #"g",
                    #" ", #"r", #"u", #"l", #"e"]))
          d)
    (fn x => Inl (snd x));

fun sl_check_decr
  (Sl_ops_ext
    (sl_La, sl_LSa, sl_I, sl_C, sl_c, sl_check_decr, sl_L, sl_LS, sl_lgen,
      sl_LS_gen, more))
  = sl_check_decr;

fun check_wf_sym_F_all (C1_, C2_) lc ld ls =
  (fn (lf, n) =>
    let
      val (f, l) = ld lf;
    in
      check (member l (ls f n) andalso eq C1_ lf (lc f n l))
        (shows_prec_list show_char Zero_nat
           [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"s", #"y", #"m",
             #"b", #"o", #"l", #" "] o
          (shows_prec C2_ Zero_nat lf o
            shows_prec_list show_char Zero_nat
              [#" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l", #"o", #"w", #"e",
                #"d"]))
    end);

fun check_wf_terms_F_all (C1_, C2_) lc ld ls lt =
  let
    val lfs = funas_term_list C1_ lt;
  in
    catch (forallm (check_wf_sym_F_all (C1_, C2_) lc ld ls) lfs)
      (fn x => Inl (snd x))
  end;

fun check_Lab_all_trs (A1_, A2_) (C1_, C2_) lc ld ls lR r =
  catch (forallm
          (fn (l, ra) =>
            catch (bindb (check_wf_terms_F_all (A1_, A2_) lc ld ls ra)
                    (fn _ =>
                      check (membera
                              (equal_prod (equal_term A1_ C1_)
                                (equal_term A1_ C1_))
                              r (map_rule (fn lf => fst (ld lf)) (l, ra)))
                        (shows_prec_list show_char Zero_nat
                          [#"u", #"n", #"l", #"a", #"b", #"e", #"l", #"i", #"n",
                            #"g", #" ", #"o", #"f", #" ", #"t", #"h", #"e",
                            #" ", #"r", #"u", #"l", #"e", #" ", #"d", #"o",
                            #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"y",
                            #"i", #"e", #"l", #"d", #" ", #"o", #"r", #"i",
                            #"g", #"i", #"n", #"a", #"l", #" ", #"r", #"u",
                            #"l", #"e"])))
              (fn x =>
                Inl (shows_prec_list show_char Zero_nat
                       [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w",
                         #"i", #"t", #"h", #" ", #"l", #"a", #"b", #"e", #"l",
                         #"e", #"d", #" ", #"r", #"u", #"l", #"e"] o
                      (shows_rule (shows_prec A2_ Zero_nat)
                         (shows_prec C2_ Zero_nat) [#" ", #"-", #">", #" "]
                         (l, ra) o
                        (shows_nl o x)))))
          lR)
    (fn x => Inl (snd x));

fun check_sl_rule_all_ass A_ B_ (D1_, D2_) (E1_, E2_) i lb la lc gen_smaller lR
  alpha (l, Fun (f, ts)) =
  let
    val ll = lab_root i lb la lc alpha l;
    val clts = mapa (eval_lab i lb lc alpha) ts;
    val lts = mapa snd clts;
    val ld = la f (mapa fst clts);
    val n = size_list ts;
    val small = gen_smaller ld;
  in
    catch (forallm
            (fn le =>
              check (membera
                      (equal_prod (equal_term D1_ E1_) (equal_term D1_ E1_)) lR
                      (ll, Fun (lc f n le, lts)))
                (shows_string
                   [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"r", #"u",
                     #"l", #"e", #" "] o
                  (shows_rule (shows_prec D2_ Zero_nat)
                     (shows_prec E2_ Zero_nat) [#" ", #"-", #">", #" "]
                     (ll, Fun (lc f n le, lts)) o
                    shows_string
                      [#" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"])))
            small)
      (fn x => Inl (snd x))
  end
  | check_sl_rule_all_ass A_ B_ (D1_, D2_) (E1_, E2_) i lb la lc gen_smaller lR
    alpha (l, Var x) =
    let
      val ll = lab_root i lb la lc alpha l;
      val lr = lab_root i lb la lc alpha (Var x);
    in
      check (membera (equal_prod (equal_term D1_ E1_) (equal_term D1_ E1_)) lR
              (ll, lr))
        (shows_string
           [#"l", #"a", #"b", #"e", #"l", #"e", #"d", #" ", #"r", #"u", #"l",
             #"e", #" "] o
          (shows_rule (shows_prec D2_ Zero_nat) (shows_prec E2_ Zero_nat)
             [#" ", #"-", #">", #" "] (ll, lr) o
            shows_string [#" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g"]))
    end;

fun check_sl_rule_all A_ B_ (D1_, D2_) (E1_, E2_) i la l lc c gen_smaller lR lr
  = catch (forallm
            (fn alpha =>
              check_sl_rule_all_ass A_ B_ (D1_, D2_) (E1_, E2_) i la l lc
                gen_smaller lR alpha lr)
            (mapa (fun_of E1_) (enum_vectors c (vars_rule_list E1_ lr))))
      (fn x => Inl (snd x));

fun check_sl_lab_all_trs A_ B_ (D1_, D2_) (E1_, E2_) i la l c gen label lP p =
  catch (forallm
          (check_sl_rule_all A_ B_ (D1_, D2_) (E1_, E2_) i la l label c gen lP)
          p)
    (fn x => Inl (snd x));

fun flatten_term_enum (Var x) = [Var x]
  | flatten_term_enum (Fun (fs, ts)) =
    let
      val lts = mapa flatten_term_enum ts;
      val ss = concat_lists lts;
    in
      maps (fn f => mapa (fn a => Fun (f, a)) ss) fs
    end;

fun lab_lhss_more_impl lc lS_gen q =
  let
    val f_all = (fn f => fn n => mapa (lc f n) (lS_gen f n));
  in
    maps (fn qa => flatten_term_enum (map_term_wa f_all qa)) q
  end;

fun check_sl_lab_lhss_more (A1_, A2_) (C1_, C2_) lc lS_gen lQ q =
  catch (check_subseteq (equal_term A1_ C1_) (lab_lhss_more_impl lc lS_gen q)
          lQ)
    (fn x =>
      Inl (shows_term (shows_prec A2_ Zero_nat) (shows_prec C2_ Zero_nat) x o
            shows_prec_list show_char Zero_nat
              [#" ", #"i", #"s", #" ", #"m", #"i", #"s", #"s", #"i", #"n", #"g",
                #" ", #"i", #"n", #" ", #"l", #"a", #"b", #"e", #"l", #"e",
                #"d", #" ", #"Q"]));

fun quasi_splitter A_ C_ ld lAll uRw =
  let
    val unlab = (fn lf => fst (ld lf));
    val la = mapa (fn r => (r, map_rule unlab r)) lAll;
    val (d, nD) =
      partition
        (fn (r, ur) =>
          equal_terma A_ C_ (fst ur) (snd ur) andalso
            not (equal_terma A_ C_ (fst r) (snd r)))
        la;
    val (rw, r) =
      partition
        (fn (_, a) =>
          membera (equal_prod (equal_term A_ C_) (equal_term A_ C_)) uRw a)
        nD;
  in
    (mapa fst r, (mapa fst rw, mapa fst d))
  end;

fun sem_lab_quasi_root_proc (A1_, A2_) (D1_, D2_) ld i valid check_decra
  check_decr check_lhss_more check_lab_all check_lab_all_trs check_model_lab
  lPAll lQ lRAll dpp =
  let
    val r = rc i dpp;
    val rw = rwc i dpp;
    val pw = pwa i dpp;
    val p = pa i dpp;
    val (lP, (lPw, _)) = model_splitter A1_ D1_ ld lPAll pw;
    val (lR, (lRw, d)) = quasi_splitter A1_ D1_ ld lRAll rw;
  in
    (case bindb valid
            (fn _ =>
              bindb (catch
                      (forallm
                        (fn (l, ra) =>
                          bindb (check_no_var A2_ D2_ l)
                            (fn _ =>
                              bindb (check_no_var A2_ D2_ ra)
                                (fn _ =>
                                  check_no_defined_root A2_ D2_
                                    (fn fna =>
                                      not (null (rules_mapb i dpp fna)))
                                    ra)))
                        (pairsa i dpp))
                      (fn x => Inl (snd x)))
                (fn _ =>
                  let
                    val q = qc i dpp;
                  in
                    bindb (check_decra d)
                      (fn _ =>
                        bindb (check_decr d)
                          (fn _ =>
                            bindb (catch
                                    (forallm
                                      (fn qa =>
check (linear_term D1_ qa)
  (shows_prec_list show_char Zero_nat
    [#"Q", #" ", #"m", #"u", #"s", #"t", #" ", #"n", #"o", #"t", #" ", #"c",
      #"o", #"n", #"t", #"a", #"i", #"n", #" ", #"n", #"o", #"n", #"-", #"l",
      #"i", #"n", #"e", #"a", #"r", #" ", #"t", #"e", #"r", #"m", #"s"]))
                                      q)
                                    (fn x => Inl (snd x)))
                              (fn _ =>
                                catch (bindb (check_lhss_more lQ q)
(fn _ =>
  bindb (check_sl_Qa (A1_, A2_) (D1_, D2_) ld lQ q)
    (fn _ =>
      bindb (check_lab_all lP p)
        (fn _ =>
          bindb (check_lab_all lPw pw)
            (fn _ =>
              bindb (check_model_lab lR r)
                (fn _ =>
                  bindb (check_model_lab lRw rw)
                    (fn _ =>
                      bindb (check_lab_all_trs lR r)
                        (fn _ => check_lab_all_trs lRw rw))))))))
                                  (fn x =>
                                    Inl (shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"d", #"u", #"r", #"i",
     #"n", #"g", #" ", #"l", #"a", #"b", #"e", #"l", #"i", #"n", #"g", #":"] o
  (shows_nl o x))))))
                  end))
      of Inl a => Inl a | Inr _ => Inr (mkc i lP lPw lQ lR (lRw @ d)))
  end;

fun sem_lab_fin_quasi_root_proc (A1_, A2_) B_ C_ (E1_, E2_) lc ld cge lge i gen
  lPAll lQ lRAll dp =
  let
    val pairs = pairsa i dp;
  in
    bindb (gen (list_union (equal_prod A1_ equal_nat)
                 (funas_trs_list A1_ (rulesd i dp))
                 (funas_args_trs_list A1_ pairs))
            (funas_root_rules_list A1_ pairs))
      (fn ops =>
        let
          val check_d = sl_check_decr ops;
          val check_da =
            check_sl_decr A1_ B_ (A1_, A2_) (E1_, E2_) lc ld (sl_LS ops) lge;
          val check_q =
            check_sl_lab_lhss_more (A1_, A2_) (E1_, E2_) lc (sl_LS_gen ops);
          val check_ml =
            check_sl_model_lab_trs (A1_, A2_) C_ (E1_, E2_) (sl_I ops)
              (sl_L ops) (sl_C ops) cge lc;
          val check_l =
            check_sl_lab_all_trs A2_ C_ (A1_, A2_) (E1_, E2_) (sl_I ops)
              (sl_L ops) (sl_La ops) (sl_C ops) (sl_lgen ops) lc;
          val check_la =
            check_Lab_all_trs (A1_, A2_) (E1_, E2_) lc ld (sl_LS ops);
        in
          sem_lab_quasi_root_proc (A1_, A2_) (E1_, E2_) ld i (Inr ()) check_d
            check_da check_q check_l check_la check_ml lPAll lQ lRAll dp
        end)
  end;

fun semlab_fin_proc (B1_, B2_) (C1_, C2_) j (Rootlab NONE) =
  sem_lab_fin_proc
    (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
    (C1_, C2_)
    (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
    label label_decomp j
    (slm_gen_to_sl_gen (rl_slm B1_ (equal_list equal_nat) NONE))
  | semlab_fin_proc (B1_, B2_) (C1_, C2_) j (Rootlab (SOME d)) =
    sem_lab_fin_root_proc
      (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
      (C1_, C2_)
      (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
      label label_decomp j
      (slm_gen_to_sl_gen (rl_slm B1_ (equal_list equal_nat) (SOME d)))
  | semlab_fin_proc (B1_, B2_) (C1_, C2_) j (Finitelab sli) =
    sem_lab_fin_proc
      (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
      (C1_, C2_) (equal_nat, show_nat) label label_decomp j
      (slm_gen_to_sl_gen (fn _ => fn _ => Inr (sli_to_slm B1_ sli)))
  | semlab_fin_proc (B1_, B2_) (C1_, C2_) j (QuasiFinitelab (sli, v)) =
    sem_lab_fin_quasi_root_proc
      (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
      (equal_sum (equal_list equal_nat)
        (equal_list (equal_lab B1_ (equal_list equal_nat))))
      show_nat (C1_, C2_) label label_decomp qmodel_cge qmodel_lge j
      (fn f => fn g => qsli_to_sl C1_ (B1_, B2_) v f g sli);

fun ur_af_root_redtriple_proc (B1_, B2_) (C1_, C2_) i rp premove ur dpp =
  (case catch let
                val (ps, pns) = split_pairsa i dpp premove;
                val p = pairsa i dpp;
                val rm = rules_mapb i dpp;
                val _ = rulesd i dpp;
                val pi = afa rp;
                val pia = aft rp;
              in
                bindb (catch
                        (forallm
                          (fn (l, r) =>
                            bindb (check_no_var B2_ C2_ l)
                              (fn _ =>
                                bindb (check_no_var B2_ C2_ r)
                                  (fn _ =>
                                    check_no_defined_root B2_ C2_
                                      (fn fna =>
not (null (rules_mapb i dpp fna)))
                                      r)))
                          p)
                        (fn x => Inl (snd x)))
                  (fn _ =>
                    bindb (valida rp)
                      (fn _ =>
                        bindb (check_ur_P_closed_rm_af (B1_, B2_) (C1_, C2_) rm
                                ur (maps (fn st =>
   let
     val Fun (f, ts) = snd st;
     val n = size_list ts;
     val is = pia f n;
   in
     map_filter (fn x => (if is x then SOME (fst st, nth ts x) else NONE))
       (upt Zero_nat n)
   end)
                                     p)
                                pi)
                          (fn _ =>
                            bindb (catch
                                    (catch (forallm (nsa rp) ur)
                                      (fn x => Inl (snd x)))
                                    (fn x =>
                                      Inl
(shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"u",
     #"s", #"a", #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e", #"s"] o
  (shows_nl o x))))
                              (fn _ =>
                                bindb (catch
(catch (forallm (nsta rp) pns) (fn x => Inl (snd x)))
(fn x =>
  Inl (shows_string
         [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
           #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g",
           #" ", #"D", #"P", #"s"] o
        (shows_nl o x))))
                                  (fn _ =>
                                    catch (catch (forallm (sa rp) ps)
    (fn x => Inl (snd x)))
                                      (fn x =>
Inl (shows_string
       [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
         #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"D",
         #"P", #"s"] o
      (shows_nl o x))))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desca rp o (shows_nl o x)))))
    of Inl a => Inl a | Inr _ => Inr (delete_P_Pwa i dpp premove premove));

fun check_wf_afs A_ pi =
  catch (forallm
          (fn (a, b) =>
            let
              val (f, n) = a;
            in
              (fn e =>
                catch (case e of Collapse i => check (less_nat i n) i
                        | AFList ids =>
                          catch (forallm
                                  (fn x =>
                                    (if less_nat x n then Inr () else Inl x))
                                  ids)
                            (fn x => Inl (snd x)))
                  (fn x =>
                    Inl (shows_string [#"i", #"n", #"d", #"e", #"x", #" "] o
                          (shows_prec_nat Zero_nat x o
                            (shows_string
                               [#" ", #"t", #"o", #"o", #" ", #"h", #"i", #"g",
                                 #"h", #" ", #"f", #"o", #"r", #" ", #"A", #"F",
                                 #"-", #"e", #"n", #"t", #"r", #"y", #" ", #"o",
                                 #"f"] o
                              (shows_prec_prod A_ show_nat Zero_nat (f, n) o
                                shows_nl))))))
            end
              b)
          pi)
    (fn x => Inl (snd x));

fun afs_list_to_af A_ pi f n =
  (case lookupa (equal_prod A_ equal_nat) (f, n) pi of NONE => (fn _ => true)
    | SOME (Collapse a) => equal_nata a
    | SOME (AFList a) => membera equal_nat a);

fun mono_af_entry n (Collapse i) = less_eq_nat n one_nata
  | mono_af_entry n (AFList ids) =
    all_interval_nat (membera equal_nat ids) Zero_nat n;

fun check_mono_afs_help A_ ((f, a), e) =
  shows_string [#"e", #"n", #"t", #"r", #"y", #" ", #"f", #"o", #"r", #" "] o
    (shows_prec A_ Zero_nat f o
      (shows_string
         [#" ", #"n", #"o", #"t", #" ", #"m", #"o", #"n", #"o", #"t", #"o",
           #"n", #"i", #"c"] o
        shows_nl));

fun check_mono_afs A_ pi =
  catch (catch
          (forallm
            (fn x =>
              (if mono_af_entry (snd (fst x)) (snd x) then Inr () else Inl x))
            pi)
          (fn x => Inl (snd x)))
    (fn x => Inl (check_mono_afs_help A_ x));

fun default_af_entry n = AFList (upt Zero_nat n);

fun afs_list_to_afs A_ pi f n =
  (case lookupa (equal_prod A_ equal_nat) (f, n) pi
    of NONE => default_af_entry n | SOME entry => entry);

fun af_redtriple (A1_, A2_) B_ pi rp =
  let
    val af = afs_list_to_af A1_ pi;
    val afs = afs_list_to_afs A1_ pi;
  in
    Redtriple_ext
      (bindb (check_wf_afs A2_ pi) (fn _ => valid rp),
        afs_check A2_ B_ (shows_string [#">"]) afs (s rp),
        afs_check A2_ B_ (shows_string [#">", #"="]) afs (ns rp),
        afs_check A2_ B_ (shows_string [#">", #"="]) afs (nst rp), af,
        bindb (check_mono_afs A2_ pi) (fn _ => mono rp),
        shows_string
          [#"A", #"r", #"g", #"u", #"m", #"e", #"n", #"t", #" ", #"F", #"i",
            #"l", #"t", #"e", #"r", #":", #" "] o
          (shows_nl o (shows_afs A2_ pi o (shows_nl o desc rp))),
        ())
  end;

fun equal_filtereda A_ (FPair (fa, nata)) (FPair (f, nat)) =
  eq A_ fa f andalso equal_nata nata nat;

fun equal_filtered A_ = {equal = equal_filtereda A_} : 'a filtered equal;

fun shows_arctic (Num_arc i) = shows_prec_int Zero_nat i
  | shows_arctic MinInfty = shows_string [#"-", #"i", #"n", #"f"];

fun shows_prec_arctic d ai = shows_arctic ai;

fun shows_list_arctic asa = shows_list_aux (shows_prec_arctic Zero_nat) asa;

val show_arctic =
  {shows_prec = shows_prec_arctic, shows_list = shows_list_arctic} :
  arctic show;

val ordered_semiring_0_int =
  {semiring_0_ordered_semiring_0 = semiring_0_int,
    ordered_ab_semigroup_ordered_semiring_0 = ordered_ab_semigroup_int}
  : int ordered_semiring_0;

val ordered_semiring_1_int =
  {semiring_1_ordered_semiring_1 = semiring_1_int,
    ordered_semiring_0_ordered_semiring_1 = ordered_semiring_0_int}
  : int ordered_semiring_1;

val max_ordered_semiring_1_int =
  {max_ordered_monoid_add_max_ordered_semiring_1 = max_ordered_monoid_add_int,
    ordered_semiring_1_max_ordered_semiring_1 = ordered_semiring_1_int}
  : int max_ordered_semiring_1;

val poly_carrier_int =
  {comm_semiring_1_poly_carrier = comm_semiring_1_int,
    max_ordered_semiring_1_poly_carrier = max_ordered_semiring_1_int}
  : int poly_carrier;

val ordered_semiring_0_rat =
  {semiring_0_ordered_semiring_0 = semiring_0_rat,
    ordered_ab_semigroup_ordered_semiring_0 = ordered_ab_semigroup_rat}
  : rat ordered_semiring_0;

val ordered_semiring_1_rat =
  {semiring_1_ordered_semiring_1 = semiring_1_rat,
    ordered_semiring_0_ordered_semiring_1 = ordered_semiring_0_rat}
  : rat ordered_semiring_1;

val max_ordered_semiring_1_rat =
  {max_ordered_monoid_add_max_ordered_semiring_1 = max_ordered_monoid_add_rat,
    ordered_semiring_1_max_ordered_semiring_1 = ordered_semiring_1_rat}
  : rat max_ordered_semiring_1;

val poly_carrier_rat =
  {comm_semiring_1_poly_carrier = comm_semiring_1_rat,
    max_ordered_semiring_1_poly_carrier = max_ordered_semiring_1_rat}
  : rat poly_carrier;

fun shows_arctic_rat (Num_arc_rat i) = shows_prec_rat Zero_nat i
  | shows_arctic_rat MinInfty_rat = shows_string [#"-", #"i", #"n", #"f"];

fun shows_prec_arctic_rat d ari = shows_arctic_rat ari;

fun shows_list_arctic_rat asa =
  shows_list_aux (shows_prec_arctic_rat Zero_nat) asa;

val show_arctic_rat =
  {shows_prec = shows_prec_arctic_rat, shows_list = shows_list_arctic_rat} :
  arctic_rat show;

fun poly_inter_to_af i f n = poly_var equal_nat (i f n);

fun check_poly_weak_mono_all B_ p =
  list_all
    (fn (_, c) =>
      ge ((non_strict_order_ordered_ab_semigroup o
            ordered_ab_semigroup_ordered_semiring_0)
           B_)
        c (zero ((zero_mult_zero o mult_zero_semiring_0 o
                   semiring_0_ordered_semiring_0)
                  B_)))
    p;

fun check_poly_weak_mono_discrete A_ (B1_, B2_) p v =
  check_poly_ge A_
    ((ordered_semiring_0_ordered_semiring_1 o
       ordered_semiring_1_max_ordered_semiring_1 o
       max_ordered_semiring_1_poly_carrier)
      B2_)
    (poly_subst A_ (B1_, comm_semiring_1_poly_carrier B2_)
      (fn w =>
        poly_of A_ (B1_, comm_semiring_1_poly_carrier B2_)
          (if eq A_ w v
            then PSum [PNum (one ((one_power o power_monoid_mult o
                                    monoid_mult_semiring_1 o
                                    semiring_1_comm_semiring_1 o
                                    comm_semiring_1_poly_carrier)
                                   B2_)),
                        PVar v]
            else PVar w))
      p)
    p;

fun check_poly_weak_mono_and_pos A_ (B1_, B2_) discrete p =
  (if discrete
    then list_all (check_poly_weak_mono_discrete A_ (B1_, B2_) p)
           (poly_vars_list A_ p) andalso
           ge ((non_strict_order_ordered_ab_semigroup o
                 ordered_ab_semigroup_ordered_semiring_0 o
                 ordered_semiring_0_ordered_semiring_1 o
                 ordered_semiring_1_max_ordered_semiring_1 o
                 max_ordered_semiring_1_poly_carrier)
                B2_)
             (eval_poly (comm_semiring_1_poly_carrier B2_)
               (fn _ =>
                 zero ((zero_mult_zero o mult_zero_semiring_0 o
                         semiring_0_semiring_1 o semiring_1_comm_semiring_1 o
                         comm_semiring_1_poly_carrier)
                        B2_))
               p)
             (zero ((zero_mult_zero o mult_zero_semiring_0 o
                      semiring_0_semiring_1 o semiring_1_comm_semiring_1 o
                      comm_semiring_1_poly_carrier)
                     B2_))
    else check_poly_weak_mono_all
           ((ordered_semiring_0_ordered_semiring_1 o
              ordered_semiring_1_max_ordered_semiring_1 o
              max_ordered_semiring_1_poly_carrier)
             B2_)
           p);

fun check_poly_inter_list (B1_, B2_) discrete i =
  catch (catch
          (forallm
            (fn x =>
              (if let
                    val (_, a) = x;
                  in
                    check_poly_weak_mono_and_pos equal_nat (B1_, B2_) discrete a
                  end
                then Inr () else Inl x))
            i)
          (fn x => Inl (snd x)))
    (fn x =>
      Inl let
            val (a, b) = x;
          in
            let
              val (f, _) = a;
            in
              (fn aa => (f, aa))
            end
              b
          end);

fun poly_inter_list_to_inter A_ B_ def i =
  (fn f => fn n =>
    (case lookupa (equal_prod B_ equal_nat) (f, n) i
      of NONE => default_I A_ def n | SOME p => p));

fun check_monom_strict_mono A_ pm m v =
  not (null m) andalso
    (null (tl m) andalso
      (eq A_ (fst (hd m)) v andalso
        (if pm then less_eq_nat one_nata (snd (hd m))
          else equal_nata (snd (hd m)) one_nata)));

fun check_poly_strict_mono A_ B_ pm p v =
  list_ex
    (fn (m, c) =>
      ge ((non_strict_order_ordered_ab_semigroup o
            ordered_ab_semigroup_ordered_semiring_0 o
            ordered_semiring_0_ordered_semiring_1 o
            ordered_semiring_1_max_ordered_semiring_1 o
            max_ordered_semiring_1_poly_carrier)
           B_)
        c (one ((one_power o power_monoid_mult o monoid_mult_semiring_1 o
                  semiring_1_comm_semiring_1 o comm_semiring_1_poly_carrier)
                 B_)) andalso
        check_monom_strict_mono A_ pm m v)
    p;

fun check_poly_strict_mono_discrete (A1_, A2_) B_ gt p v =
  check_poly_gt
    ((ordered_semiring_0_ordered_semiring_1 o
       ordered_semiring_1_max_ordered_semiring_1 o
       max_ordered_semiring_1_poly_carrier)
      A2_)
    B_ gt
    (poly_subst B_ (A1_, comm_semiring_1_poly_carrier A2_)
      (fn w =>
        poly_of B_ (A1_, comm_semiring_1_poly_carrier A2_)
          (if eq B_ w v
            then PSum [PNum (one ((one_power o power_monoid_mult o
                                    monoid_mult_semiring_1 o
                                    semiring_1_comm_semiring_1 o
                                    comm_semiring_1_poly_carrier)
                                   A2_)),
                        PVar v]
            else PVar w))
      p)
    p;

fun check_poly_strict_mono_smart (A1_, A2_) B_ discrete pm gt p v =
  (if discrete then check_poly_strict_mono_discrete (A1_, A2_) B_ gt p v
    else check_poly_strict_mono B_ A2_ pm p v);

fun create_nlpoly_redtriple (A1_, A2_, A3_) (B1_, B2_) (C1_, C2_) def gt
  power_mono discrete i =
  let
    val j = poly_inter_list_to_inter A2_ B1_ def i;
    val x =
      poly_subst (equal_list equal_char) (A1_, comm_semiring_1_poly_carrier A2_)
        (fn n =>
          poly_of (equal_list equal_char)
            (A1_, comm_semiring_1_poly_carrier A2_)
            (PVar ([#"x", #"_"] @ shows_prec_nat Zero_nat n [])));
    val ns =
      (fn (s, t) =>
        let
          val p = eval_term (A1_, A2_) C1_ j s;
          val q = eval_term (A1_, A2_) C1_ j t;
        in
          check (check_poly_ge C1_
                  ((ordered_semiring_0_ordered_semiring_1 o
                     ordered_semiring_1_max_ordered_semiring_1 o
                     max_ordered_semiring_1_poly_carrier)
                    A2_)
                  p q)
            (shows_string
               [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                 #"e", #"n", #"s", #"u", #"r", #"e", #" "] o
              (shows_poly C2_ (A1_, A2_, A3_) p o
                (shows_string [#" ", #">", #"=", #" "] o
                  shows_poly C2_ (A1_, A2_, A3_) q)))
        end);
  in
    Redtriple_ext
      (catch (check_poly_inter_list (A1_, A2_) discrete i)
         (fn xa =>
           Inl let
                 val (f, p) = xa;
               in
                 shows_string
                   [#"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t", #"a",
                     #"t", #"i", #"o", #"n", #" "] o
                   (shows_poly (show_list show_char) (A1_, A2_, A3_) (x p) o
                     (shows_string [#" ", #"o", #"f", #" "] o
                       (shows_prec B2_ Zero_nat f o
                         shows_string
                           [#" ", #"i", #"n", #"v", #"a", #"l", #"i", #"d",
                             #" "])))
               end),
        (fn (s, t) =>
          let
            val p = eval_term (A1_, A2_) C1_ j s;
            val q = eval_term (A1_, A2_) C1_ j t;
          in
            check (check_poly_gt
                    ((ordered_semiring_0_ordered_semiring_1 o
                       ordered_semiring_1_max_ordered_semiring_1 o
                       max_ordered_semiring_1_poly_carrier)
                      A2_)
                    C1_ gt p q)
              (shows_string
                 [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                   #"e", #"n", #"s", #"u", #"r", #"e", #" "] o
                (shows_poly C2_ (A1_, A2_, A3_) p o
                  (shows_string [#" ", #">", #" "] o
                    shows_poly C2_ (A1_, A2_, A3_) q)))
          end),
        ns, ns, poly_inter_to_af j,
        catch (catch
                (forallm
                  (fn xa =>
                    (if let
                          val (a, b) = xa;
                        in
                          let
                            val (_, n) = a;
                          in
                            (fn p =>
                              all_interval_nat
                                (check_poly_strict_mono_smart (A1_, A2_)
                                  equal_nat discrete power_mono gt p)
                                Zero_nat n)
                          end
                            b
                        end
                      then Inr () else Inl xa))
                  i)
                (fn xa => Inl (snd xa)))
          (fn xa =>
            Inl let
                  val (a, b) = xa;
                in
                  let
                    val (f, _) = a;
                  in
                    (fn p =>
                      shows_string
                        [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t",
                          #" ", #"e", #"n", #"s", #"u", #"r", #"e", #" ", #"m",
                          #"o", #"n", #"o", #"t", #"o", #"n", #"i", #"c", #"t",
                          #"y", #" ", #"o", #"f", #" "] o
                        (shows_poly (show_list show_char) (A1_, A2_, A3_)
                           (x p) o
                          (shows_string
                             [#" ", #"a", #"s", #" ", #"i", #"n", #"t", #"e",
                               #"r", #"p", #"r", #"e", #"t", #"a", #"t", #"i",
                               #"o", #"n", #" ", #"o", #"f", #" "] o
                            shows_prec B2_ Zero_nat f)))
                  end
                    b
                end),
        shows_string
          [#"p", #"o", #"l", #"y", #"n", #"o", #"m", #"i", #"a", #"l", #" ",
            #"i", #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t", #"a", #"t",
            #"i", #"o", #"n"] o
          (shows_nl o
            shows_sep
              (fn (a, b) =>
                let
                  val (f, n) = a;
                in
                  (fn p =>
                    shows_string [#"P", #"o", #"l", #"("] o
                      (shows_prec B2_ Zero_nat f o
                        (shows_string [#"/"] o
                          (shows_prec_nat Zero_nat n o
                            (shows_string [#")", #" ", #"=", #" "] o
                              shows_poly (show_list show_char) (A1_, A2_, A3_)
                                (x p))))))
                end
                  b)
              shows_nl i),
        ())
  end;

fun create_afI A_ B_ ze [] f n = (fn _ => true)
  | create_afI A_ B_ ze (((g, m), (c, coeffs)) :: rest) f n =
    (if eq B_ f g andalso equal_nata m n
      then let
             val len = size_list coeffs;
           in
             (fn i => less_nat i len andalso not (eq A_ (nth coeffs i) ze))
           end
      else create_afI A_ B_ ze rest f n);

fun get_comp_ge
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  ge;

fun show_pvars (A1_, A2_) B_ on [] = []
  | show_pvars (A1_, A2_) B_ on ((x, c) :: vas) =
    ((if eq A1_ on c then [] else shows_prec A2_ Zero_nat c []) @
      shows_prec B_ Zero_nat x []) ::
      show_pvars (A1_, A2_) B_ on vas;

fun shows_lpoly (A1_, A2_) B_ ze on (LPoly (c, cs)) =
  (case show_pvars (A1_, A2_) B_ on cs of [] => shows_prec A2_ Zero_nat c
    | a :: lista =>
      (if eq A1_ c ze then id
        else shows_prec A2_ Zero_nat c o shows_string [#" ", #"+", #" "]) o
        shows_list_gen (shows_prec_list show_char Zero_nat) [] []
          [#" ", #"+", #" "] [] (a :: lista));

fun lookup_rest A_ x [] = NONE
  | lookup_rest A_ x ((y, c) :: ycs) =
    (if eq A_ x y then SOME (c, ycs)
      else (case lookup_rest A_ x ycs of NONE => NONE
             | SOME (d, yccs) => SOME (d, (y, c) :: yccs)));

fun check_pvarsI B_ ze ge vas [] =
  catch (forallm (fn va => check (ge (snd va) ze) (fst va)) vas)
    (fn x => Inl (snd x))
  | check_pvarsI B_ ze ge vas ((x, b) :: vbs) =
    let
      val (a, vasa) =
        (case lookup_rest B_ x vas of NONE => (ze, vas)
          | SOME (a, ba) => (a, ba));
    in
      bindb (check (ge a b) x) (fn _ => check_pvarsI B_ ze ge vasa vbs)
    end;

fun check_lpoly_sI (A1_, A2_) (B1_, B2_) mode ze on ge gt (LPoly (a, vas))
  (LPoly (b, vbs)) =
  catch (bindb
          (check (gt a b)
            (shows_string
              [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
                #"n", #" ", #"c", #"o", #"m", #"p", #"a", #"r", #"i", #"n",
                #"g", #" ", #"c", #"o", #"n", #"s", #"t", #"a", #"n", #"t",
                #" ", #"p", #"a", #"r", #"t"]))
          (fn _ =>
            catch (check_pvarsI B1_ ze (if mode then ge else gt) vas vbs)
              (fn x =>
                Inl (shows_string
                       [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w",
                         #"h", #"e", #"n", #" ", #"c", #"o", #"m", #"p", #"a",
                         #"r", #"i", #"n", #"g", #" ", #"c", #"o", #"e", #"f",
                         #"f", #"i", #"c", #"i", #"e", #"n", #"t", #"s", #" ",
                         #"o", #"f", #" ", #"v", #"a", #"r", #"i", #"a", #"b",
                         #"l", #"e", #" "] o
                      shows_prec B2_ Zero_nat x))))
    (fn x =>
      Inl (shows_string
             [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
               #"n", #" ", #"c", #"o", #"m", #"p", #"a", #"r", #"i", #"n", #"g",
               #" "] o
            (shows_lpoly (A1_, A2_) B2_ ze on (LPoly (a, vas)) o
              (shows_string [#" ", #">", #" "] o
                (shows_lpoly (A1_, A2_) B2_ ze on (LPoly (b, vbs)) o
                  (shows_nl o x))))));

fun check_polo_sI (A1_, A2_) B_ (C1_, C2_) mode ze on pl ti mz ge gt pi (s, t) =
  let
    val left = pleftI A1_ C1_ ze on pl ti mz pi s;
    val right = prightI A1_ C1_ ze on pl ti mz pi t;
  in
    catch (check_lpoly_sI (A1_, A2_) (C1_, C2_) mode ze on ge gt left right)
      (fn x =>
        Inl (shows_string
               [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                 #"e", #"n", #"s", #"u", #"r", #"e", #" "] o
              (shows_prec_term B_ C2_ Zero_nat s o
                (shows_string [#" ", #">", #" "] o
                  (shows_prec_term B_ C2_ Zero_nat t o (shows_nl o x))))))
  end;

fun get_comp_max0
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  mz;

fun check_lpoly_nsI (A1_, A2_) (B1_, B2_) ze on ge (LPoly (a, vas))
  (LPoly (b, vbs)) =
  catch (bindb
          (check (ge a b)
            (shows_string
              [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
                #"n", #" ", #"c", #"o", #"m", #"p", #"a", #"r", #"i", #"n",
                #"g", #" ", #"c", #"o", #"n", #"s", #"t", #"a", #"n", #"t",
                #" ", #"p", #"a", #"r", #"t", #"s"]))
          (fn _ =>
            catch (check_pvarsI B1_ ze ge vas vbs)
              (fn x =>
                Inl (shows_string
                       [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w",
                         #"h", #"e", #"n", #" ", #"c", #"o", #"m", #"p", #"a",
                         #"r", #"i", #"n", #"g", #" ", #"c", #"o", #"e", #"f",
                         #"f", #"i", #"c", #"i", #"e", #"n", #"t", #"s", #" ",
                         #"o", #"f", #" ", #"v", #"a", #"r", #"i", #"a", #"b",
                         #"l", #"e", #" "] o
                      shows_prec B2_ Zero_nat x))))
    (fn x =>
      Inl (shows_string
             [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e",
               #"n", #" ", #"c", #"o", #"m", #"p", #"a", #"r", #"i", #"n", #"g",
               #" "] o
            (shows_lpoly (A1_, A2_) B2_ ze on (LPoly (a, vas)) o
              (shows_string [#" ", #">", #"=", #" "] o
                (shows_lpoly (A1_, A2_) B2_ ze on (LPoly (b, vbs)) o
                  (shows_nl o x))))));

fun check_polo_nsI (A1_, A2_) B_ (C1_, C2_) ze on pl ti mz ge pi (s, t) =
  let
    val left = pleftI A1_ C1_ ze on pl ti mz pi s;
    val right = prightI A1_ C1_ ze on pl ti mz pi t;
  in
    catch (check_lpoly_nsI (A1_, A2_) (C1_, C2_) ze on ge left right)
      (fn x =>
        Inl (shows_string
               [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                 #"e", #"n", #"s", #"u", #"r", #"e", #" "] o
              (shows_prec_term B_ C2_ Zero_nat s o
                (shows_string [#" ", #">", #"=", #" "] o
                  (shows_prec_term B_ C2_ Zero_nat t o (shows_nl o x))))))
  end;

fun to_lpoly_inter B_ d on i f n =
  (case lookupa (equal_prod B_ equal_nat) (f, n) i
    of NONE => (d, replicate n on) | SOME cas => cas);

fun check_poly_monoI A_ B_ ze ge cm =
  (fn xs =>
    catch (forallm
            (fn (a, b) =>
              let
                val (f, n) = a;
              in
                (fn (c, cs) =>
                  catch (bindb
                          (check (ge c ze)
                            (shows_string
                               [#"c", #"o", #"n", #"s", #"t", #"a", #"n", #"t",
                                 #" ", #"p", #"a", #"r", #"t", #" "] o
                              (shows_prec A_ Zero_nat c o
                                (shows_string
                                   [#" ", #"m", #"u", #"s", #"t", #" ", #"b",
                                     #"e", #" ", #"a", #"t", #" ", #"l", #"e",
                                     #"a", #"s", #"t", #" "] o
                                  (shows_prec A_ Zero_nat ze o shows_nl)))))
                          (fn _ =>
                            bindb (check (less_eq_nat n (size_list cs))
                                    (shows_string
                                       [#"t", #"h", #"e", #" ", #"l", #"a",
 #"s", #"t", #" ", #"a", #"r", #"g", #"u", #"m", #"e", #"n", #"t", #" ", #"i",
 #"s", #" ", #"i", #"g", #"n", #"o", #"r", #"e", #"d"] o
                                      shows_nl))
                              (fn _ =>
                                catch (forallm
(fn d =>
  check (cm d)
    (shows_string
       [#"c", #"o", #"e", #"f", #"f", #"i", #"c", #"i", #"e", #"n", #"t",
         #" "] o
      (shows_prec A_ Zero_nat d o
        (shows_string
           [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l",
             #"o", #"w", #"e", #"d"] o
          shows_nl))))
cs)
                                  (fn x => Inl (snd x)))))
                    (fn x =>
                      Inl (shows_string
                             [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                               #"w", #"i", #"t", #"h", #" ", #"m", #"o", #"n",
                               #"o", #"t", #"o", #"n", #"i", #"c", #"i", #"t",
                               #"y", #" ", #"d", #"u", #"e", #" ", #"t", #"o",
                               #" ", #"i", #"n", #"t", #"e", #"r", #"p", #"r",
                               #"e", #"t", #"a", #"t", #"i", #"o", #"n", #" ",
                               #"o", #"f", #" "] o
                            (shows_prec B_ Zero_nat f o
                              (shows_string [#"/"] o
                                (shows_prec_nat Zero_nat n o
                                  (shows_nl o x)))))))
              end
                b)
            xs)
      (fn x => Inl (snd x)));

fun get_comp_wf_elem
  (wfe, (ze, (on, (def, (pl, (ti, (mz, (ge, (gt, (mo, (de, (ap, cm)))))))))))) =
  wfe;

fun create_lpoly_repr (A1_, A2_) (B1_, B2_) c i =
  let
    val pi = to_lpoly_inter B1_ (get_comp_def c) (get_comp_1 c) i;
  in
    shows_string
      [#"p", #"o", #"l", #"y", #"n", #"o", #"m", #"i", #"a", #"l", #" ", #"i",
        #"n", #"t", #"e", #"r", #"p", #"r", #"e", #"t", #"r", #"a", #"t", #"i",
        #"o", #"n", #" ", #"o", #"v", #"e", #"r", #" "] o
      (shows_string (get_comp_description c) o
        (shows_nl o
          shows_sep
            (fn (f, n) =>
              let
                val t =
                  Fun (f, mapa Var
                            (fresh_strings_list [#"x", #"_"] one_nata [] n));
              in
                shows_string [#"P", #"o", #"l", #"("] o
                  (shows_prec_term B2_ (show_list show_char) Zero_nat t o
                    (shows_string [#")", #" ", #"=", #" "] o
                      shows_lpoly (A1_, A2_) (show_list show_char)
                        (get_comp_0 c) (get_comp_1 c)
                        (pleftI A1_ (equal_list equal_char) (get_comp_0 c)
                          (get_comp_1 c) (get_comp_plus c) (get_comp_times c)
                          (get_comp_max0 c) pi t)))
              end)
            shows_nl (remdups (equal_prod B1_ equal_nat) (mapa fst i))))
  end;

fun check_lpoly_coeffs A_ B_ wfe apos ch i =
  catch (forallm
          (fn (a, b) =>
            let
              val (f, n) = a;
            in
              (fn (c, cs) =>
                catch (bindb
                        (check (wfe c)
                          (shows_string
                             [#"c", #"o", #"n", #"s", #"t", #"a", #"n", #"t",
                               #" ", #"p", #"a", #"r", #"t", #" "] o
                            (shows_prec A_ Zero_nat c o
                              (shows_string
                                 [#" ", #"i", #"s", #" ", #"n", #"o", #"t",
                                   #" ", #"w", #"e", #"l", #"l", #"-", #"f",
                                   #"o", #"r", #"m", #"e", #"d"] o
                                shows_nl))))
                        (fn _ =>
                          bindb (check (apos c orelse list_ex apos (take n cs))
                                  (shows_string
                                     [#"c", #"o", #"u", #"l", #"d", #" ", #"n",
                                       #"o", #"t", #" ", #"f", #"i", #"n", #"d",
                                       #" ", #"p", #"o", #"s", #"i", #"t", #"i",
                                       #"v", #"e", #" ", #"e", #"n", #"t", #"r",
                                       #"y", #" ", #"w", #"h", #"i", #"c", #"h",
                                       #" ", #"i", #"s", #" ", #"r", #"e", #"q",
                                       #"u", #"i", #"r", #"e", #"d", #" ", #"f",
                                       #"o", #"r", #" ", #"a", #"r", #"c", #"t",
                                       #"i", #"c", #" ", #"i", #"n", #"t", #"e",
                                       #"r", #"p", #"r", #"e", #"t", #"a", #"t",
                                       #"i", #"o", #"n", #"s"] o
                                    shows_nl))
                            (fn _ =>
                              catch (forallm
                                      (fn aa =>
check (ch aa andalso wfe aa)
  (shows_string
     [#"c", #"o", #"e", #"f", #"f", #"i", #"c", #"i", #"e", #"n", #"t", #" "] o
    (shows_prec A_ Zero_nat aa o
      (shows_string
         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #"l", #"l",
           #"o", #"w", #"e", #"d"] o
        shows_nl))))
                                      cs)
                                (fn x => Inl (snd x)))))
                  (fn x =>
                    Inl (shows_string
                           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                             #"w", #"i", #"t", #"h", #" ", #"i", #"n", #"t",
                             #"e", #"r", #"p", #"r", #"e", #"t", #"a", #"t",
                             #"i", #"o", #"n", #" ", #"o", #"f", #" "] o
                          (shows_prec B_ Zero_nat f o
                            (shows_string [#"/"] o
                              (shows_prec_nat Zero_nat n o (shows_nl o x)))))))
            end
              b)
          i)
    (fn x => Inl (snd x));

fun create_poly_redtriple (A1_, A2_) (B1_, B2_) (C1_, C2_) cI c i =
  let
    val pi = to_lpoly_inter A1_ (get_comp_def c) (get_comp_1 c) i;
    val ns =
      check_polo_nsI (B1_, B2_) A2_ (C1_, C2_) (get_comp_0 c) (get_comp_1 c)
        (get_comp_plus c) (get_comp_times c) (get_comp_max0 c) (get_comp_ge c)
        pi;
  in
    Redtriple_ext
      (bindb (cI i)
         (fn _ =>
           check_lpoly_coeffs B2_ A2_ (get_comp_wf_elem c) (get_comp_apos c)
             (fn x => get_comp_ge c x (get_comp_0 c)) i),
        check_polo_sI (B1_, B2_) A2_ (C1_, C2_) (get_comp_mono c) (get_comp_0 c)
          (get_comp_1 c) (get_comp_plus c) (get_comp_times c) (get_comp_max0 c)
          (get_comp_ge c) (get_comp_gt c) pi,
        ns, ns, create_afI B1_ A1_ (get_comp_0 c) i,
        bindb (check (get_comp_mono c)
                (shows_string
                  [#"m", #"o", #"n", #"o", #"t", #"o", #"n", #"e", #" ", #"p",
                    #"o", #"l", #"y", #"n", #"o", #"m", #"i", #"a", #"l", #"s",
                    #" ", #"n", #"o", #"t", #" ", #"s", #"u", #"p", #"p", #"o",
                    #"r", #"t", #" ", #"f", #"o", #"r", #" ", #"t", #"h", #"i",
                    #"s", #" ", #"d", #"o", #"m", #"a", #"i", #"n"]))
          (fn _ =>
            check_poly_monoI B2_ A2_ (get_comp_0 c) (get_comp_ge c)
              (get_comp_check_mono c) i),
        create_lpoly_repr (B1_, B2_) (A1_, A2_) c i, ())
  end;

fun prec_repr_to_pr A_ prs (FPair (f, a)) uu =
  (case lookupa (equal_prod A_ equal_nat) (f, a) prs of NONE => Zero_nat
    | SOME aa => fst aa);

fun faulty_redtriple A_ B_ s =
  Redtriple_ext
    (Inl (shows_string s), (fn _ => Inr ()), (fn _ => Inr ()), (fn _ => Inr ()),
      full_af, Inr (), id, ());

fun prec_repr_to_status A_ prs (FPair (f, a)) uu =
  (case lookupa (equal_prod A_ equal_nat) (f, a) prs of NONE => Lex
    | SOME aa => snd aa);

fun get_redtriple (A1_, A2_) (B1_, B2_) (Int_carrier i) =
  create_poly_redtriple (A1_, A2_) (equal_int, show_int) (B1_, B2_)
    (fn _ => Inr ())
    ((fn _ => true),
      ((0 : IntInf.int),
        ((1 : IntInf.int),
          ((1 : IntInf.int),
            ((fn a => fn b => a + b),
              ((fn a => fn b => a * b),
                (max0_int,
                  (ge_int,
                    ((fn x => fn y => y < x),
                      (true, (int_name, ((fn _ => true), int_mono))))))))))))
    i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Int_nl_carrier i) =
    create_nlpoly_redtriple (equal_int, poly_carrier_int, show_int) (A1_, A2_)
      (B1_, B2_) (1 : IntInf.int) (fn x => fn y => y < x) true true i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Rat_carrier (d, i)) =
    create_poly_redtriple (A1_, A2_) (equal_rat, show_rat) (B1_, B2_)
      (fn _ =>
        check (less_rat (fract (0 : IntInf.int) (1 : IntInf.int)) d)
          (shows_string
            [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"e", #"l",
              #"t", #"a"]))
      ((fn _ => true),
        (fract (0 : IntInf.int) (1 : IntInf.int),
          (fract (1 : IntInf.int) (1 : IntInf.int),
            (d, (plus_rata,
                  (times_rata,
                    (max0_rat,
                      (ge_rat,
                        (rat_gt d,
                          (true,
                            (rat_name, ((fn _ => true), rat_mono))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Rat_nl_carrier (d, i)) =
    (if less_rat (fract (0 : IntInf.int) (1 : IntInf.int)) d
      then create_nlpoly_redtriple (equal_rat, poly_carrier_rat, show_rat)
             (A1_, A2_) (B1_, B2_) d (rat_gt d)
             (less_eq_rat (fract (1 : IntInf.int) (1 : IntInf.int)) d) false i
      else faulty_redtriple A2_ B2_
             [#"d", #"e", #"l", #"t", #"a", #" ", #"m", #"u", #"s", #"t", #" ",
               #"b", #"e", #" ", #"l", #"a", #"r", #"g", #"e", #"r", #" ", #"t",
               #"h", #"a", #"n", #" ", #"z", #"e", #"r", #"o"])
  | get_redtriple (A1_, A2_) (B1_, B2_) (Arctic_carrier i) =
    create_poly_redtriple (A1_, A2_) (equal_arctic, show_arctic) (B1_, B2_)
      (fn _ => Inr ())
      ((fn _ => true),
        (zero_arctic,
          (one_arctic,
            (one_arctic,
              (plus_arctic,
                (times_arctic,
                  (id, (ge_arctic,
                         (gt_arctic,
                           (false,
                             (arctic_name,
                               (pos_arctic, (fn _ => false)))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Arctic_rat_carrier (d, i)) =
    create_poly_redtriple (A1_, A2_) (equal_arctic_rat, show_arctic_rat)
      (B1_, B2_)
      (fn _ =>
        check (less_rat (fract (0 : IntInf.int) (1 : IntInf.int)) d)
          (shows_string
            [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"e", #"l",
              #"t", #"a"]))
      ((fn _ => true),
        (zero_arctic_rat,
          (one_arctic_rat,
            (one_arctic_rat,
              (plus_arctic_rat,
                (times_arctic_rat,
                  (id, (ge_arctic_rat,
                         (gt_arctic_rat d,
                           (false,
                             (arctic_rat_name,
                               (pos_arctic_rat, (fn _ => false)))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Int_mat_carrier (n, sd, i)) =
    create_poly_redtriple (A1_, A2_)
      (equal_list (equal_list equal_int), show_list (show_list show_int))
      (B1_, B2_)
      (fn _ =>
        bindb (Inr ())
          (fn _ =>
            check (less_nat Zero_nat sd andalso less_eq_nat sd n)
              (shows_string
                [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"i",
                  #"m", #"e", #"n", #"s", #"i", #"o", #"n"])))
      (mat n n,
        (mat0I (0 : IntInf.int) n n,
          (mat1I (0 : IntInf.int) (1 : IntInf.int) n,
            (mat1I (0 : IntInf.int)
               (get_comp_def
                 ((fn _ => true),
                   ((0 : IntInf.int),
                     ((1 : IntInf.int),
                       ((1 : IntInf.int),
                         ((fn a => fn b => a + b),
                           ((fn a => fn b => a * b),
                             (max0_int,
                               (ge_int,
                                 ((fn x => fn y => y < x),
                                   (true,
                                     (int_name,
                                       ((fn _ => true), int_mono)))))))))))))
               n,
              (mat_plusI (fn a => fn b => a + b),
                (mat_multI (0 : IntInf.int) (fn a => fn b => a + b)
                   (fn a => fn b => a * b) n,
                  (mat_max0 max_ordered_monoid_add_int,
                    (mat_ge non_strict_order_int,
                      (mat_gtI non_strict_order_int
                         (get_comp_gt
                           ((fn _ => true),
                             ((0 : IntInf.int),
                               ((1 : IntInf.int),
                                 ((1 : IntInf.int),
                                   ((fn a => fn b => a + b),
                                     ((fn a => fn b => a * b),
                                       (max0_int,
 (ge_int,
   ((fn x => fn y => y < x),
     (true, (int_name, ((fn _ => true), int_mono)))))))))))))
                         sd,
                        (get_comp_mono
                           ((fn _ => true),
                             ((0 : IntInf.int),
                               ((1 : IntInf.int),
                                 ((1 : IntInf.int),
                                   ((fn a => fn b => a + b),
                                     ((fn a => fn b => a * b),
                                       (max0_int,
 (ge_int,
   ((fn x => fn y => y < x),
     (true, (int_name, ((fn _ => true), int_mono)))))))))))),
                          (concat
                             [shows_prec_nat Zero_nat n [], [#"x"],
                               shows_prec_nat Zero_nat n [],
                               [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e",
                                 #"s", #" ", #"w", #"i", #"t", #"h", #" ", #"s",
                                 #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
                                 #"m", #"e", #"n", #"s", #"i", #"o", #"n",
                                 #" "],
                               shows_prec_nat Zero_nat sd [],
                               [#" ", #"o", #"v", #"e", #"r", #" "],
                               get_comp_description
                                 ((fn _ => true),
                                   ((0 : IntInf.int),
                                     ((1 : IntInf.int),
                                       ((1 : IntInf.int),
 ((fn a => fn b => a + b),
   ((fn a => fn b => a * b),
     (max0_int,
       (ge_int,
         ((fn x => fn y => y < x),
           (true, (int_name, ((fn _ => true), int_mono))))))))))))],
                            ((fn _ => true),
                              mat_mono sd
                                (get_comp_check_mono
                                  ((fn _ => true),
                                    ((0 : IntInf.int),
                                      ((1 : IntInf.int),
((1 : IntInf.int),
  ((fn a => fn b => a + b),
    ((fn a => fn b => a * b),
      (max0_int,
        (ge_int,
          ((fn x => fn y => y < x),
            (true, (int_name, ((fn _ => true), int_mono)))))))))))))))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Rat_mat_carrier (d, n, sd, i)) =
    create_poly_redtriple (A1_, A2_)
      (equal_list (equal_list equal_rat), show_list (show_list show_rat))
      (B1_, B2_)
      (fn _ =>
        bindb (check (less_rat (fract (0 : IntInf.int) (1 : IntInf.int)) d)
                (shows_string
                  [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"e",
                    #"l", #"t", #"a"]))
          (fn _ =>
            check (less_nat Zero_nat sd andalso less_eq_nat sd n)
              (shows_string
                [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"i",
                  #"m", #"e", #"n", #"s", #"i", #"o", #"n"])))
      (mat n n,
        (mat0I (fract (0 : IntInf.int) (1 : IntInf.int)) n n,
          (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
             (fract (1 : IntInf.int) (1 : IntInf.int)) n,
            (mat1I (fract (0 : IntInf.int) (1 : IntInf.int))
               (get_comp_def
                 ((fn _ => true),
                   (fract (0 : IntInf.int) (1 : IntInf.int),
                     (fract (1 : IntInf.int) (1 : IntInf.int),
                       (d, (plus_rata,
                             (times_rata,
                               (max0_rat,
                                 (ge_rat,
                                   (rat_gt d,
                                     (true,
                                       (rat_name,
 ((fn _ => true), rat_mono)))))))))))))
               n,
              (mat_plusI plus_rata,
                (mat_multI (fract (0 : IntInf.int) (1 : IntInf.int)) plus_rata
                   times_rata n,
                  (mat_max0 max_ordered_monoid_add_rat,
                    (mat_ge non_strict_order_rat,
                      (mat_gtI non_strict_order_rat
                         (get_comp_gt
                           ((fn _ => true),
                             (fract (0 : IntInf.int) (1 : IntInf.int),
                               (fract (1 : IntInf.int) (1 : IntInf.int),
                                 (d, (plus_rata,
                                       (times_rata,
 (max0_rat,
   (ge_rat, (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))))
                         sd,
                        (get_comp_mono
                           ((fn _ => true),
                             (fract (0 : IntInf.int) (1 : IntInf.int),
                               (fract (1 : IntInf.int) (1 : IntInf.int),
                                 (d, (plus_rata,
                                       (times_rata,
 (max0_rat,
   (ge_rat, (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono)))))))))))),
                          (concat
                             [shows_prec_nat Zero_nat n [], [#"x"],
                               shows_prec_nat Zero_nat n [],
                               [#" ", #"m", #"a", #"t", #"r", #"i", #"c", #"e",
                                 #"s", #" ", #"w", #"i", #"t", #"h", #" ", #"s",
                                 #"t", #"r", #"i", #"c", #"t", #" ", #"d", #"i",
                                 #"m", #"e", #"n", #"s", #"i", #"o", #"n",
                                 #" "],
                               shows_prec_nat Zero_nat sd [],
                               [#" ", #"o", #"v", #"e", #"r", #" "],
                               get_comp_description
                                 ((fn _ => true),
                                   (fract (0 : IntInf.int) (1 : IntInf.int),
                                     (fract (1 : IntInf.int) (1 : IntInf.int),
                                       (d,
 (plus_rata,
   (times_rata,
     (max0_rat,
       (ge_rat,
         (rat_gt d, (true, (rat_name, ((fn _ => true), rat_mono))))))))))))],
                            ((fn _ => true),
                              mat_mono sd
                                (get_comp_check_mono
                                  ((fn _ => true),
                                    (fract (0 : IntInf.int) (1 : IntInf.int),
                                      (fract (1 : IntInf.int) (1 : IntInf.int),
(d, (plus_rata,
      (times_rata,
        (max0_rat,
          (ge_rat,
            (rat_gt d,
              (true,
                (rat_name, ((fn _ => true), rat_mono)))))))))))))))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Arc_mat_carrier (n, i)) =
    create_poly_redtriple (A1_, A2_)
      (equal_list (equal_list equal_arctic), show_list (show_list show_arctic))
      (B1_, B2_)
      (fn _ =>
        bindb (Inr ())
          (fn _ =>
            check (less_nat Zero_nat n)
              (shows_string
                [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"i",
                  #"m", #"e", #"n", #"s", #"i", #"o", #"n"])))
      (mat n n,
        (mat0I zero_arctic n n,
          (mat1I zero_arctic one_arctic n,
            (mat1I zero_arctic
               (get_comp_def
                 ((fn _ => true),
                   (zero_arctic,
                     (one_arctic,
                       (one_arctic,
                         (plus_arctic,
                           (times_arctic,
                             (id, (ge_arctic,
                                    (gt_arctic,
                                      (false,
(arctic_name, (pos_arctic, (fn _ => false))))))))))))))
               n,
              (mat_plusI plus_arctic,
                (mat_multI zero_arctic plus_arctic times_arctic n,
                  (id, (mat_ge non_strict_order_arctic,
                         (mat_comp_all
                            (get_comp_gt
                              ((fn _ => true),
                                (zero_arctic,
                                  (one_arctic,
                                    (one_arctic,
                                      (plus_arctic,
(times_arctic,
  (id, (ge_arctic,
         (gt_arctic,
           (false, (arctic_name, (pos_arctic, (fn _ => false)))))))))))))),
                           (false,
                             (concat
                                [shows_prec_nat Zero_nat n [], [#"x"],
                                  shows_prec_nat Zero_nat n [],
                                  [#" ", #"m", #"a", #"t", #"r", #"i", #"c",
                                    #"e", #"s", #" ", #"o", #"v", #"e", #"r",
                                    #" "],
                                  get_comp_description
                                    ((fn _ => true),
                                      (zero_arctic,
(one_arctic,
  (one_arctic,
    (plus_arctic,
      (times_arctic,
        (id, (ge_arctic,
               (gt_arctic,
                 (false,
                   (arctic_name, (pos_arctic, (fn _ => false)))))))))))))],
                               (mat_arc_posI
                                  (get_comp_apos
                                    ((fn _ => true),
                                      (zero_arctic,
(one_arctic,
  (one_arctic,
    (plus_arctic,
      (times_arctic,
        (id, (ge_arctic,
               (gt_arctic,
                 (false,
                   (arctic_name, (pos_arctic, (fn _ => false)))))))))))))),
                                 (fn _ => false)))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Arc_rat_mat_carrier (d, n, i)) =
    create_poly_redtriple (A1_, A2_)
      (equal_list (equal_list equal_arctic_rat),
        show_list (show_list show_arctic_rat))
      (B1_, B2_)
      (fn _ =>
        bindb (check (less_rat (fract (0 : IntInf.int) (1 : IntInf.int)) d)
                (shows_string
                  [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"e",
                    #"l", #"t", #"a"]))
          (fn _ =>
            check (less_nat Zero_nat n)
              (shows_string
                [#"i", #"n", #"v", #"a", #"l", #"i", #"d", #" ", #"d", #"i",
                  #"m", #"e", #"n", #"s", #"i", #"o", #"n"])))
      (mat n n,
        (mat0I zero_arctic_rat n n,
          (mat1I zero_arctic_rat one_arctic_rat n,
            (mat1I zero_arctic_rat
               (get_comp_def
                 ((fn _ => true),
                   (zero_arctic_rat,
                     (one_arctic_rat,
                       (one_arctic_rat,
                         (plus_arctic_rat,
                           (times_arctic_rat,
                             (id, (ge_arctic_rat,
                                    (gt_arctic_rat d,
                                      (false,
(arctic_rat_name, (pos_arctic_rat, (fn _ => false))))))))))))))
               n,
              (mat_plusI plus_arctic_rat,
                (mat_multI zero_arctic_rat plus_arctic_rat times_arctic_rat n,
                  (id, (mat_ge non_strict_order_arctic_rat,
                         (mat_comp_all
                            (get_comp_gt
                              ((fn _ => true),
                                (zero_arctic_rat,
                                  (one_arctic_rat,
                                    (one_arctic_rat,
                                      (plus_arctic_rat,
(times_arctic_rat,
  (id, (ge_arctic_rat,
         (gt_arctic_rat d,
           (false,
             (arctic_rat_name, (pos_arctic_rat, (fn _ => false)))))))))))))),
                           (false,
                             (concat
                                [shows_prec_nat Zero_nat n [], [#"x"],
                                  shows_prec_nat Zero_nat n [],
                                  [#" ", #"m", #"a", #"t", #"r", #"i", #"c",
                                    #"e", #"s", #" ", #"o", #"v", #"e", #"r",
                                    #" "],
                                  get_comp_description
                                    ((fn _ => true),
                                      (zero_arctic_rat,
(one_arctic_rat,
  (one_arctic_rat,
    (plus_arctic_rat,
      (times_arctic_rat,
        (id, (ge_arctic_rat,
               (gt_arctic_rat d,
                 (false,
                   (arctic_rat_name,
                     (pos_arctic_rat, (fn _ => false)))))))))))))],
                               (mat_arc_posI
                                  (get_comp_apos
                                    ((fn _ => true),
                                      (zero_arctic_rat,
(one_arctic_rat,
  (one_arctic_rat,
    (plus_arctic_rat,
      (times_arctic_rat,
        (id, (ge_arctic_rat,
               (gt_arctic_rat d,
                 (false,
                   (arctic_rat_name,
                     (pos_arctic_rat, (fn _ => false)))))))))))))),
                                 (fn _ => false)))))))))))))
      i
  | get_redtriple (A1_, A2_) (B1_, B2_) (Rpo (prec_tau, pi)) =
    af_redtriple (A1_, A2_) B2_ pi
      (create_RPO_redtriple A2_ (equal_filtered A1_, show_filtered A2_)
        (B1_, B2_)
        (fn pr => (prec_repr_to_pr A1_ pr, prec_repr_to_status A1_ pr))
        prec_tau);

fun check_weak (A1_, A2_) (B1_, B2_) p r =
  catch (check (equal_terma A1_ B1_ (proj_term p (fst r)) (proj_term p (snd r)))
          (shows_string
             [#"t", #"h", #"e", #" ", #"p", #"r", #"o", #"j", #"e", #"c", #"t",
               #"e", #"d", #" ", #"l", #"h", #"s", #" ", #"i", #"s", #" ", #"n",
               #"o", #"t", #" ", #"e", #"q", #"u", #"a", #"l", #" ", #"t", #"o",
               #" ", #"t", #"h", #"e", #" ", #"p", #"r", #"o", #"j", #"e", #"c",
               #"t", #"e", #"d", #" ", #"r", #"h", #"s"] o
            shows_nl))
    (fn x =>
      Inl (shows_string
             [#"C", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"o",
               #"r", #"i", #"e", #"n", #"t", #" ", #"r", #"u", #"l", #"e",
               #" "] o
            (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
               [#" ", #"-", #">", #" "] r o
              (shows_string [#",", #" ", #"s", #"i", #"n", #"c", #"e"] o
                (shows_nl o
                  (shows_prec_term A2_ B2_ Zero_nat (proj_term p (fst r)) o
                    (shows_string [#" ", #"!", #"=", #" "] o
                      (shows_prec_term A2_ B2_ Zero_nat (proj_term p (snd r)) o
                        (shows_nl o x)))))))));

fun is_QNFc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = is_QNF;

fun q_emptyc
  (Dpp_ops_ext
    (dpp, p, pw, pairs, q, r, rw, rules, q_empty, rules_no_left_var,
      rules_non_collapsing, is_QNF, nFQ_subset_NF_rules, rules_map,
      reverse_rules_map, intersect_pairs, delete_P_Pw, delete_R_Rw, split_pairs,
      split_rules, mk, more))
  = q_empty;

fun check_strict_rstep (A1_, A2_) (B1_, B2_) ra rseqm p r =
  let
    val s = proj_term p (fst r);
    val t = proj_term p (snd r);
  in
    (case rseqm r of NONE => check_supt (A1_, A2_) (B1_, B2_) s t
      | SOME rseq =>
        (if equal_nata (size_list rseq) Zero_nat
          then check_supt (A1_, A2_) (B1_, B2_) s t
          else let
                 val u = snd (snd (last rseq));
               in
                 bindb (check_rsteps (A1_, A2_) (B1_, B2_) ra rseq s u)
                   (fn _ => check_supteq (A1_, A2_) (B1_, B2_) u t)
               end))
  end;

fun check_prop_rstep (A1_, A2_) (B1_, B2_) pa r p rule s t =
  let
    val sps = poss_list s;
    val tps = poss_list t;
  in
    bindb (check (list_ex (eq_rule_mod_vars A1_ B1_ rule) r)
            (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
               [#" ", #"-", #">", #" "] rule o
              (shows_string
                 [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #" ",
                   #"r", #"u", #"l", #"e", #" ", #"o", #"f"] o
                (shows_nl o
                  (shows_trs (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
                     [#" ", #"-", #">", #" "]
                     [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s",
                       #"y", #"s", #"t", #"e", #"m", #":"]
                     r o
                    shows_nl)))))
      (fn _ =>
        bindb (check (membera equal_pos sps p)
                (shows_prec_pos Zero_nat p o
                  (shows_string
                     [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a",
                       #" ", #"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n",
                       #" ", #"o", #"f", #" "] o
                    (shows_prec_term A2_ B2_ Zero_nat s o shows_nl))))
          (fn _ =>
            bindb (check (membera equal_pos tps p)
                    (shows_prec_pos Zero_nat p o
                      (shows_string
                         [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"a",
                           #" ", #"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n",
                           #" ", #"o", #"f", #" "] o
                        (shows_prec_term A2_ B2_ Zero_nat t o shows_nl))))
              (fn _ =>
                let
                  val c = ctxt_of_pos_term p s;
                  val d = ctxt_of_pos_term p t;
                  val u = subt_at s p;
                  val v = subt_at t p;
                in
                  (case match_list A1_ B1_ [(u, fst rule), (v, snd rule)]
                    of NONE =>
                      Inl (shows_string
                             [#"t", #"h", #"e", #" ", #"t", #"e", #"r", #"m",
                               #" "] o
                            (shows_prec_term A2_ B2_ Zero_nat t o
                              (shows_string
                                 [#" ", #"d", #"o", #"e", #"s", #" ", #"n",
                                   #"o", #"t", #" ", #"r", #"e", #"s", #"u",
                                   #"l", #"t", #" ", #"f", #"r", #"o", #"m",
                                   #" ", #"a", #" ", #"p", #"r", #"o", #"p",
                                   #"e", #"r", #" ", #"a", #"p", #"p", #"l",
                                   #"i", #"c", #"a", #"t", #"i", #"o", #"n",
                                   #" ", #"o", #"f", #" ", #"r", #"u", #"l",
                                   #"e", #" "] o
                                (shows_nl o
                                  (shows_rule (shows_prec A2_ Zero_nat)
                                     (shows_prec B2_ Zero_nat)
                                     [#" ", #"-", #">", #" "] rule o
                                    (shows_string
                                       [#" ", #"a", #"t", #" ", #"p", #"o",
 #"s", #"i", #"t", #"i", #"o", #"n", #" "] o
                                      (shows_prec_pos Zero_nat p o
shows_nl)))))))
                    | SOME _ =>
                      bindb (catch (forallm pa (args u)) (fn x => Inl (snd x)))
                        (fn _ =>
                          check (equal_ctxt A1_ B1_ c d)
                            (shows_string
                               [#"t", #"h", #"e", #" ", #"t", #"e", #"r", #"m",
                                 #" "] o
                              (shows_prec_term A2_ B2_ Zero_nat t o
                                (shows_string
                                   [#" ", #"d", #"o", #"e", #"s", #" ", #"n",
                                     #"o", #"t", #" ", #"r", #"e", #"s", #"u",
                                     #"l", #"t", #" ", #"f", #"r", #"o", #"m",
                                     #" ", #"a", #" ", #"p", #"r", #"o", #"p",
                                     #"e", #"r", #" ", #"a", #"p", #"p", #"l",
                                     #"i", #"c", #"a", #"t", #"i", #"o", #"n",
                                     #" ", #"o", #"f", #" ", #"r", #"u", #"l",
                                     #"e", #" "] o
                                  (shows_nl o
                                    (shows_rule (shows_prec A2_ Zero_nat)
                                       (shows_prec B2_ Zero_nat)
                                       [#" ", #"-", #">", #" "] rule o
                                      (shows_string
 [#" ", #"a", #"t", #" ", #"p", #"o", #"s", #"i", #"t", #"i", #"o", #"n",
   #" "] o
(shows_prec_pos Zero_nat p o shows_nl)))))))))
                end)))
  end;

fun check_qrstep (A1_, A2_) (B1_, B2_) nf =
  check_prop_rstep (A1_, A2_) (B1_, B2_)
    (fn t =>
      check (nf t)
        (shows_prec_term A2_ B2_ Zero_nat t o
          shows_prec_list show_char Zero_nat
            [#" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"i", #"n", #" ",
              #"Q", #"-", #"n", #"o", #"r", #"m", #"a", #"l", #" ", #"f", #"o",
              #"r", #"m"]));

fun check_strict_qrstep (A1_, A2_) (B1_, B2_) nf ra rseqm p r =
  let
    val s = proj_term p (fst r);
    val t = proj_term p (snd r);
  in
    (case rseqm r of NONE => check_supt (A1_, A2_) (B1_, B2_) s t
      | SOME [] =>
        Inl (shows_string
              [#"m", #"o", #"r", #"e", #" ", #"t", #"h", #"a", #"n", #" ", #"a",
                #" ", #"s", #"i", #"n", #"g", #"l", #"e", #" ", #"Q", #"-",
                #"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s", #"t",
                #"e", #"p", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ",
                #"a", #"l", #"l", #"o", #"w", #"e", #"d"])
      | SOME [(pos, (rule, u))] =>
        bindb (check_qrstep (A1_, A2_) (B1_, B2_) nf ra pos rule s u)
          (fn _ => check_supteq (A1_, A2_) (B1_, B2_) u t)
      | SOME ((pos, (rule, u)) :: _ :: _) =>
        Inl (shows_string
              [#"m", #"o", #"r", #"e", #" ", #"t", #"h", #"a", #"n", #" ", #"a",
                #" ", #"s", #"i", #"n", #"g", #"l", #"e", #" ", #"Q", #"-",
                #"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s", #"t",
                #"e", #"p", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ",
                #"a", #"l", #"l", #"o", #"w", #"e", #"d"]))
  end;

fun subterm_criterion_proc (B1_, B2_) (C1_, C2_) i p rseqm prm dpp =
  (case let
          val pa = pairsa i dpp;
          val r = rulesd i dpp;
          val pb = snd (split_pairsa i dpp prm);
        in
          bindb (catch
                  (forallm
                    (fn (l, ra) =>
                      bindb (check_no_var B2_ C2_ l)
                        (fn _ =>
                          bindb (check_no_var B2_ C2_ ra)
                            (fn _ =>
                              check_no_defined_root B2_ C2_
                                (fn fna => not (null (rules_mapb i dpp fna)))
                                ra)))
                    pa)
                  (fn x => Inl (snd x)))
            (fn _ =>
              bindb (if q_emptyc i dpp
                      then catch (forallm
                                   (check_strict_rstep (B1_, B2_) (C1_, C2_) r
                                     rseqm p)
                                   prm)
                             (fn x => Inl (snd x))
                      else catch (forallm
                                   (check_strict_qrstep (B1_, B2_) (C1_, C2_)
                                     (is_QNFc i dpp) r rseqm p)
                                   prm)
                             (fn x => Inl (snd x)))
                (fn _ =>
                  catch (forallm (check_weak (B1_, B2_) (C1_, C2_) p) pb)
                    (fn x => Inl (snd x))))
        end
    of Inl a => Inl a | Inr _ => Inr (delete_P_Pwa i dpp prm prm));

fun min_set_ext s_ns =
  (fn asa => fn bs =>
    (not (null bs) andalso
       list_all (fn a => list_ex (fn b => fst (s_ns a b)) bs) asa,
      list_all (fn a => list_ex (fn b => snd (s_ns a b)) bs) asa));

fun or2 (b1, b2) (b3, b4) = (b1 orelse b3, b2 orelse b4);

fun lifta (uu, b) = (b, b);

fun mul_ext_impl A_ f [] [] = (false, true)
  | mul_ext_impl A_ f [] (v :: va) = (false, false)
  | mul_ext_impl A_ f (v :: va) [] = (true, true)
  | mul_ext_impl A_ f (v :: va) (y :: ys) =
    ex_dominating A_ f y (v :: va) (v :: va) ys
and ex_dominating A_ f y [] uw ux = (false, false)
  | ex_dominating A_ f y (b :: bs) xs ys =
    (case f b y
      of (true, ns) =>
        or2 (lifta
              (mul_ext_impl A_ f (remove1 A_ b xs)
                (filter (fn ya => not (fst (f b ya))) ys)))
          (ex_dominating A_ f y bs xs ys)
      | (false, true) =>
        or2 (mul_ext_impl A_ f (remove1 A_ b xs) ys)
          (ex_dominating A_ f y bs xs ys)
      | (false, false) => ex_dominating A_ f y bs xs ys);

fun list_ext A_ MS_Ext = mul_ext_impl A_
  | list_ext A_ Max_Ext = set_ext
  | list_ext A_ Min_Ext = min_set_ext;

fun get_root_redtriple (A1_, A2_) (B1_, B2_) (Scnp (typea, af, rp)) =
  generate_scnp_rp (A1_, A2_) B2_
    (list_ext (equal_prod (equal_term A1_ B1_) equal_nat) typea) af
    (get_redtriple (A1_, A2_) (B1_, B2_)) rp;

fun combine B_ (Scg (pa, qa, stra, wka)) (Scg (p, q, str, wk)) =
  Scg (pa, qa, remdups (equal_prod B_ B_) (stra @ str),
        remdups (equal_prod B_ B_) (wka @ wk))
  | combine B_ Null s = Null
  | combine B_ (Scg (v, va, vb, vc)) Null = Null;

fun in_situ B_ Null = true
  | in_situ B_ (Scg (p, q, str, wk)) = list_ex (fn (a, b) => eq B_ a b) str;

fun comp A_ esa es =
  remdups (equal_prod A_ A_)
    (maps (fn (x, y) =>
            maps (fn (ya, z) => (if eq A_ y ya then [(x, z)] else [])) es)
      esa);

fun subtract_list A_ xs ys = filter (fn x => not (membera A_ ys x)) xs;

fun scg_comp B_ conn (Scg (pa, qa, stra, wka)) (Scg (p, q, str, wk)) =
  (if not (conn qa p) then Null
    else let
           val strs =
             remdups (equal_prod B_ B_)
               (comp B_ stra str @ comp B_ stra wk @ comp B_ wka str);
           val a =
             subtract_list (equal_prod B_ B_)
               (remdups (equal_prod B_ B_) (comp B_ wka wk)) strs;
         in
           Scg (pa, q, strs, a)
         end)
  | scg_comp B_ conn Null g = Null
  | scg_comp B_ conn (Scg (v, va, vb, vc)) Null = Null;

fun subsumes A_ B_ (Scg (pa, qa, stra, wka)) (Scg (p, q, str, wk)) =
  eq A_ pa p andalso
    (eq A_ qa q andalso
      (list_all (membera (equal_prod B_ B_) str) stra andalso
        list_all (membera (equal_prod B_ B_) (str @ wk)) wka))
  | subsumes A_ B_ g Null = true
  | subsumes A_ B_ Null (Scg (v, va, vb, vc)) = false;

fun sagiv A_ B_ conn g =
  (if in_situ B_ g then true
    else let
           val gg = scg_comp B_ conn g g;
         in
           (if subsumes A_ B_ gg g then false
             else sagiv A_ B_ conn (combine B_ g gg))
         end);

fun equal_scg A_ B_ (Scg (pp1, pp2, list1, list2)) Null = false
  | equal_scg A_ B_ Null (Scg (pp1, pp2, list1, list2)) = false
  | equal_scg A_ B_ (Scg (pp1a, pp2a, list1a, list2a))
    (Scg (pp1, pp2, list1, list2)) =
    eq A_ pp1a pp1 andalso
      (eq A_ pp2a pp2 andalso
        (equal_lista (equal_prod B_ B_) list1a list1 andalso
          equal_lista (equal_prod B_ B_) list2a list2))
  | equal_scg A_ B_ Null Null = true;

fun insert_scg A_ B_ g gs =
  (if equal_scg A_ B_ g Null then NONE
    else (if list_ex (fn ga => subsumes A_ B_ ga g) gs then NONE
           else SOME (g :: filter (fn ga => not (subsumes A_ B_ g ga)) gs)));

fun mk_trancl A_ B_ conn [] s = s
  | mk_trancl A_ B_ conn (g :: gs) s =
    (case insert_scg A_ B_ g s of NONE => mk_trancl A_ B_ conn gs s
      | SOME sa =>
        mk_trancl A_ B_ conn
          (mapa (scg_comp B_ conn g) sa @
            mapa (fn f => scg_comp B_ conn f g) sa @ gs)
          sa);

fun check_SCT A_ B_ conn gs =
  let
    val a = mk_trancl A_ B_ conn gs [];
  in
    list_all (sagiv A_ B_ conn) a
  end;

fun get_arg t Zero_nat = t
  | get_arg t (Suc n) = nth (args t) n;

fun check_sct_ur_af_entry (A1_, A2_) (B1_, B2_) is_def rm ur pi sa nst s t stri
  nstri =
  catch (bindb (check_no_var A2_ B2_ s)
          (fn _ =>
            bindb (check_no_var A2_ B2_ t)
              (fn _ =>
                bindb (check_no_defined_root A2_ B2_ is_def t)
                  (fn _ =>
                    let
                      val m = num_args t;
                      val n = num_args s;
                    in
                      bindb (catch
                              (forallm
                                (fn i =>
                                  check (less_eq_nat i n)
                                    (shows_string
                                       [#"l", #"e", #"f", #"t", #"-", #"i",
 #"n", #"d", #"e", #"x", #" ", #"t", #"o", #" ", #"l", #"a", #"r", #"g", #"e"] o
                                      (shows_prec_nat Zero_nat i o shows_nl)))
                                (remdups equal_nat (mapa fst (stri @ nstri))))
                              (fn x => Inl (snd x)))
                        (fn _ =>
                          bindb (catch
                                  (forallm
                                    (fn j =>
                                      check
(less_eq_nat j m andalso
  isOK (check_ur_closed_term_rm_af (A1_, A2_) (B1_, B2_) rm ur pi
         (get_arg t j)))
(shows_string
   [#"r", #"i", #"g", #"h", #"t", #"-", #"i", #"n", #"d", #"e", #"x", #" ",
     #"t", #"o", #" ", #"l", #"a", #"r", #"g", #"e", #" ", #"o", #"r", #" ",
     #"a", #"r", #"g", #"u", #"m", #"e", #"n", #"t", #" ", #"v", #"i", #"o",
     #"l", #"a", #"t", #"e", #"s", #" ", #"u", #"s", #"a", #"b", #"l", #"e",
     #"-", #"r", #"u", #"l", #"e", #"s", #" ", #"c", #"o", #"n", #"d", #"i",
     #"t", #"i", #"o", #"n"] o
  shows_prec_nat Zero_nat j))
                                    (remdups equal_nat
                                      (mapa snd (stri @ nstri))))
                                  (fn x => Inl (snd x)))
                            (fn _ =>
                              let
                                val _ = args s;
                                val _ = args t;
                              in
                                bindb (catch
(forallm
  (fn (i, j) =>
    check (isOK (sa (get_arg s i, get_arg t j)))
      (shows_string
         [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"i", #"t",
           #"h", #" ", #"e", #"d", #"g", #"e", #" "] o
        (shows_prec_nat Zero_nat i o
          (shows_string [#" ", #"-", #"S", #"-", #">", #" "] o
            shows_prec_nat Zero_nat j))))
  stri)
(fn x => Inl (snd x)))
                                  (fn _ =>
                                    catch (forallm
    (fn (i, j) =>
      check (isOK (nst (get_arg s i, get_arg t j)))
        (shows_string
           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"i", #"t",
             #"h", #" ", #"e", #"d", #"g", #"e", #" "] o
          (shows_prec_nat Zero_nat i o
            (shows_string [#" ", #"-", #"N", #"S", #"-", #">", #" "] o
              shows_prec_nat Zero_nat j))))
    nstri)
                                      (fn x => Inl (snd x)))
                              end))
                    end))))
    (fn x =>
      Inl (shows_string
             [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #"s", #" ", #"w", #"i",
               #"t", #"h", #" ", #"D", #"P", #" "] o
            (shows_rule (shows_prec A2_ Zero_nat) (shows_prec B2_ Zero_nat)
               [#" ", #"-", #">", #" "] (s, t) o
              (shows_nl o x))));

fun sct_ur_af_proc (B1_, B2_) (C1_, C2_) i rp gs ur dpp =
  catch let
          val p = pairsa i dpp;
          val rm = rules_mapb i dpp;
          val is_def = (fn fna => not (null (rules_mapb i dpp fna)));
          val _ = rulesd i dpp;
          val ggs =
            filter
              (fn g =>
                membera (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_)) p
                  (fst g))
              gs;
          val pi = af rp;
          val sa = s rp;
          val nsa = ns rp;
          val nsta = nst rp;
          val cap1 = capRM_dpp B1_ C1_ i dpp;
          val cap2 = reverse_capRM_dpp B1_ C1_ i dpp;
        in
          bindb (valid rp)
            (fn _ =>
              bindb (catch
                      (catch
                        (forallm
                          (fn lr =>
                            check_ur_closed_term_rm_af (B1_, B2_) (C1_, C2_) rm
                              ur pi (snd lr))
                          ur)
                        (fn x => Inl (snd x)))
                      (fn x =>
                        Inl (shows_string
                               [#"e", #"r", #"r", #"o", #"r", #" ", #"w", #"h",
                                 #"e", #"n", #" ", #"c", #"h", #"e", #"c", #"k",
                                 #"i", #"n", #"g", #" ", #"c", #"l", #"o", #"s",
                                 #"u", #"r", #"e", #" ", #"p", #"r", #"o", #"p",
                                 #"e", #"r", #"t", #"i", #"e", #"s", #" ", #"o",
                                 #"f", #" ", #"r", #"h", #"s", #" ", #"o", #"f",
                                 #" ", #"u", #"s", #"a", #"b", #"l", #"e", #" ",
                                 #"r", #"u", #"l", #"e", #"s"] o
                              (shows_nl o x))))
                (fn _ =>
                  bindb (catch
                          (check_subseteq
                            (equal_prod (equal_term B1_ C1_)
                              (equal_term B1_ C1_))
                            p (mapa fst ggs))
                          (fn x =>
                            Inl (shows_string
                                   [#"t", #"h", #"e", #"r", #"e", #" ", #"i",
                                     #"s", #" ", #"n", #"o", #" ", #"s", #"i",
                                     #"z", #"e", #"-", #"c", #"h", #"a", #"n",
                                     #"g", #"e", #" ", #"g", #"r", #"a", #"p",
                                     #"h", #" ", #"f", #"o", #"r", #" ", #"D",
                                     #"P", #" "] o
                                  shows_rule (shows_prec B2_ Zero_nat)
                                    (shows_prec C2_ Zero_nat)
                                    [#" ", #"-", #">", #" "] x)))
                    (fn _ =>
                      bindb (catch
                              (forallm
                                (fn (a, b) =>
                                  let
                                    val (saa, t) = a;
                                  in
                                    (fn (aa, ba) =>
                                      check_sct_ur_af_entry (B1_, B2_)
(C1_, C2_) is_def rm ur pi sa nsta saa t aa ba)
                                  end
                                    b)
                                ggs)
                              (fn x => Inl (snd x)))
                        (fn _ =>
                          bindb (catch
                                  (catch (forallm nsa ur) (fn x => Inl (snd x)))
                                  (fn x =>
                                    Inl (shows_string
   [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n",
     #" ", #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"u",
     #"s", #"a", #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e", #"s"] o
  (shows_nl o x))))
                            (fn _ =>
                              check (check_SCT
                                      (equal_prod (equal_term B1_ C1_)
(equal_prod (equal_term B1_ C1_)
  (equal_prod (equal_gctxt B1_) (equal_gctxt B1_))))
                                      equal_nat
                                      (fn (_, (t, (_, ct))) =>
fn (u, (_, (cu, _))) => matchb B1_ C1_ ct u andalso matchb B1_ C1_ cu t)
                                      (mapa
(fn (a, b) =>
  let
    val (sb, t) = a;
  in
    (fn (stri, nstri) =>
      let
        val e = (sb, (t, (cap2 sb, cap1 t)));
      in
        Scg (e, e, stri, nstri)
      end)
  end
    b)
ggs))
                                (shows_string
                                   [#"s", #"i", #"z", #"e", #"-", #"c", #"h",
                                     #"a", #"n", #"g", #"e", #" ", #"a", #"n",
                                     #"a", #"l", #"y", #"s", #"i", #"s", #" ",
                                     #"f", #"a", #"i", #"l", #"e", #"d"] o
                                  shows_nl))))))
        end
    (fn x =>
      Inl (shows_string
             [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"a",
               #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ", #"s", #"i",
               #"z", #"e", #"-", #"c", #"h", #"a", #"n", #"g", #"e", #" ", #"p",
               #"r", #"o", #"c", #"e", #"s", #"s", #"o", #"r", #" ", #"w", #"i",
               #"t", #"h", #" ", #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l",
               #"o", #"w", #"i", #"n", #"g", #" "] o
            (shows_nl o
              (desc rp o
                (shows_nl o
                  (shows_string
                     [#"f", #"o", #"r", #" ", #"t", #"h", #"e", #" ", #"f",
                       #"o", #"l", #"l", #"o", #"w", #"i", #"n", #"g", #" ",
                       #"r", #"e", #"a", #"s", #"o", #"n"] o
                    (shows_nl o x)))))));

fun sct_subterm_proc (B1_, B2_) (C1_, C2_) i gs dpp =
  catch let
          val p = pairsa i dpp;
          val is_def = (fn fna => not (null (rules_mapb i dpp fna)));
          val cap1 = capRM_dpp B1_ C1_ i dpp;
          val cap2 = reverse_capRM_dpp B1_ C1_ i dpp;
        in
          bindb (catch
                  (check_subseteq
                    (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_)) p
                    (mapa fst gs))
                  (fn x =>
                    Inl (shows_string
                           [#"t", #"h", #"e", #"r", #"e", #" ", #"i", #"s",
                             #" ", #"n", #"o", #" ", #"s", #"i", #"z", #"e",
                             #"-", #"c", #"h", #"a", #"n", #"g", #"e", #" ",
                             #"g", #"r", #"a", #"p", #"h", #" ", #"f", #"o",
                             #"r", #" ", #"t", #"h", #"e", #" ", #"p", #"a",
                             #"i", #"r", #" "] o
                          shows_rule (shows_prec B2_ Zero_nat)
                            (shows_prec C2_ Zero_nat) [#" ", #"-", #">", #" "]
                            x)))
            (fn _ =>
              bindb (catch
                      (forallm
                        (fn (a, b) =>
                          let
                            val (s, t) = a;
                          in
                            (fn (stri, nstri) =>
                              catch (bindb (check_no_var B2_ C2_ s)
                                      (fn _ =>
bindb (check_no_var B2_ C2_ t)
  (fn _ =>
    bindb (check_no_defined_root B2_ C2_ is_def t)
      (fn _ =>
        let
          val m = num_args t;
          val n = num_args s;
        in
          bindb (catch
                  (forallm
                    (fn (ia, j) =>
                      check (less_eq_nat ia n andalso
                              (less_eq_nat j m andalso
                                isOK (check_supt (B1_, B2_) (C1_, C2_)
                                       (get_arg s ia) (get_arg t j))))
                        (shows_string
                           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                             #"w", #"i", #"t", #"h", #" ", #"e", #"d", #"g",
                             #"e", #" "] o
                          (shows_prec_nat Zero_nat ia o
                            (shows_string [#" ", #"|", #">", #" "] o
                              (shows_prec_nat Zero_nat j o shows_nl)))))
                    stri)
                  (fn x => Inl (snd x)))
            (fn _ =>
              catch (forallm
                      (fn (ia, j) =>
                        check (less_eq_nat ia n andalso
                                (less_eq_nat j m andalso
                                  isOK (check_supteq (B1_, B2_) (C1_, C2_)
 (get_arg s ia) (get_arg t j))))
                          (shows_string
                             [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                               #"w", #"i", #"t", #"h", #" ", #"e", #"d", #"g",
                               #"e", #" "] o
                            (shows_prec_nat Zero_nat ia o
                              (shows_string [#" ", #"|", #">", #"=", #" "] o
                                (shows_prec_nat Zero_nat j o shows_nl)))))
                      nstri)
                (fn x => Inl (snd x)))
        end))))
                                (fn x =>
                                  Inl (shows_string
 [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"i", #"t", #"h", #" ",
   #"p", #"a", #"i", #"r", #" "] o
(shows_rule (shows_prec B2_ Zero_nat) (shows_prec C2_ Zero_nat)
   [#" ", #"-", #">", #" "] (s, t) o
  (shows_nl o x)))))
                          end
                            b)
                        gs)
                      (fn x => Inl (snd x)))
                (fn _ =>
                  check (check_SCT
                          (equal_prod (equal_term B1_ C1_)
                            (equal_prod (equal_term B1_ C1_)
                              (equal_prod (equal_gctxt B1_) (equal_gctxt B1_))))
                          equal_nat
                          (fn (_, (t, (_, ct))) => fn (u, (_, (cu, _))) =>
                            matchb B1_ C1_ ct u andalso matchb B1_ C1_ cu t)
                          (mapa (fn (a, b) =>
                                  let
                                    val (s, t) = a;
                                  in
                                    (fn (stri, nstri) =>
                                      let
val e = (s, (t, (cap2 s, cap1 t)));
                                      in
Scg (e, e, stri, nstri)
                                      end)
                                  end
                                    b)
                            gs))
                    (shows_string
                       [#"s", #"i", #"z", #"e", #"-", #"c", #"h", #"a", #"n",
                         #"g", #"e", #" ", #"a", #"n", #"a", #"l", #"y", #"s",
                         #"i", #"s", #" ", #"f", #"a", #"i", #"l", #"e", #"d"] o
                      shows_nl)))
        end
    (fn x =>
      Inl (shows_string
             [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ", #"a",
               #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ", #"s", #"i",
               #"z", #"e", #"-", #"c", #"h", #"a", #"n", #"g", #"e", #" ", #"p",
               #"r", #"o", #"c", #"e", #"s", #"s", #"o", #"r", #" ", #"b", #"a",
               #"s", #"e", #"d", #" ", #"o", #"n", #" ", #"t", #"h", #"e", #" ",
               #"s", #"u", #"b", #"t", #"e", #"r", #"m", #"-", #"r", #"e", #"l",
               #"a", #"t", #"i", #"o", #"n"] o
            (shows_nl o x)));

fun check_dp_proof (B1_, B2_) assms ia i dpp PisEmpty =
  debug (ia []) [#"P", #" ", #"i", #"s", #" ", #"e", #"m", #"p", #"t", #"y"]
    (if null (pa i dpp) andalso (null (pwa i dpp) orelse null (rc i dpp))
      then Inr ()
      else Inl (ia o (shows_string
                        [#":", #" ", #"P", #" ", #"i", #"s", #" ", #"n", #"o",
                          #"t", #" ", #"e", #"m", #"p", #"t", #"y", #" ", #"i",
                          #"n", #" ", #"t", #"h", #"e", #" ", #"f", #"o", #"l",
                          #"l", #"o", #"w", #"i", #"n", #"g", #" ", #"D", #"P",
                          #"-", #"p", #"r", #"o", #"b", #"l", #"e", #"m",
                          #" "] o
                       (shows_nl o
                         shows_dpp
                           (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
                           (shows_prec_list show_char Zero_nat) i dpp))))
  | check_dp_proof (B1_, B2_) assms ia i dpp
    (SubtermCriterionProc (p, rseq, rP, prf)) =
    debug (ia [])
      [#"S", #"u", #"b", #"t", #"e", #"r", #"m", #"C", #"r", #"i", #"t", #"e",
        #"r", #"i", #"o", #"n", #"P", #"r", #"o", #"c"]
      let
        val pa = pairsa i dpp;
        val pr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            pa rP;
      in
        bindb (catch
                (subterm_criterion_proc
                  (equal_lab B1_ (equal_list equal_nat),
                    show_lab B2_ (show_list show_nat))
                  (equal_list equal_char, show_list show_char) i
                  (create_proj (equal_lab B1_ (equal_list equal_nat)) p)
                  (create_rseq_map (equal_lab B1_ (equal_list equal_nat))
                    (equal_list equal_char) rseq)
                  pr dpp)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"w", #"h", #"e", #"n", #" ", #"a", #"p", #"p",
                                 #"l", #"y", #"i", #"n", #"g", #" ", #"t", #"h",
                                 #"e", #" ", #"s", #"u", #"b", #"t", #"e", #"r",
                                 #"m", #" ", #"c", #"r", #"i", #"t", #"e", #"r",
                                 #"i", #"o", #"n", #" ", #"t", #"o", #" ", #"t",
                                 #"h", #"e", #" ", #"D", #"P", #" ", #"p", #"r",
                                 #"o", #"b", #"l", #"e", #"m"] o
                              (shows_nl o
                                (shows_dpp
                                   (shows_prec_lab B2_ (show_list show_nat)
                                     Zero_nat)
                                   (shows_prec_list show_char Zero_nat) i dpp o
                                  (shows_nl o
                                    (shows_string
                                       [#"a", #"n", #"d", #" ", #"t", #"r",
 #"y", #"i", #"n", #"g", #" ", #"t", #"o", #" ", #"r", #"e", #"m", #"o", #"v",
 #"e", #" ", #"t", #"h", #"e", #" ", #"p", #"a", #"i", #"r", #"s", #" "] o
                                      (shows_nl o
(shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] pr o
  (shows_nl o x)))))))))))
          (fn dppa =>
            catch (check_dp_proof (B1_, B2_) assms
                    (ia o shows_string [#".", #"1"]) i dppa prf)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"s", #"u", #"b", #"t", #"e", #"r",
                               #"m", #" ", #"c", #"r", #"i", #"t", #"e", #"r",
                               #"i", #"o", #"n"] o
                            (shows_nl o indent x)))))
      end
  | check_dp_proof (B1_, B2_) assms ia i dpp (RedPairProc (redp, rP, prf)) =
    debug (ia [])
      [#"R", #"e", #"d", #"P", #"a", #"i", #"r", #"P", #"r", #"o", #"c"]
      let
        val p = pairsa i dpp;
        val pr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            p rP;
        val proc =
          (case redp
            of Inl rrp =>
              root_redtriple_proc (show_lab B2_ (show_list show_nat))
                (show_list show_char) i
                (get_root_redtriple
                  (equal_lab B1_ (equal_list equal_nat),
                    show_lab B2_ (show_list show_nat))
                  (equal_list equal_char, show_list show_char) rrp)
            | Inr rp =>
              redtriple_proc (show_lab B2_ (show_list show_nat))
                (show_list show_char) i
                (get_redtriple
                  (equal_lab B1_ (equal_list equal_nat),
                    show_lab B2_ (show_list show_nat))
                  (equal_list equal_char, show_list show_char) rp));
      in
        bindb (catch (proc pr dpp)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"w", #"h", #"e", #"n", #" ", #"a", #"p", #"p",
                                 #"l", #"y", #"i", #"n", #"g", #" ", #"t", #"h",
                                 #"e", #" ", #"r", #"e", #"d", #"u", #"c", #"t",
                                 #"i", #"o", #"n", #" ", #"p", #"a", #"i", #"r",
                                 #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s",
                                 #"o", #"r", #" ", #"t", #"o", #" ", #"r", #"e",
                                 #"m", #"o", #"v", #"e", #" ", #"f", #"r", #"o",
                                 #"m", #" ", #"t", #"h", #"e", #" ", #"D", #"P",
                                 #" ", #"p", #"r", #"o", #"b", #"l", #"e",
                                 #"m"] o
                              (shows_nl o
                                (shows_dpp
                                   (shows_prec_lab B2_ (show_list show_nat)
                                     Zero_nat)
                                   (shows_prec_list show_char Zero_nat) i dpp o
                                  (shows_nl o
                                    (shows_string
                                       [#" ", #"t", #"h", #"e", #" ", #"p",
 #"a", #"i", #"r", #"s", #" "] o
                                      (shows_nl o
(shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] pr o
  (shows_nl o x)))))))))))
          (fn dppa =>
            catch (check_dp_proof (B1_, B2_) assms
                    (ia o shows_string [#".", #"1"]) i dppa prf)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"r", #"e", #"d", #"u", #"c", #"t",
                               #"i", #"o", #"n", #" ", #"p", #"a", #"i", #"r",
                               #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s",
                               #"o", #"r"] o
                            (shows_nl o indent x)))))
      end
  | check_dp_proof (B1_, B2_) assms ia i dpp
    (MonoRedPairProc (redp, rP, rR, prf)) =
    debug (ia [])
      [#"M", #"o", #"n", #"o", #"R", #"e", #"d", #"P", #"a", #"i", #"r", #"P",
        #"r", #"o", #"c"]
      let
        val p = pairsa i dpp;
        val pr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            p rP;
        val r = rulesd i dpp;
        val rr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            r rR;
      in
        bindb (catch
                (mono_redpair_proc (show_lab B2_ (show_list show_nat))
                  (show_list show_char) i
                  (get_redtriple
                    (equal_lab B1_ (equal_list equal_nat),
                      show_lab B2_ (show_list show_nat))
                    (equal_list equal_char, show_list show_char) redp)
                  pr rr dpp)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"w", #"h", #"e", #"n", #" ", #"a", #"p", #"p",
                                 #"l", #"y", #"i", #"n", #"g", #" ", #"t", #"h",
                                 #"e", #" ", #"m", #"o", #"n", #"o", #" ", #"r",
                                 #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n",
                                 #" ", #"p", #"a", #"i", #"r", #" ", #"p", #"r",
                                 #"o", #"c", #"e", #"s", #"s", #"o", #"r", #" ",
                                 #"t", #"o", #" ", #"r", #"e", #"m", #"o", #"v",
                                 #"e", #" ", #"f", #"r", #"o", #"m", #" ", #"t",
                                 #"h", #"e", #" ", #"D", #"P", #" ", #"p", #"r",
                                 #"o", #"b", #"l", #"e", #"m"] o
                              (shows_nl o
                                (shows_dpp
                                   (shows_prec_lab B2_ (show_list show_nat)
                                     Zero_nat)
                                   (shows_prec_list show_char Zero_nat) i dpp o
                                  (shows_nl o
                                    (shows_string
                                       [#" ", #"t", #"h", #"e", #" ", #"p",
 #"a", #"i", #"r", #"s", #" "] o
                                      (shows_nl o
(shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] pr o
  (shows_nl o
    (shows_string
       [#" ", #"a", #"n", #"d", #" ", #"t", #"h", #"e", #" ", #"r", #"u", #"l",
         #"e", #"s", #" "] o
      (shows_nl o
        (shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
           (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] rr o
          (shows_nl o x)))))))))))))))
          (fn dppa =>
            catch (check_dp_proof (B1_, B2_) assms
                    (ia o shows_string [#".", #"1"]) i dppa prf)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"m", #"o", #"n", #"o", #" ", #"r",
                               #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n",
                               #" ", #"p", #"a", #"i", #"r", #" ", #"p", #"r",
                               #"o", #"c", #"e", #"s", #"s", #"o", #"r"] o
                            (shows_nl o indent x)))))
      end
  | check_dp_proof (B1_, B2_) assms ia i dpp (DepGraphProc edpts) =
    debug (ia [])
      [#"D", #"e", #"p", #"G", #"r", #"a", #"p", #"h", #"P", #"r", #"o", #"c"]
      (bindb
        (catch
          (dep_graph_proc
            (equal_lab B1_ (equal_list equal_nat),
              show_lab B2_ (show_list show_nat))
            (equal_list equal_char, show_list show_char) i dpp edpts)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"i", #"l", #"e", #" ", #"t", #"r", #"y", #"i",
                           #"n", #"g", #" ", #"t", #"o", #" ", #"p", #"e", #"r",
                           #"f", #"o", #"r", #"m", #" ", #"S", #"C", #"C", #"-",
                           #"d", #"e", #"c", #"o", #"m", #"p", #"o", #"s", #"i",
                           #"t", #"i", #"o", #"n", #" ", #" ", #"o", #"n",
                           #" "] o
                        (shows_nl o
                          (shows_dpp
                             (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
                             (shows_prec_list show_char Zero_nat) i dpp o
                            (shows_nl o x)))))))
        (fn pdpps =>
          catch (catch
                  (forallm_index
                    (fn (prof, dppa) => fn j =>
                      check_dp_proof (B1_, B2_) assms
                        (ia o (shows_string [#"."] o
                                shows_prec_nat Zero_nat (Suc j)))
                        i dppa prof)
                    pdpps)
                  (fn x => Inl (snd x)))
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                             #"e", #" ", #"d", #"e", #"p", #"e", #"n", #"d",
                             #"e", #"n", #"c", #"y", #" ", #"g", #"r", #"a",
                             #"p", #"h", #" ", #"p", #"r", #"o", #"c", #"e",
                             #"s", #"s", #"o", #"r"] o
                          (shows_nl o indent x))))))
  | check_dp_proof (B1_, B2_) assms ia i dpp (RedPairUrProc (redp, rP, ur, prf))
    = debug (ia [])
        [#"R", #"e", #"d", #"P", #"a", #"i", #"r", #"U", #"r", #"P", #"r", #"o",
          #"c"]
        let
          val p = pairsa i dpp;
          val pr =
            list_diff
              (equal_prod
                (equal_term (equal_lab B1_ (equal_list equal_nat))
                  (equal_list equal_char))
                (equal_term (equal_lab B1_ (equal_list equal_nat))
                  (equal_list equal_char)))
              p rP;
          val proc =
            (case redp
              of Inl rrp =>
                ur_af_root_redtriple_proc
                  (equal_lab B1_ (equal_list equal_nat),
                    show_lab B2_ (show_list show_nat))
                  (equal_list equal_char, show_list show_char) i
                  (get_root_redtriple
                    (equal_lab B1_ (equal_list equal_nat),
                      show_lab B2_ (show_list show_nat))
                    (equal_list equal_char, show_list show_char) rrp)
              | Inr rp =>
                ur_af_redtriple_proc
                  (equal_lab B1_ (equal_list equal_nat),
                    show_lab B2_ (show_list show_nat))
                  (equal_list equal_char, show_list show_char) i
                  (get_redtriple
                    (equal_lab B1_ (equal_list equal_nat),
                      show_lab B2_ (show_list show_nat))
                    (equal_list equal_char, show_list show_char) rp));
        in
          bindb (catch (proc pr ur dpp)
                  (fn x =>
                    Inl (ia o (shows_string
                                 [#":", #" ", #"e", #"r", #"r", #"o", #"r",
                                   #" ", #"w", #"h", #"e", #"n", #" ", #"a",
                                   #"p", #"p", #"l", #"y", #"i", #"n", #"g",
                                   #" ", #"t", #"h", #"e", #" ", #"r", #"e",
                                   #"d", #"u", #"c", #"t", #"i", #"o", #"n",
                                   #" ", #"p", #"a", #"i", #"r", #" ", #"p",
                                   #"r", #"o", #"c", #"e", #"s", #"s", #"o",
                                   #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                                   #"u", #"s", #"a", #"b", #"l", #"e", #" ",
                                   #"r", #"u", #"l", #"e", #"s", #" ", #"t",
                                   #"o", #" ", #"r", #"e", #"m", #"o", #"v",
                                   #"e", #" ", #"f", #"r", #"o", #"m", #" ",
                                   #"t", #"h", #"e", #" ", #"D", #"P", #" ",
                                   #"p", #"r", #"o", #"b", #"l", #"e", #"m"] o
                                (shows_nl o
                                  (shows_dpp
                                     (shows_prec_lab B2_ (show_list show_nat)
                                       Zero_nat)
                                     (shows_prec_list show_char Zero_nat) i
                                     dpp o
                                    (shows_nl o
                                      (shows_string
 [#" ", #"t", #"h", #"e", #" ", #"p", #"a", #"i", #"r", #"s", #" "] o
(shows_nl o
  (shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
     (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] pr o
    (shows_nl o x)))))))))))
            (fn dppa =>
              catch (check_dp_proof (B1_, B2_) assms
                      (ia o shows_string [#".", #"1"]) i dppa prf)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                                 #"e", #" ", #"r", #"e", #"d", #"u", #"c", #"t",
                                 #"i", #"o", #"n", #" ", #"p", #"a", #"i", #"r",
                                 #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s",
                                 #"o", #"r"] o
                              (shows_nl o indent x)))))
        end
  | check_dp_proof (B1_, B2_) assms ia i dpp
    (MonoRedPairUrProc (redp, rP, rR, ur, prf)) =
    debug (ia [])
      [#"M", #"o", #"n", #"o", #"R", #"e", #"d", #"P", #"a", #"i", #"r", #"U",
        #"r", #"P", #"r", #"o", #"c"]
      let
        val p = pairsa i dpp;
        val pr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            p rP;
        val r = rulesd i dpp;
        val rr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            r rR;
      in
        bindb (catch
                (mono_ur_redpair_proc
                  (equal_lab B1_ (equal_list equal_nat),
                    show_lab B2_ (show_list show_nat))
                  (equal_list equal_char, show_list show_char) i
                  (get_redtriple
                    (equal_lab B1_ (equal_list equal_nat),
                      show_lab B2_ (show_list show_nat))
                    (equal_list equal_char, show_list show_char) redp)
                  pr rr ur dpp)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"w", #"h", #"e", #"n", #" ", #"a", #"p", #"p",
                                 #"l", #"y", #"i", #"n", #"g", #" ", #"t", #"h",
                                 #"e", #" ", #"m", #"o", #"n", #"o", #" ", #"r",
                                 #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n",
                                 #" ", #"p", #"a", #"i", #"r", #" ", #"p", #"r",
                                 #"o", #"c", #"e", #"s", #"s", #"o", #"r", #" ",
                                 #"w", #"i", #"t", #"h", #" ", #"u", #"s", #"a",
                                 #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e",
                                 #"s", #" ", #"t", #"o", #" ", #"r", #"e", #"m",
                                 #"o", #"v", #"e", #" ", #"f", #"r", #"o", #"m",
                                 #" ", #"t", #"h", #"e", #" ", #"D", #"P", #" ",
                                 #"p", #"r", #"o", #"b", #"l", #"e", #"m"] o
                              (shows_nl o
                                (shows_dpp
                                   (shows_prec_lab B2_ (show_list show_nat)
                                     Zero_nat)
                                   (shows_prec_list show_char Zero_nat) i dpp o
                                  (shows_nl o
                                    (shows_string
                                       [#" ", #"t", #"h", #"e", #" ", #"p",
 #"a", #"i", #"r", #"s", #" "] o
                                      (shows_nl o
(shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] pr o
  (shows_nl o
    (shows_string
       [#" ", #"a", #"n", #"d", #" ", #"t", #"h", #"e", #" ", #"r", #"u", #"l",
         #"e", #"s", #" "] o
      (shows_nl o
        (shows_rules (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
           (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] rr o
          (shows_nl o x)))))))))))))))
          (fn dppa =>
            catch (check_dp_proof (B1_, B2_) assms
                    (ia o shows_string [#".", #"1"]) i dppa prf)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"m", #"o", #"n", #"o", #" ", #"r",
                               #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n",
                               #" ", #"p", #"a", #"i", #"r", #" ", #"p", #"r",
                               #"o", #"c", #"e", #"s", #"s", #"o", #"r", #" ",
                               #"w", #"i", #"t", #"h", #" ", #"u", #"s", #"a",
                               #"b", #"l", #"e", #" ", #"r", #"u", #"l", #"e",
                               #"s"] o
                            (shows_nl o indent x)))))
      end
  | check_dp_proof (B1_, B2_) assms ia i dpp
    (UncurryProc (mode, u_info, p, r, prf)) =
    debug (ia [])
      [#"U", #"n", #"c", #"u", #"r", #"r", #"y", #"P", #"r", #"o", #"c"]
      (bindb
        (catch
          (uncurry_proc_both (B1_, B2_)
            (equal_list equal_nat, show_list show_nat) i mode u_info p r dpp)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                           #"i", #"n", #"g", #" ", #"t", #"h", #"e", #" ", #"u",
                           #"n", #"c", #"u", #"r", #"r", #"y", #"i", #"n", #"g",
                           #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s", #"o",
                           #"r", #" ", #"o", #"n", #" ", #"t", #"h", #"e", #" ",
                           #"D", #"P", #" ", #"p", #"r", #"o", #"b", #"l", #"e",
                           #"m"] o
                        (shows_nl o
                          (shows_dpp
                             (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
                             (shows_prec_list show_char Zero_nat) i dpp o
                            (shows_nl o x)))))))
        (fn dppa =>
          catch (check_dp_proof (B1_, B2_) assms
                  (ia o shows_string [#".", #"1"]) i dppa prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                             #"e", #" ", #"u", #"n", #"c", #"u", #"r", #"r",
                             #"y", #"i", #"n", #"g", #" ", #"p", #"r", #"o",
                             #"c", #"e", #"s", #"s", #"o", #"r"] o
                          (shows_nl o indent x))))))
  | check_dp_proof (B1_, B2_) assms ia i dpp (SizeChangeSubterm graphs) =
    debug (ia [])
      [#"S", #"i", #"z", #"e", #"C", #"h", #"a", #"n", #"g", #"e", #"S", #"u",
        #"b", #"t", #"e", #"r", #"m"]
      (sct_subterm_proc
        (equal_lab B1_ (equal_list equal_nat),
          show_lab B2_ (show_list show_nat))
        (equal_list equal_char, show_list show_char) i graphs dpp)
  | check_dp_proof (B1_, B2_) assms ia i dpp
    (SizeChangeRedPair (redp, ur, graphs)) =
    debug (ia [])
      [#"S", #"i", #"z", #"e", #"C", #"h", #"a", #"n", #"g", #"e", #"R", #"e",
        #"d", #"P", #"a", #"i", #"r"]
      (sct_ur_af_proc
        (equal_lab B1_ (equal_list equal_nat),
          show_lab B2_ (show_list show_nat))
        (equal_list equal_char, show_list show_char) i
        (get_redtriple
          (equal_lab B1_ (equal_list equal_nat),
            show_lab B2_ (show_list show_nat))
          (equal_list equal_char, show_list show_char) redp)
        graphs ur dpp)
  | check_dp_proof (B1_, B2_) assms ia i dpp (FccProc (f, fcs, p, r, prf)) =
    debug (ia []) [#"F", #"c", #"c", #"P", #"r", #"o", #"c"]
      (bindb
        (catch
          (fcc_proc
            (equal_lab B1_ (equal_list equal_nat),
              show_lab B2_ (show_list show_nat))
            (equal_list equal_char, show_list show_char) i f fcs p [] r dpp)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                           #"i", #"n", #"g", #" ", #"t", #"h", #"e", #" ", #"f",
                           #"l", #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e",
                           #"x", #"t", #" ", #"c", #"l", #"o", #"s", #"u", #"r",
                           #"e", #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s",
                           #"o", #"r", #" ", #"o", #"n", #" ", #"t", #"h", #"e",
                           #" ", #"D", #"P", #" ", #"p", #"r", #"o", #"b", #"l",
                           #"e", #"m"] o
                        (shows_nl o
                          (shows_dpp
                             (shows_prec_lab B2_ (show_list show_nat) Zero_nat)
                             (shows_prec_list show_char Zero_nat) i dpp o
                            (shows_nl o x)))))))
        (fn dppa =>
          catch (check_dp_proof (B1_, B2_) assms
                  (ia o shows_string [#".", #"1"]) i dppa prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                             #"e", #" ", #"f", #"l", #"a", #"t", #" ", #"c",
                             #"o", #"n", #"t", #"e", #"x", #"t", #" ", #"c",
                             #"l", #"o", #"s", #"u", #"r", #"e", #" ", #"p",
                             #"r", #"o", #"c", #"e", #"s", #"s", #"o", #"r"] o
                          (shows_nl o indent x))))))
  | check_dp_proof (B1_, B2_) assms ia i dpp
    (SplitProc (prem, rrem, prf1, prf2)) =
    debug (ia []) [#"S", #"p", #"l", #"i", #"t", #"P", #"r", #"o", #"c"]
      let
        val (dpp1, dpp2) =
          split_proc (show_lab B2_ (show_list show_nat)) (show_list show_char) i
            dpp prem rrem;
      in
        bindb (catch
                (check_dp_proof (B1_, B2_) assms
                  (ia o shows_string [#".", #"1"]) i dpp1 prf1)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                                 #"e", #" ", #"s", #"p", #"l", #"i", #"t", #" ",
                                 #"p", #"r", #"o", #"c", #"e", #"s", #"s", #"o",
                                 #"r"] o
                              (shows_nl o indent x)))))
          (fn _ =>
            catch (check_dp_proof (B1_, B2_) assms
                    (ia o shows_string [#".", #"2"]) i dpp2 prf2)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"s", #"p", #"l", #"i", #"t", #" ",
                               #"p", #"r", #"o", #"c", #"e", #"s", #"s", #"o",
                               #"r"] o
                            (shows_nl o indent x)))))
      end
  | check_dp_proof (B1_, B2_) assms ia i dpp (SemlabProc (sli, lP, lQ, lR, prf))
    = debug (ia []) [#"S", #"e", #"m", #"l", #"a", #"b", #"P", #"r", #"o", #"c"]
        (bindb
          (catch
            (semlab_fin_proc (B1_, B2_)
              (equal_list equal_char, show_list show_char) i sli lP lQ lR dpp)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"w", #"h", #"e", #"n", #" ", #"a", #"p", #"p",
                             #"l", #"y", #"i", #"n", #"g", #" ", #"t", #"h",
                             #"e", #" ", #"s", #"e", #"m", #"l", #"a", #"b",
                             #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s",
                             #"o", #"r", #" ", #"o", #"n", #" ", #"t", #"h",
                             #"e", #" ", #"D", #"P", #" ", #"p", #"r", #"o",
                             #"b", #"l", #"e", #"m"] o
                          (shows_nl o
                            (shows_dpp
                               (shows_prec_lab B2_ (show_list show_nat)
                                 Zero_nat)
                               (shows_prec_list show_char Zero_nat) i dpp o
                              (shows_nl o x)))))))
          (fn dppa =>
            catch (check_dp_proof (B1_, B2_) assms
                    (ia o shows_string [#".", #"1"]) i dppa prf)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"s", #"e", #"m", #"l", #"a", #"b",
                               #" ", #"p", #"r", #"o", #"c", #"e", #"s", #"s",
                               #"o", #"r"] o
                            (shows_nl o indent x))))))
  | check_dp_proof (B1_, B2_) assms ia i dppa (AssumeFinite dpp) =
    debug (ia [])
      [#"F", #"i", #"n", #"i", #"t", #"e", #"n", #"e", #"s", #"s", #" ", #"A",
        #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o", #"n"]
      (if assms
        then catch (check_dpp_subsumes (B1_, B2_)
                     (equal_list equal_nat, show_list show_nat)
                     (equal_list equal_char, show_list show_char) i dpp dppa)
               (fn x =>
                 Inl (ia o (shows_string
                              [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                #"i", #"n", #" ", #"f", #"i", #"n", #"i", #"t",
                                #"e", #"n", #"e", #"s", #"s", #" ", #"a", #"s",
                                #"s", #"u", #"m", #"p", #"t", #"i", #"o",
                                #"n"] o
                             (shows_nl o (x o shows_nl)))))
        else Inl (ia o (shows_string
                          [#":", #" ", #"t", #"h", #"e", #" ", #"p", #"r", #"o",
                            #"o", #"f", #" ", #"c", #"o", #"n", #"t", #"a",
                            #"i", #"n", #"s", #" ", #"a", #" ", #"l", #"o",
                            #"c", #"a", #"l", #" ", #"f", #"i", #"n", #"i",
                            #"t", #"e", #"n", #"e", #"s", #"s", #" ", #"a",
                            #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o",
                            #"n"] o
                         shows_nl)));

fun shows_tp funa var i t =
  let
    val r = ra i t;
    val rw = rwa i t;
    val q = qa i t;
  in
    shows_trs funa var [#" ", #"-", #">", #" "]
      [#"r", #"u", #"l", #"e", #"s", #":"] r o
      ((if null rw then id
         else shows_trs funa var [#" ", #"-", #">", #"=", #" "]
                [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #" ", #"r",
                  #"u", #"l", #"e", #"s", #":"]
                rw) o
        (if null q then id
          else shows_terms funa var
                 [#"Q", #"-", #"c", #"o", #"m", #"p", #"o", #"n", #"e", #"n",
                   #"t", #":"]
                 q))
  end;

fun check_tp_subsumes (B1_, B2_) (C1_, C2_) (D1_, D2_) i (q, (r, rw)) tp =
  catch let
          val qaa = qa i tp;
          val raa = ra i tp;
          val rwaa = rwa i tp;
          val rb = r @ rw;
        in
          bindb (catch
                  (check_subseteq (equal_term (equal_lab B1_ C1_) D1_) qaa q)
                  (fn x =>
                    Inl (toomuch [#"t", #"e", #"r", #"m"]
                          (shows_term (shows_prec_lab B2_ C2_ Zero_nat)
                            (shows_prec D2_ Zero_nat) x))))
            (fn _ =>
              bindb (catch
                      (check_subseteq (equal_term (equal_lab B1_ C1_) D1_) q
                        qaa)
                      (fn x =>
                        Inl (missing [#"t", #"e", #"r", #"m"]
                              (shows_term (shows_prec_lab B2_ C2_ Zero_nat)
                                (shows_prec D2_ Zero_nat) x))))
                (fn _ =>
                  bindb (catch
                          (check_subseteq
                            (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
                              (equal_term (equal_lab B1_ C1_) D1_))
                            raa r)
                          (fn x =>
                            Inl (toomuch [#"r", #"u", #"l", #"e"]
                                  (shows_rule (shows_prec_lab B2_ C2_ Zero_nat)
                                    (shows_prec D2_ Zero_nat)
                                    [#" ", #"-", #">", #" "] x))))
                    (fn _ =>
                      bindb (catch
                              (check_subseteq
                                (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
                                  (equal_term (equal_lab B1_ C1_) D1_))
                                rwaa rb)
                              (fn x =>
                                Inl (toomuch
                                      [#"r", #"e", #"l", #"a", #"t", #"i", #"v",
#"e", #" ", #"r", #"u", #"l", #"e"]
                                      (shows_rule
(shows_prec_lab B2_ C2_ Zero_nat) (shows_prec D2_ Zero_nat)
[#" ", #"-", #">", #" "] x))))
                        (fn _ => Inr ()))))
        end
    (fn x =>
      Inl (shows_string
             [#"t", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n",
               #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"p", #"r", #"o",
               #"b", #"l", #"e", #"m"] o
            (shows_nl o
              (shows_tp (shows_prec_lab B2_ C2_ Zero_nat)
                 (shows_prec D2_ Zero_nat) i tp o
                (shows_nl o
                  (shows_string
                     [#"m", #"a", #"y", #" ", #"n", #"o", #"t", #" ", #"b",
                       #"e", #" ", #"c", #"o", #"n", #"c", #"l", #"u", #"d",
                       #"e", #"d", #" ", #"f", #"r", #"o", #"m", #" ", #"a",
                       #"s", #"s", #"u", #"m", #"i", #"n", #"g", #" ", #"t",
                       #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o",
                       #"n", #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ",
                       #"p", #"r", #"o", #"b", #"l", #"e", #"m"] o
                    (shows_nl o
                      (shows_tp (shows_prec_lab B2_ C2_ Zero_nat)
                         (shows_prec D2_ Zero_nat) i (mka i q r rw) o
                        (shows_nl o (x o shows_nl))))))))));

fun fcc_tt (B1_, B2_) (C1_, C2_) i fcs cR tp =
  let
    val r = ra i tp;
    val q = qa i tp;
    val vs = vars_trs_list C1_ r;
    val fas = funas_trs_list B1_ r;
  in
    (case bindb (check (null q)
                  (shows_string
                     [#"Q", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ",
                       #"e", #"m", #"p", #"t", #"y"] o
                    shows_nl))
            (fn _ =>
              bindb (check (null (rwa i tp))
                      (shows_string
                         [#"w", #"e", #"a", #"k", #" ", #"r", #"u", #"l", #"e",
                           #"s", #" ", #"a", #"r", #"e", #" ", #"n", #"o", #"t",
                           #" ", #"e", #"m", #"p", #"t", #"y"] o
                        shows_nl))
                (fn _ =>
                  bindb (check (not (null fcs))
                          (shows_string
                             [#"a", #"t", #" ", #"l", #"e", #"a", #"s", #"t",
                               #" ", #"o", #"n", #"e", #" ", #"f", #"l", #"a",
                               #"t", #" ", #"c", #"o", #"n", #"t", #"e", #"x",
                               #"t", #" ", #"i", #"s", #" ", #"r", #"e", #"q",
                               #"u", #"i", #"r", #"e", #"d", #" ", #"f", #"o",
                               #"r", #" ", #"f", #"l", #"a", #"t", #" ", #"c",
                               #"o", #"n", #"t", #"e", #"x", #"t", #" ", #"c",
                               #"l", #"o", #"s", #"u", #"r", #"e"] o
                            shows_nl))
                    (fn _ =>
                      bindb (catch
                              (forallm
                                (check_flat_ctxt (C1_, C2_) (B1_, B2_) vs) fcs)
                              (fn x => Inl (snd x)))
                        (fn _ =>
                          bindb (catch
                                  (forallm
                                    (check_is_flat_ctxt (C1_, C2_) (B1_, B2_) vs
                                      fas)
                                    fcs)
                                  (fn x => Inl (snd x)))
                            (fn _ =>
                              bindb (catch
                                      (forallm
(check_flat_ctxt_complete (B1_, B2_) C2_ fcs) fas)
                                      (fn x => Inl (snd x)))
                                (fn _ =>
                                  bindb (catch
  (forallm (check_rule_preserving (B1_, B2_) (C1_, C2_) fcs cR) r)
  (fn x => Inl (snd x)))
                                    (fn _ =>
                                      catch
(forallm (check_rule_reflecting (B1_, B2_) (C1_, C2_) fcs r) cR)
(fn x => Inl (snd x)))))))))
      of Inl a => Inl a | Inr _ => Inr (mka i [] cR []))
  end;

fun rule_removal_tt B_ C_ i rp rremove trs =
  (case catch let
                val (rs, rns) = split_rulesa i trs rremove;
              in
                bindb (valid rp)
                  (fn _ =>
                    bindb (catch (mono rp)
                            (fn x =>
                              Inl (shows_string
                                     [#"p", #"r", #"o", #"b", #"l", #"e", #"m",
                                       #" ", #"w", #"i", #"t", #"h", #" ", #"m",
                                       #"o", #"n", #"o", #"t", #"o", #"n", #"i",
                                       #"c", #"i", #"t", #"y", #" ", #"o", #"f",
                                       #" ", #"s", #"t", #"r", #"i", #"c", #"t",
                                       #" ", #"o", #"r", #"d", #"e", #"r"] o
                                    (shows_nl o x))))
                      (fn _ =>
                        bindb (catch
                                (catch (forallm (ns rp) rns)
                                  (fn x => Inl (snd x)))
                                (fn x =>
                                  Inl (shows_string
 [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ", #"w", #"h", #"e", #"n", #" ",
   #"o", #"r", #"i", #"e", #"n", #"t", #"i", #"n", #"g", #" ", #"T", #"R",
   #"S"] o
(shows_nl o x))))
                          (fn _ =>
                            catch (catch (forallm (s rp) rs)
                                    (fn x => Inl (snd x)))
                              (fn x =>
                                Inl (shows_string
                                       [#"p", #"r", #"o", #"b", #"l", #"e",
 #"m", #" ", #"w", #"h", #"e", #"n", #" ", #"o", #"r", #"i", #"e", #"n", #"t",
 #"i", #"n", #"g", #" ", #"T", #"R", #"S"] o
                                      (shows_nl o x))))))
              end
          (fn x =>
            Inl (shows_string
                   [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                     #"a", #"p", #"p", #"l", #"y", #" ", #"t", #"h", #"e", #" ",
                     #"r", #"e", #"d", #"u", #"c", #"t", #"i", #"o", #"n", #" ",
                     #"p", #"a", #"i", #"r", #" ", #"p", #"r", #"o", #"c", #"e",
                     #"s", #"s", #"o", #"r", #" ", #"w", #"i", #"t", #"h", #" ",
                     #"t", #"h", #"e", #" ", #"f", #"o", #"l", #"l", #"o", #"w",
                     #"i", #"n", #"g"] o
                  (shows_nl o (desc rp o (shows_nl o x)))))
    of Inl a => Inl a | Inr _ => Inr (delete_R_Rwa i trs rremove rremove));

fun sem_lab_rel_tt (A1_, A2_) (B1_, B2_) splitter ld i valid check_decr
  check_model_lab lQ lAll tp =
  let
    val r = ra i tp;
    val rw = rwa i tp;
    val (lR, (lRw, d)) = splitter lAll rw;
  in
    (case bindb valid
            (fn _ =>
              let
                val q = qa i tp;
              in
                catch (bindb (check_decr d)
                        (fn _ =>
                          bindb (check_sl_Qa (A1_, A2_) (B1_, B2_) ld lQ q)
                            (fn _ =>
                              bindb (check_model_lab lR r)
                                (fn _ => check_model_lab lRw rw))))
                  (fn x =>
                    Inl (shows_string
                           [#"p", #"r", #"o", #"b", #"l", #"e", #"m", #" ",
                             #"w", #"i", #"t", #"h", #" ", #"l", #"a", #"b",
                             #"e", #"l", #"e", #"d", #" ", #"T", #"R", #"S",
                             #":"] o
                          (shows_nl o x)))
              end)
      of Inl a => Inl a | Inr _ => Inr (mka i lQ lR (lRw @ d)))
  end;

fun sem_lab_fin_tt (A1_, A2_) (B1_, B2_) D_ splitter lc ld cge i gen lQ lAll tp
  = bindb (gen (funas_trs_list A1_ (rulesb i tp)) [])
      (fn ops =>
        let
          val check_ml =
            check_sl_model_lab_trs (A1_, A2_) D_ (B1_, B2_) (sl_I ops)
              (sl_L ops) (sl_C ops) cge lc;
          val check_d = sl_check_decr ops;
        in
          sem_lab_rel_tt (A1_, A2_) (B1_, B2_) splitter ld i (Inr ()) check_d
            check_ml lQ lAll tp
        end);

fun semlab_fin_tt (B1_, B2_) (C1_, C2_) j (Rootlab uu) =
  sem_lab_fin_tt
    (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
    (C1_, C2_) (show_lab B2_ (show_list show_nat))
    (model_splitter (equal_lab B1_ (equal_list equal_nat)) C1_ label_decomp)
    label label_decomp (equal_laba B1_ (equal_list equal_nat)) j
    (slm_gen_to_sl_gen (rl_slm B1_ (equal_list equal_nat) NONE))
  | semlab_fin_tt (B1_, B2_) (C1_, C2_) j (Finitelab sli) =
    sem_lab_fin_tt
      (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
      (C1_, C2_) show_nat
      (model_splitter (equal_lab B1_ (equal_list equal_nat)) C1_ label_decomp)
      label label_decomp equal_nata j
      (slm_gen_to_sl_gen (fn _ => fn _ => Inr (sli_to_slm B1_ sli)))
  | semlab_fin_tt (B1_, B2_) (C1_, C2_) j (QuasiFinitelab (sli, v)) =
    sem_lab_fin_tt
      (equal_lab B1_ (equal_list equal_nat), show_lab B2_ (show_list show_nat))
      (C1_, C2_) show_nat
      (quasi_splitter (equal_lab B1_ (equal_list equal_nat)) C1_ label_decomp)
      label label_decomp qmodel_cge j
      (fn f => fn g => qsli_to_sl C1_ (B1_, B2_) v f g sli);

fun check_unary_signature A_ B_ r =
  catch (catch
          (forallm
            (fn x =>
              (if let
                    val (l, ra) = x;
                  in
                    unary_term l andalso unary_term ra
                  end
                then Inr () else Inl x))
            r)
          (fn x => Inl (snd x)))
    (fn x =>
      Inl (shows_string [#"t", #"h", #"e", #" ", #"r", #"u", #"l", #"e", #" "] o
            (shows_nl o
              (shows_rule (shows_prec A_ Zero_nat) (shows_prec B_ Zero_nat)
                 [#" ", #"-", #">", #" "] x o
                (shows_nl o
                  (shows_string
                     [#"v", #"i", #"o", #"l", #"a", #"t", #"e", #"s", #" ",
                       #"t", #"h", #"e", #" ", #"c", #"o", #"n", #"d", #"i",
                       #"t", #"i", #"o", #"n", #" ", #"t", #"h", #"a", #"t",
                       #" ", #"a", #"l", #"l", #" ", #"f", #"u", #"n", #"c",
                       #"t", #"i", #"o", #"n", #" ", #"s", #"y", #"m", #"b",
                       #"o", #"l", #"s"] o
                    (shows_nl o
                      shows_prec_list show_char Zero_nat
                        [#"h", #"a", #"v", #"e", #" ", #"t", #"o", #" ", #"b",
                          #"e", #" ", #"u", #"n", #"a", #"r", #"y"])))))));

fun string_reversal_tt B_ C_ i trs =
  let
    val r = rulesb i trs;
  in
    (case check_unary_signature B_ C_ r of Inl a => Inl a
      | Inr _ => Inr (mka i [] (mapa rev_rule r) []))
  end;

fun dP_list A_ B_ shp r d_list =
  maps (fn lr =>
         let
           val l = fst lr;
           val s = sharp_term shp l;
         in
           map_filter
             (fn x =>
               (if not (member (l, x) (supt A_ B_)) andalso
                     (not (is_var x) andalso
                       membera (equal_prod A_ equal_nat) d_list
                         (the (root x), num_args x))
                 then SOME (s, sharp_term shp x) else NONE))
             (supteq_list (snd lr))
         end)
    r;

fun is_QNFa
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = is_QNF;

fun useful_rule_impla q lr = list_all q (args (fst lr));

fun dependency_pairs_tt (B1_, B2_) (C1_, C2_) i j tp shp p =
  let
    val r = rulesb i tp;
    val q = qa i tp;
    val iQ = is_QNFa i tp;
    val u = filter (useful_rule_impla iQ) r;
  in
    (case catch (bindb (check_wf_trs B2_ (C1_, C2_) u)
                  (fn _ =>
                    bindb (catch (forallm (check_no_var B2_ C2_) q)
                            (fn x => Inl (snd x)))
                      (fn _ =>
                        let
                          val qr = mapa (fn Fun (f, ss) => (f, size_list ss)) q;
                          val d = defs_list B1_ u;
                        in
                          bindb (catch
                                  (forallm
                                    (fn (f, n) =>
                                      check
(not (membera (equal_prod B1_ equal_nat) d (shp f, n)))
(shows_string [#"s", #"h", #"a", #"r", #"p", #"i", #"n", #"g", #" "] o
  (shows_prec B2_ Zero_nat f o
    (shows_string
       [#" ", #"y", #"i", #"e", #"l", #"d", #"s", #" ", #"t", #"h", #"e", #" ",
         #"d", #"e", #"f", #"i", #"n", #"e", #"d", #" ", #"s", #"y", #"m", #"b",
         #"o", #"l", #" "] o
      shows_prec B2_ Zero_nat (shp f)))))
                                    d)
                                  (fn x => Inl (snd x)))
                            (fn _ =>
                              bindb (catch
                                      (forallm
(fn (f, n) =>
  check (not (membera (equal_prod B1_ equal_nat) qr (shp f, n)))
    (shows_string [#"s", #"h", #"a", #"r", #"p", #"i", #"n", #"g", #" "] o
      (shows_prec B2_ Zero_nat f o
        (shows_string
           [#" ", #"y", #"i", #"e", #"l", #"d", #"s", #" ", #"t", #"h", #"e",
             #" ", #"s", #"y", #"m", #"b", #"o", #"l", #" "] o
          (shows_prec B2_ Zero_nat (shp f) o
            shows_string
              [#" ", #"w", #"h", #"i", #"c", #"h", #" ", #"i", #"s", #" ", #"a",
                #" ", #"r", #"o", #"o", #"t", #" ", #"o", #"f", #" ", #"Q"])))))
d)
                                      (fn x => Inl (snd x)))
                                (fn _ =>
                                  catch (check_subseteq
  (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_))
  (dP_list B1_ C1_ shp u d) p)
                                    (fn x =>
                                      Inl
(shows_string [#"t", #"h", #"e", #" ", #"D", #"P", #" "] o
  (shows_rule (shows_prec B2_ Zero_nat) (shows_prec C2_ Zero_nat)
     [#" ", #"-", #">", #" "] x o
    (shows_string
       [#" ", #"d", #"o", #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"a", #"p",
         #"p", #"e", #"a", #"r", #" ", #"i", #"n", #" ", #"t", #"h", #"e", #" ",
         #"D", #"P", #" ", #"p", #"r", #"o", #"b", #"l", #"e", #"m"] o
      shows_nl))))))
                        end)))
            (fn x =>
              Inl (shows_string
                     [#"t", #"h", #"e", #" ", #"D", #"P", #"-", #"t", #"r",
                       #"a", #"n", #"s", #"f", #"o", #"r", #"m", #"a", #"t",
                       #"i", #"o", #"n", #" ", #"i", #"s", #" ", #"n", #"o",
                       #"t", #" ", #"a", #"p", #"p", #"l", #"i", #"e", #"d",
                       #" ", #"c", #"o", #"r", #"r", #"e", #"c", #"t", #"l",
                       #"y", #"."] o
                    (shows_nl o x)))
      of Inl a => Inl a | Inr _ => Inr (mkc j p [] q [] r))
  end;

fun check_trs_proof (B1_, B2_, B3_) a ia i j tp RisEmpty =
  debug (ia []) [#"R", #" ", #"i", #"s", #" ", #"e", #"m", #"p", #"t", #"y"]
    (if null (ra i tp) then Inr ()
      else Inl (ia o (shows_string
                        [#":", #" ", #"R", #" ", #"i", #"s", #" ", #"n", #"o",
                          #"t", #" ", #"e", #"m", #"p", #"t", #"y", #" ", #"i",
                          #"n", #" ", #"t", #"h", #"e", #" ", #"f", #"o", #"l",
                          #"l", #"o", #"w", #"i", #"n", #"g", #" ", #"t", #"e",
                          #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n",
                          #"-", #"p", #"r", #"o", #"b", #"l", #"e", #"m",
                          #" "] o
                       (shows_nl o
                         shows_tp
                           (shows_prec_lab B3_ (show_list show_nat) Zero_nat)
                           (shows_prec_list show_char Zero_nat) i tp))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (RuleRemoval (redp, rR, prf)) =
    debug (ia [])
      [#"R", #"u", #"l", #"e", #" ", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
      let
        val r = rulesb i tp;
        val rr =
          list_diff
            (equal_prod
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char))
              (equal_term (equal_lab B1_ (equal_list equal_nat))
                (equal_list equal_char)))
            r rR;
      in
        bindb (catch
                (rule_removal_tt (show_lab B3_ (show_list show_nat))
                  (show_list show_char) i
                  (get_redtriple
                    (equal_lab B1_ (equal_list equal_nat),
                      show_lab B3_ (show_list show_nat))
                    (equal_list equal_char, show_list show_char) redp)
                  rr tp)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"w", #"h", #"e", #"n", #" ", #"a", #"p", #"p",
                                 #"l", #"y", #"i", #"n", #"g", #" ", #"t", #"h",
                                 #"e", #" ", #"r", #"u", #"l", #"e", #" ", #"r",
                                 #"e", #"m", #"o", #"v", #"a", #"l", #" ", #"t",
                                 #"e", #"c", #"h", #"n", #"i", #"q", #"u", #"e",
                                 #" ", #"o", #"n", #" "] o
                              (shows_nl o
                                (shows_tp
                                   (shows_prec_lab B3_ (show_list show_nat)
                                     Zero_nat)
                                   (shows_prec_list show_char Zero_nat) i tp o
                                  (shows_nl o
                                    (shows_string
                                       [#" ", #"t", #"o", #" ", #"r", #"e",
 #"m", #"o", #"v", #"e", #" ", #"t", #"h", #"e", #" ", #"r", #"u", #"l", #"e",
 #"s", #" "] o
                                      (shows_nl o
(shows_rules (shows_prec_lab B3_ (show_list show_nat) Zero_nat)
   (shows_prec_list show_char Zero_nat) [#" ", #"-", #">", #" "] rr o
  (shows_nl o x)))))))))))
          (fn tpa =>
            catch (check_trs_proof (B1_, B2_, B3_) a
                    (ia o shows_string [#".", #"1"]) i j tpa prf)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"r", #"u", #"l", #"e", #" ", #"r",
                               #"e", #"m", #"o", #"v", #"a", #"l", #" ", #"t",
                               #"e", #"c", #"h", #"n", #"i", #"q", #"u", #"e"] o
                            (shows_nl o indent x)))))
      end
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (DPTrans (p, prf)) =
    debug (ia []) [#"D", #"P", #" ", #"t", #"r", #"a", #"n", #"s"]
      (bindb
        (catch
          (dependency_pairs_tt
            (equal_lab B1_ (equal_list equal_nat),
              show_lab B3_ (show_list show_nat))
            (equal_list equal_char, show_list show_char) i j tp Sharp p)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"s", #"w", #"i", #"t", #"c",
                           #"h", #"i", #"n", #"g", #" ", #"f", #"r", #"o", #"m",
                           #" ", #"t", #"h", #"e", #" ", #"T", #"R", #"S"] o
                        (shows_nl o
                          (shows_tp
                             (shows_prec_lab B3_ (show_list show_nat) Zero_nat)
                             (shows_prec_list show_char Zero_nat) i tp o
                            (shows_nl o
                              (shows_string
                                 [#"t", #"o", #" ", #"t", #"h", #"e", #" ",
                                   #"i", #"n", #"i", #"t", #"i", #"a", #"l",
                                   #" ", #"D", #"P", #" ", #"p", #"r", #"o",
                                   #"b", #"l", #"e", #"m", #" ", #"w", #"i",
                                   #"t", #"h", #" ", #"p", #"a", #"i", #"r",
                                   #"s", #" "] o
                                (shows_nl o
                                  (shows_rules
                                     (shows_prec_lab B3_ (show_list show_nat)
                                       Zero_nat)
                                     (shows_prec_list show_char Zero_nat)
                                     [#" ", #"-", #">", #" "] p o
                                    (shows_nl o x)))))))))))
        (fn dpp =>
          catch (check_dp_proof (B1_, B3_) a (ia o shows_string [#".", #"1"]) j
                  dpp prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"s", #"w",
                             #"i", #"t", #"c", #"h", #" ", #"t", #"o", #" ",
                             #"d", #"e", #"p", #"e", #"n", #"d", #"e", #"n",
                             #"c", #"y", #" ", #"p", #"a", #"i", #"r", #"s"] o
                          (shows_nl o indent x))))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (StringReversal prf) =
    debug (ia [])
      [#"S", #"t", #"r", #"i", #"n", #"g", #" ", #"R", #"e", #"v", #"e", #"r",
        #"s", #"a", #"l"]
      (bindb
        (catch
          (string_reversal_tt (show_lab B3_ (show_list show_nat))
            (show_list show_char) i tp)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                           #"i", #"n", #"g", #" ", #"s", #"t", #"r", #"i", #"n",
                           #"g", #" ", #"r", #"e", #"v", #"e", #"r", #"s", #"a",
                           #"l", #" ", #"o", #"n", #" "] o
                        (shows_nl o
                          (shows_tp
                             (shows_prec_lab B3_ (show_list show_nat) Zero_nat)
                             (shows_prec_list show_char Zero_nat) i tp o
                            (shows_nl o x)))))))
        (fn tpa =>
          catch (check_trs_proof (B1_, B2_, B3_) a
                  (ia o shows_string [#".", #"1"]) i j tpa prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                             #"e", #" ", #"s", #"t", #"r", #"i", #"n", #"g",
                             #" ", #"r", #"e", #"v", #"e", #"r", #"s", #"a",
                             #"l", #" ", #"t", #"e", #"c", #"h", #"n", #"i",
                             #"q", #"u", #"e"] o
                          (shows_nl o indent x))))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (Semlab (sli, lQ, lAll, prf)) =
    debug (ia []) [#"S", #"e", #"m", #"l", #"a", #"b"]
      (bindb
        (catch
          (semlab_fin_tt (B1_, B3_) (equal_list equal_char, show_list show_char)
            i sli lQ lAll tp)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                           #"i", #"n", #"g", #" ", #"s", #"e", #"m", #"a", #"n",
                           #"t", #"i", #"c", #" ", #"l", #"a", #"b", #"e", #"l",
                           #"l", #"i", #"n", #"g", #" ", #"o", #"n", #" "] o
                        (shows_nl o
                          (shows_tp
                             (shows_prec_lab B3_ (show_list show_nat) Zero_nat)
                             (shows_prec_list show_char Zero_nat) i tp o
                            (shows_nl o x)))))))
        (fn tpa =>
          catch (check_trs_proof (B1_, B2_, B3_) a
                  (ia o shows_string [#".", #"1"]) i j tpa prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                             #"e", #" ", #"s", #"e", #"m", #".", #"l", #"a",
                             #"b", #" ", #"t", #"e", #"c", #"h", #"n", #"i",
                             #"q", #"u", #"e"] o
                          (shows_nl o indent x))))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (Bounds info) =
    debug (ia []) [#"B", #"o", #"u", #"n", #"d", #"s"]
      (catch
        (bounds_tt
          (equal_lab B1_ (equal_list equal_nat),
            linorder_lab (B1_, B2_)
              (equal_list equal_nat, linorder_list (equal_nat, linorder_nat)),
            show_lab B3_ (show_list show_nat))
          (equal_list equal_char, linorder_list (equal_char, linorder_char),
            show_list show_char)
          i info tp)
        (fn x =>
          Inl (ia o (shows_string
                       [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                         #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                         #"i", #"n", #"g", #" ", #"b", #"o", #"u", #"n", #"d",
                         #"s", #" ", #"o", #"n", #" ", #"t", #"h", #"e", #" ",
                         #"t", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i",
                         #"o", #"n", #" ", #"p", #"r", #"o", #"b", #"l", #"e",
                         #"m", #" "] o
                      (shows_nl o
                        (shows_tp
                           (shows_prec_lab B3_ (show_list show_nat) Zero_nat)
                           (shows_prec_list show_char Zero_nat) i tp o
                          (shows_nl o x)))))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (Uncurry (u_info, rR, prf)) =
    debug (ia []) [#"U", #"n", #"c", #"u", #"r", #"r", #"y"]
      (bindb
        (catch
          (uncurry_tt
            (equal_lab B1_ (equal_list equal_nat),
              show_lab B3_ (show_list show_nat))
            i u_info rR tp)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                           #"i", #"n", #"g", #" ", #"c", #"u", #"r", #"r", #"y",
                           #"i", #"n", #"g", #" ", #"t", #"r", #"a", #"n", #"s",
                           #"f", #"o", #"r", #"m", #"a", #"t", #"i", #"o",
                           #"n"] o
                        (shows_nl o x)))))
        (fn tpa =>
          catch (check_trs_proof (B1_, B2_, B3_) a
                  (ia o shows_string [#".", #"1"]) i j tpa prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                             #"e", #" ", #"u", #"n", #"c", #"u", #"r", #"r",
                             #"y", #"i", #"n", #"g", #" ", #"t", #"e", #"c",
                             #"h", #"n", #"i", #"q", #"u", #"e"] o
                          (shows_nl o indent x))))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (Fcc (fcs, r, prf)) =
    debug (ia []) [#"F", #"c", #"c"]
      (bindb
        (catch
          (fcc_tt
            (equal_lab B1_ (equal_list equal_nat),
              show_lab B3_ (show_list show_nat))
            (equal_list equal_char, show_list show_char) i fcs r tp)
          (fn x =>
            Inl (ia o (shows_string
                         [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"w",
                           #"h", #"e", #"n", #" ", #"a", #"p", #"p", #"l", #"y",
                           #"i", #"n", #"g", #" ", #"f", #"l", #"a", #"t", #" ",
                           #"c", #"o", #"n", #"t", #"e", #"x", #"t", #" ", #"c",
                           #"l", #"o", #"s", #"u", #"r", #"e"] o
                        (shows_nl o x)))))
        (fn tpa =>
          catch (check_trs_proof (B1_, B2_, B3_) a
                  (ia o shows_string [#".", #"1"]) i j tpa prf)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"b", #"e", #"l", #"o", #"w", #" ", #"f", #"l",
                             #"a", #"t", #" ", #"c", #"o", #"n", #"t", #"e",
                             #"x", #"t", #" ", #"c", #"l", #"o", #"s", #"u",
                             #"r", #"e"] o
                          (shows_nl o indent x))))))
  | check_trs_proof (B1_, B2_, B3_) a ia i j tp (Split (rrem, prf1, prf2)) =
    debug (ia []) [#"S", #"p", #"l", #"i", #"t"]
      let
        val (tp1, tp2) =
          split_tt (show_lab B3_ (show_list show_nat)) (show_list show_char) i
            tp rrem;
      in
        bindb (catch
                (check_trs_proof (B1_, B2_, B3_) a
                  (ia o shows_string [#".", #"1"]) i j tp1 prf1)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                                 #"e", #" ", #"s", #"p", #"l", #"i", #"t", #"t",
                                 #"i", #"n", #"g"] o
                              (shows_nl o indent x)))))
          (fn _ =>
            catch (check_trs_proof (B1_, B2_, B3_) a
                    (ia o shows_string [#".", #"2"]) i j tp2 prf2)
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"b", #"e", #"l", #"o", #"w", #" ", #"t", #"h",
                               #"e", #" ", #"s", #"p", #"l", #"i", #"t", #"t",
                               #"i", #"n", #"g"] o
                            (shows_nl o indent x)))))
      end
  | check_trs_proof (B1_, B2_, B3_) a ia i j tpa (AssumeSN tp) =
    debug (ia [])
      [#"T", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n", #" ",
        #"A", #"s", #"s", #"u", #"m", #"p", #"t", #"i", #"o", #"n"]
      (if a then catch (check_tp_subsumes (B1_, B3_)
                         (equal_list equal_nat, show_list show_nat)
                         (equal_list equal_char, show_list show_char) i tp tpa)
                   (fn x =>
                     Inl (ia o (shows_string
                                  [#":", #" ", #"e", #"r", #"r", #"o", #"r",
                                    #" ", #"i", #"n", #" ", #"t", #"e", #"r",
                                    #"m", #"i", #"n", #"a", #"t", #"i", #"o",
                                    #"n", #" ", #"a", #"s", #"s", #"u", #"m",
                                    #"p", #"t", #"i", #"o", #"n"] o
                                 (shows_nl o (x o shows_nl)))))
        else Inl (ia o (shows_string
                          [#":", #" ", #"t", #"h", #"e", #" ", #"p", #"r", #"o",
                            #"o", #"f", #" ", #"c", #"o", #"n", #"t", #"a",
                            #"i", #"n", #"s", #" ", #"a", #" ", #"l", #"o",
                            #"c", #"a", #"l", #" ", #"t", #"e", #"r", #"m",
                            #"i", #"n", #"a", #"t", #"i", #"o", #"n", #" ",
                            #"a", #"s", #"s", #"u", #"m", #"p", #"t", #"i",
                            #"o", #"n"] o
                         shows_nl)));

fun contains_var_term A_ x (Var y) = eq A_ x y
  | contains_var_term A_ x (Fun (uu, ts)) = list_ex (contains_var_term A_ x) ts;

fun ident_solve_impla A_ B_ mu v_incr cps stn =
  let
    val cp =
      remdups
        (equal_prod (equal_term B_ A_)
          (equal_prod (equal_term B_ A_) equal_nat))
        (conflict_pos A_ B_ mu stn);
  in
    (if list_ex (fn (u, (_, _)) => not (is_var u)) cp then NONE
      else (if list_ex
                 (fn (u, (v, _)) =>
                   is_var u andalso
                     (not (is_var v) andalso
                       (not (membera A_ v_incr (the_var u)) orelse
                         contains_var_term A_ (the_var u) v)))
                 cp
             then NONE
             else (if list_ex
                        (fn (u, (v, m)) =>
                          is_var u andalso
                            (not (is_var v) andalso
                              list_ex
                                (fn (ua, (va, ma)) =>
                                  equal_terma B_ A_ ua u andalso
                                    (not (is_var va) andalso
                                      is_none
(mgu B_ A_ (subst_apply_term v (substpow_impl mu m))
  (subst_apply_term va (substpow_impl mu ma)))))
                                cps))
                        cp
                    then NONE
                    else (if list_ex
                               (fn (u, (v, _)) =>
                                 membera
                                   (equal_prod (equal_term B_ A_)
                                     (equal_term B_ A_))
                                   (mapa (fn (ua, (va, _)) => (ua, va)) cps)
                                   (u, v))
                               cp
                           then NONE
                           else bind (mapM (fn (u, (v, m)) =>
     ident_solve_impla A_ B_ mu v_incr ((u, (v, m)) :: cps)
       (subst_apply_term u mu, (v, Suc m)))
                                       cp)
                                  (fn is => SOME (max_list (mapa Suc is)))))))
  end;

fun ident_solve_impl A_ B_ =
  (fn mu => fn vincr => fn (s, t) =>
    ident_solve_impla A_ B_ mu vincr [] (s, (t, Zero_nat)));

fun redex_rps_decision A_ B_ mu =
  let
    val mua = mk_subst A_ mu;
    val d = mk_subst_domain A_ B_ mu;
    val v = v_incr_impl A_ d;
    val simp = simplify_mp A_ B_ mu v;
    val ident = ident_solve_impl A_ B_ mua v;
    val w = w_impl A_ d;
    val main = redex_decision B_ A_ B_ A_ mua simp ident w;
  in
    (fn xs =>
      catch (forallm (fn tl => check (not (main tl)) tl) xs)
        (fn x => Inl (snd x)))
  end;

fun check_NF_iteration A_ B_ mu =
  let
    val dec = redex_rps_decision A_ B_ mu;
  in
    (fn q => fn t => dec (mapa (fn a => (t, a)) q))
  end;

fun check_qrstep_subst (A1_, A2_) (B1_, B2_) cni =
  let
    val main =
      check_prop_rstep (A1_, A2_) (B1_, B2_)
        (fn t =>
          catch (cni t)
            (fn _ =>
              Inl (shows_prec_term A2_ B2_ Zero_nat t o
                    shows_prec_list show_char Zero_nat
                      [#" ", #"m", #"u", #" ", #"^", #"^", #" ", #"i", #" ",
                        #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"i", #"n",
                        #" ", #"Q", #"-", #"n", #"o", #"r", #"m", #"a", #"l",
                        #" ", #"f", #"o", #"r", #"m", #" ", #"f", #"o", #"r",
                        #" ", #"a", #"l", #"l", #" ", #"i"])));
  in
    (fn r => fn p => fn ra => fn s => fn t =>
      bindb (check (not (is_var (fst ra)))
              (shows_prec_list show_char Zero_nat
                [#"l", #"o", #"o", #"p", #" ", #"c", #"h", #"e", #"c", #"k",
                  #" ", #"r", #"e", #"q", #"u", #"i", #"r", #"e", #"s", #" ",
                  #"l", #"h", #"s", #"s", #" ", #"t", #"o", #" ", #"b", #"e",
                  #" ", #"n", #"o", #"n", #"-", #"v", #"a", #"r", #"i", #"a",
                  #"b", #"l", #"e"]))
        (fn _ => main r p ra s t))
  end;

fun check_rqrstep_subst (A1_, A2_) (B1_, B2_) cni =
  (fn r => check_qrstep_subst (A1_, A2_) (B1_, B2_) cni r Empty);

fun check_qsteps_subst (A1_, A2_) (B1_, B2_) cni p r [] s u =
  check (equal_terma A1_ B1_ s u)
    (shows_string
       [#"t", #"h", #"e", #" ", #"l", #"a", #"s", #"t", #" ", #"t", #"e", #"r",
         #"m", #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"r", #"e", #"w",
         #"r", #"i", #"t", #"e", #" ", #"s", #"e", #"q", #"u", #"e", #"n", #"c",
         #"e"] o
      (shows_nl o
        (shows_prec_term A2_ B2_ Zero_nat s o
          (shows_nl o
            (shows_string
               [#"d", #"o", #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"c",
                 #"o", #"r", #"r", #"e", #"s", #"p", #"o", #"n", #"d", #" ",
                 #"t", #"o", #" ", #"t", #"h", #"e", #" ", #"g", #"o", #"a",
                 #"l", #" ", #"t", #"e", #"r", #"m"] o
              (shows_nl o (shows_prec_term A2_ B2_ Zero_nat u o shows_nl)))))))
  | check_qsteps_subst (A1_, A2_) (B1_, B2_) cni p ra
    ((uu, (r, (true, t))) :: prts) s u =
    bindb (check_rqrstep_subst (A1_, A2_) (B1_, B2_) cni p r s t)
      (fn _ => check_qsteps_subst (A1_, A2_) (B1_, B2_) cni p ra prts t u)
  | check_qsteps_subst (A1_, A2_) (B1_, B2_) cni pa ra
    ((p, (r, (false, t))) :: prts) s u =
    bindb (check_qrstep_subst (A1_, A2_) (B1_, B2_) cni ra p r s t)
      (fn _ => check_qsteps_subst (A1_, A2_) (B1_, B2_) cni pa ra prts t u);

fun check_qrsteps_subst (A1_, A2_) (B1_, B2_) cni r prts s u =
  check_qsteps_subst (A1_, A2_) (B1_, B2_) cni [] r
    (mapa (fn (p, (ra, t)) => (p, (ra, (false, t)))) prts) s u;

fun check_loop (A1_, A2_) (B1_, B2_) q nf s rseq sigma c r =
  bindb (check (not (null rseq))
          (shows_prec_list show_char Zero_nat
            [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s", #"e", #"q",
              #"u", #"e", #"n", #"c", #"e", #" ", #"m", #"u", #"s", #"t", #" ",
              #"b", #"e", #" ", #"n", #"o", #"n", #"-", #"e", #"m", #"p", #"t",
              #"y"]))
    (fn _ =>
      (if null q
        then check_rsteps (A1_, A2_) (B1_, B2_) r rseq s
               (ctxt_apply c (subst_apply_term s (mk_subst B1_ sigma)))
        else check_qrsteps_subst (A1_, A2_) (B1_, B2_)
               (check_NF_iteration B1_ A1_ sigma q) r rseq s
               (ctxt_apply c (subst_apply_term s (mk_subst B1_ sigma)))));

fun check_rqrstep (A1_, A2_) (B1_, B2_) nf r rule s t =
  check_qrstep (A1_, A2_) (B1_, B2_) nf r Empty rule s t;

fun check_qsteps (A1_, A2_) (B1_, B2_) nf p r [] s u =
  check (equal_terma A1_ B1_ s u)
    (shows_string
       [#"t", #"h", #"e", #" ", #"l", #"a", #"s", #"t", #" ", #"t", #"e", #"r",
         #"m", #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"r", #"e", #"w",
         #"r", #"i", #"t", #"e", #" ", #"s", #"e", #"q", #"u", #"e", #"n", #"c",
         #"e"] o
      (shows_nl o
        (shows_prec_term A2_ B2_ Zero_nat s o
          (shows_nl o
            (shows_string
               [#"d", #"o", #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"c",
                 #"o", #"r", #"r", #"e", #"s", #"p", #"o", #"n", #"d", #" ",
                 #"t", #"o", #" ", #"t", #"h", #"e", #" ", #"g", #"o", #"a",
                 #"l", #" ", #"t", #"e", #"r", #"m"] o
              (shows_nl o (shows_prec_term A2_ B2_ Zero_nat u o shows_nl)))))))
  | check_qsteps (A1_, A2_) (B1_, B2_) nf p ra ((uu, (r, (true, t))) :: prts) s
    u = bindb (check_rqrstep (A1_, A2_) (B1_, B2_) nf p r s t)
          (fn _ => check_qsteps (A1_, A2_) (B1_, B2_) nf p ra prts t u)
  | check_qsteps (A1_, A2_) (B1_, B2_) nf pa ra ((p, (r, (false, t))) :: prts) s
    u = bindb (check_qrstep (A1_, A2_) (B1_, B2_) nf ra p r s t)
          (fn _ => check_qsteps (A1_, A2_) (B1_, B2_) nf pa ra prts t u);

fun check_dp_loop (A1_, A2_) (B1_, B2_) q nf s prseq sigma c p r =
  (if equal_ctxt A1_ B1_ c Hole
    then bindb (check (not (null prseq))
                 (shows_prec_list show_char Zero_nat
                   [#"r", #"e", #"w", #"r", #"i", #"t", #"e", #" ", #"s", #"e",
                     #"q", #"u", #"e", #"n", #"c", #"e", #" ", #"m", #"u", #"s",
                     #"t", #" ", #"b", #"e", #" ", #"n", #"o", #"n", #"-", #"e",
                     #"m", #"p", #"t", #"y"]))
           (fn _ =>
             (if null q
               then check_qsteps (A1_, A2_) (B1_, B2_) nf p r prseq s
                      (subst_apply_term s (mk_subst B1_ sigma))
               else check_qsteps_subst (A1_, A2_) (B1_, B2_)
                      (check_NF_iteration B1_ A1_ sigma q) p r prseq s
                      (subst_apply_term s (mk_subst B1_ sigma))))
    else check_loop (A1_, A2_) (B1_, B2_) q nf s
           (mapa (fn (x, (y, (_, z))) => (x, (y, z))) prseq) sigma c r);

fun check_dp_disproof (B1_, B2_) (C1_, C2_) ia i dpp
  (DP_Loop (s, rseq, sigma, c)) =
  debug (ia []) [#"L", #"o", #"o", #"p"]
    let
      val p = pairsa i dpp;
      val r = rulesd i dpp;
      val nf = is_QNFc i dpp;
      val q = qc i dpp;
    in
      check_dp_loop (B1_, B2_) (C1_, C2_) q nf s rseq sigma c p r
    end
  | check_dp_disproof (B1_, B2_) (C1_, C2_) ia i dpp
    (DP_Rule_Removal (p, r, prf)) =
    debug (ia [])
      [#"R", #"u", #"l", #"e", #" ", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
      let
        val pa = pairsa i dpp;
        val prm =
          list_diff (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_)) pa p;
        val ra = rulesd i dpp;
        val rrm =
          list_diff (equal_prod (equal_term B1_ C1_) (equal_term B1_ C1_)) ra r;
      in
        check_dp_disproof (B1_, B2_) (C1_, C2_) (ia o shows_string [#".", #"1"])
          i (delete_R_Rwc i (delete_P_Pwa i dpp prm prm) rrm rrm) prf
      end;

fun unsharp (Sharp f) = f
  | unsharp (Lab (v, va)) = Lab (v, va)
  | unsharp (FunLab (v, va)) = FunLab (v, va)
  | unsharp (UnLab v) = UnLab v;

fun check_dps (A1_, A2_) (B1_, B2_) unshp r p =
  let
    val d = defs_list A1_ r;
  in
    catch (forallm
            (fn x =>
              (if let
                    val (ll, rr) = x;
                  in
                    not (is_var rr) andalso
                      (not (membera (equal_prod A1_ equal_nat) d
                             (the (root rr), num_args rr)) andalso
                        list_ex
                          (fn (l, ra) =>
                            equal_terma A1_ B1_ l (sharp_term unshp ll) andalso
                              member (ra, sharp_term unshp rr) (supteq A1_ B1_))
                          r)
                  end
                then Inr () else Inl x))
            p)
      (fn x => Inl (snd x))
  end;

fun q_emptya
  (Tp_ops_ext
    (qreltrs, q, r, rw, rules, q_empty, is_QNF, nFQ_subset_NF_rules, rules_map,
      delete_R_Rw, split_rules, mk, more))
  = q_empty;

fun useful_rule_impl nf r = list_all nf (args (fst r));

fun check_wwf_qtrs A_ (B1_, B2_) nf r =
  catch (catch
          (forallm
            (fn ra =>
              (if useful_rule_impl nf ra
                then catch (bindb
                             (check (not (is_var (fst ra)))
                               (shows_string
                                 [#"v", #"a", #"r", #"i", #"a", #"b", #"l",
                                   #"e", #" ", #"l", #"e", #"f", #"t", #"-",
                                   #"h", #"a", #"n", #"d", #" ", #"s", #"i",
                                   #"d", #"e", #" ", #"i", #"n"]))
                             (fn _ =>
                               catch (check_subseteq B1_
                                       (vars_term_list B1_ (snd ra))
                                       (vars_term_list B1_ (fst ra)))
                                 (fn x =>
                                   Inl (shows_string
  [#"f", #"r", #"e", #"e", #" ", #"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e",
    #" "] o
 (shows_prec B2_ Zero_nat x o
   shows_string
     [#" ", #"i", #"n", #" ", #"r", #"i", #"g", #"h", #"t", #"-", #"h", #"a",
       #"n", #"d", #" ", #"s", #"i", #"d", #"e", #" ", #"o", #"f"])))))
                       (fn x =>
                         Inl (x o (shows_string
                                     [#" ", #"r", #"u", #"l", #"e", #" "] o
                                    (shows_rule (shows_prec A_ Zero_nat)
                                       (shows_prec B2_ Zero_nat)
                                       [#" ", #"-", #">", #" "] ra o
                                      shows_nl))))
                else Inr ()))
            r)
          (fn x => Inl (snd x)))
    (fn x =>
      Inl (shows_string
             [#"t", #"h", #"e", #" ", #"Q", #"-", #"T", #"R", #"S", #" ", #"i",
               #"s", #" ", #"n", #"o", #"t", #" ", #"w", #"e", #"a", #"k", #"l",
               #"y", #" ", #"w", #"e", #"l", #"l", #"-", #"f", #"o", #"r", #"m",
               #"e", #"d"] o
            (shows_nl o x)));

fun check_not_wwf_qtrs A_ (B1_, B2_) nf r =
  check (not (isOK (check_wwf_qtrs A_ (B1_, B2_) nf r)))
    (shows_string
       [#"T", #"h", #"e", #" ", #"Q", #"-", #"T", #"R", #"S", #" ", #"i", #"s",
         #" ", #"w", #"e", #"l", #"l", #" ", #"f", #"o", #"r", #"m", #"e",
         #"d"] o
      shows_nl);

fun check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
  (TRS_Loop (s, rseq, sigma, c)) =
  debug (ia []) [#"L", #"o", #"o", #"p"]
    let
      val r = rulesb i tp;
      val nf = is_QNFa i tp;
      val q = qa i tp;
    in
      check_loop (equal_lab B1_ C1_, show_lab B2_ C2_) (D1_, D2_) q nf s rseq
        sigma c r
    end
  | check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    TRS_Not_Well_Formed =
    debug (ia [])
      [#"N", #"o", #"t", #" ", #"W", #"e", #"l", #"l", #"-", #"F", #"o", #"r",
        #"m", #"e", #"d"]
      (catch
        (check_not_wwf_qtrs (show_lab B2_ C2_) (D1_, D2_) (is_QNFa i tp)
          (rulesb i tp))
        (fn x =>
          Inl (ia o (shows_string
                       [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ", #"i",
                         #"n", #" ", #"n", #"o", #"t", #" ", #"w", #"e", #"l",
                         #"l", #"-", #"f", #"o", #"r", #"m", #"e", #"d", #" ",
                         #"p", #"r", #"o", #"o", #"f"] o
                      (shows_nl o x)))))
  | check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    (TRS_Rule_Removal (r, prf)) =
    debug (ia [])
      [#"R", #"u", #"l", #"e", #" ", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
      let
        val ra = rulesb i tp;
        val rrm =
          list_diff
            (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
              (equal_term (equal_lab B1_ C1_) D1_))
            ra r;
      in
        check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_)
          (ia o shows_string [#".", #"1"]) i j (delete_R_Rwa i tp rrm rrm) prf
      end
  | check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    (TRS_String_Reversal prf) =
    debug (ia [])
      [#"S", #"t", #"r", #"i", #"n", #"g", #" ", #"R", #"e", #"v", #"e", #"r",
        #"s", #"a", #"l"]
      let
        val r = rulesb i tp;
      in
        bindb (check (q_emptya i tp)
                (shows_prec_list show_char Zero_nat
                  [#"Q", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"e",
                    #"m", #"p", #"t", #"y"]))
          (fn _ =>
            bindb (catch
                    (case check_unary_signature (show_lab B2_ C2_) D2_ r
                      of Inl a => Inl a
                      | Inr _ => Inr (mka i [] (mapa rev_rule r) []))
                    (fn x =>
                      Inl (ia o (shows_string
                                   [#":", #" ", #"e", #"r", #"r", #"o", #"r",
                                     #" ", #"w", #"h", #"e", #"n", #" ", #"a",
                                     #"p", #"p", #"l", #"y", #"i", #"n", #"g",
                                     #" ", #"s", #"t", #"r", #"i", #"n", #"g",
                                     #" ", #"r", #"e", #"v", #"e", #"r", #"s",
                                     #"a", #"l", #" ", #"o", #"n"] o
                                  (shows_nl o
                                    (shows_tp (shows_prec_lab B2_ C2_ Zero_nat)
                                       (shows_prec D2_ Zero_nat) i tp o
                                      (shows_nl o x)))))))
              (fn tpa =>
                catch (check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_)
                        (ia o shows_string [#".", #"1"]) i j tpa prf)
                  (fn x =>
                    Inl (ia o (shows_string
                                 [#":", #" ", #"e", #"r", #"r", #"o", #"r",
                                   #" ", #"b", #"e", #"l", #"o", #"w", #" ",
                                   #"t", #"h", #"e", #" ", #"s", #"t", #"r",
                                   #"i", #"n", #"g", #" ", #"r", #"e", #"v",
                                   #"e", #"r", #"s", #"a", #"l", #" ", #"t",
                                   #"e", #"c", #"h", #"n", #"i", #"q", #"u",
                                   #"e"] o
                                (shows_nl o indent x))))))
      end
  | check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    (TRS_DP_Trans (p, prf)) =
    debug (ia [])
      [#"D", #"P", #" ", #"T", #"r", #"a", #"n", #"s", #"f", #"o", #"r", #"m",
        #"a", #"t", #"i", #"o", #"n"]
      let
        val r = rulesb i tp;
        val q = qa i tp;
      in
        bindb (catch
                (check_dps (equal_lab B1_ C1_, show_lab B2_ C2_) (D1_, D2_)
                  unsharp r p)
                (fn x =>
                  Inl (ia o (shows_string
                               [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                                 #"i", #"n", #" ", #"D", #"P", #" ", #"t", #"r",
                                 #"a", #"n", #"s", #"f", #"o", #"r", #"m", #"a",
                                 #"t", #"i", #"o", #"n"] o
                              (shows_nl o
                                (shows_prec_list show_char Zero_nat
                                   [#"p", #"r", #"o", #"b", #"l", #"e", #"m",
                                     #"a", #"t", #"i", #"c", #" ", #"r", #"u",
                                     #"l", #"e", #" "] o
                                  shows_rule (shows_prec_lab B2_ C2_ Zero_nat)
                                    (shows_prec D2_ Zero_nat)
                                    [#" ", #"-", #">", #" "] x))))))
          (fn _ =>
            let
              val dpp = mkc j p [] q r [];
            in
              check_dp_disproof (equal_lab B1_ C1_, show_lab B2_ C2_) (D1_, D2_)
                (ia o shows_string [#".", #"1"]) j dpp prf
            end)
      end;

fun check_rel_seq (A1_, A2_) (B1_, B2_) r sa [] s u true =
  check (equal_terma A1_ B1_ s u)
    (shows_string
       [#"t", #"h", #"e", #" ", #"l", #"a", #"s", #"t", #" ", #"t", #"e", #"r",
         #"m", #" ", #"o", #"f", #" ", #"t", #"h", #"e", #" ", #"r", #"e", #"w",
         #"r", #"i", #"t", #"e", #" ", #"s", #"e", #"q", #"u", #"e", #"n", #"c",
         #"e"] o
      (shows_nl o
        (shows_prec_term A2_ B2_ Zero_nat s o
          (shows_string
             (shows_nl
               [#"d", #"o", #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"c",
                 #"o", #"r", #"r", #"e", #"s", #"p", #"o", #"n", #"d", #" ",
                 #"t", #"o", #" ", #"t", #"h", #"e", #" ", #"g", #"o", #"a",
                 #"l", #" ", #"t", #"e", #"r", #"m"]) o
            (shows_nl o (shows_prec_term A2_ B2_ Zero_nat u o shows_nl))))))
  | check_rel_seq (A1_, A2_) (B1_, B2_) r sa [] s u false =
    Inl (shows_prec_list show_char Zero_nat
          [#"d", #"i", #"d", #" ", #"n", #"o", #"t", #" ", #"f", #"i", #"n",
            #"d", #" ", #"s", #"t", #"r", #"i", #"c", #"t", #" ", #"s", #"t",
            #"e", #"p", #" ", #"i", #"n", #" ", #"r", #"e", #"w", #"r", #"i",
            #"t", #"e", #" ", #"s", #"e", #"q", #"u", #"e", #"n", #"c", #"e"])
  | check_rel_seq (A1_, A2_) (B1_, B2_) ra sa ((p, (r, (true, t))) :: prts) s u
    b = bindb (check_rstep (A1_, A2_) (B1_, B2_) ra p r s t)
          (fn _ => check_rel_seq (A1_, A2_) (B1_, B2_) ra sa prts t u true)
  | check_rel_seq (A1_, A2_) (B1_, B2_) ra sa ((p, (r, (false, t))) :: prts) s u
    b = bindb (check_rstep (A1_, A2_) (B1_, B2_) sa p r s t)
          (fn _ => check_rel_seq (A1_, A2_) (B1_, B2_) ra sa prts t u b);

fun check_rel_loop (A1_, A2_) (B1_, B2_) sa rseq sigma c r s =
  check_rel_seq (A1_, A2_) (B1_, B2_) r s rseq sa
    (ctxt_apply c (subst_apply_term sa (mk_subst B1_ sigma))) false;

fun check_wf_reltrs A_ (B1_, B2_) (r, s) =
  bindb (check_wf_trs A_ (B1_, B2_) r)
    (fn _ =>
      (if null r then Inr ()
        else catch (forallm
                     (fn rule =>
                       catch (catch
                               (check_subseteq B1_
                                 (vars_term_list B1_ (snd rule))
                                 (vars_term_list B1_ (fst rule)))
                               (fn x =>
                                 Inl (shows_string
[#"f", #"r", #"e", #"e", #" ", #"v", #"a", #"r", #"i", #"a", #"b", #"l", #"e",
  #" "] o
                                       (shows_prec B2_ Zero_nat x o
 shows_string
   [#" ", #"i", #"n", #" ", #"r", #"i", #"g", #"h", #"t", #"-", #"h", #"a",
     #"n", #"d", #" ", #"s", #"i", #"d", #"e", #" ", #"o", #"f"]))))
                         (fn x =>
                           Inl (x o (shows_string
                                       [#" ", #"r", #"u", #"l", #"e", #" "] o
                                      (shows_rule (shows_prec A_ Zero_nat)
 (shows_prec B2_ Zero_nat) [#" ", #"-", #">", #" "] rule o
shows_nl)))))
                     s)
               (fn x => Inl (snd x))));

fun check_not_wf_reltrs A_ (B1_, B2_) rs =
  check (not (isOK (check_wf_reltrs A_ (B1_, B2_) rs)))
    (shows_string
       [#"T", #"h", #"e", #" ", #"T", #"R", #"S", #"s", #" ", #"R", #" ", #"a",
         #"n", #"d", #" ", #"S", #" ", #"a", #"r", #"e", #" ", #"w", #"e", #"l",
         #"l", #" ", #"f", #"o", #"r", #"m", #"e", #"d"] o
      shows_nl);

fun check_reltrs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
  (Rel_Loop (s, rseq, sigma, c)) =
  debug (ia []) [#"L", #"o", #"o", #"p"]
    let
      val r = ra i tp;
      val sa = rwa i tp;
    in
      bindb (check (q_emptya i tp)
              (shows_prec_list show_char Zero_nat
                [#"Q", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"e",
                  #"m", #"p", #"t", #"y"]))
        (fn _ =>
          catch (check_rel_loop (equal_lab B1_ C1_, show_lab B2_ C2_) (D1_, D2_)
                  s rseq sigma c r sa)
            (fn x =>
              Inl (ia o (shows_string
                           [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                             #"i", #"n", #" ", #"l", #"o", #"o", #"p", #" ",
                             #"p", #"r", #"o", #"o", #"f"] o
                          (shows_nl o x)))))
    end
  | check_reltrs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    (Rel_R_Not_SN prf) =
    let
      val q = qa i tp;
      val r = ra i tp;
      val tpa = mka i q r [];
    in
      check_trs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_)
        (ia o shows_string [#".", #"1"]) i j tpa prf
    end
  | check_reltrs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    Rel_Not_Well_Formed =
    debug (ia [])
      [#"N", #"o", #"t", #" ", #"W", #"e", #"l", #"l", #"-", #"F", #"o", #"r",
        #"m", #"e", #"d"]
      let
        val r = ra i tp;
        val s = rwa i tp;
      in
        bindb (check (q_emptya i tp)
                (shows_prec_list show_char Zero_nat
                  [#"Q", #" ", #"i", #"s", #" ", #"n", #"o", #"t", #" ", #"e",
                    #"m", #"p", #"t", #"y"]))
          (fn _ =>
            catch (check_not_wf_reltrs (show_lab B2_ C2_) (D1_, D2_) (r, s))
              (fn x =>
                Inl (ia o (shows_string
                             [#":", #" ", #"e", #"r", #"r", #"o", #"r", #" ",
                               #"i", #"n", #" ", #"n", #"o", #"t", #"-", #"w",
                               #"e", #"l", #"l", #"-", #"f", #"o", #"r", #"m",
                               #"e", #"d", #" ", #"p", #"r", #"o", #"o", #"f"] o
                            (shows_nl o x)))))
      end
  | check_reltrs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_) ia i j tp
    (Rel_Rule_Removal (r, s, prf)) =
    debug (ia [])
      [#"R", #"u", #"l", #"e", #" ", #"R", #"e", #"m", #"o", #"v", #"a", #"l"]
      let
        val raa = ra i tp;
        val rrm =
          list_diff
            (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
              (equal_term (equal_lab B1_ C1_) D1_))
            raa r;
        val sa = rwa i tp;
        val srm =
          list_diff
            (equal_prod (equal_term (equal_lab B1_ C1_) D1_)
              (equal_term (equal_lab B1_ C1_) D1_))
            sa s;
      in
        check_reltrs_disproof (B1_, B2_) (C1_, C2_) (D1_, D2_)
          (ia o shows_string [#".", #"1"]) i j (delete_R_Rwa i tp rrm srm) prf
      end;

fun certify_cert_problem (B1_, B2_, B3_) a i j (TRS_Proof (q, r, NONE, prf)) =
  (case check_trs_proof (B1_, B2_, B3_) a (shows_string [#"1"]) i j
          (mka i (strategy_to_Q q r) r []) prf
    of Inl err =>
      Error ((shows_string
                [#"t", #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o",
                  #"n", #" ", #"p", #"r", #"o", #"o", #"f", #" ", #"n", #"o",
                  #"t", #" ", #"a", #"c", #"c", #"e", #"p", #"t", #"e", #"d"] o
               (shows_nl o err))
              [])
    | Inr _ => Certified (xml_tag (TRS_Proof (q, r, NONE, prf))))
  | certify_cert_problem (B1_, B2_, B3_) a i j (TRS_Proof (q, r, SOME s, prf)) =
    (case check_trs_proof (B1_, B2_, B3_) a (shows_string [#"1"]) i j
            (mka i (strategy_to_Q q r) r s) prf
      of Inl err =>
        Error ((shows_string
                  [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #" ", #"t",
                    #"e", #"r", #"m", #"i", #"n", #"a", #"t", #"i", #"o", #"n",
                    #" ", #"p", #"r", #"o", #"o", #"f", #" ", #"n", #"o", #"t",
                    #" ", #"a", #"c", #"c", #"e", #"p", #"t", #"e", #"d"] o
                 (shows_nl o err))
                [])
      | Inr _ => Certified (xml_tag (TRS_Proof (q, r, SOME s, prf))))
  | certify_cert_problem (B1_, B2_, B3_) a i j (TRS_Disproof (q, r, prf)) =
    (case check_trs_disproof (B1_, B3_)
            (equal_list equal_nat, show_list show_nat)
            (equal_list equal_char, show_list show_char) (shows_string [#"1"]) i
            j (mka i (strategy_to_Q q r) r []) prf
      of Inl err =>
        Error ((shows_string
                  [#"n", #"o", #"n", #"t", #"e", #"r", #"m", #"i", #"n", #"a",
                    #"t", #"i", #"o", #"n", #" ", #"p", #"r", #"o", #"o", #"f",
                    #" ", #"n", #"o", #"t", #" ", #"a", #"c", #"c", #"e", #"p",
                    #"t", #"e", #"d"] o
                 (shows_nl o err))
                [])
      | Inr _ => Certified (xml_tag (TRS_Disproof (q, r, prf))))
  | certify_cert_problem (B1_, B2_, B3_) a i j (Rel_TRS_Disproof (q, r, s, prf))
    = (case check_reltrs_disproof (B1_, B3_)
              (equal_list equal_nat, show_list show_nat)
              (equal_list equal_char, show_list show_char) (shows_string [#"1"])
              i j (mka i (strategy_to_Q q r) r s) prf
        of Inl err =>
          Error ((shows_string
                    [#"r", #"e", #"l", #"a", #"t", #"i", #"v", #"e", #" ", #"n",
                      #"o", #"n", #"t", #"e", #"r", #"m", #"i", #"n", #"a",
                      #"t", #"i", #"o", #"n", #" ", #"p", #"r", #"o", #"o",
                      #"f", #" ", #"n", #"o", #"t", #" ", #"a", #"c", #"c",
                      #"e", #"p", #"t", #"e", #"d"] o
                   (shows_nl o err))
                  [])
        | Inr _ => Certified (xml_tag (Rel_TRS_Disproof (q, r, s, prf))))
  | certify_cert_problem (B1_, B2_, B3_) a i j (DP_Proof (p, pw, q, r, rw, prf))
    = (case check_dp_proof (B1_, B3_) a (shows_string [#"1"]) j
              (mkc j p pw (strategy_to_Q q (r @ rw)) r rw) prf
        of Inl err =>
          Error ((shows_string
                    [#"f", #"i", #"n", #"i", #"t", #"e", #"n", #"e", #"s", #"s",
                      #" ", #"p", #"r", #"o", #"o", #"f", #" ", #"n", #"o",
                      #"t", #" ", #"a", #"c", #"c", #"e", #"p", #"t", #"e",
                      #"d"] o
                   (shows_nl o err))
                  [])
        | Inr _ => Certified (xml_tag (DP_Proof (p, pw, q, r, rw, prf))))
  | certify_cert_problem (B1_, B2_, B3_) a i j (DP_Disproof (p, q, r, prf)) =
    (case check_dp_disproof
            (equal_lab B1_ (equal_list equal_nat),
              show_lab B3_ (show_list show_nat))
            (equal_list equal_char, show_list show_char) (shows_string [#"1"]) j
            (mkc j p [] (strategy_to_Q q r) [] r) prf
      of Inl err =>
        Error ((shows_string
                  [#"i", #"n", #"f", #"i", #"n", #"i", #"t", #"e", #"n", #"e",
                    #"s", #"s", #" ", #"p", #"r", #"o", #"o", #"f", #" ", #"n",
                    #"o", #"t", #" ", #"a", #"c", #"c", #"e", #"p", #"t", #"e",
                    #"d"] o
                 (shows_nl o err))
                [])
      | Inr _ => Certified (xml_tag (DP_Disproof (p, q, r, prf))));

fun mk_impl (A1_, A2_) B_ q r rw =
  let
    val (vr, ra) = partition (is_var o fst) r;
    val (vrw, rwa) = partition (is_var o fst) rw;
  in
    (q, (nF_subset A1_ B_ (mapa fst (r @ rw)) q,
          (vr, (vrw, insert_rules equal_bool (A1_, A2_) B_ true ra
                       (insert_rules equal_bool (A1_, A2_) B_ false rwa
                         (rm_empty
                           (linorder_prod (A1_, A2_)
                             (equal_nat, linorder_nat))))))))
  end;

fun mk (A1_, A2_) B_ q r rw = Tp (mk_impl (A1_, A2_) B_ q r rw);

fun rw_impl (A1_, A2_) (uu, (uv, (uw, (vRw, m)))) =
  vRw @ rules_with (A1_, A2_) not m;

fun rw (A1_, A2_) tp = rw_impl (A1_, A2_) (impl_ofa A2_ tp);

fun rules_impl (A1_, A2_) (uu, (uv, (vR, (vRw, m)))) =
  vR @ vRw @ mapa snd
               (values (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) m);

fun rulesa (A1_, A2_) tp = rules_impl (A1_, A2_) (impl_ofa A2_ tp);

fun nF_terms_list A_ B_ ls t =
  list_all (fn s => list_all (fn l => not (matches A_ B_ s l)) ls)
    (supteq_list t);

fun is_QNF_impl A_ B_ (q, uu) = nF_terms_list A_ B_ q;

fun is_QNF (A1_, A2_) B_ tp = is_QNF_impl A1_ B_ (impl_ofa A2_ tp);

fun q_empty_impl (q, uu) = null q;

fun q_empty A_ tp = q_empty_impl (impl_ofa A_ tp);

fun qreltrs_impl (A1_, A2_) B_ (q, (uu, (vR, (vRw, m)))) =
  (set (equal_term A1_ B_) q,
    (set (equal_prod (equal_term A1_ B_) (equal_term A1_ B_))
       (vR @ rules_with (A1_, A2_) id m),
      set (equal_prod (equal_term A1_ B_) (equal_term A1_ B_))
        (vRw @ rules_with (A1_, A2_) not m)));

fun qreltrs (A1_, A2_) B_ tp = qreltrs_impl (A1_, A2_) B_ (impl_ofa A2_ tp);

fun rules_map_impl (A1_, A2_) (uu, (uv, (uw, (ux, m)))) fna =
  (case rm_lookup (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) fna m
    of NONE => [] | SOME a => mapa snd a);

fun rules_map (A1_, A2_) tp = rules_map_impl (A1_, A2_) (impl_ofa A2_ tp);

fun delete_R_Rw_impl (A1_, A2_) B_ (q, (uu, (vR, (vRw, m)))) r rw =
  let
    val (vr, ra) = partition (is_var o fst) r;
    val (vrw, rwa) = partition (is_var o fst) rw;
    val vra =
      list_diff (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) vR vr;
    val vrwa =
      list_diff (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) vRw vrw;
    val ma =
      delete_rules equal_bool (A1_, A2_) B_ true ra
        (delete_rules equal_bool (A1_, A2_) B_ false rwa m);
  in
    (q, (nF_subset A1_ B_
           (mapa fst
             (vra @
               vrwa @
                 mapa snd
                   (values (linorder_prod (A1_, A2_) (equal_nat, linorder_nat))
                     ma)))
           q,
          (vra, (vrwa, ma))))
  end;

fun delete_R_Rw (A1_, A2_) B_ tp r rw =
  Tp (delete_R_Rw_impl (A1_, A2_) B_ (impl_ofa A2_ tp) r rw);

fun split_rules_impl (A1_, A2_) B_ tp rs =
  partition (membera (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) rs)
    (rules_impl (A1_, A2_) tp);

fun split_rules (A1_, A2_) B_ tp =
  split_rules_impl (A1_, A2_) B_ (impl_ofa A2_ tp);

fun nFQ_subset_NF_rules_impl (uu, (b, uv)) = b;

fun nFQ_subset_NF_rules A_ tp = nFQ_subset_NF_rules_impl (impl_ofa A_ tp);

fun tp_rbt_impl (A1_, A2_) B_ =
  Tp_ops_ext
    (qreltrs (A1_, A2_) B_, q A2_, r (A1_, A2_), rw (A1_, A2_),
      rulesa (A1_, A2_), q_empty A2_, is_QNF (A1_, A2_) B_,
      nFQ_subset_NF_rules A2_, rules_map (A1_, A2_), delete_R_Rw (A1_, A2_) B_,
      split_rules (A1_, A2_) B_, mk (A1_, A2_) B_, ());

fun p_impl (p, uu) = p;

fun impl_ofb A_ (Dpp x) = x;

fun p A_ d = p_impl (impl_ofb A_ d);

fun q_impla (uu, (uv, (q, uw))) = q;

fun qb A_ d = q_impla (impl_ofb A_ d);

fun r_impla (A1_, A2_) (uu, (uv, (uw, (ux, (uy, (vr, (uz, (m, va)))))))) =
  vr @ rules_with (A1_, A2_) id m;

fun rb (A1_, A2_) d = r_impla (A1_, A2_) (impl_ofb A2_ d);

fun mk_impla (A1_, A2_) B_ p pw q r rw =
  let
    val (vr, ra) = partition (is_var o fst) r;
    val (vrw, rwa) = partition (is_var o fst) rw;
    val rs = r @ rw;
  in
    (p, (pw, (q, (nF_subset A1_ B_ (mapa fst rs) q,
                   (list_all (fn (_, rb) => not (is_var rb)) rs,
                     (vr, (vrw, (insert_rules equal_bool (A1_, A2_) B_ true ra
                                   (insert_rules equal_bool (A1_, A2_) B_ false
                                     rwa (rm_empty
   (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)))),
                                  insert_rules equal_bool (A1_, A2_) B_ true
                                    (mapa (fn (x, y) => (y, x)) r)
                                    (insert_rules equal_bool (A1_, A2_) B_ false
                                      (mapa (fn (x, y) => (y, x)) rw)
                                      (rm_empty
(linorder_prod (A1_, A2_) (equal_nat, linorder_nat))))))))))))
  end;

fun mkb (A1_, A2_) B_ p pw q r rw = Dpp (mk_impla (A1_, A2_) B_ p pw q r rw);

fun pw_impl (uu, (pw, uv)) = pw;

fun pw A_ d = pw_impl (impl_ofb A_ d);

fun rw_impla (A1_, A2_) (uu, (uv, (uw, (ux, (uy, (uz, (vrw, (m, va)))))))) =
  vrw @ rules_with (A1_, A2_) not m;

fun rwb (A1_, A2_) d = rw_impla (A1_, A2_) (impl_ofb A2_ d);

fun dpp_impl (A1_, A2_) B_ (p, (pw, (q, (uu, (uv, (vr, (vrw, (m, uw)))))))) =
  (set (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) p,
    (set (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) pw,
      (set (equal_term A1_ B_) q,
        (set (equal_prod (equal_term A1_ B_) (equal_term A1_ B_))
           (vr @ rules_with (A1_, A2_) id m),
          set (equal_prod (equal_term A1_ B_) (equal_term A1_ B_))
            (vrw @ rules_with (A1_, A2_) not m)))));

fun dppa (A1_, A2_) B_ d = dpp_impl (A1_, A2_) B_ (impl_ofb A2_ d);

fun pairs_impl (p, (pw, uu)) = p @ pw;

fun pairs A_ d = pairs_impl (impl_ofb A_ d);

fun rules_impla (A1_, A2_) (uu, (uv, (uw, (ux, (uy, (vr, (vrw, (m, uz)))))))) =
  vr @ vrw @ mapa snd
               (values (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) m);

fun rulesc (A1_, A2_) d = rules_impla (A1_, A2_) (impl_ofb A2_ d);

fun is_QNF_impla A_ B_ (uu, (uv, (q, uw))) = nF_terms_list A_ B_ q;

fun is_QNFb (A1_, A2_) B_ d = is_QNF_impla A1_ B_ (impl_ofb A2_ d);

fun q_empty_impla (uu, (uv, (q, uw))) = null q;

fun q_emptyb A_ d = q_empty_impla (impl_ofb A_ d);

fun rules_map_impla (A1_, A2_) (uu, (uv, (uw, (ux, (uy, (uz, (va, (m, vb))))))))
  fna =
  (case rm_lookup (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) fna m
    of NONE => [] | SOME a => mapa snd a);

fun rules_mapa (A1_, A2_) d = rules_map_impla (A1_, A2_) (impl_ofb A2_ d);

fun delete_P_Pw_impl A_ B_ (p, (pw, rest)) pd pwd =
  (list_diff (equal_prod (equal_term A_ B_) (equal_term A_ B_)) p pd,
    (list_diff (equal_prod (equal_term A_ B_) (equal_term A_ B_)) pw pwd,
      rest));

fun delete_P_Pw (A1_, A2_) B_ d p pw =
  Dpp (delete_P_Pw_impl A1_ B_ (impl_ofb A2_ d) p pw);

fun delete_R_Rw_impla (A1_, A2_) B_ d r rw =
  let
    val (p, (pw, (q, (_, (nc, (vR, (vRw, (m, rm)))))))) = d;
    val (vr, ra) = partition (is_var o fst) r;
    val (vrw, rwa) = partition (is_var o fst) rw;
    val vra =
      list_diff (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) vR vr;
    val vrwa =
      list_diff (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) vRw vrw;
    val ma =
      delete_rules equal_bool (A1_, A2_) B_ true ra
        (delete_rules equal_bool (A1_, A2_) B_ false rwa m);
    val rma =
      delete_rules equal_bool (A1_, A2_) B_ true (mapa (fn (x, y) => (y, x)) r)
        (delete_rules equal_bool (A1_, A2_) B_ false
          (mapa (fn (x, y) => (y, x)) rw) rm);
    val rs =
      vra @ vrwa @
              mapa snd
                (values (linorder_prod (A1_, A2_) (equal_nat, linorder_nat))
                  ma);
  in
    (p, (pw, (q, (nF_subset A1_ B_ (mapa fst rs) q,
                   (nc orelse list_all (fn (_, rb) => not (is_var rb)) rs,
                     (vra, (vrwa, (ma, rma))))))))
  end;

fun delete_R_Rwb (A1_, A2_) B_ d r rw =
  Dpp (delete_R_Rw_impla (A1_, A2_) B_ (impl_ofb A2_ d) r rw);

fun split_pairs_impl A_ B_ d ps =
  partition (membera (equal_prod (equal_term A_ B_) (equal_term A_ B_)) ps)
    (pairs_impl d);

fun split_pairs (A1_, A2_) B_ d = split_pairs_impl A1_ B_ (impl_ofb A2_ d);

fun split_rules_impla (A1_, A2_) B_ d rs =
  partition (membera (equal_prod (equal_term A1_ B_) (equal_term A1_ B_)) rs)
    (rules_impla (A1_, A2_) d);

fun split_rulesb (A1_, A2_) B_ d =
  split_rules_impla (A1_, A2_) B_ (impl_ofb A2_ d);

fun intersect_pairs_impl A_ B_ (p, (pw, rest)) ps =
  (list_inter (equal_prod (equal_term A_ B_) (equal_term A_ B_)) p ps,
    (list_inter (equal_prod (equal_term A_ B_) (equal_term A_ B_)) pw ps,
      rest));

fun intersect_pairs (A1_, A2_) B_ d ps =
  Dpp (intersect_pairs_impl A1_ B_ (impl_ofb A2_ d) ps);

fun reverse_rules_map_impl (A1_, A2_)
  (uu, (uv, (uw, (ux, (uy, (uz, (va, (vb, m)))))))) fna =
  (case rm_lookup (linorder_prod (A1_, A2_) (equal_nat, linorder_nat)) fna m
    of NONE => [] | SOME a => mapa snd a);

fun reverse_rules_map (A1_, A2_) d =
  reverse_rules_map_impl (A1_, A2_) (impl_ofb A2_ d);

fun rules_no_left_var_impl (uu, (uv, (uw, (ux, (uy, ([], ([], uz))))))) = true
  | rules_no_left_var_impl (v, (vc, (ve, (vg, (vi, (vm :: vn, vl)))))) = false
  | rules_no_left_var_impl (v, (vc, (ve, (vg, (vi, (vk, (vo :: vp, vn))))))) =
    false;

fun rules_no_left_var A_ d = rules_no_left_var_impl (impl_ofb A_ d);

fun nFQ_subset_NF_rules_impla (uu, (uv, (uw, (b, ux)))) = b;

fun nFQ_subset_NF_rulesa A_ d = nFQ_subset_NF_rules_impla (impl_ofb A_ d);

fun rules_non_collapsing_impl (uu, (uv, (uw, (ux, (nc, uy))))) = nc;

fun rules_non_collapsing A_ d = rules_non_collapsing_impl (impl_ofb A_ d);

fun dpp_rbt_impl (A1_, A2_) B_ =
  Dpp_ops_ext
    (dppa (A1_, A2_) B_, p A2_, pw A2_, pairs A2_, qb A2_, rb (A1_, A2_),
      rwb (A1_, A2_), rulesc (A1_, A2_), q_emptyb A2_, rules_no_left_var A2_,
      rules_non_collapsing A2_, is_QNFb (A1_, A2_) B_, nFQ_subset_NF_rulesa A2_,
      rules_mapa (A1_, A2_), reverse_rules_map (A1_, A2_),
      intersect_pairs (A1_, A2_) B_, delete_P_Pw (A1_, A2_) B_,
      delete_R_Rwb (A1_, A2_) B_, split_pairs (A1_, A2_) B_,
      split_rulesb (A1_, A2_) B_, mkb (A1_, A2_) B_, ());

fun certify_proof a problemString =
  (case parse_cert_problem problemString
    of Inl err =>
      Unsupported
        ([#"e", #"r", #"r", #"o", #"r", #" ", #"w", #"h", #"i", #"l", #"e",
           #" ", #"p", #"a", #"r", #"s", #"i", #"n", #"g"] @
          [newline] @ err)
    | Inr cp =>
      (case extract_input_proof problemString
        of NONE =>
          Error [#"c", #"o", #"u", #"l", #"d", #" ", #"n", #"o", #"t", #" ",
                  #"f", #"i", #"n", #"d", #" ", #"i", #"n", #"p", #"u", #"t",
                  #" ", #"a", #"n", #"d", #" ", #"p", #"r", #"o", #"o", #"f",
                  #" ", #"i", #"n", #" ", #"s", #"t", #"r", #"i", #"n", #"g",
                  #" ", #"f", #"o", #"r", #" ", #"c", #"o", #"m", #"p", #"a",
                  #"r", #"i", #"s", #"o", #"n", #" ", #"w", #"i", #"t", #"h",
                  #" ", #"p", #"a", #"r", #"s", #"e", #"d", #" ", #"r", #"e",
                  #"s", #"u", #"l", #"t"]
        | SOME (the_input, (_, the_proof)) =>
          (if eqWhiteSpace the_input
                (shows_prec_xml Zero_nat
                  (xml_cert_problem (show_list show_char) show_nat
                    (show_list show_char) cp)
                  [])
            then (case certify_cert_problem
                         (equal_list equal_char,
                           linorder_list (equal_char, linorder_char),
                           show_list show_char)
                         a (tp_rbt_impl
                             (equal_lab (equal_list equal_char)
                                (equal_list equal_nat),
                               linorder_lab
                                 (equal_list equal_char,
                                   linorder_list (equal_char, linorder_char))
                                 (equal_list equal_nat,
                                   linorder_list (equal_nat, linorder_nat)))
                             (equal_list equal_char))
                         (dpp_rbt_impl
                           (equal_lab (equal_list equal_char)
                              (equal_list equal_nat),
                             linorder_lab
                               (equal_list equal_char,
                                 linorder_list (equal_char, linorder_char))
                               (equal_list equal_nat,
                                 linorder_list (equal_nat, linorder_nat)))
                           (equal_list equal_char))
                         cp
                   of Certified tag =>
                     (if starts_with the_proof tag then Certified tag
                       else Error ([#"p", #"r", #"o", #"v", #"e", #"n", #" ",
                                     #"p", #"r", #"o", #"p", #"e", #"r", #"t",
                                     #"y", #" "] @
                                    tag @ [#" ", #"d", #"o", #"e", #"s", #" ",
    #"n", #"o", #"t", #" ", #"c", #"o", #"r", #"r", #"e", #"s", #"p", #"o",
    #"n", #"d", #" ", #"t", #"o", #" ", #"p", #"r", #"o", #"o", #"f", #" ",
    #"i", #"n", #" ", #"i", #"n", #"p", #"u", #"t", #" ", #"s", #"t", #"r",
    #"i", #"n", #"g", #":", #" "] @
    take (nat (20 : IntInf.int)) the_proof))
                   | Unsupported aa => Unsupported aa | Error aa => Error aa)
            else Error (concat
                         [[#"p", #"a", #"r", #"s", #"e", #"d", #" ", #"p", #"r",
                            #"o", #"b", #"l", #"e", #"m", #" ", #"d", #"o",
                            #"e", #"s", #" ", #"n", #"o", #"t", #" ", #"c",
                            #"o", #"r", #"r", #"e", #"s", #"p", #"o", #"n",
                            #"d", #" ", #"t", #"o", #" ", #"i", #"n", #"p",
                            #"u", #"t"],
                           [newline], [#"i", #"n", #"p", #"u", #"t", #":"],
                           [newline],
                           filter (fn c => not (membera equal_char wspace c))
                             the_input,
                           [newline], [newline],
                           [#"p", #"a", #"r", #"s", #"e", #"d", #":"],
                           [newline],
                           filter (fn c => not (membera equal_char wspace c))
                             (shows_prec_xml Zero_nat
                               (xml_cert_problem (show_list show_char) show_nat
                                 (show_list show_char) cp)
                               []),
                           [newline]]))));

end; (*struct EvalCeta*)
